# -*- coding: cp1252 -*-
import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import tkFileDialog
import raioop2
import copy
import stats
import pstat

#Brg in cooperation with Korbinian Freier, MPI Hamburg, 2.10. and 3.10.09
# Bordasimpl1.py: Brg 30.4.2013
# Constraint: No ties for any indicator!!!!!
# preliminary program: see borda3.py in Uebungsprogramme

def calc(X,r,k):
    # brg 30.4.2013
    rX=rmod2.marray(r,k)
    for j in range(0,k):
        hilf=rmod2.vecgen1(r)
        for i in range(0,r):
            hilf[i]=X[i][j]
        rlist=pstat.lrankdata(hilf)
        for i in range(0,r):
            rX[i][j]=rlist[i]

    frank=rmod2.vecgen1(r)
    bordasum=rmod2.vecgen1(r)
    for i in range(0,r):
        frank[i]=i


    for i in range(0,r):
        bordasum[i]=0
        for j in range(0,k):
            bordasum[i]+=frank[int(rX[i][j])-1]

    print "bordasum ",bordasum
    return bordasum        




def HD():
    """based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"""
    # Brg 20.12.07, 28.12.07, 2.10.,3.10.09
    # If the number of representants > 70 then only the cover-matrix and the level-population
    #
    global dm,obj,prop,r,k,rred
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    
    fn=tkFileDialog.askopenfilename()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    lb1.config(text="opened "+fn,bg="yellow")
    

    prop=[]
    for j in range(0,k):
        prop.append(pro[j+1])
            
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
    for i in range(0,r):
        obj[i]=ob[i+1]

    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,dm,obj)  
    
    #
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    if rred>70:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram  ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()


def calcBorda():
    # Brg 30.4.2013
    global r,k,rred

    print "r= ",r
    print "rred= ",rred
    print "k= ",k
    
    bs=calc(dm,r,k)
    y=copy.copy(bs)

    print "bs= ",bs
    x_act,n_act=rmod2.raisort(r,bs)

    print "n_act= ",n_act
    txt="Borda results "+"\n"
    txt+="++++ Note: no ties with respect to any indicator allowed++++"+"\n"
    txt+=60*"="+"\n"
    for rk in range(r-1,-1,-1):
        txt+="consensus-rank= "+str(rk+1)+": "+str(obj[n_act[rk]])+"\n"

    txt+="\n"
    txt+="- - -   e o f  - - - "
    result.insert("end",txt)


## Tkinter Plot
hf = Tkinter.Tk()
hf.title(' Bordasimpl ')
aboutHDsimpl=raioop2.brgabout(hf,"tp1","about_Bordasimpl.txt",1,\
            "April, 30th,2013"," about Bordasimpl ", "white", "t1",80,5,ScrolledText)
helpHDsimpl=raioop2.brgabout(hf,"tp1","help_HDsimpl.txt",1,\
            "April, 30th,2013"," help_Bordasimpl ", "white", "t1",80,5,ScrolledText)
    
fr=Tkinter.Frame(hf,width=60)
fr.pack()
buttHD = Tkinter.Button(fr, text='select, open and HD',width=25,bg="cyan",command=HD)
buttHD.pack(pady=5)
lb1=Tkinter.Label(fr,text=" ",width=50)
lb1.pack()
buttcalc=Tkinter.Button(fr,text=" Borda_simplified ",bg="cyan",width=25,command=calcBorda)
buttcalc.pack()
result=ScrolledText(fr,width=60,height=10)
result.pack()
buttexit = Tkinter.Button(fr, text = 'exit', bg = 'red', width=25,command = hf.destroy)
buttexit.pack(pady=10)

hf.mainloop()

