# -*- coding: cp1252 -*-
import rmod2
import raioop2
import Tkinter
import random
import tkFileDialog
import Canvas
from ScrolledText import ScrolledText
import copy


# brg 30.3.2013
# brg 31.3.2013
# brg 1.4.2013
# brg 2.4.2013
# brg 3.4.2013
# brg 13.12.2016

def filecomp(r,k,dm,obj):
    """ reduces a dm with equiv objects to a dm of a quotient set """
    # Brg 12.12.07, 13.1.08, 8.5.08, 20.6.08
    #
    #############################dieser Teil ist neu 21.12.07
    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,dm,obj)    
    ###############################################################
    
    return rred,xred,objred,obj,txt,neq   #20.6.08      

def fileselect():
    # brg 2.4.2013
    global fn,dm,obj,prop,r,k
    fn=tkFileDialog.askopenfilename()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    prop=[]
    for j in range(0,k):
        prop.append(pro[j+1])
            
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
    for i in range(0,r):
        obj[i]=ob[i+1]
    lbfile.config(text="file opened: "+str(r)+", "+str(k),bg="yellow")    

def startlinext(dm,r,k):
    # brg 1.4.2013
    global rred,objred,obj
    rred,xred,objred,obj,txt,neq=filecomp(r,k,dm,obj)
    
    zetahilf=rmod2.comp(rred,k,xred)
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    
    sigma=rmod2.vecgen1(rred)  
    txtmethod=" method: "
    startselect=0
        
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
           
    for i in range(0,rred):
        sigma[i]=revlext[i]
    return sigma, zeta,rred

def ufunct(zeta,rred):
    # brg 1.4.2013
    u=0
    for i in range(0,rred):
        for j in range(0,rred):
            if i!=j:
                if zeta[i][j]==0 and zeta[j][i]==0:
                    u+=0.5
                else:
                    u+=0
            else:
                pass
    return u



def HDgen():
    HD(hf,dm,obj,r,k)





def HD(hf,dm,obj,r,k):
    """based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"""
    # Brg 20.12.07, 28.12.07, 2.10.,3.10.09
    # If the number of representants > 70 then only the cover-matrix and the level-population
    # Brg 1.4.2013 taken from HDsimpl
    tpHD=Tkinter.Toplevel(hf)
    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,dm,obj)  
    
    #
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    if rred>200:
        print" +++too many objects ++++  "
    else:
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(tpHD,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()
        

def BubleyDyer(sigma,zeta,n,nMC,unif_sampl):
    """MC-calculation of a random set of linear extensions
    after Bubley and Dyer , see also Denoeux-paper
    from this set dynamically rkav is calculated """
    #brg 3.1.08, 17.6.08, 18.6.08, 13.12.16
    #sigma is the initial linear extension von unten nach oben, Nummern
    # .... anstelle von Objectnamen
    #
    #zeta is the zeta matrix, orientation row defining number <
    #......columndefining number then corresp. entry =1
    # .....Diagonale: 0
    #
    # n is the number of objects
    #nMC is the number of MC-trials at least 4000, better more
    #unif_sampl. if e.g. unif_sampl=100 and nMC=10000 then the
    #          rkav will be calculated after each 100.step
    sigmanew=rmod2.vecgen1(n)
    rkav0=rmod2.vecgen1(n)
    rkav=rmod2.vecgen1(n)
    rkavalt=rmod2.vecgen1(n)
    for i in range(0,n):
        rkav[i]=sigma.index(i)+1
        rkav0[i]=sigma.index(i)+1
        rkavalt[i]=sigma.index(i)+1
    #Initial average rank rkav0
    #print "rkav start = ",rkav
    for i in range(0,n):
        sigmanew[i]=sigma[i]

    zaehl=0
    lint=1
    prob=rmod2.marray(n,n+1)
   #18.6.: check the loop-finishing condition
    while zaehl<nMC:
        r=random.randint(0,1)  #17.6.08 8 changed to n 18.6 changed to (0,1)
        if r==0:        #17.6.08 18.6.08 changed
            for i in range(0,n):
                sigmanew[i]=sigma[i]

        else:
            irandom=random.randint(0,n)  ## better: take f(i)
            if 0<=irandom<n-1:   #25.6.08 changed from < to =<
                sigmanew[irandom+1]=sigma[irandom] #transposition of width =1
                sigmanew[irandom]=sigma[irandom+1]  # transpos. of width=1
            else:
                sigmanew[0]=sigma[n-1]
                sigmanew[n-1]=sigma[0]

            flag=rmod2.enrich(sigmanew,zeta,n)  #check whether or not consistent with the original order
            if flag==1:
                
                #print sigmanew
                for i in range(0,n):
                    sigma[i]=sigmanew[i]
                    
                if zaehl%unif_sampl==0:  #18.7.08
                    for i in range(0,n):
                        rkav[i]+=sigma.index(i)+1.0
                        prob[i][sigma.index(i)+1]+=1
                    lint+=1
                    #print "lint = ",lint,"   sigma = ",sigma       #9.8.17
                    #print " "
            else:
                for i in range(0,n):
                    sigmanew[i]=sigma[i]
        
        zaehl+=1
        if zaehl==nMC-2:
            for i in range(0,n):
                rkavalt[i]=rkav[i]
            #print "rkavalt=  ",rkavalt
    # MC-loop finished
    #print "lint--> return ",lint
    return lint,rkavalt,prob


def BDrkav():
    # brg 2.4.2013, 9.8.2017
    global prob, lint_act
    try:
        nMC=int(e_nMC.get())
    except:
        nMC=r**4
    try:
        unif_sampl=int(e_sampling.get())
    except:
        if nMC<10:
            unif_sampl=nMC
        else:
            unif_sampl=1.0*nMC/3.0
    sigma_act,zeta_act,rred=startlinext(dm,r,k)
    #print "sigma_act= ",sigma_act
    U_act=ufunct(zeta_act,rred)
    lint_act,rkav_act,prob=BubleyDyer(sigma_act,zeta_act,rred,nMC,unif_sampl)
    #print "lint_act = ", lint_act
    #print "rkav_act = ",rkav_act
    for i in range(0,rred):
        print objred[i],
        for i2 in range(1,rred+1):
            prob[i][i2]=1.0*prob[i][i2]/(1.0*lint_act)
            print round(prob[i][i2],3),
        print " "    
    print " "        
    rkavvertices=rmod2.vecgen1(rred)
    for i in range(0,rred):
        rkavvertices[i]=1.0*rkav_act[i]/(1.0*lint_act)
    tprkav=Tkinter.Toplevel(hf)
    tprkav.title(' averaged heights after BubleyDyer (rkav)')
    trkav=ScrolledText(tprkav,width=60,height=10)
    trkav.pack()
    txt="  Average Heights (also called rkav) after BubleyDyer "+"\n"
    txt+=60*"="+"\n"
    txt+="\nBasis-information "+"\n"
    txt+="File =           "+str(fn)+"\n"
    txt+="\n# objects        "+str(r)+"\n"
    txt+="# vertices      "+str(rred)+"\n"
    txt+="# attributes     " +str(k)+"\n"
    txt+="\n BubleyDyer-start-parameters "+"\n"
    txt+=" # MC            "+str(nMC)+"\n"
    txt+=" # drawn samples "+str(lint_act)+"\n"
    txt+=" # unif_sampl    "+str(unif_sampl)+"\n"
    txt+="\n Object"+"\t"+"average height "+"\n"
    txthilf=""
    for i in range(0,rred):
        txthilf+=str(objred[i])+"\t"+str(rkavvertices[i])+"\n"
    txt+=txthilf
    txt+="- - - EOF - - - "+"\n"
    trkav.insert("end",txt)


def show_prob():
    #brg 09.08.2017
    global eobj
    tpprob=Tkinter.Toplevel(hf)
    tprob=ScrolledText(tpprob,width=120,height=20)
    tprob.pack()
    txt="rank probabilities due to Bubley-Dyer "+"\n"
    txt+="Number of drawn linear extensions "+str(lint_act)+"\n"
    txt+="\t"
    for i2 in range(1,rred+1):
        txt+=str(i2)+2*"\t"
    txt+="\n"    
    for i in range(0,rred):
        txt+=str(objred[i])+":\t"
        for i2 in range(1,rred+1):
            txt+=str(round(prob[i][i2],3))+2*"\t"
        txt+="\n"
    txt+="\n"
    tprob.insert("end",txt)
    lbtpprob1=Tkinter.Label(tpprob,text="Select an object for drawing ")
    lbtpprob1.pack()
    eobj=Tkinter.Entry(tpprob,width=10)
    eobj.pack()
    draw=Tkinter.Button(tpprob,text="Draw the probability ",width=30,bg="white",command=draw_prob)
    draw.pack()
    
def draw_prob():
    #brg 09.08.17
    objsel=eobj.get()
    h=[]
    for i2 in range(1,rred+1):
        h.append(prob[objred.index(objsel)][i2])
    print "objselected ",objsel,"   h= ",h
    names=["ranks","prob","object"+str(objsel),"Bubley-Dyer","prob("+str(objsel)+", ranks)"]
    app=raioop2.brggraph3(hf,names,20,20,"red",5,h,1,rred)
    app.ausgabe()
    
hf=Tkinter.Tk()
hf.title(' BubleyDyer ')
aboutBubleyDyer=raioop2.brgabout(hf,"tp1","about_BubleyDyer.txt",11,\
            "August, the 9th,2017"," about BubleyDyer ", "white", "t1",80,5,ScrolledText)
helpBubleyDyer=raioop2.brgabout(hf,"tp1","help_BubleyDyer.txt",9,\
            "August, the 9th,2017"," help_BubleyDyer ", "white", "t1",80,5,ScrolledText)
    
fr=Tkinter.Frame(hf,width=60)
fr.pack()
buttfile=Tkinter.Button(fr,text="Select and open a data file ",bg="cyan",width=30,command=fileselect)
buttfile.pack()
lbfile=Tkinter.Label(fr,text="")
lbfile.pack()
buttHD=Tkinter.Button(fr,text=" Draw HD of original dm ",bg="cyan",width=30,command=HDgen)
buttHD.pack()
lbBD=Tkinter.Label(fr,text=" Entry #MC-runs and Entry #sampling ")
lbBD.pack()
frBD=Tkinter.Frame(fr,bd=3,relief="sunken")
frBD.pack()
e_nMC=Tkinter.Entry(frBD,width=10)
e_nMC.pack(side="left")
e_sampling=Tkinter.Entry(frBD,width=10)
e_sampling.pack(side="left")
buttrkav=Tkinter.Button(fr,text="Rkav by BubleyDyer ",width=30,bg="cyan",command=BDrkav)
buttrkav.pack()
buttprob=Tkinter.Button(fr,text="rank-probabilities ",width=30, bg="cyan",command=show_prob)
buttprob.pack()
buttexit=Tkinter.Button(fr,text="Exit",bg="red",bd=4,command=hf.destroy)
buttexit.pack()
hf.mainloop()
