import tkFileDialog
import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import raioop2

# brg 1.12.17
# brg 11.12.17
# brg 01.02.2018 derived from combi_total_orders



def HD(dm, k, labels):
    # brg 26.7.2013, 29.8.2013, 2.11.16, 21.11.17
    # Rearrangement as a dunctional procedure, getting data by the procedure input list
    TpHD=Tkinter.Toplevel(hf)
    TpHD.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(TpHD,width=200,height=300)
    freq.pack()
    nHD=len(labels)    #
    zetahilf=rmod2.comp(nHD,k,dm)  #zeta matrix with col<row
    zeta=rmod2.marray(nHD,nHD)
    for i1 in range(0,nHD):  #however we need for the 'normal' presentation: row < col. Transposition
        for i2 in range(0,nHD):
            zeta[i1][i2]=zetahilf[i2][i1]
    
    Utotal = rmod2.incompzeta(nHD,zeta)
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(nHD,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(nHD,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(nHD,adjc,lext)
       
    
    cov=rmod2.cover(nHD,tr,lext)

    if nHD>400:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram , Utotal =  "+str(Utotal))
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(nHD,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(nHD,nHD)
        geomy=rmod2.marray(nHD,nHD)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=labels[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()
        return cov


def inputfield():
    #brg 01.12.17, 11.12.17
    global cto, etotal,r, objset
    flag=0
    try:
        cto=int(e_count_of_total_orders.get())
    except:
        cto=2
        flag+=1
    if flag==0:   
        print "User defined: cto = ",cto
    else:
        print "By default: cto = ",cto
    
    r=int(e_r.get())
    print "r = ",r
    etotal=rmod2.vecgen1(cto)
    tp1=Tkinter.Toplevel(hf)
    lbinputfield=Tkinter.Label(tp1,text="Number of objects must be the same,\n\
                               sorted increasingly, separated by ',' ")
    lbinputfield.pack()
    
    for i in range(0,cto):
        etotal[i]=Tkinter.Entry(tp1,width=40)
        etotal[i].pack()
        
        #print etotal
       

def calc_cover(cov, labels):
    #brg 21.11.17
    #rearrangement to a functional procedure
    Tpcover = Tkinter.Toplevel(hf)
    Tpcover.title(' cover-matrix ')
    lbcov = Tkinter.Label(Tpcover,text=" Cover-Relations ")
    lbcov.pack()
    txt3 = "\n cover-matrix  \n"
    ncc = len(labels)
    for i1 in range(0, ncc):
        txt3 += "\n" + str(labels[i1]) + ":\t"
        txt3 += "is covered by "
        for i2 in range(0, ncc):
            if i1!=i2:
                if cov[i1][i2] == 1:
                    txt3 += " " + str(labels[i2]) + " ,"
                else:
                    pass
            else:
                pass
        txt3 += "\n"    
    txt3 += "\n"
    txt3 += " -- end of list --"
    tcov=ScrolledText(Tpcover,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)
        

def calc_HD():
    #brg 01.12.17, 01.02,2018
    global cov, Mfinal, Mrelat, obj
    hilf=rmod2.vecgen1(r)
    hilfw=rmod2.vecgen1(cto)
    weight=rmod2.vecgen1(cto)
    order=rmod2.vecgen1(cto)
    dmorder=rmod2.marray(r,cto)
    for i in range(0,cto):
        hilf[i]=etotal[i].get()
        order[i]=hilf[i].split(",")
    print "order"
    rmod2.strmatout(cto,r,order)
    print ""
    obj=rmod2.vecgen1(r)
    objhilf=eobj.get()
    obj=objhilf.split(',')
    print "obj in calc_HD  ",obj    
    numorder=rmod2.marray(cto,r)
    for i in range(0,cto):
        for j in range(0,r):
            numorder[i][j]=order[i].index(obj[j])
            
    print "numorder"
    rmod2.matout(cto,r,numorder)
    dmorder=rmod2.mattransp(cto,r,numorder)
    print "dmorder "
    rmod2.matout(r,cto,dmorder)
    cov=HD(dmorder,cto,order[0])
    calc_cover(cov,obj)
    # new: 01.02.2018
    Mrelat=rmod2.marray3(r,r,cto)
    for k in range(0,cto):
        Mhelp=rmod2.marray(r,r)
        for i1 in range(0,r):
            for i2 in range(0,r):
                if order[k].index(obj[i1])<=order[k].index(obj[i2]):
                    if i1==i2:
                        Mrelat[i1][i2][k]=0
                        Mhelp[i1][i2]=0
                    else:    
                        Mrelat[i1][i2][k]=1
                        Mhelp[i1][i2]=1
                else:
                    Mrelat[i1][i2][k]=-1
                    Mhelp[i1][i2]=-1
        print "order relation ",k
        rmod2.matout(r,r,Mhelp)
        #weights
    hilfw=e_weights.get()
    weight=hilfw.split(",")
    print "weights"
    Mfinal=rmod2.marray(r,r)
    controlsum=0
    for k in range(0,cto):
        weight[k]=float(weight[k])
        controlsum+=weight[k]
        print "k= ", round(weight[k],3)
        for i1 in range(0,r):
            for i2 in range(0,r):
                Mfinal[i1][i2]+=weight[k]*Mrelat[i1][i2][k]
    if 0.98<=controlsum<=1.02:
        print "weights are ok"
    else:
        print "++++something is wrong with weights +++!!!"
    print " "             
    print "Finale Relation "
    rmod2.matout(r,r,Mfinal)
    
def checktorder():
    # brg 01.02.2018
    global taustar, crucpair
    print "obj ",obj
    torder=e_testorder.get()
    t_order=torder.split(",")
    print "t_order ",t_order
    pairs_in_torder=[]
    pairs=[]
    for i1 in range(0,r):
        for i2 in range(0,r):
            if i1!=i2:
                pairs.append((obj[i1],obj[i2]))
                if t_order.index(obj[i1])<t_order.index(obj[i2]):
                    pairs_in_torder.append((obj[i1],obj[i2]))
    print "all pairs: ",pairs
    print "pairs in t_order ",pairs_in_torder
    taustar = -99999
    
    for i1 in range(0,r):
        for i2 in range(0,r):
            if i1!=i2:
                if (obj[i1],obj[i2]) not in pairs_in_torder:
                    if Mfinal[i1][i2]>taustar:
                        taustar=Mfinal[i1][i2]
                        
    print "taustar= ",taustar
    maxpair=[]
    for i1 in range(0,r):
        for i2 in range(0,r):
            if i1!=i2:
                if Mfinal[i1][i2]==taustar and (obj[i1],obj[i2]) not in pairs_in_torder:
                    maxpair.append((obj[i1],obj[i2]))
                                    
    print "pairs with maximal tau: ",maxpair
    Mrelatmod=rmod2.marray3(r,r,cto)
    crucpair=[]
    for k in range(0,cto):
        for i1 in range(0,r):
            for i2 in range(0,r):
                if i1!=i2:
                    if (obj[i1],obj[i2]) not in pairs_in_torder:
                        Mrelatmod[i1][i2][k]=Mrelat[i1][i2][k]-taustar
                    else:
                        Mrelatmod[i1][i2][k]=Mrelat[i1][i2][k]+taustar
                    if (obj[i1],obj[i2]) not in pairs_in_torder:
                        if Mrelatmod[i1][i2][k]==1.0-taustar:
                            crucpair.append((obj[i1],obj[i2],k))
    print "crucpairs (obj1,obj2,number of empirical relation) = "
    print crucpair
    txt="Cardoso, Sousa-Analysis "+"\n"
    txt+=69*"-"+"\n"
    txt+="t-Order "+"\n"
    for j in range(0, len(t_order)-1):
        txt+=str(t_order[j])+" < "
    txt+=str(t_order[len(t_order)-1])+"\n"
    txt+="Weights: "+"\n"
    for k in range(0,cto-1):
        txt+=str(round(weight[k],3))+", "
    txt+=str(round(weight[cto-1],3)) +"\n"   
    txt+="\n"    
    txt+="Mfinal "+"\n"
    for i1 in range(0,r):
        for i2 in range(0, r):
            txt+=str(round(Mfinal[i1][i2],2))+", "
        txt+="\n"
    txt+="\n"    
        
    txt+="Comparability Level based on empirical relations "+"\n"
    for i1 in range(0,r):
        for i2 in range(0,r):
            if i1!= i2:
                if Mfinal[i1][i2]>0:
                    txt+=str(obj[i1])+"<"+str(obj[i2])+"\t"+"Level: "+str(round(Mfinal[i1][i2],3))+"\n"
                
    txt+="\n"
    txt+="tau*: "+str(round(taustar,3))+"\n"
    if taustar>0.5:
        txt+="t_order is in reasonable conflict with the empirical "+str(cto)+" relations"+"\n"
    elif 0<taustar<=0.5:
        txt+="t_order is in some conflicts with the empirical "+str(cto)+"  relations"+"\n"
    else:
        txt+="t_order can be accepted "+"\n"
    txt+="Details: see Cardoso & Sousa: Networs, 41(4), 229-234, 2003 "+"\n"    
    txt+="Pairs of empirical order not in t_order and with a comparabbility level of "+str(round(taustar,3))+":"+"\n"
    lp=len(maxpair)
    for j in range(0,lp-1):
        txt+=str(maxpair[j])+"  , "
    txt+=str(maxpair[lp-1])
    txt+="\n"
    Tptau=Tkinter.Toplevel(hf)
    Ttau=ScrolledText(Tptau,width=80,height=20)
    Ttau.pack()
    Ttau.insert("end",txt)
        



## Tkinter Plot
hf = Tkinter.Tk()
hf.title(' CardosoSousa ')
aboutfuzzy_FCA=raioop2.brgabout(hf,"tp1","about_cardososousa.txt",1,\
            "Febr. the 01st, 2018"," about Cardoso Sousa ", "white", "t1",120,5,ScrolledText)
helpHDsimpl=raioop2.brgabout(hf,"tp1","help_cardososousa.txt",1,\
            "Febr., the 01st, 2018"," help Cardoso Sousa ", "white", "t1",120,5,ScrolledText)
global e_count_of_total_orders,e_r,fr    
fr = Tkinter.Frame(hf, width=60)
fr.pack()
lb0=Tkinter.Label(fr,text="Insert how many total (empirical) orders (default: 2) ")
lb0.pack()
e_count_of_total_orders=Tkinter.Entry(fr,width=5)
e_count_of_total_orders.pack()
lb1=Tkinter.Label(fr,text="How many objects? ")
lb1.pack()
e_r=Tkinter.Entry(fr,width=5)
e_r.pack()
lb2=Tkinter.Label(fr,text="list of object(label)s separated by ','")
lb2.pack()
eobj=Tkinter.Entry(fr, width=20)
eobj.pack()
buttinputfield=Tkinter.Button(fr,text="Open inputfield ",width=45,bg="cyan",command=inputfield)
buttinputfield.pack()
lb3=Tkinter.Label(fr,text="Insert weights (0...,1) sum weights = 1) ")
lb3.pack()
e_weights=Tkinter.Entry(fr,width=20)
e_weights.pack()
buttcalc_HD=Tkinter.Button(fr,text="calc Hasse diagram \n(input of weights mandatory) ",width=45,bg="cyan",command=calc_HD)
buttcalc_HD.pack()
lb4=Tkinter.Label(fr,text="Enter the total order to be tested (t-order) ")
lb4.pack()
e_testorder=Tkinter.Entry(fr, width=20)
e_testorder.pack()
buttchecktestorder=Tkinter.Button(fr, text="characterize the t-order ",width=45,bg="cyan",command=checktorder)
buttchecktestorder.pack() 
buttexit=Tkinter.Button(fr,text="Exit ",bg="red",bd=5,width=10,command=hf.destroy)
buttexit.pack(pady=5)
hf.mainloop()
