#Disco2.py from Disco1.py
# Programm for Concordance-Discordance analysis
# Now with the cental calculation as procedure
#Now with Tkinter
# 22.3.08, 23.3.08, 23.5.08
# 23.5.08: New module: preview
# 12.10.08: help text now as external file, loading by an OOP-function
# 16.10.09: correction in line 94/95
# 25.10.2012: Discordance3.py 

import rmod2
import raioop2
import Tkinter
import Canvas
from ScrolledText import *
import tkFileDialog

def how_many_attributes():
    """read in how many weights """
    global k
    k = int(ek.get())
    global egew
    egew=rmod2.vecgen1(k)
    lbgew.config(text=" weights for  "+str(k)+"  attributes")
    for j in range(0,k):
        egew[j]=Tkinter.Entry(frinput3,width=4)
        egew[j].grid(row=2,column=j)

    
def confirm_weights():
    """read in weights """
    #brg 22.3.08 , 23.3.08
    global g
    g=rmod2.vecgen1(k)
    gsum=0
    txtw=""
    for j in range(0,k):
        try:
            g[j]=float(egew[j].get())
        except:
            g[j]=1.0/k
        gsum+=g[j]
    if gsum!=1.0 and gsum!=0:
        for j in range(0,k):
            g[j]=g[j]/gsum
        txtw=" +++note: renormalized! +++"
    elif gsum>0.9999 and gsum<1.0001:
        txtw="weights: ok"
    else:
        txtw="+++please control the weights +++"
        
        
    lbconfirm.config(text=str(k)+" weights read in, "+txtw,bg="yellow")     
    
def fselectopencalc():
    """ File selection and opening by Tkinter-Standards"""
    #*13.1.08
    #akt: 25.10.12
    #note: There may be conflicts with other moduls
    #source:-
    tp=Tkinter.Toplevel(hf)
    global fn,iob
    fn=tkFileDialog.askopenfilename()
    global dm,ob,obj,pro,r
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    prop=rmod2.vecgentext1(k)
    obj=rmod2.vecgen1(r)  #changed 23.5.08, 25.10.2012
    for i in range(0,k):
        prop[i]=pro[i+1]
    for i in range(0,r):
        obj[i]=ob[i+1]

    lbfile=Tkinter.Label(tp,text="selected file : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns")
    lbfile.pack()
    # new 25.10.2012
    iob=eref.get()
    txtref=""
    try:
        refnr=obj.index(iob)
        txtref+="Reference object: "+str(iob)
    except:
        refnr=0
        textref+="+++ selected object is not in the list, object "+str(ob[refnr+1])+"  selected+++"
    lbfile1=Tkinter.Label(tp,text=txtref)
    lbfile1.pack()
                                                                       
                                                                       
    mco,mdi,cov,div=rmod2.discon(dm,r,k,refnr,obj,g)
    maxcov=max(cov)
    tdisco=ScrolledText(tp,width=60,height=20)
    tdisco.pack()
    txtdisco="\n"
    txtdisco+="\n Results of Discordance - Concordance - Analysis "
    txtdisco+="\n weights: "+str(k)
    txtdisco+="\n Reference object "+str(iob)
    txtg=""
    for j in range(0,k):
        txtg+=str(round(g[j],3))+" ,"
    txtdisco+="\n\n"+txtg
    txtdisco+="\n"
    txtdisco+="maxcov= "+str(maxcov)
    txtdisco+="\n\tobject\tcov-vector\tdis-vector\tdis - cov + maxcov"
    txtres=""
    for i in range(0,r):
        txtres+="\t"+ob[i+1]+"\t"+str(cov[i])+"\t"+str(div[i])+"\t"+str(round(div[i]-cov[i]+maxcov,2))+"\n"
    txtdisco+="\n"+txtres
    txtdisco+="\n  - - - end of File - - -"
    tdisco.insert("end",txtdisco)

    
    hfgr=Tkinter.Toplevel(hf,width=250,height=400)
    hfgr.title(' Graphics Discordance-Concordance ')
    frgr=Tkinter.Frame(hfgr,width=250,height=400)
    frgr.pack()
    cv1=Tkinter.Canvas(frgr,width=200,height=120)
    cv1.create_line(10,90,10,10,arrow="last")
    cv1.create_line(10,90,180,90)
    bbar=0.8*170/(1.0*k)
    abstbar=bbar/4.0
    hbar=rmod2.vecgen1(k)
    for j in range(0,k):
        hbar[j]=g[j]*80
    for j in range(0,k):
        cv1.create_rectangle(10+j*(abstbar+bbar),90,10+j*(abstbar+bbar)+bbar,80-hbar[j],fill="red")
        
    cv1.create_text(85,110,text="weights")
    cv1.pack()
    cv2=Tkinter.Canvas(frgr,width=250,height=200)
    cv2.create_rectangle(30,180,200,10)
    for i in range(0,r):
        cv2.create_text(10,180-i*170.0/(1.0*r),text=str(ob[i+1]))
    for j in range(0,k):
        cv2.create_text(40+j*170.0/(1.0*k),5,text="g"+str(j))
    for i in range(0,r):
        for j in range(0,k):
            if mdi[i][j]==1:
                farbe="red"
            else:
                farbe="white"
                
            cv2.create_rectangle(40+j*170.0/(1.0*k),180-i*170.0/(1.0*r),50+j*170.0/(1.0*k),170-i*170.0/(1.0*r),fill=farbe)
            
                        
    cv2.pack()
    # HD
    hfhd3=Tkinter.Toplevel(hf)
    #hfhd2.title('Hasse diagram or cover matrix ')
    freq2=Tkinter.Frame(hfhd3,width=200,height=300)
    freq2.pack()
    cocov=rmod2.vecgen1(r)
    max_cocov=max(cov)
    for i in range(0,r):
        cocov[i]=max_cocov-cov[i]    #by this the div-vector and cocov (cov)-vector have the same orientation
                                        #large values: bad
    dm2=rmod2.marray(r,2)
    k2=2
    for i in range(0,r):
        dm2[i][0]=div[i]
        dm2[i][1]=cocov[i]
    pro2=rmod2.vecgen1(3)
    pro2[0]="disco"
    pro2[1]="div"
    pro2[2]="cocov"
    
    obj=rmod2.vecgen1(r)
    for i in range(0,r):
        obj[i]=ob[i+1]
    #############################dieser Teil ist neu 21.12.07
    rred2,xred2,objred2,txt=rmod2.equivcompact(r,k2,dm2,obj)    
    ###############################################################
    n=rred2
    labeq=Tkinter.Label(freq2,text=" calc. is based on representants ")
    labeq.config(bg="yellow")
    labeq.pack()

    #
    zetahilf=rmod2.comp(n,k2,xred2)
    zeta=rmod2.marray(rred2,rred2)
    for i in range(0,rred2):
        for j in range(0,rred2):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    lbhd1=Tkinter.Label(freq2,text= "Level ")
    lbhd1.pack()

    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(n,zeta)
    #print "zzmax = ",zzmax
    tlev=ScrolledText(freq2,width=60,height=4)
    tlev.pack()
    txt1="\n"
    
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= objred2[lobj[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)

    txt2="\n One linear extension \n\n"
    for i in range(0,n):
        if i<n-1:
            txt2+=objred2[revlext[i]]+" < "
        else:
            txt2+=objred2[revlext[i]]+"\n"
    txt2+="\n"
    txt2+="\n -- end of list -- "
    tlinext=ScrolledText(freq2,width=60, height=2)
    tlinext.pack()
    tlinext.insert("end",txt2)
    
    #Adj-Listen

    adjc=rmod2.adjacent(n,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(n,adjc,lext)
       
    
    zeta2=rmod2.cover(n,tr,lext)
    if n>30:
        lbhd2=Tkinter.Label(freq2,text=" graphical presentation not meaningful, see levels and cover-matrix ")
        lbhd2.pack()
        txt3="\n cover-matrix  \n"
        for i in range(0,n):
            txt3+="\t"+objred2[i]+"\t"
        txt3+="\n"
        for i in range(0,n):
            txt3+=objred2[i]+" :"
            for j in range(0,n):
                txt3+=str(zeta2[i][j])+"\t"
            txt3+="\n"
        txt3+=" -- end of list --"
        tcov=ScrolledText(freq2,width=60, height=4)
        tcov.pack()
        tcov.insert("end",txt3)
    else:
        lbhd3=Tkinter.Label(freq2,text=" Hasse Diagram based on Discordance and Co-Concordance ")
        lbhd3.pack()
        cv=Tkinter.Canvas(freq2,width=400,height=250)
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(n,n)
        geomy=rmod2.marray(n,n)

        geom0x=10
        geom0y=20
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(160.0/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(160.0/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if zeta2[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred2[lobj[i][j]])
        garrow1x=210
        garrow1y=20
        garrow2y=190
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
##        cv.create_line(garrow1x-4,garrow2y-4,garrow1x,garrow2y)
##        cv.create_line(garrow1x+4,garrow2y-4,garrow1x,garrow2y)
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.create_text(75,205,text="weights: " + txtg)
        cv.create_text(75,230,text="Reference object: "+str(iob))
        cv.pack()
        

         
def showDM():
    """ New routine : shows the data matrix """
    #Brg 13.1.08
    tp2=Tkinter.Toplevel(hf)
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+ob[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+pro[j+1]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=pro[j+1]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=ob[i+1]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)


def HDdiagram():
    "based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"
    # Brg 20.12.07, 28.12.07
    # If the number of representants > 20 then only the cover-matrix and the level-population
    #
    global zeta2,n,objred    
    hfhd2=Tkinter.Toplevel(hf)
    #hfhd2.title('Hasse diagram or cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    global fn
    #dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    rred,xred,objred,obj,prop,txt=filecomp(r,dm,pro,fn)
    n=rred
    labeq=Tkinter.Label(freq,text="file = "+fn+": calc. is based on representants ")
    labeq.config(bg="yellow")
    labeq.pack()

    #
    zetahilf=rmod2.comp(n,k,xred)
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    lbhd1=Tkinter.Label(freq,text= "Level ")
    lbhd1.pack()

    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(n,zeta)
    #print "zzmax = ",zzmax
    tlev=ScrolledText(freq,width=60,height=4)
    tlev.pack()
    txt1="\n"
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= objred[lobj[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)

    txt2="\n One linear extension \n\n"
    for i in range(0,n):
        if i<n-1:
            txt2+=objred[revlext[i]]+" < "
        else:
            txt2+=objred[revlext[i]]+"\n"
    txt2+="\n"
    txt2+="\n -- end of list -- "
    tlinext=ScrolledText(freq,width=60, height=2)
    tlinext.pack()
    tlinext.insert("end",txt2)
    
    #Adj-Listen

    adjc=rmod2.adjacent(n,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(n,adjc,lext)
       
    
    zeta2=rmod2.cover(n,tr,lext)
    if n>100:
        lbhd2=Tkinter.Label(freq,text=" graphical presentation not meaningful, see levels and cover-matrix ")
        lbhd2.pack()
        txt3="\n cover-matrix  \n"
        for i in range(0,n):
            txt3+="\t"+objred[i]+"\t"
        txt3+="\n"
        for i in range(0,n):
            txt3+=objred[i]+" :"
            for j in range(0,n):
                txt3+=str(zeta2[i][j])+"\t"
            txt3+="\n"
        txt3+=" -- end of list --"
        tcov=ScrolledText(freq,width=60, height=4)
        tcov.pack()
        tcov.insert("end",txt3)
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram of File "+fn)
        lbhd3.pack()
        cv=Tkinter.Canvas(freq,width=300,height=200)
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(n,n)
        geomy=rmod2.marray(n,n)

        geom0x=10
        geom0y=20
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(160.0/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(160.0/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if zeta2[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        garrow1x=210
        garrow1y=20
        garrow2y=190
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
##        cv.create_line(garrow1x-4,garrow2y-4,garrow1x,garrow2y)
##        cv.create_line(garrow1x+4,garrow2y-4,garrow1x,garrow2y)
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.pack()
        buttcover=Tkinter.Button(freq,text="show cover relation",command=cover_show)
        buttcover.pack()

def cover_show():
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: -
    hfcover=Tkinter.Toplevel(hf)
    #hfcover.title(' cover-matrix ')
    
    lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,n):
        txt3+="\n"+objred[i]+":\t"
        txt3+="is cover_less than "
        for j in range(0,n):
            if i!=j:
                if zeta2[i][j]==1:
                    txt3+=" "+objred[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=4)
    tcov.pack()
    tcov.insert("end",txt3)


##def raihelp():
##    """ Help about DisCO """
##    
##    #  brg 22.3.08, 23.3.08, 23.5.08
##    
##    txthelp="\n   Aim   \n"
##    txthelp+="\n  DisCo calculates   (1) the Hasse diagram "
##    txthelp+="\n        calculates   (2) Discordance and Concordance matrices "
##    txthelp+="\n        calculates   (3) Discordance and Concordance vector"
##    txthelp+="\n                         after selection of a reference object  " 
##    txthelp+="\n                         and input of weights"
##    txthelp+="\n        calculates   (4) a new Hasse diagram based on Discordance and Concordance vectors "
##    txthelp+="\n\n  Prerequisites \n"
##    txthelp+="\n  (1)Preview: to get the number of the objects and of attributes"
##    txthelp+="\n     you may press the 'preview Button'. Note that even if the data matrix "
##    txthelp+="\n     is that you wanted, you have later explicitly select and open the file"
##    txthelp+="\n  (2)Excel - data matrix with the names of objects and properties, "
##    txthelp+="\n     stored as txt-file (tabulators as sep.) and any txt in the (0,0)-position"
##    txthelp+="\n     Less than 200 objects and less than 200 attributes "
##    txthelp+="\n     Details, see tutorial for more information"
##    txthelp+="\n  (3)Be aware that you must know the number of objects and of the attributes"
##    txthelp+="\n     therefore it is recommended to use the preview-function. "
##    txthelp+="\n\n  Usage \n"
##    txthelp+="\n   Theoretical and literature information, press the 'about'-Button"
##    txthelp+="\n   1)The entries: a) identifier for the object to be a reference object "
##    txthelp+="\n   b) number of attributes "
##    txthelp+="\n   2) Confirm the reference object"
##    txthelp+="\n   3) Confirm the number of attributes. By this a field is opening to read in the weights"
##    txthelp+="\n   4) Confirm the weights"
##    txthelp+="\n   5) Select, open and calculate (the main button for processing)"
##    txthelp+="\n   6) If wanted, one can look at the data matrix (dm) and the Hasse diagram of dm."
##    txthelp+="\n   "
##    txthelp+="\n   Different results are shown in different windows, so that they can be arranged by you"
##    txthelp+="\n    ...as you like it (for example to perform a screenshot)"
##    txthelp+="\n   Some results are given in textfields with scroll-function"
##    txthelp+="\n     "
##    txthelp+="\n\n\n  Examples   "
##    txthelp+="\n    Good examples are kodi.txt and kodi2.txt  "
##    txthelp+="\n - - - -   end of   f i l e   - - - - -\n"
##    hfhelp=Tkinter.Toplevel(hf)
##    lbhelp2=Tkinter.Label(hfhelp,text="   help: Disco   ")
##    lbhelp2.pack()
##    frhelp=Tkinter.Frame(hfhelp,width=400,height=400)
##    frhelp.pack()
##    thelp=ScrolledText(frhelp,width=80, height=20)
##    thelp.pack()
##    
##    thelp.insert("end",txthelp)




def filecomp(r,dm,pro,fn):
    """ reduces a dm with equiv objects to a dm of a quotient set """
    # Brg 12.12.07, 13.1.08, 23.5.08
    #r,k,dm,ob,pro,fn are globals and should be available after open
    
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    #recoding ob to obj and pro to prop
    if r==0:
        hfwarning=Tkinter.Toplevel(hf)
        frwarning=Tkinter.Frame(hfwarning,width=10,height=3)
        frwarning.pack()
        bwarning=Tkinter.Button(frwarning,text="++warning ++",command=msgwarning)
        bwarning.pack()
        
    prop=rmod2.vecgentext1(k)
    obj=rmod2.vecgentext1(r)  #changed 23.5.08
    for i in range(0,k):
        prop[i]=pro[i+1]
    for i in range(0,r):
        obj[i]=ob[i+1]
    #############################dieser Teil ist neu 21.12.07
    rred,xred,objred,txt=rmod2.equivcompact(r,k,dm,obj)    
    ###############################################################
    #print objred
    #print "reduzierte matrix"
    #rmod2.matout(rred,k,xred)
    return rred,xred,objred,obj,prop,txt           
    
def preview():
    # brg 23.5.08
    
    tpprev=Tkinter.Toplevel(hf)
    tfileprev=ScrolledText(tpprev,width=60,height=4)
    tfileprev.pack()
    fn=tkFileDialog.askopenfilename()
    global dm,ob,pro,r
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    
    
    txt1="\n"
    txt1+="\n "+str(r)+"  objects\n"
    txt1+="\n "+str(k)+"  attributes\n"
    txt1+="\n========================= \n"
    for i in range(0,r):
        txt1+=str(i)+":"+ob[i+1]+",\n"
    txt1+="\n\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=str(j)+":"+pro[j+1]+",\n"
    txt2+="\n\n"
    txt3="\n"
    txt3+="\n Sorry, even if this is the correct matrix "
    txt3+="\n you must once again select and open the file, "
    txt3+="\n after selecting the refenrence object and the weights."
    txt3+="\n  - - -  end of file - - - "
    
    txt=txt1+txt2+txt3
    tfileprev.insert("end",txt)
    
    



hf=Tkinter.Tk()
hf.title(' Discordance-Concordance ')

helpdiscordance=raioop2.brgabout(hf,"tp1","help_discordance.txt",3,\
            "October, 2012, the 25th"," help_discordance ", "white", "t1",80,5,ScrolledText)
    
aboutdiscordance=raioop2.brgabout(hf,"tp1","about_discordance.txt",3,\
            "October, the 25th, 2012"," about_discordance ", "white", "t1",80,5,ScrolledText)    


frmain=Tkinter.Frame(hf,width=200,height=200)
frmain.pack()
lbgeom=Tkinter.Label(frmain,text="                                                                           ")
lbgeom.pack()

buttpreview=Tkinter.Button(frmain,text="preview", command=preview)
buttpreview.pack()

frinput=Tkinter.Frame(frmain,width=50,height=10)
frinput.pack()

lbrefob=Tkinter.Label(frinput,text="select one ref_obj ")  #23.5.08, 25.10012
lbrefob.pack(side="left")
eref=Tkinter.Entry(frinput,width=3)
eref.pack(side="left")
frinput2=Tkinter.Frame(frmain,width=50,height=10)
frinput2.pack()
lb_how_many_weights=Tkinter.Label(frinput2,text="how many attributes ")
lb_how_many_weights.pack(side="left")
ek=Tkinter.Entry(frinput2,width=3)
ek.pack(side="left")
butt1=Tkinter.Button(frmain,text="confirm ref-object, open weights-entries",bg="cyan",command=how_many_attributes)
butt1.pack()
lbgew=Tkinter.Label(frmain,text="")
lbgew.pack()
frinput3=Tkinter.Frame(frmain,width=60,height=10,relief="groove",bd=2)
frinput3.pack()

butt2=Tkinter.Button(frmain,text="confirm weights ",bg="cyan",width=25,command=confirm_weights)
butt2.pack()
lbconfirm=Tkinter.Label(frmain,text="")
lbconfirm.pack()
buttfile=Tkinter.Button(frmain,text="Select, open file and Discordance-calc",bg="cyan",width=35, bd=4,command=fselectopencalc)
buttfile.pack(pady=5)
buttshow=Tkinter.Button(frmain,text="show data matrix ",width=25, command=showDM)
buttshow.pack()
buttHD=Tkinter.Button(frmain,text=" Hasse diagram ", width=25,command=HDdiagram)
buttHD.pack(pady=5)
buttexit=Tkinter.Button(frmain,text=" exit ",width=25,bg="red",command=hf.destroy)
buttexit.pack(pady=5)
hf.mainloop()


 

