# -*- coding: cp1252 -*-
import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import tkFileDialog
import raioop2
import random
import pstat
import stats

#Brg in cooperation with Korbinian Freier, MPI Hamburg, 2.10. and 3.10.09
# Brg HDCI: 7.10.2010
# Brg: some cosmetics: 8.10.2010
# Version 2: inclusion of order ideals, filters and intervals: 13.10.2010
# Brg  15.3.2011:
#       Version 3: scan of weights and check for order relations between
#       a selected pair of objects
#       Version 4: parts of linagg10 are now accessible in HDCI4 too. 
# Brg 16.3.2011: Version 5: weight distribution for a certain order relation between two objects
# Brg 4.8.2011 There is a bug in HD and its CI-values
# Brg 5.8., 6.8. 2011 extension of the program
# Brg 11.8.2012: memory error: rmod2 in listes.extend(trs(w)). 12.7.2012 still unclear
# brg 18.10.2013, 19.10.2013, 20.10.2013
# brg 14.11.2013 U(x) as additional information in CI-rankings and LPOMext-ranking
# brg 22.8.2014 saving the ranking lists for obj (not only for objred)

def overview():
    #brg 6.8.2011
    tpover=Tkinter.Toplevel(hf)
    tpover.title(' Overview  ')
    cvo=Tkinter.Canvas(tpover,width=600,height=500,bg="white")
    cvo.pack()
    dr1=20
    dr2=50
    rec=rmod2.vecgen1(12)
    rectext=rmod2.vecgen1(12)
    linov=rmod2.vecgen1(13)
    linov[0]=cvo.create_line(250,50+dr1,250,125-dr1,arrow="last",fill="red")
    linov[1]=cvo.create_line(250,125+dr1,300,200-dr1,arrow="last",fill="red")
    linov[2]=cvo.create_line(250,125+dr1,425,200-dr1,arrow="last",fill="red")
    linov[3]=cvo.create_line(250,125+dr1,530,200-dr1,arrow="last",fill="red")
    linov[5]=cvo.create_line(250,125+dr1,150,200,fill="black")
    linov[6]=cvo.create_line(150,200,150,350-dr1,arrow="last",fill="black")
    linov[7]=cvo.create_line(150,350+dr1,50,420-dr1,arrow="last",fill="black")
    linov[8]=cvo.create_line(150,350+dr1,250,420-dr1,arrow="last",fill="black")
    linov[9]=cvo.create_line(300,200+dr1,300,300-dr1,arrow="last",fill="red")
    linov[10]=cvo.create_line(530,200+dr1,530,300-dr1,arrow="last",fill="red")
    linov[11]=cvo.create_line(530,300+dr1,530,420-dr1,arrow="last",fill="red")
    linov[12]=cvo.create_line(425,200+dr1,530,300-dr1,arrow="last",fill="red")
    rec[0]=cvo.create_rectangle(250-dr2,50+dr1,250+dr2,50-dr1)
    rectext[0]=cvo.create_text(250,50,text="Select/Open")
    rec[1]=cvo.create_rectangle(250-dr2,125+dr1,250+dr2,125-dr1)
    rectext[1]=cvo.create_text(250,125,text="Select weights")   
    rec[2]=cvo.create_rectangle(300-dr2,200+dr1,300+dr2,200-dr1)
    rectext[2]=cvo.create_text(300,200,text="HD (orig. dm)")
    rec[3]=cvo.create_rectangle(425-dr2,200+dr1,425+dr2,200-dr1,fill="yellow")
    rectext[3]=cvo.create_text(425,200,text="CI(weights,dm)")
    rec[4]=cvo.create_rectangle(530-dr2,200+dr1,530+dr2,200-dr1)
    rectext[4]=cvo.create_text(530,200,text="Rkav(dm)")
    rec[5]=cvo.create_rectangle(300-dr2,300+dr1,300+dr2,300-dr1,fill="yellow")
    rectext[5]=cvo.create_text(300,300,text="Navig. in HD(orig)")
    rec[6]=cvo.create_rectangle(530-dr2,300+dr1,530+dr2,300-dr1)
    rectext[6]=cvo.create_text(530,300,text="Anal. of discr.")
    rec[7]=cvo.create_rectangle(530-dr2,420+dr1,530+dr2,420-dr1,fill="yellow")
    rectext[7]=cvo.create_text(530,420,text="HD(CI,Rkav)")
    rec[8]=cvo.create_rectangle(150-dr2,350+dr1,150+dr2,350-dr1)
    rectext[8]=cvo.create_text(150,350,text="weight analysis")
    rec[9]=cvo.create_rectangle(50-dr2,420+dr1,50+dr2,420-dr1,fill="yellow")
    rectext[9]=cvo.create_text(50,420,text="x > y as f(weights)")
    rec[10]=cvo.create_rectangle(250-dr2,420+dr1,250+dr2,420-dr1,fill="yellow")
    rectext[10]=cvo.create_text(250,420,text="HD as f(weights)")

def rfilter():
    """ subposet by generatiing a filter """
    global i12set,orderchar
    dobj=o1.get()  
    #print "filter generating object: ",dobj
    #print "objred ",objred
    i1=objred.index(dobj)
    i1set=set([i1])
    for j in range(0,rred):
        if zeta[i1][j]==1:
            i1set=i1set|set([j])
    i2set=set([0])
    for i in range(1,rred):
        i2set=i2set|set([i])
    i12set=i1set&i2set
    orderchar="principal filter of "+dobj
    graphs()

def rideal():
    """ subposet by generating ideal """
    global i12set,orderchar
    uobj=o2.get() #upper object
    i2=objred.index(uobj)
    i2set=set([i2])
    for i in range(0,rred):
        if zeta[i][i2]==1:
            i2set=i2set|set([i])
    i1set=set([0])
    for i in range(1,rred):
        i1set=i1set|set([i])
    i12set=i1set&i2set
    orderchar="principal ideal of "+uobj
    graphs()
     

def rinterv():
    """ subposet by generating interval """
    global i12set,orderchar
    #print " rinterval i12set ",i12set
    dobj=o3.get() #lower object
    uobj=o4.get() #upper object
    #print "rinterval dobj ",dobj
    #print "rinterval uobj ",uobj
    i1=objred.index(dobj)
    i2=objred.index(uobj)
    i1set=set([i1])
    for j in range(0,rred):
        if zeta[i1][j]==1:
            i1set=i1set|set([j])
    i2set=set([i2])
    for i in range(0,rred):
        if zeta[i][i2]==1:
            i2set=i2set|set([i])
    i12set=i1set&i2set
    orderchar="interval of "+dobj+"  and  "+uobj    #5.3.09
    graphs()
     

def graphs():
    """ Digraph based on subset selections """
    tpsub=Tkinter.Toplevel(hf)
    tpsub.title(' subgraphs ')
    
    try:
        diam=int(ediam.get())
    except:
        diam=15
    try:
        hdf=float(efact.get())
    except:
        hdf=1.5
    try:
        fpt=int(efont.get())
    except:
        fpt=8


        
    l12=len(i12set)
    if l12==0:
        lbmsg=Tkinter.Label(tpsub,text="  +++empty order +++  ", font=("Arial",18,"bold"),bg="yellow")
        lbmsg.pack()
    else:    
        objsub=rmod2.vecgentext1(l12)
        z=0
        #print "in graphs: rred = ",rred,"  objred = ",objred 
        for i in range(0,rred):
            if objred.index(objred[i]) in i12set:
                objsub[z]=objred[i]
                z+=1
            
        zetaneu=rmod2.marray(l12,l12)
        z1=0
        for i in range(0,rred):
            z2=0
            for j in range(0,rred):
                if i in i12set and j in i12set:
                    if zeta[i][j]==1:
                        zetaneu[z1][z2]=1
                    else:
                        zetaneu[z1][z2]=0
                    z2+=1   
            if i in i12set:
                z1+=1

        #rmod2.matout(l12,l12,zetaneu)
        n=l12
        #rmod2.matout(n,n,zeta)
        lobj,lext,revlext,zzmax=rmod2.levtopsort(n,zetaneu)
        #print "zzmax = ",zzmax
        
           
        #Adj-Listen

        adjc=rmod2.adjacent(n,lext,revlext,zetaneu)
            
        #Transitive reduced relations
        ts,tr=rmod2.trreduct2(n,adjc,lext,n)
           
        
        zeta2=rmod2.cover(n,tr,lext)
        if n>100:
            lbhd2=Tkinter.Label(tpsub,text=" graphical presentation not meaningful, see levels and cover-matrix ")
            lbhd2.pack()
            txt3="\n cover-matrix  \n"
            for i in range(0,n):
                txt3+="\t"+objred[i]+"\t"
            txt3+="\n"
            for i in range(0,n):
                txt3+=objred[i]+" :"
                for j in range(0,n):
                    txt3+=str(zeta2[i][j])+"\t"
                txt3+="\n"
            txt3+=" -- end of list --"
            tcov=ScrolledText(tpsub,width=60, height=6)
            tcov.pack()
            tcov.insert("end",txt3)
        else:
            lbhd3=Tkinter.Label(tpsub,text=orderchar)
            lbhd3.pack()
            cv=Tkinter.Canvas(tpsub,width=300,height=200,bg="white")
            lz=zzmax
            l=rmod2.vecgen1(lz)
            for i in range(0,lz):
                l[i]=len(lobj[i])

            pos=rmod2.vecgen1(lz)
            for i in range(0,lz):
                pos[i]=l[i]
            
            geomx=rmod2.marray(n,n)
            geomy=rmod2.marray(n,n)
            
            geom0x=10
            geom0y=20
            for i in range(0,lz):
                for j in range(0,l[i]):
                    geomx[i][j]=geom0x+hdf*(160.0/(pos[i]+1.0))*(j+1)
                    geomy[i][j]=geom0y+hdf*(160.0/lz)*i
                

            for i in range(0,lz-1):
                for j in range(0,l[i]):
                    #print obj[lobj[i][j]]
                    for i1 in range(i+1,lz):
                        for j1 in range(0,l[i1]):
                            #print obj[lobj[i1][j1]]
                            if zeta2[lobj[i1][j1]][lobj[i][j]]==1:
                                #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                                cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])

            
            print "in graphs "
            print "objsub : ",objsub
            print " objred= ",objred
            print "lobj = ",lobj
            for i in range(0,lz):
                for j in range(0,l[i]):
                    cv.create_oval(geomx[i][j]-diam,geomy[i][j]+diam,geomx[i][j]+diam,geomy[i][j]-diam,fill="white")
                    print "i = ",i,"   j= ",j,"   lobj[i][j]= ",lobj[i][j]
                    
                    iob=lobj[i][j]
                    print "iob = ",iob
                    
                    print "objred-related: ",objred[iob]
                    print "obj-related ",obj[iob]
                    print "objsub-related ",objsub[iob]
                    ob=objsub[iob]
                    iobadj=objred.index(ob)
                    print "adjusted iobadj ",iobadj
                    print "ci iobadj : ",ci[iobadj]
                    cv.create_text(geomx[i][j],geomy[i][j],text=objsub[lobj[i][j]]+":"+str(round(ci[iobadj],2)),font=("arial",fpt))
            garrow1x=210
            garrow1y=20
            garrow2y=190
    
            cv.pack()
        




def fileopen():
    global dm,obj,prop,r,rred,fn,k,weighte,rred,xred,objred,txteq,neq   

    fn=tkFileDialog.askopenfilename()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    lb1.config(text="opened "+fn,bg="yellow")
    

    prop=[]
    for j in range(0,k):
        prop.append(pro[j+1])
            
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
    for i in range(0,r):
        obj[i]=ob[i+1]

    rred,xred,objred,txteq,neq=rmod2.equivcompactm(r,k,dm,obj)
    print "txteq= ",txteq
    print "neq ",neq
    print "k = ",k
    weighte=rmod2.vecgen1(k)
    lbw.config(text="read in the weights ")
    for j in range(0,k):
        weighte[j]=Tkinter.Entry(frw,width=12)
        weighte[j].grid(row=1,column=j)

    tps0=Tkinter.Toplevel(hf)
    tps0.title(" weight scan - board ")
    global ewlower,ewupper,esteps,eobjpaar,eMCsim
    ewlower=rmod2.vecgen1(k)
    ewupper=rmod2.vecgen1(k)
    esteps=rmod2.vecgen1(k)
    lbw2=Tkinter.Label(tps0,text="lower and upper limit of weights")
    lbw2.pack()
    frw2=Tkinter.Frame(tps0,relief="sunken",bd=3)
    frw2.pack()
    for j in range(0,k):
        lbnumber=Tkinter.Label(frw2,text=str(j+1)+". weight")
        lbnumber.grid(row=j,column=0)
        ewlower[j]=Tkinter.Entry(frw2,width=4)
        ewlower[j].grid(row=j,column=1)
        ewupper[j]=Tkinter.Entry(frw2,width=4)
        ewupper[j].grid(row=j,column=2)
        
    frob=Tkinter.Frame(tps0)
    frob.pack()
    lbmc=Tkinter.Label(tps0,text="Number of trials (MCsim) ")
    lbmc.pack()
    eMCsim=Tkinter.Entry(tps0,width=6)
    eMCsim.pack()
    lbob=Tkinter.Label(frob,text="Insert in the entry boxes:\nObject 1, order relation > or < , object 2")
    lbob.pack()
    eobjpaar=rmod2.marray(3,3)  #preliminary set to observe three object pairs and 1 for > , 2 for <
    frob2=Tkinter.Frame(frob)
    frob2.pack()
    for j1 in range(0,1):
        eobjpaar[j1][0]=Tkinter.Entry(frob2,width=5)
        eobjpaar[j1][1]=Tkinter.Entry(frob2,width=2)
        eobjpaar[j1][2]=Tkinter.Entry(frob2,width=5)
        eobjpaar[j1][0].grid(row=j1,column=0)
        eobjpaar[j1][1].grid(row=j1,column=1)
        eobjpaar[j1][2].grid(row=j1,column=2)
    buttcalc=Tkinter.Button(tps0,text="scan...",width=25,bg="cyan",command=weightscan)
    buttcalc.pack(pady=3) 
    


def showDM():
    """ New routine : shows the data matrix """
    #Brg 4.8.2011 from chain5
    tp2=Tkinter.Toplevel(hf)
    tp2.title(' show DM ')
    lbtp2=Tkinter.Label(tp2,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+ob[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+pro[j+1]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=pro[j+1]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=ob[i+1]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)


def calcU(r,k,dm):
    # brg 14.11.2013. Procedure taken from incomp_basic1.py
    # calulates from data matrix the matrix objx
    # objx is the basis for calculating quobx, which is the matrix including, lt,gt,ec,ic
    # From quobx the incomparabilities of each onbject x are obtained and shown.
    # return: Uobx as a vector of length r.
    objx=rmod2.comp(r,k,dm)
    quobx=rmod2.qualcomp1(r,objx)
    U=rmod2.rai_inc(r,quobx)
    Uobj=rmod2.vecgen1(r)
    for i in range(0,r):
        for i1 in range(0,r):
            if U[i][i1]!=-1:
                Uobj[i]+=1
    return Uobj
    
def calc():
    #brg 7.10.2010, 8.10.2010
    global ci,yn,w
    w=rmod2.vecgen1(k)
    ci=rmod2.vecgen1(r)
    txt="CI calculation  "
    txt+="\nweights  :"
    
    try:
        for j in range(0,k):
            w[j]=float(weighte[j].get())
            txt+=str(round(w[j],2))+"\t"
    except:
        for j in range(0,k):
            w[j]=1.0/(1.0*k)
            txt+=str(round(w[j],2))+"\t"
    sumw=0
    for j in range(0,k):
        sumw+=w[j]
    if sumw!=1:
        txtcorr="\n+++ weights corrected for sum weights = 1 +++\n"
        for j in range(0,k):
            w[j]=1.0*w[j]/(1.0*sumw)
    else:
        txtcorr=""
    yn=rmod2.matrixnorm(r,k,dm)   
    txt+="\n"+60*"-"+"\n"
    txt+=txtcorr
    for i in range(0,r):
        for j in range(0,k):
            ci[i]+=w[j]*yn[i][j]
        txt+=str(obj[i])+"\t CI(ari)= "+str(round(ci[i],2))+"\n"
        txt+="original values :\t"                          
        for j in range(0,k):
            txt+=str(round(dm[i][j],2))+"\t"

        txt+="\n"+"[0,1]-normalized values:"
        for j in range(0,k):
            txt+=str(round(yn[i][j],2))+"\t"
        txt+="\n"+60*"="
        txt+="\n"
    tcalc.insert("end",txt)    
    buttHD.config(state="active")
    buttHDCI.config(state="active")


def calc_ig():
    # brg 18.10.2013
    # Paola's recommendation as an alternative, originally formulated by Lugo et al., 2009
    #brg 7.10.2010, 8.10.2010
    global ci,yn,w
    w=rmod2.vecgen1(k)
    ci=rmod2.vecgen1(r)
    txt="CI (geom) calculation  "
    txt+="\nweights  :"
    
    try:
        for j in range(0,k):
            w[j]=float(weighte[j].get())
            txt+=str(round(w[j],2))+"\t"
    except:
        for j in range(0,k):
            w[j]=1.0/(1.0*k)
            txt+=str(round(w[j],2))+"\t"
    sumw=0
    for j in range(0,k):
        sumw+=w[j]
    if sumw!=1:
        txtcorr="\n+++ weights corrected for sum weights = 1 +++\n"
        for j in range(0,k):
            w[j]=1.0*w[j]/(1.0*sumw)
    else:
        txtcorr=""
    yn=rmod2.matrixnorm(r,k,dm)   
    txt+="\n"+60*"-"+"\n"
    txt+=txtcorr
    for i in range(0,r):
        for j in range(0,k):
            ci[i]+=w[j]*(yn[i][j])**0.5
        ci[i]=ci[i]**2    
        txt+=str(obj[i])+"\t CI(geom)= "+str(round(ci[i],2))+"\n"
        txt+="original values :\t"                          
        for j in range(0,k):
            txt+=str(round(dm[i][j],2))+"\t"

        txt+="\n"+"[0,1]-normalized values:"
        for j in range(0,k):
            txt+=str(round(yn[i][j],2))+"\t"
        txt+="\n"+60*"="
        txt+="\n"
    tcalc.insert("end",txt)    
    buttHD.config(state="active")
    buttHDCI.config(state="active")
    buttHDCIg.config(state="active")
    

def HDCIarithm():
    #brg 4.8.2011, 18.10.2013, 14.11.2013
    global ciorig,cisort
    tpHD2=Tkinter.Toplevel(hf)
    tpHD2.title(' Ranking due to CI ')
    global ci,yn,w
    w=rmod2.vecgen1(k)
    ci=rmod2.vecgen1(r)
    txt="CI calculation  "
    txt+="\nweights  :"
    
    try:
        for j in range(0,k):
            w[j]=float(weighte[j].get())
            txt+=str(round(w[j],2))+"\t"
    except:
        for j in range(0,k):
            w[j]=1.0/(1.0*k)
            txt+=str(round(w[j],2))+"\t"
    sumw=0
    for j in range(0,k):
        sumw+=w[j]
    if sumw!=1:
        txtcorr="\n+++ weights corrected for sum weights = 1 +++\n"
        for j in range(0,k):
            w[j]=1.0*w[j]/(1.0*sumw)
    else:
        txtcorr=""
    yn=rmod2.matrixnorm(r,k,dm)   
    
    for i in range(0,r):
        for j in range(0,k):
            ci[i]+=w[j]*yn[i][j]
        if i<10:
            print i," ",obj[i],"   ci= ",ci[i]
    cim=rmod2.marray(r,2)
    for i in range(0,r):        #in order to use as far as possible former routines: ci gets two identical columns
        cim[i][0]=ci[i]
        cim[i][1]=ci[i]
        
    Uorig=calcU(r,k,dm)    #new 14.11.2013
    

    rred2,xred2,objred2,txteq2,neq2=rmod2.equivcompactm(r,2,cim,obj)
    ciorig=[]
    for i in range(0,r):
        ciorig.append(ci[i])
    cisort,nsort=rmod2.raisort(r,ci)

    

    txt="CI(ari) ordered acc. to the object's sequence and their U(x)-values"+"\n"
    for i in range(0,r):
        txt+=str(obj[i])+"\t"+str(round(ciorig[i],3))+"\t"+str(Uorig[i])+"\n"
    txt+="\n"
    txt+="Sequence due to CI(ari), increasing and their U(x)-values"+"\n"
    txt+=30*"="+"\n"
    for i in range(0,r):
        txt+=str(i+1)+"\t"+str(obj[nsort[i]])+"\t"+str(round(cisort[i],3))+"\t"+str(Uorig[nsort[i]])+"\n"

    txt+="\n"
    txt+=30*"="+"\n"
    # equivalence elements (4.8.2011)
    txt+="Equivalences due to the CI-values "+"\n"
    txt+=txteq2+"\n"
    tequiv2=ScrolledText(tpHD2,width=60,height=10)
    tequiv2.pack(expand="y",fill="x")
    tequiv2.insert("end",txt)
    buttsaveci = Tkinter.Button(tpHD2,text = "Save the CI-values ",command=saveci)
    buttsaveci.pack()

def saveci():
    # brg 22.8.2014
    # ciorig will be stored in a file
    fn=tkFileDialog.asksaveasfilename(parent=hf,title="save file (extension '.txt' is recommended")
    f = open(fn,"w")
    f.write(str(len(ciorig))+"\n")
    for i in range(0, len(ciorig)):
        f.write(str(ciorig[i])+",")
    f.close

    
def HDCIgeom():
    #brg 4.8.2011, 18.10.2013
    global ciorig
    tpHD2g=Tkinter.Toplevel(hf)
    tpHD2g.title(' Ranking due to CI(geom) ')
    global ci,yn,w
    w=rmod2.vecgen1(k)
    ci=rmod2.vecgen1(r)
    txt="CI calculation  "
    txt+="\nweights  :"
    
    try:
        for j in range(0,k):
            w[j]=float(weighte[j].get())
            txt+=str(round(w[j],2))+"\t"
    except:
        for j in range(0,k):
            w[j]=1.0/(1.0*k)
            txt+=str(round(w[j],2))+"\t"
    sumw=0
    for j in range(0,k):
        sumw+=w[j]
    if sumw!=1:
        txtcorr="\n+++ weights corrected for sum weights = 1 +++\n"
        for j in range(0,k):
            w[j]=1.0*w[j]/(1.0*sumw)
    else:
        txtcorr=""
    yn=rmod2.matrixnorm(r,k,dm)   
    
    for i in range(0,r):
        for j in range(0,k):
            ci[i]+=w[j]*(yn[i][j])**0.5
        ci[i]=ci[i]**2

    cim=rmod2.marray(r,2)
    for i in range(0,r):        #in order to use as far as possible former routines: ci gets two identical columns
        cim[i][0]=ci[i]
        cim[i][1]=ci[i]


    Uorig=calcU(r,k,dm)  #new 14.11.2013
    
    rred2,xred2,objred2g,txteq2g,neq2g=rmod2.equivcompactm(r,2,cim,obj)
    ciorig=[]
    for i in range(0,r):
        ciorig.append(ci[i])
    cisort,nsort=rmod2.raisort(r,ci)

    txt="CI(geom) ordered accord to the object's sequence and their incomparabilities"+"\n"
    for i in range(0,r):
        txt+=str(obj[i])+"\t"+str(round(ciorig[i],3))+"\t"+str(Uorig[i]) +"\n"
    txt+="\n"

    txt+="Sequence due to increasing CI(geom) and corresp. incomparabilities "+"\n"
    txt+=30*"="+"\n"
    for i in range(0,r):
        txt+=str(i+1)+"\t"+str(obj[nsort[i]])+"\t"+str(round(cisort[i],3))+"\t"+str(Uorig[nsort[i]])+"\n"

    txt+="\n"
    txt+=30*"="+"\n"
    # equivalence elements (4.8.2011)
    txt+="Equivalences due to the CI-values "+"\n"
    txt+=txteq2g+"\n"
    tequiv2g=ScrolledText(tpHD2g,width=60,height=10)
    tequiv2g.pack(expand="y",fill="x")
    tequiv2g.insert("end",txt)
    
    


def HD():
    global zeta
    tpHD=Tkinter.Toplevel(hf)
    tpHD.title(" Hasse diagram ")
    frHD=Tkinter.Frame(tpHD,width=1000,height=1000)
    frHD.pack(side="top")
    freq=Tkinter.Frame(tpHD)
    freq.pack(side="bottom")
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    if rred>100:
        lbhd3=Tkinter.Label(frHD,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(frHD,text=" Hasse Diagram, file= "+str(fn)+" \n\n ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(tpHD,width=actwidth,height=actheight,bg="white")
        cv.config(scrollregion=(0,0,1000,1000))
        cv.config(highlightthickness=1)
        sbary=Tkinter.Scrollbar(cv,orient="vertical")
        sbary.config(command=cv.yview) 
        cv.config(yscrollcommand=sbary.set) 
        sbary.pack(side="right", fill="y")

        sbarx=Tkinter.Scrollbar(cv,orient="horizontal")
        sbarx.config(command=cv.xview) 
        cv.config(xscrollcommand=sbarx.set) 
        sbarx.pack(side="bottom",fill="x")          
        cv.pack(expand="y",fill="both")          
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(1.5*factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(1.5*factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])

        print "CI iob i..."
        for i in range(0,lz):
            for j in range(0,l[i]):
                iob=obj.index(objred[lobj[i][j]]) #lobj is based on representative elements, whereas ci is based on all objects
                
                print "i=",i,"  j= ",j,"  lobj = ",lobj[i][j],objred[lobj[i][j]],iob,obj[iob]
                print "ci...",ci[iob]
                
                cv.create_oval(geomx[i][j]-20,geomy[i][j]+20,geomx[i][j]+20,geomy[i][j]-20,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]]+": "+str(round(ci[iob],2)))
        # equivalence elements (4.8.2011)
        tequiv=ScrolledText(freq,width=60,height=2)
        tequiv.pack()
        tequiv.insert("end",txteq)
    buttrkav.config(state="active")

def SaPaUa():
    #Brg 5.8.2011 taken and adopted for the
    # purpose here, from hdgt5 of 30.9.09
##    try:
##        rkint=int(erankintervals.get())
##    except:
##        rkint=5                             #five intervals filled with objects
    global rkav
    tprkav=Tkinter.Toplevel(hf)
    tprkav.title(' Extended LPOM ')
    trkav=ScrolledText(tprkav,width=60,height=10)
    trkav.pack()
    Sa=rmod2.marray1(rred,rred,-1)
    Pa=rmod2.marray1(rred,rred,-1)
    Ua=rmod2.marray1(rred,rred,-1)
    countSa=rmod2.vecgen1(rred)
    countPa=rmod2.vecgen1(rred)
    countUa=rmod2.vecgen1(rred)
    
    for ob in objred:
        obi=objred.index(ob)
        
        #obi the selected element whose rkav will be deternmined
        z=0
        for i1 in range(0,rred):
            if zeta[i1][obi]==1:
                z+=1
                Sa[obi][i1]=i1
        #print "ob = ",ob,"  its order ideal:  ",Sa[obi]
        countSa[obi]=z
    for ob in objred:
        obi=objred.index(ob)
        
        #obi the selected element whose rkav will be determined
        z=0
        for i1 in range(0,rred):
            if zeta[obi][i1]==1:
                z+=1
                Pa[obi][i1]=i1
        #print "ob = ",ob,"  its order filter:  ",Pa[obi]
        countPa[obi]=z
    for ob in objred:
        obi=objred.index(ob)
        
        #obi the selected element whose rkav will be deternmined
        z=0
        for i1 in range(0,rred):
            if zeta[i1][obi]==0 and zeta[obi][i1]==0:
                z+=1
                Ua[obi][i1]=i1
        #print "ob = ",ob,"  its incomparables  ",Ua[obi]
        countUa[obi]=z

    #rmod2.matout(rred,rred,Ua)
    
    txt="Rkav (LPOMext MATCH, 2011) \n "
    txt+=60*"="+"\n"
    global rkav
    rkav=rmod2.vecgen1(rred)
    for i2 in range(0,rred):
        rkav[i2]=countSa[i2]  #note Sa includes the interesting element a too
      
    txt+="\n Object\tRkav (LPOMext)\n"
    txt+=50*"-"+"\n"
    
    for ob in objred:
        obi=objred.index(ob)
        increment=0
        
        for y in Ua[obi]:
            #print "y in increment loop: ",objred[y]," ",
            Uy=[]
            Pdown=0
            Pup=0
            
            if y!=-1:
                for i1 in range(0,rred):
                    if zeta[i1][y]==0 and zeta[y][i1]==0:
                        Uy.append(i1)
                
                for x in Uy:
                    if x in Sa[obi]:
                        Pdown+=1
                            
                for x in Uy:
                    if x in Pa[obi]:
                        Pup+=1
                
                dinc=1.0*Pdown/(1.0*Pdown+1.0*Pup)
                
                increment+=dinc
                #print "obi = ",obi,"  y= ",y,"  Pdown= ",Pdown,"   Pup = ",Pup
        rkav[obi]+=1.0*increment
        txt+=ob+"\t"+str(round(rkav[obi],3))+"\n"
    txt+="\n"
    print "rkav= ....",rkav
    txtorder="\nOrdered sequence of objects "+"\n"
    txtorder+=50*"="+"\n"
    rkavsik=[]
    for i in range(0,rred):
        rkavsik.append(rkav[i])
    
    rksort,nrksort=rmod2.raisort(rred,rkavsik)
    
    for i in range(0,rred):
        txtorder+=str(objred[nrksort[i]])+"\t"+str(round(rksort[i],3))+"\n"

    txtorder+="\n"
    txtorder+=50*"="+"\n"
    txt+=txtorder
    trkav.insert("end",txt)
    buttsaverkav = Tkinter.Button(tprkav, text = "save rkavextended ", command=rkextsave)
    buttsaverkav.pack()
    global fim
    fim=rmod2.marray(rred,2)   # final matrix : first column: rkav of LPOMext, second column: CI of only those objects which are representative elements
##    for oborig in obj:
##        ioborig=obj.index(oborig)
##        print oborig,"  ci  ",ciorig[ioborig]
    print "Testing of 20.10.2013 "
    zahl=0
    for ob in objred:
        iob=objred.index(ob)
        fim[iob][0]=rkav[iob]
        ioborig=obj.index(ob)
        fim[iob][1]=ciorig[ioborig]
        if zahl<10:
            print ob,"  iob = ",iob,"  rkav = ",rkav[iob],"   ioborig= ",ioborig,"   ci(orig) = ",ciorig[ioborig]
        zahl+=1    
    fim0=[]
    fim1=[]
    for i in range(0,rred):
        fim0.append(fim[i][0])
        fim1.append(fim[i][1])
        if i<10:
            print "i= ",i,"  objred= ",objred[i],"  fim0 (hav) = ",fim0[i],"  fim1 (CI) = ",fim1[i]
    rspear,probspear=pstat.lspearmanr(fim0,fim1)    
    print "Spearman correlation ",rspear
    tpcheck=Tkinter.Toplevel(hf)
    tpcheck.title(' Spearman correlation Partial order vs CI ')
    lbwarn=Tkinter.Label(tpcheck,text="")
    lbwarn.pack()
    txtweight=""
    for j in range(0,k):
        txtweight+=str(w[j])+"\t"
    txtweight+="\n"    
    txtcorr="correlation of both sequences Rkav vs CI \n(concerning the rpresentative elements) "+"\n"
    txtcorr+=50*"="+"\n"
    if rspear>0.95:
        txtcorr+="Your weighting scheme: "+txtweight+"\n"
        txtcorr+="Spearman correlation index = "+str(rspear)+"\n"
        txtcorr+="Weighting scheme not in conflict with partial order"+"\n"
        lbwarn.config(text=" No contradictions ",bg="yellow")
    else:
        txtcorr+="Your weighting scheme: "+txtweight+"\n"
        txtcorr+="Spearman correlation index = "+str(rspear)+"\n"
        txtcorr+=" < =0.95 as an arbitrary limit "+"\n"
        txtcorr+=" There may be conflicts due to your weighting "+"\n"
        lbwarn.config(text=" May be some severe contradictions ",bg="orange",font=("arial",14,"bold"))
    txtcorr+=" - - - e o f - - -  "+"\n"
    
    tcheck=ScrolledText(tpcheck,width=60,height=5)
    tcheck.pack()
    tcheck.insert("end",txtcorr)
    buttanalysis=Tkinter.Button(tpcheck,text="analysis",command=check)
    buttanalysis.pack()
    
def rkextsave():
    #brg 22.8.2014
    dummy1,dummy2,dummy3,dummy4,eqm_act = rmod2.equivcompactgr(r,k,dm,obj)
    print "eqm_act= ",eqm_act
    rkextended = rmod2.weak2(r,obj,objred,rkav, eqm_act)
    print "rkextended = ",rkextended
    fn=tkFileDialog.asksaveasfilename(parent=hf,title="save rkextended (extension '.txt' is recommended")
    f = open(fn,"w")
    f.write(str(len(rkextended))+"\n")
    for i in range(0, len(rkextended)):
        f.write(str(rkextended[i])+",")
    f.close


def check():
    #brg  5.8.2011
    tpanalysis=Tkinter.Toplevel(hf)
    tpanalysis.title(' analysis of discrepancies ')
    tanalysis=ScrolledText(tpanalysis)
    tanalysis.pack()
    zetahilf3=rmod2.comp(rred,2,fim)  #zeta matrix with col<row
    zeta3=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta3[i][j]=zetahilf3[j][i]
    
    Sa3=rmod2.marray1(rred,rred,-1)
    Pa3=rmod2.marray1(rred,rred,-1)
    Ua3=rmod2.marray1(rred,rred,-1)
    countSa3=rmod2.vecgen1(rred)
    countPa3=rmod2.vecgen1(rred)
    countUa3=rmod2.vecgen1(rred)
    
    for ob in objred:
        obi=objred.index(ob)
        
        #obi the selected element whose rkav will be deternmined
        z=0
        for i1 in range(0,rred):
            if zeta3[i1][obi]==1:
                z+=1
                Sa3[obi][i1]=i1
        #print "ob = ",ob,"  its order ideal:  ",Sa[obi]
        countSa3[obi]=z
    for ob in objred:
        obi=objred.index(ob)
        
        #obi the selected element whose rkav will be deternmined
        z=0
        for i1 in range(0,rred):
            if zeta3[obi][i1]==1:
                z+=1
                Pa3[obi][i1]=i1
        #print "ob = ",ob,"  its order filter:  ",Pa[obi]
        countPa3[obi]=z
    for ob in objred:
        obi=objred.index(ob)
        
        #obi the selected element whose rkav will be deternmined
        z=0
        for i1 in range(0,rred):
            if zeta3[i1][obi]==0 and zeta3[obi][i1]==0:
                z+=1
                Ua3[obi][i1]=i1
        #print "ob = ",ob,"  its incomparables  ",Ua[obi]
        countUa3[obi]=z

    U3total=0
    for i in range(0,rred):
        for i1 in range(0,rred):
            if i!=i1:
                if zeta3[i][i1]==0 and zeta3[i1][i]==0:
                    U3total+=0.5

    dcoinc=1.0-(1.0*U3total/(1.0*rred*(rred-1.0)/2.0))        


    Ua3countsik=[]
    for i in range(0,rred):
        Ua3countsik.append(countUa3[i])
    
    cUa3sort,n3sort=rmod2.raisort(rred,Ua3countsik)

    txtweight=""
    for j in range(0,k):
        txtweight+=str(w[j])+"\t"
    txtweight+="\n"  

    txtua="Results"+"\n"
    txtua+=30*"="+"\n"
    txtua+="Number of incomparabilities in Rkav vs Ci - order "+str(U3total)+"\n"
    txtua+="Degree of coincidence (Bruggemann, Patil, 2011, page 156): "+str(round(dcoinc,3))+"\n"
    txtua+="\n\nSequence due to incomparabilities, increasing "+"\n"
    
    for i in range(0,rred):
        txtua+=str(objred[n3sort[i]])+"\t"+str(cUa3sort[i])+"\n"

    txtua+="\n"
    txtua+="Used weighting scheme "+"\n"
    txtua+=txtweight
    txtua+=30*"="+"\n"
    
    tanalysis.insert("end",txtua)
    buttHDfim=Tkinter.Button(tpanalysis,text="representation CI and Rkav by a HD",command=hdcirk)
    buttHDfim.pack()


def hdcirk():
    #brg 5.8.2012, 18.10.2013
    tpHD4=Tkinter.Toplevel(hf)
    tpHD4.title(' CI and Rkav (LPOMext)')
    print "fim= ",fim    
    rred4,xred4,objred4,txteq4,neq4=rmod2.equivcompactm(rred,2,fim,objred)
    print "rred4 = ",rred4
    zetahilf4=rmod2.comp(rred4,2,xred4)  #zeta matrix with col<row, dm with CI and Rkav
    zeta4=rmod2.marray(rred4,rred4)
    for i in range(0,rred4):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred4):
            zeta4[i][j]=zetahilf4[j][i]
    #Check for incomparabilities
    incompcirkav=0
    incomppairs=[]
    for i in range(0,rred4):
        for i1 in range(0,rred4):
            if zeta4[i][i1]==0 and zeta4[i1][i]==0:
                incompcirkav+=0.5
                incomppairs.append([objred4[i],objred4[i1]])
    lincomp=len(incomppairs)
    tphdcirk=Tkinter.Toplevel(hf)
    tphdcirk.title(' incomp with respect to CI and hav ')
    thdcirk=ScrolledText(tphdcirk,width=60,height=10)
    thdcirk.pack()
    txt=" Incomparabilities of simultaneous ranking due to hav and CI "+"\n"
    txt+=50*"="+"\n"
    txt+="Incomparabilities: "+str(incompcirkav)+"\n"
    txt+="incomparable pairs : "+"\n"
    txthilf=" "
    for i2 in range(0,lincomp):
        if incomppairs[i2][0]!=txthilf:
            txt+="\n"+str(incomppairs[i2])+", "
            txthilf=incomppairs[i2][0]
        else:
             txt+=str(incomppairs[i2])+", "
            
    txt+="\n"
    thdcirk.insert("end",txt)
    # if incompcirkav < 20% of rred4*(rred4)/2 then no HD
    fractionincomp=0.2
    totalcomp=rred4*rred4/2.0
    if incompcirkav<fractionincomp*totalcomp:
        tpwarncirk=Tkinter.Toplevel(hf)
        lbwarncirk=Tkinter.Label(tpwarncirk, text=" No fuerher analysis, because too many comparabilities !!",bg="yellow")
        lbwarncirk.pack()
    else:
    
                                   
        #One linear extension (based on levels)
        
        lobj4,lext4,revlext4,zzmax4=rmod2.levtopsort(rred4,zeta4)
           
        levmax=-10**20     #20.6.08
        for i in range(0,zzmax4):
            if len(lobj4[i])>=levmax:
                levmax=len(lobj4[i])
           
        #Adj-Listen

        adjc=rmod2.adjacent(rred4,lext4,revlext4,zeta4)
            
        #Transitive reduced relations
        ts,tr=rmod2.trreduct(rred4,adjc,lext4)
           
        
        cov4=rmod2.cover(rred4,tr,lext4)

        if rred4>100:
            lbhd5=Tkinter.Label(tpHD4,text=" +++too many objects ++++  ",bg="yellow")
            lbhd5.pack()                  
        else:
            lbhd5=Tkinter.Label(tpHD4,text=" Hasse Diagram, file= "+str(fn)+" \n\n ")
            lbhd5.pack()
            actwidth,actheight,factorx,\
                    factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred4,levmax,zzmax4)
            cv4=Tkinter.Canvas(tpHD4,width=actwidth,height=actheight,bg="white")
            cv4.config(scrollregion=(0,0,1000,1000))
            cv4.config(highlightthickness=1)
            sbary=Tkinter.Scrollbar(cv4,orient="vertical")
            sbary.config(command=cv4.yview) 
            cv4.config(yscrollcommand=sbary.set) 
            sbary.pack(side="right", fill="y")

            sbarx=Tkinter.Scrollbar(cv4,orient="horizontal")
            sbarx.config(command=cv4.xview) 
            cv4.config(xscrollcommand=sbarx.set) 
            sbarx.pack(side="bottom",fill="x")          
            cv4.pack(expand="y",fill="both")          
            lz=zzmax4
            l=rmod2.vecgen1(lz)
            for i in range(0,lz):
                l[i]=len(lobj4[i])

            pos=rmod2.vecgen1(lz)
            for i in range(0,lz):
                pos[i]=l[i]

            geomx=rmod2.marray(rred4,rred4)
            geomy=rmod2.marray(rred4,rred4)

           
            for i in range(0,lz):
                for j in range(0,l[i]):
                    geomx[i][j]=geom0x+(1.5*factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                    geomy[i][j]=geom0y+(1.5*factory/lz)*i
                
            
            for i in range(0,lz-1):
                for j in range(0,l[i]):
                    for i1 in range(i+1,lz):
                        for j1 in range(0,l[i1]):
                            if cov4[lobj4[i1][j1]][lobj4[i][j]]==1:
                                cv4.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


            for i in range(0,lz):
                for j in range(0,l[i]):
                    iob=obj.index(objred4[lobj4[i][j]]) #lobj is based on representative elements, whereas ci is based on all objects
                    #print "i=",i,"  j= ",j,"  lobj = ",lobj[i][j],objred[lobj[i][j]],iob,obj[iob]
                    
                    cv4.create_oval(geomx[i][j]-20,geomy[i][j]+20,geomx[i][j]+20,geomy[i][j]-20,fill="white")
                    cv4.create_text(geomx[i][j],geomy[i][j],text=objred4[lobj4[i][j]])
            # equivalence elements (4.8.2011)
            tequiv4=ScrolledText(tpHD4,width=60,height=2)
            tequiv4.pack()
            txtanalhd=""
            txtweight=""
            for j in range(0,k):
                txtweight+=str(w[j])+"\t"
            txtweight+="\n"
            txtanalhd+="weighting scheme: "+txtweight+"\n"
            txtanalhd+="Equivalence classes "+"\n"
            txtanalhd+=txteq4
            tequiv4.insert("end",txtanalhd)
    



def weightscan():
    MCsim=int(eMCsim.get())
    upperw=rmod2.vecgen1(k)
    lowerw=rmod2.vecgen1(k)
    
    weight=rmod2.marray(k,10)  #5: 5 different values of the jth weight.
    objpaar=rmod2.marray(3,3)
    for j in range(0,k):
        try:
            lowerw[j]=float(ewlower[j].get())
        except:
            lowerw[j]=0.0
        try:    
            upperw[j]=float(ewupper[j].get())
        except:
            upperw[j]=1.0
        
    for j1 in range(0,1):
        objpaar[j1][0]=eobjpaar[j1][0].get()
        objpaar[j1][1]=eobjpaar[j1][1].get()
        objpaar[j1][2]=eobjpaar[j1][2].get()
       
    yn=rmod2.matrixnorm(r,k,dm)
    rmod2.matout(r,k,yn)
    

    iob=rmod2.marray(3,2)  #let it for more than 1 object pair
    for j1 in range(0,1):
        try:
            iob[j1][0]=obj.index(objpaar[j1][0])
        except:
            iob[j1][0]=99999   #dummy for no object
        try:    
            iob[j1][1]=obj.index(objpaar[j1][2])
        except:
            iob[j1][1]=99999  #dummy for no object

    minw=rmod2.vecgen1(k)
    maxw=rmod2.vecgen1(k)
    for j in range(0,k):
        minw[j]=9999
        maxw[j]=-9999

    txt="S c a n   o f   w e i g h t s"
    txt+="\n"
    flag1=0
    flag2=0
    hist=rmod2.marray(k,5)#0..0.2, 0.2,,,0.4, 0.4..0.6,0.6..0.8,0.8...1
    anz=0
    for mc in range(0,MCsim):
        CI=rmod2.vecgen1(r)
        
       
        sumw=0
        for j in range(0,k):
            weight[j]=0.01*random.randint(100*lowerw[j],100*upperw[j])
            sumw+=weight[j]
        if sumw!=1.00 and sumw!=0:
            for j in range(0,k):
                weight[j]=1.0*weight[j]/(1.0*sumw)
        for i in range(0,r):
            for j in range(0,k):
                CI[i]+=weight[j]*yn[i][j]
        for j1 in range(0,1):
            if objpaar[j1][1]==">":
                if iob[j1][0]<99999:
                    if CI[iob[j1][0]]>CI[iob[j1][1]]:
                        txt+=str(objpaar[j1][0]) +" > "+ str(objpaar[j1][2])+":\n"+str(round(CI[iob[j1][0]],2))+">"+str(round(CI[iob[j1][1]],2))
                        txthilf="weights"
                        for j in range(0,k):
                            txthilf+="  "+str(round(weight[j],3))+", "
                            for j3 in range(0,5):
                                if j3*0.2<=weight[j]<0.2*(j3+1):
                                    hist[j][j3]+=1
                            if weight[j]<=minw[j]:
                                minw[j]=weight[j]
                                flag1=1
                            if weight[j]>=maxw[j]:
                                maxw[j]=weight[j]
                                flag2=1
                        txt+="\n"+txthilf+"\n"
                        anz+=1
            elif objpaar[j1][1]=="<":
                if iob[j1][0]<99999:
                    if CI[iob[j1][0]]<CI[iob[j1][1]]:
                        txt+=str(objpaar[j1][0]) +" < "+ str(objpaar[j1][2])+":\n"+str(round(CI[iob[j1][0]],2))+"<"+str(round(CI[iob[j1][1]],2))
                        txthilf="weights: "
                        for j in range(0,k):
                            txthilf+="  "+str(round(weight[j],3))+", "
                            for j3 in range(0,5):
                                if j3*0.2<=weight[j]<0.2*(j3+1):
                                    hist[j][j3]+=1
                            if weight[j]<=minw[j]:
                                minw[j]=weight[j]
                                flag1=1
                            if weight[j]>=maxw[j]:
                                maxw[j]=weight[j]
                                flag2=1
                        txt+="\n"+txthilf+"\n"
                        anz+=1
    tphisto=rmod2.vecgen1(k)
    th=rmod2.vecgen1(k)
    barth=["0.1","0.3","0.5","0.7","0.9"]
    tob=" "+str(objpaar[0][0])+" "+str(objpaar[0][1])+" "+str(objpaar[0][2])
    for j in range(0,k):
        tobw="\nweight no "+str(j)
        #print "j= ",j," histo = ",hist[j]
        tphisto[j]=Tkinter.Toplevel(hf)
        tphisto[j].title(' distribution of weight '+str(j))
        lbhisto=Tkinter.Label(tphisto[j],text=" count of successful weight combinations   : "+str(anz))
        lbhisto.pack()
        th[j]=ScrolledText(tphisto[j],width=120,height=5)
        th[j].pack()
        thhilf="weight "+str(j)+": \t"
        thtxt="\t\t"
        for j3 in range(0,5):
            thhilf+=str(j3*0.2)+"\t..."+str((j3+1)*0.2)+",\t"
            thtxt+=str(hist[j][j3])+"\t\t"
        th[j].insert("end",thhilf+"\n"+thtxt)    
        app=raioop2.brgbar8(tphisto[j],hist[j],barth,tob+tobw)
        app.ausgabe()
    
    txt+="\n"+" - - - e o f - - - "
    txt2=" Summary of MCsimulation "
    txt2+=str(objpaar[0][0])+" "+str(objpaar[0][1])+" "+str(objpaar[0][2])
    txt2+="\n"+"max weights:"+"\n"
    txthilf2=""
    for j in range(0,k):
        txthilf2+=str(round(maxw[j],3))+" ,   "
    txt2+=txthilf2
    txt2+="\n"+"min weights: "+"\n"
    txthilf3=""
    for j in range(0,k):
        txthilf3+=str(round(minw[j],3))+" ,  "
    txt2+=txthilf3    
                      
    txt2+="\n - e o f - "
    tpweight=Tkinter.Toplevel(hf)
    tpweight.title(' Detailed list of possible weights ')
    tweight=ScrolledText(tpweight,width=120,height=10)#
    tweight.pack()
    if flag1+flag2==2:
        txtf=txt
        txt2f=txt2
    else:
        txtf="++ no weight combination found +++"
        txt2f="++ no weight combination found +++"
    
    tweight.insert("end",txtf)
    tps02=Tkinter.Toplevel(hf)
    tps02.title(' Summary of results ')
    tweight2=ScrolledText(tps02,width=120,height=5)
    tweight2.pack()
    
    tweight2.insert("end",txt2f)



def MCHD():
    # nbrg 24.1.2011 (taken from linagg10.py
    # Idea: The user may be interested in variation of m' weights, whereas m-m' are held constant
    # Within the MC-simulation any case represents a ranking.
    # All rankings can be put together to a HD (similar to the stability4.py)
    global eMCsim,tpMCHD,egbelow,egabove
    tpMCHDo=Tkinter.Toplevel(hf)
    egbelow=rmod2.vecgen1(k)
    egabove=rmod2.vecgen1(k)
    lbgMCHD=Tkinter.Label(tpMCHDo,text="weight-intervals (below-above) ")
    lbgMCHD.pack()
    frgMCHD=Tkinter.Frame(tpMCHDo,bd=3,relief="sunken")
    frgMCHD.pack()
    for j in range (0,k):
        lbhilf=Tkinter.Label(frgMCHD,text="weight["+str(j)+"]:")
        lbhilf.grid(row=j,column=0)
        egbelow[j]=Tkinter.Entry(frgMCHD,width=5)
        egbelow[j].grid(row=j,column=1)
        egabove[j]=Tkinter.Entry(frgMCHD,width=5)
        egabove[j].grid(row=j,column=2)
    lbgsim=Tkinter.Label(tpMCHDo, text="How many MC-simulations")
    lbgsim.pack()
    eMCsim=Tkinter.Entry(tpMCHDo,width=10)
    eMCsim.pack()
    buttMCHD=Tkinter.Button(tpMCHDo,text="submit of weight-intervals ",command=gsubmit)
    buttMCHD.pack()


def gsubmit():
    global zeta21, objred1,rred1
    tpMCHD=Tkinter.Toplevel(hf)
    freq1=Tkinter.Frame(tpMCHD)
    freq1.pack()
    idnr=random.randint(1,1000)
    print "k = ",k
    gbelow=rmod2.vecgen1(k)
    gabove=rmod2.vecgen1(k)
    MCsim=int(eMCsim.get())
    dmg=rmod2.marray(rred,MCsim)
    g=rmod2.vecgen1(k)
    for j in range(0,k):
        gbelow[j]=float(egbelow[j].get())
        gabove[j]=float(egabove[j].get())
##    print "y = "
##    rmod2.matout(rred,k,y)
##    print " "
    gmin=rmod2.vecgen1(k)
    gmax=rmod2.vecgen1(k)
    gmean=rmod2.vecgen1(k)
    ming=rmod2.vecgen1(k)
    maxg=rmod2.vecgen1(k)
    for j in range(0,k):
        ming[j]=9999
        maxg[j]=-9999
    for mc in range(0,MCsim):
        sumg=0
        for j in range(0,k):
            g[j]=0.0001*random.randint(int(10000*gbelow[j]),int(10000*gabove[j]))
            #print "j = ",j," g= ",g[j]
            sumg+=g[j]
        if sumg!=1:    # sumweight=1 -normalization
            for j in range(0,k):
                g[j]=1.0*g[j]/sumg
        for j in range(0,k):
            gmean[j]+=g[j]
            if g[j]>=maxg[j]:
                maxg[j]=g[j]
            if g[j]<=ming[j]:
                ming[j]=g[j]
        Gamma=rmod2.vecgen1(rred)
##        print "mc= ",mc
##        for j in range(0,k):
##            print "  g[",j,"]= ",round(g[j],3),ming[j],maxg[j]
        for io in range(0,rred):
            for j in range(0,k):
                Gamma[io]+=yn[io][j]*g[j]   #normalized dm of representants
            #print "Gamma fuer ",io,"  : ",Gamma[io]    
            
        lio=pstat.lrankdata(Gamma)
        for io in range(0,rred):
            dmg[io][mc]=lio[io]     #dmg will be filled with the different rankings counted by mc

##    rmod2.matout(rred,MCsim,dmg)
##    print "Nach equivcompact "
    for j in range(0,k):
        gmean[j]=1.0*gmean[j]/(1.0*MCsim)

    tpg=Tkinter.Toplevel(hf)
    tpg.title(' g-characteristic ')
    lbgchar=Tkinter.Label(tpg,text="effective g-values in a simulation with "+str(MCsim)+"  runs")
    lbgchar.pack()
    txtg="identifier: "+str(idnr)+"\n"
    txtg+=60*"="+"\n"
    txtg+=60*"="+"\n"
    txtg+="g-characteristics\n"
    txtg+=60*"="+"\n"
    txtg+="Inputs"+"\n"
    txtg+="    gbelow"+"\t"+"gabove"+"\n"
    for j in range(0,k):
        txtg+=str(j)+": "+str(round(gbelow[j],3))+"\t\t"+str(round(gabove[j],3))+"\n"
    txtg+=2*"\n"    
    txtg+="    min-values"+"\t"+"mean-values"+"\t"+"  max-values\n"
    for j in range(0,k):
        txtg+=str(j)+": "+str(round(ming[j],3))+"\t\t"+str(round(gmean[j],3))+"\t\t"+str(round(maxg[j],3))+"\n"
    txtg+="\n"
    txtg+="   e o f   "
    tgc=ScrolledText(tpg,width=80,height=10)
    tgc.pack()
    tgc.insert("end",txtg)

    rred1,dmgred,objred1,txtquot,txteq=rmod2.equivcompact3(rred,MCsim,dmg,objred)
##    rmod2.matout(rred1,MCsim,dmgred)
    print "in gsubmit ",rred1
    zetahilf1=rmod2.comp(rred1,MCsim,dmgred)
    zeta1=rmod2.marray(rred,rred)
    for i in range(0,rred1):
        for j in range(0,rred1):
            zeta1[i][j]=zetahilf1[j][i]
    #
    
    #rmod2.matout(rred,rred,zeta)
    lobj1,lext1,revlext1,zzmax1=rmod2.levtopsort(rred1,zeta1)
    print "zzmax1 = ",zzmax1
    print "lext1 = ",lext1
    tlev1=ScrolledText(freq1,height=10,width=60)
    tlev1.pack()
    txt1="\n"
    for i in range(0,zzmax1):
        txt1+="Level "+str(zzmax1-i)+" :"
        for j in range(0,len(lobj1[i])):
            txt1+= objred1[lobj1[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev1.insert("end",txt1)

        
    #Adj-Listen

    adjc1=rmod2.adjacent(rred1,lext1,revlext1,zeta1)
    print "len(adjc1)=",len(adjc1)    
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred1,adjc1,lext1)  #new trreduct2 12.7.2012
       
    
    zeta21=rmod2.cover(rred1,tr,lext1)
    if rred1>100:
        lbhd2=Tkinter.Label(freq1,text=" graphical presentation not meaningful, see levels and cover-matrix ")
        lbhd2.pack()
        txt3="\n cover-matrix  \n"
        for i in range(0,rred1):
            txt3+="\t"+objred1[i]+"\t"
        txt3+="\n"
        for i in range(0,rred1):
            txt3+=objred1[i]+" :"
            for j in range(0,rred1):
                txt3+=str(zeta21[i][j])+"\t"
            txt3+="\n"
        txt3+=" -- end of list --"
        tcov=ScrolledText(freq1,width=60, height=4)
        tcov.pack()
        tcov.insert("end",txt3)
    else:
        lbhd3=Tkinter.Label(freq1,text=" Hasse Diagram of File "+fn)
        lbhd3.pack()
        cv=Tkinter.Canvas(freq1,width=300,height=240,bg="white")
        lz=zzmax1
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj1[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(rred1,rred1)
        geomy=rmod2.marray(rred1,rred1)

        geom0x=10
        geom0y=20
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(160.0/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(160.0/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if zeta21[lobj1[i1][j1]][lobj1[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred1[lobj1[i][j]])
        garrow1x=210
        garrow1y=20
        garrow2y=190
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.create_text(50,230,text="Identifier: "+str(idnr))
        
        
        buttcover=Tkinter.Button(freq1,text="show cover relation",command=cover1_show)
        buttcover.pack()
        cv.pack()


def cover1_show():
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: -
    hfcover1=Tkinter.Toplevel(hf)
    hfcover1.title(' cover-matrix ')
    
    lbhd2=Tkinter.Label(hfcover1,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,rred1):
        txt3+="\n"+objred1[i]+":\t"
        txt3+="is covered by "
        for j in range(0,rred1):
            if i!=j:
                if zeta21[i][j]==1:
                    txt3+=" "+objred1[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover1,width=50, height=4)
    tcov.pack()
    tcov.insert("end",txt3)






    
hf = Tkinter.Tk()
hf.title(' HDCI ')
hf.title(' HDCI ')
aboutHDCI=raioop2.brgabout(hf,"tp1","about_HDCI.txt",7,\
            "August, 22nd,2014"," about HDCI ", "white", "t1",80,5,ScrolledText)
helpHDCI=raioop2.brgabout(hf,"tp1","help_HDCI.txt",7,\
            "August, 22nd, 2014"," help_HDCI ", "white", "t1",80,5,ScrolledText)
    
buttoverview=Tkinter.Button(hf,text="Overview",bg="green",width=25,command=overview)
buttoverview.pack()
fr=Tkinter.Frame(hf,width=60)
fr.pack()
buttopen = Tkinter.Button(fr, text='select, open ',width=25,bg="cyan",command=fileopen)
buttopen.pack(pady=5)
lb1=Tkinter.Label(fr)
lb1.pack()
buttshowdm=Tkinter.Button(fr,text="show data matrix",width=25,command=showDM)
buttshowdm.pack()

frw=Tkinter.Frame(fr)
frw.pack()
lbw=Tkinter.Label(frw,text="")
lbw.grid(row=0,columnspan=4)
buttcalc=Tkinter.Button(fr,text=" CI-calculation ",width=25,bg="cyan",command=calc)
buttcalc.pack()
buttcalc2=Tkinter.Button(fr,text=" CI(geom)-calculation ",width=25,bg="cyan",command=calc_ig)
buttcalc2.pack()
frresults=Tkinter.Frame(fr)
frresults.pack()
tcalc=ScrolledText(frresults,width=60,height=10)
tcalc.pack()

buttHD=Tkinter.Button(fr,text="Hasse diagram (orig. dm)",width=25,bg="cyan",state="disabled",command=HD)
buttHD.pack()
buttHDCI=Tkinter.Button(fr,text=" Ranking due to CI(arithm) ", width=25,bg="cyan",state="disabled",command=HDCIarithm)
buttHDCI.pack()
buttHDCIg=Tkinter.Button(fr,text=" Ranking due to CI(geom) ", width=25,bg="cyan",state="disabled",command=HDCIgeom)
buttHDCIg.pack()
buttrkav=Tkinter.Button(fr,text="Ranking due to LPOMext ",width=25, bg="cyan",state="disabled",command=SaPaUa)
buttrkav.pack()
freinstellung=Tkinter.Frame(fr,bd=3,relief="groove")  #grid!!!!
freinstellung.pack()
lbeinst=Tkinter.Label(freinstellung,text=" Filters,Ideals,Intervals: \n Sel. of diam. (15), line-dist. factor (1.5), font (8) ")
lbeinst.grid(row=0,columnspan=5)
ediam=Tkinter.Entry(freinstellung,width=2)
ediam.grid(row=1,column=1)
efact=Tkinter.Entry(freinstellung,width=2)
efact.grid(row=1,column=3)
efont=Tkinter.Entry(freinstellung,width=2)
efont.grid(row=1,column=5)
frfilter=Tkinter.Frame(hf,relief="sunken",bd=2)
frfilter.pack(fill="x")
lbfilter=Tkinter.Label(frfilter,text=">>>enter filter-generating object >>>")
lbfilter.pack(side="left",fill="x")
o1=Tkinter.Entry(frfilter,width=10)
o1.pack(side="left")
buttfilter=Tkinter.Button(frfilter,text = "(3a) filter ",bg="cyan",width=15,command=rfilter)
buttfilter.pack()

frideal=Tkinter.Frame(hf,relief="sunken",bd=2)
frideal.pack(fill="x")
lbideal=Tkinter.Label(frideal,text=">>>enter ideal-generating object >>>")
lbideal.pack(side="left",fill="x")
o2=Tkinter.Entry(frideal,width=10)
o2.pack(side="left")
buttideal=Tkinter.Button(frideal,text = "(3b) ideal ",bg="cyan",width=15,command=rideal)
buttideal.pack()

frinterv=Tkinter.Frame(hf,relief="sunken",bd=2)
frinterv.pack()
lbinterv1=Tkinter.Label(frinterv,text=">enter generat.object (below)>>")
lbinterv1.pack(side="left")
o3=Tkinter.Entry(frinterv,width=10)
o3.pack(side="left")
lbinterv2=Tkinter.Label(frinterv,text=">enter generat.object (above)>>")
lbinterv2.pack(side="left")
o4=Tkinter.Entry(frinterv,width=10)
o4.pack(side="left")              
buttinterv=Tkinter.Button(frinterv,text = "(3c) interval ",bg="cyan",width=15,command=rinterv)
buttinterv.pack()
buttMCHD=Tkinter.Button(hf,text="Subset of g-values ",bg="cyan",width=25,command=MCHD)
buttMCHD.pack(pady=5)
buttexit = Tkinter.Button(hf, text = 'exit', bg = 'red', width=25,command = hf.destroy)
buttexit.pack(pady=10)

hf.mainloop()

