# -*- coding: cp1252 -*-
import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import tkFileDialog
import raioop2
import random
import pstat
import stats

#Brg in cooperation with Korbinian Freier, MPI Hamburg, 2.10. and 3.10.09
# Brg HDCI: 7.10.2010
# Brg: some cosmetics: 8.10.2010
# Version 2: inclusion of order ideals, filters and intervals: 13.10.2010
# Brg  15.3.2011:
#       Version 3: scan of weights and check for order relations between
#       a selected pair of objects
#       Version 4: parts of linagg10 are now accessible in HDCI4 too. 
# Brg 16.3.2011: Version 5: weight distribution for a certain order relation between two objects
# Brg 4.8.2011 There is a bug in HD and its CI-values
# Brg 5.8., 6.8. 2011 extension of the program
# Brg 11.8.2012: memory error: rmod2 in listes.extend(trs(w)). 12.7.2012 still unclear
# brg 18.10.2013, 19.10.2013, 20.10.2013
# brg 14.11.2013 U(x) as additional information in CI-rankings and LPOMext-ranking
# brg 15.11.2013: Rearrangement: normalizing (y/n), selection of aggregation method
# Brg 15.11.2013: HDCI6_4 will be maintained
# Brg 15.11.2013: New HDCICIhav which was derived from HDCI6_4, with strict parallism between CIari and CIgen
# brg 16.11.2013: Pearson correlation included and many bugs eliminated


def fileopen():
    global dm,obj,prop,r,rred,fn,k,weighte,rred,xred,objred,txteq,neq   

    fn=tkFileDialog.askopenfilename()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    lb1.config(text="opened "+fn,bg="yellow")
    

    prop=[]
    for j in range(0,k):
        prop.append(pro[j+1])
            
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
    for i in range(0,r):
        obj[i]=ob[i+1]

    rred,xred,objred,txteq,neq=rmod2.equivcompactm(r,k,dm,obj)
    print "txteq= ",txteq
    print "neq ",neq
    print "k = ",k
    weighte=rmod2.vecgen1(k)
    lbw.config(text="read in the weights ")
    for j in range(0,k):
        weighte[j]=Tkinter.Entry(frw,width=12)
        weighte[j].grid(row=1,column=j)

    
def showDM():
    """ New routine : shows the data matrix """
    #Brg 4.8.2011 from chain5
    tp2=Tkinter.Toplevel(hf)
    tp2.title(' show DM ')
    lbtp2=Tkinter.Label(tp2,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+ob[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+pro[j+1]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=pro[j+1]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=ob[i+1]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)


def calcU(r,k,dm):
    # brg 14.11.2013. Procedure taken from incomp_basic1.py
    # calculates from data matrix the matrix objx
    # objx is the basis for calculating quobx, which is the matrix including, lt,gt,ec,ic
    # From quobx the incomparabilities of each onbject x are obtained and shown.
    # return: Uobx as a vector of length r.
    global Uobj
    objx=rmod2.comp(r,k,dm)
    quobx=rmod2.qualcomp1(r,objx)
    U=rmod2.rai_inc(r,quobx)
    Uobj=rmod2.vecgen1(r)
    for i in range(0,r):
        for i1 in range(0,r):
            if U[i][i1]!=-1:
                Uobj[i]+=1
    return Uobj
    
def calc():
    #brg 7.10.2010, 8.10.2010, 15.11.2013
    global ciari,yfin,w
    w=rmod2.vecgen1(k)
    ciari=rmod2.vecgen1(r)
    txt="CI calculation  "
    txt+="\nweights  :"
    try:
        hnorm=enorm.get()
    except:
        hnorm="y"
    try:
        for j in range(0,k):
            w[j]=float(weighte[j].get())
            txt+=str(round(w[j],2))+"\t"
    except:
        for j in range(0,k):
            w[j]=1.0/(1.0*k)
            txt+=str(round(w[j],2))+"\t"
    sumw=0
    for j in range(0,k):
        sumw+=w[j]
    if sumw!=1:
        txtcorr="\n+++ weights corrected for sum weights = 1 +++\n"
        for j in range(0,k):
            w[j]=1.0*w[j]/(1.0*sumw)
    else:
        txtcorr=""
    if hnorm=="n":
        yfin=rmod2.matcopy1(r,k,dm)
    else:
        yfin=rmod2.matrixnorm(r,k,dm)
    
    txt+="\n"+60*"-"+"\n"
    txt+=txtcorr
    for i in range(0,r):
        for j in range(0,k):
            ciari[i]+=w[j]*yfin[i][j]
        txt+=str(obj[i])+"\t CI(ari)= "+str(round(ciari[i],3))+"\n"
        txt+="original values :\t"                          
        for j in range(0,k):
            txt+=str(round(dm[i][j],2))+"\t"

        txt+="\n"+"used values:"
        for j in range(0,k):
            txt+=str(round(yfin[i][j],2))+"\t"
        txt+="\n"+60*"="
        txt+="\n"
    tcalc.insert("end",txt)    
    
    


def calc_ig():
    # brg 18.10.2013
    # Paola's recommendation as an alternative, originally formulated by Lugo et al., 2009
    #brg 7.10.2010, 8.10.2010
    global cigen,yfin,w
    w=rmod2.vecgen1(k)
    cigen=rmod2.vecgen1(r)
    txt="CI (geom) calculation  "
    txt+="\nweights  :"
    try:
        hnorm=enorm.get()
    except:
        hnorm="y"
    try:
        for j in range(0,k):
            w[j]=float(weighte[j].get())
            txt+=str(round(w[j],2))+"\t"
    except:
        for j in range(0,k):
            w[j]=1.0/(1.0*k)
            txt+=str(round(w[j],2))+"\t"
    sumw=0
    for j in range(0,k):
        sumw+=w[j]
    if sumw!=1:
        txtcorr="\n+++ weights corrected for sum weights = 1 +++\n"
        for j in range(0,k):
            w[j]=1.0*w[j]/(1.0*sumw)
    else:
        txtcorr=""

    if hnorm=="n":
        yfin=rmod2.matcopy1(r,k,dm)
    else:
        yfin=rmod2.matrixnorm(r,k,dm)
        
       
    txt+="\n"+60*"-"+"\n"
    txt+=txtcorr
    for i in range(0,r):
        for j in range(0,k):
            cigen[i]+=w[j]*(yfin[i][j])**0.5
        cigen[i]=cigen[i]**2    
        txt+=str(obj[i])+"\t CI(geom)= "+str(round(cigen[i],3))+"\n"
        txt+="original values :\t"                          
        for j in range(0,k):
            txt+=str(round(dm[i][j],2))+"\t"

        txt+="\n"+"used values:"
        for j in range(0,k):
            txt+=str(round(yfin[i][j],2))+"\t"
        txt+="\n"+60*"="
        txt+="\n"
    tcalc.insert("end",txt)    
    
    
    


def HDCIarithm():
    #brg 4.8.2011, 18.10.2013, 14.11.2013, 16.11.2013
    global ciariorig,cimari,ciari,txtari
      
    cimari=rmod2.marray(r,2)
    for i in range(0,r):        #in order to use as far as possible former routines: ci gets two identical columns
        cimari[i][0]=ciari[i]
        cimari[i][1]=ciari[i]
        
    Uorig=calcU(r,k,dm)    #new 14.11.2013
    rred2,xred2,objred2,txteq2,neq2=rmod2.equivcompactm(r,2,cimari,obj)
    ciariorig=[]
    for i in range(0,r):
        ciariorig.append(ciari[i])
    ciario,ciarisort,nsort=rmod2.raisort2(ciari)
    print "ciariorig= ",ciariorig
    print "ciari",ciari

    # equivalence elements (4.8.2011)
    txtari=""
    txtari+="Equivalences due to the CI-values "+"\n"
    txtari+=txteq2+"\n"
    
    
def HDCIgeom():
    #brg 4.8.2011, 18.10.2013
    global cigenorig,cimgen,cigen,txtgen
    
        
    cimgen=rmod2.marray(r,2)
    for i in range(0,r):        #in order to use as far as possible former routines: ci gets two identical columns
        cimgen[i][0]=cigen[i]
        cimgen[i][1]=cigen[i]


    Uorig=calcU(r,k,dm)  #new 14.11.2013
    
    rred2,xred2,objred2g,txteq2g,neq2g=rmod2.equivcompactm(r,2,cimgen,obj)
    cigenorig=[]
    for i in range(0,r):
        cigenorig.append(cigen[i])
    cigeno,cigensort,nsort=rmod2.raisort2(cigen)
    print "cigen ",cigen
    print "cigeno", cigeno

    
    # equivalence elements (4.8.2011)
    txtgen=""
    txtgen+="Equivalences due to the CI-values "+"\n"
    txtgen+=txteq2g+"\n"
    
def SaPaUa():
    #Brg 5.8.2011 taken and adopted for the
    # purpose here, from hdgt5 of 30.9.09
    global rkav
    
    Sa=rmod2.marray1(rred,rred,-1)
    Pa=rmod2.marray1(rred,rred,-1)
    Ua=rmod2.marray1(rred,rred,-1)
    countSa=rmod2.vecgen1(rred)
    countPa=rmod2.vecgen1(rred)
    countUa=rmod2.vecgen1(rred)
    
    for ob in objred:
        obi=objred.index(ob)
        
        #obi the selected element whose rkav will be deternmined
        z=0
        for i1 in range(0,rred):
            if zeta[i1][obi]==1:
                z+=1
                Sa[obi][i1]=i1
        #print "ob = ",ob,"  its order ideal:  ",Sa[obi]
        countSa[obi]=z
    for ob in objred:
        obi=objred.index(ob)
        
        #obi the selected element whose rkav will be deternmined
        z=0
        for i1 in range(0,rred):
            if zeta[obi][i1]==1:
                z+=1
                Pa[obi][i1]=i1
        #print "ob = ",ob,"  its order filter:  ",Pa[obi]
        countPa[obi]=z
    for ob in objred:
        obi=objred.index(ob)
        
        #obi the selected element whose rkav will be deternmined
        z=0
        for i1 in range(0,rred):
            if zeta[i1][obi]==0 and zeta[obi][i1]==0:
                z+=1
                Ua[obi][i1]=i1
        #print "ob = ",ob,"  its incomparables  ",Ua[obi]
        countUa[obi]=z

    #rmod2.matout(rred,rred,Ua)
    
    rkav=rmod2.vecgen1(rred)
    for i2 in range(0,rred):
        rkav[i2]=countSa[i2]  #note Sa includes the interesting element a too
      
    
    for ob in objred:
        obi=objred.index(ob)
        increment=0
        
        for y in Ua[obi]:
            #print "y in increment loop: ",objred[y]," ",
            Uy=[]
            Pdown=0
            Pup=0
            
            if y!=-1:
                for i1 in range(0,rred):
                    if zeta[i1][y]==0 and zeta[y][i1]==0:
                        Uy.append(i1)
                
                for x in Uy:
                    if x in Sa[obi]:
                        Pdown+=1
                            
                for x in Uy:
                    if x in Pa[obi]:
                        Pup+=1
                
                dinc=1.0*Pdown/(1.0*Pdown+1.0*Pup)
                
                increment+=dinc
                #print "obi = ",obi,"  y= ",y,"  Pdown= ",Pdown,"   Pup = ",Pup
        rkav[obi]+=1.0*increment
        
        
    
def calculatelist():
    #brg 16.11.2013
    
    HDCIarithm()
    HDCIgeom()
    SaPaUa()

def HDari():
    global zeta,txteq
    tpHD=Tkinter.Toplevel(hf)
    tpHD.title(" Hasse diagram ")
    frHD=Tkinter.Frame(tpHD,width=1000,height=1000)
    frHD.pack(side="top")
    freq=Tkinter.Frame(tpHD)
    freq.pack(side="bottom")
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    if rred>100:
        lbhd3=Tkinter.Label(frHD,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(frHD,text=" Hasse Diagram (CIari), file= "+str(fn)+" \n\n ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(tpHD,width=actwidth,height=actheight,bg="white")
        cv.config(scrollregion=(0,0,1000,1000))
        cv.config(highlightthickness=1)
        sbary=Tkinter.Scrollbar(cv,orient="vertical")
        sbary.config(command=cv.yview) 
        cv.config(yscrollcommand=sbary.set) 
        sbary.pack(side="right", fill="y")

        sbarx=Tkinter.Scrollbar(cv,orient="horizontal")
        sbarx.config(command=cv.xview) 
        cv.config(xscrollcommand=sbarx.set) 
        sbarx.pack(side="bottom",fill="x")          
        cv.pack(expand="y",fill="both")          
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(1.5*factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(1.5*factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])

        print "CI iob i..."
        for i in range(0,lz):
            for j in range(0,l[i]):
                iob=obj.index(objred[lobj[i][j]]) #lobj is based on representative elements, whereas ci is based on all objects
                
                print "i=",i,"  j= ",j,"  lobj = ",lobj[i][j],objred[lobj[i][j]],iob,obj[iob]
                print "ci...",ciari[iob]
                
                cv.create_oval(geomx[i][j]-20,geomy[i][j]+20,geomx[i][j]+20,geomy[i][j]-20,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]]+": "+str(round(ciari[iob],2)))
        # equivalence elements (4.8.2011)
        tequiv=ScrolledText(freq,width=60,height=2)
        tequiv.pack()
        tequiv.insert("end",txteq)
    

def HDgen():
    global zeta
    tpHD=Tkinter.Toplevel(hf)
    tpHD.title(" Hasse diagram ")
    frHD=Tkinter.Frame(tpHD,width=1000,height=1000)
    frHD.pack(side="top")
    freq=Tkinter.Frame(tpHD)
    freq.pack(side="bottom")
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    if rred>100:
        lbhd3=Tkinter.Label(frHD,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(frHD,text=" Hasse Diagram (CIgen), file= "+str(fn)+" \n\n ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(tpHD,width=actwidth,height=actheight,bg="white")
        cv.config(scrollregion=(0,0,1000,1000))
        cv.config(highlightthickness=1)
        sbary=Tkinter.Scrollbar(cv,orient="vertical")
        sbary.config(command=cv.yview) 
        cv.config(yscrollcommand=sbary.set) 
        sbary.pack(side="right", fill="y")

        sbarx=Tkinter.Scrollbar(cv,orient="horizontal")
        sbarx.config(command=cv.xview) 
        cv.config(xscrollcommand=sbarx.set) 
        sbarx.pack(side="bottom",fill="x")          
        cv.pack(expand="y",fill="both")          
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(1.5*factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(1.5*factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])

        print "CI iob i..."
        for i in range(0,lz):
            for j in range(0,l[i]):
                iob=obj.index(objred[lobj[i][j]]) #lobj is based on representative elements, whereas ci is based on all objects
                
                print "i=",i,"  j= ",j,"  lobj = ",lobj[i][j],objred[lobj[i][j]],iob,obj[iob]
                print "ci...",cigen[iob]
                
                cv.create_oval(geomx[i][j]-20,geomy[i][j]+20,geomx[i][j]+20,geomy[i][j]-20,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]]+": "+str(round(cigen[iob],2)))
        # equivalence elements (4.8.2011)
        tequiv=ScrolledText(freq,width=60,height=2)
        tequiv.pack()
        tequiv.insert("end",txteq)
    




def hav_extension(r,obj,objred,dm,hav):
    # brg 15.11.2013
    # using weak2 and equivcompactgr
    rred,xred,objred,extralist,eqm1=rmod2.equivcompactgr(r,k,dm,obj)

    hav_ex=rmod2.weak2(r,obj,objred,rkav,eqm1)
    return hav_ex



def ausgabeobj():
    # brg 15.11.2013, 16.11.2013
    global txtari,txtgen,txteq,rkav_ext

    tp0=Tkinter.Toplevel(hf)
    tp0.title("Basic info and equivalences ")
    t0=ScrolledText(tp0,width=60,height=10)
    t0.pack()
    rkav_ext=hav_extension(r,obj,objred,dm,rkav)
    print "rkav_ext=",rkav_ext
    txt="Output, ordered corresponding to the objects "+"\n"
    txt+="Object"+"\t"+"hav_ext"+"\t"+"CI ari"+"\t"+"CI gen"+"\t"+"Incomp(x)"+"\n"
    for i in range(0,r):
        txt+=str(obj[i])+"\t"+str(round(rkav_ext[i],3))+"\t"+str(round(ciari[i],3))+"\t"+str(round(cigen[i],3))+"\t"+str(Uobj[i])+"\n"
    txt+="\n"
    txt+="Equivalences: "+"\n"
    txt+="a): due to partial order:"+"\n"
    txt+=txteq+"\n"
    txt+="b) due to CI(ari):"+"\n"
    txt+=txtari+"\n"
    txt+="c) due to CI(gen): "+"\n"
    txt+=txtgen+"\n"
    txt+="\n"
    txt+=" - - -   e o f   - - - "
    t0.insert("end",txt)
   
def ausgabe1():
    #brg 15.11.2013, 16.11.2013
    tp1=Tkinter.Toplevel(hf)
    tp1.title("ordered due to CIari")
    t1=ScrolledText(tp1,width=60,height=10)
    t1.pack()
    rkav_ext=hav_extension(r,obj,objred,dm,rkav)
    print "rkav_ext=",rkav_ext
    
    cio,cisort,nsort=rmod2.raisort2(ciari)
    txt="Output, ordered corresponding to CI(ari) "+"\n"
    txt+="Object"+"\t"+"hav_ext"+"\t"+"CI ari"+"\t"+"CI gen"+"\t"+"Incomp(x)"+"\n"
    for i in range(0,r):
        txt+=str(obj[nsort[i]])+"\t"+str(round(rkav_ext[nsort[i]],3))+"\t"+str(round(cisort[i],3))+"\t"+str(round(cigen[nsort[i]],3))+"\t"+str(Uobj[nsort[i]])+"\n"
    txt+="\n"
    txt+=" - - -   e o f   - - - "
    t1.insert("end",txt)
   
def ausgabe2():
    #brg 16.11.2013
    tp2=Tkinter.Toplevel(hf)
    tp2.title("ordered due to CIgen")
    t2=ScrolledText(tp2,width=60,height=10)
    t2.pack()
    rkav_ext=hav_extension(r,obj,objred,dm,rkav)
    print "rkav_ext=",rkav_ext
    print "cigen in ausgabe2 ",cigen
    cigo,cigsort,ngsort=rmod2.raisort2(cigen)
    txt="Output, ordered corresponding to CI(gen) "+"\n"
    txt+="Object"+"\t"+"hav_ext"+"\t"+"CI ari"+"\t"+"CI gen"+"\t"+"Incomp(x)"+"\n"
    for i in range(0,r):
        txt+=str(obj[ngsort[i]])+"\t"+str(round(rkav_ext[ngsort[i]],3))+"\t"+str(round(ciari[ngsort[i]],3))+"\t"+str(round(cigsort[i],3))+"\t"+str(Uobj[ngsort[i]])+"\n"
    txt+="\n"
    txt+="\n"
    txt+=" - - -   e o f   - - - "
    t2.insert("end",txt)
       
def ausgabe3():
    #brg 16.11.2013
    tp3=Tkinter.Toplevel(hf)
    tp3.title(" ordered due to hav")
    t3=ScrolledText(tp3,width=60,height=10)
    t3.pack()
    rkav_ext=hav_extension(r,obj,objred,dm,rkav)
    print "rkav_ext=",rkav_ext
    print "cigen in ausgabe2 ",cigen
    havo,havsort,nhsort=rmod2.raisort2(rkav_ext)
    txt="Output, ordered corresponding to hav "+"\n"
    txt+="Object"+"\t"+"hav_ext"+"\t"+"CI ari"+"\t"+"CI gen"+"\t"+"Incomp(x)"+"\n"
    for i in range(0,r):
        txt+=str(obj[nhsort[i]])+"\t"+str(round(havsort[i],3))+"\t"+str(round(ciari[nhsort[i]],3))+"\t"+str(round(cigen[nhsort[i]],3))+"\t"+str(Uobj[nhsort[i]])+"\n"
    txt+="\n"
    txt+="\n"
    txt+=" - - -   e o f   - - - "
    t3.insert("end",txt)
   
def allcorrelation():
    #brg 16.11.2013
    #Spearman
    rspearhavciari,pha=pstat.lspearmanr(rkav_ext,ciari)
    rspearhavcigen,phg=pstat.lspearmanr(rkav_ext,cigen)
    rspearciaricigen,pag=pstat.lspearmanr(ciari,cigen)

    #Pearson
    rpearsonhavciari,ppha=pstat.lpearsonr(rkav_ext,ciari)
    rpearsonhavcigen,pphg=pstat.lpearsonr(rkav_ext,cigen)
    rpearsonciaricigen,ppag=pstat.lpearsonr(ciari,cigen)
    tp4=Tkinter.Toplevel(hf)
    tp4.title(" correlations ")
    t4=ScrolledText(tp4,width=80,height=10)
    t4.pack()
    txt="Summarizing statistical information "+"\n"
    txt+=70*"="+"\n"
    txt+="\t\tSpearman correlation "+"\t"+" two-sided probability \n"
    txt+="hav vs CI(ari):\t"+str(round(rspearhavciari,3))+4*"\t"+str(round(pha,3))+"\n"
    txt+="hav vs CI(gen):\t"+str(round(rspearhavcigen,3))+4*"\t"+str(round(phg,3))+"\n"
    txt+="CI(ari) vs CI(gen):\t"+str(round(rspearciaricigen,3))+4*"\t"+str(round(pag,3))+"\n"
    txt+="\n"
    txt+="\t\tPearson correlation "+"\t"+" two-sided probability \n"
    txt+="hav vs CI(ari):\t"+str(round(rpearsonhavciari,3))+4*"\t"+str(round(ppha,3))+"\n"
    txt+="hav vs CI(gen):\t"+str(round(rpearsonhavcigen,3))+4*"\t"+str(round(pphg,3))+"\n"
    txt+="CI(ari) vs CI(gen):\t"+str(round(rpearsonciaricigen,3))+4*"\t"+str(round(ppag,3))+"\n"
    txt+="\n"
    txt+=" - - -    e o f    - - -"
    t4.insert("end",txt)


    
hf = Tkinter.Tk()
hf.title(' HDCICIhav ')

aboutHDCI=raioop2.brgabout(hf,"tp1","about_HDCICIhav.txt",2,\
            "Nov., 16th,2013"," about HDCICIhav ", "white", "t1",80,5,ScrolledText)
helpHDCI=raioop2.brgabout(hf,"tp1","help_HDCICIhav.txt",2,\
            "Nov., 16th, 2013"," help_HDCICIhav ", "white", "t1",80,5,ScrolledText)
    
fr=Tkinter.Frame(hf,width=60)
fr.pack()
buttopen = Tkinter.Button(fr, text='select, open ',width=25,bg="cyan",command=fileopen)
buttopen.pack(pady=5)
lb1=Tkinter.Label(fr)
lb1.pack()
buttshowdm=Tkinter.Button(fr,text="show data matrix",width=25,command=showDM)
buttshowdm.pack()

frw=Tkinter.Frame(fr)
frw.pack()
lbw=Tkinter.Label(frw,text="")
lbw.grid(row=0,columnspan=4)
frnorm=Tkinter.Frame(fr)
frnorm.pack()
lbnorm=Tkinter.Label(frnorm,text="[0,1]-normalization (y/n) ")
lbnorm.pack(side="left")
enorm=Tkinter.Entry(frnorm,width=2)
enorm.pack(side="right")
buttcalc=Tkinter.Button(fr,text=" CI(ari)-calculation ",width=25,bg="cyan",command=calc)
buttcalc.pack()
buttcalc2=Tkinter.Button(fr,text=" CI(geom)-calculation ",width=25,bg="cyan",command=calc_ig)
buttcalc2.pack()
frresults=Tkinter.Frame(fr)
frresults.pack()
tcalc=ScrolledText(frresults,width=60,height=10)
tcalc.pack()

buttHDari=Tkinter.Button(fr,text="Hasse diagram (orig. dm, CI ari)",width=25,bg="cyan",command=HDari)
buttHDari.pack()
buttHDgen=Tkinter.Button(fr,text="Hasse diagram (orig. dm, CI gen)",width=25,bg="cyan",command=HDgen)
buttHDgen.pack()
buttcalcall=Tkinter.Button(fr,text=" Calculate the lists ", width=25,bg="cyan",command=calculatelist)
buttcalcall.pack()
fr2=Tkinter.Frame(fr,bd=3,relief="sunken")
fr2.pack(pady=3)
buttausgabeobj=Tkinter.Button(fr2,text="Sequence of objects: hav, CIari, CIgen, incomp ",bg="cyan",width=70,command=ausgabeobj)
buttausgabeobj.pack()
buttausgabe1=Tkinter.Button(fr2,text="Ordered sequence of objects: hav, CIgen, incomp, ordered by CIari ",bg="cyan",width=70,command=ausgabe1)
buttausgabe1.pack()
buttausgabe2=Tkinter.Button(fr2,text="Ordered sequence of objects: hav, CIari, incomp, ordered by CIgen ",bg="cyan",width=70,command=ausgabe2)
buttausgabe2.pack()
buttausgabe3=Tkinter.Button(fr2,text="Ordered sequence of objects: hav, CIari, incomp, ordered by hav ",bg="cyan",width=70,command=ausgabe3)
buttausgabe3.pack()
buttcorrel=Tkinter.Button(fr2,text="Summarizing correlations hav, CIari, CIgen",bg="cyan",width=70,command=allcorrelation)
buttcorrel.pack()
buttexit = Tkinter.Button(hf, text = 'exit', bg = 'red', width=25,command = hf.destroy)
buttexit.pack(pady=5)

hf.mainloop()

