# -*- coding: cp1252 -*-
import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import tkFileDialog
import raioop2
import random

#Brg in cooperation with Korbinian Freier, MPI Hamburg, 2.10. and 3.10.09
# 7.11.2011 minimum spanning tree (from mainHD is now an own special module)

def HD():
    """based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"""
    # Brg 20.12.07, 28.12.07, 2.10.,3.10.09
    # If the number of representants > 70 then only the cover-matrix and the level-population
    #
    global r,k,dm,fn,pro,ob,obj
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    
    fn=tkFileDialog.askopenfilename()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    lb1.config(text="opened "+fn,bg="yellow")
    

    prop=[]
    for j in range(0,k):
        prop.append(pro[j+1])
            
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
    for i in range(0,r):
        obj[i]=ob[i+1]

    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,dm,obj)  
    
    #
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    if rred>70:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram  ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()

def showDM():
    """ New routine : shows the data matrix """
    #Brg 13.1.08
    tp2=Tkinter.Toplevel(hf)
    tp2.title('showDM')
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack(expand=1,fill="both")
    prop=[]
    for j in range(0,k):
        prop.append(pro[j+1])
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+ob[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=ob[i+1]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)


def mst():
    """ the reduced dm will be enhanced by a fictitious least element
    which gets the zeroth row. Then the prim algorithm finds all
    vertices """
    # Brg  14.3.09
    # * 14.3.09
    # act: 14.3.09
    #   a minimum spanning tree from the dual HD may be useful too  5.3.09
    
    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,dm,obj)  
    
    #minimum spanning trees, MST,(up to now (5.3.09) only if 1 comp)

    #least element
    least=rmod2.vecgen1(k)
    
    for j in range(0,k):
        testmin=10**10
        for i in range(0,rred):
            if xred[i][j]<=testmin:
                testmin=xred[i][j]
        least[j]=testmin-1.0  #subtract -1 to be sure that there will be no equivalence

    #new dm
    xprim=rmod2.marray(rred+1,k)
    for j in range(0,k):
        xprim[0][j]=least[j]
    for i in range(1,rred+1):
        for j in range(0,k):
            xprim[i][j]=xred[i-1][j]
    
    

    # zeta matrices
    rred1=rred+1
    zetahilf=rmod2.comp(rred1,k,xprim) #zetahilf comes out as col<row.
    zeta=rmod2.marray(rred1,rred1)
    for i in range(0,rred1):      #we need the transposed matrix (row < col)
        for j in range(0,rred1):
            zeta[i][j]=zetahilf[j][i]

    # extended object list
    objext=rmod2.vecgentext1(rred1)
    objext[0]="least"
    for i in range(1,rred1):
        objext[i]=objred[i-1]
        
        
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred1,zeta)
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
    
   
    #Adj-Listen

    adjc=rmod2.adjacent(rred1,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred1,adjc,lext)
       
    
    covC=rmod2.cover(rred1,tr,lext)  #cov: row < ccol (standard presentation)
    tpmst=Tkinter.Toplevel(hf)  #window for all results of MST
    tpmst.title(' MST ')
    tmst=ScrolledText(tpmst,width=60,height=10) #scrolled Text for all results of MST
    tmst.pack(expand=1,fill="both")
    # cov is a cover matrix (standard presentation)
    weight=rmod2.marray(rred1,rred1)  #15.3.09 here in future weight may be selected specifically
    dist=rmod2.marray(rred1,rred1)   # note xred should be normalizes
    #print "rred1= ",rred1,"    k= ",k
    xnprim=rmod2.matrixnorm(rred1,k,xprim)
    for i in range(0,rred1):
        for j in range(0,rred1):
            for i1 in range(0,k):
                dist[i][j]+=(xnprim[i][i1]-xnprim[j][i1])**2

    try:
        wgov=int(wg.get())
        
    except:
        wgov=0
    print "wgov= ",wgov
    if wgov==0:   # weights equals 1, later random choice
        for i in range(0,rred1):
            for j in range(0,rred1):
                weight[i][j]=1.0   #15.3.09
    elif wgov==1: #least metric distances among the properties of nodes are favorably selected
        for i in range (0,rred1):
            for j in range(0,rred1):
                weight[i][j]=1.0/(1.0*dist[i][j]+1.0)
                
    elif wgov==2: #greatest distance among the properties of nodes is favorably selected            
         for i in range (0,rred1):
            for j in range(0,rred1):
                weight[i][j]=1.0*dist[i][j]
    else:
        for i in range(0,rred1):
            for j in range(0,rred1):
                weight[i][j]=0.5*(1.0/(1.0*dist[i][j]+1.0))+0.5*dist[i][j]   #15.3.09
                   
    adjlist=rmod2.covadjlistweighted(covC,rred1,weight) #cov is available from components first part
    #print "adjacency list standard ",adjlist
    # analysis of cov continued. Info for Scrolled Text        
    summ,result=rmod2.prim0(adjlist)
        
    txtmst=""
    zaehl=0
    for diredge in result:
        txtmst+=str(zaehl)+": "
        for vertex in diredge:
            txtmst+=objext[vertex]+"-"
        txtmst+="\n"
        zaehl+=1

    txtmst0="Spanning Tree: root is the fictitious least element in the extended dm \n"
    txtmst0+="Modus: "
    txthilf=""
    if wgov==0:
        txthilf="random"
    elif wgov==1:
        txthilf="minimum distance of (normalized) data matrix"
    elif wgov==2:
        txthilf="maximum distance of (normalized) data matrix"
    else:
        txthilf="average of minimum and maximum"
    txtmst0+=" "+txthilf+"\n"
    txtmst0+="edge-weight-sum: "+str(round(summ,2))+"\n"
    txtmst0+=txtmst+"\n"
    txtmsthilf="char. of minimum spanning tree alg. \n"
    for i in range(0,rred1):
        for j in range(0,rred1):
            if covC[i][j]==1:
                txtmsthilf+=objext[i]+"--"+objext[j]+":\t "+str(round(weight[i][j],4))+" "+str(round(dist[i][j],2))+"\n"
    txtmsthilf+="\n"
    txtmst0+=txtmsthilf
    tmst.insert("end",txtmst0)
    # standard should be seen in ScrolledText tmst

    #Graphics
    #toplevel and frame of standard
    tpmstgraphic1=Tkinter.Toplevel(hf)
    frgrmst1=Tkinter.Frame(tpmstgraphic1)
    frgrmst1.pack()
    
    lbmst1=Tkinter.Label(frgrmst1,text=" Minimal Spanning tree of standard HD, modus = "+txthilf)
    lbmst1.pack()
    #geometry
    actwidth,actheight,factorx,factory,\
                geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred1,levmax,zzmax)
    cv1=Tkinter.Canvas(frgrmst1,width=actwidth,height=actheight,bg="white")
    cv1.pack()
        
    lz=zzmax
    l=rmod2.vecgen1(lz)
    for i in range(0,lz):
        l[i]=len(lobj[i])

    pos=rmod2.vecgen1(lz)
    for i in range(0,lz):
        pos[i]=l[i]

    geomx=rmod2.marray(rred1,rred1)
    geomy=rmod2.marray(rred1,rred1)

    for i in range(0,lz):
        for j in range(0,l[i]):
            geomx[i][j]=random.randint(20,40)+geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
            geomy[i][j]=geom0y+(factory/lz)*i

    # based on HD
    for i in range(0,lz-1):
        for j in range(0,l[i]):
            #print obj[lobj[i][j]]
            for i1 in range(i+1,lz):
                for j1 in range(0,l[i1]):
                    #print obj[lobj[i1][j1]]
                    v1=lobj[i1][j1]
                    v2=lobj[i][j]
                    if covC[lobj[i1][j1]][lobj[i][j]]==1 and [v1,v2] in result:
                        #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                        cv1.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


    for i in range(0,lz):
        for j in range(0,l[i]):
            cv1.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
            cv1.create_text(geomx[i][j],geomy[i][j],text=objext[lobj[i][j]])






## Tkinter Plot
hf = Tkinter.Tk()
hf.title(' GUI: HD_msptree ')
aboutHDsimpl=raioop2.brgabout(hf,"tp1","about_HD_msptree.txt",1,\
            "November, 7th,2011"," about HD_msptree ", "white", "t1",80,5,ScrolledText)
helpHDsimpl=raioop2.brgabout(hf,"tp1","help_HD_msptree.txt",1,\
            "November, 7th,2009"," help_HD_msptree ", "white", "t1",80,5,ScrolledText)
    
fr=Tkinter.Frame(hf,width=60)
fr.pack()
buttHD = Tkinter.Button(fr, text='select, open and HD',width=25,bg="cyan",command=HD)
buttHD.pack(side="top",pady=5)
buttshowDM=Tkinter.Button(fr,text="show data matrix", bg="cyan", width=25,command=showDM)
buttshowDM.pack(side="top",pady=5)
lb1=Tkinter.Label(fr,text=" ",width=50)
lb1.pack()
fr2=Tkinter.Frame(hf)
fr2.pack()
frmst=Tkinter.Frame(fr2,bd=3,relief="sunken")
frmst.pack()
lbmst=Tkinter.Label(frmst,text="For minimum spanning tree select")
lbmst.pack()
lbmst2=Tkinter.Label(frmst,text=" Select modus:\n0: random choice,\n1: minimum distance,\n2: maximum distance\n any other number: average of min and max ")
lbmst2.pack()
wg=Tkinter.Entry(frmst,width=1)
wg.pack()
buttmst=Tkinter.Button(frmst,text="Minimum spanning tree",width=25,bg="cyan",command=mst)
buttmst.pack()           
buttexit = Tkinter.Button(fr2, text = 'exit', bg = 'red', width=25,command = hf.destroy)
buttexit.pack(pady=10)

hf.mainloop()

