# -*- coding: cp1252 -*-
import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import tkFileDialog
import raioop2
import random
import pstat
import stats

#Brg from HDsimpl as basis: 14.7.2012
# brg 17.7.2012 cosmetics
# 4.11.2014 error message around line 368
# 4.11.2014 Lin ext stuff eliminated
# 28.12.2014 LPOM stuff newly integrated
# 11.1.2015 More info about matrix of composite indicators
# 6.3.2015: Distances among indicators and dm due to relational matrices
# 12.3.2015 K-values for each indicator, CI
# 25.11.16 : restriction: number of objects now <200

def fileselectopenHD():
    """based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"""
    # Brg 20.12.07, 28.12.07, 2.10.,3.10.09
    # If the number of representants > 70 then only the cover-matrix and the level-population
    #
    global yn,rred,k,objred,txteq,obj,r,zeta,dm,prop
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('orig Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    
    fn=tkFileDialog.askopenfilename()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
       

    prop=[]
    for j in range(0,k):
        prop.append(pro[j+1])
            
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
    for i in range(0,r):
        obj[i]=ob[i+1]

    rred,xred,objred,txteq,neq=rmod2.equivcompactm(r,k,dm,obj)  
    yn=rmod2.matrixnorm(r,k,dm)  #yn normalized r*k matrix of data file
    print "txteq= ",txteq
    #
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    comparabilities=0
    for i in range(0,rred):
        for j in range(0,rred):
            if i!=j:
                comparabilities+=zeta[i][j]


    utotal=0
    for i in range(0,rred):
        for j in range(0,rred):
            if zeta[i][j]==0 and zeta[j][i]==0:
                utotal+=0.5
                
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    if rred>200:  #25.11.16
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram  ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        lbhd3.config(text="Hasse diagram: comparabilities= "+str(comparabilities)+"\n  incomparabilities = "+str(utotal))
        cv.pack()


def showDM():
    """ New routine : shows the data matrix """
    #Brg 13.1.08, 15.1.08, 11.1.2015
    #*: 13.1.08
    #akt: 15.1.08
    #note: modified from the routine, taken from interval9.py
    tp2=Tkinter.Toplevel(hf)
    tp2.title('show DM')
    lbtp2=Tkinter.Label(tp2,text=" General information about the [0,1]-columnwise data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,k):
            txt3+=str(yn[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)    


def distrelat(relat1, relat2, r):
    # brg 6.3.2015
    """ calculates the squared Euclidian distance between relat1 and relat2"""
    distsum = 0
    for i1 in range(0, r):
        for i2 in range(0, r):
            distsum += (relat1[i1][i2] - relat2[i1][i2])**2
    return distsum        

def calc_K(eqclasses):
    K = 0
    for i1 in range(0, len(eqclasses)):
        hilf = len(eqclasses[i1])
        K += hilf*(hilf - 1)
    return K                    
       
def distances():
    # brg 6.3.2015
    # relat of orig dm
    relatdist = rmod2.marray3(r,r,k+2)
    hilf = rmod2.comp(r, k, dm)
    for i1 in range(0, r):
        for i2 in range(0, r):
            relatdist[i1][i2][0] = hilf[i1][i2]
    # relat of single indicators
    Gamma = rmod2.marray(r,2)
    Kvec = []
    for i in range(0,r):
        for j in range(0, k):
            Gamma[i][0] += (1.0/(1.0*k))*yn[i][j]
            Gamma[i][1] = Gamma[i][0]
    rredGamma, xredGamma, objredGamma, exGamma, eqmGamma = rmod2.equivcompactgr1(r,2,Gamma,obj)        
    eqclGamma, dummy1, dummy2 = rmod2.deliver_readable_eqclasses(r, eqmGamma, obj)
    K = calc_K(eqclGamma)
    Kvec.append(K)
    for j in range(0, k):
        indicmatrix = rmod2.marray(r,2)
        for i in range(0, r):
            indicmatrix[i][0] = dm[i][j]
            indicmatrix[i][1] = dm[i][j]
        rredq, qq, objredq, exq, eqmq = rmod2.equivcompactgr1(r,2,indicmatrix,obj)
        eqclindic, dummy1, dummy2 = rmod2.deliver_readable_eqclasses(r, eqmq,obj)
        K = calc_K(eqclindic)
        Kvec.append(K)
        hilf = rmod2.comp(r, 2, indicmatrix)
        for i1 in range(0, r):
            for i2 in range(0, r):
                relatdist[i1][i2][j+1] = hilf[i1][i2]
    hilfG = rmod2.comp(r, 2, Gamma)
    for i1 in range(0, r):
        for i2 in range(0, r):
            relatdist[i1][i2][k+1] = hilfG[i1][i2]

    distmatrix = rmod2.marray(k+2,k+2)
     
    for j1 in range(0, k+2):
        for j2 in range(0, k+2):
            R1 = rmod2.marray(r, r)
            R2 = rmod2.marray(r, r)
            for i1 in range(0, r):
                for i2 in range(0, r):
                    R1[i1][i2] = relatdist[i1][i2][j1]
                    R2[i1][i2] = relatdist[i1][i2][j2]
                     
            D = distrelat(R1, R2, r)
            distmatrix[j1][j2] = D
    #print "Distmatrix = ", distmatrix       
    tpdist = Tkinter.Toplevel(hf)
    tpdist.title(' Distances orig dm vs attributes order')
    tdist = ScrolledText(tpdist, width=80, height=30)
    tdist.pack()
    txt = "\t"
    for j in range(0, k + 2):
        if j == 0:
            txt+= "orig"+"\t"
        elif j == k + 1:
            txt += "CIrelat" + "\t"
        else:  
            txt+=str(prop[j-1])+"\t"
    txt+="\n"        
    for j1 in range(0, k + 2):
        if j1 == 0:
            txt+="orig"+"\t"
        elif j1 == k + 1:
            txt+= "CIrelat"+"\t"
        else:
            txt+=str(prop[j1-1])+"\t"
        for j2 in range(0, k + 2):
            txt+=str(distmatrix[j1][j2])+"\t"
        txt+=2*"\n"
    txt += "Degeneracy (K) "+"\n"
    txt += "CI:  "+str(Kvec[0])+"\n"
    for j in range(0, k):
        txt += str(prop[j])+"  "+str(Kvec[j+1])+"\n"
    txt+="-    -   -   e o f -   -   -"    
    tdist.insert("end",txt)
    return distmatrix, Kvec

def MCHD():
    # brg 24.1.2011, 14.7.2012 
    # Idea: The user may be interested in variation of m weights
    # Within the MC-simulation any case represents a ranking.
    # All rankings can be put together to a HD (similar to the stability4.py)
    global eMCsim,tpMCHD,egbelow,egabove
    tpMCHDo=Tkinter.Toplevel(hf)
    tpMCHDo.title(" weight's intervals ")
    egbelow=rmod2.vecgen1(k)
    egabove=rmod2.vecgen1(k)
    lbgMCHD=Tkinter.Label(tpMCHDo,text="weight-intervals (below-above) ", width=60)
    lbgMCHD.pack()
    frgMCHD=Tkinter.Frame(tpMCHDo,bd=3,relief="sunken")
    frgMCHD.pack()
    for j in range (0,k):
        lbhilf=Tkinter.Label(frgMCHD,text="weight["+str(j)+"]:")
        lbhilf.grid(row=j,column=0)
        egbelow[j]=Tkinter.Entry(frgMCHD,width=5)
        egbelow[j].grid(row=j,column=1)
        egabove[j]=Tkinter.Entry(frgMCHD,width=5)
        egabove[j].grid(row=j,column=2)
    lbgsim=Tkinter.Label(tpMCHDo, text="How many MC-simulations")
    lbgsim.pack()
    eMCsim=Tkinter.Entry(tpMCHDo,width=10)
    eMCsim.pack()
    

def gsubmit():
    # brg 13.7.2012, 14.7.2012, 15.7.2012, 23.12.2014, 28.08.17
    # Generating a reduced Matrix with 'celi' exclusively different rankCI as columns: 'dmact'
    global zeta21, objred1,rred,dmg,identifier,MCsim,r,obj, gmean, ming, maxg
    tpMCHD=Tkinter.Toplevel(hf)
    tpMCHD.title(" info about weights ")
    freq1=Tkinter.Frame(tpMCHD)
    freq1.pack()
    
    print "k = ",k
    gbelow=rmod2.vecgen1(k)
    gabove=rmod2.vecgen1(k)
    MCsim=int(eMCsim.get())
    dmg=rmod2.marray(rred,MCsim)
    g=rmod2.vecgen1(k)
    #
    identifier=random.randint(1,10000)   # to relate the weight infos with those of the HD
    #
    for j in range(0,k):
        gbelow[j]=float(egbelow[j].get())
        gabove[j]=float(egabove[j].get())
##    print "y = "
##    rmod2.matout(rred,k,y)
##    print " "
    gmin=rmod2.vecgen1(k)
    gmax=rmod2.vecgen1(k)
    gmean=rmod2.vecgen1(k)
    ming=rmod2.vecgen1(k)
    maxg=rmod2.vecgen1(k)
    for j in range(0,k):
        ming[j]=9999
        maxg[j]=-9999

    dmg=rmod2.marray(r,MCsim)
    sumgMC =0
    for mc in range(0,MCsim):
        # step 1 organisation of the weights and background info
        sumg = 1.0
        while 0.99 < sumg <1.01:
            #print "sumg!=1"
            sumg=0
            for j in range(0,k):
                g[j] = 1.0/(1.0*k)
                zahl =0
                bool = True
                while bool:
                    g[j] = random.random()
                    zahl+=1
                    if g[j] >= gbelow[j] and g[j] <= gabove[j]:
                        bool = False
                    if zahl > 10000:    
                        break
                        print "zahl ",zahl
                sumg+=g[j]
        if sumg!=1:    # sumweight=1 -normalization
            for j in range(0,k):
                g[j]=1.0*g[j]/(1.0*sumg)
        sumc=0
        for j in range(0,k):
            sumc+=g[j]
        sumgMC+=sumc    
        for j in range(0,k):
            gmean[j]+=g[j]
            if g[j]>=maxg[j]:
                maxg[j]=g[j]
            if g[j]<=ming[j]:
                ming[j]=g[j]

        #step 2 CI
        Gamma=rmod2.vecgen1(r)
        #print "mc= ",mc
        for i in range(0,r): # calculation of CI for a special g-vector
            for j in range(0,k):
                Gamma[i]+=yn[i][j]*g[j]   #normalized dm of representants
            #print "i= ",i," Gamma= ",Gamma[i]  
        #print " "
        # step 3 fill the dmg-matrix only with rank vectors that are different
        for i in range(0,r):
            dmg[i][mc]=Gamma[i]
        
    #print "dmg = "    
    #rmod2.matout(r,MCsim,dmg)
    #print "Nach equivcompact "
    for j in range(0,k):
        gmean[j]=1.0*gmean[j]/(1.0*MCsim)
    sumweights = 1.0*sumgMC/(1.0*MCsim)
    varvol=1
    dimvol=k
    for j in range(0,k):
        print "maxg[j]-ming[j]",maxg[j]-ming[j],"  varvol= ",varvol
        if maxg[j]==ming[j]:
            varvol=varvol*1
            dimvol-=1
        else:    
            varvol=varvol*(maxg[j]-ming[j])
    # characteirstics of dmg
    dmgtr=rmod2.marray(MCsim,r)
    for i in range(0,r):
        for j in range(0,MCsim):
            dmgtr[j][i]=dmg[i][j]
    asim=rmod2.matrixchar(MCsim,r,dmgtr)
    tpg=Tkinter.Toplevel(hf)
    tpg.title(' g-characteristic ')
    lbgchar=Tkinter.Label(tpg,text="effective g-values in a simulation with "+str(MCsim)+"  runs")
    lbgchar.pack()
    txtg="identifier: "+str(identifier)+"\n"
    txtg+=60*"="+"\n"
    txtg+="Mean sum of weights = "+str(round(sumweights,4))+"\n"
    txtg+="g-characteristics\n"
    txtg+="Inputs"+"\n"
    txtg+="    gbelow"+"\t"+"gabove"+"\n"
    for j in range(0,k):
        txtg+=str(j)+": "+str(round(gbelow[j],3))+"\t\t"+str(round(gabove[j],3))+"\n"
    txtg+="\n"    
    txtg+="    min-values"+"\t"+"mean-values"+"\t"+"  max-values"+"\n"
    for j in range(0,k):
        txtg+=str(j)+": "+str(round(ming[j],3))+"\t\t"+str(round(gmean[j],3))+"\t\t"+\
               str(round(maxg[j],3))+"\n"
    txtg+="    Weight-Volume(r) "+"   Dim of Volume "+"\n"
    txtg+=" "+ str(round(varvol,5))+2*"\t"+str(dimvol)+"\n"
    Vinput = 1
    dim_input = 0
    for j in range(0,k):
        deltag = gabove[j] - gbelow[j]
        if deltag!= 0:
            dim_input+=1
            Vinput = Vinput*deltag
        
    txtg+="    Weight-volume (input) = "+ "   Dim of Volume_input = "+"\n"
    txtg+="  "+str(round(Vinput,5)) + 2*"\t" + str(dim_input)+"\n" 
    txtg+="\n"+str(MCsim)+" simulations "
    txtg+="\n"
    distancmatrix, Kvector = distances()
    for j in range(0, len(Kvector)):
        if j == 0:
            txtg+= "Degeneracy of  CI = "+str(Kvector[j])+"\n"
        else:
            txtg+="Degeneracy of "+str(prop[j-1])+" = "+str(Kvector[j])+"\n"
    print "Kvector = ",Kvector
    redfactor = 1
    krel=[]
    for j in range(0,len(Kvector)):
        krel.append(1.0 - (1.0*Kvector[j]/(1.0*r*(r - 1.0))))
    for j in range(1, len(Kvector)):
        print "j = ",j,"  krel[j]= ",krel[j]
        redfactor = redfactor*krel[j]
                    
    txtg+="\n"
    txtg+="Resulting reduction factor = " + str(round(redfactor,5))+"\n"
    print "distances  ",distancmatrix
    print "Degeneracy   ",Kvector
    print "krel = ",krel
    print "redfactor = ",redfactor
    txthilf2=HDbasics()
    txtg+="Partial order results"+"\n"
    txtg+=txthilf2+"\n"
    txtg+="   e o f   "
    tgc=ScrolledText(tpg,width=80,height=10)
    tgc.pack()
    tgc.insert("end",txtg)

def trred(n,ad):
    #brg 18.8.2011
    #ad: zeta matrix: row >= column
    # ++++ this procedure needs the zetaq matrix (procedure comp)
    # then the direct analysis to get the HD with help of cover-matrix
    # return: cover matrix
    # applications in HDweight2 and in HDalter2
    covh=rmod2.marray(n,n)
    for i1 in range(0,n):
        for i2 in range(0,n):
            covh[i1][i2]=ad[i1][i2]
    for i1 in range(0,n):
        for i2 in range(0,n):
            if i1!=i2:
                for i3 in range(0,n):
                    if i2!=i3:
                        testsum=ad[i1][i2]+ad[i2][i3]
                        if testsum>ad[i1][i3]:
                            covh[i1][i3]=0
    return covh            

def HDbasics():
    #brg 23.12.2014, 28.12.2014
    global rred1,objred1,zetaMC
    rred1,xred1,objred1,txteq1,neq1=rmod2.equivcompactm(r,MCsim,dmg,obj)
    zetahilf=rmod2.comp(rred1,MCsim,xred1)  #zeta matrix with col<row
    zetaMC=rmod2.marray(rred1,rred1)
    for i1 in range(0,rred1):  #however we need for the 'normal' presentation: row < col. Transposition
        for i2 in range(0,rred1):
            zetaMC[i1][i2]=zetahilf[i2][i1]
    #
    #comparabilities and incomparabilities, count of minimal and maximal elements 
    comparabilities=0
    for i1 in range(0,rred1):
        for i2 in range(0,rred1):
            if i1!=i2:
                comparabilities+=zetaMC[i1][i2]
    utotal=0
    for i1 in range(0,rred1):
        for i2 in range(0,rred1):
            if zetaMC[i1][i2]==0 and zetaMC[i2][i1]==0:
                utotal+=0.5

    rsumzetaMC=rmod2.matrixrowsum(zetaMC,rred1,rred1)
    #print "rsumzetaMC = ",rsumzetaMC
    maxcount=0
    for i in range(0,rred1):
        if rsumzetaMC[i]==1:
            maxcount+=1
    
    csumzetaMC=rmod2.matrixcolsum(zetaMC,rred1,rred1)
    #print "csumzetaMC = ",csumzetaMC
    mincount=0
    for i in range(0,rred1):
        if csumzetaMC[i]==1:
            mincount+=1
        
    
    #rmod2.matout(n,n,zeta)
    lobj1,lext1,revlext1,zzmax1=rmod2.levtopsort(rred1,zetaMC)
    
    
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax1):
        if len(lobj1[i])>=levmax:
            levmax=len(lobj1[i])

    txt1x="identifier = "+str(identifier)+"\n"
    txt1x+=" Number of levels                    = "+str(zzmax1)+"\n"
    txt1x+=" Number of elements in largest level = "+str(levmax)+"\n" 
    txt1x+=" comparabilities                      = "+str(comparabilities)+"\n"
    txt1x+=" incomparabilities                    = "+str(utotal)+"\n"
    txt1x+=" number of representative elements    = "+str(rred1)+"\n"
    txt1x+=" Count of maximal elements            = "+str(maxcount)+"\n"
    txt1x+=" Count of minimal elements            = "+str(mincount)+"\n"
    return txt1x
   
        

    

def HDCIg():
    #  brg 15.7.2012
    global zetaMC,covMC,objred1, rred1    #6.11.2011,1.12.2011, 15.7.2012   
    hfhd3=Tkinter.Toplevel(hf)
    hfhd3.title('Hasse diagram / cover matrix based on the CI')
    
    try:
        perturb=int(eperturb.get())
    except:
        perturb=0
     
    #
    print "rred in HDCIg ",rred
    print "MCsim in HDCIg ",MCsim
    print "dmg "
    #rmod2.matout(rred, MCsim, dmg)
    #print " "
    rred1,xred1,objred1,txteq1,neq1=rmod2.equivcompactm(r,MCsim,dmg,obj)
    print "objred1 = ",objred1
    zetahilf=rmod2.comp(rred1,MCsim,xred1)  #zeta matrix with col<row
    zetaMC=rmod2.marray(rred1,rred1)
    for i1 in range(0,rred1):  #however we need for the 'normal' presentation: row < col. Transposition
        for i2 in range(0,rred1):
            zetaMC[i1][i2]=zetahilf[i2][i1]
    #
    #comparabilities and incomparabilities, count of minimal and maximal elements 
    comparabilities=0
    for i1 in range(0,rred1):
        for i2 in range(0,rred1):
            if i1!=i2:
                comparabilities+=zetaMC[i1][i2]
    utotal=0
    for i1 in range(0,rred1):
        for i2 in range(0,rred1):
            if zetaMC[i1][i2]==0 and zetaMC[i2][i1]==0:
                utotal+=0.5

    rsumzetaMC=rmod2.matrixrowsum(zetaMC,rred1,rred1)
    #print "rsumzetaMC = ",rsumzetaMC
    maxcount=0
    for i in range(0,rred1):
        if rsumzetaMC[i]==1:
            maxcount+=1
    
    csumzetaMC=rmod2.matrixcolsum(zetaMC,rred1,rred1)
    #print "csumzetaMC = ",csumzetaMC
    mincount=0
    for i in range(0,rred1):
        if csumzetaMC[i]==1:
            mincount+=1
        
    
    #rmod2.matout(n,n,zeta)
    lobj1,lext1,revlext1,zzmax1=rmod2.levtopsort(rred1,zetaMC)
    
    tplev=Tkinter.Toplevel(hf)
    tplev.title(' Basics of the poset ')
    tlev=ScrolledText(tplev,width=60,height=4)  
    tlev.pack()
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax1):
        if len(lobj1[i])>=levmax:
            levmax=len(lobj1[i])

    txt1="identifier = "+str(identifier)+"\n"
    for i in range(0,zzmax1):
        txt1+="Level "+str(zzmax1-i)+" :"
        for j in range(0,len(lobj1[i])):
            txt1+= objred1[lobj1[i][j]]+" "
        txt1+="\n"
    txt1+="identifier = "+str(identifier)+"\n"
    txt1+=" Number of levels                    = "+str(zzmax1)+"\n"
    txt1+=" Number of elements in largest level = "+str(levmax)+"\n" 
    txt1+=" comparabilities                      = "+str(comparabilities)+"\n"
    txt1+=" incomparabilities                    = "+str(utotal)+"\n"
    txt1+=" number of representative elements    = "+str(rred1)+"\n"
    txt1+=" Count of maximal elements            = "+str(maxcount)+"\n"
    txt1+=" Count of minimal elements            = "+str(mincount)+"\n"
    txt1+="equivalence classes of HDg            = "+txteq1+"\n"
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)
    lbutotal = Tkinter.Label(hfhd3, text =" incomparabilities = "+str(utotal))
    lbutotal.pack()
    
    
    #Adj-Listen

      
    covMC=trred(rred1,zetaMC)  #taken from HDalter6, maybe I need a loop..
    # now the needed matrices are generated and the buttons for filters and order ideals can be activated
    
    if rred1>200:
        coverMC_show()                  #20.1.08
    else:
        lbhd3=Tkinter.Label(hfhd3,text=" Hasse Diagram of MCsim")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred1,levmax,zzmax1)
        cv=Tkinter.Canvas(hfhd3,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax1
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj1[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred1,rred1)
        geomy=rmod2.marray(rred1,rred1)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=(perturb*random.randint(1,5)+1)*geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if covMC[lobj1[i1][j1]][lobj1[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-17,geomy[i][j]+17,geomx[i][j]+17,geomy[i][j]-17,\
                               fill="white",tags="object_"+str(objred1[lobj1[i][j]]))
                cv.create_text(geomx[i][j],geomy[i][j],text=objred1[lobj1[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")

        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.create_text(int(1.0*actwidth/2.0),actheight-5,text="identifier = "+str(identifier))
        cv.pack()
        
        buttcover=Tkinter.Button(hfhd3,text="show cover relation",command=coverMC_show)
        buttcover.pack(side="left",padx=5)
        
def coverMC_show():
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: mainHD20_3
    hfcoverMC=Tkinter.Toplevel(hf)
    hfcoverMC.title(' cover-matrix MC')
    
    lbhd2=Tkinter.Label(hfcoverMC,text=" Cover-Relations MC ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,rred1):
        txt3+="\n"+objred1[i]+":\t"
        txt3+="is covered by "
        for j in range(0,rred1):
            if i!=j:
                if covMC[i][j]==1:
                    txt3+=" "+objred1[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcoverMC,width=50, height=20)
    tcov.pack(expand=1,fill="both")
    tcov.insert("end",txt3)
        

def LPOMext():
    #Brg 30.9.09, 2.3,2012, 28.7.2012, 23.2.2013, 18.3.2015
    global havext 
    Sa=rmod2.marray1(rred,rred,-1)
    Pa=rmod2.marray1(rred,rred,-1)
    Ua=rmod2.marray1(rred,rred,-1)
    countSa=rmod2.vecgen1(rred)
    countPa=rmod2.vecgen1(rred)
    countUa=rmod2.vecgen1(rred)
    increm = rmod2.vecgen1(rred)
    alpha=1  #parameters to be determined by statistical techniques
    beta=0  #parameters to be determined by statistical techniques

    for ob in objred:
        obi=objred.index(ob)
        
        #obi the selected element label whose rkav will be deternmined
        z=0
        for i1 in range(0,rred):
            if zeta[i1][obi]==1:
                z+=1
                Sa[obi][i1]=i1
        #print "ob = ",ob,"  its order ideal:  ",Sa[obi]
        countSa[obi]=z

    for ob in objred:
        obi=objred.index(ob)
        
        #obi the selected element whose rkav will be deternmined
        z=0
        for i1 in range(0,rred):
            if zeta[obi][i1]==1:
                z+=1
                Pa[obi][i1]=i1
        #print "ob = ",ob,"  its order filter:  ",Pa[obi]
        countPa[obi]=z

    for ob in objred:
        obi=objred.index(ob)
        z=0
        for i1 in range(0,rred):
            if zeta[i1][obi]==0 and zeta[obi][i1]==0:
                z+=1
                Ua[obi][i1]=i1
                countUa[obi]+=1
       
    rkav=rmod2.vecgen1(rred) #LPOMext
    for i2 in range(0,rred):
        rkav[i2]=countSa[i2]  #note Sa includes the interesting element a too
   
    
    txt="LPOMext of orig poset"+"\n"
    txt+50*"="+"\n"
    txt+="Objects"+"\t"+"rkav(orig)"+"\t"+"min rank"+"\t"+"increment"+"\t"+"incomp"+"\t"+"Uncertainty "+"\n"
    for ob in objred:
        obi=objred.index(ob)
        increment=0
        hilf=rmod2.vecgen1(rred)
        for i in range(0,rred):   #28.7.2012
            hilf[i]=Ua[obi][i]  #28.7.2012
        for y in hilf:
##            if y!=-1:
##                #print "ob= ",ob, " y ncrloop: ",y," nme= ",objred[y]," ",
            Uy=[]
            Pdown=0
            Pup=0
            
            if y!=-1:
                for i1 in range(0,rred):
                    if zeta[i1][y]==0 and zeta[y][i1]==0:
                        Uy.append(i1)
                        
                
                for x in Uy:
                    if x in Sa[obi]:
                        Pdown+=1
                            
                for x in Uy:
                    if x in Pa[obi]:
                        Pup+=1
                
                dinc=1.0*Pdown/(1.0*Pdown+1.0*Pup)
                
                
                
                increment+=dinc
                print "obi = ",obi,"  y= ",y,"  Pdown= ",Pdown,"   Pup = ",Pup, "  increment= ",increment
        rkav[obi]+=alpha*increment+beta
        increm[obi]=increment
    print "obj = ",obj
    print "objred = ",objred
    print "rkav= ",rkav
    eqm=rmod2.equivcompactgr3(r,k,dm)
    havext=rmod2.weak2(r,obj,objred,rkav,eqm)
    for ob in obj:
        obi=obj.index(ob)
        txt+=ob+":\t"+str(round(havext[obi],3))+"\t"+str(countSa[obi])+"\t"+\
              str(round(increm[obi],2))+"\t"+str(countUa[obi])+"\t"+str(countSa[obi])+"..."+str(countSa[obi]+countUa[obi])+"\n"
    txt+="\n\n\n"
    tpLPOM=Tkinter.Toplevel(hf)
    tpLPOM.title('  LPOMext-results ')
    tlpom=ScrolledText(tpLPOM,width=50,height=20)
    tlpom.pack()
    tlpom.insert("end",txt)


def LPOMextmod():
    #Brg 30.9.09, 2.3,2012, 28.7.2012, 23.2.2013, 18.3.2015
    global havext1
    Sa=rmod2.marray1(rred1,rred1,-1)
    Pa=rmod2.marray1(rred1,rred1,-1)
    Ua=rmod2.marray1(rred1,rred1,-1)
    countSa=rmod2.vecgen1(rred1)
    countPa=rmod2.vecgen1(rred1)
    countUa=rmod2.vecgen1(rred1)
    increm = rmod2.vecgen1(rred1)
    alpha=1  #parameters to be determined by statistical techniques
    beta=0  #parameters to be determined by statistical techniques
    
    for ob in objred1:
        obi=objred1.index(ob)
        
        #obi the selected element label whose rkav will be deternmined
        z=0
        for i1 in range(0,rred1):
            if zetaMC[i1][obi]==1:
                z+=1
                Sa[obi][i1]=i1
        #print "ob = ",ob,"  its order ideal:  ",Sa[obi]
        countSa[obi]=z

    for ob in objred1:
        obi=objred1.index(ob)
        
        #obi the selected element whose rkav will be deternmined
        z=0
        for i1 in range(0,rred1):
            if zetaMC[obi][i1]==1:
                z+=1
                Pa[obi][i1]=i1
        #print "ob = ",ob,"  its order filter:  ",Pa[obi]
        countPa[obi]=z

    for ob in objred1:
        obi=objred1.index(ob)
        z=0
        for i1 in range(0,rred1):
            if zetaMC[i1][obi]==0 and zetaMC[obi][i1]==0:
                z+=1
                Ua[obi][i1]=i1   #if object with label i1 is incomparable with obi, then Ua[obi][i1] gets just the label i1
        #print "ob = ",ob,"  its incomparables  ",Ua[obi]
                countUa[obi] += 1
    rkav1=rmod2.vecgen1(rred1) #LPOMext mod (due to dmg)
    for i2 in range(0,rred1):
        rkav1[i2]=countSa[i2]  #note Sa includes the interesting element a too
   
    
    txt="LPOMext of weight-based poset"+"\n"
    txt+50*"="+"\n"
    txt+="Object"+"\t"+"Rkav "+"\t"+"min height "+"\t"+"increment"+"\t"+"incomp"+"\t"+"uncertainty"+ "\n"
    txt+=80*"="+"\n"
    for ob in objred1:
        obi=objred1.index(ob)
        increment=0
        hilf=rmod2.vecgen1(rred1)
        for i in range(0,rred1):   #28.7.2012
            hilf[i]=Ua[obi][i]  #28.7.2012
        print "ob = ",ob
        print "hilf= ",hilf
        for y in hilf:
##            if y!=-1:
##                #print "ob= ",ob, " y ncrloop: ",y," nme= ",objred[y]," ",
            Uy=[]
            Pdown=0
            Pup=0
            
            if y!=-1:
                for i1 in range(0,rred1):
                    if zetaMC[i1][y]==0 and zetaMC[y][i1]==0:
                        Uy.append(i1)
                        
                
                for x in Uy:
                    if x in Sa[obi]:
                        Pdown+=1
                            
                for x in Uy:
                    if x in Pa[obi]:
                        Pup+=1
                
                dinc=1.0*Pdown/(1.0*Pdown+1.0*Pup)
                
                
                
                increment+=dinc
                print "obi = ",obi,"  y= ",y,"  Pdown= ",Pdown,"   Pup = ",Pup, "increment= ",increment
        increm[obi] = increment
        rkav1[obi]+=alpha*increment+beta
    print "rkav1= ",rkav1
    eqm1=rmod2.equivcompactgr3(r,MCsim,dmg)
    havext1=rmod2.weak2(r,obj,objred1,rkav1,eqm1)
    for ob in obj:
        obi=obj.index(ob)
        txt+=ob+":\t"+str(round(havext1[obi],3))+2*"\t"+str(countSa[obi])+"\t"+str(round(increm[obi],2))+\
              "\t"+str(countUa[obi])+"\t"+str(countSa[obi])+"..."+str(countSa[obi]+countUa[obi])+"\n"
    txt+="\n\n\n"
    tpLPOM1=Tkinter.Toplevel(hf)
    tpLPOM1.title('  LPOMext-results ')
    tlpom1=ScrolledText(tpLPOM1,width=80,height=20)
    tlpom1.pack()
    tlpom1.insert("end",txt)
    
def spear():
    # brg 28.12.2014
    rspear,pspear=pstat.spearmanr(havext,havext1)
    tpspear=Tkinter.Toplevel(hf)
    tpspear.title(' Spearman correlation ')
    tspear=ScrolledText(tpspear,width=50,height=5)
    tspear.pack()
    txt="Spearman correlation "+"\n"
    txt+=50*"="+"\n"
    txt+="Number of cases "+str(len(havext))+"\n"
    txt+="Identifier = "+str(identifier)+"\n"
    txt+="rSpearman = "+str(rspear)+"\n"
    txt+="pSpearman = "+str(pspear)+"\n"
    txt+="- - -   eof - - - "
    tspear.insert("end",txt)
    
def save_relat():
    # brg 3.1.2015
    relat=rmod2.comp(r,MCsim,dmg)
    fnrelat=tkFileDialog.asksaveasfilename(parent=hf,title="save relational-files in PyHasseformat")
    fcsv=open(fnrelat,"w")
    fcsv.write(str(r)+"\n")
    for i1 in range(0,r):
        for i2 in range(0,r):
            fcsv.write(str(relat[i2][i1])+"\t")
        fcsv.write("\n")
    fcsv.close()
    print "the first four elements of relational matrix "
    for i1 in range(0,4):
        for i2 in range(0,4):
            print relat[i1][i2]," ",
        print " "

def calc_Kron(dm,g,n,m):
    #brg 28.08.17, 29.08.17
    #dm: Data matrix with n rows (Objects)
    #g: mean value of weights obtained after MC
    #n: r oder rred
    #m: number of indicators/attributes
    #return Kron (= matrix of q(i,j)*g(j),maxkron (=maximum for each row of Kron) 
    Kron=[]
    for i in range(0,n):
        Kron.append(0)
        Kron[i]=[]
        for j in range(0,m):
            Kron[i].append(dm[i][j]*g[j])
    maxkron=[]
    for i in range(0,n):
        maxkron.append(max(Kron[i]))
    return Kron, maxkron

def calc_incomp(dm,obj,n,m):
    # brg 28.08.17
    # dm data matrix (columnwise [0,1]-normalized)
    #....with n rows (objects) and m columns (indicators)
    # obj = obj or objred, list of labels of the objects
    # n: rred or r number of rows
    # m: number of indicators
    # return: List of objects mutually incomparable in the form of (a,b),(c,d),...
    zeta=rmod2.comp(n,m,dm)
    incomp=[]
    for i1 in range(0,n):
        for i2 in range(i1+1,n):
            if zeta[i1][i2]==0 and zeta[i2][i1]==0:
                incomp.append((obj[i1],obj[i2]))
    return incomp

def estimator(incomp,maxkron,dm,g,obj,m):
    #brg 28.08.17, 29.08.17, 30.08.17
    #incomp (as a result of procedur calc_incomp)
    #maxkron (as a result of calc_Kron)
    #dm: [0,1] columnwise normalized data matrix
    # g: mean-values of weights
    #obj: obj or objred : list of object labels
    #return: estim (structure (("a","b"),hilf)), estim2
    global estim2max, estim2mean,estim2min
    estim=[]
    estim2=[]
    for pair in incomp:
        iob1=obj.index(pair[0])
        iob2=obj.index(pair[1])
        hilf=abs(maxkron[iob1]-maxkron[iob2])
        estim.append((pair,hilf))
        hilf2=0
        for j in range(0,m):
            hilf2+=g[j]*(dm[iob1][j]-dm[iob2][j])
        estim2.append((pair,hilf2))    
    return estim, estim2

def check_stability():
    #brg 28.08.17, 29.08.17
    global est, est2mean,est2max,est2min
    Kron,mkron=calc_Kron(yn,gmean,r,k)
    icmp=calc_incomp(yn,obj,r,k)
    print "gmax= ",maxg
    est,est2mean=estimator(icmp,mkron,yn,gmean,obj,k)
    est,est2max=estimator(icmp,mkron,yn,maxg,obj,k)
    est,est2min=estimator(icmp,mkron,yn,ming,obj,k)
    tpcheck=Tkinter.Toplevel(hf)
    tpcheck.title(' check of weight-stable/unstable incomparabilities')
    tcheck=ScrolledText(tpcheck,width=80,height=20)
    tcheck.pack()
    txt="Estimation of (x||y)-stability w.r.t. weight-intervals "+"\n"
    txt+="mean-values of weights due to MC simulation"+"\n"
    for j in range(0,k):
        txt+=str(prop[j])+": "+str(round(gmean[j],3))+"\n"
    txt+="max values of dm[i][j]*g[j] for each object "+"\n"
    for i in range(0,r):
        txt+=str(obj[i])+" :"+str(round(mkron[i],3))+"\n"
    txt+="\n"
    txt+="estimators1: the larger, the more instable is the original incomparability "+"\n"
    txt+="with respect to weight intervals "+"\n"
    for triple in est:
        txt+=str(triple[0])+": "+str(round(triple[1],3))+"\n"
    txt+="\n"
    hilf=[]
    for triple in est:
        hilf.append(triple[1])
    estim,n_estim=rmod2.raisort(len(est),hilf)
    #print "n_estim  ",n_estim
    #print "len(est)=  ",len(est)
    txt+="sorting...."+"\n"
    for i in range(0,len(est)):
        if i<len(est)-1:
            txt+=str(est[n_estim[i]][0])+"<= "
        else:
            txt+=str(est[n_estim[i]][0])
    txt+="\n"    
    
    tcheck.insert("end",txt)
    buttonestim2=Tkinter.Button(tpcheck, text="estimator 2 ",command=estim_2)
    buttonestim2.pack()

def estim_2():
    #brg 30.08.17
    #print "estim2 "
    tpcheck2=Tkinter.Toplevel(hf)
    tpcheck2.title(' estimator 2 ')
    tcheck2=ScrolledText(tpcheck2,width=80,height=20)
    tcheck2.pack()
    txt="estimator 2: mean-weighted sum of difference of data\n"
    for triple in est2mean:
        txt+=str(triple[0])+": "+str(round(triple[1],3))+"\n"
    txt+="\n"
    txt+="estimator 2: min-weighted sum of difference of data\n"
    for triple in est2min:
        txt+=str(triple[0])+": "+str(round(triple[1],3))+"\n"
    txt+="\n"
    txt+="estimator 2: just the max-weighted sum of difference of data\n"
    for triple in est2max:
        txt+=str(triple[0])+": "+str(round(triple[1],3))+"\n"
    txt+="\n"    
    tcheck2.insert("end",txt)
    
    
          
## Tkinter Plot
hf = Tkinter.Tk()
hf.title(' HDweights ')
aboutHDsimpl=raioop2.brgabout(hf,"tp1","about_HDweight.txt",9,\
            "Aug., 28th,2017"," about HDweight ", "white", "t1",80,5,ScrolledText)
helpHDsimpl=raioop2.brgabout(hf,"tp1","help_HDweight.txt",9,\
            "Aug., 28th,2017"," help_HDweight ", "white", "t1",80,5,ScrolledText)
    
fr=Tkinter.Frame(hf,width=60)
fr.pack()
buttHD = Tkinter.Button(fr, text='select, open and HD',width=35,bg="cyan",command=fileselectopenHD)
buttHD.pack(pady=5)
buttshowdm=Tkinter.Button(fr,text="Show data matrix ",width=35,bg="cyan",command=showDM)
buttshowdm.pack()
buttMCHD=Tkinter.Button(fr,text="weight intervals ",width=35, bg="cyan", command=MCHD)
buttMCHD.pack()
buttgsubmit=Tkinter.Button(fr,text="perform the MC-simulations",width=35,bg="cyan",command=gsubmit)
buttgsubmit.pack()
lbeperturb=Tkinter.Label(fr,text="insert (0 for no perturbation and 1... for increased perturbation ")
lbeperturb.pack()
eperturb=Tkinter.Entry(fr,width=4)
eperturb.pack()
buttHDCIg=Tkinter.Button(fr,text="HD due to weight-intervals ",width=35,bg="cyan",command=HDCIg)
buttHDCIg.pack()
buttestim=Tkinter.Button(fr, text="Check of weight-stable/unstable \n\
                                mutually incomparable objects", width=35, bg="cyan",command=check_stability)
buttestim.pack()
buttLPOM=Tkinter.Button(fr, text="1) hav due to the orig. HD ",width=35,bg="cyan",command=LPOMext)
buttLPOM.pack()
buttLPOMmod=Tkinter.Button(fr, text="2) hav due to the weight based HD ",bg="cyan",width=35,command=LPOMextmod)
buttLPOMmod.pack()
buttspear=Tkinter.Button(fr, text="Spearman-correlation of both av. heights ",bg="cyan",width=35,command=spear)
buttspear.pack()
buttdistances = Tkinter.Button(fr, text = "distances among all relat matrices)", bg = "cyan", width = 35, command = distances)
buttdistances.pack()
buttsaverelat=Tkinter.Button(fr,text="Save relational matrix ",bg="cyan",width=35,command=save_relat)
buttsaverelat.pack()
buttexit = Tkinter.Button(fr, text = 'exit', bg = 'red', bd=4,width=10,command = hf.destroy)
buttexit.pack(pady=10)

hf.mainloop()

