#  LPOM GUI  24.6.07 , 7.7.07  Brg
#  
# 7.7.07, 8.7.07, 20.10.07 , 22.10.07, 7.11.07, 16.11.07, 29.11.07, 30.11.07,
# 4.2.08
# this program calculates exclusively averaged ranks based on three variants of
# approximation
# 18.2.08 : bug: hfgraphics vs hfgraphics3  eliminated, unification: help-button green 

#  Brg: 13.10.08 help text now external. Loading by an OOP-function
# Brg cosmetics  3.6.09

import Tkinter 
import math
import rmod2
import raioop2
from ScrolledText import *
import Canvas

    
def graphics_up():
    "displays a graphical scheme"
    #brg 29.11.07, 4.2.08
    ci=rmod2.vecgen1(10)
    hfgraphic=Tkinter.Toplevel(hf)
    hfgraphic.title(' help / up ')
    lbhfgraphic=Tkinter.Label(hfgraphic,text="LPOM0_1_up")
    lbhfgraphic.pack()
    cv=Tkinter.Canvas(hfgraphic,width=200,height=200, bd=2,relief="sunken")
    cv.create_line(100,20,100,160,fill="black")
    cv.create_line(100,42,144,156,fill="black")
    cv.create_line(100,42,124,156,fill="black")
    for i in range(0,8):
        
        if i==1:
            ci[i]=cv.create_oval(96,18+20*i,104,26+20*i,fill="yellow")
        elif i==4:
            ci[i]=cv.create_oval(96,18+20*i,104,26+20*i,fill="red")
        else:
            ci[i]=cv.create_oval(96,18+20*i,104,26+20*i,fill="white",outline="black")
    
    ci[8]=cv.create_oval(120,158,128,166,fill="blue",outline="black")
    ci[9]=cv.create_oval(140,158,148,166,fill="blue",outline="black")

    cv.create_text(50,19,text="tail")
    cv.create_text(50,39,text="anchor point")
    cv.create_text(50,99,text="actual object")
    cv.create_text(50,123,text="successors")

    cv.pack()
    txt="\n"
    txt+="actual element ' x ' (red) \n"
    txt+="there is -relatively to the actual element- ...\n"
    txt+=" ...always an upper or (exclusively) lower anchor point (yellow) \n"
    txt+=" Correspondingly there is either an upper tail (anchor point above x )\n"
    txt+=" or a lower tail (anchor point below x \n"
    txt+=" the elements between x and the anchor point belong to the 'interval' \n"
    txt+=" In the graphical scheme the case 'upper anchor, upper interval, upper tail' is shown\n"
    txt+=" In that case the button 'approx1up' is to be pressed.\n"
    txt+=" The tail would contain one element, the interval two and the successors are 3 \n"
    tstr=ScrolledText(hfgraphic, width=60, height=10)
    tstr.pack()
    tstr.insert("end",txt)
    

def graphics_down():
    "displays a graphical scheme"
    #brg 29.11.07, 30.11.07
    ci=rmod2.vecgen1(10)
    hfgraphic2=Tkinter.Toplevel(hf)
    hfgraphic2.title(' help/down ')
    lbhfgraphic2=Tkinter.Label(hfgraphic2, text="LPOM0_1_down")
    lbhfgraphic2.pack()
    cv=Tkinter.Canvas(hfgraphic2,width=200,height=200, bd=2,relief="sunken")
    cv.create_line(100,20,100,160,fill="black")
    cv.create_line(100,102,124,22,fill="black")
    cv.create_line(100,102,144,22,fill="black")
    for i in range(0,8):
        
        if i==1:
            ci[i]=cv.create_oval(96,18+20*i,104,26+20*i,fill="red")
        elif i==4:
            ci[i]=cv.create_oval(96,18+20*i,104,26+20*i,fill="yellow")
        else:
            ci[i]=cv.create_oval(96,18+20*i,104,26+20*i,fill="white",outline="black")
    
    ci[8]=cv.create_oval(120,18,128,26,fill="blue",outline="black")
    ci[9]=cv.create_oval(140,18,148,26,fill="blue",outline="black")

    cv.create_text(50,19,text="predecessors")
    cv.create_text(50,99,text="anchor point")
    cv.create_text(50,39,text="actual object")
    cv.create_text(50,123,text="tail (down)")

    cv.pack()
    txt="\n"
    txt+="actual element ' x ' (red) \n"
    txt+="there is -relatively to the actual element- ...\n"
    txt+=" ...always an upper or (exclusively) lower anchor point (yellow) \n"
    txt+=" Correspondingly there is either an upper tail (anchor point above x )\n"
    txt+=" or a lower tail (anchor point below x \n"
    txt+=" the elements between x and the anchor point belong to the 'interval' \n"
    txt+=" In the graphical scheme the case 'predecessors, lower anchor, lower interval, tail down' is shown\n"
    txt+=" In that case the button 'approx1down' is to be pressed.\n"
    txt+=" The tail would contain three element, the interval two and the successors are 3 \n"
    tstr2=ScrolledText(hfgraphic2, width=60, height=10)
    tstr2.pack()
    tstr2.insert("end",txt)
    

def graphics_0():
    "displays a graphical scheme"
    #brg 29.11.07, 4.2.08
    ci=rmod2.vecgen1(10)
    hfgraphics3=Tkinter.Toplevel(hf)
    hfgraphics3.title(' help / 0.th approx ')
    lbhfgraphics3=Tkinter.Label(hfgraphics3,text="LPOM0")
    lbhfgraphics3.pack()
    cv=Tkinter.Canvas(hfgraphics3,width=200,height=200, bd=2,relief="sunken")
    cv.create_line(100,20,100,160,fill="black")
    
    for i in range(0,8):
        
        if i==4:
            ci[i]=cv.create_oval(96,18+20*i,104,26+20*i,fill="red")
        else:
            ci[i]=cv.create_oval(96,18+20*i,104,26+20*i,fill="white",outline="black")
    
    ci[8]=cv.create_oval(120,18,128,26,fill="blue",outline="black")
    ci[9]=cv.create_oval(140,18,148,26,fill="blue",outline="black")

    cv.create_text(50,25,text="predecessors")
    
    cv.create_text(50,99,text="actual object")
    cv.create_text(50,123,text="successors")

    cv.pack()
    txt="\n"
    txt+="actual element ' x ' (red) \n"
    txt+="incomparable elements ' u ' with u || x are considered as isolated \n"
    txt+="Elements above x are predecessors \n"
    txt+="Elements below x are successors \n"
    txt+="+++Note, we are following the convention top to bottom +++\n"
    tstr3=ScrolledText(hfgraphics3, width=60, height=10)
    tstr3.pack()
    tstr3.insert("end",txt)
    
    

def approx0():
    global e1,e2,e3,lb04
    hf0=Tkinter.Toplevel(hf)
    lbhf0=Tkinter.Label(hf0,text="LPOM0")
    lbhf0.pack()
    fr0=Tkinter.Frame(hf0,width=60, height=20)
    fr0.pack()
    fr01=Tkinter.Frame(fr0,width=30,height=2)
    fr01.pack()
    lb01=Tkinter.Label(fr01,text="no of successors? ")
    lb01.pack(side="left",fill="x")
    e1=Tkinter.Entry(fr01,width=4)
    e1.pack(side="left",fill="x")
    fr02=Tkinter.Frame(fr0,width=30, height=2)
    fr02.pack()
    lb02=Tkinter.Label(fr02,text="no of predecessors? ")
    lb02.pack(side="left",fill="x")
    e2=Tkinter.Entry(fr02,width=4)
    e2.pack(side="left",fill="x")
    fr03=Tkinter.Frame(fr0,width=30,height=2)
    fr03.pack()
    lb03=Tkinter.Label(fr03,text="no of incomparables? ")
    lb03.pack(side="left",fill="x")
    e3=Tkinter.Entry(fr03,width=4)
    e3.pack(side="left",fill="x")
    lb04=Tkinter.Label(fr0,text="")
    lb04.pack()
    butt0=Tkinter.Button(fr0,text="calculation ",bg="cyan",command=start0)
    butt0.pack()
    



def start0():    
    s=float(e1.get())
    p=float(e2.get())
    u=float(e3.get())
    rkav0=float(s+1)*(p+s+u+2)/float(p+s+2)
    lb04.config(bg="yellow",relief="raised",bd=2)
    lb04["text"]="Result: Rkav(x)=  "+str(round(rkav0,2))
        

def approx1down():
    global e11,e21,e31,e41,lb15
    hf1=Tkinter.Toplevel(hf)
    lbhf1=Tkinter.Label(hf1,text="LPOM1down: ")
    lbhf1.pack()
    fr1=Tkinter.Frame(hf1,width=50, height=50)
    fr1.pack()

    fr11=Tkinter.Frame(fr1,width=40,height=2)
    fr11.pack()
    lb11=Tkinter.Label(fr11,text="# of elements in down tail ? ")
    lb11.pack(side="left",fill="x")
    e11=Tkinter.Entry(fr11,width=4)
    e11.pack(side="left",fill="x")

    fr12=Tkinter.Frame(fr1,width=40,height=2)
    fr12.pack()
    lb12=Tkinter.Label(fr12,text="# of elements in interval (x,a)? ")
    lb12.pack(side="left",fill="x")
    e21=Tkinter.Entry(fr12,width=4)
    e21.pack(side="left",fill="x")

    fr13=Tkinter.Frame(fr1,width=40,height=2)
    fr13.pack()
    lb13=Tkinter.Label(fr13,text="# of predecessors? ")
    lb13.pack(side="left",fill="x")

    e31=Tkinter.Entry(fr13,width=4)
    e31.pack(side="left",fill="x")

    fr14=Tkinter.Frame(fr1,width=40,height=2)
    fr14.pack()
    lb14=Tkinter.Label(fr14,text="# of incomparables ?")
    lb14.pack(side="left",fill="x")
    e41=Tkinter.Entry(fr14,width=4)
    e41.pack()

    lb15=Tkinter.Label(fr1,text=" ")
    lb15.pack()
    butt1down=Tkinter.Button(fr1,text="calculation ",bg="cyan",command=start1down)
    butt1down.pack()


def start1down():    
    tail=float(e11.get())
    interv=float(e21.get())
    p=float(e31.get())
    u=float(e41.get())
    prob=1.0*(interv+1.0)/(interv+p+2.0)
    rkav1down=tail+2.0+interv+prob*u
    lb15.config(bg="yellow")
    lb15["text"]="Result: Rkav(x) = "+str(round(rkav1down,2))
    
    
    
    
    
def approx1up():
    global e13,e23,e33,e43,lb25
                       
    # corresponds to the graphical scheme in graphics
    
    # brg 29.11.07, 4.2.08
    hf2=Tkinter.Toplevel(hf)
    lbhf2=Tkinter.Label(hf2,text="LPOM1up: ")
    lbhf2.pack()
    fr2=Tkinter.Frame(hf2,width=50, height=50)
    fr2.pack()

    fr21=Tkinter.Frame(fr2,width=35,height=2)
    fr21.pack()
    lb21=Tkinter.Label(fr21,text="# of successors ? ")
    lb21.pack(side="left")
    e13=Tkinter.Entry(fr21,width=4)
    e13.pack(side="left")

    
    fr23=Tkinter.Frame(fr2,width=30,height=2)
    fr23.pack()
    lb23=Tkinter.Label(fr23,text="# of elements in interval (x,a) ? ")
    lb23.pack(side="left")
    e33=Tkinter.Entry(fr23,width=4)
    e33.pack(side="left")

    fr24=Tkinter.Frame(fr2,width=30,height=2)
    fr24.pack()
    lb24=Tkinter.Label(fr24,text="# of incomparables ?")
    lb24.pack(side="left",fill="x")
    e43=Tkinter.Entry(fr24,width=4)
    e43.pack(side="left",fill="x")

    lb25=Tkinter.Label(fr2,width=60,height=2)
    lb25.pack()
    butt1up=Tkinter.Button(fr2,text="calculation ",bg="cyan",command=start1up)
    butt1up.pack()

    

def start1up():    
    s=float(e13.get())
    interv=float(e33.get())
    u=float(e43.get())
    prob=1.0*(s+1.0)/(1.0*interv+s+2.0)
    rkav1up=s+1.0+prob*u
    lb25.config(bg="yellow")
    lb25["text"]="Result: Rkav(x) = "+str(round(rkav1up,3))
    
    
    
        

hf=Tkinter.Tk()
hf.title("LPOMstruct1")
helplpom=raioop2.brgabout(hf,"tp1","help_lpom.txt",1,\
            "Febr, 18th,2008"," help_lpom ", "white", "t1",80,5,ScrolledText)
    
    
frabout=Tkinter.Frame(hf,width=300, height=300)
frabout.pack()
lbabout=Tkinter.Label(frabout,text=" LPOMstruct1 vs of 4.2.08 Author: Bruggemann ")
lbabout.pack()

##butthelp=Tkinter.Button(frabout,text="Lit-info&Help",bg="green",command=raihelp)
##butthelp.pack(fill="x",pady=25)

buttgraphup=Tkinter.Button(frabout,text="graph.scheme_'0'",bg="cyan",command=graphics_0)
buttgraphup.pack(fill="x")
buttgraphdown=Tkinter.Button(frabout,text="graph.scheme_'down'",bg="cyan",command=graphics_down)
buttgraphdown.pack(fill="x")
buttgraph_0=Tkinter.Button(frabout,text="graph.scheme_'up'",bg="cyan",command=graphics_up)
buttgraph_0.pack(fill="x")
b1=Tkinter.Button(frabout,text = "start approx0 ",bg="cyan",bd=4,command=approx0)
b1.pack(pady=25)
b2=Tkinter.Button(frabout,text = "start approx1down ",bg="cyan",bd=4,command=approx1down)
b2.pack(pady=25)
b3=Tkinter.Button(frabout,text = "start approx1up ",bg="cyan",bd=4,command=approx1up)
b3.pack(pady=25)
b4=Tkinter.Button(frabout,text=" exit ",bg="red",command=hf.destroy)
b4.pack(pady=25)



hf.mainloop()
