import csv
import tkFileDialog
import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import raioop2
#from string import replace

# brg 26.7.2013
# CSV-readin using professional routines of csv-library
# HDsimpl specifically for CSV-files (CSV-separated by ";")
# 28.7.2013: "," in numbers in "." in numbers
# 29.7.2013 cosmetics
# 29.8.2013 enabling to read data files stored in different formats
# 22.3.2014 cover-relation
# 8.9.2014 precision when checking the equivalence classes (equivcompactm2)
# 8.9.2014: output equivalence classes
# 9.9.2014 interface: graphviz
# 08.09.17: L_eval01_1.py auf der Basis von HDsimpl03
# 15.09.17: L_eval04_2.py: Higher flexibility in user selections.
# 09.10.17: Object-subsets as input
# 21.10.17: General rearrangement, vs L_eval09_1
# 21.11.17: Inclusion of the step 1.1 of concept generation
#           ...step 1.2 would be the concept determination
#           ...step 1.3 would be the HD of concepts
#           step 2 will be the determination of association rules
# 29.6.18: error at line 889 in vs 15_1
# 08.07.18: User can change single values in the data matrix
# 18.07.18: Normalizing explicitly by the user
# 19.07.18: HD of transposed dm (either normalized) or as it is 
# 25.07.18: Concept analysis now outcommented
# 04.10.2018: checked. Seems to work well


###### editfenster ### 08.09.17 #####
def xselectfile():
    # brg 6.8.2013
    global fn
    fn=tkFileDialog.askopenfilename()
    print "fn ",fn
    Tpopener=Tkinter.Toplevel(hf)
    Tpopener.title(' Opening window: different formats ')
    fropen2=Tkinter.Frame(Tpopener,bd=3,bg="white")
    fropen2.pack()
    # +++ Grid-Geometry manager +++
    lb0=Tkinter.Label(fropen2,text=" Select the appropriate format: ",bg="yellow",font=("arial",12,"bold"))
    lb0.grid(row=0,column=0)
    lb1=Tkinter.Label(fropen2,text="(1a) Open files, txt, tab (or blank) as delimiter (PyHasse-standard) :                ",bg="white")
    lb1.grid(row=1,column=0)
    lb2=Tkinter.Label(fropen2,text="(1b) Open files, csv, ';' as delimiter (csv with ';') :                               ",bg="white")
    lb2.grid(row=2,column=0)
    lb3=Tkinter.Label(fropen2,text="(1c) Open files, csv, ',' as delimiter (csv with ',') :                               ",bg="white")
    lb3.grid(row=3,column=0)
    lb6=Tkinter.Label(fropen2,text="(1f) Open files, pdt, internal PyHasse-format to exchange interim-results:            ",bg="white") 
    lb6.grid(row=6,column=0)
    butt1=Tkinter.Button(fropen2,text="(1a) Open txt-file       ",bg="cyan",bd=4,command=xfileopen)
    butt1.grid(row=1,column=1)
    butt2=Tkinter.Button(fropen2,text="(1b) Open csv-file (';') ",bg="cyan",bd=4,command=xcsvopenS)
    butt2.grid(row=2,column=1)
    butt3=Tkinter.Button(fropen2,text="(1c) Open csv-file (',') ",bg="cyan",bd=4,command=xcsvopenK)
    butt3.grid(row=3,column=1)
    butt6=Tkinter.Button(fropen2,text="(1f) Open pdt-file       ",bg="cyan",bd=4,command=xopenfilepdt)
    butt6.grid(row=6,column=1)


def xcsvopenS():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,obj,prop,x,xredh,rred,objred,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=';', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")
    rred,xredh,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)
    print "rred ",rred
    print "Matrix "
    rmod2.matout(r,k,xred)
    print "neq= ",neq
    print "txteq = ", txteq
    

    

def xcsvopenK():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,x,fn,obj,prop,xredh,objred,rred,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=',', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")

    rred,xredh,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)   # 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq
    




def xfileopen():
    "Informs about the file-operations"
    # Excelreadin4 built in
    # Brg 29.11.07, 30.11.07, 15.1.08,18.2.08
    global fn,r,k,x,prop,obj,rred,xredh,objred,txteq
    x,ob,pr,r,k=rmod2.EXCELreadin6(fn)
    print "r = ",r,"   k = ",k
    obj=rmod2.vecgentext1(r)                        # 29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  # recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pr[i+1]   # recoding, because pr[0] is a dummy string
    # rmod2.matout(r,k,x)
    
    lbopen1.config(bg="yellow")    # 18.2.08
    lbopen1["text"]="File "+fn+" was opened with "+str(r)+" rows and "+str(k)+"  columns"
    
    rred,xredh,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)   # 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq
    

    

def xopenfilepdt():
    """ File selection of transformed data matrices
    through other PyHasse programs """
    # brg 29.10.2012 taken from sensitivity18_3
    #* 1.6.09
    # akt. 29.10.2012 (taken from sensitivity18_3), 6.8.2013
    # source: mainHD19
    global fn,r,k,x,prop,obj,rred,xredh,objred,txteq
    
    r,k,x,obj,prop=rmod2.raireadin5(fn)
    lbpdtopen.config(bg="yellow")
    lbpdtopen["text"]="selected file (PyHasse (pdt) format) : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns"

    rred,xredh,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)  # new 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq
    


def show_dmact(dm,rows,columns,text):
    #brg taken from HDweightMC8_7
    #Brg 13.1.08, 15.1.08, 11.1.2015
    #*: 13.1.08
    #akt: 15.1.08, 21.10.17, 18.07.18
    #note: modified from the routine, taken from interval9.py
    tp2=Tkinter.Toplevel(hf)
    tp2.title('show DM')
    lbtp2=Tkinter.Label(tp2,text=" Gen. info. about the data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=20)
    tfile.pack()
    
    txt1="\n"
    txt1+=text+"\n"
    txt1+="\n objects\n"
    for i in range(0,rows):
        txt1+=" "+objred[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,columns):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,columns):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,rows):
        txt3+=objred[i]+"\t"
        for j in range(0,columns):
            txt3+=str(round(dm[i][j],3))+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)    

def show_dm():
    # brg 18.07.18
    show_dmact(xredh,rred,k,"..as input")


def HD(dm, k, labels):
    # brg 26.7.2013, 29.8.2013, 2.11.16, 21.11.17
    # Rearrangement as a dunctional procedure, getting data by the procedure input list
    TpHD=Tkinter.Toplevel(hf)
    TpHD.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(TpHD,width=200,height=300)
    freq.pack()
    nHD=len(labels)    #
    zetahilf=rmod2.comp(nHD,k,dm)  #zeta matrix with col<row
    zeta=rmod2.marray(nHD,nHD)
    for i1 in range(0,nHD):  #however we need for the 'normal' presentation: row < col. Transposition
        for i2 in range(0,nHD):
            zeta[i1][i2]=zetahilf[i2][i1]
    
    Utotal = rmod2.incompzeta(nHD,zeta)
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(nHD,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(nHD,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(nHD,adjc,lext)
       
    
    cov=rmod2.cover(nHD,tr,lext)

    if nHD>400:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram , Utotal =  "+str(Utotal))
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(nHD,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(nHD,nHD)
        geomy=rmod2.marray(nHD,nHD)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=labels[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()
        return cov

def HDdm():
    #brg 21.11.17
    global covdm
    # dm, k, labels
    covdm=HD(xredh,k,objred)

def covdm():
    #brg 21.11.17
    calc_cover(covdm,objred)
        
def calc_cover(cov, labels):
    #brg 21.11.17
    #rearrangement to a functional procedure
    Tpcover = Tkinter.Toplevel(hf)
    Tpcover.title(' cover-matrix ')
    lbcov = Tkinter.Label(Tpcover,text=" Cover-Relations ")
    lbcov.pack()
    txt3 = "\n cover-matrix  \n"
    ncc = len(labels)
    for i1 in range(0, ncc):
        txt3 += "\n" + str(labels[i1]) + ":\t"
        txt3 += "is covered by "
        for i2 in range(0, ncc):
            if i1!=i2:
                if cov[i1][i2] == 1:
                    txt3 += " " + str(labels[i2]) + " ,"
                else:
                    pass
            else:
                pass
        txt3 += "\n"    
    txt3 += "\n"
    txt3 += " -- end of list --"
    tcov=ScrolledText(Tpcover,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)
    

def show_eq():
    tpequiv = Tkinter.Toplevel(hf)
    tpequiv.title(" equivalence classes ")
    tequiv=ScrolledText(tpequiv,width=60, height=10)
    tequiv.pack()
    txteq2="Equivalence classes"+"\n"
    txteq2+=50*"="+"\n"
    txteq2+="File: "+str(fn) +"\n"
    txteq2+="equivalence classes: "+txteq
    txteq2+="\n"
    txteq2+="- - - e o f - - -"
    tequiv.insert("end",txteq2)

def HDdmnormtransp():
    # brg  19.07.18, 25.07.18
    # dm normalized and transposed
    xtr=rmod2.marray(k,r)
    xn=rmod2.matrixnorm(r,k,x)
    for i in range(0,r):
        for j in range(0,k):
            xtr[j][i]=xn[i][j]
    print "dm orig "
    rmod2.matout(r,k,xn)
    print "dm internally normalized and after that transposed"
    rmod2.matout(k,r,xtr)
    print " "
    rredtr,xredntr,attred,txttreq,neqtr=rmod2.equivcompactm2(k,r,xtr,prop,10)  # new 8.9.2014
    print "neq= ",neqtr
    print "txteq = ",txttreq
    covdmtr=HD(xredntr,rred,attred)

def HDdmtransp():
    # brg  19.07.18, 25.07.18
    # dm normalized and transposed
    xtr=rmod2.marray(k,r)
    
    for i in range(0,r):
        for j in range(0,k):
            xtr[j][i]=x[i][j]
    print "dm orig "
    rmod2.matout(r,k,x)
    print "dm transposed (without normalization of the initial dm)"
    rmod2.matout(k,r,xtr)
    print " "
    rredtr,xredtr,attred,txttreq,neqtr=rmod2.equivcompactm2(k,r,xtr,prop,10)  # new 8.9.2014
    print "neq= ",neqtr
    print "txteq = ",txttreq
    covdmtr=HD(xredtr,rred,attred)

def normalize_dm():
    # brg 18.07.18
    global xred
    entext=enormalize.get()
    try:
        if entext=="y":
            xred=rmod2.matrixnorm(rred, k,xredh)
        else:
            xred=rmod2.matcopy1(rred,k,xredh)
    except:
        xred=rmod2.matcopy1(rred,k,xredh)
    show_dmact(xred,rred,k," after preparing the actual dm")    
            
        
    

def tnorm_scalar(select,lamb,nue):
    # brg 12.08.17, 8.9.17
    # tnorm for the special case that the inputs are scalars (lamb and nue)
    # norm = -99999 in order to indicate a nonrealized t-norm
    norm=-999999
    if select==1:
        # standard norm
        norm=min(lamb,nue)
    elif select==2:
        #drastic norm
        if nue==1:
            norm=lamb
        else:
            if lamb==1:
                norm=nue
            else:
                norm=0
    elif select==3:
        # Lukasiewicz-norm, Pollandt, 17
        norm=max(0,lamb+nue-1)
    elif select==4:
        #product norm
        norm=lamb*nue
    else:
        norm=-999999
    return norm

def resid_scalar(select,lamb,mue):
    # brg 12.08.17, 21.10.17
    if select == 1:
        if lamb<=mue:
            resid=1
        else:
            resid=mue
    elif select==2:
        if lamb==1:
            resid=mue
        else:
            resid=1
    elif select==3:
        resid=min(1,1-lamb+mue)
    elif select==4:
        if lamb!=0:
            resid=1.0*mue/(1.0*lamb)
        else:
            resid=1
    else:
        resid=999999
    return resid    

def replace():
    # brg 8.7.18
    global xred
    rowact=int(eselectrow.get())
    colact=int(eselectcol.get())
    valact=float(eselectval.get())
    tpreplace=Tkinter.Toplevel(hf)
    tpreplace.title("Replace ")
    treplace=ScrolledText(tpreplace,width=60,height=10)
    treplace.pack()
    txt="Replace a value in the data matrix "+"\n"
    txt+="Until now "+str(xred[rowact][colact])+"\n"
    xred[rowact][colact]=valact
    txt+="Now:  "+str(xred[rowact][colact])+"\n"
    treplace.insert("end",txt)

def calc_tv(select,dm,obj,prop,bx1,bx2):
    # brg 7.09.17, 9.9.17
    #select: which kind of t-norm
    #dm: data matrix with n rows, m columns.
    #+++Note, if normaliation is done, then xred will be overwritten+++
    #obj=tupel with n object-labels
    #prop: tupel with attribute's labels
    #bx1 pattern of attribute subset1, bx2: pattern of attribute subset2
    n=len(obj)
    k=len(prop)
    oaa=[]
    AAderiv=[]        #AAderiv: tupel attribute-related  of bx1
    BBderiv=[]        #BBderiv: tupel attribute related of bx2
    for i in range(0,n):
        AAderiv.append(0)
        BBderiv.append(0)
        AAderiv[i]=[]
        BBderiv[i]=[]
        for j in range(0,k):
            resid1=resid_scalar(select,bx1[j],dm[i][j])
            AAderiv[i].append(resid1)
            resid2=resid_scalar(select,bx2[j],dm[i][j])
            BBderiv[i].append(resid2)
        minAA=min(AAderiv[i])
        minBB=min(BBderiv[i])
        resid=resid_scalar(select,minAA,minBB)
        oaa.append(resid)
    tv=min(oaa)
    return tv, AAderiv, BBderiv, oaa

def bx_reduction(bx1,bx2,m):
    #brg 07.09.17
    # if bx1<bx2 or bx2<bx1 then flag=1
    flag1=0
    zahl=0
    for j in range(0,m):
        if bx1[j]<=bx2[j]:
            zahl+=1
    if zahl==m:
        flag1=1
    flag2=0
    zahl=0
    for j in range(0,m):
        if bx2[j]<=bx1[j]:
            zahl+=1
    if zahl==m:
        flag2=1
    if flag1==1 or flag2==1:
        flag=1
    else:
        flag=0
    return flag    
        
def readable_bx(bx,prop,m):
    # brg 07.09.17, 09.09.17
    txthilf=""
    for j in range(0,m):
        if bx[j]==1:
            txthilf+=str(prop[j])+", "
    if txthilf=="":
        txthilf="--empty--"
    return txthilf
    

def calc_truthvalue():
    #brg 8.9.17, 9.9.17, 29.09.17, 9.10.17, 21.10.17
    global select,objset,rredhilf, dmwork
    
    try:
        filterimp=float(efilterimp.get())
    except:
        filterimp=0
    try:
        bxfilter=ebtx.get()
    except:
        bxfilter="n"
    txt="File = "+fn+"\n"
    txt+="implications filtered by "+str(round(filterimp,3))+"\n"
    
    
    objset=eobjectset.get().split(",")
    if objset[0]=="":
        objset=[]
        for obhilf in objred:
            #print "obhilf= ",obhilf
            objset.append(obhilf)
      
    dmwork=rmod2.marray(len(objset),k)
    
    if len(objset)<rred:
        zahl=0
        for ob in objset:
            iob=objred.index(ob)
            for j in range(0,k):
                dmwork[zahl][j]=xred[iob][j]
            zahl+=1
        rredhilf=len(objset)   
    else:
        dmwork=rmod2.matcopy1(rred,k,xred)
        rredhilf = rred
        
    
    show_dmact(dmwork,rredhilf,k,"used in 'calc_truthvalue'")
    txt+="\n"
    
    try:
        select=int(eselect.get())
        if select==1:
            txt+="standard-norm "+"\n"
        elif select==2:
            txt+="drastic norm "+"\n"
        elif select==3:
            txt+="Lukasiewicz-norm "+"\n"
        elif select==4:
            txt+="Product norm "+"\n"
        else:
            txt+="+++no suitable norm selected+++ "+"\n"
            txt+="standard norm will be applied   "
    except:       
        select=1
        txt+="standard norm "+"\n"
    if bxfilter=="y":
        txt+="premises only by one attribute "+"\n"
    elif bxfilter=="yy":
        txt+="premises and conclusions: only one attribute "
    else:    
        txt+="all possible attribute subsets "+"\n"
    txt+="Analyse "+"\n"
    txt+="concerning the set of objects as follows "+"\n"
    for ob in objset:
        txt+=str(ob)+", "
    txt+="\n"    
    for j1 in range(0,2**k):
        bx1=rmod2.bitrep(k,j1)
        sumbx1=sum(bx1)
        
        print "bx1= ",bx1,"  sumbx1 = ",sumbx1
        if bxfilter=="y":
            if sumbx1==1:
                for j2 in range(0,2**k):
                    bx2=rmod2.bitrep(k,j2)
                    sumbx2=sum(bx2)
                    print "bx2= ",bx2,"   sumbx2 = ",sumbx2
                    if bx1!= bx2:
                        txthilf1=readable_bx(bx1,prop,k)
                        txthilf2=readable_bx(bx2,prop,k)
                        tv, AAd,BBd,oaa=calc_tv(select,dmwork,objset,prop,bx1,bx2)
                        if tv>=filterimp:
                            txt+="\n"+txthilf1+"implies "+txthilf2+"with truth-value "+str(round(tv,3))
        elif bxfilter=="yy":
            if sumbx1==1:
                for j2 in range(0,2**k):
                    bx2=rmod2.bitrep(k,j2)
                    sumbx2=sum(bx2)
                    if sumbx2==1:
                        print "bx2= ",bx2,"   sumbx2 = ",sumbx2
                        if bx1!= bx2:
                            txthilf1=readable_bx(bx1,prop,k)
                            txthilf2=readable_bx(bx2,prop,k)
                            tv, AAd,BBd,oaa=calc_tv(select,dmwork,objset,prop,bx1,bx2)
                            if tv>=filterimp:
                                txt+="\n"+txthilf1+"implies "+txthilf2+"with truth-value "+str(round(tv,3))
                
        else:
            for j2 in range(0,2**k):
                    bx2=rmod2.bitrep(k,j2)
                    sumbx2=sum(bx2)
                    print "bx2= ",bx2,"   sumbx2 = ",sumbx2
                    if bx1!= bx2:
                        txthilf1=readable_bx(bx1,prop,k)
                        txthilf2=readable_bx(bx2,prop,k)
                        tv, AAd,BBd,oaa=calc_tv(select,dmwork,objset,prop,bx1,bx2)
                        if tv>=filterimp:
                            txt+="\n"+txthilf1+"implies "+txthilf2+"with truth-value "+str(round(tv,3))
            
    tpeval=Tkinter.Toplevel(hf)
    tpeval.title(" Result of implic-check")
    teval=ScrolledText(tpeval,width=120,height=40)
    teval.pack()
    teval.insert("end",txt)
                    
def calc_bx_sublist(prop,sublist):
    # brg 09.09.17, 29.09.17
    k=len(prop)
    bx=rmod2.vecgen1(k)
    for att in sublist:
        bx[prop.index(att)]=1
    return bx    

def show_details():
    #brg 21.10.17, 29.6.18
    global epremise,econclus
    tpdetails=Tkinter.Toplevel(hf)
    tpdetails.title(' details... ')
    fr3=Tkinter.Frame(tpdetails,bd=3,relief="sunken",bg="white")
    fr3.pack()
    lb5=Tkinter.Label(fr3,text="For a detailed analysis: Enter the subsets\n\
                                describing the premise and that describing\n the conclusion\n\
                                for example for test: q1,q2 ==> q3 you have to enter q1,q2 \n\
                                for the premise and q3 for the conclusion", bg="yellow")
    lb5.pack()
    lb6=Tkinter.Label(fr3, text="left entry: attribute's labels of the premise",bg="white")
    lb6.pack()
    lb7=Tkinter.Label(fr3,text="right entry: attribute's labels of the attributes of the conclusion ",bg="white")
    lb7.pack()
    epremise=Tkinter.Entry(fr3,width=15)
    epremise.pack(side="left")
    econclus=Tkinter.Entry(fr3,width=15)
    econclus.pack(side="right")
    fr4=Tkinter.Frame(tpdetails)
    fr4.pack()
    buttinterim=Tkinter.Button(fr4,text="Details",width=45,bg="cyan",command=interim_results)
    buttinterim.pack()
    butt_Derivations = Tkinter.Button(fr4, text=" Derivations based on dm ", bg="cyan",width=45,command=derivations)
    butt_Derivations.pack()
    lb8_29=Tkinter.Label(fr4,text=" Note only the original dm with values from [0,1]!" )
    lb8_29.pack()
                         
    butt_calc_all = Tkinter.Button(fr4,text="all attribute subsets and first and second derivations ", bg="cyan", \
                                   width=45,command=calc_all)
    butt_calc_all.pack()
    butt_HDconceptsint = Tkinter.Button(fr4,text="HD of the intents of the concepts ",bg="cyan",width=45, command=HDconcepts)
    butt_HDconceptsint.pack()
    butt_covconcepts = Tkinter.Button(fr4,text="Cover-relations of concept-lattice ",bg="cyan",width=45,command=cov_concepts)
    butt_covconcepts.pack()
    butt_showconcepts = Tkinter.Button(fr4, text="show concepts ",bg="cyan",width=45,command=show_concepts)
    butt_showconcepts.pack()
    

def interim_results():
    #brg 9.9.17, 15.9.17, 28.09.17, 29.09.17, 09.10.17
    premise=epremise.get().split(",")#Baustelle
    print "premise  ",premise
    conclus=econclus.get().split(",")
    print "conclus  ",conclus
    bx1=calc_bx_sublist(prop,premise)
    bx2=calc_bx_sublist(prop,conclus)
    txt="Concerning the set of objects as follows "+"\n"
    for ob in objset:
        txt+=str(ob)+", "
    txt+="\n"    
    show_dmact(dmwork,rredhilf,k,"used in 'interim results'")
    txt+="\n"    
    if select==1:
        txt+="standard-norm "+"\n"
    elif select==2:
        txt+="drastic norm "+"\n"
    elif select==3:
        txt+="Lukasiewicz-norm "+"\n"
    elif select==4:
        txt+="Product norm "+"\n"
    else:
        txt+="no suitable norm selected "+"\n"    
    txthilf1=readable_bx(bx1,prop,k)
    txthilf2=readable_bx(bx2,prop,k)
    tv, AAd,BBd,oaa=calc_tv(select,dmwork,objset,prop,bx1,bx2)
    txt+=2*"\n"+"check of: "+txthilf1+" implies "+txthilf2+"\n"
    txt+="AA-derivation"+"\n"
    txthilf3="   "
    for j in range(0,k):
        txthilf3+=str(prop[j])+"\t"
    txthilf3+="\n"
    txthilf3a="AA holds-relation"+"\n"
    for i in range(0, rredhilf):
        txthilf3+=str(objset[i])+": "
        for j in range(0,k):
            txthilf3+=str(round(AAd[i][j],3))+"\t"
        txthilf3+="\n"
        mAAd=min(AAd[i])
        txthilf3a+=str(objset[i])+" holds "+txthilf1+" with degree "+str(round(mAAd,3))+"\n"
    txthilf3a+="\n"    
    txt+="\n"+txthilf3+"\n"
    txt+="BB-derivation "+"\n"
    txthilf4="   "
    for j in range(0,k):
        txthilf4+=str(prop[j])+"\t"
    txthilf4+="\n"
    txthilf4a="BB holds-relation "+"\n"
    for i in range(0, rredhilf):
        txthilf4+=str(objset[i])+": "
        for j in range(0,k):
            txthilf4+=str(round(BBd[i][j],3))+"\t"
        txthilf4+="\n"
        mBBd=min(BBd[i])
        txthilf4a+=str(objset[i])+" holds "+txthilf2+" with degree "+str(round(mBBd,3))+"\n"
        
    txt+="\n"+txthilf4+"\n"
    txt+=txthilf3a+"\n"
    txt+=txthilf4a+"\n"
    txthilf5="Tuple of residua of AA and BB.... "+"\n"
    txthilf5+="...from which the infimum is to be taken "+"\n"
    for i1 in range(0,rredhilf):
        txthilf5+=str(objset[i1])+": "+str(round(oaa[i1],3))+"\n"
    txthilf5+="\n"
    txt+=txthilf5+"\n"
    txthilf6=readable_bx(bx1,prop,k)
    txthilf7=readable_bx(bx2,prop,k)
    txt+=txthilf6+"implies "+txthilf7+"\n"
    txt+="truth-value = "+str(round(tv,3))+"\n"
    tpdetails=Tkinter.Toplevel(hf)
    tpdetails.title("details ")
    tdetails=ScrolledText(tpdetails,width=120,height=40)
    tdetails.pack()
    tdetails.insert("end",txt)

def derivations():
    #brg 20.10.17
    global eAA,tderiv, ewant
    tpderiv=Tkinter.Toplevel(hf)
    tpderiv.title(' Derivations ')
    lbd1=Tkinter.Label(tpderiv,text="Enter a tuple of length "+str(k)+"  to define an attribute subset ")
    lbd1.pack()
    eAA=Tkinter.Entry(tpderiv,width=10)
    eAA.pack()
    lbd2=Tkinter.Label(tpderiv,text="1st and 2nd derivation based on all repr. objects")
    lbd2.pack()
    lbd3=Tkinter.Label(tpderiv,text="use of the original (normalized) dm ?  (y,n)")
    lbd3.pack()
    ewant=Tkinter.Entry(tpderiv,width=2)
    ewant.pack()
    butt1deriv=Tkinter.Button(tpderiv,text="calculate derivations ",bg="yellow",width=50,command=deriv1)
    butt1deriv.pack()
    tderiv=ScrolledText(tpderiv,width=120, height=20)
    tderiv.pack()

def deriv_basis(select,bra,ket):
    # 20.10.17
    nbra=len(bra)
    nket=len(ket)
    residvec=[]
    if nbra!=nket:
        print "dimensions of bra and ket are not ok...!"
        resid=999999
        for i in range(0,nbra):
            residvec.append(resid)
    else:    
        for i in range(0,nbra):
            #print "bra ",i," = ",bra[i],"   ket ",i,"   = ",ket[i]
            resid=resid_scalar(select, bra[i],ket[i])
            residvec.append(resid)
    infrv=min(residvec)
    return residvec, infrv


def deriv1():
    #brg 20.10.17, 21.10.17, 29.6.18
    global bra, ket, bra2, ket2, txtder, xredn,want
    bra=eAA.get().split(",")
    nbra=len(bra)
    want=ewant.get()
    print "want (as input) ",want
    print "rred = ",rred
    # want = 'y' then the original xred is expected  29.6.18
    if want=="" or want=="n" or want=="n ":
        want="n"
    else:
        want="y"
    print "want=  ",want    
    txtder=" "
    if want=="y":
        print "xred= "
        rmod2.matout(rred,k,xred)
        print "  "
        dmwork = rmod2.marray(rred, k)
        rredhilf = rred
        print "want = 'y' "
        
        print " "
        print "rredhilf in deriv1 = ",rredhilf
        for i in range(0,rred):       #new: 29.6.18
            for j in range(0, k):
                dmwork[i][j] = xred[i][j]
        rredhilf= rred        
        print "dmwork= "
        rmod2.matout(rredhilf,k,dmwork)    
        txtder+="Applied data matrix "+"\n"
        show_dmact(dmwork,rredhilf,k,"used in 'deriv1'")
        txtder+="\n"
        txtder+="transposed matrix "+"\n"
        for j in range(0,k):
            for i in range(0,rredhilf):
                txtder+=str(round(dmwork[i][j],2))+"\t"
            txtder+="\n"
        txtder+="\n"    
    else:
        rredhilf = len(objset)
        dmwork=rmod2.marray(rredhilf,k)
        #The dmwork is given by the object subset "
        zahl=0
        for ob in objset:
            iob=objred.index(ob)
            for j in range(0,k):
                dmwork[zahl][j]=xred[iob][j]
            zahl+=1
        print "actually used dmwork "
        rmod2.matout(rredhilf,k,dmwork)
        print " "
        
    bra2=[]
   
    for i in range(0,nbra):
        bra[i]=float(bra[i])    #is the input, for exampe 0,1,0,0
    print "1. Ableitung "
    print "bra= ",bra
    print "nbra = ",nbra
    
    for i in range(0, rredhilf):
        ket=rmod2.vecgen1(k)
        for j in range(0,k):
            ket[j]=dmwork[i][j]
        print "i= ",i
        print "bra= ",bra
        print "ket = ",ket
        residvector,ifv=deriv_basis(select,bra,ket)
        bra2.append(ifv)
        print "residvector ",residvector
        # ifv is the minimal value found in residvector
        # the residvector is calculated for each object of the selected set
        print "ifv= ",ifv
    print "bra2= (tuple of ifv) "
    rmod2.vecout(rredhilf,bra2)
    print " "
    txtder+="\n"
    txtder+="input:"+"\n"
    txtder+=100*"="+"\n"
    for i in range(0,nbra):
        txtder+=str(bra[i])+", "
    txtder+="\n"
    txthilf=""
    if select==1:
        txthilf="standard norm "
    elif select==2:
        txthilf="drastic norm "
    elif select==3:
        txthilf="Lukasiewicz norm "
    elif select==4:
        txthilf="product norm "
    else:
        txthilf="???????????? "
    txtder+="1st derivation based on t-norm of type "+txthilf+"\n"
    for i in range(0, rredhilf):
        txtder+=str(round(bra2[i],2))+", "
    txtder+="\n"
    deriv2()
    

def deriv2():
    #brg 20.10.17, 21.10.17, 29.06.18
    global bratest, txtder
    print "objset = ",objset
    if want=="y":
        print "xred= "
        rmod2.matout(rred,k,xred)
        print "  "
        dmwork = rmod2.marray(rred, k)
        rredhilf = rred
        print "want = 'y' "
        
        print " "
        print "rredhilf in deriv1 = ",rredhilf
        for i in range(0,rred):       #new: 29.6.18
            for j in range(0, k):
                dmwork[i][j] = xred[i][j]
        rredhilf= rred        
        print "dmwork= "
        rmod2.matout(rredhilf,k,dmwork)    
        txtder+="Applied data matrix "+"\n"
        show_dmact(dmwork,rredhilf, k,"used in 'deriv2'")
        txtder+="\n"
        txtder+="transposed matrix "+"\n"
        for j in range(0,k):
            for i in range(0,rredhilf):
                txtder+=str(round(dmwork[i][j],2))+"\t"
            txtder+="\n"
        txtder+="\n"    
    else:
        rredhilf = len(objset)
        dmwork=rmod2.marray(rredhilf,k)
        #The dmwork is given by the object subset "
        zahl=0
        for ob in objset:
            iob=objred.index(ob)
            for j in range(0,k):
                dmwork[zahl][j]=xred[iob][j]
            zahl+=1
        print "actually used dmwork "
        rmod2.matout(rredhilf,k,dmwork)
        print " "

        
    
    bratest=[]
    for j in range(0,k):
        ket2=rmod2.vecgen1(rredhilf)
        for i in range(0,rredhilf):
            ket2[i]=dmwork[i][j]
        residvector2,ifv2=deriv_basis(select,bra2,ket2)
        bratest.append(ifv2)        
    txtder+="2nd derivation based on dm and the input"+"\n"
    for i in range(0, len(bratest)):
        txtder+=str(round(bratest[i],3))+", "
    txtder+="\n"    
    tderiv.insert("end",txtder)
    
def calc_deriv_basis(select,bra,ket):
    # 20.10.17, 20.11.17, 21.11.17
    # bra can be A, or dA1
    # ket depends whether or not A or dA1 is the input
    nbra=len(bra)
    nket=len(ket)
    residvec=[]
    if nbra!=nket:
        print "dimensions of bra and ket are not ok...!"
        resid=999999
        for i in range(0,nbra):
            residvec.append(resid)
    else:    
        for i in range(0,nbra):
            resid=resid_scalar(select, bra[i],ket[i])   #bra-ket
            residvec.append(resid)
    infrv=min(residvec)
    return residvec, infrv


def calc_deriv1(select, A, dmwork, rredhilf, k):
    #brg 20.10.17, 21.10.17, 20.11.17, 29.06.18
    # A crisp attribute subset, expressed in terms of a 0,1-tuple
    # dA1 its first derivative
    nA=len(A)
    dA1=[]
    print "rredhilf = ", rredhilf
    # problem: When a subset of objects is selected rredhild should be the count of
    # the elements of the subset. Obviously however rredhilf is the original length of the complete o
    # of the complete object set!!
    print "k = ",k
    print "A = ",A
    print "dmwork = "
    print dmwork
    print " "
    for i in range(0,nA):
        A[i]=float(A[i])   #bra from which a bra-ket will be generated
    ket = rmod2.vecgen1(k)    
    for i in range(0, rredhilf):
        for j in range(0,k):
            ket[j]=dmwork[i][j]
        residvector,ifv=calc_deriv_basis(select,A,ket)
        dA1.append(ifv)
        # dA1, a tuple of numbers of [0,1] for each object
    return dA1
    
    

def calc_deriv2(select, dA1, dmwork, rredhilf, k):
    #brg 20.10.17, 21.10.17, 21.11.17
    #A crisp subset of attributes
    #dA2 second derivative of the crisp attribute subset A
    dA2=[]
    for j in range(0,k):
        ket2=rmod2.vecgen1(rredhilf)
        for i in range(0,rredhilf):
            ket2[i]=dmwork[i][j]
        residvector2,ifv2=calc_deriv_basis(select,dA1,ket2)
        dA2.append(ifv2)        
    return dA2
        
def calc_all():
    # brg 21.11.17, 22.11.17, 29.06.18
    global dm_AA, dm_AX, concept_label, txtconcept, candPremise, candConclusio, txtimplication
    candPremise = []
    candConclusio = []
    dm_AA=[]   #concept: intent (attributes)
    concept_label=[]
    dm_AX=[]    #concept: extent (object set fuzzy)
    countconcept=1
    txtconcept = "Infos concerning the concepts of "+str(fn)+"\n"
    for j1 in range(0,2**k):
        bx1=rmod2.bitrep(k,j1)  #==A
        sumbx=sum(bx1)
        txtconcept+= "\n"
        bra2=calc_deriv1(select, bx1, xred, rred, k)  #dmwork replaced by xred
        print "1. deriv: "
        for i in range(0,len(bra2)):
            print round(bra2[i],1),
        print " "    
        bra_deriv2=calc_deriv2(select, bra2, xred, rred, k)
        print "2. deriv "
        for i in range(0, len(bra_deriv2)):
            print round(bra_deriv2[i],1),
        print " "
        conceptint,conceptext,flag=calc_equality(bx1,bra2,bra_deriv2)
        if flag == 0:
            candPremise.append(bx1)
            candConclusio.append(bra_deriv2)
        if conceptint!=None:
            dm_AA.append(conceptint)
            print "j1= ",j1,"   conceptint= ",conceptint
            concept_label.append(countconcept)   #preliminary : later the attributlabels
            dm_AX.append(conceptext)
            txtconcept+= "concept No "+str(countconcept)+"  : 0. deriv "+"\n"
            txthilf=readable_bx(bx1,prop,k)
            txtconcept+=txthilf+"\n"
            txtconcept+="Intent of concept No "+str(countconcept)+":"
            txthilf1=""
            for i in range(0, len(conceptint)):
                txthilf1+=str(conceptint[i])+", "
            txtconcept+="  "+txthilf1+"\n"    
            txtconcept+="Extend of concept No "+str(countconcept)+":"
            txthilf2=""
            for i in range(0, len(conceptext)):
                txthilf2+=str(round(conceptext[i],1))+", "
            txtconcept+="  "+txthilf2+"\n"
            countconcept+=1
            txtconcept+=60*"="+"\n"
    print "Intents"
    rmod2.matout(len(dm_AA),k,dm_AA)
    print "extents "
    rmod2.matout(len(dm_AX),rred,dm_AX)
    print " "
    print "candPremise "
    ncp = len(candPremise)
    rmod2.matout(len(candPremise),k,candPremise)
    print " "
    print "candConclusio (length must be the same as ncp"
    rmod2.matout(len(candConclusio),k,candConclusio)
    #Implication pretty formally: candPremise ==> candConclusio-candPremise
    conclusio=[]
    txtimplication="List of implications "+"\n"
    for i in range(0,ncp):
        conclusio.append(0)
        conclusio[i]=[]
        txthilfc1=""
        for j in range(0, k):
            txthilfc1+=str(candPremise[i][j])+", "
        txtimplication+=txthilfc1+"  ==>  "    
        txthilfc2=""
        for j in range(0,k):
            conclusio[i].append(candConclusio[i][j]-candPremise[i][j])
            txthilfc2+=str(round(conclusio[i][j],1))+", "
        txtimplication+=txthilfc2+"\n"
    
def calc_equality(A,dA1,dA2):
    # brg 21.11.17, 22.11.17
    nA=len(A)
    nA1=len(dA1)
    flag = 1
    count=0
    for i in range(0,nA):
        if A[i]==dA2[i]:
            count+=1
    if count==nA:
        txt=""
        vec_concept_intent=[]
        for i in range(0,nA):
            vec_concept_intent.append(A[i])
        vec_concept_extent=[]
        for i in range(0,nA1):
            vec_concept_extent.append(dA1[i])
    else:
        flag = 0
        vec_concept_intent=None
        vec_concept_extent=None
    return vec_concept_intent,vec_concept_extent, flag    
         
def HDconcepts():
    #brg 21.11.17
    global covconcepts, concept_label
    covconcepts = HD(dm_AA, k, concept_label)

def HDconceptsext():
    #brg 21.11.17
    global covconcepts, concept_label
    covconceptsext = HD(dm_AX, k, concept_label)

def cov_concepts():
    #brg 21.11.17
    calc_cover(covconcepts, concept_label)
    
def show_concepts():
    #brg 21.11.17, 22.11.17
    Tpconcepts=Tkinter.Toplevel(hf)
    Tpconcepts.title("Details zu concepts ")
    tconcept=ScrolledText(Tpconcepts,width=120, height=20)
    tconcept.pack()
    tconcept.insert("end",txtconcept)
    timplic=ScrolledText(Tpconcepts,width=120, height=20)
    timplic.pack()
    timplic.insert("end",txtimplication)

## Tkinter Plot
hf = Tkinter.Tk()
hf.title(' L_eval ')
aboutHDsimpl=raioop2.brgabout(hf,"tp1","about_L_eval.txt",20,\
            "Juli, the 25th, 2018"," about L_eval ", "white", "t1",80,5,ScrolledText)
helpHDsimpl=raioop2.brgabout(hf,"tp1","help_L_eval.txt",20,\
            "Juli, the 25th, 2018"," help_L_eval ", "white", "t1",80,5,ScrolledText)
    
fr = Tkinter.Frame(hf, width=60)
fr.pack()
frinput1 = Tkinter.Frame(fr, width=100, height=10)
frinput1.pack()
text = "Select first the file, then decide in which format to be opened "
lbinput1 = Tkinter.Label(frinput1,
                         text=text)
lbinput1.pack()
butt1 = Tkinter.Button(frinput1, text="Select filename  ",
                       bg="white", width=45,command=xselectfile)
butt1.pack()
                      
lbopen1 = Tkinter.Label(fr, text="")
lbopen1.pack()
buttshow_datamatrix = Tkinter.Button(fr,text="Show orig. data matrix (dm)",\
                                     bg="cyan",width=45, command=show_dm)
buttshow_datamatrix.pack()
buttHDdm = Tkinter.Button(fr, text='Draw HDdm (mandatory)', width=45, bg="cyan", command=HDdm)
buttHDdm.pack()
buttcovdm = Tkinter.Button(fr, text='Cover relation of HDdm ', width=45, bg="cyan", command=covdm)
buttcovdm.pack()
butteq = Tkinter.Button(fr, text=' Check equivalence relation of dm ',width=45, bg="cyan",command=show_eq)
butteq.pack()
lb1 = Tkinter.Label(fr,text=" ", width=50)
lb1.pack()
lbtr=Tkinter.Label(fr,text="HD of transposed dm:  ")
lbtr.pack()
buttHDdmtransposed = Tkinter.Button(fr,text="HD of data matrix transposed ",width=45,bg="cyan", command=HDdmtransp)
buttHDdmtransposed.pack()
lbtr2=Tkinter.Label(fr,text="HD of transposed (normalized) dm:  ")
lbtr2.pack()
buttHDdmnormtransposed = Tkinter.Button(fr,text="HD of (norm.) data matrix transp. ",width=45,bg="cyan", command=HDdmnormtransp)
buttHDdmnormtransposed.pack()
tpfr2=Tkinter.Toplevel(hf)
tpfr2.title("L_eval: Details ")
fr2=Tkinter.Frame(tpfr2,bd=3,relief="sunken")
fr2.pack()
lb2=Tkinter.Label(fr2,text="normalize the dm (y,n) (default: 'n') ")
lb2.pack()
enormalize=Tkinter.Entry(fr2,width=3)
enormalize.pack()
enbutt=Tkinter.Button(fr2,text="Preparing the final data matrix ", width=45, bg="cyan", command=normalize_dm)
enbutt.pack()
lb3=Tkinter.Label(fr2,text="Select t-norm (1,2,3,4) ")
lb3.pack()
eselect=Tkinter.Entry(fr2,width=5)
eselect.pack()
lb3a=Tkinter.Label(fr2,text="Only implications with truth-value>=selected filter")
lb3a.pack()
lb3c=Tkinter.Label(fr2, text="Enter value for your filter (0: default)")
lb3c.pack()
efilterimp=Tkinter.Entry(fr2,width=5)
efilterimp.pack()
lb4=Tkinter.Label(fr2,text="y: Only premises built by one attribute?\n\
                  yy: premises  a n d  conclusions: singletons\n\
                  n:(default)) all possible attribute subsets")
lb4.pack()
ebtx=Tkinter.Entry(fr2,width=5)
ebtx.pack()
lb5=Tkinter.Label(fr2,text="select row, select col, select value ")
lb5.pack()
frdata=Tkinter.Frame(fr2,bd=3,relief="sunken")
frdata.pack()
eselectrow=Tkinter.Entry(frdata,width=5)
eselectrow.grid(row=1,column=5)
eselectcol=Tkinter.Entry(frdata,width=5)
eselectcol.grid(row=1,column=10)
eselectval=Tkinter.Entry(frdata,width=5)
eselectval.grid(row=1,column=15)
buttreplace=Tkinter.Button(fr2,text="Replace the value of the dm ",bg="cyan", width=45, command=replace)
buttreplace.pack()
lb6=Tkinter.Label(fr2,text="Enter the objects of interest \
            \ndefault: all representative elements ")
lb6.pack()
eobjectset=Tkinter.Entry(fr2,width=30)
eobjectset.pack()

buttcalc=Tkinter.Button(fr2,text=" calculation of truth-values ",bg="cyan",\
                        width=45,bd=5,command=calc_truthvalue)
buttcalc.pack()
#buttdetails=Tkinter.Button(fr,text="Concept analysis ",width=45,bg="cyan",command=show_details)
#buttdetails.pack()

buttexit = Tkinter.Button(fr, text='exit', bg='red',
                          width=45, command=hf.destroy)
buttexit.pack(pady=10)

hf.mainloop()
