import raioop2
import rmod2
import Tkinter
from ScrolledText import ScrolledText

# brg 23.4.2013, 27.4.2013

def distancevector(x1,x2):
    lx=len(x1)
    lx2=len(x2)
    if lx!=lx2:
        dist=99999
        return dist
    else:
        sumx=0
        for i in range(0,lx):
            sumx+=(x1[i]-x2[i])**2
        dist=sumx
        return dist



def MarkovChain1(r,MCT,x,eps,safety):
    # brg 27.4.2013
    # MCT is a matrix, a stochastic matrix expressing state-change probabilities
    # r: number of rows/columns of this square matrix
    # x is a uniform distribution vector of r components
    # eps = 0.0001 recommended. The distance between initial and
    # ........... final x should be < eps
    # safety: As there is an iteration in a while loop one may stop after
    # ........'safety' cycles
    
    
    # first step: Transposition

    MCTT=rmod2.mattransp(r,r,MCT)

    
    zahl=0
    dist=3
    while dist>eps:
        xnew=rmod2.matvecmult(r,r,MCTT,x)
        dist=distancevector(x,xnew)
        
        for i in range(0,r):
            x[i]=xnew[i]
        zahl+=1
        if zahl>safety:
            break
       
    return x,zahl

def submit_number_of_tau():
    # brg 28.4.2013
    global k
    try:
        k=int(ek.get())# number  auf top-lists
    except:
        k=2   #default
        
def submit_tau():
    # brg 28.4.2013
    global k,etau
    tptau=Tkinter.Toplevel(hf)
    tptau.title(' Entry boxes for tau ')
    etau=rmod2.vecgen1(k)
    lbtau=Tkinter.Label(tptau,text="list of  d e creasing order of objects ")
    lbtau.pack()
    #tau[0]=["a","d"]            #meaning: a > d
    #tau[1]=["b","a","d"]        #meaning b>a, b>c, a>c 
    #tau[2]=["a","b","e","c","d"] #meaning a>b, a>c, ...,b>e, b>c,...,c>d
    #tau[3]=["a","g","c","d"]   # analog
    #tau[4]=["a","c","f","b","e","d"] #a>c, ... a>f,..a>d, c>f,...
    for i in range(0,k):
        etau[i]=Tkinter.Entry(tptau,width=20)
        etau[i].pack()
        
def calc():
    # brg 28.4.2013
    global k, Uvec, x_act, MCT,lU,tau
    # user enty
    
    tau=rmod2.vecgen1(k)
    for i in range(0,k):
        tau[i]=etau[i].get().split(",")
        print tau[i]


    #sets and preliminaries
    tauset=rmod2.vecgen1(k)
    for i in range(0,k):
         tauset[i]=set([])

    for i in range(0,k):
        hilf=set([])
        lt=len(tau[i])
        for j in range(0,lt):
            hilf.add(tau[i][j])
        
        tauset[i]=hilf
        print "tauset ",i," = ",tauset[i]


    U=set([])
    for i in range(0,k):
        lt=len(tau[i])
        for j in range(0,lt):
            U.add(tau[i][j])

    print "set U = ",U


    lU=len(U)
    print "length U = ",lU
    Uvec=rmod2.vecgen1(lU)
    z=0
    for el in U:
        Uvec[z]=el
        z+=1

    print "Uvec= ",Uvec    

    # the calculation        
    nMarkov=rmod2.marray(lU,lU)
    rMarkov=rmod2.marray(lU,lU)
    Markov=rmod2.marray(lU,lU)
    sumMCT=rmod2.vecgen1(lU)
    x=rmod2.vecgen1(lU)

    for i1 in range(0,lU):
        for i2 in range(0,lU):
            if i1==i2:
                pass
            else:
                for i in range(0,k):
                    if Uvec[i1] in tau[i] and Uvec[i2] in tau[i]:
                        nMarkov[i1][i2]+=1
                        iel1=tau[i].index(Uvec[i1])
                        iel2=tau[i].index(Uvec[i2])
                        if iel1<iel2:
                            rMarkov[i1][i2]+=1
                    else:
                        nMarkov[i1][i2]+=0
                        rMarkov[i1][i2]+=0
            if nMarkov[i1][i2]!=0:
                Markov[i1][i2]=1.0*rMarkov[i1][i2]/(1.0*nMarkov[i1][i2])
            else:
                Markov[i1][i2]=0.5

    print "nMarkov"        
    rmod2.matout(lU,lU,nMarkov)
    print "rMarkov"
    rmod2.matout(lU,lU,rMarkov)
    print "Markov"
    rmod2.matout(lU,lU,Markov)
                    

    MCT=rmod2.marray(lU,lU)

    for i1 in range(0,lU):
        for i2 in range(0,lU):
            if i1!=i2:
                MCT[i1][i2]=1.0*Markov[i1][i2]/(1.0*lU)
                sumMCT[i1]+=MCT[i1][i2]
            else:
                pass
            
    for i1 in range(0,lU):
        for i2 in range(0,lU):
            if i1==i2:
                MCT[i1][i2]=1.0-sumMCT[i1]
            else:
                pass

    delta=0.17
    for i1 in range(0,lU):
        for i2 in range(0,lU):
            MCT[i1][i2]=MCT[i1][i2]*(1-delta)+1.0*delta/(1.0*lU)


    print "MCT ergodic "
    rmod2.matout(lU,lU,MCT)

    for i in range(0,lU):
        x[i]=1.0/(1.0*lU)

    print "x eingabe "
    for i in range(0,lU):
        print round(x[i],2)," ",
    print " "

    x_act,z_act=MarkovChain1(lU,MCT,x,0.0001,1000)


    print z_act
    for i in range(0,lU):
        print Uvec[i],"   ",
    print " "    
    print "resulting x "
    for i in range(0,lU):
        print round(x_act[i],2)," ",  #1-x describes the final ranking
    print " "    


def view_results():
    # brg 28.4.2013
    global k,lU
    import copy
    tpresults=Tkinter.Toplevel(hf)
    tpresults.title('results ')
    tresults=ScrolledText(tpresults,width=80, height=10)
    tresults.pack()
    txt=" Markov Chain Rank aggregation of tau-lists "+"\n"
    txt+=60*"="+"\n"
    txt+="a) Inputs "+"\n"
    for i in range(0,k):
        txt+="tau["+str(i)+"]:"
        for j in range (0,len(tau[i])):
            txt+=str(tau[i][j])+ "> "
        txt+="\n"
    txt+="\n"
    txt+="b) Final vector of objects "+"\n"
    txt+="\t"
    for i in range(0,lU):
        txt+=str(Uvec[i])+", "
    txt+="\n"    
    txt+="\nc) Markov-matrix (ergodic) "+"\n"
    txt+="      "
    for i in range(0,lU):
        txt+=str(Uvec[i])+",       "
    txt+="\n"    
    for i1 in range(0,lU):
        txt+=str(Uvec[i1])+"  "
        for i2 in range(0,lU):
            txt+="   "+str(round(MCT[i1][i2],2))+", "
        txt+="\n"
    txt+="\nd) Result: stationary distribution (serve as ranking scores)"+"\n"
    rankx=rmod2.vecgen1(lU)
    txt+="\t"
    for i in range(0,lU):
        rankx[i]= 1.0-x_act[i]
        txt+=str(Uvec[i])+", "

    txt+="\n\t"
    for i in range(0,lU):
        txt+=str(round(rankx[i],2))+", "
    txt+=2*"\n"
    txt+="e) objects sorted "+"\n"
    ranky=copy.copy(rankx)
    rk_act,n_act=rmod2.raisort(lU,rankx)
    txt+="\t"
    for i3 in range(lU-1,-1,-1):
        txt+=str(i3+1)+": "+str(Uvec[n_act[i3]])+"  "
    txt+="\n"
    txt+=" - - -   e o  f - - -   "
    tresults.insert("end",txt)    
        
    
hf=Tkinter.Tk()
# brg 28.4.2013
hf.title(' Rank aggregation / Markov Chain ')
aboutMarkov=raioop2.brgabout(hf,"tp1","about_markov.txt",4,\
            "April, 28th,2013"," about markov ", "white", "t1",80,5,ScrolledText)
helpMarkov=raioop2.brgabout(hf,"tp1","help_markov.txt",4,\
            "April, 28th, 2013"," help_prob_max", "white", "t1",80,5,ScrolledText)
ek=Tkinter.Entry(hf,width=3)
ek.pack()
buttsubmitk=Tkinter.Button(hf,text="how many tau-lists ",bg="cyan",width=30,command=submit_number_of_tau)
buttsubmitk.pack()
buttsubmittau=Tkinter.Button(hf,text="Enter objects decreasing ",bg="cyan",width=30,command=submit_tau)
buttsubmittau.pack()
buttcalc=Tkinter.Button(hf,text="Calculation  ",width=30,bg="cyan",command=calc)
buttcalc.pack(pady=5)
buttview=Tkinter.Button(hf,text="View the results ",bg="cyan",width=30,command=view_results)
buttview.pack(pady=5)
buttexit=Tkinter.Button(hf,text="  Exit ",bg="red",width=30,command=hf.destroy)
buttexit.pack(pady=10)
hf.mainloop()

        
