import Tkinter
import rmod2
import raioop2
from ScrolledText import *
import tkFileDialog
import stats
import pstat

import Canvas
import os
from math import *

#brg 10.10.18
# normalization of a dm by (x-xmin)/(xmax-xmin), leading to dmn
# alternative normalization by mean and standard deviation. Statistically robust.




def fileselect():
    """ File selection and opening by Tkinter-Standards"""
    #*13.1.08
    #akt: 13.1.08, 28.5.09, 12.1.2015, 4.10.18
    #note: Taken from antag
    #source:-
    #tp=Tkinter.Toplevel(hf)   #18.2.08
    global fn,k,r,dm,pro,ob,obj, prop
    fn=tkFileDialog.askopenfilename()
    
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    prop=rmod2.vecgentext1(k)
    obj=rmod2.vecgentext1(r)     #changed to ...text1: 8.5.08
    for i in range(0,k):
        prop[i]=pro[i+1]
    for i in range(0,r):
        obj[i]=ob[i+1]
    lbopen1.config(bg="yellow")
    lbopen1["text"]="selected initial file : "+fn+"\n"+str(r)+" rows\n"+str(k)+" columns"
    

def showDM():
    """ New routine : shows the data matrix """
    #Brg 13.1.08, 4.10.18
    global mindm,maxdm
    tp2=Tkinter.Toplevel(hf)
    tp2.title(' show DM ')
    lbtp2=Tkinter.Label(tp2,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=20)
    tfile.pack()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+ob[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+pro[j+1]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=pro[j+1]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=ob[i+1]+"\t"
        for j in range(0,k):
            txt3+=str(round(dm[i][j],3))+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)
                      

def normalizedm():
    # brg 04.10.18
    global dmn
    dmn = rmod2.matrixnorm(r,k,dm)
    lbnorm.config(text="!!Normalization done!!",bg="yellow")

def robustnormalize():
    #brg 10.10.18
    global dmn
    dmn=rmod2.marray(r,k)
    for j in range(0,k):
        print prop[j]
        x=[]
        for i in range(0,r):
            x.append(dm[i][j])
        print "x= "
        rmod2.vecout(len(x),x)
        n,mm,m,sd,sk,kurt=pstat.ldescribe(x)
        print "n= ",n,"   m= ",m,"   sd= ",sd
        y= []
        for elem in x:
            y.append((1.0*elem-1.0*m)/(1.0*sd))
            limit_u = -3
            limit_o = 3
        z = []
        for elem in y:
            if elem<limit_u:
                z.append(0)
            elif elem > limit_o:
                z.append(1)
            else:
                z.append((1.0*elem+3.0)/6.0)
        for i in range(0, r):
            dmn[i][j]=z[i]
    rmod2.matout(r,k,dmn)        
    return dmn       

    
    
def showdms():
    """ New routine : shows the data matrix """
    #Brg 13.1.08
    tp3=Tkinter.Toplevel(hf)
    tp3.title(' show discret.DM ')
    lbtp2=Tkinter.Label(tp3,text=" Normalized data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp3,width=60,height=20)
    tfile.pack()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+ob[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+pro[j+1]+",\t"
    txt2+="\n"
    txt3="\n normalized data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=pro[j+1]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=ob[i+1]+"\t"
        for j in range(0,k):
            txt3+=str(round(dmn[i][j],3))+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)

def HD():
    # brg 26.7.2013, 29.8.2013, 2.11.16, 31.07.18, 1.8.18
    
    global x,la,ls,cov, rred, objred, txtlevel,sumlevtotal,countlevel
    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,dmn,obj,10)
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
        #
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    if rred<20:        
        rmod2.matout(rred,rred,zeta)
    else:
        print "only the first twenty rows of the zeta matrix "
        for i1 in range(0,rred):
            for i2 in range(0,20):
                print zeta[i1][i2],
            print " "
    print " "        
    Utotal = rmod2.incompzeta(rred,zeta)
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
    print "lobj = "
    sumlevtotal = []
    countlevel=[]
    txtlevel="Level "+"\n"
    for j in range(0,len(lobj)):
        if sum(lobj[j])>=0:
            txtlevel+="Level "+str(j)+": "
            sumlevel=0
            count=0
            for j2 in range(0, len(lobj[j])):
                if lobj[j][j2]!=-1:
                    count+=1
                    txtlevel+=str(objred[lobj[j][j2]])+", "
                    for j3 in range(0,k):
                        sumlevel+=xred[lobj[j][j2]][j3]
            sumlevtotal.append(sumlevel)
            countlevel.append(count)
            print " "
            txtlevel+="\n"
    print "sumlevtotal = ",sumlevtotal
    print "count of level = ",countlevel
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    if rred>400:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram , Utotal =  "+str(Utotal))
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()
        buttcov=Tkinter.Button(freq, text = "cover - relation ",width = 20, command = cover)
        buttcov.pack()
        buttequiv = Tkinter.Button(freq,text="show equivalence classes", width = 30,command = showeq)
        buttequiv.pack()
        

def cover():
    hfcover = Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    lbcov = Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbcov.pack()
    txt3 = "\n cover-matrix  \n"
    for i in range(0, rred):
        txt3 += "\n" + objred[i] + ":\t"
        txt3 += "is covered by "
        for j in range(0, rred):
            if i!=j:
                if cov[i][j] == 1:
                    txt3 += " " + objred[j] + " ,"
                else:
                    pass
            else:
                pass
        txt3 += "\n"    
    txt3 += "\n"
    txt3 += " -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)
    

def showeq():
    tpequiv = Tkinter.Toplevel(hf)
    tpequiv.title(" equivalence classes ")
    tequiv=ScrolledText(tpequiv,width=60, height=10)
    tequiv.pack()
    txteq2="Equivalence classes"+"\n"
    txteq2+=50*"="+"\n"
    txteq2+="File: "+str(fn) +"\n"
    txteq2+="equivalence classes: "+txteq
    txteq2+="\n"
    txteq2+="- - - e o f - - -"
    tequiv.insert("end",txteq2)
    


def savefile():
    # brg 4.8.2016, 4.11.2016
                      
    txt=""
    fn=tkFileDialog.asksaveasfilename(parent=hf,title="save file in Standard format")
    f1=open(fn,"w")
    txt+="path+filename="+fn+"\n"
    f1.write("dummy"+"\t")
    txt+=str(k)+"  columns"+"\n"
    for j in range(0,k):
        f1.write(str(prop[j])+"\t")
    f1.write("\n")
    txt+=str(r)+"  rows"+"\n"
    for i in range(0,r):
        f1.write(str(obj[i])+"\t")
        for j in range(0, k):
            f1.write(str(dmn[i][j])+"\t")
        f1.write("\n")
    f1.close()
    txt+="successfully saved "
    lbsuccess2.config(text=txt,bg="yellow")


hf=Tkinter.Tk()
hf.title('--    normalization of a dm   -- ')
                      


aboutmainHD=raioop2.brgabout(hf,"tp1","about_normaliz.txt",3,\
            "October, 10th,2018"," about normaliz ", "white", "t1",80,5,ScrolledText)
helpmainHD=raioop2.brgabout(hf,"tp1","help_normaliz.txt",3,\
            "October 10th,2018"," help_normaliz ", "white", "t1",80,5,ScrolledText)
    

fr1=Tkinter.Frame(hf,width=60)   #about, help, fn, lbopen1
fr1.pack()

Buttfn=Tkinter.Button(fr1,text="select file",width=35,bg="cyan",command=fileselect)
Buttfn.pack(pady=5)
lbopen1=Tkinter.Label(fr1,text="")
lbopen1.pack()
Buttshow=Tkinter.Button(fr1,text="show data matrix",width=35,command=showDM)
Buttshow.pack(pady=5)
buttnormalize = Tkinter.Button(fr1,text="columnwise [0,1]-normaliz dm", width=35, bg="cyan", command=normalizedm)
buttnormalize.pack()
buttrobust = Tkinter.Button(fr1,text="Robust normalization (data in [0,1] ",width=35, bg="cyan", command=robustnormalize)
buttrobust.pack()
lbnorm=Tkinter.Label(fr1,text="")
lbnorm.pack()
                      
                      
buttshowdms=Tkinter.Button(fr1,text="show normalized matrix ",width=35,bg="cyan",command=showdms)
buttshowdms.pack()
buttHD=Tkinter.Button(fr1,text="Hasse diagram (HD) ", width=35, bg="cyan", command=HD)
buttHD.pack()
ButtsaveStandard=Tkinter.Button(hf, text="Save normalized data matrix \n(Excel-analog.format)",width=35,bg="white",bd=5,command=savefile)
ButtsaveStandard.pack()
lbsuccess2=Tkinter.Label(hf,text="")
lbsuccess2.pack()
buttexit=Tkinter.Button(hf,text=" Exit  ",bg="red", width=5,bd = 4, command=hf.destroy)
buttexit.pack(pady=10)
hf.mainloop()
