# -*- coding: cp1252 -*-
import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import tkFileDialog
import raioop2
import stats
import pstat
import random
import math


# Development: chain1.py : June 2010, starting from "HDsimpl1.py"
# chain3: 21.9.10 Control of height of chain, search fctn
# chain4: 26.6.2011. Characterization of start- and endpoint of a chain
# chain5: 22.7.2011 The management of maximal chain length is unsatisfactory. Hence a new version
# chain6.py: 7.9.2011 cosmetics
# chain7_1: 13.9.2012 chain-matrix
# chain8_1: Many changes. Mainly concerning the chainmatrix and layouts
# chain8_3: Many minor changes, 25.7.2013
# chain8_4: show cover matrix
# chain8_5.py: bug in txt-output eliminated
# 14.1.2015: basic1.py derived from chain6, start of programming
# 15.1.2015: Programming cont'd
# 16.1.2015 Programming cont'd

###### editfenster ### 29.8.2013 #####
def xsave_in_PyHasseformat():
    # brg 26.7.2013
    # 6.8.2013: taken from csvHDsimpl1.py, 27.8.2013
    global r,k,x
    la=r+1
    ls=k+1
    
    xext=rmod2.marray(la,ls)
    for i in range(0,la):
        for j in range(0,ls):
            if i==0 and j==0:
                xext[i][j]="dummy"
            elif j==0 and i>0:
                xext[i][j]=obj[i-1]
            elif j>0 and i==0:
                xext[i][j]=prop[j-1]
            else:
                xext[i][j]=x[i-1][j-1]


    print " xext-matrix "
    for i in range(0,la):
        for j in range(0,ls):
            print xext[i][j]," ",
        print " "
    print "  "    
    fnnew=tkFileDialog.asksaveasfilename(parent=hf,title="save orig dm in PyHasseformat")
    fcsv=open(fnnew,"w")
    for i in range(0,la):
        for j in range(0,ls):
            fcsv.write(str(xext[i][j])+"\t")
        fcsv.write("\n")
    fcsv.close()
   
def xsave_in_PyHasseformat_n():
    # brg 26.7.2013
    # 6.8.2013: taken from csvHDsimpl1.py, 27.8.2013
    global r,k,x
    xn=rmod2.matrixnorm(r,k,x)

    la=r+1
    ls=k+1
    
    xext=rmod2.marray(la,ls)
    for i in range(0,la):
        for j in range(0,ls):
            if i==0 and j==0:
                xext[i][j]="dummy"
            elif j==0 and i>0:
                xext[i][j]=obj[i-1]
            elif j>0 and i==0:
                xext[i][j]=prop[j-1]
            else:
                xext[i][j]=xn[i-1][j-1]


    print " xext-matrix "
    for i in range(0,la):
        for j in range(0,ls):
            print xext[i][j]," ",
        print " "
    print "  "    
    fnnew=tkFileDialog.asksaveasfilename(parent=hf,title="save normalized dm in PyHasseformat")
    fcsv=open(fnnew,"w")
    for i in range(0,la):
        for j in range(0,ls):
            fcsv.write(str(xext[i][j])+"\t")
        fcsv.write("\n")
    fcsv.close()


def xselectfile():
    # brg 6.8.2013
    global fn
    fn=tkFileDialog.askopenfilename()
    print "fn ",fn
    Tpopener=Tkinter.Toplevel(hf)
    Tpopener.title(' Opening window: different formats ')
    fropen2=Tkinter.Frame(Tpopener,bd=3,bg="white")
    fropen2.pack()
    # +++ Grid-Geometry manager +++
    lb0=Tkinter.Label(fropen2,text=" Select the appropriate format: ",bg="yellow",font=("arial",12,"bold"))
    lb0.grid(row=0,column=0)
    lb1=Tkinter.Label(fropen2,text="(1a) Open files, txt, tab (or blank) as delimiter (PyHasse-standard) :                ",bg="white")
    lb1.grid(row=1,column=0)
    lb2=Tkinter.Label(fropen2,text="(1b) Open files, csv, ';' as delimiter (csv with ';') :                               ",bg="white")
    lb2.grid(row=2,column=0)
    lb3=Tkinter.Label(fropen2,text="(1c) Open files, csv, ',' as delimiter (csv with ',') :                               ",bg="white")
    lb3.grid(row=3,column=0)
    lb6=Tkinter.Label(fropen2,text="(1f) Open files, pdt, internal PyHasse-format to exchange interim-results:            ",bg="white") 
    lb6.grid(row=6,column=0)
    butt1=Tkinter.Button(fropen2,text="(1a) Open txt-file       ",bg="cyan",bd=4,command=xfileopen)
    butt1.grid(row=1,column=1)
    butt2=Tkinter.Button(fropen2,text="(1b) Open csv-file (';') ",bg="cyan",bd=4,command=xcsvopenS)
    butt2.grid(row=2,column=1)
    butt3=Tkinter.Button(fropen2,text="(1c) Open csv-file (',') ",bg="cyan",bd=4,command=xcsvopenK)
    butt3.grid(row=3,column=1)
    butt6=Tkinter.Button(fropen2,text="(1f) Open pdt-file       ",bg="cyan",bd=4,command=xopenfilepdt)
    butt6.grid(row=6,column=1)
    lbclose=Tkinter.Label(fropen2,text="After your selection you can close this window")
    lbclose.grid(row=7,columnspan=3)


def xcsvopenS():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,obj,prop,x,xred,rred,objred,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=';', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")
    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)
    print "rred ",rred
    print "Matrix "
    rmod2.matout(r,k,xred)
    print "neq= ",neq
    print "txteq = ", txteq

    

def xcsvopenK():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,x,fn,obj,prop,xred,objred,rred,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=',', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")

    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)   # 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq





def xfileopen():
    "Informs about the file-operations"
    # Excelreadin4 built in
    # Brg 29.11.07, 30.11.07, 15.1.08,18.2.08
    global fn,r,k,x,prop,obj,rred,xred,objred,txteq
    x,ob,pr,r,k=rmod2.EXCELreadin6(fn)
    print "r = ",r,"   k = ",k
    obj=rmod2.vecgentext1(r)                        # 29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  # recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pr[i+1]   # recoding, because pr[0] is a dummy string
    # rmod2.matout(r,k,x)
    
    lbopen1.config(bg="yellow")    # 18.2.08
    lbopen1["text"]="File "+fn+" was opened with "+str(r)+" rows and "+str(k)+"  columns"
    
    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)   # 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq


    

def xopenfilepdt():
    """ File selection of transformed data matrices
    through other PyHasse programs """
    # brg 29.10.2012 taken from sensitivity18_3
    #* 1.6.09
    # akt. 29.10.2012 (taken from sensitivity18_3), 6.8.2013
    # source: mainHD19
    global fn,r,k,x,prop,obj,rred,xred,objred,txteq
    
    r,k,x,obj,prop=rmod2.raireadin5(fn)
    lbpdtopen.config(bg="yellow")
    lbpdtopen["text"]="selected file (PyHasse (pdt) format) : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns"

    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)  # new 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq

##### end of editenster ### 29.8.2013 ####



def showDM():
    """ New routine : shows the data matrix """
    #Brg 13.1.08 (from dds8)
    tp2=Tkinter.Toplevel(hf)
    tp2.title(' show DM ')
    lbtp2=Tkinter.Label(tp2,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+ob[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+pro[j+1]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=pro[j+1]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=ob[i+1]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)
    
def chardm():
    #brg 16.1.2015
    global achar
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    achar=rmod2.matrixchar(r,k,dm)
    tp3=Tkinter.Toplevel(hf)
    tp3.title("Elementary statistics of the data matrix ")
    t3=ScrolledText(tp3,width=60,height=20)
    t3.pack()
    txt4="Elementary statistics of the data matrix"
    txt4+=40*"="+"\n"
    txt4+="Indic."+"\t"+"Minimum"+"\t"+"Mean"+"\t"+"Maximum"+"\t"+"Standard deviation"+"\n"
    for j in range(0,k):
        txt4+=str(prop[j])+":\t"+str(achar[1][j])+"\t"+\
                   str(achar[2][j])+"\t"+str(achar[0][j])+"\t"+str(achar[3][j])+"\n"
    txt4+="\n"
    txt4+="-   -   - e o f -   -   - "
    t3.insert("end",txt4)
    


def order():
    """based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"""
    # Brg 20.12.07, 28.12.07, 2.10.,3.10.09, 13.6.10, 14.1.2015
    # If the number of representants > 400 then only the cover-matrix and the level-population
    #
    global cov,rred,objred,zzmax,zeta
    
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    maximalelements = []
    for i1 in range(0, rred):
        flag=0
        for i2 in range(0, rred):
            if i1!=i2:
                if zeta[i1][i2]!=0:
                    flag=1
        if flag==0:            
            maximalelements.append(objred[i1])

    minimalelements = []
    for i1 in range(0, rred):
        flag=0
        for i2 in range(0, rred):
            if i1!=i2:
                if zeta[i2][i1]!=0:
                    flag=1
        if flag==0:
            minimalelements.append(objred[i1])
    txt1= "1) Basic Order analysis\n"
    txt1+="1a) Number of representative elements: "+str(rred)+"\n"
    txt1+="1b) Representative (i.e. the relevant) elements: "+"\n"
    for i in range(0, rred):
        txt1+=str(objred[i])+", "
    txt1+=2*"\n"    
    txt1+=" 1c) Maximal objects: "
    for i in range(0, len(maximalelements)):
        txt1+=str(maximalelements[i])+", "
    txt1+=2*"\n"
    txt1+=" 1d) Minimal objects: "
    for i in range(0,len(minimalelements)):
        txt1+=str(minimalelements[i])+", "
    txt1+=2*"\n"
    iso=[]
    for ob in maximalelements:
        if ob in minimalelements:
            iso.append(ob)
    txt1+="1e) Objects both: minimal a n d maximal: "
    for ob in iso:
        txt1+=str(ob)+", "
    txt1+="\n"    
   
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)

    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    # Determination of equivalent profiles (note this is only
    # meaningful, if the attributes are on a common scale!!!!!)
    #print "lobj ",lobj
    print "objred=  ",objred
    level = []
    for i1 in range(0,zzmax):
        level.append(0)
        level[i1]=[]
        for i2 in range(0,len(lobj[i1])):
            if lobj[i1][i2]>=0 and lobj[i1][i2]!=[]:
                level[i1].append(objred[lobj[i1][i2]])
    
    
   
    txt1+=2*"\n"
    txt1+="1f) A first rough screening of order by the 'level': "+"\n"
    for i in range(0, zzmax):
        txt1+="Level "+str(zzmax-i)+":  "
        for i2 in range(0, len(level[i])):
            txt1+=str(level[i][i2])+", "
        txt1+="\n"
    txt1+="\n"    
    txt1+="\n1g) One of many total orders among the objects: "+"\n"
    for i in range(0, len(lext)):
        if i<len(lext)-1:
            txt1+=str(objred[revlext[i]])+"< "
        else:
            txt1+=str(objred[revlext[i]])+". "
    txt1+=2*"\n"        
    tresults.insert("end",txt1)
    buttupdown.config(state="active")
    return lobj,levmax,zzmax,cov,zeta, rred
    

def chain():
    # brg 14.1.2015
    try:
        limitlp=int(elimitlp.get())
    except:
        limitlp=2
    chaincore(limitlp)
    
def chaincore(limitlp):
    #brg 13.6.10, 21.9.10, 22.7.2011, 23.5.2013, 14.1.2015
    #brg 25.7.2013: major changes: countpath is now a list (in former times a set)
    # This part in order to perform 'path' without the need of displaying the HD
    global chset2,countpath, chainm, emincx, indicch
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    global cov,npath,countpath   #13.6.10
    cov=rmod2.cover(rred,tr,lext)   

    # the following lines are the proper path part
    grc=rmod2.graphcovdict(cov,rred)
    start=objred.index(estart.get())
    sink=objred.index(eend.get())
    flag=0
    if zeta[start][sink]==1:
        lbwarn.config(text=estart.get()+" < "+eend.get(),bg="white", font= "Arial 14 bold")
        flag=1
    else:
        lbwarn.config(text="+++ start and sink are not in a <-relation +++",bg="yellow", font="Arial 14")
        
    npath=rmod2.find_all_paths(grc,start,sink)
    lp=len(npath)
    txt2=""
    if flag==1:
        txt2="\n 3a) Sequence analysis \n"
        txt2="\n 3a1) Total number of sequences between object "+str(estart.get())+"\n and object "+str(eend.get())+": = "+str(lp)+"\n"
        for maxch in range(zzmax, 1, -1): 
            if lp > limitlp:
                lp = limitlp
            for i in range(0,lp):
                if len(npath[i])==maxch and npath[i]!=[]:
                    print "Path = ",i, "  maxch = ",maxch
                    for i1 in range(0, len(npath[i])):
                        print objred[npath[i][i1]],"<",
                    print " "    
       
        txt2+="3a2) Limiting value of the number of sequences: "+str(limitlp)+":\n"
        txt2+= "3a3) Sequences ordered for decreasing lengths between "+str(estart.get()) +" and "+str(eend.get())+":\n"
        for maxch in range(zzmax, 1, -1): 
            if lp > limitlp:
                lp = limitlp
            for i in range(0,lp):
                if len(npath[i])==maxch and npath[i]!=[]:
                    txt2+= "Sequence with length "+str(maxch)+":\n"
                    for i1 in range(0, len(npath[i])):
                        if i1 <len(npath[i])-1:
                            txt2+=str(objred[npath[i][i1]])+"<= "
                        else:
                            txt2+=str(objred[npath[i][i1]])+" "
                    txt2+="\n"
            txt2+="\n"
        txt2+="\n"
    else:
        txt2+="\n3) Sequence analysis \n"
        txt2+="3b) +++ there exists no sequence between\n"
        txt2+=str(estart.get())+"  and  " + str(eend.get())+"  +++"+"\n"
        txt3,countconflict_act=conflict(estart.get(),eend.get())
        txt2+=txt3
    tresults.insert("end",txt2)
        
        
def conflict(x,y):
    # brg 14.1.2015
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    achar=rmod2.matrixchar(r,k,dm)
    txt3="3b) Conflicts between objects "+str(x)+" and "+str(y)+"\n"
    iob1 = objred.index(x)
    iob2 = objred.index(y)
    countconflict=0
    for j1 in range(0,k):
        for j2 in range(j1+1,k):
            bool1 = xred[iob1][j1] > xred[iob2][j1] and xred[iob1][j2] < xred[iob2][j2]
            bool2 = xred[iob1][j1] < xred[iob2][j1] and xred[iob1][j2] > xred[iob2][j2]
            if bool1:
                countconflict+=1
            if bool2:
                countconflict+=1
                
    txt3+=50*"="+"\n"
    txt3+="3b1) Intensity of conflicts between "+str(x) +"  and "+str(y) +"  = "+str(countconflict)+"  "+"\n"
    txt3+="3b2) \t"+" object \t"+str(x) +" vs   object "+str(y)+3*"\t"+"|data range|\n"
    for j1 in range(0,k):
        for j2 in range(j1+1,k):
            bool1 = xred[iob1][j1] > xred[iob2][j1] and xred[iob1][j2] < xred[iob2][j2]
            bool2 = xred[iob1][j1] < xred[iob2][j1] and xred[iob1][j2] > xred[iob2][j2]
            if bool1:
                txt3+= "\t attribute \t"+str(prop[j1])+": "+str(round(xred[iob1][j1],3))+\
                       " > "+str(round(xred[iob2][j1],3))+3*"\t"+str(abs(achar[0][j1]-achar[1][j1]))+"\n"
                txt3+= "\t attribute \t"+str(prop[j2])+": "+str(round(xred[iob1][j2],3))+\
                       " < "+str(round(xred[iob2][j2],3))+3*"\t"+str(abs(achar[0][j2]-achar[1][j2]))+"\n"
                countconflict+=1
            if bool2:
                txt3+= "\t attribute \t"+str(prop[j1])+": "+str(round(xred[iob1][j1],3))+\
                       " < "+str(round(xred[iob2][j1],3))+3*"\t"+str(abs(achar[0][j1]-achar[1][j1]))+"\n"
                txt3+= "\t attribute \t"+str(prop[j2])+": "+str(round(xred[iob1][j2],3))+\
                       " > "+str(round(xred[iob2][j2],3))+3*"\t"+str(abs(achar[0][j2]-achar[1][j2]))+"\n"
                countconflict+=1 
        txt3+="\n"
    txt3+="\n"    
    return txt3,countconflict
    
def connectance():
    # brg 14.1.2015
    try:
        testobject=eobjstart.get()
    except:
        testobject=objred[0]
    connectedobjectsupward=[]
    connectedobjectsdownward=[]
    iob=objred.index(testobject)
    for i1 in range(0,rred):
        if zeta[iob][i1]==1:
            connectedobjectsupward.append(objred[i1])
        if zeta[i1][iob]==1:
            connectedobjectsdownward.append(objred[i1])
    print "objects upward of ",testobject,": ",connectedobjectsupward
    print "objects downward of ",testobject,": ",connectedobjectsdownward
    txthilf1=""
    for i in range(0, len(connectedobjectsupward)):
        txthilf1+=str(connectedobjectsupward[i])+", "
    txthilf1+="\n"
    txt4="2) Connectances of object "+str(testobject)+"\n"
    txt4+="2a) objects >= "+str(testobject)+": = "+txthilf1
    txthilf1=""
    for i in range(0, len(connectedobjectsdownward)):
        txthilf1+=str(connectedobjectsdownward[i])+", "
    txt4+="2b) objects <= "+str(testobject)+": = "+txthilf1
    txt4+="\n"
    txt4 += "\n"
    tresults.insert("end",txt4)

def count_up_down():
    # brg 14.1.2015, 22.1.2015
    countup = []
    countdown = []
    for i in range(0, rred):
        connectedobjectsupward = []
        connectedobjectsdownward = []
        for i1 in range(0,rred):
            if zeta[i][i1] == 1:
                connectedobjectsupward.append(objred[i1])
            if zeta[i1][i] == 1:
                connectedobjectsdownward.append(objred[i1])
        countup.append(len(connectedobjectsupward)-1)
        countdown.append(len(connectedobjectsdownward)-1)
    txthilf2 = "2c) Counts up, down "+"\n"
    txthilf2 +="Object:"+"\tupwards: "+"\t"+"downwards" +"\n"
    for i in range(0, rred):
        txthilf2 += str(objred[i])+"\t"+str(countup[i]) +"\t  "+str(countdown[i])+"\n"
    txthilf2+="\n"
    tpcountupdown = Tkinter.Toplevel(hf)
    tpcountupdown.title("summary: how many above, how many below ")
    tcountupdown=ScrolledText(tpcountupdown, width=60,height=20)
    tcountupdown.pack()
    tcountupdown.insert("end",txthilf2)
    return txthilf2
    
    
    
    
## Tkinter Plot
hf = Tkinter.Tk()
hf.title(' User-Interface PO_easy ')
aboutPOeasy=raioop2.brgabout(hf,"tp1","about_POeasy.txt",1,\
            "January., 15th,2015"," about POeasy ", "white", "t1",80,5,ScrolledText)
helpPOeasy=raioop2.brgabout(hf,"tp1","help_POeasy.txt",1,\
            "January. 15th,2015"," help_POeasy ", "white", "t1",80,5,ScrolledText)
    

fr = Tkinter.Frame(hf, width=60)
fr.pack()
frinput1 = Tkinter.Frame(fr, width=100, height=10)
frinput1.pack()
text = "Select first the file, then decide in which format to be opened "
lbinput1 = Tkinter.Label(frinput1,
                         text=text)
lbinput1.pack()
butt1 = Tkinter.Button(frinput1, text="Select filename  ",
                       bg="cyan", width=40, command=xselectfile)
butt1.pack()
                      
lbopen1 = Tkinter.Label(fr, text="")
lbopen1.pack()
buttshow=Tkinter.Button(fr,text="show data matrix (an own window pops up)",width=40, bg="cyan",command=showDM)
buttshow.pack()
buttchardm= Tkinter.Button(fr,text="Elementary statistics of the dm\n\
            (an own window pops up)",width=40,bg="cyan",command=chardm)
buttchardm.pack()
lbinfo=Tkinter.Label(fr, text="Results of 'order', 'connectance', 'path': see popping up window 'Results of PO_easy'")
lbinfo.pack()
buttorder = Tkinter.Button(fr, text='1. order',width=40,bg="cyan",command=order)
buttorder.pack()
lbconnect=Tkinter.Label(fr,text="check connectances of a single object ")
lbconnect.pack()
eobjstart=Tkinter.Entry(fr,width=5)
eobjstart.pack()
buttconnect=Tkinter.Button(fr,text="2. check the connectance of selected object ",bg="cyan",width=40,command=connectance)
buttconnect.pack()
lb2=Tkinter.Label(fr,text="Determination of a sequence (if existing) between two user-selected objects\n\
                    Note: If there is no such chain, you will be informed about that fact")
lb2.pack(pady=10)
fr1=Tkinter.Frame(fr, relief="sunken",bd=4)
fr1.pack()
lb2a=Tkinter.Label(fr1, text= "Enter the object name from which the sequence should start (in increasing order)")
lb2a.pack(side="left")
estart=Tkinter.Entry(fr1,width=5)
estart.pack(side="right")
fr2=Tkinter.Frame(fr, relief="sunken",bd=4)
fr2.pack()
lb2b=Tkinter.Label(fr2, text= "Enter the object name to which the sequence  should go ( in increasing order)      ")
lb2b.pack(side="left")
eend=Tkinter.Entry(fr2,width=5)
eend.pack(side="right")
fr3=Tkinter.Frame(fr, relief="sunken",bd=4)
fr3.pack()
hilfstext="The number of object sequences can be large,therefore it is a good idea to limit the\n number of these sequences"
lb3=Tkinter.Label(fr3,text=hilfstext,bg="yellow")
lb3.pack(side="left")
elimitlp=Tkinter.Entry(fr3, width=5)
elimitlp.pack(side="right")
buttpath=Tkinter.Button(fr,text="3. Sequences ",width=40, bg="cyan",command=chain)
buttpath.pack()
frwarn=Tkinter.Frame(fr,relief="sunken",bd=3)
frwarn.pack()
lbwarn=Tkinter.Label(frwarn,text="")
lbwarn.pack()
Tpresults=Tkinter.Toplevel(hf)
Tpresults.title('Results of PO_easy ')
tresults=ScrolledText(Tpresults,width=80,height=30)
tresults.pack()
buttupdown=Tkinter.Button(fr, text = "Summary of up / down relations ", bg = "cyan", width = 40, state = "disabled", command = count_up_down)
buttupdown.pack()
buttexit = Tkinter.Button(fr, text = 'exit', bg = 'red', width=40,command = hf.destroy)
buttexit.pack(pady=15)

hf.mainloop()

