# -*- coding: cp1252 -*-
import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import tkFileDialog
import raioop2
import stats
import pstat

#Brg in cooperation with Korbinian Freier, MPI Hamburg, 2.10. and 3.10.09
# 16.12.2012: Basis for the new module POcdn1.py
# Idea: HD and different PO-coordinate systems
# 29.5.2013 New coordinates
# 2.8.2013 Vertical and horizontal analysis in FOU-plot
# 3.8.2013 ...extended by average values of the attributes of the objects of each transsection
# 25.8.2013: division by U[i]. Now an if...else structur in case U[i]=0
# 6.11.2014 Inclusion of level number and (correctly reoriented) colevel-number...
#   ........(for representative elements)
# 8.11.2014 extension to all objects

def levelcolevel(rred,k,obj,xred):
    # brg 6.11.2014
    # rred, k, obj: please the representative elements mostly objred
    # xred the dm of representative elements
    zetahilf=rmod2.comp(rred,k,xred)
    zetausual=rmod2.marray(rred,rred)
    zetadual=rmod2.marray(rred,rred)
    for i in range(0,rred):
        for j in range(0,rred):
            zetausual[i][j]=zetahilf[j][i]
            zetadual[i][j] = zetahilf[i][j]
    #
    #One linear extension (based on levels)
    
    lobj1,lext1,revlext1,zzmax1=rmod2.levtopsort(rred,zetausual)
    lobj2, lext2,revlext2,zzmax2=rmod2.levtopsort(rred,zetadual)


    level = []
    colevel= []
    for i1 in range(0,zzmax1):
        level.append(0)
        level[i1]=[]
        for i2 in range(0,len(lobj1[i1])):
            level[i1].append(objred[lobj1[i1][i2]])
            
    levz = [] 
    for ob in obj:
        searchobj = ob
        for i1 in range(0,zzmax1):
            for i2 in range(0, len(level[i1])):
                if level[i1][i2] == searchobj:
                    levz.append(zzmax1-i1)
                    break

    for i1 in range(0,zzmax2):
        colevel.append(0)
        colevel[i1]=[]
        for i2 in range(0,len(lobj2[i1])):
            colevel[i1].append(objred[lobj2[i1][i2]])
            
    colevz = []   
    for ob in obj:
        searchobj = ob
        for i1 in range(0,zzmax2):
            for i2 in range(0, len(colevel[i1])):
                if colevel[i1][i2] == searchobj:
                    colevz.append(i1+1)
                    break
    return level, levz, colevel,colevz           


def showDM():
    """ New routine : shows the data matrix """
    #Brg 13.1.08, 16.12.2012 taken from antag2.py
    tp2=Tkinter.Toplevel(hf)
    tp2.title(' show DM ')
    lbtp2=Tkinter.Label(tp2,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack()
    dm,ob,pro,r,k=rmod2.EXCELreadin6(fn)
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+ob[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+pro[j+1]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=pro[j+1]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=ob[i+1]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)


def showequivalenceclasses():
    # brg 2.8.2013
    tpeq=Tkinter.Toplevel(hf)
    tpeq.title(' Equivalence classes w.r.t. data profile ')
    teq=ScrolledText(tpeq,width=60,height=10)
    teq.pack()
    teq.insert("end",txteq_act)

    
def HD():
    """based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"""
    # Brg 20.12.07, 28.12.07, 2.10.,3.10.09
    # If the number of representants > 70 then only the cover-matrix and the level-population
    #
    global fn, txteq_act,neq_act,obj,objred,r,k,rred,dm,prop,cov
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    
    fn=tkFileDialog.askopenfilename()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    lb1.config(text="opened "+fn,bg="yellow")
    

    prop=[]
    for j in range(0,k):
        prop.append(pro[j+1])
            
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
    for i in range(0,r):
        obj[i]=ob[i+1]

    rred,xred,objred,txteq_act,neq_act=rmod2.equivcompactm(r,k,dm,obj)  
    print "neq_act ", neq_act
    print "txteq_act ",txteq_act
    #
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    if rred>100:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram  ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.create_text(150,actheight-30,text=txteq_act)
        cv.pack()
        buttcov=Tkinter.Button(hfhd2,text="cover relation ",command=cover_show)
        buttcov.pack()

def cover_show():
    """Cover-matrix is displayed"""
    #brg 28.12.07, 16.12.2012
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: antag2.py
    hfcover=Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    
    lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,rred):
        txt3+="\n"+objred[i]+":\t"
        txt3+="is cover_less than "
        for j in range(0,rred):
            if i!=j:
                if cov[i][j]==1:
                    txt3+=" "+objred[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=4)
    tcov.pack()
    tcov.insert("end",txt3)



def Poc():
    # brg 16.12.2012, 29.5.2013
    global FO,WayneFO,U,sumeg,sumup,sumdown,sumic,emaxsymx,emaxsymy
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    rred,xred,objred,txtred=rmod2.equivcompact(r,k,dm,obj)
    lev_act,levz_act,colev_act,colevz_act = levelcolevel(rred, k, objred, xred)
    c_act=rmod2.comp(r,k,dm)
    quobx_act=rmod2.qualcomp1(r,c_act)
    sumeg=rmod2.vecgen1(r)
    sumdown=rmod2.vecgen1(r)
    sumup=rmod2.vecgen1(r)
    sumic=rmod2.vecgen1(r)
    txt="Info Equivalence classes "+"\n"
    txt+=txteq_act+"\n"
    txt+="\nBasis coordinates: all elements of the object set"+"\n"
    txt+=60*"="+2*"\n"
    txt+="obj"+"\t"+"Equiv."+"\t"+"successors"+"\t"+"predecessors"+"\t"+\
          "incomparables"+"\n"
    txt+=50*"- "+"\n"
    for i in range(0,r):
        for i1 in range(0,r):
            if quobx_act[i][i1]=="eg":
                sumeg[i]+=1
            if quobx_act[i][i1]=="lt":
                sumup[i]+=1
            if quobx_act[i][i1]=="gt":
                sumdown[i]+=1    
            if quobx_act[i][i1]=="ic":
                sumic[i]+=1
        txt+=str(obj[i])+"\t"+str(sumeg[i])+"\t"+str(sumdown[i])+2*"\t"\
              +str(sumup[i])+2*"\t"+str(sumic[i])+"\n"
    txt+="\n"
    txt+="List of Level and (mod.)Colevel 1) for the representativel elements"+"\n"
    txt+=" repr.obj"+"\t"+" level "+"\t"+"co-level (re-oriented)  "+"\n"
    txt+=50*"-"+"\n"
    for i in range(0,rred):
        txt+=str(objred[i])+"\t"+str(levz_act[i])+"\t"+str(colevz_act[i])+"\n"
    txt+="\n"
    # extension to all objects
    rred,xred,objred,txtlist,eqm=rmod2.equivcompactgr(r,k,dm,obj)
    levzext=rmod2.weak1(r,obj,objred,levz_act,eqm)
    colevzext=rmod2.weak1(r,obj,objred,colevz_act,eqm)
    txt+="List of Level and (mod.) Colevel of all objects "+"\n"
    txt+="\nobjects"+"\t"+"Level"+"\t"+"mod.Colevel"+"\n"
    for i in range(0,r):
        txt+=str(obj[i])+"\t"+str(levzext[i])+"\t"+str(colevzext[i])+"\n"
    txt+="\n"
    txt+="FOU-coordinates (all objects)"+"\n"
    FO=rmod2.vecgen1(r)
    U=rmod2.vecgen1(r)
    WayneFO=rmod2.vecgen1(r)
    for i in range(0,r):
        FO[i]=(sumdown[i]-sumup[i])
        U[i]=sumic[i]
        WayneFO[i]=1.0*(sumdown[i]+1.0)/(sumup[i]+1.0)
    txt+="obj x"+"\t"+"(|O(x)|-|F(x)|)"+"\t"+"|U(x)|"  +"\n"
    for i in range(0,r):
        txt+=str(obj[i])+"\t"+str(FO[i])+3*"\t"+str(U[i])+"\n"
    txt+="\n"
    txt+="Wayne-coordinates "+"\n"
    txt+="obj x"+"\t"+"|O(x)|/|F[x]|"+"\t"+"U(x)"+"\n"
    for i in range(0,r):
        txt+=str(obj[i])+"\t"+str(round(WayneFO[i],2))+2*"\t"+str(U[i])+"\n"
    txt+="\n"
    txt+="Symmetric scatterplot "+"\n"
    txt+="obj x"+"\t"+"|O(x)|/|U[x]|"+"\t"+"|F(x)|/|U(x)|"+"\n"
    oumax=-99999
    fomax=-99999
    for i in range(0,r):
        if U[i]!=0:
            x=1.0*sumdown[i]/(1.0*U[i])
        else:
            x=9999.9    #dummy value
        if x>oumax:
            oumax=x
        if U[i]!=0:    
            y=1.0*sumup[i]/(1.0*U[i])
        else:
            y=99999.9
        if y>fomax:
            fomax=y
        txt+=str(obj[i])+"\t"+str(round(x,2))+2*"\t"+str(round(y,2))+"\n"
    txt+="\n"
    txt+="Maximal value O/U = "+str(round(oumax,3))+"\n"
    txt+="Maximal value F/U = "+str(round(fomax,3))+"\n"
    txt+="\n"
    
    tpcdn=Tkinter.Toplevel(hf)
    tpcdn.title(' PO-coordinates: Results ')
    tcdn=ScrolledText(tpcdn,width=80,height=10)
    tcdn.pack()
    tcdn.insert("end",txt)
    butt1=Tkinter.Button(tpcdn,text=" FOU-plot ",command=FOU)
    butt1.pack()
    butt2=Tkinter.Button(tpcdn,text="Wayne-plot ",command=Wayne)
    butt2.pack()
    lbsym=Tkinter.Label(tpcdn,text="max-values for abscissa and ordinate ")
    lbsym.pack()
    emaxsymx=Tkinter.Entry(tpcdn,width=5)
    emaxsymx.pack()
    emaxsymy=Tkinter.Entry(tpcdn,width=5)
    emaxsymy.pack()
    butt3=Tkinter.Button(tpcdn,text= "symm-plot ",command=symmetry)
    butt3.pack()

def FOU():
    #brg 16.12.2012, main part taken from mHDCl2_datamining4
    def detailsfou(event):
        # brg 14.8.2012
        #brg 19.8.2011, 6.11.2011 taken from HDalter
        # Info taken for the FOU-plot
        from ScrolledText import ScrolledText
        tpinfofou=Tkinter.Toplevel(hf)
        tpinfofou.title('Info for selected vertex ')
##        lbequiv=Tkinter.Label(tpinfofou,text="Equivalence classes "+"\n"+txteq_act)
##        lbequiv.pack()
        tinfo=ScrolledText(tpinfofou,width=40,height=10)
        tinfo.pack(expand="yes")
                  
       
        x=int(cvfou.canvasx(event.x))
        y=int(cvfou.canvasy(event.y))
        #print item2
        
        tu=cvfou.gettags(cvfou.find_closest(x,y))
        print "tu= ",tu[0]
        lt=len(tu[0])
        tagn=tu[0][7:lt]
        print "tagn= ",tagn
        try:
           iobact=obj.index(tagn)   #clicked object
        except:
           iobact=999999
        txt="Detail information "+"\n"
        txt+=19*"="+"\n"
        txt+="Selected object: "+tagn+"\n"
        such=obj[iobact]
        txtact=rmod2.readequiv(txteq_act,such)
        txt+="corresponding equivalence class: "+txtact+"\n"
        txt+="Data profile "+"\n"
        txt+=str(obj[iobact])+"\t"
        for j in range(0,k):
            txt+=str(prop[j])+"\t"
        txt+="\n"+"\t"
        for j in range(0,k):
            txt+=str(dm[iobact][j])+"\t"
        txt+=2*"\n"
        txt+="Basis-coordinates (concerning the object set)"+"\n"
        txt+=20*"- "+"\n"
        txt+="Equiv("+str(obj[iobact])+"):"+2*"\t"+str(sumeg[iobact])+"\n"  
        txt+="Downset("+str(obj[iobact])+"):"+2*"\t"+str(sumdown[iobact])+"\n"
        txt+="Upset("+str(obj[iobact])+"):"+2*"\t"+str(sumup[iobact])+"\n"
        txt+="U("+str(obj[iobact])+"):"+2*"\t"+str(sumic[iobact])+"\n"
        txt+="FOU-coordinates"+"\n"
        txt+="(|O(x)|-|F(x)|)="+3*"\t"+str(FO[iobact])+"\n"
        txt+="|U(x)|="+3*"\t"+str(U[iobact])+"\n"
        txt+="\n - - - -  e o f - - - -"+"\n"
        tinfo.insert("end",txt)
            
            
    # main body of fouplot
    tpfouplot=Tkinter.Toplevel(hf)
    tpfouplot.title('scatterplot O-F vs U ')
##    lbfou=Tkinter.Label(tpfouplot,text="Equivalence classes "+txteq_act)
##    lbfou.pack()
    basiskdn=rmod2.vecgen1(6) #5.7.2012
    lbfou=Tkinter.Label(tpfouplot,text="Alt-Mouse-button-1 for further information on points in FOU-plot ",bg="yellow")
    lbfou.pack()    
    scattplot=rmod2.marray(r,2)
                
    for i in range(0,r):
        scattplot[i][0]=FO[i]     #O-F
        scattplot[i][1]=U[i] #U
    
    fr=Tkinter.Frame(tpfouplot,width=500,height=500)
    fr.pack()

    #graphic
    maxdmx=-9999
    mindmx=9999
    for i in range(0,r):
        if scattplot[i][0]>=maxdmx:
            maxdmx=scattplot[i][0]
        if scattplot[i][0]<=mindmx:
            mindmx=scattplot[i][0]
            
    maxdmy=-9999
    for i in range(0,r):
        if scattplot[i][1]>=maxdmy:
            maxdmy=scattplot[i][1]

    
    maxxaxis=max(maxdmx,abs(mindmx))

    #print "corrected maxdmy= ",maxdmy, "  corrected maxxaxis ",maxxaxis
    cvfou=Tkinter.Canvas(fr,width=500,height=500,bg="white")
    cvfou.pack()
    xleft=50
    ybasis=450
    xbasis=400
    ybereich=400
    mitte=xleft+(1.0*xbasis)*0.5
    xright=xbasis+xleft
    liy=cvfou.create_line(mitte,ybasis,mitte,20,arrow="last",width=2,fill="red")
    texty=cvfou.create_text(mitte-20,30,text="|U(x)|")
    texty2=cvfou.create_text(mitte-10,50,text=str(maxdmy))
    lix=cvfou.create_line(xleft,ybasis,xleft+xbasis+10,ybasis,arrow="last",width=2,fill="red")
    
    

    if maxxaxis!=0:        
            axleft=1.0*(mitte-xleft)/(1.0*maxxaxis)
    else:
            axleft=5
    bxleft=mitte # = bxright

    if maxxaxis!=0:
            axright=1.0*xbasis/(2.0*maxxaxis)
    else:
            axright=5

    if maxdmy!=0:
            ay=-1.0*ybereich/maxdmy
    else:
            ay=-5.0
    by=ybasis
    basiskdn[0]=ay
    basiskdn[1]=by
    basiskdn[2]=axright
    basiskdn[3]=bxleft
    basiskdn[4]=axleft
   
    for i in range(0,r):
        if scattplot[i][0]<=0:
            xg=axleft*scattplot[i][0]+bxleft
        else:
            xg=axright*scattplot[i][0]+bxleft
        yg=ay*scattplot[i][1]+by
        ci=cvfou.create_oval(xg-4,yg+4,xg+4,yg-4,fill="red",tags="object_"+obj[i])
        
            
    xt1=xleft-10
    yt1=ybasis+10
    ctext1=cvfou.create_text(xt1,yt1,text="-"+str(maxxaxis))
    xt2=xright+10
    yt2=ybasis+10
    ctext2=cvfou.create_text(xt2,yt2,text="+"+str(maxxaxis))
    
    xt4=mitte+150
    yt4=ybasis+10
    ctext4=cvfou.create_text(xt4,yt4,text="|O(x)|-|F(x)|")
    
    cvfou.bind("<Alt-Button-1>",detailsfou)


def Wayne():
    #brg 16.12.2012
    flag=1
    dmwayne=rmod2.marray(r,2)
    for i in range(0,r):
        dmwayne[i][1]=WayneFO[i]
        dmwayne[i][0]=U[i]
    objassign=rmod2.marray(r,2)
    app=raioop2.brgscatterplot1(hf,"tpwayne",obj,objassign,dmwayne,dm,"U","O/F",txteq_act,r,k,flag)
    app.anzeige()
    
def symmetry():
    # brg 29.5.2013
    maxsymx=float(emaxsymx.get())
    maxsymy=float(emaxsymy.get())
    flag=1
    dmsym=rmod2.marray(r,2)
    for i in range(0,r):
        if U[i]!=0:
            x=1.0*sumdown[i]/(1.0*U[i])
            y=1.0*sumup[i]/(1.0*U[i])
        else:
            x=99999.9
            y=99999.9
        if x<=maxsymx:
            dmsym[i][1]=x
        else:
            dmsym[i][1]=maxsymx
        if y<=maxsymy:    
            dmsym[i][0]=y
        else:
            dmsym[i][0]=maxsymy
    objassign2=rmod2.marray(r,2)
    app=raioop2.brgscatterplot1(hf,"tpsymm",obj,objassign2,dmsym,dm,"O/U","F/U",txteq_act,r,k,flag)
    app.anzeige()
        
def count():
    #brg 16.12.2012    
    tpcount=Tkinter.Toplevel(hf)
    tpcount.title('example how is counted ')
    cvc=Tkinter.Canvas(tpcount,width=200,height=200,bg="white")
    cvc.pack()
    rd=25
    
    cvline1f=cvc.create_line(150,50,88,170)
    cvline2f=cvc.create_line(150,50,100,170)
    cvline3f=cvc.create_line(150,50,112,170)
    cvline1d=cvc.create_line(40,50,88,170)
    cvline2d=cvc.create_line(40,50,100,170)
    cvline3d=cvc.create_line(40,50,112,170)
    cvline1d=cvc.create_line(53,50,88,170)
    cvline2d=cvc.create_line(53,50,100,170)
    cvline3d=cvc.create_line(53,50,112,170)
    cvlinedf=cvc.create_line(40,50,100,20)
    cvlinedf2=cvc.create_line(100,20,150,50)
    cvlineef=cvc.create_line(53,50,100,80)
    cvlineef2=cvc.create_line(100,80,150,50)
    cvccir1=cvc.create_oval(100-rd,170+rd,100+rd,170-rd,fill="yellow")
    cvccir2=cvc.create_oval(50-rd,50+rd,50+rd,50-rd,fill="orange")
    cvccir3=cvc.create_oval(150-rd,50+rd,150+rd,50-rd,fill="cyan")
    cvctxt1=cvc.create_text(100,170,text="a   b    c")
    cvctxt2=cvc.create_text(50,50,text="d    e ")
    cvctxt3=cvc.create_text(150,50,text="f ")
    
    
def sectionsthroughFOU():
    # brg 2.8.2013
    typ=etyp.get()
    var=int(evar.get())
    x=int(esec.get())
    txt=" Transsections through FOU-plot "+"\n"
    txt+=60*"="+"\n"
    if typ=="h":
        ustart=x
    elif typ=="v":
        fostart=x
    else:
        lbwarn4.config(text="+++wrong selection of vertical (v) or horizontal (h)+++",bg="yellow")
    if typ=="h":
        lbwarn4.config(text=" correct selection ",bg="green")
        txt+="horizontal analysis with ustart= "+str(ustart)+"  allowed variation "+str(var)+"\n"
        zahl1=1
        meanprop1=rmod2.vecgen1(k)
        for i in range(0,r):
            if ustart-var<=U[i]<=ustart+var:
                txthilf=""
                for j in range(0,k):
                    txthilf+=str(round(dm[i][j],2))+"\t"
                    meanprop1[j]+=dm[i][j]
                txthilf+="\n"    
                txt+=str(zahl1)+":  "+str(obj[i])+" actual FO= "+str(FO[i])+"  actual U = "+str(U[i])+"  data profile "+txthilf+"\n"
                zahl1+=1
        print "zahl1= ",zahl1
        print "meanprop1= ",meanprop1
        for j in range(0,k):
            if zahl1>1:
                meanprop1[j]=1.0*meanprop1[j]/(1.0*zahl1-1.0)
            else:
                meanprop1[j]=99999
        
        txt+="\n"
        txt+="Average values of data within the selected transsection "+"\n"
        txthilf1=""
        for j in range(0,k):
            if meanprop1[j]!=99999:
                txthilf1+=str(round(meanprop1[j],2))+"\t"
            else:
                txthilf1+=" +++ averaging not meaningful +++"
        txthilf1+="\n"
        txt+=txthilf1
        
    elif typ=="v":
        lbwarn4.config(text=" correct selection ",bg="green")
        txt+="vertical analysis with fostart = "+str(fostart)+" allowed variation  "+str(var)+"\n"
        zahl2=1
        meanprop2=rmod2.vecgen1(k)
        for i in range(0,r):
            if fostart-var<=FO[i]<=fostart+var:
                txthilf=""
                for j in range(0,k):
                    txthilf+=str(round(dm[i][j],2))+"\t"
                    meanprop2[j]+=dm[i][j]
                txthilf+="\n"    
                txt+=str(zahl2)+":  "+str(obj[i])+" actual FO= "+str(FO[i])+"  actual U = "+str(U[i])+"  data profile "+txthilf+"\n"
                zahl2+=1
        print "zahl2= ",zahl2
        print "meanprop2= ",meanprop2
        for j in range(0,k):
            if zahl2>1.0:
                meanprop2[j]=1.0*meanprop2[j]/(1.0*zahl2-1.0)
            else:
                meanprop2[j]=99999
        txt+="\n"
        txt+="Average values of data within the selected transsection "+"\n"
        txthilf2=""
        for j in range(0,k):
            if meanprop2[j]!=99999:
                txthilf2+=str(round(meanprop2[j],2))+"\t"
            else:
                txthilf2+="  +++ averaging not meaningful +++"               
        txthilf2+="\n"
        txt+=txthilf2
    else:
        #dummy
        lbwarn4.config(text=" default selection ",bg="green")
        txt+="analysis with ustart= "+str(int(1.0*r/5.0))+"  allowed variation: 2 "+"\n"
        ustart=int(1.0*r/5.0)
        var=2
        for i in range(0,r):
            if ustart-var<=U[i]<=ustart+var:
                txt+=str(obj[i])+" actual FO= "+str(FO[i])+"  actual U = "+str(U[i])+"\n" 
    

    tpsection=Tkinter.Toplevel(hf)
    tpsection.title(' sections through FOU-plot ')
    tsection=ScrolledText(tpsection,width=60,height=10)
    tsection.pack()
    tsection.insert("end",txt)
        

def FOUstatistics():
    # brg 4.8.2013
    typ=etyp.get()
    var=int(evar.get())
    x=int(esec.get())
    if typ=="h":
        ustart=x
    elif typ=="v":
        fostart=x
    else:
        pass
    indic=rmod2.vecgen1(k)
    for j in range(0,k):
        indic[j]=[]
        for i in range(0,r):
            if typ=="h":
                if ustart-var<=U[i]<=ustart+var:
                    indic[j].append(dm[i][j])
            elif typ=="v":
                if fostart-var<=FO[i]<=fostart+var:
                    indic[j].append(dm[i][j])
            else:
                print "+++ no correct transsection +++ "
        print "typ= ",typ,"  indicators= ",indic[j]
        print " "
        lindic=len(indic[0])
    meanindic=rmod2.vecgen1(k)
    medianindic=rmod2.vecgen1(k)
    stddevindic=rmod2.vecgen1(k)
    maxindic=rmod2.vecgen1(k)
    minindic=rmod2.vecgen1(k)
    for j in range(0,k):
        maxindic[j]=-99999
        minindic[j]=99999
        meanindic[j]=pstat.lmean(indic[j])
        medianindic[j]=pstat.lmedianscore(indic[j])
        stddevindic[j]=pstat.lstdev(indic[j])
    print "mean  ",meanindic
    print "median  ",medianindic
    print "stddev  ",stddevindic
    for j in range(0,k):
        for i in range(0,lindic):
            if indic[j][i]>=maxindic[j]:
                maxindic[j]=indic[j][i]
            if indic[j][i]<=minindic[j]:
                minindic[j]=indic[j][i]
        print j,":  maximum  ",maxindic[j],"  minimum  ",minindic[j]
    #
    #Now a comparison of indicatorvalues for any object falling into the stripe of v or h
    maxperobj=rmod2.vecgen1(lindic)
    minperobj=rmod2.vecgen1(lindic)
    deltaperobj=rmod2.vecgen1(lindic)
    for i in range(0,lindic):
        maxperobj[i]=-99999
        minperobj[i]=99999
    for i in range(0,lindic):
        for j in range(0,k):
            if indic[j][i]>=maxperobj[i]:
                maxperobj[i]=indic[j][i]
            if indic[j][i]<=minperobj[i]:
                minperobj[i]=indic[j][i]
        print i," max ",maxperobj[i],"  min ",minperobj[i]        
        deltaperobj[i]+=abs(maxperobj[i]-minperobj[i])
        print i, "  delta ",deltaperobj[i]
    avdeltaperobj=pstat.lmean(deltaperobj)
    tpstatistics=Tkinter.Toplevel(hf)
    tpstatistics.title(' statistics of transsections ')
    tstatistics=ScrolledText(tpstatistics,width=60,height=10)
    tstatistics.pack()
    txt="Exploration of stripe "+str(x)+"in "+str(typ)+"-direction"
    txt+="width of stripe "+str(var)+"\n"
    txt+="Exploration for "+str(lindic)+"  objects in the selected stripe "+"\n"
    txthilf=""
    for j in range(0,k):
        txthilf+=str(round(meanindic[j],2))+"\t"
    txthilf+="\n"
    txt+="Average values "+txthilf+"\n"
    txthilf=""
    for j in range(0,k):
        txthilf+=str(medianindic[j])+"\t"
    txthilf+="\n"
    txt+="Median values "+txthilf+"\n"
    txthilf=""
    for j in range(0,k):
        txthilf+=str(round(stddevindic[j],2))+"\t"
    txthilf+="\n"
    txt+="standard deviations "+txthilf+"\n"
    txthilf=""
    for j in range(0,k):
        txthilf+=str(maxindic[j])+"\t"
    txthilf+="\n"
    txt+="max-values "+txthilf+"\n"
    txthilf=""
    for j in range(0,k):
        txthilf+=str(minindic[j])+"\t"
    txthilf+="\n"
    txt+="min-values "+txthilf+"\n"
    txt+="\n"
    txt+="+++Note, this part is only meaningful, when the indicators are in the same range++"+"\n"
    txt+="Average discrepancy (discrepancies taken over the data profiles of each object"+"\n"
    txt+="From the differences abs(max - min) (within each data profile) the average is calculated."+"\n"
    txt+="Average discrepancy "+str(round(avdeltaperobj,2))+"\n"
    txt+="\n"
    txt+=" - - -   e o f   - - - "+"\n"
    tstatistics.insert("end",txt)
    
    
    
                
        
    
    

                
## Tkinter Plot
hf = Tkinter.Tk()
hf.title(' GUI: POcdn ')
aboutPOcdn=raioop2.brgabout(hf,"tp1","about_POcdn.txt",4,\
            "Nov., 6th,2014"," about POcdn ", "white", "t1",80,5,ScrolledText)
helpPOcdn=raioop2.brgabout(hf,"tp1","help_POcdn.txt",4,\
            "Nov. 6th,2014"," help_POcdn ", "white", "t1",80,5,ScrolledText)

global etyp,evar,esec    #04.08.2013    
fr=Tkinter.Frame(hf,width=60)
fr.pack()
buttcounting=Tkinter.Button(fr,text="Example of how is counted ",bg="green",width=35,command=count)
buttcounting.pack()
fr2=Tkinter.Frame(hf,relief="sunken",bd=4)
fr2.pack()
buttHD = Tkinter.Button(fr2, text='select, open and HD',width=35,bg="cyan",command=HD)
buttHD.pack(pady=5)

lb1=Tkinter.Label(fr2,text=" ",width=50)
lb1.pack()
buttshow=Tkinter.Button(fr2,text="Show data matrix ",bg="cyan",width=35,command=showDM)
buttshow.pack()
buttshow2=Tkinter.Button(fr2,text="Show equivalence classes ",bg="cyan",width=35,command=showequivalenceclasses)
buttshow2.pack()
buttcdn=Tkinter.Button(fr2,text="PO-coordinates ",bg="cyan",width=35,command=Poc)
buttcdn.pack()

lbinfo=Tkinter.Label(fr2,text="below: entry for vertical or horizontal analysis (v,h)\nallowed variation (1,2,3...)\nvalue of FO or U to begin with")
lbinfo.pack()
etyp=Tkinter.Entry(fr2,width=2)
etyp.pack()
lbwarn4=Tkinter.Label(fr2,text="")
lbwarn4.pack()
evar=Tkinter.Entry(fr2,width=2)
evar.pack()
esec=Tkinter.Entry(fr2,width=4)
esec.pack()
buttsec=Tkinter.Button(fr2,text="Vertical/horizontal\n transsection through FOU-plot",width=35,bg="cyan",command=sectionsthroughFOU)
buttsec.pack()
buttfoustatistics=Tkinter.Button(fr2,text="FOU-statistics ",bg="cyan",width=35,command=FOUstatistics)
buttfoustatistics.pack()
fr3=Tkinter.Frame(hf)
fr3.pack()    
buttexit = Tkinter.Button(fr3, text = 'exit', bg = 'red', width=35,command = hf.destroy)
buttexit.pack(pady=10)

hf.mainloop()

