import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import tkFileDialog
import raioop2
import random
import pstat
import stats

# brg 22.8.2014: SRD analysis after Heberger.
# brg 10.9.2014: To get more functionalities:
#               1. step: Read in dm and derive its HD
#               2. step: LPOMext and the single indicators provide a set of weak orders
#               3. step: These and the weighted sum of normalized indicators will
#                         be the basis for SRD-approach
def fileopen():
    "Informs about the file-operations"
    # Excelreadin4 built in
    # Brg 29.11.07, 30.11.07, 15.1.08,18.2.08
    global fn,x,xn, ob,pr,r,k,prop,obj, txteq,objred, rred, xred
    fn=tkFileDialog.askopenfilename()
    x,ob,pr,r,k=rmod2.EXCELreadin4(fn)
    print "r = ",r
    obj=rmod2.vecgentext1(r)                        #29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  #recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pr[i+1]   #recoding, because pr[0] is a dummy string
    lbopen1.config(bg="yellow")    #18.2.08
    lbopen1["text"]="File "+fn+" was opened with "+str(r)+" rows and "+str(k)+"  columns"
    xn = rmod2.matrixnorm(r,k,x)
    rmod2.matout(r,k,x)
    rmod2.matout(r,k,xn)
    rred,xred,objred,txteq, extlist = rmod2.equivcompactm2(r,k,x,obj,10)
    print "rred = ",rred
    print "extlist= ",extlist
    print "txteq= ",txteq
    return 

def showDM():
    """ New routine : shows the data matrix """
    #Brg 13.1.08, 15.1.08
    #*: 13.1.08
    #akt: 15.1.08
    #note: modified from the routine, taken from simi3
    tp2=Tkinter.Toplevel(hf)
    tp2.title('show DM')
    lbtp2=Tkinter.Label(tp2,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,k):
            txt3+=str(x[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)    

def HD():
    # brg 26.7.2013, 29.8.2013
    # taken from formatHDsimpl01_3.py
    global rred,xred,objred,cov,zeta
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
        #
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    if rred>400:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram  ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()
        buttcov=Tkinter.Button(freq, text = "cover - relation ",width = 20, command = cover)
        buttcov.pack()
        buttequiv = Tkinter.Button(freq,text="show equivalence classes", width = 30,command = showeq)
        buttequiv.pack()
        

def cover():
    hfcover = Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    lbcov = Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbcov.pack()
    txt3 = "\n cover-matrix  \n"
    for i in range(0, rred):
        txt3 += "\n" + objred[i] + ":\t"
        txt3 += "is covered by "
        for j in range(0, rred):
            if i!=j:
                if cov[i][j] == 1:
                    txt3 += " " + objred[j] + " ,"
                else:
                    pass
            else:
                pass
        txt3 += "\n"    
    txt3 += "\n"
    txt3 += " -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)
    

def showeq():
    tpequiv = Tkinter.Toplevel(hf)
    tpequiv.title(" equivalence classes ")
    tequiv=ScrolledText(tpequiv,width=60, height=10)
    tequiv.pack()
    txteq2="Equivalence classes"+"\n"
    txteq2+=50*"="+"\n"
    txteq2+="File: "+str(fn) +"\n"
    txteq2+="equivalence classes: "+str(txteq)
    txteq2+="\n"
    txteq2+="- - - e o f - - -"
    tequiv.insert("end",txteq2)

def indiv_ranks():
    #brg 10.9.2014
    global ind_rank
    ind_rank = rmod2.marray(r,k)
    for j in range(0,k):
        hilf=[]
        for i in range(0, r):
            hilf.append(x[i][j])
        hilf2=pstat.lrankdata(hilf) #see L.Sachs, 7th edition p. 371
        for i2 in range(0,r):
            ind_rank[i2][j]=hilf2[i2]
    rmod2.matout(r,k,ind_rank)        
    
def CI():
    #brg 10.9.2014
    global ci,rankci
    wvec = eweight.get()
    weights1 = wvec.split(",")
    lw=len(weights1)
    weights=[]
    for j in range(0,lw):
        weights1[j]=float(weights1[j])
        weights.append(round(weights1[j],5))
        #print "weights = ",weights[j],
    ci=[]
    for i in range(0,r):
        sumci=0
        for j in range(0,k):
            sumci+=xn[i][j]*weights[j]
        ci.append(sumci)
    print "CI = ",ci
    rankci =pstat.lrankdata(ci)


def hav():
    #Brg 30.9.09, 2.3,2012, 28.7.2012, 23.2.2013
    #taken from LPOM6, 10.9.2014
    global rkav,rkextended, rankhav
    Sa=rmod2.marray1(rred,rred,-1)
    Pa=rmod2.marray1(rred,rred,-1)
    Ua=rmod2.marray1(rred,rred,-1)
    countSa=rmod2.vecgen1(rred)
    countPa=rmod2.vecgen1(rred)
    countUa=rmod2.vecgen1(rred)
    
    for ob in objred:
        obi=objred.index(ob)
        
        #obi the selected element label whose rkav will be deternmined
        z=0
        for i1 in range(0,rred):
            if zeta[i1][obi]==1:
                z+=1
                Sa[obi][i1]=i1
        countSa[obi]=z

    for ob in objred:
        obi=objred.index(ob)
        
        #obi the selected element whose rkav will be deternmined
        z=0
        for i1 in range(0,rred):
            if zeta[obi][i1]==1:
                z+=1
                Pa[obi][i1]=i1
        #print "ob = ",ob,"  its order filter:  ",Pa[obi]
        countPa[obi]=z

    for ob in objred:
        obi=objred.index(ob)
        print "ob= ",ob,"obi= ",obi
        #obi the selected element whose rkav will be deternmined
        z=0
        for i1 in range(0,rred):
            if zeta[i1][obi]==0 and zeta[obi][i1]==0:
                z+=1
                Ua[obi][i1]=i1   #if object with label i1 is incomparable with obi, then Ua[obi][i1] gets just the label i1
        countUa[obi]=z
           
    rkav=rmod2.vecgen1(rred) #LPOMext
    for i2 in range(0,rred):
        rkav[i2]=countSa[i2]  #note Sa includes the interesting element a too
        
    for ob in objred:
        obi=objred.index(ob)
        increment=0
        hilf=rmod2.vecgen1(rred)
        for i in range(0,rred):   #28.7.2012
            hilf[i]=Ua[obi][i]  #28.7.2012
        for i2 in hilf:
            Uy=[]
            Pdown=0
            Pup=0
            
            if i2!=-1:
                for i1 in range(0,rred):
                    if zeta[i1][i2]==0 and zeta[i2][i1]==0:
                        Uy.append(i1)
                        
                
                for i3 in Uy:
                    if i3 in Sa[obi]:
                        Pdown+=1
                            
                for i3 in Uy:
                    if i3 in Pa[obi]:
                        Pup+=1
                
                dinc=1.0*Pdown/(1.0*Pdown+1.0*Pup)
                
                
                
                increment+=dinc
                
        rkav[obi]+=increment
    print "rkav = ",rkav
    print "x in hav  ",x
    rmod2.matout(r,k,x)
    print "  "
    # Now an embedding is needed to get the values not only for rred but for all r elements
    dummy1,dummy2,dummy3,dummy4,eqm_act = rmod2.equivcompactgr(r,k,x,obj)
    print "eqm_act= ",eqm_act
    rkextended = rmod2.weak2(r,obj,objred,rkav, eqm_act)
    print "rkav_extended = ",rkextended
    rankhav=pstat.lrankdata(rkextended)
    print "rankhav= ",rankhav


def make_rankmatrix():
    # brg 10.9.2014
    global rkmatrix
    rkmatrix=rmod2.marray(r,k+2)
    for i in range(0,r):
        for j in range(0,k):
            rkmatrix[i][j] = ind_rank[i][j]
        rkmatrix[i][k] = rankci[i]
        rkmatrix[i][k+1] = rankhav[i]
    rmod2.matout(r,k+2,rkmatrix)

def SRD():
    # brg 10.9.2014
    global srd, anz, whichwithwhich,model
    count_rankings = k+2 #k ranks due to single attributes,ranks due to CI, ranks due to rkav
    anz = int(1.0*count_rankings*(count_rankings - 1.0)/2.0)
    rksum = rmod2.vecgen1(anz)
    srd = rmod2.vecgen1(anz)
    model=rmod2.vecgen1(k+2)
    for j in range(0,k):
        model[j]=prop[j]
    model[k]="CI"
    model[k+1]="hav"
    whichwithwhich = []
    zahl = 0
    for j1 in range(0, count_rankings):
        for j2 in range(j1+1,count_rankings):
            whichwithwhich.append((model[j1],model[j2]))
            for i3 in range(0, r):
                rksum[zahl] += abs(rkmatrix[i3][j1]-rkmatrix[i3][j2])
            zahl+=1
    for i in range(0, anz):
        srd[i] = rksum[i]
    print "SRD = ",srd

def SDRmax():
    # brg 24.8.2014
    h = ""

    if 1.0 * r / 2.0 == int(1.0 * r/ 2.0):
        h =" n is even"
        SRDmax = 1.0 * r * r / 2.0
    else:
        h = "n is odd"
        SRDmax = 1.0  *(r * r - 1) / 2.0
    return SRDmax     



def show_SRD_results():
    # brg 22.8.2014, 24.8.2014
    sdrmax = SDRmax()
    tpresult=Tkinter.Toplevel(hf)
    tpresult.title("results of SRD ")
    tresult = ScrolledText(tpresult, width = 80, height=10)
    tresult.pack()
    txt = " SRD " +"\n"
    txt+= 50*"=" +"\n"
    txt+=" data matrix: "+str(fn)+"\n"
    txt+=" Number of comparisons: "+str(anz)+"\n"    
    txt+=" Number of objects "+str(r)+"\n"
    txt+=" Number of models/methods "+str(k+2)+"\n"
    txt+=" SRDmax = "+str(sdrmax)+"\n"
    txt+=" Matrix of the ranks due to "+str(k+2)+"  models"+"\n"
    txt+="\t"
    for j in range(0,k+2):
        txt+=str(model[j])+"\t"
    txt+="\n"    
    for i in range(0, r):
        txt+=str(obj[i])+"\t: "
        for j in range(0, k+2):
            txt+=str(rkmatrix[i][j])+"\t"
        txt+="\n"    
    txt+="\n"
    txt+=" SRD :"+ "\n"
    for i in range(0, anz):
        txt+=str(whichwithwhich[i])+": "
        txt+=str(srd[i]) +"\n"
    txt+="SRD/SRDmax "+"\n"
    for i in range(0, anz):
        txt+=str(whichwithwhich[i])+": "
        txt+=str(round(1.0*srd[i]/(1.0*sdrmax),2)) +"\n"
    txt+="- - -     e o f  - - "
    tresult.insert("end",txt)             
        


hf = Tkinter.Tk()
hf.title(' SRD ')
aboutHDCI=raioop2.brgabout(hf,"tp1","about_SRD.txt",1,\
            "September, 10th, 2014"," about SRD ", "white", "t1",80,5,ScrolledText)
helpHDCI=raioop2.brgabout(hf,"tp1","help_SRD.txt",1,\
            "September, 10th, 2014"," help_SRD ", "white", "t1",80,5,ScrolledText)
lbopen1=Tkinter.Label(hf, text = " ")
lbopen1.pack(pady=5)
lb2=Tkinter.Label(hf,text="")
lb2.pack()
buttreadin = Tkinter.Button(hf,text ="Readin the data matrix",bg="cyan", width=40, command=fileopen)
buttreadin.pack()
buttshowdm = Tkinter.Button(hf, text = "Show data matrix",bg="cyan",width=40,command=showDM)
buttshowdm.pack()
buttHD = Tkinter.Button(hf,text="Hassediagram",bg="cyan",width=40,command=HD)
buttHD.pack()
buttiR = Tkinter.Button(hf, text="Ranks of each attribute",bg="cyan",width=40,command=indiv_ranks)
buttiR.pack()
lbweight=Tkinter.Label(hf,text="Entryfield for weights in order to calculate the CI")
lbweight.pack()
eweight=Tkinter.Entry(hf,width=20)
eweight.pack()
buttCI=Tkinter.Button(hf,text="CI corresp. to the weights ([0,1]-normalized attributes)",bg="cyan",width=40,command=CI)
buttCI.pack()
butthav=Tkinter.Button(hf,text="Average ranks (LPOMext)",bg="cyan",width=40,command=hav)
butthav.pack()
buttmake=Tkinter.Button(hf,text="Final rankings-matrix ",bg="cyan",width=40,command=make_rankmatrix)
buttmake.pack()
buttcalc = Tkinter.Button(hf,text="calculate the SRD-values ",bg="cyan",width=40,command=SRD)
buttcalc.pack()
buttshow = Tkinter.Button(hf, text = "show the SRD -results ",bg="cyan",width=40, command=show_SRD_results)
buttshow.pack(pady=3)



buttexit = Tkinter.Button(hf, text =" Exit ",bg="red",width=30, bd=3,command = hf.destroy)
buttexit.pack(pady=3)
hf.mainloop()
