import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import tkFileDialog
import raioop2
import random
import pstat
import stats

# brg 22.8.2014: SRD analysis after Heberger.
# brg 10.9.2014: now renamed into SRDsimpl1_2.py as a
#                module will be developed with more functionalities
# brg 13.9.2014: help-text extended, SRD-calculation simplified

def howmany_rankings():
    # brg 22.8.2014
    global count_rankings
    count_rankings = int(ecount_rankings.get())
    print "count_rankings = ",count_rankings


def readin_rankings():
    # brg 22.7.2014
    global count_rankings, number_of_ranks, rkmatrix, fns
    print "count_rankings in 'readin_rankings'",count_rankings
    rkmatrix = []
    fns = []
    for i in range(0, count_rankings):
        lb2.config(text=str(i+1)+"th readin of "+str(count_rankings), bg="yellow")
        fn=tkFileDialog.askopenfilename()
        fns.append(fn)
        f=open(fn,'r')
        s=f.readline()
        n=int(s)
        print "n= ",n
        x=f.readline()
        f.close()
        print "x= ",x
        
        rk = x.split(",")
        print "rk= ",rk
        rkpur = [] 
        for i1 in range(0, len(rk)):
            if rk[i1] != "":
                rkpur.append(float(rk[i1]))
        print "i= ",i,"  rk= ",rkpur
        number_of_ranks = len(rkpur)
        rankx = pstat.rankdata(rkpur)
        print "i",i," rank = ",rankx


        rkmatrix.append(0)
        rkmatrix[i] = []
        for i2 in range(0, len(rkpur)):
            rkmatrix[i].append(rankx[i2])
    rmod2.matout(count_rankings,len(rkpur),rkmatrix)
    

def SDR():
    # brg 22.8.2014, 13.9.2013
    global anz, srd, whichwithwhich
    anz = int(1.0*count_rankings*(count_rankings - 1.0)/2.0)
    srd = rmod2.vecgen1(anz)
    whichwithwhich = []
    zahl = 0
    for i1 in range(0, count_rankings):
        for i2 in range(i1+1,count_rankings):
            whichwithwhich.append((i1,i2))
            for j in range(0, number_of_ranks):
                srd[zahl] += abs(rkmatrix[i1][j]-rkmatrix[i2][j])
            zahl+=1
    print "SRD = ",srd

def SDRmax():
    # brg 24.8.2014
    h = ""

    nr = number_of_ranks # just to have a short label
    if 1.0 * nr / 2.0 == int(1.0 * nr/ 2.0):
        h =" n is even"
        SRDmax = 1.0 * nr * nr / 2.0
    else:
        h = "n is odd"
        SRDmax = 1.0  *(nr * nr - 1) / 2.0
    return SRDmax     



def show_results():
    # brg 22.8.2014, 24.8.2014
    sdrmax = SDRmax()
    tpresult=Tkinter.Toplevel(hf)
    tpresult.title("results of SRD ")
    tresult = ScrolledText(tpresult, width = 60, height=5)
    tresult.pack()
    txt = " SRD " +"\n"
    txt+= 50*"=" +"\n"
    txt+=" Files used"+"\n"
    for i in range(0, count_rankings):
        txt+=str(i)+" "+str(fns[i])+"\n"
    txt+=" Number of comparisons: "+str(anz)+"\n"    
    txt+=" Rankings: Background info"+"\n"
    txt+=" Number of ranks "+str(number_of_ranks)+"\n"
    txt+=" Number of models/methods "+str(count_rankings)+"\n"
    txt+=" SRDmax = "+str(sdrmax)+"\n"
    for i in range(0, count_rankings):
        txt+=str(i)+"\t: "
        for j in range(0, number_of_ranks):
            txt+=str(rkmatrix[i][j])+", "
        txt+="\n"    
    txt+="\n"
    txt+=" SRD :"+ "\n"
    for i in range(0, anz):
        txt+=str(whichwithwhich[i])+": "
        txt+=str(srd[i]) +"\n"
    txt+="SRD/SRDmax "+"\n"
    for i in range(0, anz):
        txt+=str(whichwithwhich[i])+": "
        txt+=str(round(1.0*srd[i]/(1.0*sdrmax),2)) +"\n"
    txt+="- - -     e o f  - - "
    tresult.insert("end",txt)             
        


hf = Tkinter.Tk()
hf.title(' SRD ')
aboutHDCI=raioop2.brgabout(hf,"tp1","about_SRDsimpl.txt",1,\
            "August, 24nd, 2014"," about SRDsimpl ", "white", "t1",80,5,ScrolledText)
helpHDCI=raioop2.brgabout(hf,"tp1","help_SRDsimpl.txt",1,\
            "August, 24nd, 2014"," help_SRDsimpl ", "white", "t1",80,5,ScrolledText)
lb1=Tkinter.Label(hf, text = "Enter the number of rankings to be studied")
lb1.pack(pady=5)
ecount_rankings = Tkinter.Entry(hf, width=3)
ecount_rankings.pack()
buttsubmit_count = Tkinter.Button(hf, text="submit your input ",width=30, bg="cyan",command=howmany_rankings)
buttsubmit_count.pack()
lb2=Tkinter.Label(hf,text="")
lb2.pack()
buttreadin = Tkinter.Button(hf,text ="Readin the files with the rankings",bg="cyan", width=30, command=readin_rankings)
buttreadin.pack()
buttcalc = Tkinter.Button(hf,text="calculate the SRD-values ",bg="cyan",width=30,command=SDR)
buttcalc.pack()
buttshow = Tkinter.Button(hf, text = "show the results ",bg="cyan",width=30, command=show_results)
buttshow.pack(pady=3)



buttexit = Tkinter.Button(hf, text =" Exit ",bg="red",width=30, bd=3,command = hf.destroy)
buttexit.pack(pady=3)
hf.mainloop()
