# -*- coding: cp1252 -*-
import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import tkFileDialog
import raioop2
import itertools
import random

#Brg in cooperation with Korbinian Freier, MPI Hamburg, 2.10. and 3.10.09
# Brg 28.7.2012, 29.7.2012, 31.7.2012, 9.8.2012 (FOU: corrected)
# brg 12.8.2012

def HD():
    """based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"""
    # Brg 20.12.07, 28.12.07, 2.10.,3.10.09
    # If the number of representants > 70 then only the cover-matrix and the level-population
    #
    global dm,objred,prop,rred,k,zeta,fn
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    
    fn=tkFileDialog.askopenfilename()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    lb1.config(text="opened "+fn,bg="yellow")
    

    prop=[]
    for j in range(0,k):
        prop.append(pro[j+1])
            
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
    for i in range(0,r):
        obj[i]=ob[i+1]

    # after opening the evaluation buuttons can be active 
    buttsingleobject.config(state="active")
    buttFOU.config(state="active")
    buttpattern.config(state="active")
    # end of activation

    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,dm,obj)  
    
    #
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    if rred>100:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram  ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()


def showDM():
    """ New routine : shows the data matrix """
    #Brg 13.1.08, 31.7.2012 taken from mainHD20_3
    
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    
    tp2=Tkinter.Toplevel(hf)
    tp2.title('showDM')
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack(expand=1,fill="both")
    #dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+ob[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=ob[i+1]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)


def soa():
    # brg 28.7.2012
    # soa = single object analysis
    tpso=Tkinter.Toplevel(hf)
    tpso.title(' single objects ')
    lbso=Tkinter.Label(tpso,text="")
    lbso.pack()
    tso=ScrolledText(tpso,width=60,height=10)
    tso.pack()
    so=esingleobject.get()
    if so in objred:
        lbso.config(text=str(so)+" is a correct selection ")
        iob=objred.index(so)
        txthilf=""
        for j in range(0,k):
            txthilf+=str(round(dm[iob][j],5))+", "
        txthilf+="\n"    
        uso=0
        for j in range(0,rred):
            if zeta[iob][j]==0 and zeta[j][iob]==0:
                uso+=1
        succ=0
        for j in range(0,rred):
            if zeta[j][iob]==1:
                succ+=1
        pred=0
        for j in range(0,rred):
            if zeta[iob][j]==1:
                pred+=1

        lessthan=rmod2.vecgen1(k)
        equalwith=rmod2.vecgen1(k)
        greaterthan=rmod2.vecgen1(k)
        
        for j in range(0,k):
            for i in range(0,rred):
                if i!=iob:
                    if dm[i][j]<dm[iob][j]:
                        lessthan[j]+=1
                    if dm[i][j]==dm[iob][j]:
                        equalwith[j]+=1
                    if dm[i][j]>dm[iob][j]:
                        greaterthan[j]+=1
                    
        probU=rmod2.marray1(k,k,-1)
        for j in range(0,k):
            for j1 in range(0,k):
                if j!=j1:
                    probU[j][j1]=1.0*lessthan[j]*greaterthan[j1]/((rred-1)*(rred-1))
                
        maxU=-999999
        minU=999999
        for j in range(0,k):
            for j1 in range(0,k):
                if j!=j1:
                    if probU[j][j1]>maxU:
                        maxU=probU[j][j1]
                    if probU[j][j1]<minU:
                        minU=probU[j][j1]
        print "minU = ",minU,"  maxU = ",maxU
        Umaxestim=maxU*(rred-1)
        Uminestim=minU*(rred-1)

        txthilf2=""
        mwvec=rmod2.vecgen1(k)
        for j in range(0,k):
            for i in range(0,rred):
                if i!=iob:
                    mwvec[j]+=dm[i][j]
            mwvec[j]=1.0*mwvec[j]/(rred-1.0)
            txthilf2+=str(round(mwvec[j],3))+", "
        txthilf2+="\n"    

        txthilf3=""
        txthilf4=""
        mwvecup=rmod2.vecgen1(k)
        mwvecdown=rmod2.vecgen1(k)
        zup=0
        zdown=0
        for j in range(0,k):
            for i in range(0,rred):
                if dm[i][j]>dm[iob][j]:
                    zup+=1
                    mwvecup[j]+=dm[i][j]
                if dm[i][j]<dm[iob][j]:
                    zdown+=1
                    mwvecdown[j]+=dm[i][j]
            if zup>0:    
                mwvecup[j]=1.0*mwvecup[j]/zup
                txthilf3+=str(round(mwvecup[j],3))+", "
            else:
                txthilf3+="not def."+", "
            if zdown>0:
                mwvecdown[j]=1.0*mwvecdown[j]/zdown
                txthilf4+=str(round(mwvecdown[j],3))+", "
            else:
                txthilf4+="not def."+", "
                
        txthilf3+="\n"
        txthilf4+="\n"
                              
                
        txt="Analysis of the single object "+str(so)+"\n"
        txt+=60*"="+"\n"
        
        txt+="\n"+"Basic information \n"
        txt+="Number of representants: "+str(rred)+"\n"
        txt+="number of indicators (attributes )"+str(k)+"\n"
        txt+="U(    "+str(so)+")= "+str(uso)+"\n"
        txt+="succ( "+str(so)+"}= "+str(succ-1)+"\n"
        txt+="pred( "+str(so)+")= "+str(pred-1)+"\n"
        txt+="Data profile: "+"\n"
        txt+=txthilf+"\n"
        txt+="Average values taken over all o t h e r objects: "+"\n"
        txt+=txthilf2+"\n"
        txt+="average values taken over all objects q(j)> q(j,"+so+")\n"
        txt+=txthilf3+"\n"
        txt+="\naverage values taken of all objects q(j) < q(j,"+so+")\n"
        txt+=txthilf4+"\n"
        
        txt+="\n"
        txt+="\n"+"Information related to each single indicator "+"\n"
        for j in range(0,k):
           txt+=str(prop[j])+"\t: # objects < object "+so+": "+str(lessthan[j])+"\n"
           txt+="\t"+": # objects > object "+so+": "+str(greaterthan[j]) +"\n"

        txt+="\n probU-matrix "+"\n"
        txt+="\t"
        for j in range(0,k):
           txt+=str(prop[j])+"\t"
        
        for j in range(0,k):
           txt+="\n"+str(prop[j])+"\t"
           for j1 in range(0,k):
               if probU[j][j1]==-1:
                   txt+="..."+"\t"
               else:    
                   txt+=str(round(probU[j][j1],2))+"\t"
           txt+="\n"

        txt+="\n"
        txt+="estimated Umax "+str(round(Umaxestim,2))+"\n"
        txt+="estimated Umin "+str(round(Uminestim,2))+"\n"
        txt+="\n"
        tso.insert("end",txt)
        # graphics
        
        tpgraphics=Tkinter.Toplevel(hf)
        cvso=Tkinter.Canvas(tpgraphics,width=600,height=600,bg="white") #changed from tpso to tpgraphics
        cvso.pack()
        deltaline=40
        textobject=cvso.create_text(300,30,text="object= "+str(so))
        if k<=12:
            for j in range(0,k):
                textvso=cvso.create_text(50,100+j*deltaline,text=str(prop[j]))
                linev0=cvso.create_line(100,100+j*deltaline,500,100+j*deltaline)
                linev1=cvso.create_line(100,100+j*deltaline+10,100,100+j*deltaline-10)
                linev2=cvso.create_line(500,100+j*deltaline+10,500,100+j*deltaline-10)
                leftpart=400.0*lessthan[j]/(1.0*greaterthan[j]+1.0*lessthan[j])
                rightpart=300.0*greaterthan[j]/(1.0*greaterthan[j]+1.0*lessthan[j])
                lineobj=cvso.create_line(100+leftpart,100+j*deltaline+18,100+leftpart,100+j*deltaline-18,width=10,fill="red")
                textleftpart=cvso.create_text(100+0.5*leftpart,100+j*deltaline-10,text=str(lessthan[j]))
                textrightpart=cvso.create_text(500-0.5*rightpart,100+j*deltaline-10,text=str(greaterthan[j]))
        else:
           kl=int(1.0*k/6.0)+1
           tpgr=rmod2.vecgen1(kl)
           cvso2=rmod2.vecgen1(kl)
           for j0 in range(0,kl):
               tpgr[j0]=Tkinter.Toplevel(hf)
               tpgr[j0].title(str(j0+1)+"th group of attributes ")
               cvso2[j0]=Tkinter.Canvas(tpgr[j0],width=600,height=600,bg="white")
               cvso2[j0].pack()
               deltaline=50
               jz=0
               for j in range(j0*6,(j0+1)*6):
                    if j<k:
                        textobject=cvso2[j0].create_text(300,30,text="object= "+str(so))
                        textvso=cvso2[j0].create_text(50,100+jz*deltaline,text=str(prop[j]))
                        linev0=cvso2[j0].create_line(100,100+jz*deltaline,500,100+jz*deltaline)
                        linev1=cvso2[j0].create_line(100,100+jz*deltaline+10,100,100+jz*deltaline-10)
                        linev2=cvso2[j0].create_line(500,100+jz*deltaline+10,500,100+jz*deltaline-10)
                        leftpart=400.0*lessthan[j]/(1.0*greaterthan[j]+1.0*lessthan[j])
                        rightpart=300.0*greaterthan[j]/(1.0*greaterthan[j]+1.0*lessthan[j])
                        lineobj=cvso2[j0].create_line(100+leftpart,100+jz*deltaline+18,100+leftpart,100+jz*deltaline-18,width=10,fill="red")
                        textleftpart=cvso2[j0].create_text(100+0.5*leftpart,100+jz*deltaline-10,text=str(lessthan[j]))
                        textrightpart=cvso2[j0].create_text(500-0.5*rightpart,100+jz*deltaline-10,text=str(greaterthan[j]))
                        jz+=1
                   
    else:
        lbso.config(text="+++ wrong object name/label/id ")
           
       
       
            
def FOUplot():
    #11.11.09, 6.11.2011, 6.7.2012,7.7.2012
    # 30.7.2012 taken from mainHD20_3
    so=esingleobject.get()
    tprkuplot=Tkinter.Toplevel(hf)
    tprkuplot.title('scatterplot O-F vs U:  "FOU-plot" ')
    lbrku=Tkinter.Label(tprkuplot,text="")
    lbrku.pack()  
    if so in objred:
        lbrku.config(text="object selected = "+str(so),bg="yellow" )
        tprkuplot.title('scatterplot O-F vs U:  "FOU-plot" ')
        global FOU,cvfou,frrkuplot,basiskdn,scattplot  #5.7.2012 frrkuplot, basiskdn, scattplot added
        
        basiskdn=rmod2.vecgen1(6) #5.7.2012
          
        FOU=rmod2.marray(rred,3)#FOU[0]=U FOU[1]=O, FOU[2]=F
        scattplot=rmod2.marray(rred,2)
        for i in range(0,rred):
            for j in range(0,rred):
                if zeta[i][j]==1:
                    FOU[i][2]+=1
                    
        for j in range(0,rred):
            for i in range(0,rred):
                if zeta[i][j]==1:
                    FOU[j][1]+=1
                    
        for i in range(0,rred):
            for j in range(0,rred):
                if zeta[i][j]==0 and zeta[j][i]==0:
                    FOU[i][0]+=1
            
        rmod2.matout(rred,3,FOU)
        for i in range(0,rred):
            scattplot[i][0]=FOU[i][1]-FOU[i][2]     #O-F
            scattplot[i][1]=FOU[i][0] #U
        
        frrkuplot=Tkinter.Frame(tprkuplot,width=500,height=500)
        frrkuplot.pack()
        maxdmx=-9999
        mindmx=9999
        for i in range(0,rred):
            if scattplot[i][0]>=maxdmx:
                maxdmx=scattplot[i][0]
            if scattplot[i][0]<=mindmx:
                mindmx=scattplot[i][0]
                
        maxdmy=-9999
        for i in range(0,rred):
            if scattplot[i][1]>=maxdmy:
                maxdmy=scattplot[i][1]

        #print maxdmx," ",maxdmy," ",mindmx
        maxxaxis=max(maxdmx,abs(mindmx))
        dy=1
        zahl=0
        while maxdmy%10!=0:
            maxdmy+=dy
            if zahl>7:
                break
        dx=1
        zahl=0
        while maxxaxis%10!=0:
            maxxaxis+=dx
            if zahl>7:
                break


        #print "corrected maxdmy= ",maxdmy, "  corrected maxxaxis ",maxxaxis
        cvfou=Tkinter.Canvas(frrkuplot,width=500,height=450,bg="white")
        xleft=50
        ybasis=420  #410
        xbasis=400
        ybereich=400
        mitte=xleft+(1.0*xbasis)*0.5
        xright=xbasis+xleft
        print "mitte= ",mitte,"   xright= ",xright
        liy=cvfou.create_line(mitte,ybasis,mitte,10,arrow="last",width=2,fill="red")
        lix=cvfou.create_line(xleft,ybasis,xleft+xbasis+10,ybasis,arrow="last",width=2,fill="red")

        anzxg=int(1.0*(xright-mitte)/10.0)
        dx=int(1.0*xbasis/(2.0*anzxg))
        print "anzg= ",anzxg,"   dx= ",dx
        for i in range(0,anzxg+1):
            ligridx=cvfou.create_line(mitte-dx*i,ybasis,mitte-dx*i,20)

        for i in range(0,anzxg+1):
            ligridx=cvfou.create_line(mitte+dx*i,ybasis,mitte+dx*i,20)

            

        anzyg=int((1.0*ybereich)/40.0)
        for i in range(0,anzyg):
            ligridy=cvfou.create_line(xleft,ybasis-40*i,xleft+xbasis,ybasis-40*i)
            

        axleft=1.0*(mitte-xleft)/(1.0*maxxaxis)
        bxleft=mitte # = bxright

        axright=1.0*xbasis/(2.0*maxxaxis)

        ay=-1.0*ybereich/maxdmy
        by=ybasis
        basiskdn[0]=ay
        basiskdn[1]=by
        basiskdn[2]=axright
        basiskdn[3]=bxleft
        basiskdn[4]=axleft
       
        for i in range(0,rred):
            if scattplot[i][0]<=0:
                xg=axleft*scattplot[i][0]+bxleft
            else:
                xg=axright*scattplot[i][0]+bxleft
            yg=ay*scattplot[i][1]+by
            if objred[i]!=so:
                ci=cvfou.create_oval(xg-3,yg+3,xg+3,yg-3,fill="red",tags="object_"+objred[i])
            else:
                ci=cvfou.create_oval(xg-3,yg+3,xg+3,yg-3,fill="blue",tags="object_"+objred[i])
                
        xt1=xleft-10
        yt1=ybasis+10
        ctext1=cvfou.create_text(xt1,yt1,text="-"+str(maxxaxis))
        xt2=xright+10
        yt2=ybasis+10
        ctext2=cvfou.create_text(xt2,yt2,text="+"+str(maxxaxis))
        xt3=mitte
        yt3=7
        ctext3=cvfou.create_text(xt3,yt3,text=str(maxdmy))
        xt4=mitte+150
        yt4=ybasis+10
        ctext4=cvfou.create_text(xt4,yt4,text="|O(x)|-|F(x)|")
        xt5=mitte+20
        yt5=20
        ctext5=cvfou.create_text(xt5,yt5,text="|U(x)|")
        cvfou.pack()
    else:
        lbrku.config(text="+++ wrong object id/label(/name ++",bg="red")



def pattern():
    # brg 30.7.2012
    # first step: which patterns are realized
    import random
    global pattern,patcount,anz
    so=esingleobject.get()
    flag=1
    if so in objred:
        iob=objred.index(so)
        pattern=rmod2.marray(rred,k)
        
        for i in range(0,rred):
            for j in range(0,k):
                if dm[i][j]>dm[iob][j]:
                    pattern[i][j]=1
                if dm[i][j]==dm[iob][j]:
                    pattern[i][j]='*'
                    
                if dm[i][j]<dm[iob][j]:
                    pattern[i][j]=0
            if random.random()>0.7:        
                print "randomly selected: ", objred[i]," pattern ",pattern[i]
            #print pattern[i]        
        # second step: which objects incomparable with the selected one, check
        # ....the pattern:
        # 1 in prop[j] : object > selected object,
        # 0 in prop[j] : object < selected object,
        # * in prop[j] : object = selected object)
        #print "k = ",k
        zahl=0
        for jper in itertools.product((0,1,'*'), repeat=k):
            zahl+=1
        anz=zahl
        #print "Count of comb with repetitions ",anz
        patternbit=rmod2.marray(anz,3)
        for j in range(0,anz):  #Default
            patternbit[j][0]=2

            
        maxpatterncount=0 #successful pattern-coincidence
        zahl=0  #count all possible patterns
        countincomppattern=0
        patcount=rmod2.vecgen1(anz)
        
        for jper in itertools.product((0,1,'*'), repeat=k):
            objcount=0
            txt=""
            
            #print "generated pattern= ",jper
            if 1 in jper and 0 in jper:
                countincomppattern+=1
                #print "pattern of an incomparable element"
                for i in range(0,rred):
                    
                    flagpattern=1
                    for j1 in range(0,k):
                        if pattern[i][j1]!=jper[j1]:
                            flagpattern=0
                        
                    if flagpattern==1:
                        #print i,"  pattern = ",pattern[i]," ==?== ",jper
                        patternbit[zahl][0]=1
                        #print "zahl= ",zahl, "patternbit = ",patternbit[zahl][0]
                        patternbit[zahl][1]=jper
                        txt+=str(objred[i])+", "
                        patternbit[zahl][2]=txt
                        
                        maxpatterncount+=1
                        objcount+=1
                    else:
                        patternbit[zahl][1]=jper
                patcount[countincomppattern]=(jper,objcount)        
                #print "maxpatterncount = ",maxpatterncount       
            zahl+=1            
    else:
        txtout="+++Sorry: wrong id/label/name of object +++"
        flag=0
    
##    for jhilf in range(0,anz):
##        print patternbit[jhilf][0]," ",patternbit[jhilf][1]," ",patternbit[jhilf][2]
    
##    for j in range(0,anz):
##        print patcount[j]
##
    
    
    tppatter=Tkinter.Toplevel(hf)
    tppatter.title("pattern of incomparables ")
    tpatter=ScrolledText(tppatter,width=60,height=10)
    tpatter.pack()
    if flag!=0:
        txtout="Pattern of objects incomparable with "+str(so)+"\n"
        txtout+=60*"-" + "\n"
        for j in range(0,anz):            
            if patternbit[j][0]==1:
                txtout+=str(patternbit[j][1])+" "+str(patternbit[j][2])+"\n"
            
        txtout+="\n"
        buttequal=Tkinter.Button(tppatter,text="Equalities",width=12,command=equal)
        buttequal.pack()
        buttpatpop=Tkinter.Button(tppatter,text="pattern population ",width=12, command=patpot)
        buttpatpop.pack()

    else:
        txtout+="Correct objectnames are: "+"\n"
        for i in range(0,rred):
            txtout+=str(objred[i])+", "
        txtout+="\n"    
            
    tpatter.insert("end",txtout)
    

def patpot():
    # brg 31.7.2012
    global anz,patcount,lpp
    tppopul=Tkinter.Toplevel(hf)
    tpopul=ScrolledText(tppopul,width=60,height=10)
    tpopul.pack()
    so=esingleobject.get()
    if so in objred:
        lpp=len(patcount)
        txth=""
        txth+="Population of incomparables along the incomparable-pattern "+"\n"
        txth+=60*"-"+"\n"
        for j in range(0,lpp):
            if patcount[j]!=0:
                txth+=str(patcount[j][0])+"\t\t"+": "+str(patcount[j][1])+"\n"
        txth+="\n"
        txth+=" - - - e o f - - -"
        tpopul.insert("end",txth)
        buttbar=Tkinter.Button(tppopul, text="bardiagram ",width=12,command=bar)
        buttbar.pack()
    else:
        txth="+++Sorry wrong object-label +++"
        tpopul.insert("end",txth)


def bar():
    # brg 31.7.2012
    pat1=[]
    pat2=[]
    for j in range(0,lpp):
        if patcount[j]!=0:
            pat1.append(patcount[j][0])
            pat2.append(patcount[j][1])
    app1=raioop2.brgbar10(hf,pat2,pat1,"Population of incomparable_pattern ",5,"red")
    app1.ausgabe()
    
    



def equal():
    # brg 30.7.2012
    tpequal=Tkinter.Toplevel(hf)
    tpequal.title('list of objects partially equal to the selected object')
    tequal=ScrolledText(tpequal,width=60,height=10)
    tequal.pack()
    txtout2=" Partially equal elements "+"\n"
    for i in range(0,rred):
        if "*" in pattern[i] and 1 in pattern[i] and 0 in pattern[i]:
            txtout2+=objred[i]+": "
            for j in range(0,k):
                txtout2+=str(pattern[i][j])+", "
            txtout2+="\n"
    tequal.insert("end",txtout2)        
            
            
    





## Tkinter Plot
hf = Tkinter.Tk()
hf.title(' singleobjects_analysis ')
aboutHDsimpl=raioop2.brgabout(hf,"tp1","about_singleobjectsanalysis.txt",4,\
            "August, 12th,2012"," about singleobjects ", "white", "t1",80,5,ScrolledText)
helpHDsimpl=raioop2.brgabout(hf,"tp1","help_singleobjectsanalysis.txt",4,\
            "August, 12th,2012"," help_singleobjectanalysis ", "white", "t1",80,5,ScrolledText)
    
fr=Tkinter.Frame(hf,width=60)
fr.pack()
buttHD = Tkinter.Button(fr, text='select, open and HD',width=30,bg="cyan",command=HD)
buttHD.pack(pady=5)
lb1=Tkinter.Label(fr,text=" ",width=50)
lb1.pack()
buttshowdm=Tkinter.Button(fr, text= "show data matrix ",width=30,command=showDM)
buttshowdm.pack()
lbsingleobject=Tkinter.Label(fr,text="Enter id of object of interest ")
lbsingleobject.pack()
esingleobject=Tkinter.Entry(fr,width=10)
esingleobject.pack()
buttsingleobject=Tkinter.Button(fr,text="Analysis concerning a single object",bg="cyan",width=30,state="disabled",command=soa)
buttsingleobject.pack()
buttFOU=Tkinter.Button(fr,text="FOU-plot ",bg="cyan",width=30,state="disabled", command=FOUplot)
buttFOU.pack()
buttpattern=Tkinter.Button(fr,text="Pattern of incomparables ",bg="cyan",width=30,state="disabled",command=pattern)
buttpattern.pack()
buttexit = Tkinter.Button(fr, text = 'exit', bg = 'red', width=30,command = hf.destroy)
buttexit.pack(pady=10)

hf.mainloop()

