# -*- coding: cp1252 -*-
import Tkinter
import rmod2
import raioop2
from ScrolledText import *
import tkFileDialog
import math

import Canvas
import os
import pstat
import stats
import csv
from string import replace
import random



# 29.11.2013: Enrich1 derived from ACsimpl1.py
# 30.11.2013
# Because of transitivity the ul,ol,mw taken from all pairs which fulfill the delta condition for a certain qi
# After many trials (see toward_enrich18...py  now the needed cluster analysis
# 8.12.2013,
# 9.12.2013
# 11.12.2013 Totalenrich1.py derived from Enrich3: Basic idea:
#............Not only the differences among incomparable pairs but all differences may be changed
# ...........when the difference < delta.
# 14.12.2013 Show the partitions
# 20.12.2013 Save the modified matrix
# 28.2.2014: steps to obtain pep8 conformity
# 20.4.2014: The user may want to find that delta, by which a reduction
#             of incomparabilities is obtained.
# 22.1.2015: Replace some algorithms by those in Improvement_totalenrich10.py
#           Presentation of real partitionings
#           Usually the mean value is selected, hence the ul and ll-variants will be eliminated

################# start of new procedures #########################
def attributecluster(x,obj,delta):
    # brg 20.1.2015
    # x is the vector of one attribute
    # obj is the list of objectnames
    # delta is the limit to cluster. data differences <=delta will be
    # ..... consiudered as irrelevant and replaced by a mean value.
    # return partpur, avsum
    r=len(obj)
    xn,sort = rmod2.raisort(r,x)
    objsort=[]
    for i in range(0,r):
        objsort.append(obj[sort[i]])

    partset=rmod2.vecgen1(r)
    for i in range(0,r):
        partset[i] = set([])

    count=0
    partset[count].add(objsort[0])
    for i in range(0,r-1):
        if round(xn[i+1],9)-round(xn[i],9)<=round(delta,9):
            partset[count].add(objsort[i+1])
        else:
            count+=1
            partset[count].add(objsort[i+1])


    #purification
    partpur=[]
    for i in range(0,r):
        if len(partset[i])>0:
            partpur.append(partset[i])

    avsum = []                        
    lp=len(partpur)
    for i in range(0, lp):
        hilf = 0
        for elem in partpur[i]:
            iob = objsort.index(elem)
            hilf+=x[iob]
        avsum.append(1.0*hilf/(1.0*len(partpur[i])))
    return partpur, avsum

def data_assignment(obj,partpur, avs):
    # brg 20.1.2015
    # obj: list of all objects
    # partpur result of attributecluster,
    # avs: averagevalues, result of attributecluster
    # return new data, xav, sorted for increasing order for the clusters
    # ...whe four clusters are found, then xav has four values
    # return xnv new data for all objects
    lp = len(partpur)
    xav=[]
    xnv=[]
    for i in range(0,lp):
        xav.append(avs[i])
        for elem in partpur[i]:
            xnv.append(xav[i])
    return xav,xnv

def resort(obj,partpur, xav):
    # brg 20.1.2015
    # obj: list of all objects
    # partpur result of attribute cluster in terms of objects clustered
    # xav values of all objects , however the sequence is according to the sequence
    #..... the objects occur in partpur
    # xnew data in correct original sequence corresponding to obj
    lp = len(partpur)
    # New for total enrich
    xnew = []
    for i in range(0, len(obj)):
        for i1 in range(0,lp):
            if obj[i] in partpur[i1]:
                xnew.append(xav[i1])

    return xnew    

# use of the three procedures for  o n e  attribute;
##x = [0.1,0.5,0,0.7,0.72, 0.2,1.0,0.11]
##obj = ["a","b","c","d","e","f","g","h"]
##delta=0.095
##r = 8
##partitioning, avs_act = attributecluster(x,obj,delta)
##print "paritioning ", partitioning
##print "avs_act = ",avs_act
##xav_act,xnv_act=data_assignment(obj,partitioning,avs_act)
##print "xnv_act ",xnv_act
##xnew_act = resort(obj,partitioning,xav_act)
##for i in range(0,r):
##    print obj[i]," ",xnew_act[i]
#################################### end of new procedures ###########

def xselectfile():
    # brg 6.8.2013, 25.11.2013 (taken from fuzzysimpl
    global fn
    fn=tkFileDialog.askopenfilename()
    print "fn ",fn
    Tpopener=Tkinter.Toplevel(hf)
    Tpopener.title(' Opening window: different formats ')
    fropen2=Tkinter.Frame(Tpopener,bd=3,bg="white")
    fropen2.pack()
    # +++ Grid-Geometry manager +++
    lb0=Tkinter.Label(fropen2,text=" Select the appropriate format: ",bg="yellow",font=("arial",12,"bold"))
    lb0.grid(row=0,column=0)
    lb1=Tkinter.Label(fropen2,text="(1a) Open files, txt, tab (or blank) as delimiter (PyHasse-standard) :                ",bg="white")
    lb1.grid(row=1,column=0)
    lb2=Tkinter.Label(fropen2,text="(1b) Open files, csv, ';' as delimiter (csv with ';') :                               ",bg="white")
    lb2.grid(row=2,column=0)
    lb3=Tkinter.Label(fropen2,text="(1c) Open files, csv, ',' as delimiter (csv with ',') :                               ",bg="white")
    lb3.grid(row=3,column=0)
    lb6=Tkinter.Label(fropen2,text="(1f) Open files, pdt, internal PyHasse-format to exchange interim-results:            ",bg="white") 
    lb6.grid(row=6,column=0)
    butt1=Tkinter.Button(fropen2,text="(1a) Open txt-file       ",bg="cyan",bd=4,command=xfileopen)
    butt1.grid(row=1,column=1)
    butt2=Tkinter.Button(fropen2,text="(1b) Open csv-file (';') ",bg="cyan",bd=4,command=xcsvopenS)
    butt2.grid(row=2,column=1)
    butt3=Tkinter.Button(fropen2,text="(1c) Open csv-file (',') ",bg="cyan",bd=4,command=xcsvopenK)
    butt3.grid(row=3,column=1)
    butt6=Tkinter.Button(fropen2,text="(1f) Open pdt-file       ",bg="cyan",bd=4,command=xopenfilepdt)
    butt6.grid(row=6,column=1)


def xcsvopenS():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,obj,prop,x,xred,rred,objred,x,txteq
    DataReader = csv.reader(open(fn), delimiter=';', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")
    rred,xred,objred,txteq,neq=rmod2.equivcompactm(r,k,x,obj)
    print "rred ",rred
    print "Matrix "
    rmod2.matout(r,k,xred)

    

def xcsvopenK():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,x,fn,obj,prop,xred,objred,rred,x,txteq
    DataReader = csv.reader(open(fn), delimiter=',', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")

    rred,xred,objred,txteq,neq=rmod2.equivcompactm(r,k,x,obj)




def xfileopen():
    """Informs about the file-operations"""
    # Excelreadin4 built in
    # Brg 29.11.07, 30.11.07, 15.1.08,18.2.08
    global fn,r,k,x,prop,obj,rred,xred,objred,txteq
    x,ob,pr,r,k=rmod2.EXCELreadin6(fn)
    print "r = ",r,"   k = ",k
    obj=rmod2.vecgentext1(r)                        #29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  #recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pr[i+1]   #recoding, because pr[0] is a dummy string
    #rmod2.matout(r,k,x)
    
    lbopen1.config(bg="yellow")    #18.2.08
    lbopen1["text"]="File "+fn+" was opened with "+str(r)+" rows and "+str(k)+"  columns"
    
    rred,xred,objred,txteq,neq=rmod2.equivcompactm(r,k,x,obj)   #6.8.2013

    

def xopenfilepdt():
    """ File selection of transformed data matrices
    through other PyHasse programs """
    # brg 29.10.2012 taken from sensitivity18_3
    #* 1.6.09
    # akt. 29.10.2012 (taken from sensitivity18_3), 6.8.2013
    # source: mainHD19
    global fn,r,k,x,prop,obj,rred,xred,objred,txteq
    
    r,k,x,obj,prop=rmod2.raireadin5(fn)
    lbpdtopen.config(bg="yellow")
    lbpdtopen["text"]="selected file (PyHasse (pdt) format) : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns"

    rred,xred,objred,txteq,neq=rmod2.equivcompactm(r,k,x,obj)    

##### end of editenster ### 29.8.2013 ####




def showDM():
    """shows the DM"""
    # taken from fuzzyHD7
    tp2a=Tkinter.Toplevel(hf)
    tp2a.title(' show DM ')
    lbtp2=Tkinter.Label(tp2a,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2a,width=60,height=4)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,k):
            txt3+=str(x[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)    

def showDMn():
    """shows the DM [0,1]-columnwise normalized"""
    # taken from fuzzyHD7
    tp2b=Tkinter.Toplevel(hf)
    tp2b.title(' show normalized DM ')
    lbtp2=Tkinter.Label(tp2b,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2b,width=60,height=4)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n normalized data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    xn=rmod2.matrixnorm(r,k,x)
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,k):
            txt3+=str(round(xn[i][j],2))+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)    



def HD():
    # brg 26.7.2013, 29.8.2013, 25.11.2013, 9.12.2013
    global x,la,ls,xred,cov,n,txteq,Uorig
    try:
        perturb=float(eperturb.get())
    except:
        perturb=1.0
    objx=rmod2.comp(r,k,x)
    rmod2.matout(r,r,objx)
    quobx=rmod2.qualcomp1(r,objx)
    rmod2.strmatout(r,r,quobx)
    Uorig=0
    for i1 in range(0,r):
        for i2 in range(0,r):
            if quobx[i1][i2]=="ic":
                Uorig+=0.5
    print "U= ",Uorig
    
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
        #
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    if rred>400:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram  ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                if perturb!=1.0:
                    pt=1+perturb*random.random()
                else:
                    pt=1
                geomx[i][j]=geom0x+pt*(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.create_text(garrow1x-130,garrow2y-6,text="Incomp(objectset based) = "+str(Uorig))
        cv.pack()

        buttcover=Tkinter.Button(freq,text="show cover relation",command=cover_show)
        buttcover.pack()

    n=rred
    teqorig=ScrolledText(freq,width=60,height=5)
    teqorig.pack()
    txteq2="Equivalence classes of \n"+str(fn)+"\n"
    txteq2+="\n"+txteq+"\n"
    teqorig.insert("end",txteq2)
    Buttcalc.config(state="active")
        
def cover_show():
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: -
    tpcover=Tkinter.Toplevel(hf)
    tpcover.title(' cover-matrix ')
    lbhd2=Tkinter.Label(tpcover,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    n=rred
    for i in range(0,n):
        txt3+="\n"+objred[i]+":\t"
        txt3+="is covered by "
        for j in range(0,n):
            if i!=j:
                if cov[i][j]==1:
                    txt3+=" "+objred[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(tpcover,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)


def geomHD(zv, levm,zlev):
    """ from zv the graphical control for HDs is derived """
    #zv is the number of vertices
    # levm is the number of vertices in the maximal level (determines the x coord
    # zlev is the number of levels, determines the y coord
    # * Brg 10.6.08
    # akt: 29.5.09
    # brg 10.6.08, 29.5.09
    # taken from interval4.py
    awidth=zv*40
    aheight=zv*40
    if awidth<120:
        awidth=120
    if awidth>600:
        awidth=600
    if aheight<120:
        aheight=120
    if aheight>600:
        aheight=600
    
    #aheight and awidth: extent of canvas
    fx = int((awidth-40))
    fy = int((aheight-40))
    g0x=5   #Start of the HD-area x
    g0y=20   #Start of the HD-area y
    garr1x=fx +10.0  #location of the arrow
    garr1y=20
    garr2y=fy+10.0
    return awidth,aheight,fx,fy,g0x,g0y,garr1x,garr1y,garr2y            
         

def calc():
    # brg 22.1.2015, completely new
    global dmmodified, zetaneu, Uneu
    """ Small differences between two objects will be replaced by one value
        """

    try:
        delta=float(edelta.get())
    except:
        delta=0.05
    
    dm=rmod2.matcopy1(r,k,x)
    dmn2=rmod2.matrixnorm(r,k,dm)
    zeta2=rmod2.comp(r,k,dmn2)
    # calculation of the original number of incomp
    U=0
    for i1 in range(0, r):
        for i2 in range(0, r):
            if zeta2[i1][i2] == 0 and zeta2[i2][i1] == 0:
                U += 0.5
    Ualt = U
    
        
    # attributewise procedure
    txthilf=""
    for k1 in range(0,k):
        txthilf += "Indicator: "+str(prop[k1])+":\n"
        q = []
        for i in range(0, r):
            q.append(dmn2[i][k1])
        #partitioning concerning actual attribute and cluster-values    
        ppur, avs = attributecluster(q, obj, delta)
        qa, qn = data_assignment(obj, ppur, avs)
        #cluster-values now for all elements of one cluster
        qnew = resort(obj, ppur, qa)
        #dmn2 modified
        for i in range(0, r):
            dmn2[i][k1] = qnew[i]
        lp = len(ppur)
        txthilf += "number of clusters: "+str(lp)+"\n"  
        for i1 in range(0, lp):
            txthilf += str(i1)+"th cluster of attribute: "+str(prop[k1])+": "
            for elem in ppur[i1]:
                txthilf += str(elem)+", "
            txthilf += "\n"    
    print "   Modifiz. dmn2-matrix"
    rmod2.matout(r,k,dmn2)
    print "...."
    zetaneu=rmod2.comp(r,k,dmn2)
    Uneu=0
    for i1 in range(0,r):
        for i2 in range(0,r):
            if zetaneu[i1][i2] == 0 and zetaneu[i2][i1] == 0:
                Uneu+=0.5
    print "Uneu= ",Uneu
        
        
        
    txtpart=""
    txtpart+="Parameter of analysis :"+"\n"
    txtpart+="File= "+str(fn)+"\n"
    txtpart+="delta = "+str(delta)+"\n"
    txtpart+="Incomp_orig = "+str(Ualt)+"  Incomp_new = "+str(Uneu)+"\n"                
    txtpart+=" Details of procedure: "+"\n"
    txtpart+=txthilf
    dmmodified=rmod2.matcopy1(r,k,dmn2)
    
    tpcalc=Tkinter.Toplevel(hf)
    tpcalc.title(' Details about the enrichment procedure ')
    tcalc=ScrolledText(tpcalc,width=60,height=10)
    tcalc.pack()
    tcalc.insert("end",txtpart)
    
def sf():
    #brg  31.5.09, 1.6.09, taken from discretiz3 20.12.2013
    #save in pdt-format
    fnneu=tkFileDialog.asksaveasfilename(parent=hf,title="save file")
    # brg  30.5.09
    for i in range(0,r):
        print obj[i]," ",
    print " "    
    rmod2.raiwrite5(fnneu,dmmodified,obj,prop,r,k)
    lbsuccess.config(text="matrix with \n"+str(r)+"  rows  and "+str(k)+"\n  columns stored",bg="yellow")

def xsave_in_PyHasseformat():
    # brg 26.7.2013
    # 6.8.2013: taken from formatHD00.py 21.12.2013
    global r,k,x
    la=r+1
    ls=k+1
    
    xext=rmod2.marray(la,ls)
    for i in range(0,la):
        for j in range(0,ls):
            if i==0 and j==0:
                xext[i][j]="dummy"
            elif j==0 and i>0:
                xext[i][j]=obj[i-1]
            elif j>0 and i==0:
                xext[i][j]=prop[j-1]
            else:
                xext[i][j]=dmmodified[i-1][j-1]


    print " xext-matrix "
    for i in range(0,la):
        for j in range(0,ls):
            print xext[i][j]," ",
        print " "
    print "  "    
    fnnew=tkFileDialog.asksaveasfilename(parent=hf,title="save orig dm in PyHasseformat")
    fcsv=open(fnnew,"w")
    for i in range(0,la):
        for j in range(0,ls):
            fcsv.write(str(xext[i][j])+"\t")
        fcsv.write("\n")
    fcsv.close()

def save_relat():
    # brg 28.12.2014
    relathilf=rmod2.comp(r,k,dmmodified)
    print "obj = ",obj
    for i1 in range(0,5):
        for i2 in range(0,5):
            print relathilf[i2][i1]," ",
        print " "
    fnrelat=tkFileDialog.asksaveasfilename(parent=hf,title="save relation-file in PyHasseformat")
    fcsv=open(fnrelat,"w")
    fcsv.write(str(r)+"\n")
    for i1 in range(0,r):
        for i2 in range(0,r):
            fcsv.write(str(relathilf[i2][i1])+"\t")
        fcsv.write("\n")
    fcsv.close()        
            
def HDenriched():
    # brg 29.11.2013
    global cov3,rred3,objred3
    try:
        perturb=float(eperturb.get())
    except:
        perturb=1.0
    rred3,xred3,objred3,txteq3,neq3=rmod2.equivcompactm(r,k,dmmodified,obj)   #6.8.2013
    hfhd3=Tkinter.Toplevel(hf)
    hfhd3.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd3,width=200,height=300)
    freq.pack()
    zetahilf=rmod2.comp(rred3,k,xred3)  #zeta matrix with col<row
    zeta=rmod2.marray(rred3,rred3)
    for i in range(0,rred3):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred3):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred3,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred3,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred3,adjc,lext)
       
    
    cov3=rmod2.cover(rred3,tr,lext)

    if rred3>400:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects check the cover-relations ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram  ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred3,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred3,rred3)
        geomy=rmod2.marray(rred3,rred3)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                if perturb!=1.0:
                    pt=1+perturb*random.random()
                else:
                    pt=1
                geomx[i][j]=geom0x+pt*(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov3[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred3[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.create_text(garrow1x-130,garrow2y-6,text="Incomp(final,objectset based)= "+str(Uneu))
        cv.pack()

        buttcover5=Tkinter.Button(freq,text="show cover relation of HD enriched ",command=cover_show3)
        buttcover5.pack()

    
    teqorig=ScrolledText(freq,width=60,height=5)
    teqorig.pack()
    txteq4="Equivalence classes of \n"+str(fn)+"\n"
    txteq4+="\n"+txteq3+"\n"
    teqorig.insert("end",txteq4)

def cover_show3():
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: -
    tpcover3=Tkinter.Toplevel(hf)
    tpcover3.title(' cover-matrix ')
    lbhd2=Tkinter.Label(tpcover3,text=" Cover-Relations ")
    lbhd2.pack()
    txt5="\n cover-matrix  \n"
    n=rred3
    for i in range(0,n):
        txt5+="\n"+objred3[i]+":\t"
        txt5+="is covered by "
        for j in range(0,n):
            if i!=j:
                if cov3[i][j]==1:
                    txt5+=" "+objred3[j]+" ,"
                else:
                    pass
            else:
                pass
        txt5+="\n"    
    txt5+="\n"
    txt5+=" -- end of list --"
    tcov=ScrolledText(tpcover3,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt5)

hf=Tkinter.Tk()
hf.title('--   GUI Enrich   -- ')

aboutmainHD=raioop2.brgabout(hf,"tp1","about_Totalenrich.txt",4,\
            "January, the 22th, 2014"," about Totalenrich ", "white", "t1",120,5,ScrolledText)
helpmainHD=raioop2.brgabout(hf,"tp1","help_Totalenrich.txt",4,\
            "January, the 22th, 2014"," help Totalenrich ", "white", "t1",120,10,ScrolledText)
    
fr1=Tkinter.Frame(hf,width=60)   #about, help, fn, lbopen1
fr1.pack()
fr11=Tkinter.Frame(fr1,width=60)
fr11.pack()
Buttfn=Tkinter.Button(fr11,text="select&open-file",width=50,bg="cyan",command=xselectfile)
Buttfn.pack()
lbopen1=Tkinter.Label(fr1,text="",width=60)
lbopen1.pack()
lbpdtopen=Tkinter.Label(fr1,text="")
lbpdtopen.pack()
fr12=Tkinter.Frame(fr1,width=60)
fr12.pack()
Buttshow=Tkinter.Button(fr12,text="show data matrix from txt-file",bg="cyan",width=50,command=showDM)
Buttshow.pack()
Buttshown=Tkinter.Button(fr12,text="Show normalized dm ",bg="cyan",width=50,command=showDMn)
Buttshown.pack()
lbperturb=Tkinter.Label(fr12,text=" perturb the Hassediagram (default=1)")
lbperturb.pack()
eperturb=Tkinter.Entry(fr12,width=2)
eperturb.pack()
ButtHD=Tkinter.Button(fr12,text="Hassediagram ",width=30,bg="cyan",command=HD)
ButtHD.pack()
fr13=Tkinter.Frame(fr1,relief="sunken",bd=4)
fr13.pack()
lb13=Tkinter.Label(fr13,text="Needed: delta ")
lb13.pack()
lb131 = Tkinter.Label(fr13, text="Enter delta (0.1 or 0.2 or...)")
lb131.pack(side="left")
edelta = Tkinter.Entry(fr13, width=4)
edelta.pack(side="left")
Buttcalc = Tkinter.Button(fr1, text="Enrichment ",
                          width=50, bg="cyan", state="disabled", command=calc)
Buttcalc.pack()
fr14 = Tkinter.Frame(fr1, relief = "sunken",bd = 4)
fr14.pack()
Buttsavemodifieddm = Tkinter.Button(fr1, text="Save modif dm in pdt-Format ",width=50, bg="cyan", command=sf)
Buttsavemodifieddm.pack()
lbsuccess = Tkinter.Label(fr1, text="Save...")
lbsuccess.pack()
Buttsavemodifdm = Tkinter.Button(fr1, text="Save in PyHasse standard format ",
                                 width=50, bg="cyan",
                                 command=xsave_in_PyHasseformat)
Buttsavemodifdm.pack()
ButtHDenriched = Tkinter.Button(fr1, text="Hasse diagram enriched ",
                                width=50, bg="cyan", command=HDenriched)
ButtHDenriched.pack()
Buttsaverelat=Tkinter.Button(fr1,text="Save relational matrix of modified data matrix",width=50,bg="cyan",command=save_relat)
Buttsaverelat.pack()
buttexit = Tkinter.Button(hf, text=" Exit  ",
                          bg="red", width=10, command=hf.destroy)
buttexit.pack(pady=10)
hf.mainloop()
