import Tkinter
import rmod2
import raioop2
from ScrolledText import *
import Canvas
import os
import tkMessageBox
import tkFileDialog
import stats
import pstat
import random



# Brg 14.12.07, 17.12.07, 13.1.08, 4.2.08
# g-stability fields
# Brg 19.2.08: Toplevel: titles
# May 08: Brg adaptations because of changes in rmod2
# 7.6.08: Important step: How to avoid the case where no incomp. pair is found
# Brg 10.10.08 Help text now as external file. Loading by an OOP-function
# HD of a weight-interval
# Brg 20.6.2012 cosmetics
# Brg 21.6.2012 rearrangements to stability6.py
# Brg 24.6.2012 further steps toward stability8
# Brg 25.6.2012 stability9 (once again a change in ideas)
# Brg 23.4.2013;: about: extended
# Brg January 2017: output changed and some slight extensions
# January, the 22nd, 2017: Heavy changes to generate the new module mod_spec3.py

   

def msgwarning2():
    tkMessageBox.showwarning("++Wrong attribute Number selected ++"," you must select a file")

def msgwarning():
    tkMessageBox.showwarning("++No data matrix available ++"," you must select a file")

    
def fileselect():
    """ File selection of an 2.dim. data matrix and opening by Tkinter-Standards"""
    #*13.1.08
    #akt: 13.1.08
    #note: There may be conflicts with other moduls
    #source:-
    tp=Tkinter.Toplevel(hf)   #19.2.08
    tp.title(' select/open ')
    global fn
    fn=tkFileDialog.askopenfilename()
    
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    
    if k==2:
        textlbfile="Selected file = "+fn+" with "+str(r)+" objects "
    else:
        textlbfile="Sorry! You need a file with two attributes only !!! "
    lbfile=Tkinter.Label(tp,bg="yellow",text=textlbfile)
    lbfile.pack()
    return r,k,dm,ob,pro,fn

         
def showDM():
    """ New routine : shows the data matrix """
    #Brg 13.1.08
    tp2=Tkinter.Toplevel(hf)
    tp2.title(' show DM ')
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+ob[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+pro[j+1]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=pro[j+1]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=ob[i+1]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)

def shownormalizedDM():
    """ New routine : shows the data matrix """
    #Brg 13.1.08
    tp2n=Tkinter.Toplevel(hf)
    tp2n.title(' show normalized DM ')
    tfilen=ScrolledText(tp2n,width=60,height=4)
    tfilen.pack()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+ob[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+pro[j+1]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=pro[j+1]+"\t"
    txt3+="\n"
    xn=rmod2.matrixnorm(r,k,dm)
    for i in range(0,r):
        txt3+=ob[i+1]+"\t"
        for j in range(0,k):
            txt3+=str(xn[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfilen.insert("end",txt)





def filecomp(fn):
    """ reduces a dm with equiv objects to a dm of a quotient set """
    # Brg 12.12.07, 13.1.08, 8.5.08
    # von mainHD3 uebernommen und geringfuegig angepasst
    #r,k,dm,ob,pro,fn are globals and should be available after open
    global prop, obj
    dm,ob,pro,r,k1=rmod2.EXCELreadin4(fn)
    #recoding ob to obj and pro to prop
    print "in filecomp k1: ",k1
    if r==0:
        hfwarning=Tkinter.Toplevel(hf)
        hfwarning.title('warning')
        frwarning=Tkinter.Frame(hfwarning,width=10,height=3)
        frwarning.pack()
        bwarning=Tkinter.Button(frwarning,text="++warning ++",command=msgwarning)
        bwarning.pack()
        
    prop=rmod2.vecgentext1(k1)
    obj=rmod2.vecgentext1(r)    #8.5.08 changed: ...text1
    for i in range(0,k1):
        prop[i]=pro[i+1]
    for i in range(0,r):
        obj[i]=ob[i+1]
    #############################dieser Teil ist neu 21.12.07
    rred,xred,objred,txt=rmod2.equivcompact(r,k1,dm,obj)    
    ###############################################################
    #print objred
    #print "reduzierte matrix"
    #rmod2.matout(rred,k,xred)
    return rred,k1,xred,objred,obj,prop,txt           

def stabcalc():
    """ calculates the g-spectrum  """
    # Brg 14.12.07, 18.1.17, 22.1.17
    global fn,x,xn,y,r,rred,obj,objred,prop, k,gc,np   #21.1.08, 21.1.11 
    r,km,x,ob,pro,fn=fileselect()
    
    # idea behind pair of weights is: the crucial weights are based on two attributes.
    # therefore it is reasonable to compare the two gc-values of each pair x||y with both weights,
    # seek the minimum of both and provide the basis for a statistical evolution
    obj=rmod2.vecgentext1(r)
    prop=rmod2.vecgentext1(km)
    # recodings
    for i in range(0,r):
        obj[i]=ob[i+1]
    for j in range(0,km):
        prop[j]=pro[j+1]
    print "r nach Einlesen ",r, "   km nach Einlesen",km,"  prop0 ",prop[0],"  prop1 ",prop[1]    
    # extract the equivalent elements
    xn=rmod2.matrixnorm(r,km,x)
    rred,k,xred,objred,obj,prop,txt=filecomp(fn)
    flageq=0
    print "rred nach filecomp ",rred
    #rmod2.matout(rred,k,xred)
    # folgender Teil von mainHD3 uebernommen
    l1=len(obj)
    l2=len(objred)
    if l1!=l2:
        hfeq=Tkinter.Toplevel(hf)
        hfeq.title('equivalence classes')
        lbeq1=Tkinter.Label(hfeq,text="Structure: quotient set")
        lbeq1.pack()
        labeq=Tkinter.Label(hfeq,text="representants and their\n equivalent objects")
        labeq.pack()
        txteq=ScrolledText(hfeq,width=60,height=4)
        txteq.pack()
        txteq.insert("end",txt)
    ######################################
    
    # matrix characteristics
    txtchar="\nsome characteristics of the complete data matrix\n"
    #rmod2.matout(rred,k,xred)
    ch=rmod2.matrixchar(rred,k,xred)
    txtchar+= "\tcol\tmax\t\tmin\t\t       mean\t\t             stdev\n"
    
    for i in range(0,k):
        txtchar+="property "+prop[i]+":\t  "
        for j in range(0,4):
            txtchar+=str(round(ch[j][i],2))+3*"\t"
        txtchar+=2*"\n"    
    txtchar+=" -- end of 'characteristics ' --"
    hfresults=Tkinter.Toplevel(hf)
    hfresults.title('results')
    lbresults2=Tkinter.Label(hfresults,text=" stability: Results ")
    lbresults2.pack()
    frresults=Tkinter.Frame(hfresults,width=200,height=400)
    frresults.pack()
    tr1=ScrolledText(frresults,width=120,height=10)
    tr1.pack()
    tr1.insert("end",txtchar)
    # normalization
    y=rmod2.matrixnorm(rred,k,xred)
       
    ############################################################
    # main calculation                                         #
    ############################################################
    gc=[]
    pairgc=[]
    zaehlgc=0    
    for i1 in range(0,rred):
        for i2 in range(i1,rred):
            if i!=j:
                delta2=y[i1][1]-y[i2][1]
                delta1=y[i1][0]-y[i2][0]
                nenner=delta2-delta1
                if abs(nenner)!=0:
                     q=delta2/nenner
                     if 0<q<1:
                         gc.append(q)
                         pairgc.append((objred[i1],objred[i2]))
                         zaehlgc+=1
                else:
                     pass
                         
                
    
    np=zaehlgc
    txtpair2="\n purified g-values and their crucial object pairs \n"
    txtpair2+="No "+"\t"+"obj-pair"+"\t"+"gc1("+str(prop[0])+")\t"+"gc2("+str(prop[1])+")\n"
    for i in range(0,np):
        txtpair2+=str(i)+":\t"+str(pairgc[i][0])+", "+str(pairgc[i][1])+":\t"\
                +str(round(gc[i],3))+"\t"+str(round(1.0-gc[i],3))+"\n"
            
    tr4=ScrolledText(frresults,width=120,height=10)
    tr4.pack()
    tr4.insert("end",txtpair2)

def s_cone():
    #brg 22.1.2017
    global txtspectrum
    print "np = ",np
    startw = epd.get().split(",")
    startweights=[]
    for j in range(0,2):
        startweights.append(float(startw[j]))
    so=rmod2.marray(np,2)
    su=rmod2.marray(np,2)
    smin=rmod2.vecgen1(np)
    txtspectrum="Formal crossing points of crucial weights with the cones "+"\n"
    txtspectrum+= "no"+"\t"+"so1"+"\t"+"so2"+"\t"+"su1"+"\t"+"su2"+"\t"+"smin"+"\n"
    txtmin=""
    for i in range(0,np):
        shilf=[]
        so[i][0]=1.0*(gc[i]-startweights[0])/(1.0-1.0*startweights[0])
        so[i][1]=1.0*(gc[i]-startweights[1])/(1.0-1.0*startweights[1])
        su[i][0]=1.0*(startweights[0]-gc[i])/(1.0*startweights[0])
        su[i][1]=1.0*(startweights[1]-gc[i])/(1.0*startweights[1])
        if so[i][0]>0:
            shilf.append(so[i][0])
        if so[i][1]>0:
            shilf.append(so[i][1])
        if su[i][0]>0:
            shilf.append(su[i][0])
        if su[i][1]>0:
            shilf.append(su[i][1])    
        smin[i]=max(shilf) ###23-01-2017 testweise: max (heuristically: the result is improved
        txtspectrum+=str(i)+": "+str(round(so[i][0],2))+", "+str(round(so[i][1],2))+", "+\
                      str(round(su[i][0],2))+", "+str(round(su[i][1],2))+", "\
                      +str(round(smin[i],2))+"\n"
        txtmin+=str(round(smin[i],2))+"\n"
    
    
    dummy,sminord,dummy2=rmod2.raisort2(smin)
    
    Uaccum=[]
    
    for s in range(0,11):
        countU=0
        for i in range(0,np):
            if sminord[i]<0.1*s:
                countU+=1
                
        Uaccum.append(countU)
    print Uaccum    
    lu=len(Uaccum)
    txtU ="s"+"\t"+"Uaccum"+"\n"
    for i in range(0,11):
        txtU+=str(i)+"\t"+str(Uaccum[i])+"\n"
    txtU+="\n"
    tpUaccum=Tkinter.Toplevel(hf)
    tUaccum=ScrolledText(tpUaccum,width=60, height=10)
    tUaccum.pack()
    tUaccum.insert("end",txtU)
    
def binfo():
    #brg 22.1.2017
    tpspectrum=Tkinter.Toplevel(hf)
    tpspectrum.title("Distribution of s-cone-values ")
    tspectrum=ScrolledText(tpspectrum,width=120, height=20)
    tspectrum.pack()
    tspectrum.insert("end",txtspectrum)
           
def HD():
    "based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"
    # Brg 20.12.07, 28.12.07, 21.1.08, 24.6.2012, 22.1.2017
    # If the number of representants > 100 then only the cover-matrix and the level-population
    # almost the same as in mainHD3
    # from stabcalc r,k,prop, obj, x are known  (21.1.08)
    global zeta2,objred,fn,n
    try:
        perturb=int(eperturb.get())
    except:
        perturb=0
    
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram or cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    
    #print "att1 = ",att1,"   att2 =",att2   
    rred,xred,objred,txtquot=rmod2.equivcompact2(r,0,1,x,obj)    
    #rred is now the number of representants of the dm-matrix with columns att1 and att2
    #xred is the correspondingly reduced data matrixc with two columns
    n=rred
    labeq=Tkinter.Label(freq,text="file = "+fn+": calc. is based on representants\n\
        attributes: "+str(prop[0])+", "+str(prop[1]))
    labeq.config(bg="yellow")
    labeq.pack()
    
    l1=len(obj)
    l2=len(objred)
    if l1!=l2:
        hfeq2=Tkinter.Toplevel(hf)
        hfeq2.title('equiv. classes')
        lbeq1=Tkinter.Label(hfeq2,text="Structure: quotient set")
        lbeq1.pack()
        labeq=Tkinter.Label(hfeq2,text="representants and their\n equivalent objects")
        labeq.pack()
        txteq=ScrolledText(hfeq2,width=60,height=4)
        txteq.pack()
        txteq.insert("end",txtquot)
    
    
    zetahilf,at1,at2=rmod2.comp2(n,0,1,xred)
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    Utotal=0
    for i1 in range(0,rred):
        for i2 in range(0,rred):
            if zeta[i1][i2]==0 and zeta[i2][i1]==0:
                Utotal+=0.5
    print "Utotal= ",Utotal            
    #One linear extension (based on levels)
    lbhd1=Tkinter.Label(freq,text= "Utotal("+str(prop[0])+", "+str(prop[1])+") = "+str(Utotal))
    lbhd1.pack()

    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
    #print "zzmax = ",zzmax
    tlev=ScrolledText(freq,width=60,height=4)
    tlev.pack()
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
    txt1="\n"
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= objred[lobj[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)

    #Adj-Listen

    adjc=rmod2.adjacent(n,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(n,adjc,lext)
       
    
    zeta2=rmod2.cover(n,tr,lext)
    if n>200:
        lbhd2=Tkinter.Label(freq,text=" graphical presentation not meaningful, see levels and cover-matrix ")
        lbhd2.pack()
        txt3="\n cover-matrix  \n"
        for i in range(0,n):
            txt3+="\t"+objred[i]+"\t"
        txt3+="\n"
        for i in range(0,n):
            txt3+=objred[i]+" :"
            for j in range(0,n):
                txt3+=str(zeta2[i][j])+"\t"
            txt3+="\n"
        txt3+=" -- end of list --"
        tcov=ScrolledText(freq,width=60, height=4)
        tcov.pack()
        tcov.insert("end",txt3)
    else:
        lbhd3=Tkinter.Label(freq,text=" HD of File "+fn+\
                            "  att.(: "+str(prop[0])+", "+str(prop[1])+")\n")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

               
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=(perturb*random.randint(1,5)+1)*geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if zeta2[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
##        cv.create_line(garrow1x-4,garrow2y-4,garrow1x,garrow2y)
##        cv.create_line(garrow1x+4,garrow2y-4,garrow1x,garrow2y)
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.pack()
        buttcover=Tkinter.Button(freq,text="show cover relation",command=cover_show)
        buttcover.pack()

def cover_show():
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: -
    hfcover=Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    
    lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,n):
        txt3+="\n"+objred[i]+":\t"
        txt3+="is covered by "
        for j in range(0,n):
            if i!=j:
                if zeta2[i][j]==1:
                    txt3+=" "+objred[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=4)
    tcov.pack()
    tcov.insert("end",txt3)
          

hf=Tkinter.Tk()
hf.title('-- modspec3 -- ')
aboutmod_spec3 = raioop2.brgabout(hf,"tp1","about_mod_spec3.txt",9,\
            "January, the 22nd, 2017"," about_U_scone_for_m=2 ", "white", "t1",120,6,ScrolledText)

helpmod_spec3=raioop2.brgabout(hf,"tp1","help_mod_spec3.txt",9,\
            "January, the 22nd, 2017"," help_U_scone_for_m=2 ", "white", "t1",120,6,ScrolledText)
    
buttmain=Tkinter.Button(hf,text=" Select\nopen and\n start program ",bd=5,bg="cyan",width=30,command=stabcalc)
buttmain.pack(pady=10)
frshow=Tkinter.Frame(hf)
frshow.pack()
butt2=Tkinter.Button(frshow,text="show   dm",command=showDM)
butt2.pack(side="left")
butt2n=Tkinter.Button(frshow,text="show normal. dm",command=shownormalizedDM)
butt2n.pack(side="right")
buttHD=Tkinter.Button(hf,text="show HD ",command=HD)
buttHD.pack()
lb2=Tkinter.Label(hf,text="Enter weights specifically for the pair of attributes ")
lb2.pack(pady=5)
epd=Tkinter.Entry(hf,width=10)
epd.pack()
buttscone=Tkinter.Button(hf,text="Calculate the s-cone ",bg="cyan", width=30,command=s_cone)
buttscone.pack()
buttbackgroundinfo = Tkinter.Button(hf,text="s-cone background info ",width=30, command=binfo)
buttbackgroundinfo.pack()
buttexit=Tkinter.Button(hf,text="  Exit  ",bg="red",width=30,command=hf.destroy)
buttexit.pack(pady=30)
hf.mainloop()
