# -*- coding: cp1252 -*-
import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import tkFileDialog
import raioop2
import math

# Brg 3.3.2011
# brg 1.7.2014
# brg 5.7.2014 Extension to a full PyHasse version
# brg 6.7.2014: elimination of numpy

###### edit-block ### 29.8.2013 Block taken from formatHDsimpl 5.7.2014 #####

def xsave_in_PyHasseformat():
    # brg 26.7.2013
    # 6.8.2013: taken from csvHDsimpl1.py, 27.8.2013
    global r,k,x
    la=r+1
    ls=k+1
    
    xext=rmod2.marray(la,ls)
    for i in range(0,la):
        for j in range(0,ls):
            if i==0 and j==0:
                xext[i][j]="dummy"
            elif j==0 and i>0:
                xext[i][j]=obj[i-1]
            elif j>0 and i==0:
                xext[i][j]=prop[j-1]
            else:
                xext[i][j]=x[i-1][j-1]


    print " xext-matrix "
    for i in range(0,la):
        for j in range(0,ls):
            print xext[i][j]," ",
        print " "
    print "  "    
    fnnew=tkFileDialog.asksaveasfilename(parent=hf,title="save orig dm in PyHasseformat")
    fcsv=open(fnnew,"w")
    for i in range(0,la):
        for j in range(0,ls):
            fcsv.write(str(xext[i][j])+"\t")
        fcsv.write("\n")
    fcsv.close()
   
def xsave_in_PyHasseformat_n():
    # brg 26.7.2013
    # 6.8.2013: taken from csvHDsimpl1.py, 27.8.2013
    global r,k,x
    xn=rmod2.matrixnorm(r,k,x)

    la=r+1
    ls=k+1
    
    xext=rmod2.marray(la,ls)
    for i in range(0,la):
        for j in range(0,ls):
            if i==0 and j==0:
                xext[i][j]="dummy"
            elif j==0 and i>0:
                xext[i][j]=obj[i-1]
            elif j>0 and i==0:
                xext[i][j]=prop[j-1]
            else:
                xext[i][j]=xn[i-1][j-1]


    print " xext-matrix "
    for i in range(0,la):
        for j in range(0,ls):
            print xext[i][j]," ",
        print " "
    print "  "    
    fnnew=tkFileDialog.asksaveasfilename(parent=hf,title="save normalized dm in PyHasseformat")
    fcsv=open(fnnew,"w")
    for i in range(0,la):
        for j in range(0,ls):
            fcsv.write(str(xext[i][j])+"\t")
        fcsv.write("\n")
    fcsv.close()
   

def xselectfile():
    # brg 6.8.2013
    global fn
    fn=tkFileDialog.askopenfilename()
    print "fn ",fn
    Tpopener=Tkinter.Toplevel(hf)
    Tpopener.title(' Opening window: different formats ')
    fropen2=Tkinter.Frame(Tpopener,bd=3,bg="white")
    fropen2.pack()
    # +++ Grid-Geometry manager +++
    lb0=Tkinter.Label(fropen2,text=" Select the appropriate format: ",bg="yellow",font=("arial",12,"bold"))
    lb0.grid(row=0,column=0)
    lb1=Tkinter.Label(fropen2,text="(1a) Open files, txt, tab (or blank) as delimiter (PyHasse-standard) :                ",bg="white")
    lb1.grid(row=1,column=0)
    lb2=Tkinter.Label(fropen2,text="(1b) Open files, csv, ';' as delimiter (csv with ';') :                               ",bg="white")
    lb2.grid(row=2,column=0)
    lb3=Tkinter.Label(fropen2,text="(1c) Open files, csv, ',' as delimiter (csv with ',') :                               ",bg="white")
    lb3.grid(row=3,column=0)
    lb6=Tkinter.Label(fropen2,text="(1f) Open files, pdt, internal PyHasse-format to exchange interim-results:            ",bg="white") 
    lb6.grid(row=6,column=0)
    butt1=Tkinter.Button(fropen2,text="(1a) Open txt-file       ",bg="cyan",bd=4,command=xfileopen)
    butt1.grid(row=1,column=1)
    butt2=Tkinter.Button(fropen2,text="(1b) Open csv-file (';') ",bg="cyan",bd=4,command=xcsvopenS)
    butt2.grid(row=2,column=1)
    butt3=Tkinter.Button(fropen2,text="(1c) Open csv-file (',') ",bg="cyan",bd=4,command=xcsvopenK)
    butt3.grid(row=3,column=1)
    butt6=Tkinter.Button(fropen2,text="(1f) Open pdt-file       ",bg="cyan",bd=4,command=xopenfilepdt)
    butt6.grid(row=6,column=1)


def xcsvopenS():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,obj,prop,x,xred,rred,objred,dm
    DataReader = csv.reader(open(fn), delimiter=';', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")
    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,x,obj)
    print "rred ",rred
    print "Matrix "
    rmod2.matout(r,k,xred)

    

def xcsvopenK():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,x,fn,obj,prop,xred,objred,rred,dm
    DataReader = csv.reader(open(fn), delimiter=',', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")

    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,x,obj)




def xfileopen():
    "Informs about the file-operations"
    # Excelreadin4 built in
    # Brg 29.11.07, 30.11.07, 15.1.08,18.2.08
    global fn,r,k,x,prop,obj,rred,xred,objred
    x,ob,pr,r,k=rmod2.EXCELreadin4(fn)
    print "r = ",r,"   k = ",k
    obj=rmod2.vecgentext1(r)                        # 29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  # recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pr[i+1]   # recoding, because pr[0] is a dummy string
    # rmod2.matout(r,k,x)
    
    lbopen1.config(bg="yellow")    # 18.2.08
    lbopen1["text"]="File "+fn+" \nwas opened with "+str(r)+" rows and "+str(k)+"  columns"
    
    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,x,obj)   # 6.8.2013

    

def xopenfilepdt():
    """ File selection of transformed data matrices
    through other PyHasse programs """
    # brg 29.10.2012 taken from sensitivity18_3
    #* 1.6.09
    # akt. 29.10.2012 (taken from sensitivity18_3), 6.8.2013
    # source: mainHD19
    global fn,r,k,x,prop,obj,rred,xred,objred
    
    r,k,x,obj,prop=rmod2.raireadin5(fn)
    lbpdtopen.config(bg="yellow")
    lbpdtopen["text"]="selected file (PyHasse (pdt) format) : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns"

    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,x,obj)    

##### end of edit-block ### 29.8.2013 ####


def pt_pr(o):
    """ calculates relative abundancies pr and sum of abundancies = pt
    """
    pt=sum(o)
    #print "o in pt_pr= ",o
    #print "pt= ",pt
    pr=rmod2.vecgen1(len(o))
    if pt!=0:
        for i in range(0,len(o)):
            pr[i]=1.0*o[i]/(1.0*pt)
        #print "pr= ",pr
    else:
        for i in range(0,len(o)):
            pr[i]=o[i]
    return pt,pr


def simpson(o):
    """ calculates Simpson index
    """
    pt,yhilf=pt_pr(o)
    xhilf=rmod2.vecgen1(len(o))
    s=0
    for i in range(0,len(o)):
        xhilf[i]=1.0*yhilf[i]*yhilf[i]
        s+=xhilf[i]
    
    if s>0:
        sim=1.0/(1.0*s)   # 1.0-s see simvar
    else:
        sim=9999
    return sim

def simvar(o):
    """ calculates Simpson-variante (see Salomon paper)
        o: population of algae, normalized (see pt_pr)
    """
    pt,yhilf=pt_pr(o)
    xhilf2=rmod2.vecgen1(len(o))
    s=0
    for i in range(0,len(o)):
        xhilf2[i]=yhilf[i]*yhilf[i]
        s+=xhilf2[i]
    sv=1.0-s
    return sv

def richness(o,limit):
    """ calculates from o the richness
        o: population of algae, normalized (see pt_pr)
        limit: if o<=limit, then this population will be ignored
    """
    pt,xhilf3=pt_pr(o)
    rc=0
    for i in xhilf3:
        if(i>limit):
            rc+=1
    return rc

def shannon(o):
    """ calculates Shannon index
        o: population of algae, normalized (see pt_pr)
    """
    pt,xhilf4=pt_pr(o)
    sh=0
    for i in range(0,len(o)):
        if xhilf4[i]!=0:
            sh-=xhilf4[i]*math.log(xhilf4[i])
        else:
            sh-=0
    return sh



def HD():
    """based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"""
    # Brg 20.12.07, 28.12.07, 2.10.,3.10.09, 5.7.2014
    # If the number of representants > 200 then only the cover-matrix and the level-population
    #
    global cov,dmneu2,rred2,objred2,k,r,rred,obj
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    
    rows=rmod2.matrixrowsum(xred,rred,k)
    flag=0
    for i1 in range(0,rred):
        for i2 in range(0,rred):
            if abs(rows[i1]-rows[i2])>0.0001:
                flag=1
                break
    if flag==1:
        txtc="Note the condition of same rowsum for each object\n is not fulfilled"
        lbcontrol.config(text="++++warning +++"+"\n"+txtc, bg="yellow")
    # sorting
    dmsort=rmod2.marray(rred,k)
    for i in range(0,rred):
        hilf=[]
        for j in range(0,k):
            hilf.append(xred[i][j])
        y,n=rmod2.raisort(k,hilf)
        ydecreas=rmod2.vecgen1(k)
        for j in range(0,k):
            ydecreas[k-1-j]=y[j]                
        for j in range(0,k):
            dmsort[i][j]=ydecreas[j]
    print "Sorted "
    rmod2.matout(rred,k,dmsort)                    

     
    dmneu=rmod2.marray(rred,k)
    for i in range(0,rred):
        for j in range(0,k):
            parsum=rmod2.vecgen1(k)
            for j1 in range(0,j+1):
                parsum[j]+=dmsort[i][j1]
            dmneu[i][j]=parsum[j]
    
    rred2,dmneu2,objred2,txt2,neq2=rmod2.equivcompactm(rred,k,dmneu,objred)
    zetahilf=rmod2.comp(rred2,k,dmneu2)  #zeta matrix with col<row
    zeta=rmod2.marray(rred2,rred2)
    for i1 in range(0,rred2):
        for i2 in range(0,rred2):
            zeta[i1][i2]=zetahilf[i2][i1]
    
    
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred2,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred2,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred2,adjc,lext)
       
    
    cov=rmod2.cover(rred2,tr,lext)

    if rred2>200:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram  Partialsums")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred2,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred2,rred2)
        geomy=rmod2.marray(rred2,rred2)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred2[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()
        txt=""
        tpequivalences=Tkinter.Toplevel(hf)
        teq=ScrolledText(tpequivalences,height=5,width=60)
        teq.pack()
        txteq="Equivalences of the raw matrix "+"\n"
        txteq+=txt+"\n"
        txteq+="Equivalences due to majorization "+"\n"
        txteq+=txt2
        teq.insert("end",txteq)
        buttcov=Tkinter.Button(hfhd2,text="cover-relations ",command=covpartsum)
        buttcov.pack()

def biodivindices():
    # brg 1.7.2014, 5.7.2014
    global cov3, rred3,objred3
    tpbiodiv=Tkinter.Toplevel(hf)
    tpbiodiv.title(' Biodiversity indices ')
    tbiodiv=ScrolledText(tpbiodiv, width=60, height=10)
    tbiodiv.pack()
    txt=" Biodiversity due to Simpson, SimpsonVariant, Shannon "+"\n"
    biomatrix=rmod2.marray(r,3)
    print "x = "
    rmod2.matout(r,k,x)
    print " "
    for i in range(0,r):
        hilfbio=[]
        for j in range(0,k):
            hilfbio.append(x[i][j])
        #print "hilfbio= ",hilfbio    
        simact=simpson(hilfbio)
        simvar_act=simvar(hilfbio)
        shact=shannon(hilfbio)
        #print simact,simvar_act,shact
        txt+=str(obj[i])+"\t"+str(round(simact,3))+"\t"+str(round(simvar_act,3))+"\t"+str(round(shact,3))+"\n"
        biomatrix[i][0]=simact
        biomatrix[i][1]=simvar_act
        biomatrix[i][2]=shact
    txt+="- - - e o f  - - - "
    tbiodiv.insert("end",txt)
    
    rred3,dmneu3,objred3,txt3,neq3=rmod2.equivcompactm(r,3,biomatrix,obj)
    #
    print "rred3=  ",rred3
    zetahilf3=rmod2.comp(rred3,3,dmneu3)  #zeta matrix with col<row
    zeta3=rmod2.marray(rred3,rred3)
    for i1 in range(0,rred3):  #however we need for the 'normal' presentation: row < col. Transposition
        for i2 in range(0,rred3):
            zeta3[i1][i2]=zetahilf3[i2][i1]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred3,zeta3)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred3,lext,revlext,zeta3)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred3,adjc,lext)
       
    
    cov3=rmod2.cover(rred3,tr,lext)
    
    tp3=Tkinter.Toplevel(hf)
    freq3=Tkinter.Frame(tp3)
    freq3.pack()
    if rred3>100:
        lbhd4=Tkinter.Label(freq3,text=" +++too many objects ++++  ",bg="yellow")
        lbhd4.pack()                  
    else:
        lbhd4=Tkinter.Label(freq3,text=" Hasse Diagram  Biodiv")
        lbhd4.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred3,levmax,zzmax)
        cv=Tkinter.Canvas(freq3,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred3,rred3)
        geomy=rmod2.marray(rred3,rred3)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov3[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred3[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()
        buttcov3=Tkinter.Button(tp3,text="coverrelations biodiv ",command=coverbiodiv)
        buttcov3.pack()       

        
def covpartsum():
    # brg 2.7.2014
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: POTanalysis2_1.py
    hfcover=Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix partialsums')
    
    lbhdps=Tkinter.Label(hfcover,text=" Cover-Relations partialsums")
    lbhdps.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,rred2):
        txt3+="\n"+objred2[i]+":\t"
        txt3+="is covered by "
        for j in range(0,rred2):
            if i!=j:
                if cov[i][j]==1:
                    txt3+=" "+objred2[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)

        
def coverbiodiv():
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: POTanalysis2_1.py
    hfbd=Tkinter.Toplevel(hf)
    hfbd.title(' cover-matrix biodiv_indices')
    
    lbhdbd=Tkinter.Label(hfbd,text=" Cover-Relations Biodiv_indices ")
    lbhdbd.pack()
    txt3="\n cover-matrix biodiv \n"
    for i in range(0,rred3):
        txt3+="\n"+objred3[i]+":\t"
        txt3+="is covered by "
        for j in range(0,rred3):
            if i!=j:
                if cov3[i][j]==1:
                    txt3+=" "+objred3[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfbd,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)
    


## Tkinter Plot
hf = Tkinter.Tk()
hf.title(' Biodiversity ')
aboutHDsimpl=raioop2.brgabout(hf,"tp1","about_biodiv.txt",2,\
            "July, 5th,2014"," about biodiv ", "white", "t1",80,5,ScrolledText)
helpHDsimpl=raioop2.brgabout(hf,"tp1","help_biodiv.txt",2,\
            "July, 5th,2014"," help_biodiv ", "white", "t1",80,5,ScrolledText)
    
fr=Tkinter.Frame(hf,width=60)
fr.pack()
frinput1 = Tkinter.Frame(fr, width=100, height=10)
frinput1.pack()
text = "Select first the file, then decide in which format to be opened "
lbinput1 = Tkinter.Label(frinput1,
                         text=text)
lbinput1.pack()
butt1 = Tkinter.Button(frinput1, text="Select filename  ",
                       bg="white", command=xselectfile)
butt1.pack()
                      
lbopen1 = Tkinter.Label(fr, text="")
lbopen1.pack()

buttHD=Tkinter.Button(fr,text="HD",width=25,bg="cyan",command=HD)
buttHD.pack()

lbcontrol=Tkinter.Label(fr,text="")
lbcontrol.pack(pady=5)
buttdiv=Tkinter.Button(fr,text="Biodiv_indices ",width=25,bg="cyan",command=biodivindices)
buttdiv.pack()

buttexit = Tkinter.Button(fr, text = 'exit', bg = 'red', width=25,command = hf.destroy)
buttexit.pack(pady=10)

hf.mainloop()


    
