# -*- coding: cp1252 -*-
import Tkinter
import rmod2
import raioop2
import random
from ScrolledText import *
import Canvas
import tkFileDialog
import stats
import pstat
import math






# brg 21.2.2011
# Idea: Let an approximative rank given (LPOM0) then: which combination
# of weights to generate a Composite indicator is nearest to the
# canonical one.
# 1.3.2011 limit value better estimated
# 2.3.2011: LPOMext as alternative
# 14.11.2011 correction, better explanation by an overviewscheme
# 14.4.2012 improvements in results-display
# 16.4.2012 extension of results and possibility to store the weight combinations in an excel-like format
# 17.4.2012 HD of CI(dmg[]),rkav
# 15.-16.5.2012 Many changes
# 7.6.2012 Scatterplot

global ejspez

def overview():
    tpov=Tkinter.Toplevel(hf)
    cvov=Tkinter.Canvas(tpov,width=400,height=400,bg="white")
    cvov.pack()
    txt1=cvov.create_text(200,10,text="ranks due to LPOM given")
    txt2=cvov.create_text(200,70,text="set of weights (LPOMweights)")
    txt3=cvov.create_text(200,80,text="...with distances less than the")
    txt4=cvov.create_text(200,90,text="limit, given by the user ")
    txt5=cvov.create_text(200,200,text="read in an empirical weight vector 'weight_em'")
    txt6=cvov.create_text(70,300,text="Selection of LPOMweights\n with min. dist to weight_em")
    txt7=cvov.create_text(330,300,text="Selection of LPOMweights\n with max dist. to weight_em")
    li1=cvov.create_line(200,15,200,60,arrow="last",fill="red", width=2)
    li2=cvov.create_line(200,100,200,190,arrow="last",fill="red",width=2)
    li3a=cvov.create_line(200,210,70,285,arrow="last",fill="red")
    li3b=cvov.create_line(200,210,330,285,arrow="last",fill="red")
    


def showdm():
    """ New routine : shows the data matrix """
    #Brg 15.5.2012 taken from antichain5.py 
    tp2=Tkinter.Toplevel(hf)
    tp2.title(' show DM ')
    lbtp2=Tkinter.Label(tp2,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+ob[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+pro[j+1]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=pro[j+1]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=ob[i+1]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)

def HD():
    """based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"""
    # Brg 20.12.07, 28.12.07, 2.10.,3.10.09, 15.4.2012
    # If the number of representants > 70 then only the cover-matrix and the level-population
    #
    global xred, rred, k, succ, pred, incomp, elimit,eMCsim,eweights,objred,zeta,cov,fn
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    
    fn=tkFileDialog.askopenfilename()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    lb1.config(text="opened "+fn,bg="yellow")
    

    prop=[]
    for j in range(0,k):
        prop.append(pro[j+1])
            
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
    for i in range(0,r):
        obj[i]=ob[i+1]

   
    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,dm,obj)  
    
    #
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    # calculation of LPOM
    
    succ=rmod2.vecgen1(rred)
    pred=rmod2.vecgen1(rred)
    incomp=rmod2.vecgen1(rred)
    
    for i in range(0,rred):
        for j in range(0,rred):
            if zeta[i][j]==0 and zeta[j][i]==1:
                succ[i]+=1
            if zeta[i][j]==1 and zeta[j][i]==0:
                pred[i]+=1
            if zeta[i][j]==0 and zeta[j][i]==0:
                incomp[i]+=1
    #print "succ ",succ
    #print "pred ",pred
    #print "incomp ",incomp
    # Preparing the weight analysis            
    tpsubmit=Tkinter.Toplevel(hf)
    tpsubmit.title(' weight-analysis ')
    lbelimit=Tkinter.Label(tpsubmit,text="weights for which the distance CI - Rkav(LPOM) is less than....")
    lbelimit.pack()
    elimit=Tkinter.Entry(tpsubmit,width=4)
    elimit.pack()
    lbMCSim=Tkinter.Label(tpsubmit, text="number of MC-simulations  ( recommended 100 power k,\n\
    k number of attributes")
    lbMCSim.pack()
    eMCsim=Tkinter.Entry(tpsubmit,width=10)
    eMCsim.pack()
##    lbempirweights=Tkinter.Label(tpsubmit, text="if known then the empirical weights can be read in ")
##    lbempirweights.pack()
##    eweights=rmod2.vecgen1(k)
##    frw=Tkinter.Frame(tpresults)
##    frw.pack()
##    for j in range(0,k):
##        eweights[j]=Tkinter.Entry(frw,width=3)
##        eweights.grid(row=0, column=j)
    
    if rred>300:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram  ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()
        bcover=Tkinter.Button(freq,text="cover relation ",command=cover_show)
        bcover.pack()


def SaPaUa():
    #Brg 30.9.09, 2.3.2011 taken from hdgt5 and appropriately modified for the purpose here
            
    Sa=rmod2.marray1(rred,rred,-1)
    Pa=rmod2.marray1(rred,rred,-1)
    Ua=rmod2.marray1(rred,rred,-1)
    countSa=rmod2.vecgen1(rred)
    countPa=rmod2.vecgen1(rred)
    countUa=rmod2.vecgen1(rred)
    
    # Order ideal
    for ob in objred:
        obi=objred.index(ob)
        
        #obi the selected element whose rkav will be deternmined
        z=0
        for i1 in range(0,rred):
            if zeta[i1][obi]==1:
                z+=1
                Sa[obi][i1]=i1
        #print "ob = ",ob,"  its order ideal:  ",Sa[obi]
        countSa[obi]=z

    # order filter
    for ob in objred:
        obi=objred.index(ob)
        
        #obi the selected element whose rkav will be deternmined
        z=0
        for i1 in range(0,rred):
            if zeta[obi][i1]==1:
                z+=1
                Pa[obi][i1]=i1
        #print "ob = ",ob,"  its order filter:  ",Pa[obi]
        countPa[obi]=z

    #incomparables
    for ob in objred:
        obi=objred.index(ob)
        
        #obi the selected element whose rkav will be deternmined
        z=0
        for i1 in range(0,rred):
            if zeta[i1][obi]==0 and zeta[obi][i1]==0:
                z+=1
                Ua[obi][i1]=i1
        #print "ob = ",ob,"  its incomparables  ",Ua[obi]
        countUa[obi]=z
    
    rkav2=rmod2.vecgen1(rred)
    for i2 in range(0,rred):
        rkav2[i2]=countSa[i2]  #note Sa includes the interesting element a too
     
    
    for ob in objred:
        obi=objred.index(ob)
        increment=0
        
        for y in Ua[obi]:
            #print "y in increment loop: ",objred[y]," ",
            Uy=[]
            Pdown=0
            Pup=0
            
            if y!=-1:
                for i1 in range(0,rred):
                    if zeta[i1][y]==0 and zeta[y][i1]==0:
                        Uy.append(i1)
                
                for x in Uy:
                    if x in Sa[obi]:
                        Pdown+=1
                            
                for x in Uy:
                    if x in Pa[obi]:
                        Pup+=1
                
                dinc=1.0*Pdown/(1.0*Pdown+1.0*Pup)
                
                increment+=dinc
                
        rkav2[obi]+=1.0*increment
    return rkav2   



def weightanalysis():
    # brg 21.2.2011, 15.4.2012, 17.4.2012, 16.5.2012
    global select,anz,dmg,rkav,distance,dmgdist,ming,ydm,limit
    try:
        select=esel.get()
    except:
        select="n"  #LPOM0 wanted (default)
    if select=="" or select==" " or select=="  " or select=="   ":
        select="n"
    rkav=rmod2.vecgen1(rred)
    if select=="y":
        rkav=SaPaUa()
    else:  #LPOM0    
        for i in range(0,rred):
            rkav[i]=(succ[i]+1.0)*(rred+1.0)/(rred+1.0-incomp[i])
   
        
        
    #print rkav    
    #composite indicator
    ydm=rmod2.matrixnorm(rred,k,xred) #[0,1]-normalized data matrix
    g=rmod2.vecgen1(k) #weights
    
    
    try:
        limit=float(elimit.get())
    except:
        limit=(4.0/rred)   #  twwo inversions, hence limiting distance <4  

    try:
        MCsim=int(eMCsim.get())
    except:
        if k<5:
            MCsim=100**k
        else:
            MCsim=100000

    
            
    tpresult=Tkinter.Toplevel(hf)
    tpresult.title(' weights minimizing the distance CI and Rkav(LPOM) ')
    tresult=ScrolledText(tpresult,width=60, height=10)
    tresult.pack()
    txt=" ================================="+"\n"
    txt+="Parameters: "+"\n"
    txt+="Limiting value for the distance : "+str(limit)+"\n"
    txt+="Parameter select: "+select+"\n"
    if select=="n":
        txt+="Method to calculate the averaged rank: LPOM0"+"\n"
    elif select=="y":
        txt+="Method to calculate the averaged rank: LPOMext"+"\n"
    else:
        txt+="Method to calculate the averaged rank: LPOM0"+"\n"
    txt+="Number of MC-simulations         :"+str(MCsim)+"\n\n"
    txt+="\t"+"distances and their weight-vector"+ "\n"

    ming=9999
    distance=rmod2.vecgen1(10000)
    dmg=rmod2.marray(10000,k) #arbitrary limit of the data field for minimal weights
    dmgdist=rmod2.marray(10000,k+1)
    zahl=0
    for mc in range(0,MCsim):  #MCsimulation
        sumg=0
        for j in range(0,k):
            g[j]=0.001*random.randint(1,1000)
            sumg+=g[j]
        if sumg!=1:
            for j in range(0,k):
                g[j]=1.0*g[j]/(1.0*sumg)

        comind=rmod2.vecgen1(rred)   # composite indicator        
        for i in range(0,rred):
            for j in range(0,k):
                comind[i]+=g[j]*1.0*ydm[i][j]
            #print "MCsim no ",mc, obj[i],"  composite indicator value = ", comind[i]    

               
        rkci1=pstat.lrankdata(comind)
        rklpom1=pstat.lrankdata(rkav)
        dist=0
        for i in range(0,rred):
            dist+=(rkci1[i]-rklpom1[i])**2
        #print "mc-sim no: ", mc,"  distance = ",dist
        dit=dist/(1.0*rred)    
        if dit<limit:
            txt+=str(zahl)+": dist = "+str(round(dit,4))+"\tweights: "
            distance[zahl]=dit
            dmgdist[zahl][0]=dit
            for j in range(0,k):
                txt+=str(round(g[j],3))+" "
                dmg[zahl][j]=g[j]
                dmgdist[zahl][j+1]=g[j]
            
            if zahl>9998:
                txt+="+++ only the first 9998 trials ++++"+"\n\n"
                break
            txt+="\n"    
        
        
            if dit<ming:
                ming=dit
                mcspez=zahl
            zahl+=1
            anz=zahl
    txt+=str(anz)+" of " + str(MCsim)+" cases, where the squared distance (CI(random),Rkav) < "+str(limit)+"\n"        
    txt+="minmal reached distance (squared)= "+str(ming)+"  case no  "+str(mcspez)+"\n"
                    
    txt+="---     e o f    --- "
        
    
    tresult.insert("end",txt)
    
        

def displayminweight():
    # brg 15.5.2012
    tpdisplayminw=Tkinter.Toplevel(hf)
    tpdisplayminw.title(' minimal weight combinations ')
    tdisplayminw=ScrolledText(tpdisplayminw,height=10, width=60)
    tdisplayminw.pack()
    txtminweight=" Weight combinations whose distance of CI is minimal to Rkav "+"\n"
    txtminweight+=60*"="+"\n"
    txtminweight+="distance"+"\t"+"weights "+"\n"
    for mc1 in range(0,10000):
        if 0<dmgdist[mc1][0]<ming+0.1*ming:
            txtminweight+=str(round(dmgdist[mc1][0],3))+"\t"
            for j in range(0,k):
                txtminweight+=str(round(dmgdist[mc1][j+1],3))+", "
            txtminweight+="\n"

    txtminweight+="\n"+" - - -   e o f - - - "
    tdisplayminw.insert("end",txtminweight)
    
            
            
    

def wstore():
    # brg 16.4.2012, 18.4.2012
    
    dmsave1=rmod2.marray(anz,k+1)
    for i in range(0,anz):
        dmsave1[i][0]=distance[i]
        for j in range(1,k+1):
            dmsave1[i][j]=dmg[i][j-1]    #only the rows not identical 0,0,0,...,0
    path="F:/Pythonprogramme/results/"
    fnweights="weightcombi"
        
    
    rmod2.raiwritematrix(path,fnweights,dmsave1,anz,k+1)
    lbsave1.config(text="save: "+path+fnweights,bg="yellow")  #  7.6.2012 check, warum die erste Spalte nicht durch Komma getrennt ist
    

def scatter():
    # brg 7.6.2012
    
    limit_actscatter=float(elimitscatter.get())
    dmsave2=rmod2.marray(anz,k+1)
    for i in range(0,anz):
        dmsave2[i][0]=distance[i]
        for j in range(1,k+1):
            dmsave2[i][j]=dmg[i][j-1]    #only the rows not identical 0,0,0,...,0
    gmg1=rmod2.marray(anz,2)
    names=rmod2.vecgen1(anz)
    
    for i in range(0,anz):
        names[i]=dmsave2[i][0] # distances
        gmg1[i][0]=dmsave2[i][1]
        gmg1[i][1]=dmsave2[i][2]
        
    app1=raioop2.brgscatterplot5(hf,"tpscatter01",names,gmg1,limit_actscatter,"g0","g1",anz)
    app1.anzeige()
    gmg1=rmod2.marray(anz,2)
    names=rmod2.vecgen1(anz)
    
    for i in range(0,anz):
        names[i]=dmsave2[i][0] # distances
        gmg1[i][0]=dmsave2[i][1]
        gmg1[i][1]=dmsave2[i][3]
        
    app2=raioop2.brgscatterplot5(hf,"tpscatter02",names,gmg1,limit_actscatter,"g0","g2",anz)
    app2.anzeige()

    gmg1=rmod2.marray(anz,2)
    names=rmod2.vecgen1(anz)
    
    for i in range(0,anz):
        names[i]=dmsave2[i][0] # distances
        gmg1[i][0]=dmsave2[i][2]
        gmg1[i][1]=dmsave2[i][3]
        
    app3=raioop2.brgscatterplot5(hf,"tpscatter12",names,gmg1,limit_actscatter,"g1","g2",anz)
    app3.anzeige()


def display_rkav():
    # brg 16.4.2012
    
    tprkav=Tkinter.Toplevel(hf)
    tprkav.title(' rkav as HD ')
    freq2=Tkinter.Frame(tprkav)
    freq2.pack()
    rkmatrix=rmod2.marray(rred,2)
    for i1 in range(0,rred):
        for i2 in range(0,2):
            rkmatrix[i1][i2]=rkav[i1]

    # standard HD
    rred2,xred2,objred2,txt2,neq2=rmod2.equivcompactm(rred,2,rkmatrix,objred)  
    
    #
    zetahilf2=rmod2.comp(rred2,2,xred2)  #zeta matrix with col<row
    zeta2=rmod2.marray(rred2,rred2)
    for i in range(0,rred2):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred2):
            zeta2[i][j]=zetahilf2[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred2,zeta2)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred2,lext,revlext,zeta2)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred2,adjc,lext)
       
    
    cov=rmod2.cover(rred2,tr,lext)

    # calculation of LPOM
    
    succ=rmod2.vecgen1(rred2)
    pred=rmod2.vecgen1(rred2)
    incomp=rmod2.vecgen1(rred2)
    
    for i in range(0,rred2):
        for j in range(0,rred2):
            if zeta2[i][j]==0 and zeta2[j][i]==1:
                succ[i]+=1
            if zeta2[i][j]==1 and zeta2[j][i]==0:
                pred[i]+=1
            if zeta2[i][j]==0 and zeta2[j][i]==0:
                incomp[i]+=1
    
    
    
    if rred2>300:
        lbhd3=Tkinter.Label(freq2,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq2,text=" Hasse Diagram  ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred2,levmax,zzmax)
        cv=Tkinter.Canvas(freq2,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred2,rred2)
        geomy=rmod2.marray(rred2,rred2)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred2[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()
        

def cover_show():
    """Cover-matrix of the HD of the original dm is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: -
    hfcover=Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    
    lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbhd2.pack()
    n=rred   #16.4.2012 not very nice...
    txt3="\n cover-matrix  \n"
    for i in range(0,n):
        txt3+="\n"+objred[i]+":\t"
        txt3+="is covered by "
        for j in range(0,n):
            if i!=j:
                if cov[i][j]==1:
                    txt3+=" "+objred[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=20)
    tcov.pack(expand=1,fill="both")
    tcov.insert("end",txt3)

def HDrkavci():
    # brg 17.4.2012
    # The CI with a user specified set of weights and the rkav will be combined to get a HD
    # rkav may be LPOM0 or LPOMext
    # Note: the basis is always the set of representants, even for the CI
    global txtHDrkavci,cov3,rred3,objred3
    txtHDrkavci=" Background i nfo to poset made of rkav and CI(spec) "+"\n"
    txtHDrkavci+=60*"="+"\n"
    tprkavci=Tkinter.Toplevel(hf)
    tprkavci.title(' HD of rkav (first attribute) and special CI (second attribute) ')
    freq3=Tkinter.Frame(tprkavci)
    freq3.pack()
    jspez=int(ejspez.get())
    gspez=rmod2.vecgen1(k)
    txtweight="weights selected "+"\n"
    for j in range(0,k):
        gspez[j]=dmg[jspez][j]
        txtweight+=str(round(gspez[j],3))+", "
    txtci="Values of CI with specific selected weights "+"\n"
    comindspez=rmod2.vecgen1(rred)   # composite indicator        
    for i in range(0,rred):
        for j in range(0,k):
            comindspez[i]+=gspez[j]*1.0*ydm[i][j]
        txtci+=str(round(comindspez[i],3))+", "
    txtci+="\n"

    #ranks after pstat
    print "CI spec ",comindspez
    cispezrk=pstat.lrankdata(comindspez)
    txtrankci="ranks of special ci "+"\n"
    for i in range(0,len(cispezrk)):
        txtrankci+=str(cispezrk[i])+", "
    txtrankci+="\n"
    txtrankrkav="ranks of PO "+"\n"
    print "rkav ",rkav
    rkavrank=pstat.lrankdata(rkav)
    for i in range(0,len(rkavrank)):
        txtrankrkav+=str(rkavrank[i])+", "
    txtrankrkav+="\n"    
    #preparing the dm of which the HD is to be drawn
    rkavci=rmod2.marray(rred,2)
    for i in range(0,rred):
        rkavci[i][0]=rkav[i]
        rkavci[i][1]=comindspez[i]

    # now the Hasse stuff
    rred3,xred3,objred3,txteq3,neq3=rmod2.equivcompactm(rred,2,rkavci,objred)  
    #preparing the background info
    txtHDrkavci+=txtweight+"\n"
    txtHDrkavci+=txtci+"\n"
    txtHDrkavci+="\n"
    txtHDrkavci+="ranks of CI and of rkav "+"\n"
    txtHDrkavci+=txtrankci
    txtHDrkavci+="\n"
    txtHDrkavci+=txtrankrkav
    txtHDrkavci+="\n"
    txtHDrkavci+=" Equivalence relations "+"\n"
    txtHDrkavci+=txteq3+"\n"
    txtHDrkavci+=" - - -  e o f  - - - "
    
    
    #
    zetahilf3=rmod2.comp(rred3,2,xred3)  #zeta matrix with col<row
    zeta3=rmod2.marray(rred3,rred3)
    for i in range(0,rred3):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred3):
            zeta3[i][j]=zetahilf3[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred3,zeta3)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred3,lext,revlext,zeta3)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred3,adjc,lext)
       
    
    cov3=rmod2.cover(rred3,tr,lext)

    # calculation of LPOM
    
    succ=rmod2.vecgen1(rred3)
    pred=rmod2.vecgen1(rred3)
    incomp=rmod2.vecgen1(rred3)
    
    for i in range(0,rred3):
        for j in range(0,rred3):
            if zeta3[i][j]==0 and zeta3[j][i]==1:
                succ[i]+=1
            if zeta3[i][j]==1 and zeta3[j][i]==0:
                pred[i]+=1
            if zeta3[i][j]==0 and zeta3[j][i]==0:
                incomp[i]+=1
    
    
    UrkavCI=0
    UrkavCI=sum(incomp)
    UrkavCI=0.5*UrkavCI

    if rred3>300:
        lbhd3=Tkinter.Label(freq3,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq3,text=" Hasse Diagram  ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred3,levmax,zzmax)
        cv=Tkinter.Canvas(freq3,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred3,rred3)
        geomy=rmod2.marray(rred3,rred3)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov3[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred3[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.create_text(50,actheight-20,text="U = "+str(UrkavCI))
        cv.pack()
    butt1=Tkinter.Button(tprkavci,text="cover-relation ",command=covrkci)
    butt1.pack()
    butt2=Tkinter.Button(tprkavci,text="backgroundinfo to poset due to rkav, CI(spec)",command=details)
    butt2.pack()

def covrkci():
    #brg 17.4.2012
    """Cover-matrix of dmrkci is displayed"""
    #brg: taken from mainHD20_2
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: mainHD20_2
    hfcover2=Tkinter.Toplevel(hf)
    hfcover2.title(' cover-matrix ')
    
    lbhd2=Tkinter.Label(hfcover2,text=" Cover-Relations of rkavCI ")
    lbhd2.pack()
    n=rred3   #16.4.2012 not very nice...
    txt4="\n cover-matrix  \n"
    for i in range(0,n):
        txt4+="\n"+objred3[i]+":\t"
        txt4+="is covered by "
        for j in range(0,n):
            if i!=j:
                if cov3[i][j]==1:
                    txt4+=" "+objred3[j]+" ,"
                else:
                    pass
            else:
                pass
        txt4+="\n"    
    txt4+="\n"
    txt4+=" -- end of list --"
    tcov=ScrolledText(hfcover2,width=50, height=20)
    tcov.pack(expand=1,fill="both")
    tcov.insert("end",txt4)

def details():
    #brg 17.4.2012
    tprkavci2=Tkinter.Toplevel(hf)
    tprkavci2.title(' details concerning rkav,ci ')
    trkavci=ScrolledText(tprkavci2, width=60,height=10)
    trkavci.pack()
    trkavci.insert("end",txtHDrkavci)
    
    

def emwsubmit():
    #brg 24.2.2011
    global emweights
    tpemw=Tkinter.Toplevel(hf)
    lb2=Tkinter.Label(tpemw,text="Empirical weights")
    lb2.pack()
    frew=Tkinter.Frame(tpemw)
    frew.pack()
    emweights=rmod2.vecgen1(k)
    for j in range(0,k):
        emweights[j]=Tkinter.Entry(frew,width=5)
        emweights[j].grid(row=0,column=j)
        
def distanceemwlpom():
    #brg 24.2.2011, 15.4.2012
    weightsempirical=rmod2.vecgen1(k)
    for j in range(0,k):
        try:
            weightsempirical[j]=float(emweights[j].get())
        except:
            weightsempirical[j]=1.0/(1.0*k)
    print "weights empirical ", weightsempirical
    dist=rmod2.vecgen1(anz)
    maxdist=0
    mindist=99999
    for mc in range(0,anz):
        for j in range(0,k):
            dist[mc]+=(dmg[mc][j]-weightsempirical[j])**2
        if dist[mc]<mindist:
            mindist=dist[mc]
            mcspec=mc
        
        
        if dist[mc]>maxdist:
            maxdist=dist[mc]
            mcspec2=mc
        
             
    tpresult2=Tkinter.Toplevel(hf)
    tpresult2.title(' comparison emiprical and weights taken from the MCsimulation ')
    tresult2=ScrolledText(tpresult2,width=80,height=10)
    tresult2.pack()
    txt=" Used method to calculate the averaged ranks "+"\n"
    if select=="n":
        txt+="LPOM0"
    elif select=="y":
        txt+="LPOMext"
    else:
        txt+="LPOM0"
    txt+="\n"    
    txt+="  Distance between weights (distance D(CI,Rkav)) and empirical weight "+"\n"
    txt+=60*"="+"\n"
    txt+="1)Minimal distance (squared Euclidian) = "+str(round(mindist,4))+"\n"
    txt+="1.1)Empirical weights "
    for j in range(0,k):
        txt+=str(weightsempirical[j])+"\t"
    txt+="\n"
    if mindist!=99999:
        txt+="1.2) weights (taken from MCsim) with minimal distance to the empirical weights "+"\n"
        txt+=60*"-"+"\n"
        txt+="The "+str(mcspec)+" position (counted 0,1,2,...)"+"\n"
        for j in range(0,k):
            txt+=str(round(dmg[mcspec][j],4))+"\t"
        txt+="\n"
    else:
        txt+="+++ no meaningful results ++++ "
    if maxdist!=0:    
        txt+="2) Maximal distance (MCsim-weights)- empirical weights: "+str(round(maxdist,4))+"\n"
        txt+="\n"
        txt+="2.1) Empirical weights "+"\n"
        for j in range(0,k):
            txt+=str(weightsempirical[j])+"\t"
        txt+="\n"
        txt+="weights (taken from MCsim) with maximal distance to the empirical weights "+"\n"
        for j in range(0,k):
            txt+=str(round(dmg[mcspec2][j],3))+"\t"
        txt+="\n"
    else:
        txt+="+++ no meaningful results +++"
    txt+="\n- - -    e o f - - - "
    tresult2.insert("end",txt)
    
        


    
def st():
    #brg 22.2.2011, 16.5.2012
    dmsave=rmod2.marray(anz,k)
    for i in range(0,anz):
        for j in range(0,k):
            dmsave[i][j]=dmg[i][j]    #only the rows not identical 0,0,0,...,0
    path="F:/Pythonprogramme/results/"
    try:
        fndmsave=ename.get()
        
    except:
        fndmsave="gmatrix"+str(random.randint(1,1000))
    rmod2.raiwritematrix(path,fndmsave,dmsave,anz,k)
    lbsave2.config(text="save: "+path+fndmsave,bg="yellow")
                  
def submitgspez():
    # brg 16.5.2012
    global egspez,tspecific
    tpspecific1=Tkinter.Toplevel(hf)
    tpspecific1.title(' input specific weights  ')
    tspecific=ScrolledText(tpspecific1,height=10,width=60)
    tspecific.pack()
    egspez=rmod2.vecgen1(k)
    frgs=Tkinter.Frame(tpspecific1)
    frgs.pack()
    buttspez1_2=Tkinter.Button(frgs,text="Calc. D(CI,Rkav) due to the user defined weights ",bg="cyan",width=30,command=Digspez)
    buttspez1_2.pack() 
    for j in range(0,k):
        egspez[j]=Tkinter.Entry(frgs,width=4)
        egspez[j].pack(side="left")
   
    

def Digspez():
    # brg 16.5.2012
    #calculation of D(CI(g),Rkav), g specifically given by the user, called gspez
    # D will be calculated with that LPOM-model, which was selected in 'weight analysis'
    
    txt=" \n Specific analysis of D(CI(gspez), Rkav), gspez by user "+"\n"
    txt+=60*"="+"\n"
    txt+="User defined weights "+"\n"
    gspez=rmod2.vecgen1(k)
    for j in range(0,k):
        gspez[j]=float(egspez[j].get())
        txt+=str(round(gspez[j],3))+", "
    txt+="\n"    
        
    comindspez=rmod2.vecgen1(rred)   # composite indicator        
    for i in range(0,rred):
        for j in range(0,k):
            comindspez[i]+=gspez[j]*1.0*ydm[i][j]


    rkci1=pstat.lrankdata(comindspez)
    rklpom1=pstat.lrankdata(rkav)
    dist=0
    for i in range(0,rred):
        dist+=(rkci1[i]-rklpom1[i])**2        
    distnormiert=1.0*dist/(1.0*rred)
    txt+="Distance D(CI,Rkav), CI depending on user input: "+str(round(distnormiert,3))+"\n"
    if distnormiert>limit:
        txt+="These weights lead to larger D(CI,Rkav) than the limit:  "+str(limit)+"\n"
    else:
        txt+="These weights lead to smaller D(CI,Rkav) than the limit: "+str(limit)+"\n"
    txt+="- - - e o f - - -"+"\n"
    tspecific.insert("end",txt)

    
    rkavci=rmod2.marray(rred,2)
    for i in range(0,rred):
        rkavci[i][0]=rkav[i]
        rkavci[i][1]=comindspez[i]

    # now the Hasse stuff
    rred3,xred3,objred3,txteq3,neq3=rmod2.equivcompactm(rred,2,rkavci,objred)  
        #
    zetahilf3=rmod2.comp(rred3,2,xred3)  #zeta matrix with col<row
    zeta3=rmod2.marray(rred3,rred3)
    for i in range(0,rred3):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred3):
            zeta3[i][j]=zetahilf3[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred3,zeta3)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred3,lext,revlext,zeta3)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred3,adjc,lext)
       
    
    cov3=rmod2.cover(rred3,tr,lext)

    # calculation of LPOM
    
    succ=rmod2.vecgen1(rred3)
    pred=rmod2.vecgen1(rred3)
    incomp=rmod2.vecgen1(rred3)
    
    for i in range(0,rred3):
        for j in range(0,rred3):
            if zeta3[i][j]==0 and zeta3[j][i]==1:
                succ[i]+=1
            if zeta3[i][j]==1 and zeta3[j][i]==0:
                pred[i]+=1
            if zeta3[i][j]==0 and zeta3[j][i]==0:
                incomp[i]+=1
    
    
    UrkavCI=0
    UrkavCI=sum(incomp)
    UrkavCI=0.5*UrkavCI
    tpHDuser=Tkinter.Toplevel(hf)
    tpHDuser.title('HD resulting from Rkav and CI(gspez) ')
    freq3=Tkinter.Frame(tpHDuser)
    freq3.pack()
    if rred3>300:
        lbhd3=Tkinter.Label(freq3,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq3,text=" Hasse Diagram  ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred3,levmax,zzmax)
        cv=Tkinter.Canvas(freq3,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred3,rred3)
        geomy=rmod2.marray(rred3,rred3)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov3[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred3[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.create_text(50,actheight-20,text="U = "+str(UrkavCI))
        cv.pack()
    

hf=Tkinter.Tk()
hf.title(' canonweight ')
aboutHDsimpl=raioop2.brgabout(hf,"tp1","about_canonweight.txt",9,\
            "May, the 16th,2012"," about canonweight ", "white", "t1",80,5,ScrolledText)
helpHDsimpl=raioop2.brgabout(hf,"tp1","help_canonweight.txt",9,\
            "May, the 16th, 2012"," help_HDcanonweights ", "white", "t1",80,5,ScrolledText)
buttov=Tkinter.Button(hf,text="overview ",bg="green", width=25,command=overview)
buttov.pack()

fr=Tkinter.Frame(hf,width=60)
fr.pack()

buttHD = Tkinter.Button(fr, text='select, open and HD',width=50,bg="cyan",command=HD)
buttHD.pack(pady=5)
lb1=Tkinter.Label(fr,text=" ",width=50)
lb1.pack()
buttshowdm=Tkinter.Button(fr,text="Show dm ",width=50,command=showdm)
buttshowdm.pack(pady=2)
fr2=Tkinter.Frame(fr,bd=3,relief="sunken")
fr2.pack(pady=2)
lb2=Tkinter.Label(fr2,text="selection of the method to calculate average rank:\n\
'n' the LPOM0, 'y': the extended LPOM after Brg & Carlsen, 2011\n (Default: LPOM0)")
lb2.pack()
esel=Tkinter.Entry(fr2,width=3)
esel.pack(pady=2)
buttweightanalysis=Tkinter.Button(fr2, text=" weight-analysis ",width=50, bg="cyan", command=weightanalysis)
buttweightanalysis.pack(pady=5)
buttstoreweightcombin=Tkinter.Button(fr2,text="save your weight combinations\n (with the distances) ",bg="cyan",width=50, command=wstore)
buttstoreweightcombin.pack(pady=5)
lbsave1=Tkinter.Label(fr2,text="")
lbsave1.pack()
lblimit=Tkinter.Label(fr2,text=" Enter a limiting value for the distance--> scatterplot ",width=50)
lblimit.pack()
elimitscatter=Tkinter.Entry(fr2,width=4)
elimitscatter.pack()
buttscatter=Tkinter.Button(fr2,text="scatterplot ",bg="cyan",width=50,command=scatter)
buttscatter.pack()
buttdisplay=Tkinter.Button(fr2,text="Display weights with minimal distance to Rkav ",bg="cyan",width=50,command=displayminweight)
buttdisplay.pack()
buttdisplay=Tkinter.Button(fr2,text="Display weak order due to av. rk ", bg="cyan", width=50, command=display_rkav)
buttdisplay.pack()
buttspez1=Tkinter.Button(fr2,text="submit user defined weights",bg="cyan",width=50,command=submitgspez)
buttspez1.pack()
frspecial=Tkinter.Frame(fr2,relief="groove")
frspecial.pack()
lbspez=Tkinter.Label(frspecial,text=" Enter the id-number of the weight tuple obtained from weight analysis >>")
lbspez.pack(side="left")
ejspez=Tkinter.Entry(frspecial,width=4)
ejspez.pack(side="left")
buttspez2=Tkinter.Button(frspecial,text=" HD of rkav and CI(spec) ",width=50,bg="cyan",command=HDrkavci)
buttspez2.pack(side="right")
fremw=Tkinter.Frame(hf,relief="sunken",bd=4)
fremw.pack(pady=5)
lbemw=Tkinter.Label(fremw,text=" This part is assuming that weights for CI are known ")
lbemw.pack()
buttemw=Tkinter.Button(fremw,text=" open field for empirical weights ",bg="cyan",width=50,command=emwsubmit)
buttemw.pack()
buttempirical=Tkinter.Button(fremw,text=" comparison with \n  empirical weights ",bg="cyan",width=50,command=distanceemwlpom)
buttempirical.pack()
lbsave2=Tkinter.Label(fremw,text="name of file for weightmatrix")
lbsave2.pack()
ename=Tkinter.Entry(fremw,width=10)
ename.pack()
lbsave=Tkinter.Label(fremw,text="")
lbsave.pack()
buttsave=Tkinter.Button(fremw,text="Save the weights < limit (without distances)", width=50,bg="cyan", command=st)
buttsave.pack(pady=3)

buttexit=Tkinter.Button(hf,text=" exit  ",bg="red", width=50,command=hf.destroy)
buttexit.pack(pady=10)

hf.mainloop()
