# -*- coding: cp1252 -*-
import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import tkFileDialog
import raioop2
import stats
import pstat
import random
import math


# Development: chain1.py : June 2010, starting from "HDsimpl1.py"
# chain3: 21.9.10 Control of height of chain, search fctn
# chain4: 26.6.2011. Characterization of start- and endpoint of a chain
# chain5: 22.7.2011 The management of maximal chain length is unsatisfactory. Hence a new version
# chain6.py: 7.9.2011 cosmetics
# chain7_1: 13.9.2012 chain-matrix
# chain8_1: Many changes. Mainly concerning the chainmatrix and layouts
# chain8_3: Many minor changes, 25.7.2013
# chain8_4: show cover matrix
# chain8_5.py: bug in txt-output eliminated


def fileselect_PyHasse():
    """ File selection of transformed data matrices
    through other PyHasse programs """
    #* 1.6.09
    # akt. 11.7.10 (taken from mainHD19 and modified
    # source: mainHD19
    global fn,r,k,dm,pro0,prop, on,ob,obj,xred,rred,objred,txt,n
    fn=tkFileDialog.askopenfilename()
    r,k,dm,obj,prop=rmod2.raireadin5(fn)
    pro0=rmod2.vecgentext1(k)
    pro0[0]="prop"              #this 3 lines construction needed because attsel needs pro0
    for j in range(1,k):
        pro0[j]=prop[j-1]
    #print "in mainHD = : r= ",r,"  k= ",k0
    ob=rmod2.vecgentext1(r+1) #this 3 lines construction needed because filecomp needs ob
    ob[0]="dummy"
    for i in range(1,r+1):
        ob[i]=obj[i-1]
    
    lbopen.config(bg="yellow")
    lbopen["text"]="selected file (PyHasse format) : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns"
    rred,xred,objred,txt=rmod2.equivcompact(r,k,dm,obj)
    n=rred
    return 

def file_select():
    # Brg 3.9.10
    global fn,dm,obj,prop,rred,xred,objred,txtred,neq,k

    fn=tkFileDialog.askopenfilename()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    lb1.config(text="opened "+fn+"\n"+str(k)+" attributes",bg="yellow")
    

    prop=[]
    for j in range(0,k):
        prop.append(pro[j+1])
            
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
    for i in range(0,r):
        obj[i]=ob[i+1]

    global rred,objred
    rred,xred,objred,txtred,neq=rmod2.equivcompactm(r,k,dm,obj)  
    return

def showDM():
    """ New routine : shows the data matrix """
    #Brg 13.1.08 (from dds8)
    tp2=Tkinter.Toplevel(hf)
    tp2.title(' show DM ')
    lbtp2=Tkinter.Label(tp2,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+ob[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+pro[j+1]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=pro[j+1]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=ob[i+1]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)
    
def profile(xred,rred,avec):
    """Calculates a matrix where equivalent
    objectpairs with respect to the profile of
    attributes in avec get a 1 in the corresponding entry"""
    # brg 12.8.2011
    equivm=rmod2.marray(rred,rred)
    la=len(avec)
    for i1 in range(0,rred):
        hilf1=rmod2.vecgen1(la)
        j1zaehl=0
        for j1 in range(0,k):
            if j1 in avec:
                hilf1[j1zaehl]=xred[i1][j1]
                j1zaehl+=1
        rankx1 = pstat.rankdata(hilf1)
        #print "i1= ",i1,"    ranks ",rankx1
        for i2 in range(0,rred):
            hilf2=rmod2.vecgen1(la)
            j2zaehl=0
            for j2 in range(0,k):
                if j2 in avec:
                    hilf2[j2zaehl]=xred[i2][j2]
                    j2zaehl+=1
            #print "i2= ",i2,"   ranks ",ranksx2    
            if i1!=i2:
                rankx2=pstat.rankdata(hilf2)
                if rankx1==rankx2:
                    equivm[i1][i2]=1
    return equivm    
    


def HD():
    """based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"""
    # Brg 20.12.07, 28.12.07, 2.10.,3.10.09, 13.6.10
    # If the number of representants > 200 then only the cover-matrix and the level-population
    #
    global perturb,cov,rred,objred
    try:
        avec=eavec.get().split(',')
        la=len(avec)
        for j in range(0,la):
            avec[j]=int(avec[j])
    except:
        avec=[]
        for j in range(0,k):
            avec.append(j)
    print "avec = ",avec        
    try:
        perturb=int(eperturb.get())
    except:
        perturb=0
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    
        #
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    # Determination of equivalent profiles (note this is only
    # meaningful, if the attributes are on a common scale!!!!!)
    equivmact=profile(xred,rred,avec)

    # Now the drawing
    if rred>300:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram  ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=(perturb*random.randint(1,5)+1)*geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        rmod2.matout(rred,rred,equivmact)
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        iob1=lobj[i1][j1]
                        iob2=lobj[i][j]
                        if cov[iob1][iob2]==1:
                            if equivmact[iob1][iob2]==1:
                                cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1], width=3,fill="red")
                            else:
                                cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()
        buttcov=Tkinter.Button(freq,text="Show cover matrix ",width=25,command=shcov)
        buttcov.pack()


def shcov():
    #brg 25.8.2013
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: intervalHD
    
    hfcover=Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    
    lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbhd2.pack()
    txt="\n cover-matrix  \n"
    for i in range(0,rred):
        txt+="\n"+objred[i]+":\t"
        txt+="is covered by "
        for j in range(0,rred):
            if i!=j:
                if cov[i][j]==1:
                    txt+=" "+objred[j]+" ,"
                else:
                    pass
            else:
                pass
        txt+="\n"    
    txt+="\n"
    txt+=" -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt)


def profilediagr():
    """Draws a graph, where those objects are connected,
    which have the same profile in terms of a preselected
    (sub)set of attributes"""
    # brg 12.8.2011
    # taken from dds9.py and adapted
    try:
        avec=eavec.get().split(',')
        la=len(avec)
        for j in range(0,la):
            avec[j]=int(avec[j])
    except:
        avec=[]
        for j in range(0,k):
            avec.append(j)
    print "avec (in profilediagr) = ",avec,"  length of avec : ",len(avec)
    equivmact=profile(xred,rred,avec)
    
    hfgraph=Tkinter.Toplevel(hf)
    hfgraph.title(' equivalent w.r.t. profiles ')
    app1=raioop2.brgmatrixoutput2(hf,equivmact,"tpeq","eq.w.r.t.profiles","",rred,rred,objred,objred,"")
    app1.ausgabe()
    frgr=Tkinter.Frame(hfgraph,width=400,height=400,relief="raised",bd=3)
    frgr.pack()
    txtprofile="selected columns(0,1,2,...): "
    for j in range(0,la):
        if int(1.0*j/10.0)-1.0*j/10.0==0:
            txtprofile+="\n"
        txtprofile+=str(avec[j])+" ,"
    txtprofile+="\n"
    lbprofile2=Tkinter.Label(frgr,text=txtprofile)
    lbprofile2.pack()
    posx=rmod2.vecgen1(rred)
    posy=rmod2.vecgen1(rred)
    cvgr=Tkinter.Canvas(frgr,width=400, height=400)
    
    
    for i in range(0,rred):
        posx[i]=100*math.cos(i*6.28/rred)
        posy[i]=100*math.sin(i*6.28/rred)
        
        cvgr.create_oval(160+posx[i]-12,130+posy[i]+12,160+posx[i]+12,130+posy[i]-12,fill="yellow")       
        cvgr.create_text(162+posx[i],132+posy[i],text=str(objred[i]),font = "8")   #7.9.2011

    for i in range(0,rred):
        for j in range(0,rred):
            if i!=j:
                if equivmact[i][j]==1:
                    posx[i]=90*math.cos(i*6.28/rred)
                    posy[i]=90*math.sin(i*6.28/rred)
                    posx[j]=90*math.cos(j*6.28/rred)
                    posy[j]=90*math.sin(j*6.28/rred)
                    cvgr.create_line(160+posx[i],130+posy[i],160+posx[j],130+posy[j])  #7.6.08
                    
    cvgr.pack()





def chain():
    #brg 13.6.10, 21.9.10, 22.7.2011, 23.5.2013
    #brg 25.7.2013: major changes: countpath is now a list (in former times a set)
    # This part in order to perform 'path' without the need of displaying the HD
    global chset2,countpath, chainm, emincx, indicch
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    global cov,npath,countpath   #13.6.10
    cov=rmod2.cover(rred,tr,lext)   

    # the following lines are the proper path part
    grc=rmod2.graphcovdict(cov,rred)
    start=objred.index(estart.get())
    sink=objred.index(eend.get())
    if zeta[start][sink]==1:
        lbwarn.config(text=estart.get()+" < "+eend.get(),bg="white")
    else:
        lbwarn.config(text="+++ start and sink are not in a <-relation +++",bg="yellow")
    try:
        maxch=int(emaxch.get())
    except:
        maxch=1
    print "maxch = ",maxch    
    npath=rmod2.find_all_paths(grc,start,sink)
    lp=len(npath)
    print "npath  ",npath
    for i in range(0,lp):
        print "  napth[",i,"]= ",npath[i]
    # here the core of chain 22.7.2011
    countpath=[]  #25.7.2013 set replaced by dynamic list
    for i in range(0,lp):
        if len(npath[i])>=maxch:
            countpath.append(i)
    print "countpath = ",countpath," length of countpath:  ",len(countpath)
    chset=set([])
    il=[]
    bartxt=[]
    avchlength0=0 #correct notation would be avchheight. Height is the number of elements in a chain
    txtch="  General information   "+"\n"
    
    for i in countpath:
        #print "length of npath ",i,"  :",len(npath[i]), "  maxch= ",maxch
        il.append(len(npath[i]))  #il contains the length of each path (including start- and endpoint.
                                        #being longer or equal maxch
        avchlength0+=len(npath[i])
        bartxt.append(" ")
    print "list of lengths > ",maxch,": = ",il
    lcp=len(countpath)        
    if lcp!=0:
        #print "flagch ",flagch
        txtch+="there are chains with elements >= "+str(maxch) +"\n"
        avchlength=1.0*avchlength0/(1.0*lcp)
    else:
        txtch+="\n"+"There is no chain equal or exceeding "+str(maxch)+"\n"
        avchlength=0
        
    lenbartxt=len(bartxt)
    tpchain1=Tkinter.Toplevel(hf)
    tpchain1.title("chain: main part")
    txt="--- chain - analysis ---"
    txt+="\n"
    txt+="selected start-point "+estart.get()+"\n"
    txt+="selected end-point   "+eend.get()+"\n"
    txt+="selected min-height  "+str(maxch)+"\n"
    txt+="result: "
    txt+="\n"+50*"="+"\n"
    txt+=txtch+"\n"
    txt+="\n"+"Number of chains of height>= "+str(maxch)+": "+str(lcp)+"\n"
    txt+="Average number of objects per chain: "+str(round(avchlength,3))+"\n"
    txt+="The individual chains"+"\n"
    txthilf=" "
    chset2=rmod2.vecgen1(lcp)  #13.9.2012, 25.7.2013
    indicch=rmod2.vecgen1(lcp)
    zahl=0                        # 25.7.2013
    for i in countpath:   # 23.5.2013,25.7.2013 by definition countpath has only those paths whose length>maxch
        #print "loop countpath: ",i," npath[",i,"]= ",npath[i]
        chset2[zahl]=set([])    #13.9.2012
        indicch[zahl]=i         # 25.7.2013 assignment: zahl and real number of the chain (with >=maxch)
        lpi=len(npath[i])
        txthilf+="\n"+"chain no: "+str(i)+"  count of elements: "+str(lpi)+":\t"  #8.9.2011
        for j in range(0,lpi):
            txthilf+=objred[npath[i][j]]+", "
            chset2[zahl].add(objred[npath[i][j]])  #chset2[i]
                                                    #contains all elements between the two end points
                                                    #(order interval) of the ith chain which are longer than maxch
        zahl+=1                                     # countpath may have numbers such as 3,6, nevertheless the vector should
                                                    # only has 2 components
        txthilf+="\n"
    #print "chset2= ",chset2
    #print "indicch= ",indicch
    txt+=txthilf        
    txt+="\n"+50*"="+"\n"
    tchain1=ScrolledText(tpchain1,width=60,height=5)
    tchain1.pack()
    tchain1.insert("end", txt)
    if lcp!=0:    #22.7.2011
        app1=raioop2.brgbar6(tpchain1,il,bartxt," ",str(lcp)+" chains \n between \nsource: "+estart.get()+\
                         "\n and sink: "+eend.get()+"\n with count of elements >= "+str(maxch)+":",20)
        app1.ausgabe()

    #numerical characterization of start and endpoint
    tpchar=Tkinter.Toplevel(hf,width=120,height=10)  #is the window for the two profiles
    # determination of the union of all chains
    vertset=set([])
    zahl=0                #25.7.2013
    for i in countpath:   #25.7.2013
        vertset=vertset|chset2[zahl]      #25.7.2013 i replaced by a enumerator "zahl"
        zahl+=1
    print "vertset= ",vertset
    nrvertset=len(vertset)
    print "nrvertset= ",nrvertset
    objstart=estart.get()
    iobstart=objred.index(objstart)
    objend=eend.get()
    iobend=objred.index(objend)
    txtstart=objstart+":\t"
    maxq=[]
    minq=[]
    deltaq=[]
    deltaqendstart=[]
    reldeltaq=[]
    for j in range(0,k):
        maxq.append(-999999)
        minq.append(99999)
        for i in range(0,rred):
            if xred[i][j]>=maxq[j]:
                maxq[j]=xred[i][j]
            if xred[i][j]<=minq[j]:
                minq[j]=xred[i][j]
        
        deltaq.append(maxq[j]-minq[j])
        deltaqendstart.append(xred[iobend][j]-xred[iobstart][j])
    for j in range(0,k):
        #print maxq[j],minq[j],deltaq[j],deltaqendstart[j]
        if deltaq[j]!=0:
            reldeltaq.append(1.0*deltaqendstart[j]/(1.0*deltaq[j]))
        else:
            reldeltaq.append(None)
    #degree of disjointness of the chains between the two endpoints
    #idea: different chains between two endpoints have at least two vertices
    #......in common. If the number of chains is nchain, then the degree of disjointness: = vertices between two endpoints/
    #      sum of all vertices of all chains - (nchain-1)*2
    denom=(1.0*avchlength0-2*(lcp-1.0))
    if denom!=0:
        degreedisj=1.0*nrvertset/(1.0*denom)
    else:
        degreedisj=999999.99

    txtdd=str(round(degreedisj,2))
    txtdd+="\n"+"elements in the interval (=denominator)  = "+str(avchlength0)+" - "+str(2*(lcp-1))+"\n"
    txtdd+="all elements of the poset (=nominator) = "+str(nrvertset)
    txtatt=""
    txtatt+="increments related to max-min of dm"+"\n\t"
    for j in range(0,k):
        if reldeltaq!=None:
            txtatt+=str(round(reldeltaq[j],3))+"  "
        else:
            txtatt+="----"+"  "
    txtatt+="\n"        
    for j in range(0,k):
        txtstart+=str(xred[iobstart][j])+"  "
    txtstart+="\n"
    txtmiddle=""
    txtmiddle+="number of chains: "+str(lcp)+"\n"+"number of vertices "+str(nrvertset)
    txtmiddle+="\nFraction of all vertices: "+str(round(1.0*nrvertset/(1.0*rred),2))
    txtend=objend+":\t"
    for j in range(0,k):
        txtend+=str(xred[iobend][j])+"  "
    txtend+="\n"
    tchar=ScrolledText(tpchar,width=120,height=20)
    tchar.pack()
    txtfinal="\n"+txtatt+"\n\n"+"degree of separatedness of chains: "+txtdd+"\n\n"+txtend+"\n\n"+txtmiddle+"\n\n"+txtstart
    tchar.insert("end",txtfinal)
    # Graphics
    tpchain_increment=Tkinter.Toplevel(hf)
    tpchain_increment.title(' Profile-information ')
    cvchar=Tkinter.Canvas(tpchar,width=400,height=400,bg="white")
    cvchar.pack()
    cvchart1=cvchar.create_text(150,20,text=txtend)
    cvcharr=cvchar.create_rectangle(20,40,380,360,outline="red",width=2)
    cvchart2=cvchar.create_text(200,200,text=txtmiddle,font=("arial",14,"bold"))
    cvchart3=cvchar.create_text(150,380,text=txtstart)
    barth2=[]
    for j in range(0,k):
        barth2.append("d_"+prop[j])
    app2=raioop2.brgbar9(tpchain_increment,reldeltaq,barth2,"Relat. Incr. realized by selected endpoints  ",2)
    app2.ausgabe()
    
    # number of elements in the mutual intersections, divided by number of elements in the union (vertset)
    # only of those chains which belong to countpath, i.e. which have more or equal elements in their chain as maxch.
    
    chainm=rmod2.marray(lcp,lcp)
    for i1 in range(0,lcp):           #25.7.2013 i1, i2 are related to "zahl" not to the chain-id
        for i2 in range(0,lcp):
            #print "i1= ",i1,"  i2= ",i2," intersection = ",chset2[i1]&chset2[i2], "   union  = ",chset2[i1]|chset2[i2]
            chainm[i1][i2]=round(1.0*len(chset2[i1]&chset2[i2])/(1.0*len(chset2[i1]|chset2[i2])),3)
##    print "chainm "
##    rmod2.matout(lcp,lcp,chainm)
##    print "chainm-end"
    tpchain_matrix=Tkinter.Toplevel(hf)
    tpchain_matrix.title('  chain-matrix: (Minimal similarity)')
    tchain_matrix=ScrolledText(tpchain_matrix,width=60,height=10)
    tchain_matrix.pack()
    mincz=99999
    mincpair=[0,0]
    for i1 in range(0,lcp):
        for i2 in range(i1+1,lcp):
            #print "chainm = ",i1,i2,"  value= ",chainm[i1][i2],"   mincz ",mincz
            if chainm[i1][i2]<=mincz:
                mincz=chainm[i1][i2]
                mincpair[0]=i1
                mincpair[1]=i2
    txt="Maximal dissimilarity between "+"\n"
    if lcp!=0:      #13.9.2013
        txt+="chain Nr "+str(indicch[mincpair[0]])+": "+str(chset2[mincpair[0]])+"\n"
        txt+="chain No "+str(indicch[mincpair[1]])+": "+str(chset2[mincpair[1]])+"\n"
    else:
        txt+="+++There are no chains of required length+++\n "
    txt+=" similarity (min) = "+str(mincz)+"\n"
    txt+="+++ Note there may be many more chains with that minimum value of similarity "+"\n"
    txt+="\n"
    txt+="---    e o  f --- "
    tchain_matrix.insert("end",txt)
    buttaddinfo=Tkinter.Button(tpchain1,text="see the chain-matrix ",command=seechainmatrix)
    buttaddinfo.pack()
    labminx=Tkinter.Label(tpchain1,text="Select a value for chain-similarity ")
    labminx.pack()
    emincx=Tkinter.Entry(tpchain1,width=4)
    emincx.pack()
    buttfindallchainpairs=Tkinter.Button(tpchain1, text="Find all chain-pairs ",command=findallch)
    buttfindallchainpairs.pack()
    
    
def seechainmatrix():
    # brg 23.5.2013
    tpchainmatrix2=Tkinter.Toplevel(hf)
    tpchainmatrix2.title( 'additional concerning the chainmatrix ')
    txtchm="Chain matrix: content of intersection of two chains/content of union of two chains"+"\n"
    txtchm+=60*"="+"\n"
    txtchm+="Contents of chains "+"\n"
    for i1 in range(0,len(countpath)):
        txtchm+="chain"+str(indicch[i1])+" : "   #indicch  (25.7.2013)
        for elem in chset2[i1]:
            txtchm+=elem+"\t"
        txtchm+="\n"
    txtchm+=2*"\n"    
    txtchm+="\t"
    for i1 in range(0,len(countpath)):
        txtchm+="chain"+str(indicch[i1])+"\t"   #indicch (25.7.2013)
    txtchm+="\n"
    for i1 in range(0,len(countpath)):
        txtchm+="chain"+str(indicch[i1])+": "
        for i2 in range(0,len(countpath)):
            txtchm+=str(chainm[i1][i2])+2*"\t"
        txtchm+="\n"
    txtchm+="\n"
    txtchm+="   - - - e o f - - -  "
    tchainmatrix2=ScrolledText(tpchainmatrix2,width=60, height=20)
    tchainmatrix2.pack()
    tchainmatrix2.insert("end",txtchm)
    

def findallch():
    # brg 23.5.2013
    try:
        minc_act=float(emincx.get())
    except:
        minc_act=0.25
    print "in findallch   minc_act0 = ",minc_act
    
    minpairchain=[]    
    for i1 in range(0,len(countpath)):
        for i2 in range(i1+1,len(countpath)):
            if chainm[i1][i2]<=minc_act:
                minpairchain.append((indicch[i1],indicch[i2]))   # 25.7.2013 the real numbers as in countpath

    tpchainmatrix3=Tkinter.Toplevel(hf)
    tpchainmatrix3.title(' Chain-matrix with similarity less a certain limit ')
    tchainmatrix3=ScrolledText(tpchainmatrix3,width=60,height=10)
    tchainmatrix3.pack()
    txt=" Dissimilarity analyis in detail "+"\n"
    txt+="Selected limit "+str(minc_act)+"\n"
    lchainsim=len(minpairchain)
    txt+="There are "+str(lchainsim)+"... \n"
    txt+="... pairs of chain with the similarity less or equal than "+str(minc_act)+"\n"

    #25.7.2013 info minpairchain[i3])...
    # ...refers to an internal chain-no which is not
    # ...understandable for users, therefore use of indicch in the lines
    # ...where minpairchain is generated
    for i3 in range(0,lchainsim):                          
        txt+="chain-pair "+str(minpairchain[i3])+"\n"
    txt+="\n"
    txt+="-   -   - e o f  -   -   - "
    tchainmatrix3.insert("end",txt)
     
                                

def HDselch():
    #brg 8.9.2011, 25.7.2013
        
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse chain diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    
    
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)

    prop=[]
    for j in range(0,k):
        prop.append(pro[j+1])
            
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
    for i in range(0,r):
        obj[i]=ob[i+1]

    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,dm,obj)  

    noch=int(eselch.get())    #read in the chain number as it appears in countpath
    print "selected number ",noch
    print "noch[",noch,"]= ",npath[noch]
    nochset=set([])
    for i in range(0,len(npath[noch])):
        nochset.add(objred[npath[noch][i]])
    #
    print "nochset= ",nochset
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    if rred>200:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram  ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=(perturb*random.randint(1,5)+1)*geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        iob1=lobj[i1][j1]
                        iob2=lobj[i][j]
                        if cov[iob1][iob2]==1:  #new lines 8.9.2011
                            if objred[iob1] in nochset and objred[iob2] in nochset:
                                cv.create_line(geomx[i][j],geomy[i][j],\
                                               geomx[i1][j1],geomy[i1][j1],width=3,fill="red")
                            else:
                                cv.create_line(geomx[i][j],geomy[i][j],\
                                               geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                iob2=lobj[i][j]
                if objred[iob2] in nochset:
                    cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,\
                                   geomx[i][j]+10,geomy[i][j]-10,fill="white",outline="red")
                else:    
                    cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,\
                                   geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()



def chsearch():
    #brg21.9.2010
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    global cov   #13.6.10
    cov=rmod2.cover(rred,tr,lext)
    
    grc=rmod2.graphcovdict(cov,rred)
    set1=set(eset1.get().split(","))
    set2=set(eset2.get().split(","))
    print "set1 ",set1
    print "set2 ",set2
    aset1=[]
    aset2=[]
    for ob in set1:
        aset1.append(objred.index(ob))
    for ob in set2:
        aset2.append(objred.index(ob))

    print "aset1 = ",aset1
    print "aset2 = ",aset2
    #npath2 has the structure [[1,2,3,4],[1',2'],[1'',2'',3''],...]
    pathmat=rmod2.marray(len(aset1),len(aset2))
    z1=0
    for ob1 in set1:
        z2=0
        for ob2 in set2:
            npath2=rmod2.find_all_paths(grc,objred.index(ob1),objred.index(ob2))
            maxch=0
            len2=len(npath2)
            hilf=[]
            for ij in range(0,len2):
                hilf.append(len(npath2[ij]))
            if len(hilf)>0:    
                nochmax=max(hilf)
            else:
                nochmax=0
            hilf.append(nochmax)
            
            print "ob1= ",ob1,"  ob2 = ",ob2,"  hilf = ", hilf
            zch=len(hilf)
            if zch>0:
                pathmat[z1][z2]=[zch-1,hilf[zch-1]]
            else:
                pathmat[z1][z2]=[0,0]
            print "pathmat = ",pathmat[z1][z2]
            z2+=1
        z1+=1    
    print " "
    maxmaxch=0
    z1=0
    for i in aset1:
        z2=0
        for j in aset2:
            if pathmat[z1][z2][1]>maxmaxch:
                maxmaxch=pathmat[z1][z2][1]
                sourcemax=i
                sinkmax=j
            z2+=1
        z1+=1    

    tpchsearch=Tkinter.Toplevel(hf)
    tpchsearch.title(' Chain-search ')
    tchsearch=ScrolledText(tpchsearch,width=80,heigh=5)
    tchsearch.pack()
    txt=" Result of search \n"
    txt+=60*"="+"\n"
    txt+=" set of sources: "
    for i in range(0,len(aset1)):
        txt+=str(objred[aset1[i]])+", "
    txt+="\n set of sinks: "
    for i in range(0,len(aset2)):
        txt+=str(objred[aset2[i]])+", "
    txt+="\n Chain with maximal height from " +str(objred[sourcemax])+" to "+str(objred[sinkmax])+"  with height "+str(maxmaxch)+"\n"
    txt+=" Special results for each objectpair taken from source and sink set , resp. \n"
    txt+="\n"+str(len(aset1)*len(aset2))+" combinations\n"
    z1=0
    for i in aset1:
        z2=0
        for j in aset2:
            txt+=str(objred[i])+"\t"+",\t"+str(objred[j])+": #(chains): "+str(pathmat[z1][z2][0])+"\tmax height: "+str(pathmat[z1][z2][1])+"\n"
            z2+=1
        z1+=1    
    txt+="\n - - - e of - - - "      
    tchsearch.insert("end",txt)
            
    
## Tkinter Plot
hf = Tkinter.Tk()
hf.title(' GUI_Chain ')
aboutHDsimpl=raioop2.brgabout(hf,"tp1","about_chain.txt",7,\
            "Sept., 8th,2011"," about chain ", "white", "t1",80,5,ScrolledText)
helpHDsimpl=raioop2.brgabout(hf,"tp1","help_chain.txt",7,\
            "Sept. 8th,2011"," help_chain ", "white", "t1",80,5,ScrolledText)
    
fr=Tkinter.Frame(hf,width=60)
fr.pack()
fropen=Tkinter.Frame(fr,width=60, relief="sunken",bd=3)
fropen.pack()
buttopen1=Tkinter.Button(fropen,text="select file (Excel derived) ",width=25,bg="white",command=file_select)
buttopen1.pack(side="left")
buttopen2=Tkinter.Button(fropen,text="select PyHasse file (...pdt) ",width=25,bg="white",command=fileselect_PyHasse)
buttopen2.pack(side="left")
buttshow=Tkinter.Button(fr,text="show data matrix ",width=25, command=showDM)
buttshow.pack(pady=2)
fravec=Tkinter.Frame(fr,bd=3,relief="sunken")
fravec.pack()
lbavec=Tkinter.Label(fravec,text="sublist of attributes\n"\
                     "from which the profile is of interest\nPlease select at least two columns (0,1,2,..)")
lbavec.pack()
eavec=Tkinter.Entry(fravec,width=20)
eavec.pack()
buttprofile=Tkinter.Button(fravec,text="equivalencies w.r.t. profile ",bg="cyan",width=25,command=profilediagr)
buttprofile.pack()
frperturb=Tkinter.Frame(fr,bd=3,relief="sunken")
frperturb.pack(pady=3)
lbperturb=Tkinter.Label(frperturb,text="perturb the HD to avoid artificial\n overlapping of lines\n recommended 1,2 or 3")
lbperturb.pack()
eperturb=Tkinter.Entry(frperturb,width=3)
eperturb.pack()
buttHD = Tkinter.Button(fr, text='Hasse diagram',width=25,bg="cyan",command=HD)
buttHD.pack(pady=2)
lb1=Tkinter.Label(fr,text=" ",width=60)
lb1.pack()
lbopen=Tkinter.Label(fr,text=" ",width=60)
lbopen.pack()
lb2=Tkinter.Label(fr,text="upper entry field: start-object, lower entry field: end-object of a chain")
lb2.pack()
estart=Tkinter.Entry(fr,width=5)
eend=Tkinter.Entry(fr,width=5)
estart.pack()
eend.pack()
frwarn=Tkinter.Frame(fr,relief="sunken",bd=3)
frwarn.pack()
lbwarn=Tkinter.Label(frwarn,text="")
lbwarn.pack()

frmax=Tkinter.Frame(fr)
frmax.pack()#   grid-manager!
lbmax=Tkinter.Label(frmax,text="chains of height >=...")
lbmax.grid(row=0,column=0)
emaxch=Tkinter.Entry(frmax,width=3)
emaxch.grid(row=0,column=1)

buttpath=Tkinter.Button(fr,text="path ",width=25, bg="cyan",command=chain)
buttpath.pack()
frselch=Tkinter.Frame(fr,width=60)
frselch.pack()
lbselch=Tkinter.Label(frselch,text="select the chain (enter the chain no) >>>")
lbselch.pack(side="left")
eselch=Tkinter.Entry(frselch,width=3)
eselch.pack(side="left")
buttHDch=Tkinter.Button(frselch,text="HD with the chain",command=HDselch)
buttHDch.pack(side="left")

lbset1=Tkinter.Label(fr,text="search of chain's heights between two object subsets: ")
lbset1.pack()
lbset2=Tkinter.Label(fr,text="first row start points , second row : sink points ")
lbset2.pack()
eset1=Tkinter.Entry(fr,width=10)
eset1.pack()
eset2=Tkinter.Entry(fr,width=10)
eset2.pack()
buttsearch=Tkinter.Button(fr,text="height of paths between \ntwo sets of objects ",width=25,bg="cyan",command=chsearch)
buttsearch.pack()
buttexit = Tkinter.Button(fr, text = 'exit', bg = 'red', width=25,command = hf.destroy)
buttexit.pack(pady=10)

hf.mainloop()

