# -*- coding: cp1252 -*-
import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import tkFileDialog
import raioop2
import stats
import pstat
import random
import math


# Development: chain1.py : June 2010, starting from "HDsimpl1.py"
# chain3: 21.9.10 Control of height of chain, search fctn
# chain4: 26.6.2011. Characterization of start- and endpoint of a chain
# chain5: 22.7.2011 The management of maximal chain length is unsatisfactory. Hence a new version
# chain6.py: 7.9.2011 cosmetics
# chain7_1: 13.9.2012 chain-matrix
# chain8_1: Many changes. Mainly concerning the chainmatrix and layouts
# chain8_3: Many minor changes, 25.7.2013
# Integration of clusteranalysis. matplotlib, numpy, scipy needed, therefore
# ... not a general method for users
# brg 13.8.2013..... maximum-chain-HD
# brg 14.8.2013: bug eliminated in clusteranalysis
# brg 27.8.2013: clusteranalysis on the basis of distances
# brg 27.8.2013: frequency table in a better readable format
# brg 23.6. 2014: Automatic generation of maximum-chain-HD


def fileselect_PyHasse():
    """ File selection of transformed data matrices
    through other PyHasse programs """
    #* 1.6.09
    # akt. 11.7.10 (taken from mainHD19 and modified
    # source: mainHD19
    global fn,r,k,dm,pro0,prop, on,ob,obj,xred,rred,objred,txt,n
    fn=tkFileDialog.askopenfilename()
    r,k,dm,obj,prop=rmod2.raireadin5(fn)
    pro0=rmod2.vecgentext1(k)
    pro0[0]="prop"              #this 3 lines construction needed because attsel needs pro0
    for j in range(1,k):
        pro0[j]=prop[j-1]
    #print "in mainHD = : r= ",r,"  k= ",k0
    ob=rmod2.vecgentext1(r+1) #this 3 lines construction needed because filecomp needs ob
    ob[0]="dummy"
    for i in range(1,r+1):
        ob[i]=obj[i-1]
    
    lbopen.config(bg="yellow")
    lbopen["text"]="selected file (PyHasse format) : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns"
    rred,xred,objred,txt=rmod2.equivcompact(r,k,dm,obj)
    n=rred
    return 

def file_select():
    # Brg 3.9.10
    global fn,dm,obj,prop,rred,xred,objred,txtred,neq,k

    fn=tkFileDialog.askopenfilename()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    lb1.config(text="opened "+fn+"\n"+str(k)+" attributes",bg="yellow")
    

    prop=[]
    for j in range(0,k):
        prop.append(pro[j+1])
            
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
    for i in range(0,r):
        obj[i]=ob[i+1]

    global rred,objred
    rred,xred,objred,txtred,neq=rmod2.equivcompactm(r,k,dm,obj)  
    return



def showDM():
    """ New routine : shows the data matrix """
    #Brg 13.1.08 (from dds8)
    tp2=Tkinter.Toplevel(hf)
    tp2.title(' show DM ')
    lbtp2=Tkinter.Label(tp2,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+ob[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+pro[j+1]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=pro[j+1]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=ob[i+1]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)
    
def profile(xred,rred,avec):
    """Calculates a matrix where equivalent
    objectpairs with respect to the profile of
    attributes in avec get a 1 in the corresponding entry"""
    # brg 12.8.2011
    equivm=rmod2.marray(rred,rred)
    la=len(avec)
    for i1 in range(0,rred):
        hilf1=rmod2.vecgen1(la)
        j1zaehl=0
        for j1 in range(0,k):
            if j1 in avec:
                hilf1[j1zaehl]=xred[i1][j1]
                j1zaehl+=1
        rankx1 = pstat.rankdata(hilf1)
        #print "i1= ",i1,"    ranks ",rankx1
        for i2 in range(0,rred):
            hilf2=rmod2.vecgen1(la)
            j2zaehl=0
            for j2 in range(0,k):
                if j2 in avec:
                    hilf2[j2zaehl]=xred[i2][j2]
                    j2zaehl+=1
            #print "i2= ",i2,"   ranks ",ranksx2    
            if i1!=i2:
                rankx2=pstat.rankdata(hilf2)
                if rankx1==rankx2:
                    equivm[i1][i2]=1
    return equivm    
    


def HD():
    """based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"""
    # Brg 20.12.07, 28.12.07, 2.10.,3.10.09, 13.6.10
    # If the number of representants > 200 then only the cover-matrix and the level-population
    #
    global perturb
    try:
        avec=eavec.get().split(',')
        la=len(avec)
        for j in range(0,la):
            avec[j]=int(avec[j])
    except:
        avec=[]
        for j in range(0,k):
            avec.append(j)
    print "avec = ",avec        
    try:
        perturb=int(eperturb.get())
    except:
        perturb=0
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    
        #
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    global cov   #13.6.10
    cov=rmod2.cover(rred,tr,lext)

    # Determination of equivalent profiles (note this is only
    # meaningful, if the attributes are on a common scale!!!!!)
    equivmact=profile(xred,rred,avec)

    # Now the drawing
    if rred>300:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram  ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=(perturb*random.randint(1,5)+1)*geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        rmod2.matout(rred,rred,equivmact)
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        iob1=lobj[i1][j1]
                        iob2=lobj[i][j]
                        if cov[iob1][iob2]==1:
                            if equivmact[iob1][iob2]==1:
                                cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1], width=3,fill="red")
                            else:
                                cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()


def chain():
    #brg 13.6.10, 21.9.10, 22.7.2011, 23.5.2013
    #brg 25.7.2013: major changes: countpath is now a list (in former times a set)
    # This part in order to perform 'path' without the need of displaying the HD
    global chset2,countpath, chainm, emincx, indicch, maxch,npath,lcp,lpi
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    global cov,npath,countpath   #13.6.10
    cov=rmod2.cover(rred,tr,lext)   

    # the following lines are the proper path part
    grc=rmod2.graphcovdict(cov,rred)
    start=objred.index(estart.get())
    sink=objred.index(eend.get())
    if zeta[start][sink]==1:
        lbwarn.config(text=estart.get()+" < "+eend.get(),bg="white")
    else:
        lbwarn.config(text="+++ start and sink are not in a <-relation +++",bg="yellow")
    
    maxch=zzmax
    
    print "maxch = ",maxch    
    npath=rmod2.find_all_paths(grc,start,sink)
    lp=len(npath)
    print "npath  ",npath
    for i in range(0,lp):
        print "  napth[",i,"]= ",npath[i]
    # here the core of chain 22.7.2011
    countpath=[]  #25.7.2013 set replaced by dynamic list
    for i in range(0,lp):
        if len(npath[i])>=maxch:
            countpath.append(i)
    print "countpath = ",countpath," length of countpath:  ",len(countpath)
    chset=set([])
    il=[]
    bartxt=[]
    avchlength0=0 #correct notation would be avchheight. Height is the number of elements in a chain
    txtch="  General information   "+"\n"
    
    for i in countpath:
        #print "length of npath ",i,"  :",len(npath[i]), "  maxch= ",maxch
        il.append(len(npath[i]))  #il contains the length of each path (including start- and endpoint.
                                        #being longer or equal maxch
        avchlength0+=len(npath[i])
        bartxt.append(" ")
    print "list of lengths > ",maxch,": = ",il
    lcp=len(countpath)        
    if lcp!=0:
        #print "flagch ",flagch
        txtch+="there are chains with elements >= "+str(maxch) +"\n"
        avchlength=1.0*avchlength0/(1.0*lcp)
    else:
        txtch+="\n"+"There is no chain equal or exceeding "+str(maxch)+"\n"
        avchlength=0
        
    lenbartxt=len(bartxt)
    tpchain1=Tkinter.Toplevel(hf)
    tpchain1.title("chain: main part")
    txt="--- chain - analysis ---"
    txt+="\n"
    txt+="selected start-point "+estart.get()+"\n"
    txt+="selected end-point   "+eend.get()+"\n"
    txt+="selected min-height  "+str(maxch)+"\n"
    txt+="result: "
    txt+="\n"+50*"="+"\n"
    txt+=txtch+"\n"
    txt+="\n"+"Number of chains of height>= "+str(maxch)+": "+str(lcp)+"\n"
    txt+="The individual chains"+"\n"
    txthilf=" "
    chset2=rmod2.vecgen1(lcp)  #13.9.2012, 25.7.2013
    indicch=rmod2.vecgen1(lcp)
    zahl=0                        # 25.7.2013
    for i in countpath:   # 23.5.2013,25.7.2013 by definition countpath has only those paths whose length>maxch
        #print "loop countpath: ",i," npath[",i,"]= ",npath[i]
        chset2[zahl]=set([])    #13.9.2012
        indicch[zahl]=i         # 25.7.2013 assignment: zahl and real number of the chain (with >=maxch)
        lpi=len(npath[i])
        txthilf+="\n"+"chain no: "+str(zahl)+"  count of elements: "+str(lpi)+":\t"  #8.9.2011
        for j in range(0,lpi):
            txthilf+=objred[npath[i][j]]+", "
            chset2[zahl].add(objred[npath[i][j]])  #chset2[i]
                                                    #contains all elements between the two end points
        txthilf+="original chainnr: "+str(i)                                             
        zahl+=1                                     
                                                    
        txthilf+="\n"
    txt+=txthilf
    txt+="- - - e o f  - - - "
    tchain=ScrolledText(tpchain1,height=10,width=80)
    tchain.pack()
    tchain.insert("end",txt)

def all_max_chains():
    #brg 13.6.10, 21.9.10, 22.7.2011, 23.5.2013
    #brg 25.7.2013: major changes: countpath is now a list (in former times a set)
    # This part in order to perform 'path' without the need of displaying the HD
    # 23.6.2014
    global chset2,countpath, chainm, emincx, indicch, maxch,npath,lcp,lpi, dmmaxchain2, rredmc2, objredmc2
    selectoutput=0
    selectoutput=eseloutput.get()
    
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    
    zeta=rmod2.marray(rred,rred)
    for i1 in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for i2 in range(0,rred):
            zeta[i1][i2]=zetahilf[i2][i1]
    #
    zetamod=rmod2.marray(rred,rred)
    for i1 in range(0,rred):
        for i2 in range(0,rred):
            if i1!=i2:
                zetamod[i1][i2]=zeta[i1][i2]
    maximal=[]
    for i1 in range(0,rred):
        zetasum=0
        for i2 in range(0,rred):
            zetasum+=zetamod[i1][i2]
        if zetasum==0:
            maximal.append(objred[i1])
    minimal=[]
    for i2 in range(0,rred):
        zetasum=0
        for i1 in range(0,rred):
            zetasum+=zetamod[i1][i2]
        if zetasum==0:
            minimal.append(objred[i2])
    print "maximal: ",maximal
    print "minimal ",minimal
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
    maxch=zzmax
    print "maxch = ",maxch
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    global cov,npath,countpath   #13.6.10
    cov=rmod2.cover(rred,tr,lext)   

    # the following lines are the proper path part
    grc=rmod2.graphcovdict(cov,rred)
    maxchainset=set([])
    for start in minimal:
        for sink in maximal:
            #print "start= ",start,"   sink = ",sink
            istart=objred.index(start)
            isink=objred.index(sink)
            npath=rmod2.find_all_paths(grc,istart,isink)
            lp=len(npath)
            #print "lp= ",lp
            #for i in range(0,lp):
                #print "  napth[",i,"]= ",npath[i]
    
            
            for i1 in range(0,lp):
                if len(npath[i1])>=maxch:
                    for i2 in range(0,len(npath[i1])):
                        #print "max path= ",npath[i1][i2],
                        maxchainset.add(objred[npath[i1][i2]])
    print "maxchainset = ",maxchainset
    lalls2=len(maxchainset)
    vecallsites2=[]
    for ob in maxchainset:
        vecallsites2.append(ob)
    dmmaxchain2=rmod2.marray(lalls2,k)
    objredmc2=[]
    zahl=0
    for i in range(0,rred):
        if objred[i]in vecallsites2:
            objredmc2.append(objred[i])
            for j in range(0,k):
                dmmaxchain2[zahl][j]=xred[i][j]
            zahl+=1   


    rredmc2=zahl
    #print "rredmc2= ",rredmc2
    #print "dmmaxchain2 "
    rmod2.matout(rredmc2,k,dmmaxchain2)

    # now the HD
    hfhdmc2=Tkinter.Toplevel(hf)
    hfhdmc2.title('Hasse diagram / cover matrix of maxchain')
    freqmc=Tkinter.Frame(hfhdmc2,width=200,height=300)
    freqmc.pack()
    # sum of the remaining objects indicator profiles
    richness=[]
    for ob in objredmc2:
        iob=objredmc2.index(ob)
        sumhilf=0
        for j in range(0,k):
            sumhilf+=dmmaxchain2[iob][j]
        richness.append(sumhilf)
    
    
        #
    zetahilfmc2=rmod2.comp(rredmc2,k,dmmaxchain2)  #zeta matrix with col<row
    zetamc2=rmod2.marray(rredmc2,rredmc2)
    for i in range(0,rredmc2):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rredmc2):
            zetamc2[i][j]=zetahilfmc2[j][i]
    #print "zetamc= "
    #rmod2.matout(rredmc,rredmc,zetamc)
    #
    #One linear extension (based on levels)
    
    lobjmc,lextmc,revlextmc,zzmaxmc=rmod2.levtopsort(rredmc2,zetamc2)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmaxmc):
        if len(lobjmc[i])>=levmax:
            levmax=len(lobjmc[i])

    print "rredmc= ",rredmc2
    print "lextmc= ",lextmc
    print "revlextmc= ",revlextmc
    #Adj-Listen

    adjcmc=rmod2.adjacent(rredmc2,lextmc,revlextmc,zetamc2)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rredmc2,adjcmc,lextmc)
       
    global covmc2   #13.6.10
    covmc2=rmod2.cover(rredmc2,tr,lextmc)

    
    
    # Now the drawing
    if rredmc2>400:
        lbhdmc2=Tkinter.Label(freqmc,text=" +++too many objects ++++  ",bg="yellow")
        lbhdmc2.pack()                  
    else:
        lbhdmc2=Tkinter.Label(freqmc,text=" Hasse Diagram maximum chains ")
        lbhdmc2.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rredmc2,levmax,zzmaxmc)
        cvmc2=Tkinter.Canvas(freqmc,width=actwidth,height=actheight,bg="white")
        
        lz=zzmaxmc
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobjmc[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rredmc2,rredmc2)
        geomy=rmod2.marray(rredmc2,rredmc2)

        perturb=0       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=(perturb*random.randint(1,5)+1)*geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        iob1=lobjmc[i1][j1]
                        iob2=lobjmc[i][j]
                        if covmc2[iob1][iob2]==1:
                            cvmc2.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])
                            


        for i in range(0,lz):
            for j in range(0,l[i]):
                if selectoutput=="1":
                    cvmc2.create_oval(geomx[i][j]-15,geomy[i][j]+15,geomx[i][j]+15,geomy[i][j]-15,fill="white")
                    cvmc2.create_text(geomx[i][j],geomy[i][j],text=objredmc2[lobjmc[i][j]]+":\n"+str(richness[lobjmc[i][j]]))
                else:
                    cvmc2.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                    cvmc2.create_text(geomx[i][j],geomy[i][j],text=objredmc2[lobjmc[i][j]])
        
        cvmc2.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cvmc2.create_text(garrow1x+8,garrow1y-6,text="high")
        cvmc2.create_text(garrow1x+8,garrow2y-6,text="low")
        cvmc2.pack()    
        
    
    
            
def Frequency():
    # brg 12.8.2013
    # towards clusteranalysis
    global maxch, chaintotal,lalls,vecallsites,lpi,lcp
    # maxch=number of levels = number of elements within each maximum chain
    # lalls: number of elements in the union of all maximum chains
    # lpi = maxch
    # lcp : number of maximum chains
    #basic information
    tpchain3=Tkinter.Toplevel(hf)
    tpchain3.title("chain: main part")
    txt="--- chain - analysis ---"
    txt+="\n"
    txt+="selected start-point "+estart.get()+"\n"
    txt+="selected end-point   "+eend.get()+"\n"
    txt+="selected min-height  "+str(maxch)+"\n"
    txt+="result: "
    txt+="\n"+50*"="+"\n"
   
    txt+="\n"+"Number of chains of height>= "+str(maxch)+": "+str(lcp)+"\n"
    
    allsites=set([])
    chset2=rmod2.vecgen1(lcp)  #13.9.2012, 25.7.2013
    indicch=rmod2.vecgen1(lcp)
    zahl=0                        # 25.7.2013
    for i in countpath:   # 23.5.2013,25.7.2013 by definition countpath has only those paths whose length>maxch
        #print "loop countpath: ",i," npath[",i,"]= ",npath[i]
        chset2[zahl]=set([])    #13.9.2012
        indicch[zahl]=i         # 25.7.2013 assignment: zahl and real number of the chain (with >=maxch)
        lpi=len(npath[i])
        
        for j in range(0,lpi):
            chset2[zahl].add(objred[npath[i][j]])  #chset2[i]
        allsites=allsites|chset2[zahl]
        zahl+=1
    print "allsites ",allsites
    lalls=len(allsites)
    print "no of sites ",lalls

    vecallsites=rmod2.vecgen1(lalls)
    zahl=0
    for ob in allsites:
        vecallsites[zahl]=ob
        zahl+=1

    print "vectorial: all sites ", vecallsites
    chaintotal=rmod2.marray(lcp,lalls)
    for i in range(0,lcp):
        zahl=0
        for ob in vecallsites:
            if ob in chset2[i]:
                chaintotal[i][zahl]=1
            else:
                chaintotal[i][zahl]=0
            zahl+=1    
        

    for j in range(0,lalls):
        print vecallsites[j],
    print " "    
    for i in range(0,lcp):
        print "i= ",i," ",
        for j in range(0,lalls):
            print chaintotal[i][j],
        print " "
    
    txt="Frequency of objects in maximum chains "+"\n"
    txt+=60*"="+"\n"
    txt+="sites"+"\n"
    sumobj=rmod2.vecgen1(lalls)
    txt+="\t"
    for j in range(0,lalls):
        txt+=str(vecallsites[j])+"\t"
    txt+="\n"
    txt+=60*"-"+"\n"
    txt+="frequency"+"\n"
    txt+="\t"
    for j in range(0,lalls):
        for i in range(0,lcp):
            sumobj[j]+=chaintotal[i][j]
        txt+=str(sumobj[j])+"\t"
    txt+="\n"    
    if lalls > 50:
        txtn=""
        txtn+="Object\tFrequency"+"\n"
        for j in range(0,lalls):
            txtn+=str(vecallsites[j])+"\t"+str(sumobj[j])+"\n"
        txtn+="\n"
        txtn+="- -  - e  o  f - - -"
        tplallslarge=Tkinter.Toplevel(hf)
        tplallslarge.title(' objects and frequency -table ')
        tallslarge=ScrolledText(tplallslarge,width=60,height=20)
        tallslarge.pack()
        tallslarge.insert("end",txtn)
        
        
        
    
    tchain3=ScrolledText(tpchain3,width=60,height=5)
    tchain3.pack()
    tchain3.insert("end", txt)
    app1=raioop2.brgbar10(tpchain3,sumobj,vecallsites,"Frequency",5,"red")
    app1.ausgabe()
    
def maxchHD():
    # brg 13.8.2013
    global lalls
    # lalls is the number of objects taken the union of maximum chains
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    prop=[]
    for j in range(0,k):
        prop.append(pro[j+1])
            
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
    for i in range(0,r):
        obj[i]=ob[i+1]

    
    rred,xred,objred,txtred,neq=rmod2.equivcompactm(r,k,dm,obj)
    # preparing the new data matrix corresponding to
    # all objects which are members of the maximum chains
    dmmaxchain=rmod2.marray(lalls,k)
    objredmc=[]
    zahl=0
    for i in range(0,rred):
        if objred[i]in vecallsites:
            objredmc.append(objred[i])
            for j in range(0,k):
                dmmaxchain[zahl][j]=xred[i][j]
            zahl+=1   


    rredmc=zahl
    print "rredmc= ",rredmc
    print "dmmaxchain "
    rmod2.matout(rredmc,k,dmmaxchain)

    # now the HD
    hfhdmc=Tkinter.Toplevel(hf)
    hfhdmc.title('Hasse diagram / cover matrix of maxchain')
    freqmc=Tkinter.Frame(hfhdmc,width=200,height=300)
    freqmc.pack()
    
    
        #
    zetahilfmc=rmod2.comp(rredmc,k,dmmaxchain)  #zeta matrix with col<row
    zetamc=rmod2.marray(rredmc,rredmc)
    for i in range(0,rredmc):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rredmc):
            zetamc[i][j]=zetahilfmc[j][i]
    #print "zetamc= "
    #rmod2.matout(rredmc,rredmc,zetamc)
    #
    #One linear extension (based on levels)
    
    lobjmc,lextmc,revlextmc,zzmaxmc=rmod2.levtopsort(rredmc,zetamc)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmaxmc):
        if len(lobjmc[i])>=levmax:
            levmax=len(lobjmc[i])

    print "rredmc= ",rredmc
    print "lextmc= ",lextmc
    print "revlextmc= ",revlextmc
    #Adj-Listen

    adjcmc=rmod2.adjacent(rredmc,lextmc,revlextmc,zetamc)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rredmc,adjcmc,lextmc)
       
    global covmc   #13.6.10
    covmc=rmod2.cover(rredmc,tr,lextmc)

    
    
    # Now the drawing
    if rredmc>300:
        lbhdmc=Tkinter.Label(freqmc,text=" +++too many objects ++++  ",bg="yellow")
        lbhdmc.pack()                  
    else:
        lbhdmc=Tkinter.Label(freqmc,text=" Hasse Diagram maximum chains ")
        lbhdmc.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rredmc,levmax,zzmaxmc)
        cvmc=Tkinter.Canvas(freqmc,width=actwidth,height=actheight,bg="white")
        
        lz=zzmaxmc
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobjmc[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rredmc,rredmc)
        geomy=rmod2.marray(rredmc,rredmc)

        perturb=1       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=(perturb*random.randint(1,5)+1)*geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        iob1=lobjmc[i1][j1]
                        iob2=lobjmc[i][j]
                        if covmc[iob1][iob2]==1:
                            cvmc.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])
                            


        for i in range(0,lz):
            for j in range(0,l[i]):
                cvmc.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cvmc.create_text(geomx[i][j],geomy[i][j],text=objredmc[lobjmc[i][j]])
        
        cvmc.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cvmc.create_text(garrow1x+8,garrow1y-6,text="high")
        cvmc.create_text(garrow1x+8,garrow2y-6,text="low")
        cvmc.pack()
                                     
            
        
    



def cluster():
    # brg 12.8.2013, 27.8.2013
    import scipy
    import scipy.cluster.hierarchy 
    import scipy.spatial.distance 
    from scipy.cluster.hierarchy import dendrogram
    import matplotlib.pyplot as plt

    global lalls,lpi
    # brg 12.8.2013
    print "lpi= ",lpi
    print "lalls= ",lalls
##    print "chaintotal "
##    rmod2.matout(lpi,lalls,chaintotal)
##    print " "
    mat = scipy.array(chaintotal)
    dmat=scipy.cluster.hierarchy.distance.pdist(mat)
    lab_act=[]
    for j in range(0,lcp):
        lab_act.append(str(j))  # 14.8.2013 chains get the identifier

    aggreg_type=emethod.get()
    linkage_matrix=scipy.cluster.hierarchy.linkage(dmat,method=aggreg_type)  #27.8.2013
    
    #clresult=scipy.cluster.hierarchy.fclusterdata(mat,1.0)
    #print clresult

    plt.title("chainclustering;method="+str(aggreg_type))
    #print linkage(1-dist_mat, "single")
    dendrogram(linkage_matrix,
           color_threshold=0,
           labels=lab_act,
           show_leaf_counts=True)


    plt.show()

def sf():
    #brg  31.5.09, 1.6.09, 1.7.2014 taken from discretiz3.py
    fn=tkFileDialog.asksaveasfilename(parent=hf,title="save file")
    # brg  30.5.09
    for i in range(0,rredmc2):
        print obj[i]," ",
    print " "    
    rmod2.raiwrite5(fn,dmmaxchain2,objredmc2,prop,rredmc2,k)
    lbsuccess.config(text="matrix with \n"+str(rredmc2)+"  rows  and "+str(k)+"\n  columns stored",bg="yellow")



    
## Tkinter Plot
hf = Tkinter.Tk()
hf.title(' GUI_Chain ')
aboutHDsimpl=raioop2.brgabout(hf,"tp1","about_chainexpert.txt",3,\
            "June, 23rd,2014"," about chainexpert ", "white", "t1",80,5,ScrolledText)
helpHDsimpl=raioop2.brgabout(hf,"tp1","help_chainexpert.txt",3,\
            "June 23rd,2014"," help_chainexpert ", "white", "t1",80,5,ScrolledText)
    
fr=Tkinter.Frame(hf,width=60)
fr.pack()
fropen=Tkinter.Frame(fr,width=60, relief="sunken",bd=3)
fropen.pack()
buttopen1=Tkinter.Button(fropen,text="select file (Excel derived) ",width=25,bg="white",command=file_select)
buttopen1.pack(side="left")
buttopen2=Tkinter.Button(fropen,text="select PyHasse file (...pdt) ",width=25,bg="white",command=fileselect_PyHasse)
buttopen2.pack(side="left")
lb1=Tkinter.Label(fr,text=" ",width=60)
lb1.pack()
lbopen=Tkinter.Label(fr,text=" ",width=60)
lbopen.pack()
buttshow=Tkinter.Button(fr,text="show data matrix ",width=25, command=showDM)
buttshow.pack(pady=2)
frperturb=Tkinter.Frame(fr,bd=3,relief="sunken")
frperturb.pack(pady=3)
lbperturb=Tkinter.Label(frperturb,text="perturb the HD to avoid artificial\n overlapping of lines\n recommended 1,2 or 3")
lbperturb.pack()
eperturb=Tkinter.Entry(frperturb,width=3)
eperturb.pack()
buttHD = Tkinter.Button(fr, text='Hasse diagram',width=25,bg="cyan",command=HD)
buttHD.pack()
lbeseloutput=Tkinter.Label(fr,text="1 for output of HD with object label  a n d  richness, 0 else")
lbeseloutput.pack()
eseloutput=Tkinter.Entry(fr,width=2)
eseloutput.pack()
buttallmaxchains=Tkinter.Button(fr,text="HD of all maximum chains ",width=25,bg="cyan",command=all_max_chains)
buttallmaxchains.pack()
buttsave=Tkinter.Button(fr,text="Save data matrix of\n maximum chain-HD ",width=25,bg="cyan",command=sf)
buttsave.pack()
lbsuccess=Tkinter.Label(fr,text="")
lbsuccess.pack()
lb2=Tkinter.Label(fr,text="upper entry field: start-object in the lowest level, lower entry field: sink-object in the top-level")
lb2.pack(pady=10)
estart=Tkinter.Entry(fr,width=5)
eend=Tkinter.Entry(fr,width=5)
estart.pack()
eend.pack()
frwarn=Tkinter.Frame(fr,relief="sunken",bd=3)
frwarn.pack()
lbwarn=Tkinter.Label(frwarn,text="")
lbwarn.pack()

buttpath=Tkinter.Button(fr,text="path ",width=25, bg="cyan",command=chain)
buttpath.pack()

frexpert=Tkinter.Frame(fr, relief="sunken",bd=3)
frexpert.pack()
buttfreq=Tkinter.Button(frexpert,text="Freq. of objects in max. chains ",width=25,bg="cyan",command=Frequency)
buttfreq.pack()
buttmaxchHD=Tkinter.Button(frexpert,text="HD of objects in maximum chains \n corresp. to start and sink objects",width=25,bg="cyan",command=maxchHD)
buttmaxchHD.pack()
labcluster=Tkinter.Label(frexpert,text="Specify the aggregation method:\nsingle\naverage\ncomplete")
labcluster.pack()
emethod=Tkinter.Entry(frexpert,width=10)
emethod.pack()
labwarn=Tkinter.Label(frexpert,text="+++ Note: clustering needs scipy,numpy, matplotlib ++",bg="yellow")
labwarn.pack()
buttclust=Tkinter.Button(frexpert,text="clusteranalysis chains",bg="cyan",width=25,command=cluster)
buttclust.pack()
buttexit = Tkinter.Button(fr, text = 'exit', bg = 'red', width=25,command = hf.destroy)
buttexit.pack(pady=10)

hf.mainloop()

