# -*- coding: cp1252 -*-
import Tkinter
import rmod2
from ScrolledText import *
import tkMessageBox
import Canvas
import os
import random
import tkFileDialog
import raioop2

# Brg derived from mainHD20_5
# 26.8.2013



def fileselect():
    """ File selection and opening by Tkinter-Standards"""
    #*13.1.08
    #akt: 13.1.08, 26.8.2013
    #note: There may be conflicts with other moduls
    #source:mainHD20_5.py
    
    global fn,r,k,dm,prop,obj
    fn=tkFileDialog.askopenfilename()
    
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)

    obj=[]
    for i in range(0,r):
        obj.append(ob[i+1])

    prop=[]
    for j in range(0,k):
        prop.append(pro[j+1])

        
def showDM():
    """ New routine : shows the data matrix """
    #Brg 13.1.08
    tp2=Tkinter.Toplevel(hf)
    tp2.title('showDM')
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack(expand=1,fill="both")
    
    
    
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)

    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+ob[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=ob[i+1]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)

def extract(r,zetah,i,obj0):
    """extracts from the crisp matrix the order relations"""
    # brg 30.11.07, 11.4.08, 16.8.08 taken from fuzzyHD10, 4.10.08
    # brg 4.3.09 taken from sensi10 and adapted for use in mainHD10
    # the matrix order corresponds to objec
    
    # order is the matrix rs*rs which results after extract
    # rs is the number of rows/ columns of the square matrix order
    ec=rmod2.dmcompress(r,r,zetah)             #30.11. from cq the equivalent relations
    eqtext=""
    eqtext+=rmod2.eqcguiout1(r,ec,obj0)        #30.11. matrix output
    #print "r  = ",r
    txt=rmod2.irc_elim(r,ec)    #7.5.08 identifycolrows replaced by icr_elim
                                #in txt are the rows (and columns)
                                #...which can be eliminated
    
    ltxt=len(txt)
    b=rmod2.recogempty(txt,ltxt)
    # Not only the matrix cq is to be contracted but also the object vector obj
    # txt is a code of row numbers and as such ok for the matrixeliminations
    # however, to perform a new object list, txt must
    # be transformed in the corresponding object names
            
    an1,ldel1=rmod2.matrixcoldel(txt,r,r,zetah) # columns eliminated
    zeta,ldel2=rmod2.matrixrowdel(txt,r,r-ldel1,an1)
    rs=r-ldel1
    
    if b=="true":
        #there is nothing to be reduced hence
        objec=rmod2.vecgentext1(r)
        for i in range(0,r):
            objec[i]=obj0[i]
    else:        
        conobj=rmod2.vecgentext1(ltxt)
        for i in range(0,ltxt):
            conobj[i]=obj0[int(txt[i])]
        #print "conobj = ",conobj    
        objec=rmod2.vecgentext1(rs)
        zaehl=0
        for i in range(0,r):
            #print "obj i  ",obj[i],"  in conobj  ",conobj
            if obj0[i]not in conobj:
                objec[zaehl]=obj0[i]
                zaehl+=1
        #print "ex4: Reduz. Liste der Objekte (objec in modul extract) ",objec
        #print "ex5: rs = ",rs
    return zeta,objec,rs



        
def posets():
    """based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"""
    # Brg 20.12.07, 5.3.09, 26.8.2013
    # If the number of representants > 20 then only the cover-matrix and the level-population
    # note : all variables which may depend on dual, have as last literal a d
    

        
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)

    obj=[]
    for i in range(0,r):
        obj.append(ob[i+1])

    prop=[]
    for j in range(0,k):
        prop.append(pro[j+1])


    #dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,dm,obj)  
    
    #
    hilfzeta=rmod2.comp(rred,k,xred)
    zeta=rmod2.marray(rred,rred)
    for i1 in range(0,rred):
        for i2 in range(0,rred):
            zeta[i1][i2]=hilfzeta[i2][i1]
        
    #
    #One linear extension (based on levels)
   

    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
    #print "zzmax = ",zzmax
    tp3=Tkinter.Toplevel(hf)    #21.6.08
    tp3.title(' One arbitrary lin. ext. and the Levels ')
    
    tlev=ScrolledText(tp3,width=60,height=4)
    tlev.pack(expand=1,fill="both")
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
    txt1="\n"
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= objred[lobj[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)

    txt2="\n One linear extension based on level-construction \n\n"
    for i in range(0,rred):
        if i<rred-1:
            txt2+=objred[lext[i]]+" > "
        else:
            txt2+=objred[lext[i]]+"\n"
    txt2+="\n"
    txt2+="\n -- end of list -- "
    tlinext=ScrolledText(tp3,width=60, height=2)  #21.6.08
    tlinext.pack()
    tlinext.insert("end",txt2)
    
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    cov=rmod2.cover(rred,tr,lext)
    cover_show(cov,rred,objred)
    covered_show(cov,rred,objred)
    

    

def cover_show(cov,rred,objred):
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07, 26.8.2013
    #note: -
    #source: -
    hfcover=Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    
    lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,rred):
        txt3+="\n"+objred[i]+":\t"
        txt3+="is covered by "
        for j in range(0,rred):
            if i!=j:
                if cov[i][j]==1:
                    txt3+=" "+objred[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=20)
    tcov.pack(expand=1,fill="both")
    tcov.insert("end",txt3)

def covered_show(cov,rred,objred):
    """Cover-matrix is displayed"""
    #brg 21.6.08
    #*28.12.07
    #akt21.06.08
    #note: from cover_show
    #source: -
    hfcovered=Tkinter.Toplevel(hf)
    hfcovered.title(' covered-matrix ')
    
    lbhd2=Tkinter.Label(hfcovered,text=" Covered-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,rred):
        txt3+="\n"+objred[i]+":\t"
        txt3+="is covering "
        for j in range(0,rred):
            if i!=j:
                if cov[j][i]==1:
                    txt3+=" "+objred[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcovered,width=50, height=20)
    tcov.pack(expand=1,fill="both")
    tcov.insert("end",txt3)        

def components():
    """the components of the HD will be calculated a dfs """
    #Brg 2.3.09
    global zeta,zeta2,rred,n,objred,fn,noC    

    # basic info    
       
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)

    obj=[]
    for i in range(0,r):
        obj.append(ob[i+1])

    prop=[]
    for j in range(0,k):
        prop.append(pro[j+1])

    
    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,dm,obj)  
    

    # zeta matices
    zetahilf=rmod2.comp(rred,k,xred) #zetahilf comes out as col<row.
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):      #we need the transposed matrix (row < col)
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]


    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
    
   
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    covC=rmod2.cover(rred,tr,lext)  #cov: row < ccol (standard presentation)

    # connectedness referred to the undirected graph
    undircov=rmod2.marray(rred,rred)
    for i in range(0,rred):
        for j in range(0,rred):
            undircov[i][j]=covC[i][j]+covC[j][i]

    # connectedComponents is based on a routine taken from Internet
    adjlist=rmod2.covadjlist(undircov,rred)
    ac=rmod2.connectedComponents(adjlist)
    eqclassC,noC,CC,lbC=rmod2.countCC1(ac)
    lbc1=rmod2.vecgentext1(noC)
    for i in range(0,noC):
        lbc1[i]=objred[eqclassC[i]]
        
    txtc=" Analysis of components \n"
    txtc+=40*"="
    txtc+="\n Number of components: = "+str(noC)+"\n"
    txtchilf="Components' representants and number of equiv. elements \n"
    for i in range(0,noC):
        txtchilf+=objred[eqclassC[i]]+" with: "+str(CC[i])+"  elements \n"
    txtc+=txtchilf
    txtc+=40*"="
    txtc+="\n - - - end of file - - -"

    tpcomp=Tkinter.Toplevel(hf)
    tpcomp.title(' components ')
    tcomp=ScrolledText(tpcomp,width=60,height=20)
    tcomp.pack(expand=1,fill="both")
    tcomp.insert("end",txtc)
    xnoc=rmod2.vecgentext1(noC)
    if noC>1:
        for i1 in range(0,noC):
            xnoc[i1]=str(i1)
        bdnoc=raioop2.brgbar3(hf,"tpbnoC",noC,CC,xnoc,50,'Components', 30,30,40)
        bdnoc.ausgabe()
        

def calc():
    """series of HD/LPOM calculations"""
    #brg 7.11.07, 12.12.07, 21.3.08, 17.6.08, 19.6.08, 21.6.08, 15.3.09, 11.11.09, 12.8.12
    # 
    # Complete rearrangement 15.3.09 Calc is separated from rendering the results
    # calc must be runned before all other results are obtainable
    global quobx
    
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)

    obj=[]
    for i in range(0,r):
        obj.append(ob[i+1])

    prop=[]
    for j in range(0,k):
        prop.append(pro[j+1])

    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,dm,obj)  
    
    l1=len(obj)
    l2=len(objred)
    hfeq=Tkinter.Toplevel(hf)
    hfeq.title(' equivalent elements ')
    lbeq1=Tkinter.Label(hfeq,text="Structure: quotient set") #21.6.08 many changes
    lbeq1.pack()
    labeq=Tkinter.Label(hfeq,text="")
    labeq.pack()
    txteq=ScrolledText(hfeq,width=60,height=10)
    txteq.pack(expand=1,fill="both")
    txtq=""
    if l1!=l2:
        labeq.config(text="quotient set is unequal the object set ")
        
        txtq=txt+"\n"
        txtq+="\n\n distribution of equivalent elements \n"
        for i in range(0,r):
            if neq[i]>1:
                txtq+=str(neq[i])+"\n"
        
       
    else:
        labeq.config(text="quotient set = object set ",bg="yellow")
        txtq+="\nThe equivalence elements are singletons "
        txtq+="\n see the data matrix for the objects "


    txteq.insert("end",txtq)    

    # 21.6.08 end of the changed part

    #         definitions of vectors
    p=[]      #successors of any obj
    u=[]      #incomparable elem. of any obj
    succ=[]   #predecessors of any obj, nmen leider vertauscht. 
    pr=[]     # number of  chains
    rkav=[]   #rkav after LPOM(0)model
    minx=[]
    maxx=[]
    isox=[]
    zmaxminiso=[]

    for i in range(0,rred):
        succ.append(0)
        u.append(0)
        p.append(0)
        rkav.append(0)
        pr.append(0)
        minx.append(-1)
        maxx.append(-1)
        isox.append(-1)
        zmaxminiso.append(0)

    # definiton of matrices
    
    objx=rmod2.marray(rred,rred)   
    redobjx=rmod2.marray(rred,rred)
    quobx=rmod2.marray(rred,rred)
    prod=rmod2.marray(rred,rred)
    prod1=rmod2.marray(rred,rred)
    unit=rmod2.matunit(rred)


    # heart of the program begin
    
    
    objx=rmod2.comp(rred,k,xred)
    rmod2.matadd(rred,1.0,objx,-1.0,unit,redobjx)
    level,pr=rmod2.chainlevel(rred,redobjx)
    rmod2.qualcomp(rred,objx,quobx)
    inco=rmod2.marray(rred,rred)    
    maxx,minx,isox=rmod2.maxminiso1(rred,quobx)
    inco=rmod2.rai_inc(rred,quobx)
    #incomsum
    incompsum=rmod2.vecgen1(rred)
    z=0
    for i in range(0,rred):
        for j in range(0,rred):
            if inco[i][j]!=-1:
                z+=1
                incompsum[i]+=1
        
    utotal=round(float(1.0*z/2.0),2)
    ntotal= 1.0*r*(r-1.0)/2.0
    # zmaxel
    zmaxel=0
    for i in range(0,rred):
        if maxx[i]!=-1:
            zmaxel+=1

    # zminel
    zminel=0
    for i in range(0,rred):
        if minx[i]!=-1:
            zminel+=1    
            
    # zisoel   
    zisoel=0
    for i in range(0,rred):
        if isox[i]!=-1:
            zisoel+=1

    # equivalences        
    eqtotal=0
    for i in range(0,r):
        eqtotal+=(neq[i]*(neq[i]-1))/2.0     #20.6.08
        
    if rred==0 or rred==1:   #29.3.09
        pib=0
        msgwarning()
    else:    
        pib=round(2.0*utotal/(rred*(rred-1)),2)
          
    totobj=len(objred)   #26.5.08
    comparabilities= (totobj*(totobj-1)/2.0)-utotal
    
    levelpop=rmod2.marray(level,rred)
    levelpop=rmod2.railevel(rred,level,objx)


    
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
    #print "zzmax = ",zzmax
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
        
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext) # basic quantity cover-matrix row < cov col
    leveldummy,prcov=rmod2.chainlevel(rred,cov)
    
    
    hfresults2=Tkinter.Toplevel(hf)
    tpriority=ScrolledText(hfresults2,width=50,height=10)
    tpriority.pack(expand=1,fill="both")
    txt="priority elements of a poset"+"\n"
    txt+=60*"="+"\n"
    txt+="Maximal elements "+"\n"
    for i in range(0,rred):
        if maxx[i]!=-1:
            txt+=str(objred[maxx[i]])+" "                 #29.11.07

    #print "number of maximal elements: ",z
    txt+="\n count of max elements: "+str(zmaxel)+"\n"
   
    ####################################6.11.07##################
    
    txt+="\nMinimal elements "+"\n"
    for i in range(0,rred):
        if minx[i]!=-1:
            txt+=str(objred[minx[i]])+" "                   #29.11.07
    txt+="\n count of min elements: "+str(zminel)+"\n"
  
    txt+="\nIsolated elements "+"\n"
    for i in range(0,rred):
        if isox[i]!=-1:
            txt+=str(objred[isox[i]])+" "
    txt+="\n count of isolated elements: "+str(zisoel)+"\n"
    
    txt+="\n"
    txt+="Incomparable elements "+"\n"

    
    
    for i in range(0,rred):
        txt+="object "+str(objred[i])+":(  "+str(incompsum[i])+") ||: "               #29.11.07
        for j in range(0,rred):
            if inco[i][j]!=-1:
                txt+=str(objred[inco[i][j]])+" "         #29.11.07
                
        txt+="\n"
    txt+="\n"
    txt+=" - - - e o f - - - "
    tpriority.insert("end",txt)
    
    Tpabov=Tkinter.Toplevel(hf)
    Tpabov.title("Relational information")
    
    tstat=ScrolledText(Tpabov,width=50,height=4)
    tstat.pack(expand=1,fill="both")
    txtstat="Quotient set and some characteristics \n"
    txtstat+="\n number of incomparabilities\t"+str(utotal)
    txtstat+="\n number of comparabilties  \t"+str(comparabilities)
    txtstat+="\n number of representants   \t"+str(totobj)
    txtstat+="\n stability (CAM-function):  \t"+str(pib)
    txtstat+="\n - - - end of file - - - "
    
    
    
    txtstat+="Level info1\n"
    for iz in range(0,level):
        txtstat+="Level "+str(level-iz)+": "
        for j in range(0,rred):
            if levelpop[iz][j]!=-1:
                txtstat+=str(objred[levelpop[iz][j]])+" "          #29.11.07
        txtstat+="\n"        
    txtstat+="\n"
    tstat.insert("end",txtstat)
    
                     

def LPOM():
    """Local partial order model """
    #brg 17.6.08
    tplpom1=Tkinter.Toplevel(hf)
    tplpom1.title(" LPOM calculation's results 1")
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)

    obj=[]
    for i in range(0,r):
        obj.append(ob[i+1])

    prop=[]
    for j in range(0,k):
        prop.append(pro[j+1])

    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,dm,obj)  
    
    succ,p,u,eq=rmod2.sucpredinc(rred,quobx)
    lbavrk1=Tkinter.Label(tplpom1,text="Results of LPOM-calculation ")
    lbavrk1.pack()

    tstruct=ScrolledText(tplpom1,width=60,height=5)
    tstruct.pack(expand=1,fill="both")
    
    
    

    
    txt1="results of LPOM1: structuralinformation \n"
    txt1+="\nobject\tsucc\tpredec\tincom\n"
    for i in range(0,rred):
        txt1+=str(objred[i])+":\t"+str(succ[i])+"\t"+str(p[i])+"\t"+str(u[i])+"\t "
        txt1+="\n"
    
    tstruct.insert("end",txt1)    

    rkav,pro,p,succ,u,eq=rmod2.lpom0(rred,quobx)


    trkav=ScrolledText(tplpom1,width=60,height=6)
    trkav.pack(expand=1,fill="both")
    txt2="results of LPOM2: averaged ranks and probabilities \n"
    txt2+="\n\t\tNo\tRkav\tpr<\tpr>\n"
    
    for i in range(0,rred):
        #test=round(pro[i][0]+pro[i][1],3)
        p1=round(pro[i][0],3)
        p2=round(pro[i][1],3)
        avr=round(rkav[i],3)
        txt2+="\t\t "+str(objred[i])+" :\t"
        txt2+=str(avr)+"\t"+str(p1)+"\t"+str(p2)+"\n"      
    txt2+="\n"
    trkav.insert("end",txt2)
    
    

def msgwarning():
    """ if P(IB) =0 then something is wrong. A message box warns"""
    tkMessageBox.showwarning("++No data matrix available ++"," you must select a file")


    
hf=Tkinter.Tk()
hf.title('--    characeristics of posets   -- ')

aboutmainHD=raioop2.brgabout(hf,"tp1","about_charposets.txt",1,\
            "August, 26th,2013"," about charposets ", "white", "t1",120,5,ScrolledText)
helpmainHD=raioop2.brgabout(hf,"tp1","help_charposets.txt",1,\
            "August, the 26th,2013"," help_charposets ", "white", "t1",120,5,ScrolledText)
    

buttfile1=Tkinter.Button(hf,text="(1a) Select and open EXCEL-file",bg="white",bd=4,width=25,command=fileselect)
buttfile1.pack()
lbfile=Tkinter.Label(hf,width=80,text="  ")
lbfile.pack()
buttshow=Tkinter.Button(hf,text="Show data matrix",bg="cyan",width=25,command=showDM)
buttshow.pack()
buttmain=Tkinter.Button(hf,text=" (1) Main program ",bg="cyan",\
                       width=25,command=calc)
buttmain.pack()


buttcomp=Tkinter.Button(hf,text=" (2) Analysis of Components ",width=25,bg="cyan",command=components)
buttcomp.pack()
buttposets=Tkinter.Button(hf,text=" (3) Further infos ",bg="cyan",width=25,command=posets)
buttposets.pack(pady=3)
buttlpom=Tkinter.Button(hf,text="(4) LPOM   ",bg="cyan",width=25,command=LPOM)
buttlpom.pack()
buttdestroy=Tkinter.Button(hf,text=" (5) exit",bg="red",width=25,bd=4,command=hf.destroy)
buttdestroy.pack()
hf.mainloop()
    

