import rmod2
import raioop2
import Tkinter
import Canvas
from ScrolledText import ScrolledText
import tkSimpleDialog
# brg 14.5.09, 15.5.09, 4.6.09, 8.12.2010
# some cosmetics (8.12.2010)


def concordancem(a,b,g):
    # brg 15.5.09
    # Concordance matrix
    cd=rmod2.marray(g,g)
    for i in range(0,g):
        for j in range(0,g):
            cd[i][j]+=len(a[i]&b[j])

    con1=0
    for i in range(0,g):
        con1+=cd[i][i]

    con2=0
    for i in range(0,g):
        for j in range(0,3,2):
            k=i-1+j
            if 0<=k<=g-1:
                con2+=cd[i][k]
            
    return con1,con2,cd


def confirm():
    #brg 22.5.09
    r=int(e_r.get())
    global r,ealeft,earight
    lbsubset.config(text="number of subsets: "+str(r))
    aleft=rmod2.vecgen1(r)
    lbaleft=rmod2.vecgen1(r)
    ealeft=rmod2.vecgen1(r)
    aright=rmod2.vecgen1(r)
    lbaright=rmod2.vecgen1(r)
    earight=rmod2.vecgen1(r)


    for i in range(0,r):
        lbaleft[i]=Tkinter.Label(frleft,text="subset1  "+str(i)+"  >>>")
        ealeft[i]=Tkinter.Entry(frleft,width=30)
        lbaleft[i].grid(row=i,column=0)
        ealeft[i].grid(row=i,column=1)
                          

    for i in range(0,r):
        lbaright[i]=Tkinter.Label(frright,text="subset2  "+str(i)+"  >>>")
        earight[i]=Tkinter.Entry(frright,width=30)
        lbaright[i].grid(row=i,column=0)
        earight[i].grid(row=i,column=1)
                      

    

def calcconc():
    #brg 14.5.09, 4.6.09
    kappa=0.5   #patil,Bhat 2008
    asleft=rmod2.vecgen1(r)
    hleft=rmod2.vecgen1(r)
    asright=rmod2.vecgen1(r)
    hright=rmod2.vecgen1(r)
       
    # read in
    for i in range(0,r):
        hleft[i]=ealeft[i].get().split(",")
        hright[i]=earight[i].get().split(",")
        asleft[i]=set(hleft[i])
        asright[i]=set(hright[i])
        
    c1,c2,cdact=concordancem(asleft,asright,r)
    
    nobj=0
    for i in range(0,r):
        for j in range(0,r):
            nobj+=cdact[i][j]
         
    conc1=1.0*c1/nobj
    conc2=(1.0*c1+kappa*c2)/nobj
    T=1./r
    logicconc2=(conc2>T)
    logicconc1=(conc1>T)
    # results-output
    lbre.config(text="concordance1= "+str(round(conc1,2))+"  concordance2= "+\
                str(round(conc2,2)),bg="yellow",bd=2,relief="groove",width=50)
    lbre2.config(text="c-teststatistics for concordance1:  "+str(logicconc1),bg="yellow"\
                 ,bd=2,relief="groove",width=50)
    lbre3.config(text="c-teststatistics for concordance2:  "+str(logicconc2),bg="yellow"\
                 ,bd=2,relief="groove",width=50)

    txt=""
    txt+="\nC o n c o r d a n c e - A n a l y s i s "
    txt+="\n"+80*"-"
    txt+="\nNumber of objects:\t"+str(nobj)
    txt+="\nNumber of subsets:\t"+str(r)
    txt+="\n\n First series of subsets (rows)"
    txthilf=""
    for i in range(0,r):
        txthilf+="\n"+str(asleft[i])
    txt+="\n"+txthilf
    txt+="\n\n Second series of subsets (columns)"
    txthilf=""
    for i in range(0,r):
        txthilf+="\n"+str(asright[i])
    txt+="\n"+txthilf
    txt+="\n\n Concordance matrix "
    txthilf="\n\t"
    for i in range(0,r):
        txthilf+=str(i)+"\t"
    for i in range(0,r):
        txthilf+="\n"+str(i)+":"+"\t"
        for j in range(0,r):
            txthilf+=str(cdact[i][j])+"\t"
    txthilf+="\n"
    txt+=txthilf
    txt+="\n\nConcordance indices "
    txt+="\nconcordance 1 (only main diagonal) \t"+str(round(conc1,3))
    txt+="\nconcordance 2 (tridiagonals      ) \t"+str(round(conc2,3))
    txt+="\n teststatistics T \t\t"+str(round(T,3))
    txt+="\n"+80*"-"
    txt+="\n     e  o   f     "
    tres.insert("end",txt)




hf=Tkinter.Tk()
lbconc=Tkinter.Label(hf,text=" Concordance ",width=60)
lbconc.pack(pady=2)
helpconc=raioop2.brgabout(hf,"tp1","help_concordance.txt",2,\
            "Dec., 8th,2010"," help_concordance ", "white", "t1",80,5,ScrolledText)
    
aboutconc=raioop2.brgabout(hf,"tp1","about_concordance.txt",2,\
            "Dec, 8th,2010"," about_concordance ", "white", "t1",80,5,ScrolledText)    

fr=Tkinter.Frame(hf,width=60,height=30)  #8.12.2010
fr.pack(expand="yes",fill="both") #8.12.2010

frentry=Tkinter.Frame(fr,relief='sunken',bd=2)###grid#########
frentry.pack()
labe_r=Tkinter.Label(frentry,text="How many subsets >> ")
labe_r.grid(column=0,row=0)
e_r=Tkinter.Entry(frentry,width=3)
e_r.grid(column=1,row=0)
#################################################grid#########
butt_er=Tkinter.Button(fr,text="confirm (number of subsets) ",bg="cyan",\
                width=25,command=confirm)
butt_er.pack()
lbsubset=Tkinter.Label(fr,text="")
lbsubset.pack()

frleft=Tkinter.Frame(fr,width=30,height=30,bd=2,relief="groove")  #8.12.2010
frleft.pack(side="left")
frright=Tkinter.Frame(fr,width=30,height=30,bd=2,relief="groove") #8.12.2010
frright.pack(side="right")
### nota bene: in frleft frright: grid !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


buttcalc=Tkinter.Button(hf,text=" calc  ",width=25,bg="cyan",command=calcconc)
buttcalc.pack(pady=5)
lbre=Tkinter.Label(hf,text="")
lbre.pack()
lbre2=Tkinter.Label(hf,text="")
lbre2.pack()
lbre3=Tkinter.Label(hf,text="")
lbre3.pack()

tres=ScrolledText(hf,width=60,height=10)
tres.pack(expand="yes",fill="both")
buttexit=Tkinter.Button(hf,text="  Exit ",bg="red",width=25,command=hf.destroy)
buttexit.pack(pady=5)


hf.mainloop()
