# -*- coding: cp1252 -*-
import math
import Tkinter
import tkFileDialog
from ScrolledText import *
import Canvas
import rmod2
import raioop2
#import pylab

# Brg condor1.py (from Condorcet-analysis) 18.6.10 on the basis of genlinext1.py
# from http://snippets.dzone.com/posts/show/753
# central recursive routine to get from an object set all permutations.
# 19.6.10 Output-arrangements
# 29.6.10 (in JRC): two major bugs eliminated. check for phi[i][0]==phisum
#                   and correct construction of the new dm
# 29.6.10: Further output options
# 1.7.10   Continued to implement further output options
# 4.8.10: CKYL
# 4.10.2010 several changes to improve user friedliness (condor8)

def about():
    """ About condor """
    # Brg 17.6.10
    aboutsensi=raioop2.brgabout(hf,"tp2","about_condor.txt",8,\
            "July 4th,2010"," about_condor ", "white", "t2",120,5,ScrolledText)
    

def raihelp():
    """ Help about condor """
    
    #  Use of OOP
    helpsensi=raioop2.brgabout(hf,"tp1","help_condor.txt",8,\
            "July 4th,2010"," help_condor ", "white", "t1",120,10,ScrolledText)

def File_select():
    """select a file and open it """
    #Brg 17.1.08
    #*:17.1.08
    #akt: 17.1.08
    global dm,ob,obj,pro,prop,r,k,fn
    fn=tkFileDialog.askopenfilename()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    lbopen.config(bg="yellow")
    lbopen["text"]="File "+fn+"\n opened with "+str(r)+" rows \n and "\
                         +str(k) +" columns"
    lbopen.pack()

    obj=rmod2.vecgentext1(r)                        #29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  #recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pro[i+1]   #recoding, because pro[0] is a dummy string
    global rred,xred,objred,txtred,tpsub,obj
    tpsub=Tkinter.Toplevel(hf,width=60,height=10)
    tpsub.title(' submit window')
    rred,xred,objred,txtred=rmod2.equivcompact(r,k,dm,obj)
    labex1=Tkinter.Label(tpsub,text="Select objects (<=8) >>>")
    labex1.pack(side="left",pady=2)
    global ex1,ew
    ex1=Tkinter.Entry(tpsub,width=30)
    ex1.pack(side="left")
    labew=Tkinter.Label(tpsub,text="Select weights for "+str(k)+" attributes")
    labew.pack(side="left")
    frc=Tkinter.Frame(tpsub)
    frc.pack(pady=2)
    ew=rmod2.vecgen1(k)
    for i in range(0,k):
        ew[i]=Tkinter.Entry(frc,width=4)
        ew[i].grid(row=0,column=i)
        
    
    return        
    

def showDM():
    """shows the DM"""
    # taken from fuzzyHD7
    tp2a=Tkinter.Toplevel(hf)
    tp2a.title(' show DM ')
    lbtp2=Tkinter.Label(tp2a,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2a,width=60,height=4)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)    

def calc():
    # Brg  4.10.2010, 17.6.10
    # calc the outranking matrix
    # takes the weights
    # Performs the Kemenyi-algorithm (CKYL algorithm after Munda)
    x1=set(ex1.get().split(","))
    if len(x1)<=1:
        x1=set([])
        #print "len(obj) ",len(obj)
        for i in range(0,len(obj)):
            #print "i = ",i,"  obj= ",obj[i],
            x1.add(obj[i])
            #print x1
    print "read in set: ",x1        
    ovec=[]
    iobj=0
    for ob in x1:
        ovec.append(obj.index(ob))  #ovec gets the internal numbers of obj, even if only three objects are selected,
                                    # ovec may contain values larger than 3. 4.10. objred --> obj
    global lovec
    lovec=len(ovec)
    
    global txtb,outrk,txtranking    
    txtb=""
    txtb+="user defined inputs \n"
    txtb+="set = "
    #print "x1 = ",x1
    weights=[]
    
    for i in x1:
        txtb+=i+", "
    
    
    try:
        for i in range(0,k):
            weights.append(float(ew[i].get()))
    except:
        for i in range(0,k):
            weights.append(1.0/(1.0*k))
            
    print "weights ",weights
    txtb+="\n"
    txtw="weights: "
    for i in range(0,k):
        txtw+=str(weights[i])+"\t"
    
    txtb+=txtw+"\n"

    # Outranking matrix corresponding to the Munda, Nardo paper, 2008
    # Outranking matrix rows(columns in an arbitrarx sequence as the objects are found in the set
    outrk=rmod2.marray(lovec,lovec)
    z1=0
    for i in ovec:
        z2=0
        for j in ovec:
            if i!=j:
                for l in range(0,k):
                    if xred[i][l]>xred[j][l]:
                        outrk[z1][z2]+=weights[l]
                    elif xred[i][l]==xred[j][l]:
                        outrk[z1][z2]+=0.5*weights[l]
                    else:
                        outrk[z1][z2]+=0
            z2+=1
        z1+=1    

    permarg=[]  #just 0,1,2,3,....
    for i in range(0,lovec):
        permarg.append(i)
    #rmod2.matout(lovec,lovec,outrk)
    global objcon    
    objcon=rmod2.vecgentext1(lovec)
    z1=0
    for j in ovec:
        objcon[z1]=objred[j]
        z1+=1
    #print "objcon = ",objcon
    #print "ovec = ",ovec
    assign=rmod2.marray(lovec,2)
    for i in range(0,lovec):
        assign[i][0]=ovec[i]
        assign[i][1]=permarg[i]
    rmod2.matout(lovec,2,assign)    

    #CKYL (Kemeny algorithm)
    global constperm, phi
    constperm=40320   # 8!
    phi=rmod2.marray(constperm,2)
    global txtphi1,txtphi2
    txtphi1=rmod2.vecgentext1(rmod2.fakult(lovec))  #phisum
    txtphi2=rmod2.strmarray(rmod2.fakult(lovec),lovec) #permutations
    txtranking=txtb+2*"\n"
    txtranking+="Ranking due to Condorcet \n"
    txtranking+=60*"="+"\n"
   
    z3=0
    for p in all_perms(permarg):
        #print "permutation ",p
        
        phisum=0    
        for i1 in range(0,lovec):
            for i2 in range(i1+1,lovec):
                phisum+=outrk[p[i1]][p[i2]]
        for i3 in range(0,len(p)):
            txtphi2[z3][i3]=str(p[i3])
        
        #print "txtphi2 : ",txtphi2
        phi[z3][0]=phisum
        txtphi1[z3]=str(phisum)
        phi[z3][1]=p
        
        z3+=1
    
    phimax1=0
    for i in range(0,constperm):
        if phi[i][0]>phimax1:
            phimax1=phi[i][0]
            
        
    txtranking+="phimax= "+str(phimax1)+"\n"
    
    #print ranking
    txtehilf="\n(Equivalent) rankings \n"
    global zel
    zel=0  #29.6.10 originally 0
    for i in range(0,constperm):
        if 0.999*phimax1<phi[i][0]<1.001*phimax1: #29.6.10 crucial step because 6.05 can also be presented as 6.04999
            for i1 in phi[i][1]:
                #print "i1 =",i1," ",objcon[i1],"  ",phi[i][1]," phisum= ",phi[i][0]
                txtehilf+=str(objcon[i1])+"> "
            #print " "
            zel+=1
            txtehilf+="\n"
    txtranking+=txtehilf
    txtranking+="\n"
    txtranking+=" number of equivalent rankings: "+str(zel)
    #print "Number of equivalent rankings ",zel
    #HD of equivalent rankings
    global dmnew
    
    dmnew=rmod2.marray(lovec,zel)
    
    z2=0
    for i in range(0,constperm):
        if 0.999*phimax1<phi[i][0]<1.001*phimax1:  #29.6.10 crucial step
            z3=0
            for i2 in range(0,lovec):
                zrank=lovec+1
                for i1 in phi[i][1]:
                    zrank-=1
                    if i1==i2:
                        dmnew[z3][z2]=zrank  #29.6.10 
                z3+=1
            z2+=1
    #rmod2.matout(lovec,zel,dmnew)
    tpsub.destroy()
    tpcalc=Tkinter.Toplevel(hf)    #new: 4.10.2010
    tpcalc.title(' calculate ... ')
    tcalc=ScrolledText(tpcalc,width=60,height=10)
    tcalc.pack()
    tcalc.insert("end",txtranking)
    
def all_perms(str):
    # from http://snippets.dzone.com/posts/show/753
    # From Michael Davies's recipe.
    if len(str) <=1:
        yield str
    else:
        for perm in all_perms(str[1:]):
            for i in range(len(perm)+1):
                yield perm[:i] + str[0:1] + perm[i:]


def show_basics():
    app1=raioop2.brgscrolltext2(hf,txtb," basics of condor ","tp1",60,5,"basics")
    app1.ausgabe()

def show_results():
    app2=raioop2.brgmatrixoutput2(hf,outrk,"tp1","outranking matrix",txtb,lovec,lovec,objcon,objcon,"outranking")
    app2.ausgabe()
    app3=raioop2.brgscrolltext2(hf,txtranking," CYKL-based rankings ","tp1",60,5,"CYKL")
    app3.ausgabe()
      
def show_detail1():
    #brg  29.6.10, 1.7.10
    txt1=txtb+2*"\n"
    for i in range(0,rmod2.fakult(lovec)):
        for j in range(0,lovec):
            txt1+=txtphi2[i][j]+">"
        txt1+="\t: "+txtphi1[i]+"\n"    
    txt1+="- - - e o f  - - -"
    tpdetails1=Tkinter.Toplevel(hf)
    tpdetails1.title(' All permutations and the phi-function ')
    tdetails1=ScrolledText(tpdetails1,width=60,height=5)
    tdetails1.pack()
    tdetails1.insert("end",txt1)    
    

def show_detail2():
    #brg  29.6.10, 1.7.10
    txt1=txtb+"\n"
    txt1+="New matrix as basis for HD of selected objects"+"\n"
    txt1+=80*"="+"\n"
    txt1h="" 
    for j in range(0,zel):
        txt1h+="\trk("+str(j+1)+")\t"
    txt1h+="\n"    
    for i in range(0,len(objcon)):
        txt1h+=objcon[i]+":\t"
        for i1 in range(0,zel):
            txt1h+=str(dmnew[i][i1])+2*"\t"
        txt1h+="\n"
    txt1+=txt1h+"\n"
    txt1+="- - - e o f - - - "
    tpdetails2=Tkinter.Toplevel(hf)
    tpdetails2.title(' new ranking matrix ')
    tdetails2=ScrolledText(tpdetails2,width=120,height=5)
    tdetails2.pack()
    tdetails2.insert("end",txt1)
    
        

def HD():
    "based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"
    # Brg 20.12.07, 28.12.07
    # If the number of representants > 20 then only the cover-matrix and the level-population
    # This module I took from mainHD5
    # 8.6.08 
    global zeta,zeta2,rred,n,objred    
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    global fn
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    rred,xred,objred,txtred=rmod2.equivcompact(r,k,dm,obj)
    n=rred
    labeq=Tkinter.Label(freq,text="file = "+fn+": calc. is based on representants ")
    labeq.config(bg="yellow")
    labeq.pack()

    #
    zetahilf=rmod2.comp(n,k,xred)
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    lbhd1=Tkinter.Label(freq,text= "Level ")
    lbhd1.pack()

    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(n,zeta)
    #print "zzmax = ",zzmax
    tlev=ScrolledText(freq,width=60,height=4)
    tlev.pack()
    txt1="\n"
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= objred[lobj[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)

    txt2="\n One linear extension \n\n"
    for i in range(0,n):
        if i<n-1:
            txt2+=objred[revlext[i]]+" < "
        else:
            txt2+=objred[revlext[i]]+"\n"
    txt2+="\n"
    txt2+="\n -- end of list -- "
    tlinext=ScrolledText(freq,width=60, height=2)
    tlinext.pack()
    tlinext.insert("end",txt2)

        
    #Adj-Listen

    adjc=rmod2.adjacent(n,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(n,adjc,lext)
       
    
    zeta2=rmod2.cover(n,tr,lext)
    if n>50:
        cover_show()                  #20.1.08
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram of File "+fn)
        lbhd3.pack()
        cv=Tkinter.Canvas(freq,width=300,height=200,bg="white")
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(n,n)
        geomy=rmod2.marray(n,n)

        geom0x=10
        geom0y=20
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(160.0/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(160.0/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if zeta2[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        garrow1x=210
        garrow1y=20
        garrow2y=190
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
##        cv.create_line(garrow1x-4,garrow2y-4,garrow1x,garrow2y)
##        cv.create_line(garrow1x+4,garrow2y-4,garrow1x,garrow2y)
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.pack()
        buttcover=Tkinter.Button(freq,text="show cover relation",command=cover_show)
        buttcover.pack()

def cover_show():
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: -
    hfcover=Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    
    lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,n):
        txt3+="\n"+objred[i]+":\t"
        txt3+="is cover_less than "
        for j in range(0,n):
            if i!=j:
                if zeta2[i][j]==1:
                    txt3+=" "+objred[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)

def HDranking():
    "based on objcon (zeta-matrix) the Hasse diagram is generated and one linear extension)"
    # Brg 20.12.07, 28.12.07
    # If the number of representants > 20 then only the cover-matrix and the level-population
    # This module I took from mainHD5
    # 8.6.08 
    global zeta,zeta2,rred,n,objred    
    hfhd3=Tkinter.Toplevel(hf)
    hfhd3.title('Hasse diagram CKYL / cover matrix ')
    freq=Tkinter.Frame(hfhd3,width=200,height=300)
    freq.pack()
    
    n=lovec
    rred=lovec  #just because I don't want to relabel all lines
    

    #
    zetahilf=rmod2.comp(n,zel,dmnew)
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    lbhd1=Tkinter.Label(freq,text= "Level ")
    lbhd1.pack()

    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(n,zeta)
    #print "zzmax = ",zzmax
    tlev=ScrolledText(freq,width=60,height=4)
    tlev.pack()
    txt1=txtb+2*"\n"
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= objcon[lobj[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)

    txt2="\n One linear extension \n\n"
    for i in range(0,n):
        if i<n-1:
            txt2+=objcon[revlext[i]]+" < "
        else:
            txt2+=objcon[revlext[i]]+"\n"
    txt2+="\n"
    txt2+="\n -- end of list -- "
    tlinext=ScrolledText(freq,width=60, height=2)
    tlinext.pack()
    tlinext.insert("end",txt2)

        
    #Adj-Listen

    adjc=rmod2.adjacent(n,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(n,adjc,lext)
       
    
    zeta2=rmod2.cover(n,tr,lext)
    if n>50:
        cover_show()                  #20.1.08
    else:
        lbhd3rk=Tkinter.Label(freq,text=" Hasse Diagram of File "+fn)
        lbhd3rk.pack()
        cv=Tkinter.Canvas(freq,width=300,height=200,bg="white")
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(n,n)
        geomy=rmod2.marray(n,n)

        geom0x=10
        geom0y=20
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(160.0/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(160.0/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if zeta2[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objcon[lobj[i][j]])
        garrow1x=210
        garrow1y=20
        garrow2y=190
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
##        cv.create_line(garrow1x-4,garrow2y-4,garrow1x,garrow2y)
##        cv.create_line(garrow1x+4,garrow2y-4,garrow1x,garrow2y)
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.pack()
        


    
hf=Tkinter.Tk()
hf.title('Condorcet/CYKL analysis')
about()
raihelp()
fropen=Tkinter.Frame(hf,width=60,height=40,relief="sunken",bd=2)
fropen.pack()
lbopen=Tkinter.Label(fropen,text=120*" ")
lbopen.pack()
buttfileselect=Tkinter.Button(fropen,text="select and open file",width=25, bg="white",command=File_select)
buttfileselect.pack(pady=10)
frshow=Tkinter.Frame(hf,width=60,height=4,relief="sunken",bd=2)
frshow.pack(fill="x")
buttshow=Tkinter.Button(frshow,text="show data matrix ",width=25,command=showDM)
buttshow.pack(pady=5)
fr2a=Tkinter.Frame(hf)
fr2a.pack()
fr2b=Tkinter.Frame(hf)
fr2b.pack()
buttHD=Tkinter.Button(frshow,text="show  HD ",width=25,command=HD)
buttHD.pack(pady=10)
frcalc=Tkinter.Frame(hf,relief="sunken",bd=2)
frcalc.pack(pady=5)
lbcalc=Tkinter.Label(frcalc, text="calculate Condorcet/CYKL ")
lbcalc.pack()
buttcalc=Tkinter.Button(frcalc,text="(1) calc ",bg="cyan",width=25,command=calc)
buttcalc.pack(pady=25)
frresults=Tkinter.Frame(hf,relief="groove",bd=4)
frresults.pack(pady=5)
buttshowbasics=Tkinter.Button(frresults,text="basics (selected objects\nselected weights)",command=show_basics)
buttshowbasics.pack()
buttshowresults=Tkinter.Button(frresults,text="Results: Condorcet, CYKL - algorithm",bg="cyan",width=30,command=show_results)
buttshowresults.pack(pady=5)
buttshowdetails1=Tkinter.Button(frresults,text="Look at all rankings" ,command=show_detail1)
buttshowdetails1.pack(pady=3)
buttshowdetails2=Tkinter.Button(frresults,text="Look at the new rank_dm" ,command=show_detail2)
buttshowdetails2.pack(pady=3)

buttHDRk=Tkinter.Button(frresults,text="HD of (equiv. ) rankings",bg="cyan",command=HDranking)
buttHDRk.pack()
buttexit=Tkinter.Button(hf,text="  Exit  ",bg="red",width=25,command=hf.destroy)
buttexit.pack(pady=30)




























hf.mainloop()
