# -*- coding: cp1252 -*-
import math
import Tkinter
import tkFileDialog
from ScrolledText import *
import Canvas
import rmod2
import raioop2


# Brg copel1.py (derived from outrk1.py)  7.7.10
# Brg copel3.py after checks by Claudio M. Rocco, Venezuela
# Brg 4.2.2014 cosmetics: copel4
# Brg 6.2.2014 copel5_1.py
# brg 7.11.2014 Representative elements and extension to all objects
# brg 8.11.2014
# brg 13.1.2015 optional: outrk - output


def copeland(objred,xred,weights,k):
    # brg 7.7.10, 2.2.2011, 3.2.2011
    # objred list of representative objects
    # weights  list of k weights, will be overwritten (2.2.2011)
    # xred dm of quotient set , representatives of eq.cl.
    # k: number of columns of xred (number of attributes)
    sumw=0                #2.2.2011 
    for j in range(0,k):
        sumw+=weights[j]
    for j in range(0,k):
        weights[j]=1.0*weights[j]/(1.0*sumw)  #2.2.2011
    lovec=len(objred)
    outrk=rmod2.marray(lovec,lovec)
    for i in range(0,lovec):
        for j in range(0,lovec):
            if i!=j:
                for l in range(0,k):
                    if xred[i][l]>xred[j][l]:
                        outrk[i][j]+=weights[l]
                    elif xred[i][l]==xred[j][l]:
                        outrk[i][j]+=0
                    else:
                        outrk[i][j]-=weights[l]
    return outrk,lovec,weights



def read_text_equivcompact(txt):
    #brg 3.2.2011 rte-routine
    z=txt.split("\n")
    #print "In rte-procedure z= ",z
    lz=len(z)
    q=rmod2.vecgen1(lz)
    for i in range(0,lz):
        q[i]=z[i].split(":")

    #print "In rte routine q ",q
    txteq=[]
    for i in range(0,lz):
        if q[i][0]!="":
            if q[i][1]!=" ":
                #print "***", q[i]
                txteq.append(q[i])
                
    return txteq




def about():
    """ About copel """
    # Brg 17.6.10
    aboutsensi=raioop2.brgabout(hf,"tp2","about_copel.txt",6,\
            "February 6th,2014"," about_cope2 ", "white", "t2",120,5,ScrolledText)
    

def raihelp():
    """ Help about copeland """
    
    #  Use of OOP
    helpsensi=raioop2.brgabout(hf,"tp1","help_copel.txt",6,\
            "February, 6th,2014"," help_cope2 ", "white", "t1",120,10,ScrolledText)

def File_select():
    """select a file and open it """
    #Brg 17.1.08
    #*:17.1.08
    #akt: 17.1.08
    global dm,ob,obj,pro,prop,r,k,fn
    fn=tkFileDialog.askopenfilename()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    lbopen.config(bg="yellow")
    lbopen["text"]="File "+fn+"\n opened with "+str(r)+" rows \n and "\
                         +str(k) +" columns"
    lbopen.pack()

    obj=rmod2.vecgentext1(r)                        #29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  #recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pro[i+1]   #recoding, because pro[0] is a dummy string
    global rred,xred,objred,txtred,tpsub,anz,ewe, eqm_basic,txteq
    rred,xred,objred,txteq,eqm_basic=rmod2.equivcompactgr(r,k,dm,obj) #equivcompact g r (...)
    tpequiv=Tkinter.Toplevel(hf)
    tpequiv.title("equivalence classes of orig. dm ")
    tequiv=ScrolledText(tpequiv,width=60,height=10)
    tequiv.pack()
    tequiv.insert("end",txteq)
    tpsub=Tkinter.Toplevel(hf,width=60,height=10)
    tpsub.title(' submit window')
    
    
    try:
        anz=int(eanz.get())
    except:
        anz=1
        print "anz=1 "
    lbwe=Tkinter.Label(tpsub,text="Entries for "+str(k)+ "weights corresponding to "+str(anz)+" tests")
    lbwe.pack()
    ewe=rmod2.marray(anz,k)
    frw=Tkinter.Frame(tpsub,bd=4,relief="sunken")
    frw.pack()
    for i in range(0,anz):
        for j in range(0,k):
            ewe[i][j]=Tkinter.Entry(frw,width=4)
            ewe[i][j].grid(row=i,column=j)
    return        
    

def showDM():
    """shows the DM"""
    # taken from fuzzyHD7
    tp2a=Tkinter.Toplevel(hf)
    tp2a.title(' show DM ')
    lbtp2=Tkinter.Label(tp2a,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2a,width=60,height=4)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt4 = "equvalence classes of the original dm "+"\n"
    txt4+=txteq
    txt=txt1+txt2+txt3+txt4
    tfile.insert("end",txt)    

def sfrepres():
    #brg  31.5.09, 1.6.09, 7.7.10 taken from palg4.py, 8.11.2014
    fn=tkFileDialog.asksaveasfilename(parent=hf,title="save file (repres. elements)")
    # brg  30.5.09
    
    rmod2.raiwrite5(fn,dmnew,objred,prop,rred,anz)
    lbsuccess2.config(text="matrix with \n"+str(rred)+"  rows  and "+str(anz)+"\n  columns stored",bg="yellow")


def sfall():
    #brg  31.5.09, 1.6.09, 7.7.10 taken from palg4.py, 8.11.2014
    fn=tkFileDialog.asksaveasfilename(parent=hf,title="save file (all elements)")
    # brg  30.5.09
    
    rmod2.raiwrite5(fn,dmallnew,obj,prop,r,anz)
    lbsuccess.config(text="matrix with \n"+str(r)+"  rows  and "+str(anz)+"\n  columns stored",bg="yellow")





def calc():
    # Brg  17.6.10, 13.1.2015
    # calc the outranking matrix
    # takes the weights
    # Performs the Copeland-method
   
    global rred,dmnew,anz,wact, dmallnew,out1
    dmnew=rmod2.marray(rred,anz)
    dmallnew=rmod2.marray(r,anz)
    we1=rmod2.marray(anz,k)
    we=rmod2.marray(anz,k)
    wact=rmod2.vecgen1(anz)
    flagw=rmod2.vecgen1(anz)
    for i1 in range(0,anz):
        for j in range(0,k):
            try:
                we1[i1][j]=float(ewe[i1][j].get())
                we[i1][j]=we1[i1][j]
                flagw[i1]=1
            except:
                we1[i1][j]=1
                we[i1][j]=we1[i1][j]
                flagw[i1]=0

    print "flagw= ",flagw
    print "we = ",we1
    # in the following the loop 0,anz reads weights for each attribute for simulation 0,..,simulation anz
    for i1 in range(0,anz):
        print "i=",i1," ",we1[i1]
        out1,lov1,wact[i1]=copeland(objred,xred,we[i1],k) # internally weights will transfomed to sum weights = 1
        print "wact= ",i1," ",wact[i1]
        
        row1=rmod2.matrixrowsum(out1,rred,rred)
        row1ext=rmod2.weak1(r,obj,objred,row1,eqm_basic)  #### new 7.11.2014
        for i in range(0, r):
            dmallnew[i][i1]=row1ext[i]
        
        for i in range(0,rred):
            dmnew[i][i1]=row1[i]  #6.2.2014 originally dmnew[j][i1] now dmnew[i][i1] (i=1,...,r)

    tpcopeland=Tkinter.Toplevel(hf)
    tpcopeland.title('  Copeland  ')
    txtcopel="Copelandindex (all objects) "+"\n"
    txtcopel+=60*"="+"\n"
    for i in range(0, r):
        txtcopel+=str(obj[i])+"\t"
        for j in range(0,anz):
            txtcopel+=str(round(dmallnew[i][j],3))+"\t"
        txtcopel+="\n"
    txtcopel+="\n"
    txtcopel+="Copeland w.r.t representative elements "+"\n"    
    for i in range(0, rred):
        txtcopel+=str(objred[i])+"\t"
        for j in range(0,anz):
            txtcopel+=str(round(dmnew[i][j],3))+"\t"
        txtcopel+="\n"    
    txtcopel+="\n"
    txtcopel+=" -  -  -  e o f  - - - "
    tcopel=ScrolledText(tpcopeland, width=70,height=10)
    tcopel.pack()
    tcopel.insert("end",txtcopel)
    rred1,xred1,objred1,txtred1=rmod2.equivcompact(r,anz,dmallnew,obj)
    print "txtred1 = ",txtred1
    txteq1=read_text_equivcompact(txtred1)   
    hfhd3=Tkinter.Toplevel(hf)
    hfhd3.title('Hasse diagramCopeland (all objects)')
    freq=Tkinter.Frame(hfhd3,width=200,height=300)
    freq.pack()
    if anz==1:
        txtanz="Only one weight-tupel (Standard)"
    else:
        txtanz="User selection of " + str(anz)+"weight-tupels "
    lbanz=Tkinter.Label(freq,text=txtanz,bg="yellow")
    lbanz.pack()
     
    
    #
    zetahilf=rmod2.comp(rred1,anz,xred1)
    zeta=rmod2.marray(rred1,rred1)
    for i in range(0,rred1):
        for j in range(0,rred1):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    lbhd1=Tkinter.Label(freq,text= "Level ")
    lbhd1.pack()

    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred1,zeta)
    #print "zzmax = ",zzmax
    tlev=ScrolledText(freq,width=60,height=4)
    tlev.pack(expand="yes",fill="both")
    
    txt1="Results \n"
    txt1+=60*"="+"\n"
    txt1+="equivalence classes "+"\n"
    lte=len(txteq1)
    txt1+="Number of nontrivial equivalence classes: "+str(lte)+"\n"
    txt1+="The first element in the following list is the representant "+"\n"
    for i2 in range(0,lte):
        txt1+=str(txteq1[i2])+"\n"
    
    txt1+="\n"

    txt1+="Level Info \n"
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= objred1[lobj[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)

    txt2="\n Further results \n\n"
    txt2+=txtanz+"\n"
    if anz==1:
        txt2+="This is the linear/weak order due to the outranking procedure\n"
    else:
        txt2="User selected weights \n"
    txthilf=""    
    for i1 in range(0,anz):
        for j in range(0,k):
            txthilf+=str(round(we1[i1][j],3))+" "
        txthilf+="\n"
    txthilf+="\n"
    txt2+=txthilf+"\n"
            
    for i in range(0,rred1):
        if i<rred1-1:
            txt2+=objred1[revlext[i]]+" < "
        else:
            txt2+=objred1[revlext[i]]+"\n"
    txt2+="\n"
    txt2+="\n -- end of list -- "
    tlinext=ScrolledText(freq,width=60, height=2)
    tlinext.pack(expand="yes")
    tlinext.insert("end",txt2)

        
    #Adj-Listen

    adjc=rmod2.adjacent(rred1,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred1,adjc,lext)
       
    
    zeta2=rmod2.cover(rred1,tr,lext)
    if rred1>60:
        cover_show()                  #20.1.08
    else:
        lbhd3rk=Tkinter.Label(freq,text=" Hasse Diagram of File "+fn)
        lbhd3rk.pack()
        cv=Tkinter.Canvas(freq,width=300,height=200,bg="white")
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(rred1,rred1)
        geomy=rmod2.marray(rred1,rred1)

        geom0x=10
        geom0y=20
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(160.0/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(160.0/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if zeta2[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred1[lobj[i][j]])
        garrow1x=210
        garrow1y=20
        garrow2y=190
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.pack()
    buttshowweights.config(state="active")


def showweights():
    # brg 6.2.2014
    tpweights=Tkinter.Toplevel(hf)
    tweights=ScrolledText(tpweights,width=80, height=10)
    tweights.pack()
    txt="Actually used (and internally normalized weights "+"\n"
    txt+="Normalization: sum weights = 1 "+"\n"
    for i1 in range(0,anz):
        for j in range(0,k):
            txt+=str(round(wact[i1][j],5))+" "
        txt+="\n"
    txt+="\n"
    txt+="- - - -    e o f  - - - "
    tweights.insert("end",txt)
    
    

def HD():
    "based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"
    # Brg 20.12.07, 28.12.07
    # If the number of representants > 20 then only the cover-matrix and the level-population
    # This module I took from mainHD5
    # 8.6.08 
    global zeta,zeta2,rred,n,objred    
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    global fn
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    rred,xred,objred,txtred=rmod2.equivcompact(r,k,dm,obj)
    n=rred
    labeq=Tkinter.Label(freq,text="file = "+fn+": calc. is based on representants ")
    labeq.config(bg="yellow")
    labeq.pack()

    #
    zetahilf=rmod2.comp(n,k,xred)
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    lbhd1=Tkinter.Label(freq,text= "Level ")
    lbhd1.pack()
    #print "In normal HD "
    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(n,zeta)
    #print "zzmax = ",zzmax
    tlev=ScrolledText(freq,width=60,height=4)
    tlev.pack()
    txt1="\n"
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= objred[lobj[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)

    txt2="\n One linear extension \n\n"
    for i in range(0,n):
        if i<n-1:
            txt2+=objred[revlext[i]]+" < "
        else:
            txt2+=objred[revlext[i]]+"\n"
    txt2+="\n"
    txt2+="\n -- end of list -- "
    tlinext=ScrolledText(freq,width=60, height=2)
    tlinext.pack()
    tlinext.insert("end",txt2)

        
    #Adj-Listen

    adjc=rmod2.adjacent(n,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(n,adjc,lext)
       
    
    zeta2=rmod2.cover(n,tr,lext)
    if n>50:
        cover_show()                  #20.1.08
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram of File "+fn)
        lbhd3.pack()
        cv=Tkinter.Canvas(freq,width=300,height=200,bg="white")
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(n,n)
        geomy=rmod2.marray(n,n)

        geom0x=10
        geom0y=20
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(160.0/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(160.0/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if zeta2[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        garrow1x=210
        garrow1y=20
        garrow2y=190
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
##        cv.create_line(garrow1x-4,garrow2y-4,garrow1x,garrow2y)
##        cv.create_line(garrow1x+4,garrow2y-4,garrow1x,garrow2y)
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.pack()
        buttcover=Tkinter.Button(freq,text="show cover relation",command=cover_show)
        buttcover.pack()

def cover_show():
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: -
    hfcover=Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    
    lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,n):
        txt3+="\n"+objred[i]+":\t"
        txt3+="is cover_less than "
        for j in range(0,n):
            if i!=j:
                if zeta2[i][j]==1:
                    txt3+=" "+objred[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)

def show_outrk():
    # brg 13.1.2015
    tpoutrk=Tkinter.Toplevel(hf)
    tpoutrk.title(' Outranking-matrix with weights')
    lboutrk=Tkinter.Label(tpoutrk,text="Outranking-matrix due to the weights ")
    lboutrk.pack()
    hilftxt="+++Note, when several sets of weights are selected, \n\
        then the outranking matrix is based on the last set of weights!++++"
    lboutrk2=Tkinter.Label(tpoutrk,text=hilftxt, bg="yellow")
    lboutrk2.pack()
    toutrk=ScrolledText(tpoutrk,width=60,height=10)
    toutrk.pack()
    txt="Outranking"+"due to the weights...\n"
    for j in range(0,anz):
        for j2 in range(0,k):
            txt+=str(wact[j][j2])+" "
        txt+="\n"
    txt+="\n"    
    txt+=50*"="+"\n"
    txt+="\t"
    for i1 in range(0,rred):
        txt+=str(objred[i1])+"\t"
    txt+="\n"
    for i1 in range(0,rred):
        txt+=str(objred[i1])+":\t"
        for i2 in range(0,rred):
            txt+=str(round(out1[i1][i2],3))+"\t"
        txt+="\n"
    txt+="\n"
    toutrk.insert("end",txt)
    

    
hf=Tkinter.Tk()
hf.title(' Copeland')
about()
raihelp()
frcut=Tkinter.Frame(hf, relief="groove",bd=3)
frcut.pack(pady=3)
lbanz=Tkinter.Label(frcut,text="Number of test weight-tuples >>")
lbanz.pack(side="left")
eanz=Tkinter.Entry(frcut,width=3)
eanz.pack(side="left")
fropen=Tkinter.Frame(hf,width=60,height=40,relief="sunken",bd=2)
fropen.pack()
lbopen=Tkinter.Label(fropen,text=120*" ")
lbopen.pack()

buttfileselect=Tkinter.Button(fropen,text="select and open file",width=25, bg="white",command=File_select)
buttfileselect.pack(pady=10)
frshow=Tkinter.Frame(hf,width=60,height=4,relief="sunken",bd=2)
frshow.pack(fill="x")
buttshow=Tkinter.Button(frshow,text="show data matrix ",width=25,command=showDM)
buttshow.pack(pady=5)

fr2a=Tkinter.Frame(hf)
fr2a.pack()
fr2b=Tkinter.Frame(hf)
fr2b.pack()
buttHD=Tkinter.Button(frshow,text="show  HD ",width=25,command=HD)
buttHD.pack(pady=10)

frc=Tkinter.Frame(hf,relief="sunken",bd=2)
frc.pack(pady=5)
buttcalc=Tkinter.Button(frc,text="(1) calc and HD ",bg="cyan",width=25,command=calc)
buttcalc.pack(pady=25)
buttshowweights=Tkinter.Button(frc,text="Show the actually used\n \
    (and normalized) weights",width=25,command=showweights,state="disabled")
buttshowweights.pack()
frresults=Tkinter.Frame(hf,relief="groove",bd=4)
frresults.pack(pady=5)
buttshowoutrk=Tkinter.Button(hf,text="Show outranking-matrix ",width=30,command=show_outrk)
buttshowoutrk.pack()
buttsfall=Tkinter.Button(hf, text = "store changed dm \nall elements ",bd=5,width=25,bg="cyan",\
                      command=sfall)
buttsfall.pack()
lbsuccess=Tkinter.Label(hf,text="")
lbsuccess.pack()
buttsfall2=Tkinter.Button(hf, text = "store changed dm \nrepresent. elem. ",bd=5,width=25,bg="cyan",\
                      command=sfrepres)
buttsfall2.pack()
lbsuccess2=Tkinter.Label(hf,text="")
lbsuccess2.pack()

buttexit=Tkinter.Button(hf,text="  Exit  ",bg="red",width=25,command=hf.destroy)
buttexit.pack(pady=30)




























hf.mainloop()
