import rmod2
import raioop2
import Tkinter
from ScrolledText import *
import random
import os

# cover_reader: Brg 21.6.08  derived from zeta_reader
# a program reading the cover matrix
# Brg: 24.6.08 Readin via GUI
# Brg: 26.6.08 New: about - function
# Brg: 26.6.08 New: Disabled/active buttons depending on the logical flow
# Brg: 13.10. Extension by calculation of mutual probabilities. Suggestion
#        of Karel De Loof included (one variant)
# Brg: 13.10.08: help text now an internal file. Loading by an OOP function
# brg: 28.12.2011 cosmetics
global q1,tech,r
tech=rmod2.vecgen1(20)
x=rmod2.marray(200,200)
y=rmod2.marray(200,200)

    
def enrich(s,z,n):
    """ tests whether the permutation s is a linear extension
    of the poset, described by the zeta matrix """
    #brg 3.1.08
    #s is a permutatin of an initial linear extension
    #z is a zeta matrix
    #n is the number of objects
    #taken from mainHD7
    flag=1
    for i in range(0,n):
        for j in range(0,n):
            if i!=j:
                try:
                    if z[i][j]==1 and s.index(i)> s.index(j):
                        flag=0
                except:       
                    flag=0
            else:
                pass
            
    return flag


def BubleyDyer(sigma,zeta,n, nMC,unif_sampl):
    """MC-calculation of a random set of linear extensions
    after Bubley and Dyer , see also Denoeux-paper
    from this set dynamically rkav is calculated """
    #brg 3.1.08, 17.6.08, 18.6.08
    #sigma is the initial linear extension
    #zeta is the zeta matrix, orientation row defining number <
    #......column defining number then corresp. entry =1
    # n is the number of objects
    #nMC is the number of MC-trials at least 4000, better more
    #unif_sampl. if e.g. unif_sampl=100 and nMC=10000 then the
    #          rkav will be calculated after each 100.step
    # taken from mainHD7
    sigmanew=rmod2.vecgen1(n)
    rkav0=rmod2.vecgen1(n)
    rkav=rmod2.vecgen1(n)
    rkavalt=rmod2.vecgen1(n)
    for i in range(0,n):
        rkav[i]=sigma.index(i)+1
        rkav0[i]=sigma.index(i)+1
        rkavalt[i]=sigma.index(i)+1
    #Initial average rank rkav0

    #print " initial sigma ",sigma
    for i in range(0,n):
        sigmanew[i]=sigma[i]

    zaehl=0
    lint=1

   #18.6.: check the loop-finishing condition
    while zaehl<nMC:
        rr=random.randint(0,1)  #17.6.08 8 changed to n 18.6 changed to (0,1)
        if rr==0:        #17.6.08 18.6.08 changed
            for i in range(0,n):
                sigmanew[i]=sigma[i]
##            if zaehl%unif_sampl==0:   #17.6.08
##                for i in range(0,n):    
##                    rkav[i]+=sigmanew.index(i)+1.0
##                lint+=1
        else:
            irandom=random.randint(0,n)  ## better: take f(i)
            if 0<=irandom<n-1:   #25.6.08 changed from < to =<
                sigmanew[irandom+1]=sigma[irandom] #transposition of width =1
                sigmanew[irandom]=sigma[irandom+1]  # transpos. of width=1
            else:
                sigmanew[0]=sigma[n-1]
                sigmanew[n-1]=sigma[0]

            flag=enrich(sigmanew,zeta,n)
            if flag==1:
                
                #print sigmanew
                for i in range(0,n):
                    sigma[i]=sigmanew[i]
                if zaehl%unif_sampl==0:  #18.7.08
                    for i in range(0,n):
                        rkav[i]+=sigma.index(i)+1.0
                    lint+=1    
            else:
                for i in range(0,n):
                    sigmanew[i]=sigma[i]
##                for i in range(0,n): ##heikel 17.6.08
##                    rkav[i]+=sigmanew.index(i)+1.0
##                lint+=1    
        
        zaehl+=1
        if zaehl==nMC-2:
            for i in range(0,n):
                rkavalt[i]=rkav[i]
            
    # MC-loop finished
    return rkav, rkav0,lint,rkavalt


    
    




def Bubley_Dyer_rkav():
    """Calculates rkav on the basis of
    MC-simulations after the algorithm of
    Bubley-Dyer """
    #Brg 5.1.07, 10.1.08, 18.2.08, 17.6.08
    # this module is more or less oly the GUI organisation
    # and responsible for some technicalities
    # taken from mainHD7
    hfrk=Tkinter.Toplevel(hf)              #11.1.08
    hfrk.title('Averaged Ranks after Bubley-Dyer ')
    freq=Tkinter.Frame(hfrk,width=200,height=300)
    freq.pack()
    lbwarn1=Tkinter.Label(hfrk,text="")
    lbwarn1.pack()
    MCstr=zahlMC.get()
    if MCstr=="":
        lbwarn1.config(bg="yellow")
        lbwarn1["text"]="!! ++Input missing++ !!"
    else:
        lbwarn1.config(bg="white")
        lbwarn1["text"]=" "
    nMC=int(zahlMC.get())
    #21.3.08  Selection starter based on levels  or based on LPOM
    # If LPOM (which probably is the better starter then first ...
    # the local partial order must be calculated
    unif_sampl=int(u_sampl.get())
    
     
##    zeta=rmod2.marray(r,r)
##    for i in range(0,r):
##        for j in range(0,r):
##            zeta[i][j]=zzeta[j][i]
    # 21.3.08 many changes!!
    # BD is based on sigma, taken from the LPOM model, the initial linear extension, some others (output LT) will
    # be calculated and from them dynamically rkav
    # The user is responsible to take care that LT is large enough to rely on
    # the results.
##    print "r = ",r
##    print "nMC = ",nMC
##    print "unif_sampl = ",unif_sampl
##    print "sigma = ",sigma
    rkavBD,rkavinit,LT,rkavaltBD=BubleyDyer(sigma,zzeta,r,nMC,unif_sampl) # central routine, calls enrich
##    print "LT = ",LT
    summe=0
    n=r
    for i in range(0,r):
        rkavBD[i]=1.0*rkavBD[i]/(1.0*LT)
        rkavaltBD[i]=1.0*rkavaltBD[i]/(1.0*LT)
        rkavBD[i]=round(rkavBD[i],2)
        summe+=abs(rkavBD[i]-rkavaltBD[i])
    summe=round(1.0*summe/(1.0*n),2)
    #results
    txt="\n Results of Bubley-Dyer-Algorithm "
    txt+="\n a1) Number of calculated linear extensions:  \t"+str(LT)
    txt+="\n a2) Number of MC-runs: \t"+str(nMC)
    txt+="\n a3) Any "+str(unif_sampl)+"  was selected"
    txt+="\n    Averaged error in %:  "+str(100*summe)
    txt+="\n b) The initial ranks "
    for i in range(0,n):
        txt+="\n "+obj[i]+"\t\t"+str(rkavinit[i])
    txt+="\n The averaged ranks after Bubley Dyer "
    for i in range(0,n):
        txt+="\n" + obj[i]+"\t\t"+str(rkavBD[i])
    txt+="\n"
    txt+="\n - - -  end of file - - - "
    tBD=ScrolledText(freq,width=60,height=10)
    tBD.pack()
    tBD.insert("end",txt)

def about():
    """about covreader3 """
    # Brg 26.6.08
    tabout=Toplevel(hf)
    frabout=Tkinter.Frame(tabout,bd=2,relief="sunken")
    frabout.pack()
    lb1=Tkinter.Label(frabout,bg="white",width=60,text="Program covreader3, developed by R.Bruggemann")
    lb1.pack()
    lb2=Tkinter.Label(frabout,bg="white",width=60,text="Aim of the program: a) interface to theoretical work\
\nb)experimental working")
    lb2.pack()
    lb3=Tkinter.Label(frabout,bg="white",width=60,text="Warshall Algorithm  for the transitive closure ")
    lb3.pack()
    lb4=Tkinter.Label(frabout,bg="white",width=60,text="See for example: K.H.Rosen, Discrete Mathematics and Its Applications\
\n4th edition, 1999, p. 399-406")
    lb4.pack()
    


def fhelp():
    """ help for cover_reader"""
    # brg 8.12.07, 15.1.08, 21.6.08, 24.6.08, 25.6.08
    hfhelp=Tkinter.Toplevel(hf)
    hfhelp.title(' help')
    lbhfhelp=Tkinter.Label(hfhelp,text="help of fuzzyHD6")
    lbhfhelp.pack()
    frhelp=Tkinter.Frame(hfhelp,width=100,height=10)
    frhelp.pack()
    txt=""
    txt+="Aim of the program \n"
    txt+="Calculates the Hasse diagram and some infos based on the cover matrix\n"
    
    txt+="\nPrerequisites \n"
    txt+="(1a) The cover matrix taking from a file: a cell with row object a and column object b \n"
    txt+="cell(a,b)= 1 indicates a < b \n"
    txt+="cell(a,b)=0 indicates either a > b or a || b \n"
    txt+="As in all PyHasse programs: cell(0,0) must include a string!"
    txt+="The file must include object identifier"
    txt+="\n (1b) You may also directly read in the cover matrix"
    txt+="\n (1b1) How many objects? After giving the number of objects an..."
    txt+="\n ......appropriate matrix opens, where you can indicate by '1' the cover relation"
    txt+="\n       You don't need to fill the empty cells with 0"
    txt+="\n  (1b2) After your input you must confirm your data by pressing the button (1b2)"
     
    txt+="\n\nSteps for the calculation \n"
    txt+="generally: Follow the order of buttons starting from the top,... \n"
    txt+="...down to the bottom\n"
    txt+="(1) read in the txt-File of an EXCEL-sheet\n"
    
    txt+="(2) HD from cover matrix   \n"
    txt+="(3) You may be interested to see some statistics for any element "
    txt+="    and to determine at least the LPOM 0th order averaged rank"
    txt+="    This is performed by Button 'some calculations'"
    txt+="\n(4) As in mainHD the Bubley-Dyer algorithm is offered. However"
    txt+="\n    ...only with the LPOM-starter."
    
    
    txt+="\n\n Known Bugs/difficulties:"
    txt+="\nNote that the analysis needs a diagonal = 1 in the cover matrix"
    txt+="\nThis step is automatically done by the program"
    txt+="\nExample file: covertest.txt " 
    
    thelp=ScrolledText(frhelp,width=60,height=5,wrap="word")
    thelp.pack()
    thelp.insert("end",txt)

def hmo():
    """ Read in number of objects """
    # hmo: how many objects
    global nobj,r,flag,ecov
    nobj=int(enobj.get())
    r=nobj
    ecov=rmod2.marray(int(nobj),int(nobj))  #nobj not identified  (23.6.08)
    for i in range(0,int(nobj)):
        for j in range(0,int(nobj)):
            ecov[i][j]=Tkinter.Entry(frin,width=2)
            ecov[i][j].grid(row=i+1,column=j+1)
    flag=1
    butt1.config(state="disabled")
    buttcovin.config(state="active")
    
def fileopen():
    "Informs about the file-operations"
    # Excelreadin4 built in
    # Brg 29.11.07, 30.11.07, 15.1.08,18.2.08
    import tkFileDialog
    global fn,cover,ob,pr,r,k,prop,obj
    fn=tkFileDialog.askopenfilename()
    cover,ob,pr,r,k=rmod2.EXCELreadin4(fn)
    #print "r = ",r,"   k = ",k
    obj=rmod2.vecgentext1(r)                        #29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  #recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    
    #rmod2.matout(r,k,x)
    lbopen1.config(bg="yellow")    #18.2.08
    lbopen1["text"]="File "+fn+" was opened with "+str(r)+" rows and "+str(k)+"  columns"
    buttnobj.config(state="disabled")
    buttcovin.config(state="disabled")
    return 

def direct_readin():
    """ Reads cover relation directly from GUI """
    # brg 23.6.08
    global cover,obj
    cover=rmod2.marray(int(nobj),int(nobj))
    obj=rmod2.vecgentext1(int(nobj))
    for i in range(0,int(nobj)):
        obj[i]=str(i+1)
    frin.config(width=300,height=300,relief="sunken",bd=3)
                
    for i in range(0,int(nobj)):
        for j in range(0,int(nobj)):
            if ecov[i][j].get()=="" or ecov[i][j].get()==" " or ecov[i][j].get()=="  ":
                cover[i][j]=0
            else:    
                cover[i][j]=int(ecov[i][j].get())
                
    for i in range(0,int(nobj)):
        cover[i][i]=1
            
    
    return cover            
                                
                                
def showDM():
    """ New routine : shows the data matrix """
    #Brg 13.1.08, 15.1.08
    #*: 13.1.08
    #akt: 15.1.08
    #note: modified from the routine, taken from simi3
    tp2=Tkinter.Toplevel(hf)
    tp2.title('show DM')
    lbtp2=Tkinter.Label(tp2,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt2="\n objects  \n"
    k=r
    for j in range(0,k):
        txt2+=" "+obj[j]+",\t"
    txt2+="\n"
    txt3="\n cover matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=obj[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,k):
            txt3+=str(cover[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)    




def HD():
    "based on cover-matrix the Hasse diagram is generated and one linear extension)"
    # Brg 20.12.07, 28.12.07
    # If the number of representants > 20 then only the cover-matrix and the level-population
    #

    global zeta2,n,obj  
   
    if r==0:
        hfwarning=Tkinter.Toplevel(hf)
        hfwarning.title('++warning++')
        frwarning=Tkinter.Frame(hfwarning,width=10,height=3)
        frwarning.pack()
        bwarning=Tkinter.Button(frwarning,text="++warning ++",command=msgwarning)
        bwarning.pack()
    #print "test 7.5.08 rs  = ",rs    
    n=r
    rs=r     #14.4.08 
   
    
    hfhd1=Tkinter.Toplevel(hf)
    hfhd1.title(' Hasse diagram / cover matrix ')
    lbhfhd1=Tkinter.Label(hfhd1,text='Hasse diagram or cover matrix ')
    lbhfhd1.pack()
    freq=Tkinter.Frame(hfhd1,width=400,height=480)
    freq.pack()
    
   
    
    zeta=rmod2.marray(rs,rs)
    for i in range(0,rs):
        for j in range(0,rs):
            zeta[i][j]=cover[i][j]
    for i in range(0,rs):
        if zeta[i][i]==0:
            zeta[i][i]=1
            
    #One linear extension (based on levels)
    lbhd1=Tkinter.Label(freq,text= "Level ")
    lbhd1.pack()
    
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rs,zeta)
    
    tlev=ScrolledText(freq,width=60,height=4)
    tlev.pack()
    txt1="\n"
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= obj[lobj[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)

    txt2="\n One linear extension \n\n"
    for i in range(0,n):
        if i<n-1:
            txt2+=obj[revlext[i]]+" < "
        else:
            txt2+=obj[revlext[i]]+"\n"
    txt2+="\n"
    txt2+="\n -- end of list -- "
    tlinext=ScrolledText(freq,width=60, height=2)
    tlinext.pack()
    tlinext.insert("end",txt2)
    
    if n>50:
        cover_show()                  #20.1.08
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram ")
        lbhd3.pack()
        cv=Tkinter.Canvas(freq,width=400,height=480)
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(n,n)
        geomy=rmod2.marray(n,n)

        geom0x=10
        geom0y=20
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(320.0/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(320.0/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if cover[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=obj[lobj[i][j]])
        garrow1x=380
        garrow1y=20
        garrow2y=230
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
##        cv.create_line(garrow1x-4,garrow2y-4,garrow1x,garrow2y)
##        cv.create_line(garrow1x+4,garrow2y-4,garrow1x,garrow2y)
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        
        cv.pack()
        buttcover=Tkinter.Button(freq,text="show cover relation",command=cover_show1)
        buttcover.pack()

def cover_show1():
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: -
    hfcover=Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    
    lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,n):
        txt3+="\n"+obj[i]+":\t"
        txt3+="is covered by "
        for j in range(0,n):
            if i!=j:
                if cover[i][j]==1:
                    txt3+=" "+obj[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=4)
    tcov.pack()
    tcov.insert("end",txt3)


def calc():
    """ some infos based on the transitive closure """
    #Brg *: 25.6.08
    #Brg, akt: 26.6.08
    #Brg, 25.6.08
    global sigma,zzeta
    zzeta=rmod2.warshall(r,cover)
    pred=rmod2.vecgen1(r)
    succ=rmod2.vecgen1(r)
    for i in range(0,r):
        for j in range(0,r):
            if zzeta[i][j]==1:
                pred[i]+=1
    for i in range(0,r):
        for j in range(0,r):
            if zzeta[j][i]==1:
                succ[i]+=1
    tc=Tkinter.Toplevel(hf)
    tc.title(' some calculations ' )
    lb1=Tkinter.Label(tc,text="structural info ", bg="yellow")
    lb1.pack()
    struc=ScrolledText(tc,width=60,height=10)
    struc.pack()
    txt="Structural information "
    txt+="\nobject\tpredec\tsuccesst\tincomparab"
    txt+="\n"+60*"--"+"\n"
    for i in range(0,r):
        txt+=obj[i]+": "
        txt+="\t"+str(pred[i]-1)+"\t"+str(succ[i]-1)+"\t"+str(r+1-(succ[i]+\
                                                pred[i]))+"\n"
            
    txt+=" e n d   o f  f i l e   "
    struc.insert("end",txt)
    
    #print "predecessors ",pred
    #print "successors   ",succ
    
    lb2=Tkinter.Label(tc,text="LPOM 0th order",bg="yellow")
    lb2.pack(pady=3)
    lpom=ScrolledText(tc,width=60,height=10)
    lpom.pack()
    txt="LPOM 0th order\n"
    txt+="objects\tRkav(LPOM)"
    txt+="\n"+60*"--"+"\n"
    rkav=rmod2.vecgen1(r)
    for i in range(0,r):
        txt+=obj[i]+":  "
        rkav[i]=(1.0*succ[i]*(r+1.0))/(succ[i]+pred[i])
        txt+="\t"+str(round(rkav[i],2))+"\n"
    txt+="\n  e n d  o f  f i l e  "    
    lpom.insert("end",txt)

    #towards Bubley Dyer Algorithm
    
    nstart,traceback=rmod2.raisort(r,rkav)
    sigma=rmod2.vecgen1(r)#this and the next 3 lines from mainHD7
    for i in range(0,r):
        sigma[i]=traceback[i]
    lb3=Tkinter.Label(tc,text= "starter for Bubley Dyer ",bg="yellow")
    lb3.pack()
    starter=ScrolledText(tc,width=60,height=4)
    starter.pack()
    txt=" Bubley-Dyer-Starter "
    txt+="\n"+60*"--"+"\n"
    for i in range (0,r):
        if i <r-1:
            txt+=obj[sigma[i]]+"<"
        else:
            txt+=obj[sigma[i]]
    txt+="\n   e n d  o f  f i l e   "
    starter.insert("end",txt)
    # logic: enable the button  Bubley Dyer
    buttBD.config(state="active")
    
def calc2():
    """ some infos based on the transitive closure """
    #Brg *: 25.6.08
    #Brg, akt: 13.10.08
    #Brg, 25.6.08
    #Brg, note: partially copied from calc
    global sigma,zzeta
    zzeta=rmod2.warshall(r,cover)
    pred=rmod2.vecgen1(r)
    succ=rmod2.vecgen1(r)
    for i in range(0,r):
        for j in range(0,r):
            if zzeta[i][j]==1:
                pred[i]+=1
    for i in range(0,r):
        for j in range(0,r):
            if zzeta[j][i]==1:
                succ[i]+=1
    tc2=Tkinter.Toplevel(hf)
    tc2.title(' mutual probabilities ' )
    lbtc2=Tkinter.Label(tc2,text="mutual probabilities (LPOM) and after De Loof", width=60)
    lbtc2.pack()
    tc2txt=ScrolledText(tc2, width=60, height=5)
    tc2txt.pack()   
    mut=rmod2.marray(r,r)
    for i in range(0,r):
        for j in range(0,r):
            if i==j:
                mut[i][j]=1.0
            else:    
                if zzeta[i][j]==1 and zzeta[j][i]==0:
                    mut[i][j]=1
                if zzeta[i][j]==0 and zzeta[j][i]==1:
                    mut[i][j]=0   #Baustelle
                if zzeta[i][j]==0 and zzeta[j][i]==0:
                    qi=(1.0*pred[i]+1.0)/(1.0*succ[i]+1.0)
                    qj=(1.0*pred[j]+1.0)/(1.0*succ[j]+1.0)
                    mut[i][j]=1.0*qi/(qi+qj)

    mutit=rmod2.marray(r,r)
    
    mutit,c0=rmod2.loof(r,10,zzeta)

    txt1=" Mutual probability  "
    txt1+="\n in successors of x are included those which also"
    txt1+="\n successors of y "
    txt1+="\n"
    txt2="LPOM\n\t"
    for i in range(0,r):
        txt2+=str(i+1)+"\t"
    txt2+="\n"    
    for i in range(0,r):
        txt2+=4*r*"-"

    for i in range(0,r):
        txt2+="\n"+str(i+1)+":\t"
        for j in range(0,r):
            txt2+=str(round(mut[i][j],2))+"\t"
            
    txt3="\n\nDeLoof (10 iterations)\n\t"
    for i in range(0,r):
        txt3+=str(i+1)+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=4*r*"-"    
    for i in range(0,r):
        txt3+="\n"+str(i+1)+":\t"
        for j in range(0,r):
            txt3+=str(round(mutit[i][j],2))+"\t"
    
    txtges=txt1+txt2+txt3
    tc2txt.insert("end",txtges)
         
    
            
    
        
    
    

hf=Tkinter.Tk()
hf.title("      cover--> HD: vs June,26th         ")
helpcov=raioop2.brgabout(hf,"tp1","help_cov.txt",4,\
            "Oct. 13th,2008"," help_cov ", "white", "t1",80,5,ScrolledText)
    
fr=Tkinter.Frame(hf,width=400,height=400)
fr.pack()
lbinfo=Tkinter.Label(fr,text="Author: R.Bruggemann, vs of 26.6.08", width=70)
lbinfo.pack(pady=10)
buttabout=Tkinter.Button(fr,text="about",bg="green",width=25,command=about)
buttabout.pack()
frinput1=Tkinter.Frame(fr,width=100,height=10)
frinput1.pack()

butt1=Tkinter.Button(fr,text="(1a) select and open cover-file ",bg="white",width=25,command=fileopen)
butt1.pack(pady=5)
lbopen1=Tkinter.Label(fr,text="")
lbopen1.pack()

frin=Tkinter.Frame(fr) #Pay attention: frin uses the grid manager!!!
frin.pack()
frin2=Tkinter.Frame(frin,relief="sunken",bd=4)
frin2.grid(row=0,column=0)
enobj=Tkinter.Entry(frin2,width=3)
enobj.pack(side="left")
buttnobj=Tkinter.Button(frin2,text="(1b1) how many objects ",bg="white",command=hmo)
buttnobj.pack(side="left")

buttcovin=Tkinter.Button(fr,text="(1b2) read from user interface",state="disabled",bg="white",width=25,command=direct_readin)
buttcovin.pack(pady=5)
    
buttshow=Tkinter.Button(fr,text="show data matrix",bg="cyan",width=25,command=showDM)
buttshow.pack()

buttHD=Tkinter.Button(hf,text=" (2) HD from cover matrix ",width=25, bd=4, bg="cyan",command=HD)
buttHD.pack(pady=15)
buttcovshow=Tkinter.Button(hf,text="show cover rel",width=25,command=cover_show1)
buttcovshow.pack(pady=5)

buttcalc=Tkinter.Button(hf,text="(3) Some calculations ",bg="cyan",command=calc)
buttcalc.pack()
buttcalc2=Tkinter.Button(hf,text="(3) Mutual probabilities ",bg="cyan",command=calc2)
buttcalc2.pack()
frBD=Tkinter.Frame(hf,width=60,height=3)
frBD.pack()
lbBD=Tkinter.Label(frBD,text=">>>number of MC-simulations > (no of obj power 4) >>>")
lbBD.pack(side="left")
zahlMC=Tkinter.Entry(frBD,width=10)
zahlMC.pack(side="left")
frBD1=Tkinter.Frame(hf,width=60,height=3)
frBD1.pack()
lbBD1=Tkinter.Label(frBD1,text=">>>after how many MCs a LE shall be selected>>")
lbBD1.pack(side="left")
u_sampl=Tkinter.Entry(frBD1,width=10)
u_sampl.pack(side="left")
buttBD=Tkinter.Button(hf,text="(5) Rkav_MC-sim",state="disabled",bg="cyan",width=15,command=Bubley_Dyer_rkav)
buttBD.pack()

buttexit=Tkinter.Button(hf,text=" exit ",bg="red", bd=4, width=25,command=hf.destroy)
buttexit.pack(pady=20)
hf.mainloop()
