# -*- coding: cp1252 -*-
import math
import Tkinter
import tkFileDialog
from ScrolledText import *
import Canvas
import rmod2
import raioop2
#import pylab

# Brg 27.6.09 on the basis of sensi11.py
# from http://snippets.dzone.com/posts/show/753
# central recursive routine to get from an object set all permutations
# by enrich all permutations are retained which are consistent with the zeta matrix
# name of module: genlinext (gen erate lin ear ext ensions)
# 16.10.09 some minor changes
# 31.1.2013 genlinext1 is the basis for crf

def about():
    """ About sensi """
    # Brg 27.6.09, 31.1.2013
    aboutsensi=raioop2.brgabout(hf,"tp2","about_crf.txt",1,\
            "January 31th,2013"," about_crf ", "white", "t2",120,5,ScrolledText)
    

def raihelp():
    """ Help about sensi """
    
    #  Use of OOP
    helpsensi=raioop2.brgabout(hf,"tp1","help_crf.txt",1,\
            "January, the 31th,2013"," help_crf ", "white", "t1",120,10,ScrolledText)

def File_select():
    """select a file and open it """
    #Brg 17.1.08
    #*:17.1.08
    #akt: 17.1.08
    global dm,ob,obj,pro,prop,r,k,fn
    fn=tkFileDialog.askopenfilename()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    lbopen.config(bg="yellow")
    lbopen["text"]="File "+fn+"\n opened with "+str(r)+" rows \n and "\
                         +str(k) +" columns"
    lbopen.pack()

    obj=rmod2.vecgentext1(r)                        #29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  #recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pro[i+1]   #recoding, because pro[0] is a dummy string
    return 

def File_select_PyHasse():
    """ File selection of transformed data matrices
    through other PyHasse programs """
    #* 1.6.09
    # akt. 1.2.2013 (taken from sensitivity19_1
    # source: sensitivity19_1
    # 1.2.2013 deactiviert
    global fn,r,k,dm,pro0,prop, on,ob,obj,xred,rred,objred,txt,n
    fn=tkFileDialog.askopenfilename()
    r,k,dm,obj,prop=rmod2.raireadin5(fn)
    print "r= ",r
    print "k= ",k
    rmod2.matout(r,k,dm)
    print "obj= ",obj
    print "prop= ",prop
    pro0=rmod2.vecgentext1(k)
    pro0[0]="prop"              #this 3 lines construction needed because attsel needs pro0
    for j in range(1,k):
        pro0[j]=prop[j-1]
    #print "in mainHD = : r= ",r,"  k= ",k0
    ob=rmod2.vecgentext1(r+1) #this 3 lines construction needed because filecomp needs ob
    ob[0]="dummy"
    for i in range(1,r+1):
        ob[i]=obj[i-1]
    
    lbopen.config(bg="yellow")
    lbopen["text"]="selected file (PyHasse format) : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns"
    rred,xred,objred,txt=rmod2.equivcompact(r,k,dm,obj)
    n=rred
    return 





def showDM():
    """shows the DM"""
    # taken from fuzzyHD7
    tp2a=Tkinter.Toplevel(hf)
    tp2a.title(' show DM ')
    lbtp2=Tkinter.Label(tp2a,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2a,width=60,height=4)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)    




def all_perms(str):
    # from http://snippets.dzone.com/posts/show/753
    # From Michael Davies's recipe.
    if len(str) <=1:
        yield str
    else:
        for perm in all_perms(str[1:]):
            for i in range(len(perm)+1):
                yield perm[:i] + str[0:1] + perm[i:]


def filecomp(r,dm,pro,fn):
    """ reduces a dm with equiv objects to a dm of a quotient set """
    # Brg 12.12.07, 13.1.08, 8.5.08
    #r,k,dm,ob,pro,fn are globals and should be available after open
    
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    #recoding ob to obj and pro to prop
    if r==0:
        hfwarning=Tkinter.Toplevel(hf)
        hfwarning.title(' ++warning++ ')
        frwarning=Tkinter.Frame(hfwarning,width=10,height=3)
        frwarning.pack()
        bwarning=Tkinter.Button(frwarning,text="++warning ++",command=msgwarning)
        bwarning.pack()
        
    prop=rmod2.vecgentext1(k)
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
    for i in range(0,k):
        prop[i]=pro[i+1]
    for i in range(0,r):
        obj[i]=ob[i+1]
    #############################dieser Teil ist neu 21.12.07
    rred,xred,objred,txt=rmod2.equivcompact(r,k,dm,obj)    
    ###############################################################
    #print objred
    #print "reduzierte matrix"
    #rmod2.matout(rred,k,xred)
    return rred,xred,objred,obj,prop,txt           


def HD():
    "based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"
    # Brg 20.12.07, 28.12.07
    # If the number of representants > 20 then only the cover-matrix and the level-population
    # This module I took from mainHD5
    # 8.6.08 
    global zeta,zeta2,rred,n,objred    
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    global fn
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    rred,xred,objred,obj,prop,txt=filecomp(r,dm,pro,fn)
    n=rred
    labeq=Tkinter.Label(freq,text="file = "+fn+": calc. is based on representants ")
    labeq.config(bg="yellow")
    labeq.pack()

    #
    zetahilf=rmod2.comp(n,k,xred)
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    lbhd1=Tkinter.Label(freq,text= "Level ")
    lbhd1.pack()

    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(n,zeta)
    #print "zzmax = ",zzmax
    tlev=ScrolledText(freq,width=60,height=4)
    tlev.pack()
    txt1="\n"
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= objred[lobj[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)

    txt2="\n One linear extension \n\n"
    for i in range(0,n):
        if i<n-1:
            txt2+=objred[revlext[i]]+" < "
        else:
            txt2+=objred[revlext[i]]+"\n"
    txt2+="\n"
    txt2+="\n -- end of list -- "
    tlinext=ScrolledText(freq,width=60, height=2)
    tlinext.pack()
    tlinext.insert("end",txt2)

        
    #Adj-Listen

    adjc=rmod2.adjacent(n,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(n,adjc,lext)
       
    
    zeta2=rmod2.cover(n,tr,lext)
    if n>25:
        cover_show()                  #20.1.08
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram of File "+fn)
        lbhd3.pack()
        cv=Tkinter.Canvas(freq,width=300,height=200,bg="white")
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(n,n)
        geomy=rmod2.marray(n,n)

        geom0x=10
        geom0y=20
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(160.0/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(160.0/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if zeta2[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        garrow1x=210
        garrow1y=20
        garrow2y=190
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
##        cv.create_line(garrow1x-4,garrow2y-4,garrow1x,garrow2y)
##        cv.create_line(garrow1x+4,garrow2y-4,garrow1x,garrow2y)
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.pack()
        buttcover=Tkinter.Button(freq,text="show cover relation",command=cover_show)
        buttcover.pack()

def cover_show():
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: -
    hfcover=Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    
    lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,n):
        txt3+="\n"+objred[i]+":\t"
        txt3+="is cover_less than "
        for j in range(0,n):
            if i!=j:
                if zeta2[i][j]==1:
                    txt3+=" "+objred[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)



def calc():
    """ generates linear extensions and derived quantities """
    # Brg  27.6.09
    # based mainly of a recursive permutation algorithm
    # which I got from Internet.
    global rkfreq,e_obj
    tplin=Tkinter.Toplevel(hf)
    tplin.title(' linear extensions ')
    freq=Tkinter.Frame(tplin, width=80, height=100)
    freq.pack()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    rred,xred,objred,obj,prop,txt=filecomp(r,dm,pro,fn)
    n=rred
    labeq=Tkinter.Label(freq,text="file = "+fn+": calc. is based on representants ")
    labeq.config(bg="yellow")
    labeq.pack()

    #
    zetahilf=rmod2.comp(n,k,xred)
    
    # use of recursive permutation all_perms and filter the sonsistent ones
    # with enrich from rmod2
    hav=rmod2.vecgen1(n)
    rkfreq=rmod2.marray(n,n)
    txthilf=""
    for i in range(0,n):
        txthilf+=objred[i]+", "
        
    #print "objred  ",objred
    lt=0
    for p in all_perms(obj):
        pnr=rmod2.vecgen1(n)
        for i in range(0,n):
            pnr[i]=obj.index(p[i])
        flag=rmod2.enrich(pnr,zetahilf,n)
        if flag==1:
            #print p
            for ob in objred:
                Hob=p.index(ob)
                #print "Hob = ",Hob,"  ob ",ob,"  index ob  ",objred.index(ob)
                rkfreq[objred.index(ob)][n-1-Hob]+=1
                        
            lt+=1
            
    #print "LT = ",lt
    #rmod2.matout(n,n,rkfreq)
    for i in range(0,n):
        for j in range(0,n):
            rkfreq[i][j]=1.0*rkfreq[i][j]/(1.0*lt)
    #rmod2.matout(n,n,rkfreq)
    for i in range(0,n):
        hav[i]=0
        for j in range(1,n+1):
            hav[i]+=1.0*j*rkfreq[i][j-1]
        #print "obj ",objred[i],"  hav = ", hav[i]         

    #number of incomparabilities
    U=0
    for i in range(0,n):
        for j in range(0,n):
            if zetahilf[i][j]==0 and zetahilf[j][i]==0:
                U+=1
    U=1.0*U/2.0            

    tlinext=ScrolledText(freq,width=80, height=40)
    tlinext.pack()
    txtlin="       Linear extensions    \n"
    txtlin+=50*"="+"\n"
    txtlin+=fn+"\n"
    txtlin+="objects :"+txthilf+"\n"
    txtlin+=" Number of linear extensions:"+"\t\t"+str(lt)+"\n"
    txtlin+=" Number of objects in quotient set: "+"\t"+str(n)+"\n"
    txtlin+=" Number of incomparabilities :"+"\t\t"+str(U)+"\n\n"
    txtlin+=" height frequency matrix \n"
    txthilf2="\t"
    for i in range(0,n):
        txthilf2+=str(i+1)+"\t"
    txtlin+=txthilf2+"\n"
    for i in range(0,n):
        txtlin+=objred[i]+": "+"\t"
        for j in range(0,n):
            txtlin+=str(round(rkfreq[i][j],2))+"\t"
        txtlin+="\n"
    txtlin+="\n"+" averaged heights "
    for i in range(0,n):
        txtlin+="\n"+objred[i]+"\t"+str(round(hav[i],3))
    txtlin+="\n"
    txtlin+="\n"+50*"="
    tlinext.insert("end",txtlin)
    lbinput=Tkinter.Label(freq,text="object name for rank frequency plot   >>> ",font=("Arial",14,"bold"))
    lbinput.pack(side="left")
    e_obj=Tkinter.Entry(freq,width=5)
    e_obj.pack(side="left")
    
    
def crf():
    # brg 31.1.2013
    global rred2, xred2,objred2
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    rred,xred,objred,obj,prop,txt=filecomp(r,dm,pro,fn)
    n=rred
    dmsum=rmod2.marray(rred,rred)
    for i in range(0,rred):
        for j in range(0,rred):
            for k in range(0,j):
                dmsum[i][j]+=rkfreq[i][k]
                
    rmod2.matout(rred,rred,dmsum)
    dmsumrev=rmod2.marray(rred,rred)
    for i in range(0,rred):
        for j in range(0,rred):
            dmsumrev[i][j]=1.0-dmsum[i][j]
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    rred2,xred2,objred2,elist2,eqmact=rmod2.equivcompactgr(rred,rred,dmsumrev,objred)
    
    labeq=Tkinter.Label(freq,text="file = "+fn+": calc. is based on representants ")
    labeq.config(bg="yellow")
    labeq.pack()
    tpeq=Tkinter.Toplevel(freq)
    tpeq.title(' equivalnces in CRF-step ')
    teq=ScrolledText(tpeq,width=60,height=10)
    teq.pack()
    teq.insert("end",elist2)
    #
    zetahilf2=rmod2.comp(rred2,rred2,xred2)
    zeta2=rmod2.marray(rred2,rred2)
    for i in range(0,rred2):
        for j in range(0,rred2):
            zeta2[i][j]=zetahilf2[j][i]
        
    lobj2,lext2,revlext2,zzmax2=rmod2.levtopsort(rred2,zeta2)
            
    #Adj-Listen

    adjc=rmod2.adjacent(rred2,lext2,revlext2,zeta2)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred2,adjc,lext2)
       
    
    cov2=rmod2.cover(rred2,tr,lext2)
    if n>15:
        cover_show()                  #20.1.08
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram of File "+fn)
        lbhd3.pack()
        cv2=Tkinter.Canvas(freq,width=300,height=200,bg="white")
        lz=zzmax2
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj2[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(rred2,rred2)
        geomy=rmod2.marray(rred2,rred2)

        geom0x=10
        geom0y=20
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(160.0/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(160.0/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if cov2[lobj2[i1][j1]][lobj2[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv2.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv2.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv2.create_text(geomx[i][j],geomy[i][j],text=objred2[lobj2[i][j]])
        garrow1x=210
        garrow1y=20
        garrow2y=190
        cv2.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")

        cv2.create_text(garrow1x+8,garrow1y-6,text="high")
        cv2.create_text(garrow1x+8,garrow2y+6,text="low")
        cv2.pack()
##        buttcover=Tkinter.Button(freq,text="show cover relation",command=cover_show)
##        buttcover.pack()




def rkgraph():
    #brg  27.6.09
    ob=e_obj.get()
    iob=objred.index(ob)
    h=rmod2.vecgen1(n)
    names=rmod2.vecgentext1(5)#16.10.09  n as argument replaced by 5
    for i in range(0,n):
        h[i]=rkfreq[iob][i]
    names[0]="ranks"
    names[1]="prob"
    names[2]="plot object: "+ob
    names[3]=""
    names[4]="rk-freq"
    ### Baustelle 31.1.2013 ###
    app1=raioop2.brggraph5(hf,names,"red",2,h,1,n)
    app1.ausgabe()
    

def sf():
    #brg  1.2.2013, taken from palg4_2.py, modified 1.2.2013
    fn=tkFileDialog.asksaveasfilename(parent=hf,title="save file")
    # brg  30.5.09
    rank2=[]
    for i in range(0,rred2):
        rank2.append(str(i))
    rmod2.raiwrite5(fn,xred2,objred2,rank2,rred2,rred2)
    lbsuccess.config(text="matrix with \n"+str(rred2)+"  rows  and "+str(rred2)+"\n  columns stored",bg="yellow")



    
hf=Tkinter.Tk()
hf.title('generates linear extensions')
about()
raihelp()
lbhallo=Tkinter.Label(hf,text="",width=60)
lbhallo.pack()
fropen=Tkinter.Frame(hf,width=60,height=40,relief="sunken",bd=2)
fropen.pack()
lbopen=Tkinter.Label(fropen,text="")
lbopen.pack()
lbfileselect1=Tkinter.Label(fropen,text=">>>select and open (Excel-derived) file>>>")
lbfileselect1.pack(side="left",pady=25)
buttfileselect=Tkinter.Button(fropen,text="sel. and open (Excel-derived) file",width=25, bg="white",command=File_select)
buttfileselect.pack(side="left",pady=10)
##fropen2=Tkinter.Frame(hf,width=60,height=40,relief="sunken",bd=2)
##fropen2.pack()
##lbfileselect2=Tkinter.Label(fropen2,text=">>>select and open CRF-matrix of iter...>>>")
##lbfileselect2.pack(side="left",pady=25)
##buttfileselect2=Tkinter.Button(fropen2,text="select and open CRF-matrix",width=25, bg="white",command=File_select_PyHasse)
##buttfileselect2.pack(side="left",pady=10)
frshow=Tkinter.Frame(hf,width=60,height=4,relief="sunken",bd=2)
frshow.pack(fill="x")
buttshow=Tkinter.Button(frshow,text="show data matrix ",width=25,command=showDM)
buttshow.pack(pady=5)
buttHD=Tkinter.Button(frshow,text="show  HD ",width=25,command=HD)
buttHD.pack(pady=10)
frcalc=Tkinter.Frame(hf,relief="sunken",bd=2)
frcalc.pack()
lbcalc=Tkinter.Label(frcalc, text="calculate lin. extensions ")
lbcalc.pack()
buttcalc=Tkinter.Button(frcalc,text="(1) calc. linext",bg="cyan",width=25,command=calc)
buttcalc.pack(pady=25)
buttcrf=Tkinter.Button(frcalc,text="Cumulative rank frequencies ",bg="cyan",command=crf)
buttcrf.pack(pady=5)                       
buttgraph=Tkinter.Button(frcalc, text="(2) rank frequency plot ",bg="cyan",width=25,command=rkgraph)
buttgraph.pack()
froptional=Tkinter.Frame(hf,relief="sunken",bd=2)
froptional.pack(pady=5)
##buttstore=Tkinter.Button(hf,text="Save CRF-matrix ",bg="cyan",width=30,command=sf)
##buttstore.pack()
##lbsuccess=Tkinter.Label(hf, text="")
##lbsuccess.pack()
buttexit=Tkinter.Button(hf,text="  Exit  ",bg="red",width=25,command=hf.destroy)
buttexit.pack(pady=30)




























hf.mainloop()
