import csv
import tkFileDialog
import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import raioop2
from math import *
#


# brg 26.7.2013
# CSV-readin using professional routines of csv-library
# HDsimpl specifically for CSV-files (CSV-separated by ";")
# 28.7.2013: "," in numbers in "." in numbers
# 29.7.2013 cosmetics
# 29.8.2013 enabling to read data files stored in different formats
# 22.3.2014 cover-relation
# 8.9.2014 precision when checking the equivalence classes (equivcompactm2)
# 8.9.2014: output equivalence classes
# 9.9.2014 interface: graphviz
# 30.03.17 Rearrangement for a new dds16.p<


###### editfenster ### 29.8.2013 #####
def xsave_in_PyHasseformat():
    # brg 26.7.2013
    # 6.8.2013: taken from csvHDsimpl1.py, 27.8.2013
    global r,k,x
    la=r+1
    ls=k+1
    
    xext=rmod2.marray(la,ls)
    for i in range(0,la):
        for j in range(0,ls):
            if i==0 and j==0:
                xext[i][j]="dummy"
            elif j==0 and i>0:
                xext[i][j]=obj[i-1]
            elif j>0 and i==0:
                xext[i][j]=prop[j-1]
            else:
                xext[i][j]=x[i-1][j-1]


    print " xext-matrix "
    for i in range(0,la):
        for j in range(0,ls):
            print xext[i][j]," ",
        print " "
    print "  "    
    fnnew=tkFileDialog.asksaveasfilename(parent=hf,title="save orig dm in PyHasseformat")
    fcsv=open(fnnew,"w")
    for i in range(0,la):
        for j in range(0,ls):
            fcsv.write(str(xext[i][j])+"\t")
        fcsv.write("\n")
    fcsv.close()
   
def xsave_in_PyHasseformat_n():
    # brg 26.7.2013
    # 6.8.2013: taken from csvHDsimpl1.py, 27.8.2013
    global r,k,x
    xn=rmod2.matrixnorm(r,k,x)

    la=r+1
    ls=k+1
    
    xext=rmod2.marray(la,ls)
    for i in range(0,la):
        for j in range(0,ls):
            if i==0 and j==0:
                xext[i][j]="dummy"
            elif j==0 and i>0:
                xext[i][j]=obj[i-1]
            elif j>0 and i==0:
                xext[i][j]=prop[j-1]
            else:
                xext[i][j]=xn[i-1][j-1]


    print " xext-matrix "
    for i in range(0,la):
        for j in range(0,ls):
            print xext[i][j]," ",
        print " "
    print "  "    
    fnnew=tkFileDialog.asksaveasfilename(parent=hf,title="save normalized dm in PyHasseformat")
    fcsv=open(fnnew,"w")
    for i in range(0,la):
        for j in range(0,ls):
            fcsv.write(str(xext[i][j])+"\t")
        fcsv.write("\n")
    fcsv.close()

def xselectfile():
    # brg 6.8.2013
    global fn
    fn=tkFileDialog.askopenfilename()
    print "fn ",fn
    Tpopener=Tkinter.Toplevel(hf)
    Tpopener.title(' Opening window: different formats ')
    fropen2=Tkinter.Frame(Tpopener,bd=3,bg="white")
    fropen2.pack()
    # +++ Grid-Geometry manager +++
    lb0=Tkinter.Label(fropen2,text=" Select the appropriate format: ",bg="yellow",font=("arial",12,"bold"))
    lb0.grid(row=0,column=0)
    lb1=Tkinter.Label(fropen2,text="(1a) Open files, txt, tab (or blank) as delimiter (PyHasse-standard) :                ",bg="white")
    lb1.grid(row=1,column=0)
    lb2=Tkinter.Label(fropen2,text="(1b) Open files, csv, ';' as delimiter (csv with ';') :                               ",bg="white")
    lb2.grid(row=2,column=0)
    lb3=Tkinter.Label(fropen2,text="(1c) Open files, csv, ',' as delimiter (csv with ',') :                               ",bg="white")
    lb3.grid(row=3,column=0)
    lb6=Tkinter.Label(fropen2,text="(1f) Open files, pdt, internal PyHasse-format to exchange interim-results:            ",bg="white") 
    lb6.grid(row=6,column=0)
    butt1=Tkinter.Button(fropen2,text="(1a) Open txt-file       ",bg="cyan",bd=4,command=xfileopen)
    butt1.grid(row=1,column=1)
    butt2=Tkinter.Button(fropen2,text="(1b) Open csv-file (';') ",bg="cyan",bd=4,command=xcsvopenS)
    butt2.grid(row=2,column=1)
    butt3=Tkinter.Button(fropen2,text="(1c) Open csv-file (',') ",bg="cyan",bd=4,command=xcsvopenK)
    butt3.grid(row=3,column=1)
    butt6=Tkinter.Button(fropen2,text="(1f) Open pdt-file       ",bg="cyan",bd=4,command=xopenfilepdt)
    butt6.grid(row=6,column=1)


def xcsvopenS():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,obj,prop,x,xred,rred,objred,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=';', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")
    rred,xred,objred,txteq,eqm_act=rmod2.equivcompactgr(r,k,x,obj)
    print "rred ",rred
    print "Matrix "
    rmod2.matout(r,k,xred)
    print "eq= ",eqm_act
    print "txteq = ", txteq

    

def xcsvopenK():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,x,fn,obj,prop,xred,objred,rred,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=',', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")

    rred,xred,objred,txteq,eqm_act=rmod2.equivcompactgr(r,k,x,obj)   # 8.9.2014
    print "eq= ",eqm_act
    print "txteq = ",txteq





def xfileopen():
    "Informs about the file-operations"
    # Excelreadin4 built in
    # Brg 29.11.07, 30.11.07, 15.1.08,18.2.08
    global fn,r,k,x,prop,obj,rred,xred,objred,txteq, eqm_act
    x,ob,pr,r,k=rmod2.EXCELreadin6(fn)
    print "r = ",r,"   k = ",k
    obj=rmod2.vecgentext1(r)                        # 29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  # recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pr[i+1]   # recoding, because pr[0] is a dummy string
    # rmod2.matout(r,k,x)
    
    lbopen1.config(bg="yellow")    # 18.2.08
    lbopen1["text"]="File "+fn+" was opened with "+str(r)+" rows and "+str(k)+"  columns"
    
    rred,xred,objred,txteq,eqm_act=rmod2.equivcompactgr(r,k,x,obj)   # 8.9.2014
    print "eqm_act= ",eqm_act
    print "txteq = ",txteq


    

def xopenfilepdt():
    """ File selection of transformed data matrices
    through other PyHasse programs """
    # brg 29.10.2012 taken from sensitivity18_3
    #* 1.6.09
    # akt. 29.10.2012 (taken from sensitivity18_3), 6.8.2013
    # source: mainHD19
    global fn,r,k,x,prop,obj,rred,xred,objred,txteq
    
    r,k,x,obj,prop=rmod2.raireadin5(fn)
    lbpdtopen.config(bg="yellow")
    lbpdtopen["text"]="selected file (PyHasse (pdt) format) : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns"

    rred,xred,objred,txteq,eqm_act=rmod2.equivcompactgr(r,k,x,obj)  # new 8.9.2014
    print "neq= ",eqm_act
    print "txteq = ",txteq

##### end of editenster ### 29.8.2013 ####
############################################################################
    

def show_dm(master,datamatrix,list_of_objects,list_of_indicators):
    #brg taken from HDweightMC8_7
    #Brg 13.1.08, 15.1.08, 11.1.2015
    #*: 13.1.08
    #akt: 15.1.08, 30.03.17
    #note: modified from the routine, taken from interval9.py
    # master: label for Toplevel
    # datamatrix: matrix to be displayed
    # list_of_objects: labels of the rows (in general objects)
    # list_of_indicators: labels of the columns of datamatrix, in general the indicators
    master=Tkinter.Toplevel(hf)
    r=len(list_of_objects)
    k=len(list_of_indicators)
    master.title('show DM')
    lbtp2=Tkinter.Label(master,text=" data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(master,width=60,height=20)
    tfile.pack()
    
    txt1="Data matrix\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+list_of_objects[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+list_of_indicators[j]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=list_of_indicators[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,k):
            txt3+=str(datamatrix[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)    

def show_dm_orig():
    #brg 30.03.17
    datamatrix=x
    master="tpshowdm"
    list_of_objects=obj
    list_of_indicators=prop
    show_dm(master,datamatrix,list_of_objects,list_of_indicators)

def HD(master,relatmatrix,list_of_objects):
    # brg 26.7.2013, 29.8.2013, 2.11.16, 30.03.17
    # master: Toplevel
    # relatmatrix: matrix based on representative elements describing the order relations
    # list of objects: labels of representative elements
    
    
    master=Tkinter.Toplevel(hf)
    master.title('Hasse diagram / cover matrix ')
    rred=len(list_of_objects)
    freq=Tkinter.Frame(master,width=200,height=300)
    freq.pack()
    
    Utotal = rmod2.incompzeta(rred,relatmatrix)
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,relatmatrix)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,relatmatrix)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    if rred>400:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram , Utotal =  "+str(Utotal))
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=list_of_objects[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()
        return relatmatrix,cov,Utotal

def HD_orig():
    # brg 30.03.17
    global zetaorig,covorig,Utotalorig
    rred=len(objred)
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #rmod2.matout(rred,rred,zeta)
    master="tporig"
    dmred=xred
    list_of_objects=objred
    zetaorig,covorig,Utotalorig=HD(master,zeta,list_of_objects)

def cover(master, covermatrix, list_of_objects):
    # brg 30.03.17
    # master: label of Toplevel
    # covermatrix: matrix of cover relations
    # list_of_objects: corresponding labels of representative elements
    master= Tkinter.Toplevel(hf)
    master.title(' cover-matrix ')
    lbcov = Tkinter.Label(master,text=" Cover-Relations ")
    lbcov.pack()
    rred=len(list_of_objects)
    
    txt3 = "\n cover-matrix  \n"
    for i in range(0, rred):
        txt3 += "\n" + list_of_objects[i] + ":\t"
        txt3 += "is covered by "
        for j in range(0, rred):
            if i!=j:
                if covermatrix[i][j] == 1:
                    txt3 += " " + list_of_objects[j] + " ,"
                else:
                    pass
            else:
                pass
        txt3 += "\n"    
    txt3 += "\n"
    txt3 += " -- end of list --"
    tcov=ScrolledText(master,width=50, height=40)
    tcov.pack()
    tcov.insert("end",txt3)
    
def cov_orig():
    # brg 30.3.17
    master="tpcovorig"
    list_of_objects=objred
    covermatrix=covorig
    cover(master,covorig,list_of_objects)

def check_equivalence(eqm_act,r):
    # brg 29.03.2017
    # eqm_act : output of filecomp and therein of rmod2-procedure equivcompactgr
    # r: number of objects
    # output: sumeq (>0 then nontrivial eq.classes
    # output txteq info about equivalence classes
    print eqm_act
    txteq_act="Check_equivalences"+"\n"
    sumeq=0
    for i in range(0,r):
        for j in range(0,r):
            sumeq+=eqm_act[i][j]
    sumeq=sumeq-r
    if sumeq!=0:
        txteq_act+=txteq
    else:
        txteq_act+="no nontrivial eq.classes"
    return sumeq, txteq_act
    

def showeq(master,filename,txtequivalence,eqm,list_of_objects):
    #brg 30.03.17
    # master: label of Toplevel
    # filename : filename of original data matrix
    # txtequivalence: text including the information about
    #........equivalence classes
    # eqm output of filecomp: relational-matrix of equivalences
    # list_of_objects: those objects for which the equivalence is to be tested
    master = Tkinter.Toplevel(hf)
    master.title(" equivalence classes ")
    tequiv=ScrolledText(master,width=60, height=20)
    tequiv.pack()
    txteq2="Equivalence classes"+"\n"
    txteq2+=50*"="+"\n"
    txteq2+="File: "+str(fn) +"\n"
    seq,txteqch=check_equivalence(eqm,len(list_of_objects))
    if seq==0:
        txteq2+="No nontrivial equivalence classes "
    else:    
        txteq2+="equivalence classes: "+txteqch
    txteq2+="\n"
    txteq2+="- - - e o f - - -"
    tequiv.insert("end",txteq2)

def showeq_orig():
    # brg 30.03.17
    master="tpeqorig"
    filename=fn
    txtequivalence=txteq
    showeq(master, filename, txtequivalence, eqm_act, obj)

def dds():
    # brg 30.03.17
    # opens a new window to keep the format small enough for laptops
    global elim, lbalpha, lbextract,eacut
    tpdomdomsep=Tkinter.Toplevel(hf)
    frdds=Tkinter.Frame(tpdomdomsep,width=60,height=100,bd=4)
    frdds.pack()
    lbdds1=Tkinter.Label(frdds,text="   Dom-Dom-Sep-window      ", font=("arial",14))
    lbdds1.pack()
    butt1=Tkinter.Button(frdds,text="   (7) Select the filenname of the classes ",width=50,bg="cyan",command=readin)
    butt1.pack()
    frdds2=Tkinter.Frame(tpdomdomsep,width=60,height=100,bg="white",bd=4)
    frdds2.pack()
    buttanalysis=Tkinter.Button(frdds2,text=" (8repr)  analysis based on \nrepresentative elements of data matrix  (analysis_repr)   ",
                                width=50,bg="cyan",command=analysis)
    buttanalysis.pack(side="left")
    buttanalysiseq=Tkinter.Button(frdds2,text=" (8eq) analysis based on all\n objects of the data matrix (analysis_eq)            ",
                                  width=50,bg="cyan",command=analysiseq)
    buttanalysiseq.pack(side="right")
    frdds2a=Tkinter.Frame(tpdomdomsep,width=60,height=100,bg="white",bd=4)
    frdds2a.pack()
    butthistogram=Tkinter.Button(frdds2a,text=" (9repr) Histogram_repr.     ",width=50, bg="cyan",command=histogram_repr)
    butthistogram.pack(side="left")
    butthistogrameq=Tkinter.Button(frdds2a,text=" (9eq) Histogram_eq     ",width=50, bg="cyan",command=histogram_eq)
    butthistogrameq.pack(side="right")
    frdds4=Tkinter.Frame(tpdomdomsep,width=60,height=100,bg="white",bd=4)
    frdds4.pack()
    lbdds3=Tkinter.Label(frdds4, text="(10opt) Enter limiting value (reldom > limit ==> graphdom = 1, else 0 ")
    lbdds3.pack()
    frdds5=Tkinter.Frame(tpdomdomsep,width=60,height=100,bg="white",bd=4)
    frdds5.pack()
    elim=Tkinter.Entry(frdds5,width=3)
    elim.pack()
    frdds6=Tkinter.Frame(tpdomdomsep,width=60,height=100,bg="white",bd=4)
    frdds6.pack()
    buttgraph1=Tkinter.Button(frdds6,text="(11repr) Generate a graph_repr ",width=50,bg="cyan",command=graph_repr)
    buttgraph1.pack(side="left")
    buttgraph2=Tkinter.Button(frdds6,text="(11eq) Generate a graph_eq ",width=50,bg="cyan",command=graph_eq)
    buttgraph2.pack(side="left")
    frdds7=Tkinter.Frame(tpdomdomsep,width=60,height=100,bg="white",bd=4)
    frdds7.pack()
    buttHDclassrepr=Tkinter.Button(frdds7,text="(12repr) HD of classes (repr) ",width=50,bg="cyan",command = HDclass_repr)
    buttHDclassrepr.pack(side="left")
    buttHDclasseq=Tkinter.Button(frdds7,text="(12eq) HD of classes (all)",width=50,bg="cyan",command = HDclass_eq)
    buttHDclasseq.pack(side="right")
    frdds8=Tkinter.Frame(tpdomdomsep,width=60,bg="white",bd=4)
    frdds8.pack()
    frdds9=Tkinter.Frame(tpdomdomsep,width=60,height=100,bg="white",bd=4)
    frdds9.pack()
    buttTrhull=Tkinter.Button(frdds9,text="(13) Transitive hull of reldom (result of step (8repr) ",bg="cyan",width=50,command=Trhull)
    buttTrhull.pack()
    lbdds4=Tkinter.Label(frdds9,text="Enter the alpha-cut ")
    lbdds4.pack()
    eacut=Tkinter.Entry(frdds9,width=5)
    eacut.pack()
    butt_towardsHDTrhull=Tkinter.Button(frdds9,text= "(14) Calculation of a 'forced' HD ",bg="cyan",width=50,command=towardsmcHD)
    butt_towardsHDTrhull.pack()
    lbalpha=Tkinter.Label(frdds9,text="")
    lbalpha.pack()
    lbextract=Tkinter.Label(frdds9,text="")
    lbextract.pack()
    #butt_details = Tkinter.Button(frdds9,text="(15opt) Some details of the forced construction of a HD ",bg="cyan",width=50,command=detailsdefuzz)
    #butt_details.pack()
    buttexit2 = Tkinter.Button(frdds9, text='(16) exit', bg='red',
                          width=30, command=hf.destroy)
    buttexit2.pack(pady=3)
                                
def HDclass_repr():
    #brg 30.03.17
    global zetaclasses,covclasses,Utotalclasses
    rred3=len(objred3)
    master="tpHDclasses_repr"
    list_of_objects=objred3
    print "in HDclass_repr objred3 ",objred3
    graphdom_tr=rmod2.marray(noc,noc)
    #transposition
    for i1 in range(0,noc):
        for i2 in range(0,noc):
            graphdom_tr[i1][i2]=graphdom[i2][i1]
    zeta_cl_repr,cov_cl_repr,Utotal_cl_repr=HD(master,graphdom_tr,objred3)
    cover("tp_classes_repr",cov_cl_repr,objred3)

def HDclass_eq():
    #brg 30.03.17
        #brg 30.03.17
    global zetaclasses,covclasses,Utotalclasses
    rred3=len(objred3)
    master="tpHDclasses_eq"
    list_of_objects=objred3
    print "In HDclass_eq   objred3 ",objred3
    print "graphdom = ",graphdom
    graphdom_tr=rmod2.marray(noc,noc)
    #transposition
    for i1 in range(0,noc):
        for i2 in range(0,noc):
            graphdom_tr[i1][i2]=graphdom[i2][i1]
    zeta_cl_eq,cov_cl_eq,Utotal_cl_eq=HD(master,graphdom_tr,objred3)
    cover("tp_classes_eq",cov_cl_eq,objred3)

def readin():
    # brg 9.7.2015, 30.03.2017
    global fn2, ra, noc
    fn2=tkFileDialog.askopenfilename()
    noc,ra=readin_subsets(fn2)   #noc: number of classes (replaces "hfs")
    
def readin_subsets(fn2):
    """ hfs entries are opened to read in hfs strings """
    #brg  8.7.2015
    global noc, ra
    f=open(fn2,'r')
    s=f.readline()
    noc=int(s)
    ra = []
    print "noc= ",noc
    for i in range(0,noc):
        x=f.readline()
        ra.append(x.split(","))
    f.close()
    #print "in readin subsets: ra= ",ra
    # purification of the class readin
    for i1 in range(0,noc):
        for i2 in range(0,len(ra[i1])):
            for i3 in range(0, len(objred)):
                if ra[i1][i2]== objred[i3] or ra[i1][i2]==str(objred[i3])+"\n":
                    ra[i1][i2]=objred[i3]
    return noc,ra
    
def analysis():
    """the core of dds8.py
    based on object subsets the
    dominance and separability matrix
    will be calculated"""
    #Brg  31.12.07, 14.1.08, 30.03.17
    #class input control
    flagwarn1=0                
    for i1 in range(0,noc):
        for i2 in range(0,len(ra[i1])):
            if ra[i1][i2] not in objred:
                flagwarn1+=1
    if flagwarn1>0:
        tpwarn1=Tkinter.Toplevel(hf)
        lbwarn1=Tkinter.Label(tpwarn1,text="+++ Please control the classes+++ of ..."+str(fn2),bg="yellow")
        lbwarn1.pack()
    #print "ra purified ",ra            
    #that is the central part: based on rai the dominance and separability degree
    rred=len(objred)
    print "zetaorig = "
    rmod2.matout(rred,rred,zetaorig)
    zetaorig_tr=rmod2.marray(rred,rred)
    #transposition
    for i1 in range(0,rred):
        for i2 in range(0,rred):
            zetaorig_tr[i1][i2]=zetaorig[i2][i1]
    dom=rmod2.marray(noc,noc)
    sep=rmod2.marray(noc,noc)
    for i1 in range(0,noc):
        for i2 in range(0,len(ra[i1])):
            for i3 in range(0,noc):
                for i4 in range(0,len(ra[i3])):
                    if zetaorig_tr[objred.index(ra[i1][i2])][objred.index(ra[i3][i4])]==1:
                        dom[i1][i3]+=1
    
    for i1 in range(0,noc):
        for i2 in range(0,len(ra[i1])):
            for i3 in range(0,noc):
                for i4 in range(0,len(ra[i3])):
                    if zetaorig[objred.index(ra[i1][i2])][objred.index(ra[i3][i4])]==0 and \
                       zetaorig[objred.index(ra[i3][i4])][objred.index(ra[i1][i2])]==0:
                        sep[i1][i3]+=1            

    
    txt1=" A n a l y s is  : Only representants "+"\n"
    txt1+=" data matrix filename = "+str(fn)+"\n"
    txt1+=" class filename       = "+str(fn2)+"\n"
    txt1+="\n a): the subsets \n"

    for i in range(0,noc):
        txt1+="set  "+str(i)+": "
        for j in range(0,len(ra[i])):
            txt1+=ra[i][j]+", "
        txt1+="\n"
    txt1+="\n\n b) dominance matrix DOM\n"
    txt1+="\n\t"
    for i in range(0,noc):
        txt1+=str(ra[i][0])+"\t"
    txt1+="\n"
    for i1 in range(0,noc):
        txt1+=str(ra[i1][0])+" :\t"
        for i2 in range(0,noc):
            txt1+=str(dom[i1][i2])+"\t"
        txt1+="\n"
    txt1+="\n\n"
    txt1+="dominance matrix Dom (DOM(i,j)/(ni*nj)) \n"
    domnorm=rmod2.marray(noc,noc)
    txt1+="\t"
    for i3 in range(0,noc):
        txt1+=str(ra[i3][0])+"\t"
    txt1+="\n"    
    for i1 in range(0,noc):
        txt1+=str(ra[i1][0])+": \t"
        for i3 in range(0,noc):
            domnorm[i1][i3]=1.0*dom[i1][i3]/(1.0*len(ra[i1])*len(ra[i3]))
            txt1+=str(round(domnorm[i1][i3],3))+"\t"
        txt1+="\n"

    tpres=Tkinter.Toplevel(hf)
    tpres.title('Results of dominance analysis ')
    tresults=ScrolledText(tpres,width=80,height=10)
    tresults.pack()
    txt1+="\n c) separability matrix SEP\n"
    txt1+="\n\t"
    for i in range(0,noc):
        txt1+=str(ra[i][0])+"\t"
    txt1+="\n"
    for i1 in range(0,noc):
        txt1+=str(ra[i][0])+" :\t"
        for i2 in range(0,noc):
            txt1+=str(sep[i1][i2])+"\t"
        txt1+="\n"
    txt1+=2*"\n"
   

    sepnorm=rmod2.marray(noc,noc)
    txt1+="\nseparability matrix Sep (SEP(i,j)/(ni*nj)) \n"
    txt1+="\t"
    for i3 in range(0,noc):
        txt1+=str(ra[i3][0])+": \t"
    txt1+="\n"    
    for i1 in range(0,noc):
        txt1+=str(ra[i1][0])+": \t"
        for i3 in range(0,noc):
            sepnorm[i1][i3]=1.0*sep[i1][i3]/(1.0*len(ra[i1])*len(ra[i3]))
            txt1+=str(round(sepnorm[i1][i3],3))+"\t"
        txt1+="\n"
    txt1+="\n"
    
    
    #relative numbers of the dominance and separability matrices
    global reldom
    relat=rmod2.marray(noc,noc)
    reldom=rmod2.marray(noc,noc)
    relsep=rmod2.marray(noc,noc)
    for i1 in range(0,noc):
        for i2 in range(0,noc):
            relat[i1][i2]=1.0*len(ra[i1])*len(ra[i2])
            reldom[i1][i2]=1.0*dom[i1][i2]/(1.0*relat[i1][i2])
            relsep[i1][i2]=1.0*sep[i1][i2]/(1.0*relat[i1][i2])
    listreldom=[]
    for i1 in range(0,noc):
        for i2 in range(0,noc):
            if reldom[i1][i2] not in listreldom:
                listreldom.append(reldom[i1][i2])
    listreldom.sort()
    txt1+=" Sorted values of relative dominance matrix "+"\n"
    for xx in listreldom:
        txt1+=str(round(xx,3))+", "
    txt1+="\n"
    txt1+="\n\n ---  end of file   ---"
    tresults.insert("end",txt1)

def histogram(relatmatrix,number_of_classes):
    #brg 30.03.17
    # relatmatrix: either reldom or reldomeq
    # number of classes: number of classes
    # delta: parameter determining the histogram
    noc=number_of_classes
    delta=0.2    
    lhisto=noc*noc-noc   # number of non-diagonal elements
    #rmod2.matout(hfs,hfs,relat)
    #rmod2.matout(hfs,hfs,reldom)
    histodom=rmod2.vecgen1(lhisto)
    # in histogram all values of reldom beside the diagonal ones
    z=0
    for i1 in range(0,noc):
        for i2 in range(0,noc):
            if i1!=i2:
                histodom[z]=relatmatrix[i1][i2]
                z+=1
    histodom.sort()
    #print histodom
    #print histodom
    
    histodomclass=rmod2.vecgen1(5)
    for z2 in range(0,5):
        for i in range(0,lhisto):
            if z2<4:                                    #changed 2.4.2011
                if delta*z2<=histodom[i]<delta*(z2+1):
                    histodomclass[z2]+=1
            else:
                if delta*z2<=histodom[i]<=delta*(z2+1):
                    histodomclass[z2]+=1
            
    #print histodomclass
    hfstat=Tkinter.Toplevel(hf)
    hfstat.title(' dds-histogram ')
    lbhfstat=Tkinter.Label(hfstat,text=' histogram ')
    lbhfstat.pack()
    frhist=Tkinter.Frame(hfstat,width=200,height=220)
    frhist.pack()
    cvhist=Tkinter.Canvas(frhist,width=200,height=220)
    cvhist.create_line(20,180,180,180)    #basic line
    cvhist.create_line(20,180,20,20)     #vertical line
    abstand=32
    for i in range(0,5):
        cvhist.create_line(15,20+abstand*i,20,20+abstand*i)
    cvhist.create_text(10,20,text=str(lhisto))
    cvhist.create_text(10,100,text=str(round(lhisto/2.0,1)))
    cvhist.create_text(10,180,text="0")
                       
    htick=rmod2.vecgen1(5)
    for i in range(0,5):
        cvhist.create_line((i+1)*32,185,(i+1)*32,180)
        htick[i]=histodomclass[i]*(160.0/(1.0*lhisto))
        cvhist.create_rectangle(22+i*32,180,50+i*32,180-htick[i],fill="blue")
        cvhist.create_text(36+i*32,190,text=str(0.1+i*0.2))
    cvhist.create_text(98,210,text="distr. of dominance degrees", font="14")
    cvhist.pack()    

def histogram_repr():
    #brg 30.03.17
    histogram(reldom, noc)
    

def readin_subsets_eq(fn2):
    """ noc entries are opened to read in hfs strings """
    #brg  8.7.2015
    global noc, ra
    f=open(fn2,'r')
    s=f.readline()
    noc=int(s)
    ra = []
    print "noc= ",noc
    for i in range(0,noc):
        hilf=f.readline()
        ra.append(hilf.split(","))
    f.close()
    print "in readineq subsets: ra= ",ra
    # purification of the class readin
    for i1 in range(0,noc):
        for i2 in range(0,len(ra[i1])):
            for i3 in range(0, len(obj)):
                if ra[i1][i2]== obj[i3] or ra[i1][i2]==str(obj[i3])+"\n":
                    ra[i1][i2]=obj[i3]
    print "in readin_eq ra purified ",ra   
    return noc,ra


def analysiseq():
    """the core of dds8.py
    based on object subsets the
    dominance and separability matrix
    will be calculated"""
    #Brg  31.12.07, 14.1.08, 6.4.2011, 30.03.17
    #class input control
    zetaeq = rmod2.marray(r,r)   
    zetaeq=rmod2.comp(r,k,x)  # zetaeq may include equivalence relations, therefore not really a zeta matrix
    noc,ra=readin_subsets_eq(fn2)   # when equivelnt objects are to be taken into account, the check must be based
    #                                 ...on obj and not on objred
    #print "len(ra) ",len(ra)
    
    flagwarn1=0                
    for i1 in range(0,noc):
        for i2 in range(0,len(ra[i1])):
            if ra[i1][i2] not in obj:
                flagwarn1+=1
    if flagwarn1>0:
        tpwarn1=Tkinter.Toplevel(hf)
        lbwarn1=Tkinter.Label(tpwarn1,text="+++ Please control the classes+++ of ..."+str(fn2),bg="yellow")
        lbwarn1.pack()
    #print "ra purified ",ra            
    #that is the central part: based on rai the dominance and separability degree
    print "ra in analysiseq ",ra
    #print "zetaeq_tr "
    #rmod2.matout(r,r,zetaeq_tr)
    domeq=rmod2.marray(noc,noc)
    sepeq=rmod2.marray(noc,noc)
    for i1 in range(0,noc):
        for i2 in range(0,len(ra[i1])):
            for i3 in range(0,noc):
                for i4 in range(0,len(ra[i3])):
                    if zetaeq[obj.index(ra[i1][i2])][obj.index(ra[i3][i4])]==1:
                        domeq[i1][i3]+=1

    for i1 in range(0,noc):
        for i2 in range(0,len(ra[i1])):
            for i3 in range(0,noc):
                for i4 in range(0,len(ra[i3])):
                    if zetaeq[obj.index(ra[i1][i2])][obj.index(ra[i3][i4])]==0 and\
                                zetaeq[obj.index(ra[i3][i4])][obj.index(ra[i1][i2])]==0:
                        sepeq[i1][i3]+=1            


    tpres2=Tkinter.Toplevel(hf)
    tpres2.title('Results of dominance analysis including equivalent objects')
    tresults2=ScrolledText(tpres2,width=80,height=10)
    tresults2.pack()
    txt1=" A n a l y s is  : Including equivalence classes "+"\n"
    txt1+=" data matrix filename = "+str(fn)+"\n"
    txt1+=" class filename       = "+str(fn2)+"\n"                            
    txt1+="\n a): the subsets \n"
    for i in range(0,noc):
        txt1+="set  "+str(i)+": "
        for j in range(0,len(ra[i])):
            txt1+=ra[i][j]+", "
        txt1+="\n"
    txt1+="\n\n b) dominance matrix DOMeq\n"
    txt1+="\n\t"
                                
    for i in range(0,noc):
        txt1+=str(ra[i][0])+"\t"
    txt1+="\n"
    for i1 in range(0,noc):
        txt1+=str(ra[i1][0])+" :\t"
        for i2 in range(0,noc):
            txt1+=str(domeq[i1][i2])+"\t"
        txt1+="\n"
    txt1+="\n\n"
    txt1+="dominance matrix Domeq (DOMeq(i,j)/(ni*nj)) \n"
    domnormeq=rmod2.marray(noc,noc)
    txt1+="\t"
    for i3 in range(0,noc):
        txt1+=str(ra[i3][0])+"\t"
    txt1+="\n"    
    for i1 in range(0,noc):
        txt1+=str(ra[i1][0])+": \t"
        for i3 in range(0,noc):
            domnormeq[i1][i3]=1.0*domeq[i1][i3]/(1.0*len(ra[i1])*len(ra[i3]))
            txt1+=str(round(domnormeq[i1][i3],3))+"\t"
        txt1+="\n"


    txt1+="\n c) separability matrix SEPeq\n"
    txt1+="\n\t"
    for i in range(0,noc):
        txt1+=str(ra[i][0])+"\t"
    txt1+="\n"
    for i1 in range(0,noc):
        txt1+=str(ra[i1][0])+" :\t"
        for i2 in range(0,noc):
            txt1+=str(sepeq[i1][i2])+"\t"
        txt1+="\n"
    txt1+=2*"\n"

   

    sepnormeq=rmod2.marray(noc,noc)
    txt1+="separability matrix Sepeq (SEP(i,j)/(ni*nj)) \n"
    txt1+="\t"
    for i3 in range(0,noc):
        txt1+=str(ra[i3][0])+": \t"
    txt1+="\n"
                                
    for i1 in range(0,noc):
        txt1+=str(ra[i1][0])+": \t"
        for i3 in range(0,noc):
            sepnormeq[i1][i3]=1.0*sepeq[i1][i3]/(1.0*len(ra[i1])*len(ra[i3]))
            txt1+=str(round(sepnormeq[i1][i3],3))+"\t"
        txt1+="\n"
    txt1+="\n"
    
    
    
    #relative numbers of the dominance and separability matrices
    global reldomeq
    relat=rmod2.marray(noc,noc)
                                
    
    reldomeq=rmod2.marray(noc,noc)
    relsepeq=rmod2.marray(noc,noc)
    for i1 in range(0,noc):
        for i2 in range(0,noc):
            relat[i1][i2]=len(ra[i1])*len(ra[i2])
            reldomeq[i1][i2]=1.0*domeq[i1][i2]/(1.0*relat[i1][i2])
            relsepeq[i1][i2]=1.0*sepeq[i1][i2]/(1.0*relat[i1][i2])
    listreldom2=[]
    for i1 in range(0,noc):
        for i2 in range(0,noc):
            if reldomeq[i1][i2] not in listreldom2:
                listreldom2.append(reldomeq[i1][i2])
    listreldom2.sort()
    txt1+=" Sorted values of relative dominance matrix_eq "+"\n"
    for hilf in listreldom2:
        txt1+=str(round(hilf,3))+", "
    txt1+="\n"
    txt1+="\n\n ---  end of file   ---"
    tresults2.insert("end",txt1)        

def histogram_eq():
    #brg 30.03.17
    histogram(reldomeq, noc)
                                
                                
def graph(master,reldom,ra):
    """the matrix of relevant dominance
    relation (due to the entry 'limiting value'
    is constructed and a graph is drawn """
    #brg 1.1.08, 30.03.17
    # master: label for Toplevel
    # reldom: the fuzzy dom (or domeq) matrix
    # ra: the classes (either without equivalent elements or with them) 
    global elim, objred3,graphdom, eqm_act3,txteq3
    try:
        limv=float(elim.get())
    except:
        limv=0.45
    print "limv= ",limv    
    graphdom=rmod2.marray(noc,noc)
    classdom=rmod2.vecgen1(noc)
    for i1 in range(0,noc):
        classdom[i1]=ra[i1][0]
        for i2 in range(0,noc):
            if reldom[i1][i2]>limv:
                graphdom[i1][i2]=1
            else:
                graphdom[i1][i2]=0
            if i1==i2:                 #Diagonale 30.03.17
                graphdom[i1][i2]=1
    master=Tkinter.Toplevel(hf)
    master.title(' filtered matrix ')
    lbhfgraph=Tkinter.Label(master,text=' filtered matrix ')
    lbhfgraph.pack()
    frgr=Tkinter.Frame(master,width=400,height=400,relief="raised",bd=3)
    frgr.pack()
    txt2="\ matrix of the directed graph of subsets "
    txt2+="\n\t"
    for i in range(0,noc):
        txt2+=str(i)+"\t"
    txt2+="\n"
    for i1 in range(0,noc):
        txt2+=str(i1)+" :\t"
        for i2 in range(0,noc):
            txt2+=str(graphdom[i1][i2])+"\t"
        txt2+="\n"
    tgraph=ScrolledText(master,width=50,height=4)
    tgraph.pack()
    tgraph.insert("end",txt2)
    posx=rmod2.vecgen1(noc)
    posy=rmod2.vecgen1(noc)
    cvgr=Tkinter.Canvas(frgr,width=400, height=400)
    
    
    for i in range(0,noc):
        posx[i]=100*cos(i*6.28/noc)
        posy[i]=100*sin(i*6.28/noc)
        
        cvgr.create_oval(160+posx[i]-20,130+posy[i]+20,160+posx[i]+20,130+posy[i]-20,fill="yellow")       
        cvgr.create_text(162+posx[i],132+posy[i],text=str(classdom[i]),font = "15")

    rdgr=80
    for i in range(0,noc):
        posx[i]=rdgr*cos(i*6.28/noc)
        posy[i]=rdgr*sin(i*6.28/noc)
        for j in range(0,noc):
            posx[j]=rdgr*cos(j*6.28/noc)
            posy[j]=rdgr*sin(j*6.28/noc)
            if i!=j:
                if graphdom[i][j]==1:
                    cvgr.create_line(160+posx[i],130+posy[i],160+posx[j],130+posy[j],arrow="last")  #7.6.08
    cvgr.create_text(140,380,text=" Dominance digraph, filter = "+str(limv),font="16")
    cvgr.pack()
    # check for transitivity
    flag,txt=transitivity_check(graphdom,noc,classdom)
    if flag>0:
        tpchecktransitivity=Tkinter.Toplevel(hf)
        tpchecktransitivity.title("Result: check transitivity ")
        tchecktransitivity=ScrolledText(tpchecktransitivity,height=60,width=60)
        tchecktransitivity.pack()
        tchecktransitivity.insert("end",txt)
    else:
        pass
    # check for equivalence of classes due to graphdom
    rred3,xred3,objred3,txteq3,eqm_act3=rmod2.equivcompactgr(noc,noc,graphdom,classdom)   # 8.9.2014
    print "txteq3 = ",txteq3
    print "objred3 = ",objred3
    txtfn=str(fn)+"\n"+str(fn2)
    showeq("tpclassesequivalent",txtfn,txteq3,eqm_act3,classdom)

def graph_repr():
    graph("tpgraph_repr",reldom,ra)

def graph_eq():
    graph("tpgraph_eq",reldomeq,ra)

def transitivity_check(rel,n, obj):
    # brg 29.03.17
    # rel: the relational matrix in terms of 0,1
    # number of rows/columns of rel
    # obj: list of object labels , corresponding to rel
    # if the transitivity is not fulfilled then flag>1 else flag = 0
    # txt describes where transitivity is not fulfilled.
    flag=0
    zahl=0
    txt="transitivity-check protocol "+"\n"
    for i in range(0,n):
        for j in range (0,n):
            for k in range(0,n):
                if rel[i][j]==1 and rel[j][k]==1:
                    if rel[i][k]==1:
                        pass
                    else:
                        zahl+=1
                        txt+=str(zahl)+"\n"
                        txt+=str(obj[i])+" < "+str(obj[j])+"  and "+str(obj[j])+" < "+str(obj[k])+"\n"
                        txt+="however: "+str(obj[i])+"  is not < "+str(obj[k])+"\n"
                        flag+=1
                else:
                    pass
    return flag,txt
    
def fuzzyproduct(matrix):
    "see DeBaets,DeMeyer in Inf Sci 152, 2003, 167-179"
    #brg 14.11.07, 31.03.17
    # matrix: for examlpe reldomeq or reldom
    # parameter rloc: number of rows/columns of the square matrix 'matrix'
    rloc=len(matrix)
    flag=0
    eps=0.01
    zaehl=0
   
    
    q=rmod2.matcopy1(rloc,rloc,matrix)
    
    while flag==0:
        q1=rmod2.fuzzymatmult(rloc,q,q)
        flag=rmod2.comparematrices(rloc,rloc,eps,q1,q)
        q=rmod2.matcopy1(rloc,rloc,q1)
        zaehl+=1
        if zaehl>100:
            break
        else:
            pass
    
    print "flag=",flag   
    txt=""
    hilf1=rmod2.vecgen1(rloc*rloc)
    hilf2=rmod2.vecgen1(rloc*rloc)
    hilf3=rmod2.vecgen1(rloc*rloc)
    alpha=rmod2.vecgen1(rloc*rloc)
    nn=rmod2.vecgen1(rloc*rloc)
    zaehl=0
    for i in range(0,rloc):
        for j in range(0,rloc):
            hilf1[zaehl]=round(q[i][j],3)
            zaehl+=1
    hr=rloc*rloc
    hilf2,nn=rmod2.raisort(hr,hilf1)
    for i in range(0,hr):
        hilf3[i]=hilf2[i]
        
    for i in range(0,hr):
        z=hilf2[i]
        for i1 in range(i+1,hr):
            if z==hilf2[i1]:
                hilf3[i1]="*"
    nr_of_cuts=0
    for i in range(0,hr):
        if hilf3[i]!="*":
            alpha[nr_of_cuts]=float(hilf3[i])
            nr_of_cuts+=1
    txt1="Number of cuts = "+str(nr_of_cuts)+"\n"
    lbalpha.config(bg="yellow")
    lbalpha["text"]=txt1
    nhisto=5         #graphics  neu 20.2.08
    nal=nr_of_cuts   #graphics
    balpha=rmod2.vecgen1(nhisto)
    for j in range(0,nhisto):
        for i in range(0,nal):
            if j<nhisto-1 and j<=nhisto*alpha[i]<j+1:
                balpha[j]+=1
            if j==nhisto-1 and j<=nhisto*alpha[i]<=j+1:
                balpha[j]+=1
    histo=Tkinter.Toplevel(hf)
    histo.title(' alpha-values  ')
    talfa=ScrolledText(histo,width=60,height=5)
    talfa.pack(expand="yes",fill="both")
    txt2="alpha-values\n "  #16.3.09
    for i in range(0,nal):
        if i>0 and i%20==0:                        #18.2.08
            txt2+=str(alpha[i])+" \n"
        else:
            txt2+=str(alpha[i])+"   "
    #txt+="\n"
    txt2+="\n"+"  - - -   eof  - - - "        
    talfa.insert("end",txt2)
    return q

def crispq(q,acuser):
    "depending on alpha: crisp matrices"
    # brg 14.11.07, 26.7.2015
    global ior, nior
    rloc=len(q)
    lbextract.config(bg="white")
    lbextract["text"]=""
    cq=rmod2.marray(rloc,rloc)
    ior = []
    nior = []
    for i1 in range(0,rloc):
        for i2 in range(0,rloc):
            if q[i1][i2]>=acuser:
                cq[i1][i2]=1
            else:
                cq[i1][i2]=0
            if i1==i2:            #31.03.17  an important step
                cq[i1][i2]=1
    print "cq in crisp = "
    print cq
    return cq,acuser,ior,nior


    
def extract(cq,acut):
    """extracts from the crisp matrix the order relations"""
    global eqtext
    lbextract.config(bg="yellow")
    lbextract["text"]="Extraction performed: Selected alpha-cut: "+str(acut)
    rloc=len(cq)
    #brg 30.11.07, 11.4.08, 31.03.17
        
       
    
    ec=rmod2.dmcompress(rloc,rloc,cq)             #30.11. from cq the equivalent relations
    eqtxt,Ksum_act=rmod2.eqcguiout2(rloc,ec,obj)        #30.11. matrix output 16.7.2013: eqc... version 2
    print "eqtxt = ",eqtxt
    eqtext="Equivalence classes"+"\n"
    eqtext+=eqtxt
    eqtext+="\n"
    eqtext+="K = "+str(Ksum_act)+"\n"
    
    
    #print "r  = ",r
    txt=rmod2.irc_elim(rloc,ec)    #7.5.08 identifycolrows replaced by icr_elim
                                #in txt are the rows (and columns)
                                #...which can be eliminated
    
    #print "======================================="
    #print " Control in extract (ex) "
    #print "======================================="
    ltxt=len(txt)
    #print "ex1: ec : ",ec
    #print "ex1: txt , ltxt",txt," ",ltxt
    
    b=rmod2.recogempty(txt,ltxt)
    # Not only the matrix cq is to be contracted but also the object vector obj
    # txt is a code of row numbers and as such ok for the matrixeliminations
    # however, to perform a new object list, txt must
    # be transformed in the corresponding object names
    
        
    an1,ldel1=rmod2.matrixcoldel(txt,rloc,rloc,cq) # columns eliminated
    rs = rloc-ldel1
    order,ldel2=rmod2.matrixrowdel(txt,rloc,rs,an1)
    print "order in extract "
    print order
      
    if b=="true":
        #there is nothing to be reduced hence
        objec=rmod2.vecgentext1(r)
        for i in range(0,rloc):
            objec[i]=obj[i]
    else:        
        conobj=rmod2.vecgentext1(ltxt)
        for i in range(0,ltxt):
            conobj[i]=obj[int(txt[i])]
        #print "conobj = ",conobj    
        objec=rmod2.vecgentext1(rs)
        zaehl=0
        for i in range(0,rloc):
            #print "obj i  ",obj[i],"  in conobj  ",conobj
            if obj[i]not in conobj:
                objec[zaehl]=obj[i]
                zaehl+=1
        #print "ex4: Reduz. Liste der Objekte (objec in modul extract) ",objec
        #print "ex5: rs = ",rs
    return order,objec,rs

def Trhull():
    # brg 8.8.2013, 29.8.2013, 7.5.2015, 9.5.2015
    # acut read in
    # normalization
    # Tr.closure by matrix method
    # crisp matrix
    # extract order
    global qmc
    qmc=fuzzyproduct(reldom)
    tp2qmc=Tkinter.Toplevel(hf)
    tp2qmc.title('show tr. corrected relat. matrix')
    lbtp2=Tkinter.Label(tp2qmc,text=" General information about the tr.corr. relational matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2qmc,width=80,height=10)
    tfile.pack()
    txt5="transitive hull of the dom-matrix of "+str(fn2)+"\n"
    txt5="\n av. transponed trhull  \n"
    txt5+="\t"
    for i in range(0,len(ra)):
        txt5+=str(ra[i][0])+"\t"
    txt5+="\n"    
    for i1 in range(0,len(ra)):
        txt5+=str(ra[i1][0])+"\t"
        for i2 in range(0,len(ra)):
            txt5+=str(round(qmc[i2][i1],3))+"\t"
        txt5+="\n"
    txt5+="\n\n"
    tfile.insert("end",txt5)

   

def towardsmcHD():
    #brg 7.5.2015, 31.03.17
    global cq, acut, ior, nior, order, rs
    try:
        acut = float(eacut.get())
    except:    
        acut = 0.5
    print "acut = ",acut
    
    cq,acut,ior,nior=crispq(qmc,acut)
    order,objec_act,rs=extract(cq,acut)
    print "order in towardsmcHD"
    print order
    print "objec_act ",objec_act
    print "rs= ",rs
    labels = []
    for i in range(0, len(ra)):
        labels.append(ra[i][0])
    #transposition
    order_tr=rmod2.marray(rs,rs)    
    for i1 in range(0,rs):
        for i2 in range(0,rs):
            order_tr[i1][i2]=order[i2][i1]
    HD("TpTransitivehull",order_tr,labels)


## Tkinter Plot
hf = Tkinter.Tk()
hf.title(' dds (Dom_Dom_Sep ')
aboutHDsimpl=raioop2.brgabout(hf,"tp1","about_ddsnew.txt",17,\
            "March, the 30th, 2017"," about dds ", "white", "t1",120,5,ScrolledText)
helpHDsimpl=raioop2.brgabout(hf,"tp1","help_ddsnew.txt",17,\
            "March, the 30th, 2017"," help_HDsimpl ", "white", "t1",120,5,ScrolledText)
    
fr = Tkinter.Frame(hf, width=60)
fr.pack()
frinput1 = Tkinter.Frame(fr, width=100, height=10)
frinput1.pack()
text = "Select first the file, then decide in which format to be opened "
lbinput1 = Tkinter.Label(frinput1,
                         text=text)
lbinput1.pack()
butt1 = Tkinter.Button(frinput1, text="(1) Select filename of the data matrix  ",
                       bg="white", width=30, command=xselectfile)
butt1.pack()
                      
lbopen1 = Tkinter.Label(fr, text="")
lbopen1.pack()
lb1 = Tkinter.Label(fr,text=" ", width=60)
lb1.pack()
buttshow_datamatrix = Tkinter.Button(fr,text="(2opt) Show data matrix (dm)",bg="cyan",width=30, command=show_dm_orig)
buttshow_datamatrix.pack()
buttHD = Tkinter.Button(fr, text='(3) Draw orig HD', width=30, bg="cyan", command=HD_orig)
buttHD.pack(pady=5)
buttcov=Tkinter.Button(fr, text = "(4opt) orig cover - relation ",width = 30, command = cov_orig)
buttcov.pack()
buttequiv = Tkinter.Button(fr,text="(5) show orig equivalence classes", width = 30,command = showeq_orig)
buttequiv.pack()
buttddswindow=Tkinter.Button(fr,text="(6) Activate the dom-dom-sep-window ",bg="cyan",width=30,command=dds)
buttddswindow.pack()
buttexit = Tkinter.Button(fr, text='(16) exit', bg='red',
                          width=30, command=hf.destroy)
buttexit.pack(pady=10)

hf.mainloop()
