import Tkinter
import rmod2
import raioop2
import random
from ScrolledText import *
import tkFileDialog
import Canvas
import os
from math import *

# dds8.py  brg 26.12.07, 31.12.07, 1.1.08, 2.1.08, 3.1.08, 14.1.08, 4.2.08
# variabler input
# 18.2.08: empty window eliminated
# 18.2.08: titles for daughter windows
# 8.5.08 : adaptations because of changes in rmod2
# 7.5.08: arrows in subsets-dominance reversed
# 26.7.08 : Reorganization of GUI
# 12.10.08 help text now external. Loading by an OOP-function
# 16.10.09 ScrolledText fuer Help enlarged
# 2.4.2011 histogram for dominance degrees corrected
# 3.4. Start to upgrade dds8 to dds9: Better HD
# 6.4. 2011 inclusion of equivalent elements (test)
# 25.3.-29.3.17 bugs. Classes can be equivalent!!
# 29.03.2017: ddssimpl1_1.py
# 25.06.18 cosmetics

global fn

def transitivity_check(rel,n, obj):
    # brg 29.03.17
    # rel: the relational matrix in terms of 0,1
    # number of rows/columns of rel
    # obj: list of object labels , corresponding to rel
    # if the transitivity is not fulfilled then flag>1 else flag = 0
    # txt describes where transitivity is not fulfilled.
    flag=0
    zahl=0
    txt="transitivity-check protocol "+"\n"
    for i in range(0,n):
        for j in range (0,n):
            for k in range(0,n):
                if rel[i][j]==1 and rel[j][k]==1:
                    if rel[i][k]==1:
                        pass
                    else:
                        zahl+=1
                        txt+=str(zahl)+"\n"
                        txt+=str(obj[i])+" < "+str(obj[j])+"  and "+str(obj[j])+" < "+str(obj[k])+"\n"
                        txt+="however: "+str(obj[i])+"  is not < "+str(obj[k])+"\n"
                        flag+=1
                else:
                    pass
    return flag,txt

def check_equivalence(eqm_act,r):
    # brg 29.03.2017
    # eqm_act : output of filecomp and therein of rmod2-procedure equivcompactgr
    # r: number of objects
    # output: sumeq (>0 then nontrivial eq.classes
    # output txteq info about equivalence classes
    sumeq=0
    for i in range(0,r):
        for j in range(0,r):
            sumeq+=eqm_act[i][j]
    sumeq=sumeq-r
    if sumeq!=0:
        txteq_act=txteq
    else:
        txteq_act="no nontrivial eq.classes"
    return sumeq, txteq

def HD1():
    """based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"""
    # Brg 20.12.07, 28.12.07
    # If the number of representants > 20 then only the cover-matrix and the level-population
    #
    try:
        perturb=int(eperturb.get())
    except:
        perturb=0
        
    global zeta,cov,rred,n,objred    
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    global fn
    #dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    rred,k1,xred,objred,obj,txteq,eqm_act=filecomp(fn)
    n=rred
    k=k1
    labeq=Tkinter.Label(freq,text="file = "+fn+": calc. is based on representants ")
    labeq.config(bg="yellow")
    labeq.pack()
    flageq,txteq=check_equivalence(eqm_act, r)

    
    labeq2=Tkinter.Label(freq,text="equivalence classes: \n"+txteq,bg="white",relief="groove",bd=3)
    labeq2.pack()
    #
    zetahilf=rmod2.comp(n,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    comparabilities=0
    utotal=0
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]

    for i in range(0,rred): #calculation of comparabilities
        for j in range(0,rred):
            if i!=j:
                comparabilities+=zeta[i][j]

    for i in range(0,rred): #calculation of utotal
        for j in range(0,rred):

            if zeta[i][j]==0  and zeta[j][i]==0:
                utotal+=1
    utotal=0.5*utotal            
#
    

    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(n,zeta)
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
    
    #Adj-Listen

    adjc=rmod2.adjacent(n,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(n,adjc,lext)
       
    
    cov=rmod2.cover(n,tr,lext)

    if n>200:
        cover_show()                  #20.1.08
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram of File "+fn)
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(n,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(n,n)
        geomy=rmod2.marray(n,n)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=(perturb*random.randint(1,5)+1)*geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-17,geomy[i][j]+17,geomx[i][j]+17,geomy[i][j]-17,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")

        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.create_text(int(1.0*actwidth/2.0),actheight-5,text="compar.:  "+str(comparabilities)+\
                       ",   incomp. "+str(utotal))

        

        cv.pack()
        

def fileselect():
    """ File selection and opening by Tkinter-Standards"""
    #*13.1.08
    #akt: 13.1.08, 29.03.17
    #note: There may be conflicts with other moduls
    #source:-
    
    global fn
    fn=tkFileDialog.askopenfilename()
    dm,ob,pro,r,k1=rmod2.EXCELreadin4(fn)
    lbopen1.config(bg="yellow")
    lbopen1["text"]="selected file : "+fn+"  with \n"+str(r)+" rows\n"+str(k1)+" columns"
    
        
def showDM():
    """ New routine : shows the complete data matrix """
    #Brg 13.1.08
    
    tp2=Tkinter.Toplevel(hf)
    tp2.title(' show DM ')
    lbtp2=Tkinter.Label(tp2,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=20)
    tfile.pack()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    #print "dm= ",dm
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+ob[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+pro[j+1]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=pro[j+1]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=ob[i+1]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)
    

def filecomp(fn):
    """ reduces a dm with equiv objects to a dm of a quotient set """
    # Brg 12.12.07, 13.1.08, 14.1.08, 8.5.08
    # von mainHD3 uebernommen und geringfuegig angepasst
    #r,k,dm,ob,pro,fn are globals and should be available after open
        #recoding ob to obj and pro to prop
    ## +++ Baustelle 4.4.2011 ++ hier muss equivcompactgr hinein und eqm
    ## zugaenglich gemacht werden +++
    global dm,ob,obj,pro,prop,k,k1,r,rred,xred,objred,txteq
    dm,ob,pro,r,k1=rmod2.EXCELreadin4(fn)
    if r==0:
        hfwarning=Tkinter.Toplevel(hf)
        hfwarning.title('++warning++')
        frwarning=Tkinter.Frame(hfwarning,width=10,height=3)
        frwarning.pack()
        bwarning=Tkinter.Button(frwarning,text="++warning ++",command=msgwarning)
        bwarning.pack()
        
    prop=rmod2.vecgentext1(k1)
    obj=rmod2.vecgentext1(r)     #changed to ...text1: 8.5.08
    for i in range(0,k1):
        prop[i]=pro[i+1]
    for i in range(0,r):
        obj[i]=ob[i+1]
    #############################dieser Teil ist neu 21.12.07
    rred,xred,objred,txteq,eqmact=rmod2.equivcompactgr(r,k1,dm,obj)    
    ###############################################################
    return rred,k1,xred,objred,obj,txteq,eqmact
    

def inforep():
    """ informs about representants """
    # Brg 14.1.08 , 25.06.18
    rred,k1,xred,objred,obj,txteq,eqm_act=filecomp(fn)
    #print "txteq = ",txteq
    #print "eqm_act = ",eqm_act
    hfinfo=Tkinter.Toplevel(hf)
    hfinfo.title(' equivalence classes ')
    lbhfinfo=Tkinter.Label(hfinfo, text=' information ')
    lbhfinfo.pack()
    tinfo=ScrolledText(hfinfo,width=80,height=20)
    tinfo.pack()
    txtrep="\n representants: \n"
    txtrep+=50*"="+"\n"
    for i in range(0,rred):
        txtrep+=objred[i]+", "
    txtrep+="\n\n"
    sumeq,txteq=check_equivalence(eqm_act, r)
    if sumeq>0:
        txtrep+=txteq
    else:
        txtrep+="No nontrivial equivalence classes "
    txtrep+="\n"
    txtrep+="\n\n ---   end of file   \n"
    tinfo.insert("end",txtrep)

    
def how_many():
    """how many entries are to be open"""
    #brg 26.12.07, 25.06.18
    tpclasses=Tkinter.Toplevel(hf)
    tpclasses.title("classes")
    global e,hfs
    hfs=int(es.get())
    #print hfs
    e=rmod2.vecgen1(hfs)
    for i in range(0,hfs):
        e[i]=Tkinter.Entry(tpclasses,width=60)  #250618
        e[i].grid(columnspan=2,row=7+i)
    
    return hfs

def confirm():
    """ hfs entries are opened to read in hfs strings """
    #brg 26.12.07
    global ra, flagexternal
    #print "in confirm hfs=",hfs," ra = "
    ra=rmod2.vecgentext1(hfs)
    for i in range(0,hfs):
        ra[i]=e[i].get()
        #print "ra= ",ra[i]
    flagexternal = 0    
    return ra



def rai_x(hfs,rai,objred):
    """ transformation of sequence (rai) into a vectorial quantity (x)"""
    #brg 26.12.07, 31.12.07
    #brg 14.1.08: renamed: calc --> rai_x, because there is no calculation
    #brg 25.3.2017 objred replaced by obj
    
    
    x=rmod2.vecgentext1(hfs)
    y = rmod2.vecgen1(hfs)
    lx=rmod2.vecgen1(hfs)
    print "in rai_x"
    for i in range(0,hfs):
        x[i]=rai[i].split(",")
    for i in range(0,hfs):
        lx[i]=len(x[i])
        y[i]=[]
        print "i= ",i,"  lx = ",lx[i],"  x= ",x[i]
    lob=len(objred)
    print "objred= ",objred
    for i in range(0,hfs):
        for j in range(0,lx[i]):
            for k in range(0,lob):
                if x[i][j] == objred[k]:
                    y[i].append(k)
    #check for correct input
    flagcorrectinput=0
    for i in range(0, hfs):
        for j in range(0,lx[i]):
            if x[i][j] not in objred:
                flagcorrectinput+=1
    
    if flagcorrectinput>0:
        tpwarning=Tkinter.Toplevel(hf)
        tpwarning.title(" warning ")
        twarning=ScrolledText(tpwarning, height=5, width=60)
        twarning.pack()
        txt="+++check: evtl. wrong object labels or incorrect delimiters +++"
        twarning.insert("end",txt)
    return y,x,lx
        
def analysis():
    """the core of dds13.py
    based on object subsets the
    dominance and separability matrix
    will be calculated"""
    #Brg  31.12.07, 14.1.08, 29.03.17
    # objx is the central zeta-matrix
    #Open the file
    # Excelreadin3 built in
    # Brg 29.11.07, 12.12.07
    global rai,ra
    rred,k,xred,objred,obj,txt,eqm_act=filecomp(fn)  #filecomp reads the file fn
                                                  #which was selected in fileselect

    # here we have now objred, prop and xred
    objx=rmod2.marray(rred,rred)   
    objx=rmod2.comp(rred,k,xred)

    #here we have the central matrix objx
    #print "ra = ",ra, "   flagexternal = ",flagexternal
    ra=confirm()          ####!!!26.7.08
    rai,x,lrai=rai_x(hfs,ra,objred)  #27.5.08, 
    
    #that is the central part: based on rai the dominance and separability degree
    dom=rmod2.marray(hfs,hfs)
    sep=rmod2.marray(hfs,hfs)
    for i1 in range(0,hfs):
        for i2 in range(0,lrai[i1]):
            for i3 in range(0,hfs):
                for i4 in range(0,lrai[i3]):
                    if objx[rai[i1][i2]][rai[i3][i4]]==1:
                        dom[i1][i3]+=1
    
    for i1 in range(0,hfs):
        for i2 in range(0,lrai[i1]):
            for i3 in range(0,hfs):
                for i4 in range(0,lrai[i3]):
                    if objx[rai[i1][i2]][rai[i3][i4]]==0 and objx[rai[i3][i4]][rai[i1][i2]]==0:
                        sep[i1][i3]+=1            

    
    txt1=" A n a l y s is  : Only representants "+"\n"
    txt1+="\n a): the subsets \n"

    for i in range(0,hfs):
        txt1+="set  "+str(i)+": "
        for j in range(0,lrai[i]):
            txt1+=x[i][j]+", "
        txt1+="\n"
    txt1+="\n\n b) dominance matrix DOM\n"
    txt1+="\n\t"
    for i in range(0,hfs):
        txt1+=str(i)+"\t"
    txt1+="\n"
    for i in range(0,hfs):
        txt1+=str(i)+" :\t"
        for j in range(0,hfs):
            txt1+=str(dom[i][j])+"\t"
        txt1+="\n"
    txt1+="\n\n"
    txt1+="dominance matrix Dom (DOM(i,j)/(ni*nj)) \n"
    domnorm=rmod2.marray(hfs,hfs)
    txt1+="\t"
    for i3 in range(0,hfs):
        txt1+=str(i3)+"\t"
    txt1+="\n"    
    for i1 in range(0,hfs):
        txt1+=str(i1)+": \t"
        for i3 in range(0,hfs):
            domnorm[i1][i3]=1.0*dom[i1][i3]/(1.0*lrai[i1]*lrai[i3])
            txt1+=str(round(domnorm[i1][i3],3))+"\t"
        txt1+="\n"

    # list of values of domnorm
    listvaluesdomnorm = []
    for i1 in range(0,hfs):
        for i2 in range(0, hfs):
            if domnorm[i1][i2] in listvaluesdomnorm:
                pass
            else:
                listvaluesdomnorm.append(domnorm[i1][i2])
    listvaluesdomnorm.sort()                                     
    tpres=Tkinter.Toplevel(hf)
    tpres.title('Results of dominance analysis ')
    tresults=ScrolledText(tpres,width=80,height=10)
    tresults.pack()
    txt1+="\nlist of values of relative dominance "+"\n"
    for i in range(0,len(listvaluesdomnorm)):
        txt1+=str(round(listvaluesdomnorm[i],3))+", "
    txt1+="\n"    
    txt1+="\n c) separability matrix SEP\n"
    txt1+="\n\t"
    for i in range(0,hfs):
        txt1+=str(i)+"\t"
    txt1+="\n"
    for i in range(0,hfs):
        txt1+=str(i)+" :\t"
        for j in range(0,hfs):
            txt1+=str(sep[i][j])+"\t"
        txt1+="\n"
    txt1+"\n"
   

    sepnorm=rmod2.marray(hfs,hfs)
    txt1+="separability matrix Sep (SEP(i,j)/(ni*nj)) \n"#
    txt1+="\t"
    for i3 in range(0,hfs):
        txt1+=str(i3)+": \t"
    txt1+="\n"    
    for i1 in range(0,hfs):
        txt1+=str(i1)+": \t"
        for i3 in range(0,hfs):
            sepnorm[i1][i3]=1.0*sep[i1][i3]/(1.0*lrai[i1]*lrai[i3])
            txt1+=str(round(sepnorm[i1][i3],3))+"\t"
        txt1+="\n"
    txt1+="\n"
    txt1+="\n\n ---  end of file   ---"
    tresults.insert("end",txt1)
    
    #relative numbers of the dominance and separability matrices
    global reldom
    relat=rmod2.marray(hfs,hfs)
    
    reldom=rmod2.marray(hfs,hfs)
    relsep=rmod2.marray(hfs,hfs)
    for i in range(0,hfs):
        for j in range(0,hfs):
            relat[i][j]=lrai[i]*lrai[j]
            reldom[i][j]=1.0*dom[i][j]/(1.0*relat[i][j])
            relsep[i][j]=1.0*sep[i][j]/(1.0*relat[i][j])
    lhisto=hfs*hfs-hfs   # number of non-diagonal elements
    #rmod2.matout(hfs,hfs,relat)
    #rmod2.matout(hfs,hfs,reldom)
    histodom=rmod2.vecgen1(lhisto)
    # in histogram all values of reldom beside the diagonal ones
    z=0
    for i in range(0,hfs):
        for j in range(0,hfs):
            if i!=j:
                histodom[z]=reldom[i][j]
                z+=1
    histodom.sort()
    #print histodom
    delta=0.2
    histodomclass=rmod2.vecgen1(5)
    for z2 in range(0,5):
        for i in range(0,lhisto):
            if z2<4:                                    #changed 2.4.2011
                if delta*z2<=histodom[i]<delta*(z2+1):
                    histodomclass[z2]+=1
            else:
                if delta*z2<=histodom[i]<=delta*(z2+1):
                    histodomclass[z2]+=1
            
    #print histodomclass
    hfstat=Tkinter.Toplevel(hf)
    hfstat.title(' dds-histogram ')
    lbhfstat=Tkinter.Label(hfstat,text=' histogram ')
    lbhfstat.pack()
    frhist=Tkinter.Frame(hfstat,width=200,height=220)
    frhist.pack()
    cvhist=Tkinter.Canvas(frhist,width=200,height=220)
    cvhist.create_line(20,180,180,180)    #basic line
    cvhist.create_line(20,180,20,20)     #vertical line
    abstand=32
    for i in range(0,5):
        cvhist.create_line(15,20+abstand*i,20,20+abstand*i)
    cvhist.create_text(10,20,text=str(lhisto))
    cvhist.create_text(10,100,text=str(round(lhisto/2.0,1)))
    cvhist.create_text(10,180,text="0")
                       
    htick=rmod2.vecgen1(5)
    for i in range(0,5):
        cvhist.create_line((i+1)*32,185,(i+1)*32,180)
        htick[i]=histodomclass[i]*(160.0/(1.0*lhisto))
        cvhist.create_rectangle(22+i*32,180,50+i*32,180-htick[i],fill="blue")
        cvhist.create_text(36+i*32,190,text=str(0.1+i*0.2))
    cvhist.create_text(98,210,text="distr. of dominance degrees", font="14")
    cvhist.pack()    
        

def analysiseq():
    """the core of dds8.py
    based on object subsets the
    dominance and separability matrix
    will be calculated"""
    #Brg  31.12.07, 14.1.08, 6.4.2011, 29.03.17
    # objx is the central generalized  zeta-matrix it includes equivalencies
    
    # Excelreadin3 built in
    dm,ob,pro,r,k1=rmod2.EXCELreadin4(fn)
    

    # here we have now objred, prop and xred
    objxeq=rmod2.marray(r,r)   
    objxeq=rmod2.comp(r,k1,dm)

    #here we have the central matrix objx
    #print "ra = ",ra
    ra=confirm()          ####!!!26.7.08
    rai,x,lrai=rai_x(hfs,ra,obj)  #27.5.08
    #print "nach rai_x"
    #that is the central part: based on rai the...
    # dominance and separability degree
    dom=rmod2.marray(hfs,hfs)
    sep=rmod2.marray(hfs,hfs)
    for i1 in range(0,hfs):
        for i2 in range(0,lrai[i1]):
            for i3 in range(0,hfs):
                for i4 in range(0,lrai[i3]):
                    if objxeq[rai[i1][i2]][rai[i3][i4]]==1:
                        dom[i1][i3]+=1
    
    for i1 in range(0,hfs):
        for i2 in range(0,lrai[i1]):
            for i3 in range(0,hfs):
                for i4 in range(0,lrai[i3]):
                    if objxeq[rai[i1][i2]][rai[i3][i4]]==0 and objxeq[rai[i3][i4]][rai[i1][i2]]==0:
                        sep[i1][i3]+=1            

    tpres=Tkinter.Toplevel(hf)
    tpres.title('Results of dominance analysis ')
    tresults=ScrolledText(tpres,width=80,height=10)
    tresults.pack()
    txt1=" A n a l y s is  : Including equivalence classes "+"\n"
    txt1+="\n a): the subsets \n"
    for i in range(0,hfs):
        txt1+="set  "+str(i)+": "
        for j in range(0,lrai[i]):
            txt1+=x[i][j]+", "
        txt1+="\n"
    txt1+="\n\n b) dominance matrix DOM\n"
    txt1+="\n\t"
    for i in range(0,hfs):
        txt1+=str(i)+"\t"
    txt1+="\n"
    for i in range(0,hfs):
        txt1+=str(i)+" :\t"
        for j in range(0,hfs):
            txt1+=str(dom[i][j])+"\t"
        txt1+="\n"
    txt1+="\n\n"
    txt1+="dominance matrix Dom (DOM(i,j)/(ni*nj)) \n"
    domnorm=rmod2.marray(hfs,hfs)
    txt1+="\t"
    for i3 in range(0,hfs):
        txt1+=str(i3)+"\t"
    txt1+="\n"    
    for i1 in range(0,hfs):
        txt1+=str(i1)+": \t"
        for i3 in range(0,hfs):
            domnorm[i1][i3]=1.0*dom[i1][i3]/(1.0*lrai[i1]*lrai[i3])
            txt1+=str(round(domnorm[i1][i3],3))+"\t"
        txt1+="\n"

    # list of values of domnorm
    listvaluesdomnorm = []
    for i1 in range(0,hfs):
        for i2 in range(0, hfs):
            if domnorm[i1][i2] in listvaluesdomnorm:
                pass
            else:
                listvaluesdomnorm.append(domnorm[i1][i2])
    listvaluesdomnorm.sort()                                     
    tpres=Tkinter.Toplevel(hf)
    tpres.title('Results of dominance analysis ')
    tresults=ScrolledText(tpres,width=80,height=10)
    tresults.pack()
    txt1+="\nlist of values of relative dominance "+"\n"
    for i in range(0,len(listvaluesdomnorm)):
        txt1+=str(round(listvaluesdomnorm[i],3))+", "
    txt1+="\n"    


    txt1+="\n c) separability matrix SEP\n"
    txt1+="\n\t"
    for i in range(0,hfs):
        txt1+=str(i)+"\t"
    txt1+="\n"
    for i in range(0,hfs):
        txt1+=str(i)+" :\t"
        for j in range(0,hfs):
            txt1+=str(sep[i][j])+"\t"
        txt1+="\n"
    txt1+="\n"
   

    sepnorm=rmod2.marray(hfs,hfs)
    txt1+="separability matrix Sep (SEP(i,j)/(ni*nj)) \n"#
    txt1+="\t"
    for i3 in range(0,hfs):
        txt1+=str(i3)+": \t"
    txt1+="\n"    
    for i1 in range(0,hfs):
        txt1+=str(i1)+": \t"
        for i3 in range(0,hfs):
            sepnorm[i1][i3]=1.0*sep[i1][i3]/(1.0*lrai[i1]*lrai[i3])
            txt1+=str(round(sepnorm[i1][i3],3))+"\t"
        txt1+="\n"
    txt1+="\n"
    txt1+="\n\n ---  end of file   ---"
    tresults.insert("end",txt1)
    
    #relative numbers of the dominance and separability matrices
    global reldom
    relat=rmod2.marray(hfs,hfs)
    
    reldom=rmod2.marray(hfs,hfs)
    relsep=rmod2.marray(hfs,hfs)
    for i in range(0,hfs):
        for j in range(0,hfs):
            relat[i][j]=lrai[i]*lrai[j]
            reldom[i][j]=1.0*dom[i][j]/(1.0*relat[i][j])
            relsep[i][j]=1.0*sep[i][j]/(1.0*relat[i][j])
    lhisto=hfs*hfs-hfs   # number of non-diagonal elements
    #rmod2.matout(hfs,hfs,relat)
    #rmod2.matout(hfs,hfs,reldom)
    histodom=rmod2.vecgen1(lhisto)
    # in histogram all values of reldom beside the diagonal ones
    z=0
    for i in range(0,hfs):
        for j in range(0,hfs):
            if i!=j:
                histodom[z]=reldom[i][j]
                z+=1
    histodom.sort()
    #print histodom
    delta=0.2
    histodomclass=rmod2.vecgen1(5)
    for z2 in range(0,5):
        for i in range(0,lhisto):
            if z2<4:                                    #changed 2.4.2011
                if delta*z2<=histodom[i]<delta*(z2+1):
                    histodomclass[z2]+=1
            else:
                if delta*z2<=histodom[i]<=delta*(z2+1):
                    histodomclass[z2]+=1
            
    #print histodomclass
    hfstat=Tkinter.Toplevel(hf)
    hfstat.title(' dds-histogram ')
    lbhfstat=Tkinter.Label(hfstat,text=' histogram ')
    lbhfstat.pack()
    frhist=Tkinter.Frame(hfstat,width=200,height=220)
    frhist.pack()
    cvhist=Tkinter.Canvas(frhist,width=200,height=220)
    cvhist.create_line(20,180,180,180)    #basic line
    cvhist.create_line(20,180,20,20)     #vertical line
    abstand=32
    for i in range(0,5):
        cvhist.create_line(15,20+abstand*i,20,20+abstand*i)
    cvhist.create_text(10,20,text=str(lhisto))
    cvhist.create_text(10,100,text=str(round(lhisto/2.0,1)))
    cvhist.create_text(10,180,text="0")
                       
    htick=rmod2.vecgen1(5)
    for i in range(0,5):
        cvhist.create_line((i+1)*32,185,(i+1)*32,180)
        htick[i]=histodomclass[i]*(160.0/(1.0*lhisto))
        cvhist.create_rectangle(22+i*32,180,50+i*32,180-htick[i],fill="blue")
        cvhist.create_text(36+i*32,190,text=str(0.1+i*0.2))
    cvhist.create_text(98,210,text="distr. of dominance degrees", font="14")
    cvhist.pack()  




def graph():
    """the matrix of relevant dominance
    relation (due to the entry 'limiting value'
    is constructed and a graph is drawn """
    #brg 1.1.08
    limv=float(elim.get())
    graphdom=rmod2.marray(hfs,hfs)
    for i in range(0,hfs):
        for j in range(0,hfs):
            if reldom[i][j]>=limv:
                graphdom[i][j]=1
            else:
                graphdom[i][j]=0

    
    hfgraph=Tkinter.Toplevel(hf)
    hfgraph.title(' filtered matrix ')
    lbhfgraph=Tkinter.Label(hfgraph,text=' filtered matrix ')
    lbhfgraph.pack()
    frgr=Tkinter.Frame(hfgraph,width=400,height=400,relief="raised",bd=3)
    frgr.pack()
    txt2="\ matrix of the directed graph of subsets "
    txt2+="\n\t"
    for i in range(0,hfs):
        txt2+=str(i)+"\t"
    txt2+="\n"
    for i in range(0,hfs):
        txt2+=str(i)+" :\t"
        for j in range(0,hfs):
            txt2+=str(graphdom[i][j])+"\t"
        txt2+="\n"
    tgraph=ScrolledText(hfgraph,width=50,height=4)
    tgraph.pack()
    tgraph.insert("end",txt2)
    posx=rmod2.vecgen1(hfs)
    posy=rmod2.vecgen1(hfs)
    cvgr=Tkinter.Canvas(frgr,width=400, height=400)
    
    
    for i in range(0,hfs):
        posx[i]=100*cos(i*6.28/hfs)
        posy[i]=100*sin(i*6.28/hfs)
        
        cvgr.create_oval(160+posx[i]-20,130+posy[i]+20,160+posx[i]+20,130+posy[i]-20,fill="yellow")       
        cvgr.create_text(162+posx[i],132+posy[i],text=str(i),font = "15")

    rdgr=80
    for i in range(0,hfs):
        posx[i]=rdgr*cos(i*6.28/hfs)
        posy[i]=rdgr*sin(i*6.28/hfs)
        for j in range(0,hfs):
            posx[j]=rdgr*cos(j*6.28/hfs)
            posy[j]=rdgr*sin(j*6.28/hfs)
            if i!=j:
                if graphdom[i][j]==1:
                    cvgr.create_line(160+posx[i],130+posy[i],160+posx[j],130+posy[j],arrow="last")  #7.6.08
                    

                    
    cvgr.create_text(140,380,text=" Dominance digraph, filter = "+str(limv),font="16")
    
    cvgr.pack()
    # new 29.03.17
    classobj=rmod2.vecgen1(hfs)
    for i in range(0,hfs):
        classobj[i]=objred[rai[i][0]]   #first object as class symbol, objred
        #print "class obj ",classobj[i]
    # check for transitivity
    flagPO,txtPO=transitivity_check(graphdom,len(graphdom),classobj)
    if flagPO>0:
        tpchecktransitivity=Tkinter.Toplevel(hf)
        tpchecktransitivity.title("Result: check transitivity ")
        tchecktransitivity=ScrolledText(tpchecktransitivity,height=60,width=60)
        tchecktransitivity.pack()
        tchecktransitivity.insert("end",txtPO)
    else:
        pass


    
    
def hdgraph():
    """the matrix of relevant dominance
    relation (due to the entry 'limiting value'
    is constructed and a Hassediagram based on graphdom is drawn """
    #brg 4.7.2012
    global cov2, rred2,objred2, classobj
    limv=float(elim.get())
    try:
        perturb2=float(eperturb2.get())
    except:
        perturb2=0
    #print "perturb2= ",perturb2    
    graphdom=rmod2.marray(hfs,hfs)
    for i in range(0,hfs):
        for j in range(0,hfs):
            if reldom[i][j]>=limv:
                graphdom[i][j]=1
            else:
                graphdom[i][j]=0
    for i in range(0,hfs):
        graphdom[i][i]=1
        
    hfhdgraph=Tkinter.Toplevel(hf)
    hfhdgraph.title(' filtered matrix--> HD ')
    classobj=rmod2.vecgen1(hfs)
    for i in range(0,hfs):
        classobj[i]=objred[rai[i][0]]   #first object as class symbol, objred
        #print "class obj ",classobj[i]
    
    rred2,xred2,objred2,txteq2,eqm_act=rmod2.equivcompactgr(hfs,hfs,graphdom,classobj) #bug of Nancy
    #print "txteq in HDdds ",txteq2
    tpclassequiv=Tkinter.Toplevel(hf)
    tpclassequiv.title("Equivalent classes ")
    tclassequiv=ScrolledText(tpclassequiv,width=60, height=20)
    tclassequiv.pack()
    txt="Equivalence of classes "+"\n"
    txt+=txteq2+"\n"
    txt+=" e o f  "+"\n"
    tclassequiv.insert("end",txt)
    n=rred2
    k2=hfs
    
    
    
   
    zetahilf=rmod2.comp(n,k2,xred2)  #zeta matrix with col<row
    zeta2=rmod2.marray(rred2,rred2)
    comparabilities=0
    utotal=0
    for i in range(0,rred2):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred2):
            zeta2[i][j]=zetahilf[j][i]

    for i in range(0,rred2): #calculation of comparabilities
        for j in range(0,rred2):
            if i!=j:
                comparabilities+=zeta2[i][j]

    for i in range(0,rred2): #calculation of utotal
        for j in range(0,rred2):

            if zeta2[i][j]==0  and zeta2[j][i]==0:
                utotal+=1
    utotal=0.5*utotal            
#
    #One linear extension (based on levels)
    

    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(n,zeta2)
    #print "lobj = ",lobj
    tplev=Tkinter.Toplevel(hf)
    tplev.title(' Level population ')
    tlev=ScrolledText(tplev,width=60,height=4)  
    tlev.pack()
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
    txt1="\n"
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= classobj[lobj[i][j]]+" "  #4.7.202
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)

  
    #Adj-Listen

    adjc=rmod2.adjacent(n,lext,revlext,zeta2)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(n,adjc,lext)
       
    
    cov2=rmod2.cover(n,tr,lext)

    if n>300:
        cover_show()                  #20.1.08
    else:
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(n,levmax,zzmax)
        cv=Tkinter.Canvas(hfhdgraph,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(n,n)
        geomy=rmod2.marray(n,n)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=(perturb2*(0.5-random.random()))*geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if cov2[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-17,geomy[i][j]+17,geomx[i][j]+17,geomy[i][j]-17,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred2[lobj[i][j]])   #4.7.2012, 25.3.17
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")

        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.create_text(int(1.0*actwidth/2.0),actheight-5,text="compar.:  "+str(comparabilities)+\
                       ",   incomp. "+str(utotal))

        
       
        cv.pack()
        buttcov2=Tkinter.Button(hfhdgraph,text="show cover - relations of dds-HD ",width=25,command=cover_show)
        buttcov2.pack()

def cover_show():
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07, 25.3.17
    #note: -
    #source: -
    hfcover=Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    n=len(objred2)
    lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,n):
        txt3+="\n"+str(objred2[i])+":\t"
        txt3+="is covered by "
        for j in range(0,n):
            if i!=j:
                if cov2[i][j]==1:
                    txt3+=" "+str(objred2[j])+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=10)
    tcov.pack()
    tcov.insert("end",txt3)
    


hf=Tkinter.Tk()
hf.title(' dominance-dominance-separability ')
lbdds8=Tkinter.Label(hf,text=" Dominance-Dominance-Separability (dds) ",width=50)
lbdds8.pack(pady=5)
helpdds=raioop2.brgabout(hf,"tp1","help_ddssimpl.txt",1,\
            "March, the 29th,2017"," help_dds ", "white", "t1",120,5,ScrolledText)
    
aboutdds=raioop2.brgabout(hf,"tp1","about_ddssimpl.txt",1,\
                          "March, the 29th, 2017"," about dds ","white","t1",120,5,ScrolledText)
fr2=Tkinter.Frame(hf,width=60,height=50,relief="sunken",bd=4)
fr2.pack()
#In fr2 exclusively grid - geometry manager  (26.7.08)
buttsubmit=Tkinter.Button(fr2,text="(1) select and open file",width=25,bg="white",command=fileselect)
buttsubmit.grid(columnspan=2,row=1)
lbopen1=Tkinter.Label(fr2,text="")
lbopen1.grid(columnspan=2,row=2)
buttinfo=Tkinter.Button(fr2,text="(2a) show the representants ",width=25,command=inforep)
buttinfo.grid(columnspan=3,row=3)
buttshow=Tkinter.Button(fr2,text="(2b) show data matrix",width=25, command=showDM)
buttshow.grid(columnspan=3,row=4)
                        
lbsubset=Tkinter.Label(fr2,text="")
lbsubset.grid(columnspan=3,row=5)
lb2=Tkinter.Label(fr2,text=">>> How many subsets? >>>>")
lb2.grid(column=0,row=5)
es=Tkinter.Entry(fr2,width=3)
es.grid(column=1,row=5)
butt1=Tkinter.Button(fr2,text="(3) confirm the number of subsets",command=how_many)
butt1.grid(columnspan=3,row=6)
fr3=Tkinter.Frame(hf,relief="sunken",bd=2)
fr3.pack(pady=5)
mainprog=Tkinter.Button(fr3,text="(5a) analysis",bg="cyan",width=25,command=analysis)
mainprog.pack()
mainprogeq=Tkinter.Button(fr3,text="(5b) analysis \n(including equivalent elements) ",bg="cyan",width=25,command=analysiseq)
mainprogeq.pack()
frgraph=Tkinter.Frame(hf,width=60,height=50,relief="sunken",bd=3)
frgraph.pack()
lbgraph=Tkinter.Label(frgraph,text="(6)>>>     limiting value [0,1]  >>>>>>>")
lbgraph.grid(row=0,columnspan=3)
elim=Tkinter.Entry(frgraph,width=3)
elim.grid(row=0,column=3)
filterbutt=Tkinter.Button(frgraph,text="(7) filter process",bg="cyan",width=25,command=graph)
filterbutt.grid(row=1,columnspan=3)
lbperturb2=Tkinter.Label(hf,text="perturb dds-HD (0,1,2...)")
lbperturb2.pack()
eperturb2=Tkinter.Entry(hf,width=5)
eperturb2.pack()
butthdgraph=Tkinter.Button(hf,text="(8) Hasse diagram of classes ",bg="cyan",width=25,command=hdgraph)
butthdgraph.pack()
frperturb=Tkinter.Frame(hf)   #next lines new 3.4.2011
frperturb.pack()
lbperturb=Tkinter.Label(frperturb,text="0 for no perturb., 1,... for perturbed HDorig ")
lbperturb.pack(side="left")
eperturb=Tkinter.Entry(frperturb,width=2)
eperturb.pack(side="left")
buttHD=Tkinter.Button(hf,text=" (2c) HD ",bg="cyan",width=25,command=HD1)
buttHD.pack()
buttexit=Tkinter.Button(hf,text=" Exit ",width=25,bd=4,bg="red",command=hf.destroy)
buttexit.pack()

hf.mainloop()
