# -*- coding: cp1252 -*-
import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import tkFileDialog
import raioop2

#Brg in cooperation with Korbinian Freier, MPI Hamburg, 2.10. and 3.10.09


def fileopen():
    # brg 21.11.2011
    global dm,k,r,prop,obj,eatt
    fn=tkFileDialog.askopenfilename()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    prop=[]
    print "Originalmatrix"
    rmod2.matout(r,k,dm)
    for j in range(0,k):
        prop.append(pro[j+1])
            
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
    for i in range(0,r):
        obj[i]=ob[i+1]
        
    lb1.config(text="opened "+fn+"\nWith "+str(r)+"rows and "+str(k)+"columns",bg="yellow")
    eatt=rmod2.vecgen1(k)
    freatt.config(bg="white",bd=4,relief="sunken")
    lbeatt=Tkinter.Label(freatt,text="'in' and 'ou' resp.")
    lbeatt.grid(row=0,columnspan=k)
    for j in range(0,k):
        eatt[j]=Tkinter.Entry(freatt,width=2)
        eatt[j].grid(row=1,column=j)


def submit():
    # brg
    # two matrices will be generated:
    # an input matrix and
    # an output matrix
    # for the purpose of HD, the input matrixelements
    # will be multiplied by -1
    # 21.11.2011
    global ki,ko,kindiff,dm1,dm2
    attchar=rmod2.vecgen1(k)
    for j in range(0,k):
        attchar[j]=eatt[j].get()
    ki=0
    ko=0
    kindiff=0
    for j in range(0,k):
        if attchar[j]=="in":
            ki+=1
        elif attchar[j]=="ou":
            ko+=1
        else:
            kindiff+=1
    if kindiff>0:
        lbwarn.config(text="The attributes are not uniquely assigned to\
        'in' or 'ou'",bg="yellow")
    #print ki,ko,attchar        
    #input-matrix, outputmatrix
    
    
    dm1=rmod2.marray(r,ki)
    dm2=rmod2.marray(r,ko)
    
    for i in range(0,r):
        zi=0
        zo=0
        for j in range(0,k):
            if attchar[j]=="in":
                #print "input ",i,j,dm[i][j]
                dm1[i][zi]=dm[i][j]
                zi+=1
            elif attchar[j]=="ou":
                #print "output ",i,j,dm[i][j]
                dm2[i][zo]=dm[i][j]
                zo+=1
            else:
                pass
    # control
##    print "input"
##    rmod2.matout(r,ki,dm1)
##    print "output"
##    rmod2.matout(r,ko,dm2)
    
    
def drawHD1():
    # brg 21.11.2011
    HD(dm1,ki,r,1)    
        
def drawHD2():
    # brg 21.11.2011
    HD(dm2,ko,r,2)

def HD(matrix,cols,rows, idnr):
    """based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"""
    # Brg 20.12.07, 28.12.07, 2.10.,3.10.09
    # If the number of representants > 70 then only the cover-matrix and the level-population
    #
    hfhd=Tkinter.Toplevel(hf)
    txttitle=""
    if idnr==1:
        txttitle+="Input matrix"
    else:
        txttitle+="Output matrix"
    hfhd.title('Hasse diagram of '+txttitle)
    freq=Tkinter.Frame(hfhd,width=200,height=300)
    freq.pack()
    
    rred,xred,objred,txt,neq=rmod2.equivcompactm(rows,cols,matrix,obj)  
    
    #
    zetahilf=rmod2.comp(rred,cols,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    if rred>70:
        lbhd=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd.pack()                  
    else:
        lbhd=Tkinter.Label(freq,text=" Hasse Diagram  "+txttitle)
        lbhd.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()


def calc():
    #brg 21.11.2011, 23.11.2011
    # Note most of the next lines are
    # primitively programmed and will be replaced
    # as soon as the modul linear programming is available.
    # at the moment a highly simple MC-simulation
    import random
    from ScrolledText import ScrolledText
    istern=int(edmu.get())
    MC=r*4000
    mcspez=999*k
    ###########################    
    lamb=rmod2.vecgen1(r)
    th=rmod2.vecgen1(ki)
    sumrel=rmod2.vecgen1(ki)
    goal_inputs=rmod2.vecgen1(ki)
    resultsin=rmod2.marray(MC,r)
    resultstheta=rmod2.vecgen1(MC)
    z=0
    for mc in range(0,MC):
        for i1 in range(0,r):
            lamb[i1]=random.random()     #startwert

        sumin=rmod2.vecgen1(ki)
        sumout=rmod2.vecgen1(ko)
        flagin=rmod2.vecgen1(ki)
        flagout=rmod2.vecgen1(ko)
        
        
        #print "mc= ",mc,"   lamb= ",lamb
    
    
        for j2 in range(0,ki):
            for i1 in range(0,r):
                sumin[j2]+=dm1[i1][j2]*lamb[i1]
            #print "  sumin[",j2,"]= ",round(sumin[j2],2)   

        for j2 in range(0,ki):
            th[j2]=1.0*sumin[j2]/(1.0*dm1[istern][j2])
        thetatest=max(th)    
        for j3 in range(0,ko):
            for i1 in range(0,r):
                sumout[j3]+=dm2[i1][j3]*lamb[i1]
            
            #print "  sumout[",j3,"]= ",round(sumout[j3],2)
    
        flaginpr=1
        for j2 in range(0,ki):
            #print "theta*X0[",j2,"] = ",round(thetatest*X[0][j2],2)
            flagin[j2]=1
            if sumin[j2]>thetatest*dm1[istern][j2]:
                flagin[j2]=0
                flaginpr=flaginpr*flagin[j2]

        flagoutpr=1      
        for j2 in range(0,ko):
            flagout[j2]=1
            #print "Y[",j2,"]= ",Y[0][j2]
            if sumout[j2]<dm2[istern][j2]:
                flagout[j2]=0
                flagoutpr=flagoutpr*flagout[j2]
            
            
                
        if flaginpr==1 and flagoutpr==1:
            #print "mc= ",mc, "lamb = ",lamb    
            for i2 in range(0,r):
                resultsin[z][i2]=lamb[i2]
            resultstheta[z]=thetatest
            z+=1
       
    zmax=z
    #print zmax, " moegliche Kombinationen"
    test=9999
    for iz in range(0,zmax):
        if resultstheta[iz]<test and sum(lamb)!=0:
            mcspez=iz
            test=resultstheta[iz]
        
        
    #print mcspez, resultsin[mcspez], resultstheta[mcspez]                   

    effic=resultstheta[mcspez]
    for j2 in range(0,ki):
        for i2 in range(0,r):
            sumrel[j2]+=resultsin[mcspez][i2]*dm1[i2][j2]

    for j2 in range (0,ki):
        goal_inputs[j2]=dm1[istern][j2]-sumrel[j2]

    sumrel2=rmod2.vecgen1(ki)
    for j2 in range(0,ki):
        for i2 in range(0,r):
            if i2!=istern:
##                print "dmu ",i2
##                print "Input no ",j2
##                print "lambda= ",resultsin[mcspez]
##                print "Input = ",dm1[i2][j2]
                sumrel2[j2]+=resultsin[mcspez][i2]*dm1[i2][j2] 
    tpdea=Tkinter.Toplevel(hf)
    tpdea.title( 'naive DEA-analysis ')
    tdea=ScrolledText(tpdea,height=10, width=60)
    tdea.pack()
    txt="Results of DEA(MC) "+"\n"
    txt+=50*"=" +"\n"                    
    txt+="selected No of DMU: "+str(istern) +"\n"
    txt+="Name of the sel. dmu: "+str(obj[istern])+"\n"
    txt+= "optimal lambdas "
    txthilf=""
    for i2 in range(0,r):
        txthilf+=str(round(resultsin[mcspez][i2],3))+" "
    txthilf+="\n"
    txt+=txthilf
    txt+="\n"
    txt+= "Efficiency: =  "+str(round(effic,2))+"\n"
    txt+= " weighted sums and inputs of the selected dmu"+"\n"
    txthilf=""
    for j2 in range(0,ki):
        txthilf+=str(round(sumrel[j2],2))+"  "+str(dm1[istern][j2])+"\n"
    txthilf+="\n"    
    txt+=txthilf+"\n"
    txt+= "Efficient levels of input "+"\n"
    txthilf=""
    for j2 in range(0,ki):
        txthilf+= " Input-column No   "+str(j2)+"  efficient inputs ="+str(round(sumrel[j2],2))+"\n"
    txt+=txthilf+"\n"
    txt+="Goal inputs  "+"\n"
    txthilf=""
    for j2 in range(0,ki):
        txthilf+=" Input-column No   "+str(j2)+" goal: "+str(round(goal_inputs[j2],2))+"\n"
    txt+=txthilf+"\n"
    txt+= "- - - e o f - - - "
    tdea.insert("end",txt)


## Tkinter Plot
hf = Tkinter.Tk()
hf.title(' deaMC ')
aboutdeaMC=raioop2.brgabout(hf,"tp1","about_deaMC.txt",1,\
            "November, 21st,2011"," about deaMC ", "white", "t1",80,5,ScrolledText)
helpdeaMC=raioop2.brgabout(hf,"tp1","help_deaMC.txt",1,\
            "November, 21st,2011"," help_deaMC ", "white", "t1",80,5,ScrolledText)
    
fr=Tkinter.Frame(hf,width=60)
fr.pack()
buttopenfile = Tkinter.Button(fr, text='select, open file ',width=25,bg="cyan",command=fileopen)
buttopenfile.pack(pady=5)
lb1=Tkinter.Label(fr,text=" ",width=50)
lb1.pack()
freatt=Tkinter.Frame(hf)
freatt.pack()
lbwarn=Tkinter.Label(hf,text="")
lbwarn.pack()
buttsubmit=Tkinter.Button(hf,text="submit your selection ",bg="cyan",width=25,command=submit)
buttsubmit.pack()                          
buttdrawHD1=Tkinter.Button(hf,text="HD of Input-dm ",bg="cyan",width=25,command=drawHD1)
buttdrawHD1.pack()
buttdrawHD2=Tkinter.Button(hf,text="HD of Output-dm ",bg="cyan",width=25,command=drawHD2)
buttdrawHD2.pack()
frdmu=Tkinter.Frame(hf,bd=3,relief="sunken")
frdmu.pack(pady=3)
lbdmu=Tkinter.Label(frdmu,text="Enter dmu of interest (0,1,...,numbero of objects-1")
lbdmu.pack()
edmu=Tkinter.Entry(hf,width=10)
edmu.pack()
buttdea=Tkinter.Button(hf,text="Perform a DEA-calculation ",bg="cyan",width=25,command=calc)
buttdea.pack()
buttexit = Tkinter.Button(hf, text = 'exit', bg = 'red', width=25,command = hf.destroy)
buttexit.pack(pady=10)

hf.mainloop()

