# -*- coding: cp1252 -*-
import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import tkFileDialog
import raioop2
import random

#Brg in cooperation with Korbinian Freier, MPI Hamburg, 2.10. and 3.10.09
# 17.8.2013 dendrogram.py
# 18.8.2012 extension: meanHD
# 24.8.2013: the flat cluster generation defined by "niveau" bocomes more and more
# .......... dubious for me. Therefore a radical rearrangement.
# 25.8.2013 Major extensions
# 13.10.2013 Heuristics to find an optimal transversale
# 14.10.2013

def compcalc(z,n,listobj):
    #brg 13.10.2013
    #z zeta-matrix
    #n dimension zeta-matrix
    # listobj: list of actual to be considered objects
    comp=0
    for i in range(0,n):
        for i1 in range(0,n):
            if i in listobj and i1 in listobj:
                if zeta[i][i1]!=0:
                    comp+=1
    return comp            

def transversale(ncl,nz,cl,zetaorig,mc):
    #brg 13.10.2013, 14.10.2013
    #ncl: number of clusters
    #nz: dimension of original zetamatrix
    #cl vector with components being elements of clusters
    # for example: cl[0]=[0,1,2] : three elements, namely 0,1,2 are members of
    #... the cluster no 0.
    # zetaorig: zetamatrix of the original poset
    # mc number of Monte-Carlo runs
    
    nclmax=10
    cltest=rmod2.vecgen1(nclmax)
    for i in range(0,nclmax):
        if i<ncl:
            cltest[i]=cl[i]
        else:
            cltest[i]=[]
    

    listobj0=[]
    for i in range(0,nz):
        listobj0.append(i)
    comptestorig=compcalc(zetaorig,nz,listobj0)
    #print "comptestorig= ",comptestorig

    comptest=rmod2.vecgen1(mc)
    listobj=rmod2.vecgen1(mc)
    for mcr in range(0,mc):
        listobj[mcr]=[]
        for i in range(0,ncl):
            listobj[mcr].append(random.choice(cl[i]))
        comptest[mcr]=compcalc(zetaorig,nz,listobj[mcr])
        #print mcr,listobj[mcr],comptest[mcr]
    maxcomp=0
    
    for mcr in range(0,mc):
        
        if comptest[mcr]>=maxcomp:
            maxcomp=comptest[mcr]
            maxlistobj=[]
            for i1 in range(0,ncl):
                maxlistobj.append(listobj[mcr][i1])
    #print maxcomp,maxlistobj
    equivtransv=[]            
    for mcr in range(0,mc):
        if comptest[mcr]==maxcomp:
            if listobj[mcr] not in equivtransv:
                equivtransv.append(listobj[mcr])
    print "equivtransp ",equivtransv        
    return maxcomp,maxlistobj,equivtransv        
            


def HD():
    """based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"""
    # Brg 20.12.07, 28.12.07, 2.10.,3.10.09
    # If the number of representants > 70 then only the cover-matrix and the level-population
    #
    global fn,zeta,rred,objred
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    
    fn=tkFileDialog.askopenfilename()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    print "r= ",r,"  k= ",k
    lb1.config(text="opened "+fn,bg="yellow")
    

    prop=[]
    for j in range(0,k):
        prop.append(pro[j+1])
            
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
    for i in range(0,r):
        obj[i]=ob[i+1]

    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,dm,obj)  
    
    #
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    if rred>100:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram  ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()


def showDM():
    """  shows the data matrix """
    #Brg 13.1.08 (from dds8), 18.8.2013
    tp2=Tkinter.Toplevel(hf)
    tp2.title(' show DM ')
    lbtp2=Tkinter.Label(tp2,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+ob[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+pro[j+1]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=pro[j+1]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=ob[i+1]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)

def normdm(r,k,dm,normh):
    # brg 19.8.2013
    print "normh= ",normh
    if normh=="y":
        dmn=rmod2.matrixnorm(r,k,dm)
    else:
        dmn=rmod2.matcopy1(r,k,dm)
    rmod2.matout(r,k,dmn)    
    return dmn



def clusteranalyse():
    # brg 17.8.2013, 24.8.2013
    # straight forward to a dendrogram
    # Read in
    global linkage_matrix, rred, mat, objred, aggreg_type, plt
    dm, ob, pro, r, k = rmod2.EXCELreadin4(fn)
    print "r= ",r,"  k= ",k
    lb1.config(text="opened "+fn,bg="yellow")
    

    prop=[]
    for j in range(0,k):
        prop.append(pro[j+1])
            
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
    for i in range(0,r):
        obj[i]=ob[i+1]

    normh=enormh.get()
    dmn=normdm(r,k,dm,normh)
    
    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,dmn,obj)

    # part taken from chain_expert2_1.py
    import scipy
    import scipy.cluster.hierarchy 
    import scipy.spatial.distance 
    from scipy.cluster.hierarchy import dendrogram
    import matplotlib.pyplot as plt

    
    mat = scipy.array(xred)

    lab_act=[]
    for i in range(0,rred):
        lab_act.append(objred[i])  # 14.8.2013 chains get the identifier

    global niveau,clvec,aggreg_type
    try:
        aggreg_type=emethod.get()
    except:
        aggreg_type="average"
    methset=["single","complete","average"]
    if aggreg_type in methset:
        lbcontrol.config(text="selection: ok",bg="yellow")
    else:
        lbcontrol.config(text="+++perhaps a typos? please repeat...+++",bg="yellow")
        
    plt.title("clustering; method="+str(aggreg_type))
    linkage_matrix = scipy.cluster.hierarchy.linkage(mat,
                         aggreg_type)
##    print "linkage_matrix"
##    print linkage_matrix
##    print " "
    niveau=1.0
    clresult=scipy.cluster.hierarchy.fclusterdata(mat,niveau)
##    print "clresult "
##    print clresult
##    print clresult[3]
    lc=len(clresult)
##    print "lc= ",lc
##    print "- - - "
##    print "object-list"
##    for i in range(0,rred):
##        print "i= ",i,"  object = ",objred[i]
    R=dendrogram(linkage_matrix,
           color_threshold=0,
           labels=lab_act,
           show_leaf_counts=True)

    #print "R= ",R
    plt.show()



def clusteroutput(clresult):
    # brg 24.8.2013, 13.10.2013
    global clv0
    tpcluster=Tkinter.Toplevel(hf)
    tpcluster.title('assignment of objects to clusters ')
    tcluster=ScrolledText(tpcluster,width=60,height=20)
    tcluster.pack()
    txt="Cluster-analysis, method = "+str(aggreg_type)+"\n"
    txt+=60*"="+"\n"
    txt+="assignment to clusters "+"\n"
    txt+="clusternummber "+"\t"+"assigned objects "+"\n"
    clrefine=[]
    zcl=0
    clv=[]
    clv0=[]  #necessary to apply the new procedure transversale
    for i in range(0,rred):
        if clresult[i] not in clrefine:
            clv.append(zcl)
            clv0.append(zcl)
            clv[zcl]=[]
            clv0[zcl]=[]
            clspez=clresult[i]
            txt+=str(clresult[i])+":"+"\t"+str(objred[i])+", "
            clrefine.append(clspez)
            clv[zcl].append(objred[i])
            clv0[zcl].append(i)
            for i2 in range(i+1,rred):
                if clresult[i2]==clspez:
                    txt+=str(objred[i2])+", "
                    clv[zcl].append(objred[i2])
                    clv0[zcl].append(i2)
            txt+="\n"
            zcl+=1
    txt+="\n"
    txt+=" Number of clusters: "+str(zcl)+"\n"
    txt+="- - -    eof   - - - "
    tcluster.insert("end",txt)
    print "clvec= ",clv
    print "clv0 = ",clv0
    return clv    
    
    


def clustercheck():
    # brg 24.8.2013, 25.8.2013
    import scipy
    import scipy.cluster.hierarchy as sch
    import matplotlib.pyplot as plt
    global dcut, ind
    d = sch.distance.pdist(mat)   # vector of (100 choose 2) pairwise distances
    # information about the mutual distances, The following part
    # ...was taken from fuzzyHD14_2.py (25.8.2013)
    #print "d= ",d
    
    L = sch.linkage(d, method="single")
    LL=len(L)
    print "LL= ",LL
    print "L= ",L
    hilf=[]
    hilf2=rmod2.vecgen1(LL)
    hilf3=rmod2.vecgen1(LL)
    alpha=rmod2.vecgen1(LL)
    nn=rmod2.vecgen1(LL)
    
    for i in range(0,LL):
        hilf.append(round(L[i][2],3))
        print "i= ",i,"   cuts= ",L[i][2]
    
    hilf2,nn=rmod2.raisort(LL,hilf)
    for i in range(0,LL):
        hilf3[i]=hilf2[i]
        
    for i in range(0,LL):
        z=hilf2[i]
        for i1 in range(i+1,LL):
            if z==hilf2[i1]:
                hilf3[i1]="*"
    nr_of_cuts=0
    for i in range(0,LL):
        if hilf3[i]!="*":
            alpha[nr_of_cuts]=float(hilf3[i])
            nr_of_cuts+=1
    txt1="Count of different distances (potential cuts) = "+str(nr_of_cuts)+"\n"
    lbalpha.config(bg="yellow")
    lbalpha["text"]=txt1
    nhisto=5         #graphics  neu 20.2.08
    nal=nr_of_cuts   #graphics
    balpha=rmod2.vecgen1(nhisto)
    for j in range(0,nhisto):
        for i in range(0,nal):
            if j<nhisto-1 and j<=nhisto*alpha[i]<j+1:
                balpha[j]+=1
            if j==nhisto-1 and j<=nhisto*alpha[i]<=j+1:
                balpha[j]+=1
    histo=Tkinter.Toplevel(hf)
    histo.title(' cuts and histogram ')
    talfa=ScrolledText(histo,width=60,height=5)
    talfa.pack(expand="yes",fill="both")
    txt2="cuts\n "  #16.3.09
    for i in range(0,nal):
        if i>0 and i%20==0:                        #18.2.08
            txt2+=str(alpha[i])+" \n"
        else:
            txt2+=str(alpha[i])+"   "
    #txt+="\n"
    txt2+="\n"+"  - - -   eof  - - - "        
    talfa.insert("end",txt2)
    thisto=ScrolledText(histo,width=60,height=5)
    thisto.pack(expand="yes",fill="both")
    txt3="\n Data of histogram \n"
    txt3+="0\t0.2\t0.4\t0.6\t0.8\t1\n"    #20.2.08 may be changed if nhisto is changed
    for j in range(0,nhisto):
        txt3+=str(balpha[j])+"\t"
    txt3+="\n"
    thisto.insert("end",txt3)
    cv=Tkinter.Canvas(histo,width=200,height=230)
    for j in range(0,nhisto):
        cv.create_rectangle(20+20*j,180,30+20*j,180-(180.0/nal)*balpha[j],fill="red")
    cv.create_line(20,180,110,180)
    cv.create_rectangle(10,190,120,2)
    cv.create_text(70,210,text="histogram\ncuts")
    cv.pack()

    # now the selection of cuts:
    try:
        dcut=float(edcut.get())
    except:
        dcut=0.2
    
    
    lbcheck.config(text="dcut = "+str(dcut)+"\nMaximal distance (dissimilarity) = "+str(round(d.max(),3)))
    print "dcut= ",dcut
    ind = sch.fcluster(L, dcut, 'distance')
    lind=len(ind)
    sind=set([])
    for i1 in range(0,lind):
        sind.add(ind[i1])
    lsind=len(sind)
    lbresult.config(text="There are "+str(lsind)+"  clusters ")
    print "ind= ",ind
    
def partitioning():
    # brg 24.8.2013
    global clvec
    clvec=clusteroutput(ind)
    print "clvec = ",clvec
    lbpart.config(text="This partitioning is the basis for further results",bg="yellow")
    lbpart.pack()


def checktransvopt():
    # brg 13.10.2013
    # optimal: the idea is that that set of representants of the clusets is optimal, which
    #...induces the maximum on comparability.
    # Basically if the cluster would correspond to the level, then the chance would be to get
    #... a high number of comparability.

    mc=int(emc.get())
    print "mc= ",mc
    lcact=len(clv0)
    print "lcact= ",lcact
    mcomp,mlist, etrlist=transversale(lcact,rred,clv0,zeta,mc)
    print "optimal comparability ",mcomp-lcact
    print " a possible list ",mlist
    for i in range(0,len(mlist)):
        print objred[mlist[i]]," ",
    print " "
    tptransversale=Tkinter.Toplevel(hf)
    ttransversale=ScrolledText(tptransversale)
    ttransversale.pack()
    txt=" A transversale with an optimum of comparability "+"\n"
    txt+="...based on "+str(mc)+"  Monte Carlo-Runs "+"\n"
    txt+=30*"- "+"\n"
    txt+="Number of clusters "+str(lcact)+"\n"
    txt+="Number of comparabilities "+str(mcomp-lcact)+"\n"
    txt+=" Suggested transversale "+"\n"
    for i in range(0,len(mlist)):
        txt+=objred[mlist[i]]+", "
    txt+="\n"
    letrl=len(etrlist)
    txt+="count of transversales with maximum comparability "+str(letrl)+"\n"
    txt+="list of maximum transversales "+"\n"
    for i in range(0,letrl):
        for i1 in range(0,len(etrlist[i])):
            txt+=objred[etrlist[i][i1]]+", "
        txt+="\n"    
                        
        
    txt+="  -  -  -   e o f   -  -  -"
    ttransversale.insert("end",txt)




def inread():
    #brg 13.8.10, 25.4.2011, taken from antichain20_4
    x1=set(ex1.get().split(","))
    
    if len(x1)<=1:
        x1=x1default
    else:
        pass
        
    lx1=len(x1)
    print x1," len x1",lx1
    return x1,lx1
    
def HDcluster():
    #brg 17.8.2013
    tphdcl=Tkinter.Toplevel(hf)
    tphdcl.title(' HD based on cluster results ')
    freqcl=Tkinter.Frame(tphdcl)
    freqcl.pack()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    

    prop=[]
    for j in range(0,k):
        prop.append(pro[j+1])
            
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
    for i in range(0,r):
        obj[i]=ob[i+1]

    normh=enormh.get()
    dmn=normdm(r,k,dm,normh)
    
    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,dmn,obj)
    xact,lxact=inread()
    for i in range(0,rred):
        print objred[i],": ",
        for j in range(0,k):
            print xred[i][j],"  ",
        print " "
    print "  "    
    #x1act actual object list
    #lxact actual length ob object list
    tpinterim=Tkinter.Toplevel(hf)
    tpinterim.title(' data profiles of the selected elements ')
    tinterim=ScrolledText(tpinterim,width=80,height=10)
    tinterim.pack()
    txt=""
    txt+=60*"="+"\n"
    for ob in xact:
        iob=objred.index(ob)
        txt+=str(ob)+"\t"+str(iob)+": "
        for j in range(0,k):
            txt+=str(round(xred[iob][j],3))+"  ,"
        txt+="\n"
    txt+="\n"
    tinterim.insert("end",txt)
    print "xact ",xact
    objclus=rmod2.vecgen1(lxact)
    zahl=0
    for ob in xact:
        print "zahl= ",zahl," ",
        objclus[zahl]=ob
        print objclus[zahl]
        zahl+=1
        
    print "objclus = ",objclus
    dmnew=[]
    
    zahl=0
    for i in range(0,lxact):
        dmnew.append(float(0))
        dmnew[i]=[]
    for ob in xact:
        iob=objred.index(ob)
        for j in range(0,k):
            dmnew[zahl].append(float(xred[iob][j]))
        zahl+=1    

    print "dmnew "
    print dmnew[0][0],dmnew[0][1]
    print " "
    rmod2.matout(lxact,k,dmnew)
    #
    rredcl=lxact
    zetahilf=rmod2.comp(rredcl,k,dmnew)  #zeta matrix with col<row
    zeta=rmod2.marray(rredcl,rredcl)
    for i in range(0,rredcl):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rredcl):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rredcl,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rredcl,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rredcl,adjc,lext)
       
    
    covcl=rmod2.cover(rredcl,tr,lext)

    if rredcl>100:
        lbhdcl=Tkinter.Label(freqcl,text=" +++too many objects ++++  ",bg="yellow")
        lbhdcl.pack()                  
    else:
        lbhdcl=Tkinter.Label(freqcl,text=" Hasse Diagram  ")
        lbhdcl.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rredcl,levmax,zzmax)
        cvcl=Tkinter.Canvas(freqcl,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rredcl,rredcl)
        geomy=rmod2.marray(rredcl,rredcl)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if covcl[lobj[i1][j1]][lobj[i][j]]==1:
                            cvcl.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cvcl.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cvcl.create_text(geomx[i][j],geomy[i][j],text=objclus[lobj[i][j]])
        
        cvcl.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cvcl.create_text(garrow1x+8,garrow1y-6,text="high")
        cvcl.create_text(garrow1x+8,garrow2y-6,text="low")
        cvcl.pack()
        
def HDmeancl():
    # brg 18.8.2013
    # note, this method is only acceptable when the data are on the
    # same scaling level, namely ratio-scaled
    # Furthermore , when applying the mean-values within each cluster and a HD based on them
    # then no hierarchy-systematic can be expected.

    # basic information
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    prop=[]
    for j in range(0,k):
        prop.append(pro[j+1])
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
    for i in range(0,r):
        obj[i]=ob[i+1]


    normh=enormh.get()
    dmn=normdm(r,k,dm,normh)
    
    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,dmn,obj)

    # structure of the clustering
    lencl=len(clvec)
    print "length clvec = ",lencl
    lindivcl=rmod2.vecgen1(lencl)
    pseudoobj=[]
    for i in range(0,lencl):
        lindivcl[i]=len(clvec[i])
        pseudoobj.append(str(i))
        #print "i= ",i,"  lindivcl= ",lindivcl[i]

    #mean of each indicator within each cluster
    dmmean=rmod2.marray(lencl,k)

    for i in range(0,lencl):
        #print "cluster no ",i
        sumhilf=rmod2.vecgen1(k)
        for j in range(0,k):
            #print "Attribut no ",j
            for i1 in range(0,lindivcl[i]):
                #print "clvec= ",clvec[i]
                iob=clvec[i].index(clvec[i][i1])
                
                iobred=objred.index(clvec[i][i1])
                sumhilf[j]+=xred[iobred][j]
                #print "  i1= ",i1," object= ",clvec[i][i1],"  iob= ",iob,"  iobred= ",iobred," value= ",xred[iobred][j]
            #print sumhilf[j]    
            dmmean[i][j]=1.0*sumhilf[j]/(1.0*lindivcl[i])
        #print " "

    tpclvec=Tkinter.Toplevel(hf)
    tpclvec.title(' pseudo-obbjects representing :...')
    tclvec=ScrolledText(tpclvec,width=80,height=10)
    tclvec.pack()
    txt=" pseudocluster representing the objects..."+"\n"
    txt+="Method  "+str(aggreg_type)+"\n"
    
    txt+="Number of pseudo-objects (clusters) "+str(lencl)+"\n"
    txt+="\n"
    for i in range(0,lencl):
        txt+="pseudo-object no "+str(i)+":\t"
        for i1 in range(0,lindivcl[i]):
            txt+=str(clvec[i][i1])+", "
        txt+="\n"
    txt+="\n"
    txt+="Mean values of each cluster "+"\n"
    txt+=2*"\t"
    for j in range(0,k):
        txt+=str(prop[j])+"\t"
    txt+="\n"
    for i in range(0,lencl):
        txt+="pseudo-object no "+str(i)+":\t"
        for j in range(0,k):
            txt+=str(round(dmmean[i][j],3))+"\t "
        txt+="\n"
    txt+="\n"
    
    tclvec.insert("end",txt)
    
                        
    


    #HD
    tpmeancl=Tkinter.Toplevel(hf)
    tpmeancl.title(' HD of means of clusters ')
    freqmcl=Tkinter.Frame(tpmeancl)
    freqmcl.pack()
    rredmeancl=lencl
    #
    zetahilf=rmod2.comp(rredmeancl,k,dmmean)  #zeta matrix with col<row
    zeta=rmod2.marray(rredmeancl,rredmeancl)
    for i in range(0,rredmeancl):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rredmeancl):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rredmeancl,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rredmeancl,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rredmeancl,adjc,lext)
       
    
    covmcl=rmod2.cover(rredmeancl,tr,lext)

    if rredmeancl>100:
        lbhdmcl=Tkinter.Label(freqmcl,text=" +++too many objects ++++  ",bg="yellow")
        lbhdmcl.pack()                  
    else:
        lbhdmcl=Tkinter.Label(freqmcl,text=" Hasse Diagram of "+str(lencl)+" pseudo-objects\n"\
                              +"cluster-method "+str(aggreg_type)+"\nniveau: "+str(niveau))
        lbhdmcl.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rredmeancl,levmax,zzmax)
        cvmcl=Tkinter.Canvas(freqmcl,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rredmeancl,rredmeancl)
        geomy=rmod2.marray(rredmeancl,rredmeancl)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if covmcl[lobj[i1][j1]][lobj[i][j]]==1:
                            cvmcl.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cvmcl.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cvmcl.create_text(geomx[i][j],geomy[i][j],text=pseudoobj[lobj[i][j]])
        
        cvmcl.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cvmcl.create_text(garrow1x+8,garrow1y-6,text="high")
        cvmcl.create_text(garrow1x+8,garrow2y-6,text="low")
        cvmcl.pack()


def finalize():
    # brg 23.10.2013
    plt.close()
    hf.destroy()
    

## Tkinter Plot
hf = Tkinter.Tk()
hf.title(' dendrogram ')
global enormh
aboutHDsimpl=raioop2.brgabout(hf,"tp1","about_dendrogram.txt",2,\
            "August, the 19th,2013"," about dendrogram", "white", "t1",80,5,ScrolledText)
helpHDsimpl=raioop2.brgabout(hf,"tp1","help_dendrogram.txt",2,\
            "August, the 19th,2013"," help_dendrogram ", "white", "t1",80,5,ScrolledText)
    
fr=Tkinter.Frame(hf,width=60)
fr.pack()
buttHD = Tkinter.Button(fr, text='select, open and HD',width=25,bg="cyan",command=HD)
buttHD.pack(pady=5)
lb1=Tkinter.Label(fr,text=" ",width=50)
lb1.pack()
buttshow=Tkinter.Button(fr,text="Show data matrix ",width=25,bg="cyan",command=showDM)
buttshow.pack()
frnorm=Tkinter.Frame(fr)
frnorm.pack()
lbnorm=Tkinter.Label(frnorm,text="columnwise normalize (y,n) ")
lbnorm.pack(side="left")
enormh=Tkinter.Entry(frnorm,width=2)
enormh.pack(side="right")


lbcluster=Tkinter.Label(fr,text="Enter the method: single, average, complete ")
lbcluster.pack()
emethod=Tkinter.Entry(fr,width=10)
emethod.pack()
lbcontrol=Tkinter.Label(fr,text="")
lbcontrol.pack()
buttcluster=Tkinter.Button(fr,text="Clusteranalyse of the data matrix ",bg="cyan",width=25,command=clusteranalyse)
buttcluster.pack()
lbcut=Tkinter.Label(fr,text=" determine the cut level")
lbcut.pack()
edcut=Tkinter.Entry(fr,width=5)
edcut.pack()
lbcheck=Tkinter.Label(fr,text="")
lbcheck.pack()
buttcheck=Tkinter.Button(fr,text="check clusters ",width=25,command=clustercheck)
buttcheck.pack()
lbalpha=Tkinter.Label(fr,text="") 
lbalpha.pack()
lbresult=Tkinter.Label(fr,text="")
lbresult.pack()
buttpartit = Tkinter.Button(fr, text="Cluster-partitioning \nat actual cut-level ",
                          bg="cyan", width=25, command=partitioning)
buttpartit.pack()
lbtrans = Tkinter.Label(fr, text="Enter the number of Monte-Carlo-runs ")
lbtrans.pack()
emc = Tkinter.Entry(fr, width=5)
emc.pack()
butttransversale = Tkinter.Button(fr, text="which representants\n \
                                  render a max of comp ",
                                  bg="cyan", width=25, command=checktransvopt)
butttransversale.pack()
lbpart = Tkinter.Label(fr, text="")
lbpart.pack()
lbex = Tkinter.Label(fr,
                     text="Enter the objects you want: \
                     either of one cluster, \nor a traverse \
                     through all clusters ")
lbex.pack()
ex1 = Tkinter.Entry(fr, width=40)
ex1.pack()
buttHDcl = Tkinter.Button(fr,
                          text=" HD of selected elements \n \
                          of clusteranalysis ",
                          bg="cyan", width=25, command=HDcluster)
buttHDcl.pack()
buttHDmean = Tkinter.Button(fr,
                            text="HD of pseudo-objects \n"
                            + "(mean values among \n"
                            + "the objects of any cluster)",
                            bg="cyan", width=25, command=HDmeancl)
buttHDmean.pack()
buttexit = Tkinter.Button(fr, text='exit', bg='red',
                          width=25, command=finalize)
buttexit.pack(pady=10)

hf.mainloop()
