import raioop2
import Tkinter
from ScrolledText import *
import tkFileDialog
import Canvas
import os
from math import *
import stats
import pstat
import rmod2

# info about differences taken over all pairs of object for each indicator
#  31.7.2013 : brg  differences1.py (motivated by Professor Kerber)
# Output vectorial



def fileselect():
    """ File selection (PyHasse format) and opening by Tkinter-Standards"""
    # actual: 12.2.18
    #note: There may be conflicts with other moduls
    #source:-
    #tp=Tkinter.Toplevel(hf)   #18.2.08
    global fn,dm,r,k,obj,prop, dmn
    fn=tkFileDialog.askopenfilename()
    
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    
    lbopen1.config(bg="yellow")
    lbopen1["text"]="selected file : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns"
    obj=rmod2.vecgen1(r)
    prop=rmod2.vecgen1(k)
    for i in range(0,r):
        obj[i]=ob[i+1]
    for j in range(0,k):
        prop[j]=pro[j+1]
    dmn=rmod2.matrixnorm(r,k,dm)

         
def showDM():
    """ New routine : shows the data matrix """
    #Brg 13.1.08, 12.02.2018
    
    tp2=Tkinter.Toplevel(hf)
    tp2.title(' show DM ')
    lbtp2=Tkinter.Label(tp2,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=20)
    tfile.pack()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    dmn=rmod2.matrixnorm(r,k,dm)
    txt1="dm normalized \n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+ob[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+pro[j+1]+",\t"
    txt2+="\n"
    txt3="\n data matrix, normalized  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=pro[j+1]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=ob[i+1]+"\t"
        for j in range(0,k):
            txt3+=str(round(dmn[i][j],3))+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)


def HD():
    """based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"""
    # Brg 20.12.07, 28.12.07, 2.10.,3.10.09
    # If the number of representants > 70 then only the cover-matrix and the level-population
    #
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    
    
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    print "r= ",r,"  k= ",k
    
    

    prop=[]
    for j in range(0,k):
        prop.append(pro[j+1])
            
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
    for i in range(0,r):
        obj[i]=ob[i+1]

    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,dm,obj)  
    
    #
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    if rred>100:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram  ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()



def calc():
    # brg 31.7.2013, 12.02.2018
    
    
    ld=int((r*(r-1))/2.0)
    objpair=rmod2.vecgen1(ld)
    differences=rmod2.marray(ld,k)
    print "  ld = ",ld
    print "r= ",r,"   k= ",k
    zahl=0    
    for i1 in range (0,r):
        for i2 in range(i1+1,r):
            #print "i1= ",i1,"  i2  = ",i2,"   zahl= ",zahl
            for j in range(0,k):
                differences[zahl][j]=dmn[i1][j]-dmn[i2][j]
            objpair[zahl]=str(obj[i1])+" - "+str(obj[i2])
            zahl+=1
    
    print " count of mutual differences ",zahl        
    return differences,objpair            


def output():
    # brg 31.7.2013, 12.02.2018
    diff,op=calc()
    try:
        att=eatt.get()
    except:
        print "wrong attributname  ",att
        att=str(prop[0])
        lbwarn.config(text="Correct selection ",bg="green")
    if att not in prop:
        lbwarn.config(text="+++ selected attribute name is not correct  +++",bg="yellow")
    else:
        lbwarn.config(text="Correct selection ",bg="green")
        iatt=prop.index(att)
        ld=int((r*(r-1))/2.0)
        hilf1=rmod2.vecgen1(ld)
        hilf2=rmod2.vecgen1(ld)
        hilf3=rmod2.vecgen1(ld)
        hilf4=rmod2.vecgen1(ld)
        for i in range(0,ld):
            hilf1[i]=diff[i][iatt]
            hilf2[i]=diff[i][iatt]
            hilf3[i]=diff[i][iatt]
            hilf4[i]=diff[i][iatt]
            
        maxdiff=-9999
        maxabsdiff=-9999
        mindiff = 9999
        minabsdiff = 9999
        for i1 in range(0,ld):
            if hilf1[i1]>maxdiff:
                maxdiff=hilf1[i1]
                imax=i1
        print "imax= ", imax,"   op= ",op[imax]        
        for i2 in range(0,ld):        
            if abs(hilf2[i2])>maxabsdiff:
                maxabsdiff=abs(hilf2[i2])
                iabsmax=i2
        for i3 in range(0,ld):        
            if hilf3[i3]<mindiff:
                mindiff=hilf3[i3]
                imin=i3
        print "imin= ", imin,"   op= ",op[imin]        
        for i4 in range(0,ld):        
            if abs(hilf4[i4])<minabsdiff:
                   minabsdiff=abs(hilf4[i4]) 
                   iabsmin=i4
##        meanact=pstat.lmean(hilf)
##        medianact=pstat.lmedian(hilf)
        #stdev=pstat.stdev(hilf)
        tpinfo=Tkinter.Toplevel(hf)
        tpinfo.title(' differences and characteristics ')
        txt=" differences , concerning the selected attribut: "+"'"+str(att)+"'"+"\n"
        txt+=60*"=" +"\n"
        txt+=" Max difference = "+str(round(maxdiff,3))+"\t"+" belonging to "+str(op[imax])+"\n"
        txt+=" Min difference = "+str(round(mindiff,3))+"\t"+" belonging to "+str(op[imin])+"\n"
        txt+=" Max (absolute) diffence = "+str(round(maxabsdiff,3))+"\t"+"  belonging to " + str(op[iabsmax])+"\n"
        txt+=" Min (absolute) diffence = "+str(round(minabsdiff,3))+"\t"+"  belonging to " + str(op[iabsmin])+"\n"
        txt+="  "+"\n"
        txt+=" List of differences "+"\t"+"abs(differences) "+"\n"
        for i in range(0,ld):
            txt+=str(op[i])+"\t"+str(round(hilf1[i],3))+"\t"+str(round(abs(hilf2[i]),3))+"\n"
        txt+=" - - -   e o f - - - "+"\n"    
        tinfo=ScrolledText(tpinfo,height=20,width=80)
        tinfo.pack()
        tinfo.insert("end",txt)

def covdiff():
    # brg 01.08.2013, 12.02.2018
    # calculation of cover-matrix
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    print "r= ",r,"  k= ",k
    dmn=rmod2.matrixnorm(r,k,dm)
    

    prop=[]
    for j in range(0,k):
        prop.append(pro[j+1])
            
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
    for i in range(0,r):
        obj[i]=ob[i+1]

    rred,xredn,objred,txt,neq=rmod2.equivcompactm(r,k,dmn,obj)  
    
    #
    zetahilf=rmod2.comp(rred,k,xredn)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
    
    cov=rmod2.cover(rred,tr,lext)
    for i1 in range(0,rred):   #to be sure that differences of obj x with obj x will be excluded
        cov[i1][i1]=0

    # calculation of differences, now in the framework of representatives
    ldred=rred*rred
    objredpair=rmod2.vecgen1(ldred)
    objtrace=rmod2.vecgen1(ldred)
    diffcov=rmod2.marray(ldred,k)
    print "  ld = ",ldred
    print "r= ",r,"   k= ",k
    zahl=0    
    for i1 in range (0,rred):
        for i2 in range(0,rred):
            #print "i1= ",i1,"  i2  = ",i2,"   zahl= ",zahl
            for j in range(0,k):
                diffcov[zahl][j]=xredn[i1][j]-xredn[i2][j]
            objredpair[zahl]=str(objred[i1])+" - "+str(objred[i2])
            objtrace[zahl]=(objred[i1],objred[i2])
            zahl+=1
    
    print " count of mutual differences ",zahl        
    print "objttace  ",objtrace
    #output
    try:
        att=eatt2.get()
    except:
        print "wrong attributname  ",att
        att=str(prop[0])
        lbwarn2.config(text="Correct selection ",bg="green")
    if att not in prop:
        lbwarn2.config(text="+++ selected attribute name is not correct  +++",bg="yellow")
    else:
        lbwarn2.config(text="Correct selection ",bg="green")
        iatt=prop.index(att)
        
        hilfred=[]
        objpairact=[]
        for i in range(0,ldred):
            iob1=objred.index(objtrace[i][0])
            iob2=objred.index(objtrace[i][1])
            print "iob1 = ",iob1,"   iob2= ",iob2
            print "objtrace 1",objtrace[i][0],"  objtrace 2 = ",objtrace[i][1]
            print "cov= ",cov[iob1][iob2]
            if cov[iob1][iob2]==1:
                hilfred.append(diffcov[i][iatt])
                objpairact.append(str(objtrace[i][0])+"  -  "+str(objtrace[i][1]))
        lhilfred=len(hilfred)        
        print "lhilfred = ",lhilfred
        print "hilfred   ",hilfred
        maxdiff=-999999
        maxabsdiff=-999999
        mindiff=999999
        minabsdiff=999999
        for i in range(0,lhilfred):
            dummy=hilfred[i]
            if dummy>maxdiff:
                maxdiff=dummy
                imax=i
            if abs(dummy)>maxabsdiff:
                maxabsdiff=abs(dummy)
                iabsmax=i
            if dummy<mindiff:
                mindiff=dummy
                imin=i
            if abs(dummy)<minabsdiff:
                   minabsdiff=abs(dummy) 
                   iabsmin=i

        tpinfo2=Tkinter.Toplevel(hf)
        tpinfo2.title(' differences and characteristics; cov-filter ')
        txt=" differences , concerning the selected attribut: "+"'"+str(att)+"'"+"\n"
        txt+=60*"=" +"\n"
        txt+=" Max difference = "+str(maxdiff)+"\t"+" belonging to "+str(objpairact[imax])+"\n"
        txt+=" Min difference = "+str(mindiff)+"\t"+" belonging to "+str(objpairact[imin])+"\n"
        txt+=" Max (absolute) diffence = "+str(maxabsdiff)+"\t"+"  belonging to " + str(objpairact[iabsmax])+"\n"
        txt+=" Min (absolute) diffence = "+str(minabsdiff)+"\t"+"  belonging to " + str(objpairact[iabsmin])+"\n"
        txt+="  "+"\n"
        txt+=" List of differences "+"\t"+"abs(differences) "+"\n"
        for i in range(0,lhilfred):
            txt+=str(objpairact[i])+"\t"+str(hilfred[i])+"\t"+str(abs(hilfred[i]))+"\n"
        txt+=" - - -   e o f - - - "+"\n"    
        tinfo2=ScrolledText(tpinfo2,height=20,width=80)
        tinfo2.pack()
        tinfo2.insert("end",txt)

def calcvec():
    # brg 8.8.2013
    # Prof. Kerber suggested this in order...
    # ...to get a tool to understand the fuzzy operations
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    print "r= ",r,"  k= ",k
    dmn=rmod2.matrixnorm(r,k,dm)
    

    prop=[]
    for j in range(0,k):
        prop.append(pro[j+1])
            
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
    for i in range(0,r):
        obj[i]=ob[i+1]

    rred,xredn,objred,txt,neq=rmod2.equivcompactm(r,k,dmn,obj)  
    
    #
    zetahilf=rmod2.comp(rred,k,xredn)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
    
    cov=rmod2.cover(rred,tr,lext)
    for i1 in range(0,rred):   #to be sure that differences of obj x with obj x will be excluded
        cov[i1][i1]=0

    # calculation of differences, now in the framework of representatives
    
    objtrace2=[]
    diffcov2=[]
    
    zahl=0
    sumdiff=[]
    for i1 in range (0,rred):
        for i2 in range(0,rred):
            if cov[i1][i2]==1:
                x2=[]
                dummysum=0
                for j in range(0,k):
                    x2.append(xredn[i1][j]-xredn[i2][j])
                    dummysum+=abs(xredn[i1][j]-xredn[i2][j])
                diffcov2.append(x2)
                sumdiff.append(dummysum)
                objtrace2.append((objred[i1],objred[i2]))
                zahl+=1
    
    print " count of mutual differences ",zahl        
    print "objtrace  ",objtrace2
    print "diffcov2 ",diffcov2
    print "  "
##    for i2 in range(0,rred):
##        print objred[i2],
##    print " "    
##    for i1 in range(0,rred):
##        print objred[i1],
##        for i2 in range(0,rred):
##            print cov[i1][i2],
##        print " "              
    ldiffcov2=len(diffcov2)
    tpdiff2=Tkinter.Toplevel(hf)
    tpdiff2.title(' output vectorial for each obj-pair obeying the cover relation ')
    tdiff2=ScrolledText(tpdiff2,width=80,height=10)
    tdiff2.pack()
    txt=" Differences of each object pair which obeys the cover relation "+"\n"
    txt+=60*"="+"\n"
    txt+="Number of object-pairs "+str(ldiffcov2)+"\n"
    txt+="obj-pair"+"\t"+"   differences   "+"\t"+"sum of abs(differences)"+"\n"
    for ii in range(0,ldiffcov2):
        txthilf1=""
        txthilf1+=str(objtrace2[ii][0])+", "+str(objtrace2[ii][1])+": "
        txthilf2=""
        for j in range(0,k):
            txthilf2+=str(round(diffcov2[ii][j],3))+", "
        txt+=txthilf1+"\t"+txthilf2+"\t"+str(round(sumdiff[ii],3))
        txt+="\n"
    txt+=" - - -    e o f    - - - "    
    tdiff2.insert("end",txt)

def calcvec2():
    # brg 8.8.2013, 9.8.2013
    # Prof. Kerber suggested this in order...
    # ...to get a tool to understand the fuzzy operations
    #...here: the role of incomparable pairs
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    dmn=rmod2.matrixnorm(r,k,dm)
    print "r= ",r,"  k= ",k
    
    

    prop=[]
    for j in range(0,k):
        prop.append(pro[j+1])
            
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
    for i in range(0,r):
        obj[i]=ob[i+1]

    rred,xredn,objred,txt,neq=rmod2.equivcompactm(r,k,dmn,obj)  
    
    #
    zetahilf=rmod2.comp(rred,k,xredn)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
    
    cov=rmod2.cover(rred,tr,lext)
    for i1 in range(0,rred):   #to be sure that differences of obj x with obj x will be excluded
        cov[i1][i1]=0

    # calculation of differences, now in the framework of representatives
    
    objtrace3=[]
    diffcov3=[]
    
    zahl=0
    sumdiff3=[]
    for i1 in range (0,rred-1):
        for i2 in range(i1+1,rred):
            if cov[i1][i2]==0 and cov[i2][i1]==0:
                x3=[]
                dummysum=0
                for j in range(0,k):
                    x3.append(xredn[i1][j]-xredn[i2][j])
                    dummysum+=abs(xredn[i1][j]-xredn[i2][j])
                diffcov3.append(x3)
                sumdiff3.append(dummysum)
                objtrace3.append((objred[i1],objred[i2]))
                zahl+=1
    
    print " count of mutual differences ",zahl        
    print "objtrace  ",objtrace3
    print "diffcov2 ",diffcov3
    print "  "
    ac=eac.get().split(",")
    print "ac= ",ac
    ldiffcov3=len(diffcov3)
    tpdiff3=Tkinter.Toplevel(hf)
    tpdiff3.title(' output vectorial for obj-pairs x||y ')
    tdiff3=ScrolledText(tpdiff3,width=80,height=20)
    tdiff3.pack()
    txt=" Differences of each object pair x||y "+"\n"
    txt+=60*"="+"\n"
    txt+="Number of object-pairs "+str(ldiffcov3)+"\n"
    txt+="obj-pair"+"\t"+"   differences   "+"\n"
    
    for iob1 in range(0, len(ac)):
        iob1aktuel=objred.index(ac[iob1])
        for iob2 in range(iob1+1,len(ac)):
            iob2aktuel=objred.index(ac[iob2])              
            txthilf1=""
            txthilf1+=str(objred[iob1aktuel])+", "+str(objred[iob2aktuel])+": "
            txthilf2=""
            for j in range(0,k):
                delta=abs(dmn[iob1aktuel][j]-dmn[iob2aktuel][j])
                txthilf2+=str(round(delta,3))+", "  
            txt+=txthilf1+"\t"+txthilf2
            txt+="\n"
            
    txt+=" - - -    e o f    - - - "    
    tdiff3.insert("end",txt)
    


    

hf=Tkinter.Tk()
hf.title(' GUI of "differences "')
helpdiff=raioop2.brgabout(hf,"tp1","help_diff.txt",2,\
            "February, the 12th,2018"," help_differences ", "white", "t1",80,5,ScrolledText)
    
aboutdiff=raioop2.brgabout(hf,"tp1","about_diff.txt",1,\
            "February, the 12th,2018"," about_differences ", "white", "t1",80,5,ScrolledText)    

buttopen=Tkinter.Button(hf,text="Select and open file (PyHasse format)",bg="cyan",width=40,command=fileselect)
buttopen.pack()
lbopen1=Tkinter.Label(hf,text="")
lbopen1.pack()
lbnote=Tkinter.Label(hf, text="columnwise [0,1]-normalized data ")
lbnote.pack()
buttshowDatamatrix=Tkinter.Button(hf,text="Show data matrix ",bg="cyan",width=40,command=showDM)
buttshowDatamatrix.pack()
buttHD=Tkinter.Button(hf,text="Show Hassediagram ",bg="cyan",width=40,command=HD)
buttHD.pack()
lbatt=Tkinter.Label(hf,text="Below: Entry field for attribute name")
lbatt.pack()
eatt=Tkinter.Entry(hf,width=10)
eatt.pack()
lbwarn=Tkinter.Label(hf,text="")
lbwarn.pack()
buttoutput=Tkinter.Button(hf,text="Info about differences ",bg="cyan",width=40,command=output)
buttoutput.pack()
lbAC=Tkinter.Label(hf,text="Entry field for AC to be analyzed")
lbAC.pack()
eac=Tkinter.Entry(hf,width=20)
eac.pack()
buttoutput2=Tkinter.Button(hf,text="Info about differences/ncover-filter applied",bg="cyan",width=40,command=covdiff)
buttoutput2.pack()
buttcalc=Tkinter.Button(hf,text="Differences in vectorial form (cov-relation)",bg="cyan",command=calcvec)
buttcalc.pack()
buttcalc2=Tkinter.Button(hf,text="Differences in vectorial form (x||y)",bg="cyan",command=calcvec2)
buttcalc2.pack()
buttexit=Tkinter.Button(hf,text=" Exit   ",bg="red",width=40,command=hf.destroy)
buttexit.pack(pady=5)



hf.mainloop()
