import Tkinter
import tkFileDialog
from ScrolledText import *
import Canvas
import rmod2
import raioop2
import psyco

psyco.full()


#Brg 17.9.09 derived from sensi11.py
# hdgt : hasse diagrams and graph theoretical analysis
# 30.9.09 cont'd
# 3.10., 4.10.09, 5.10.09 (cosmetics in GUI)
# 20.10.09 LPOM0-model included
# 15.3.2011 some cosmetics
# 2.3.2012 Rearrangements



def about():
    """ About sensi """
    # Brg 16.8.08
    aboutsensi=raioop2.brgabout(hf,"tp2","about_hdgt.txt",4,\
            "October 4th,2009"," about_hdgt ", "white", "t2",60,3,ScrolledText)
    

def raihelp():
    """ Help about hdgt """
    
    #  Use of OOP
    helpsensi=raioop2.brgabout(hf,"tp1","help_hdgt.txt",4,\
            "October, 4th, 2009"," help_hdgt ", "white", "t1",80,5,ScrolledText)

def File_select():
    """select a file and open it """
    #Brg 17.1.08
    #*:17.1.08
    #akt: 17.1.08
    global dm,ob,obj,pro,prop,r,k,fn
    fn=tkFileDialog.askopenfilename()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    lbopen.config(bg="yellow")
    lbopen["text"]="File "+fn+"\n opened with "+str(r)+" rows \n and "\
                         +str(k) +" columns"
    lbopen.pack()

    obj=rmod2.vecgentext1(r)                        #29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  #recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pro[i+1]   #recoding, because pro[0] is a dummy string
    return 

def showDM():
    """shows the DM"""
    # taken from fuzzyHD7
    tp2a=Tkinter.Toplevel(hf)
    tp2a.title(' show DM ')
    lbtp2=Tkinter.Label(tp2a,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2a,width=60,height=4)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)    

def filecomp(r,dm,pro,fn):
    """ reduces a dm with equiv objects to a dm of a quotient set """
    # Brg 12.12.07, 13.1.08, 8.5.08
    #r,k,dm,ob,pro,fn are globals and should be available after open
    
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    #recoding ob to obj and pro to prop
    if r==0:
        hfwarning=Tkinter.Toplevel(hf)
        hfwarning.title(' ++warning++ ')
        frwarning=Tkinter.Frame(hfwarning,width=10,height=3)
        frwarning.pack()
        bwarning=Tkinter.Button(frwarning,text="++warning ++",command=msgwarning)
        bwarning.pack()
        
    prop=rmod2.vecgentext1(k)
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
    for i in range(0,k):
        prop[i]=pro[i+1]
    for i in range(0,r):
        obj[i]=ob[i+1]
    #############################dieser Teil ist neu 21.12.07
    rred,xred,objred,txt=rmod2.equivcompact(r,k,dm,obj)    
    ###############################################################
    #print objred
    #print "reduzierte matrix"
    #rmod2.matout(rred,k,xred)
    return rred,xred,objred,obj,prop,txt           

def showinc():
    #Brg 4.10.09, 2.3.2012
    # Characterization for the single selected element index: obs
    tprkav2=Tkinter.Toplevel(hf)
    trkav2=ScrolledText(tprkav2,width=120,height=10)
    trkav2.pack()
    try:
        obs=eobs.get()
        iobs=objred.index(obs)
    except:
        obs="1st el"
        iobs=0                   #Default: the first element in internal labelling
        

    hinc=[]
    pdownvec=[]
    pupvec=[]
    txtindiv="Indivual contributions (see also histogram)\n\n "
    txtindiv+=60*"="+"\n"

    for y in Ua[iobs]:
            
            Uy=[]
            Pdown=0
            Pup=0
            
            if y!=-1:
                #print "y in increment loop: ",objred[y]
                for i1 in range(0,rred):
                    if zeta[i1][y]==0 and zeta[y][i1]==0:
                        Uy.append(i1)
                
                for x in Uy:
                    if x in Sa[iobs]:
                        Pdown+=1
                            
                for x in Uy:
                    if x in Pa[iobs]:
                        Pup+=1
                pdownvec.append(Pdown)
                pupvec.append(Pup)
                dinc=1.0*Pdown/(1.0*Pdown+1.0*Pup)
                hinc.append(dinc)
                
   
    lh=len(hinc)
    txth=""
    for y in Ua[iobs]:
        if y!=-1:
            #print y," ",
            txth+=objred[y]+"    :\t"
        
        Uys=[]
        Pdowns=[]
        Pups=[]
        if y!=-1:
                for i1 in range(0,rred):
                    if zeta[i1][y]==0 and zeta[y][i1]==0:
                        Uys.append(i1)
                
                for x in Uys:
                    if x in Sa[iobs]:
                        Pdowns.append(x)
                            
                for x in Uys:
                    if x in Pa[iobs]:
                        Pups.append(x)

                txth+="\nUys("+objred[y]+"):\t\t"
                for i in range(0,len(Uys)):
                    txth+=objred[Uys[i]]+"\t"
                txth+="\nPdowns("+objred[y]+"):\t\t"
                for ihilf in Pdowns:
                    txth+=objred[ihilf]+"\t"
                txth+="\nPups("+objred[y]+"):\t\t"
                for ihilf in Pups:
                    txth+=objred[ihilf]+"\t"
                txth+="\n"
        txth+="\n"
    
    txtindiv+=txth
    txtindiv+="\n"+"- - - e o f - - -"
    trkav2.insert("end",txtindiv)
    lua=len(Ua[iobs])
    texth=[]
    for i in range(0,lua):
        if Ua[iobs][i]!=-1:
            texth.append(objred[Ua[iobs][i]])
    app=raioop2.brgbar6(tprkav2,hinc,texth," ","contribution of incomparables of "+obs,17)
    app.ausgabe()

def SaPaUa():
    #Brg 30.9.09, 2.3,2012
    global Ua,Sa,Pa
    Sa=rmod2.marray1(rred,rred,-1)
    Pa=rmod2.marray1(rred,rred,-1)
    Ua=rmod2.marray1(rred,rred,-1)
    countSa=rmod2.vecgen1(rred)
    countPa=rmod2.vecgen1(rred)
    countUa=rmod2.vecgen1(rred)
    alpha=1  #parameters to be determined by statistical techniques
    beta=0  #parameters to be determined by statistical techniques
    for ob in objred:
        obi=objred.index(ob)
        
        #obi the selected element whose rkav will be deternmined
        z=0
        for i1 in range(0,rred):
            if zeta[i1][obi]==1:
                z+=1
                Sa[obi][i1]=i1
        #print "ob = ",ob,"  its order ideal:  ",Sa[obi]
        countSa[obi]=z
    for ob in objred:
        obi=objred.index(ob)
        
        #obi the selected element whose rkav will be deternmined
        z=0
        for i1 in range(0,rred):
            if zeta[obi][i1]==1:
                z+=1
                Pa[obi][i1]=i1
        #print "ob = ",ob,"  its order filter:  ",Pa[obi]
        countPa[obi]=z
    for ob in objred:
        obi=objred.index(ob)
        
        #obi the selected element whose rkav will be deternmined
        z=0
        for i1 in range(0,rred):
            if zeta[i1][obi]==0 and zeta[obi][i1]==0:
                z+=1
                Ua[obi][i1]=i1
        #print "ob = ",ob,"  its incomparables  ",Ua[obi]
        countUa[obi]=z

    #rmod2.matout(rred,rred,Ua)
    hav=rmod2.vecgen1(rred)    
    txt="General information \n "
    txt+=60*"="+"\n"
    txt+=" Elements in principal:\t order ideal\t order filter:\t incomparables\tLPOM0avrk\n" 
    for obi in range(0,rred):
        hav[obi]=1.0*countSa[obi]*(rred+1)/(1.0*(rred+1-countUa[obi]))
        txt+= "obj "+objred[obi]+":\t\t\t  "+str(countSa[obi])+"\t\t"+str(countPa[obi])+"\t\t"+str(countUa[obi])+"\t\t"+str(round(hav[obi],3))+"\n"
        
    
    rkav=rmod2.vecgen1(rred)
    for i2 in range(0,rred):
        rkav[i2]=countSa[i2]  #note Sa includes the interesting element a too
    txt+="\n\n"
    txt+=" R k a v  b y   LPOMext (Match, 2011)"+"\n"
    txt+=60*"="+"\n"
    txt+="\n Object\tRkav (LPOMext)\tminRank\tincrement\n"
    txt+=60*"-"+"\n"
    
    #print " "
    for ob in objred:
        obi=objred.index(ob)
        increment=0
        
        for y in Ua[obi]:
            #print "y in increment loop: ",objred[y]," ",
            Uy=[]
            Pdown=0
            Pup=0
            
            if y!=-1:
                for i1 in range(0,rred):
                    if zeta[i1][y]==0 and zeta[y][i1]==0:
                        Uy.append(i1)
                
                for x in Uy:
                    if x in Sa[obi]:
                        Pdown+=1
                            
                for x in Uy:
                    if x in Pa[obi]:
                        Pup+=1
                
                dinc=1.0*Pdown/(1.0*Pdown+1.0*Pup)
                
                increment+=dinc
                #print "obi = ",obi,"  y= ",y,"  Pdown= ",Pdown,"   Pup = ",Pup
        rkav[obi]+=alpha*increment+beta
        txt+=ob+":\t"+str(round(rkav[obi],3))+"\t\t"+str(countSa[obi])+"\t\t"+str(round(increment,3))+"\n"
    txt+="\n\n\n"
    
    
    txth=" "
    tprkav=Tkinter.Toplevel(hf)
    trkav=ScrolledText(tprkav,width=150,height=10)
    trkav.pack()
    txt+="\n\t"+"- - -  E O F - - - "
    trkav.insert("end",txt)
    
    
    

def HD():
    "based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"
    # Brg 20.12.07, 28.12.07
    # If the number of representants > 20 then only the cover-matrix and the level-population
    # This module I took from mainHD5
    # 8.6.08 
    global zeta,zeta2,rred,n,objred    
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    global fn
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    rred,xred,objred,obj,prop,txt=filecomp(r,dm,pro,fn)
    n=rred
    labeq=Tkinter.Label(freq,text="file = "+fn+": calc. is based on representants ")
    labeq.config(bg="yellow")
    labeq.pack()

    #
    zetahilf=rmod2.comp(n,k,xred)
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    lbhd1=Tkinter.Label(freq,text= "Level ")
    lbhd1.pack()

    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(n,zeta)
    #print "zzmax = ",zzmax
    tlev=ScrolledText(freq,width=60,height=4)
    tlev.pack()
    txt1="\n"
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= objred[lobj[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)

    txt2="\n One linear extension \n\n"
    for i in range(0,n):
        if i<n-1:
            txt2+=objred[revlext[i]]+" < "
        else:
            txt2+=objred[revlext[i]]+"\n"
    txt2+="\n"
    txt2+="\n -- end of list -- "
    tlinext=ScrolledText(freq,width=60, height=2)
    tlinext.pack()
    tlinext.insert("end",txt2)
    
    #Adj-Listen

    adjc=rmod2.adjacent(n,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(n,adjc,lext)
       
    
    zeta2=rmod2.cover(n,tr,lext)
    if n>100:
        cover_show()                  #2.3.2012
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram of File "+fn)
        lbhd3.pack()
        cv=Tkinter.Canvas(freq,width=600,height=400,bg="white")
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(n,n)
        geomy=rmod2.marray(n,n)

        geom0x=50
        geom0y=20
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(320.0/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(320.0/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if zeta2[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        garrow1x=550
        garrow1y=20
        garrow2y=300
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
##        cv.create_line(garrow1x-4,garrow2y-4,garrow1x,garrow2y)
##        cv.create_line(garrow1x+4,garrow2y-4,garrow1x,garrow2y)
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.pack()
        buttcover=Tkinter.Button(freq,text="show cover relation",command=cover_show)
        buttcover.pack()

def cover_show():
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: -
    hfcover=Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    
    lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,n):
        txt3+="\n"+objred[i]+":\t"
        txt3+="is covered by "
        for j in range(0,n):
            if i!=j:
                if zeta2[i][j]==1:
                    txt3+=" "+objred[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)


def cover_showcase(i,zeta2,objred,tpHDcase):
    """Cover-matrix is displayed"""
    #brg 28.12.07, 16.8.08
    #*28.12.07
    #akt 16.8.08
    #note: -
    #source: cover_show
    lbhd2=Tkinter.Label(tpHDcase,text=" Cover-Relations  case:" + str(i))
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for ix in range(0,n):
        txt3+="\n"+objred[ix]+":\t"
        txt3+="is covered by "
        for j in range(0,n):
            if ix!=j:
                if zeta2[ix][j]==1:
                    txt3+=" "+objred[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(tpHDcase,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)
        
def extract(r,zetah,i,tpcase):
    """extracts from the crisp matrix the order relations"""
    #brg 30.11.07, 11.4.08, 16.8.08 taken from fuzzyHD10, 4.10.08
    # the matrix order corresponds to objec
    
    # order is the matrix rs*rs which results after extract
    # rs is the number of rows/ columns of the square matrix order
    ec=rmod2.dmcompress(r,r,zetah)             #30.11. from cq the equivalent relations
    eqtext=""
    eqtext+=rmod2.eqcguiout1(r,ec,obj)        #30.11. matrix output
    #print "r  = ",r
    txt=rmod2.irc_elim(r,ec)    #7.5.08 identifycolrows replaced by icr_elim
                                #in txt are the rows (and columns)
                                #...which can be eliminated
    
    #print "======================================="
    #print " Control in extract (ex) "
    #print "======================================="
    ltxt=len(txt)
    #print "ex1: ec : ",ec
    #print "ex1: txt , ltxt",txt," ",ltxt
    
    b=rmod2.recogempty(txt,ltxt)
    # Not only the matrix cq is to be contracted but also the object vector obj
    # txt is a code of row numbers and as such ok for the matrixeliminations
    # however, to perform a new object list, txt must
    # be transformed in the corresponding object names
    if b=="true":
        texteq="No equivalent objects in case "+str(i)
    else:
        texteq="Case "+str(i)+": Equivalent objects"
    lbhfeq=Tkinter.Label(tpcase[i-1],text=texteq)
    lbhfeq.pack()
    if b!="true":
        teq=ScrolledText(tpcase[i-1],width=60,height=3)
        teq.pack()
        teq.insert("end",eqtext)
        
    an1,ldel1=rmod2.matrixcoldel(txt,r,r,zetah) # columns eliminated
    zeta,ldel2=rmod2.matrixrowdel(txt,r,r-ldel1,an1)
    rs=r-ldel1
    
    if b=="true":
        #there is nothing to be reduced hence
        objec=rmod2.vecgentext1(r)
        for i in range(0,r):
            objec[i]=obj[i]
    else:        
        conobj=rmod2.vecgentext1(ltxt)
        for i in range(0,ltxt):
            conobj[i]=obj[int(txt[i])]
        #print "conobj = ",conobj    
        objec=rmod2.vecgentext1(rs)
        zaehl=0
        for i in range(0,r):
            #print "obj i  ",obj[i],"  in conobj  ",conobj
            if obj[i]not in conobj:
                objec[zaehl]=obj[i]
                zaehl+=1
        #print "ex4: Reduz. Liste der Objekte (objec in modul extract) ",objec
        #print "ex5: rs = ",rs
    return zeta,objec,rs

def calc():
    lbsuccess.config(text="Calculation of the digraph")
    obsel=eob.get()
    if obsel not in objred:
        lbcalc2.config(text="+++ selected object not in object list\n as default the first object of the object list \n will be selected +++",bg="yellow")
        obsel=objred[0]
    else:
        lbcalc2.config(text=" selected object: "+obsel,bg="cyan")
    #rmod2.matout(n,n,zeta2)    
    dmax=n-1
    updist=rmod2.strmarray1(dmax,n,"-")
    downdist=rmod2.strmarray1(dmax,n,"-")
    incompdist=rmod2.strmarray1(dmax,n,"-")
    graph=rmod2.graphcovdict(zeta2,n)
    #print graph
    
    for d in range(1,dmax):
        zaehl=0
        for o in objred:
            if o!=obsel:
                path=[]
                shortpath=rmod2.find_shortest_path(graph,objred.index(obsel),objred.index(o),path)
                #print shortpath
                if shortpath!=None:
                    lshortpath=len(shortpath)-1
                    #print lshortpath
                    if lshortpath==d:
                        updist[d][zaehl]=o
                        zaehl+=1
        
    covtr=rmod2.marray(n,n)
    for i in range(0,n):
        for j in range(0,n):
            covtr[i][j]=zeta2[j][i]
    graph2=rmod2.graphcovdict(covtr,n)
    for d in range(1,dmax):
        zaehl=0
        for o in objred:
            if o!=obsel:
                path=[]
                shortpath=rmod2.find_shortest_path(graph2,objred.index(obsel),objred.index(o),path)
                #print shortpath
                if shortpath!=None:
                    lshortpath=len(shortpath)-1
                    #print lshortpath
                    if lshortpath==d:
                        downdist[d][zaehl]=o
                        zaehl+=1

    for d in range(1,dmax):
        zaehl=0
        for o in objred:
            if o!=obsel:
                distancun=rmod2.dist_graph(zeta2,n,objred.index(obsel),objred.index(o))
                #print o,"  distance = ",distancun
                if distancun==d:
                    incompdist[d][zaehl]=o
                    zaehl+=1
                    
    #rmod2.strmatout(dmax,n,updist)
    #rmod2.strmatout(dmax,n,downdist)
    tpcalc=Tkinter.Toplevel(hf)
    tpcalc.title(' distances in HD-graph ')
    lbinfocalc=Tkinter.Label(tpcalc,text="selected object = "+obsel)
    lbinfocalc.pack()
    tcalc=ScrolledText(tpcalc,width=60,height=10)
    tcalc.pack()
    txt1="Distances \n"
    txt1+=60*"="+"\n"
    txt1+="upwards\n"
    
    for d in range(1,dmax):
        flag=0
        for j in range(0,n):
            if updist[d][j]=="-" or updist[d][j]=="" or updist[d][j]==" " or updist[d][j]=="  ":
                flag=0
            else:
                #print "d = ",d," j = ",j,"  updist = ",updist[d][j]
                flag=1
                break
            
        if flag==1:    
            txt1+="distance d ="+str(d)+"  :"
            for j in range(0,n):
                if updist[d][j]!="-":
                    txt1+=updist[d][j]+",  "
            txt1+="\n"        
    txt1+="-----------------------------\n"
    
    txt1+="downwards\n"
    for d in range(1,dmax):
        flag=0
        for j in range(0,n):
            if downdist[d][j]=="-" or downdist[d][j]=="" or downdist[d][j]==" " or downdist[d][j]=="  ":
                flag=0
            else:
                #print "d = ",d," j = ",j,"  updist = ",updist[d][j]
                flag=1
                break
            
        if flag==1:    
            txt1+="distance d ="+str(d)+"  :"
            for j in range(0,n):
                if downdist[d][j]!="-":
                    txt1+=downdist[d][j]+",  "
            txt1+="\n"                
    txt1+="-----------------------------\n"
    lbsuccess.config(text="Calculation of upward, downward and incomp's distances")
    txt1+="incomparables\n"
    for d in range(1,dmax):
        flag=0
        for j in range(0,n):
            if incompdist[d][j]=="-" or incompdist[d][j]=="" or incompdist[d][j]==" " or incompdist[d][j]=="  ":
                flag=0
            else:
                #print "d = ",d," j = ",j,"  updist = ",updist[d][j]
                flag=1
                break
            
        if flag==1:    
            txt1+="distance d ="+str(d)+"  :"
            for j in range(0,n):
                if incompdist[d][j]!="-":
                    txt1+=incompdist[d][j]+",  "
            txt1+="\n"                
    txt1+=60*"="+"\n"
    tcalc.insert("end",txt1)

hf=Tkinter.Tk()
hf.title('graph theoretical analyses ')
about()
raihelp()
lbhallo=Tkinter.Label(hf,text="",width=60)
lbhallo.pack()
fropen=Tkinter.Frame(hf,width=60,height=40,relief="sunken",bd=2)
fropen.pack()
lbopen=Tkinter.Label(fropen,text="")
lbopen.pack()
lbfileselect=Tkinter.Label(fropen,text=">>>select and open file>>>")
lbfileselect.pack(side="left",pady=25)
buttfileselect=Tkinter.Button(fropen,text="select and open file",width=25, bg="white",command=File_select)
buttfileselect.pack(side="left",pady=10)
frshow=Tkinter.Frame(hf,width=60,height=4,relief="sunken",bd=2)
frshow.pack(fill="x")
buttshow=Tkinter.Button(frshow,text="show data matrix ",width=25,command=showDM)
buttshow.pack(pady=5)
buttHD=Tkinter.Button(frshow,text="show  HD ",width=25,bg="cyan",command=HD)
buttHD.pack(pady=10)
frcalc=Tkinter.Frame(hf,relief="sunken",bd=2)
frcalc.pack()
lbcalc1=Tkinter.Label(frcalc, text="graph theoretical calculation ")
lbcalc1.pack()
frcalc2=Tkinter.Frame(hf)
frcalc2.pack()
lbcalc12=Tkinter.Label(frcalc2,text=" enter object name>>>")
lbcalc12.grid(row=0, column=0)
eob=Tkinter.Entry(frcalc2,width=4)
eob.grid(row=0,column=1)
lbcalc2=Tkinter.Label(frcalc2,text="")
lbcalc2.grid(row=1,columnspan=2)
buttcalc=Tkinter.Button(frcalc2,text=" calculate",bg="cyan",width=25,command=calc)
buttcalc.grid(row=0,column=2)
lbsuccess=Tkinter.Label(frcalc2,text=" ",bg="yellow")
lbsuccess.grid(row=2,columnspan=3)
frcalc3=Tkinter.Frame(hf)
frcalc3.pack(pady=15)
buttSa=Tkinter.Button(frcalc3,text="extended LPOM ",width=25,bg="cyan",command=SaPaUa)
buttSa.pack()
frcalc4=Tkinter.Frame(hf,relief="sunken",bd=2)
frcalc4.pack()
lobs=Tkinter.Label(frcalc4,text="Individual analysis for an single object >>>")
lobs.pack(side="left")
eobs=Tkinter.Entry(frcalc4,width=10)
eobs.pack(side="left")
butthinc=Tkinter.Button(frcalc4,text=" contributions of incomp's\n of the selected individual single object",\
                            command=showinc)
butthinc.pack()
buttexit=Tkinter.Button(hf,text="  Exit  ",bg="red",width=25,command=hf.destroy)
buttexit.pack(pady=30)


hf.mainloop()
