# -*- coding: cp1252 -*-
import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import tkFileDialog
import raioop2
import pstat
import stats

#Brg in cooperation with Korbinian Freier, MPI Hamburg, 2.10. and 3.10.09
# brg 4.6.2013 : poset of incomp.pairs due to attribute-object-constellation
# brg  25.6.2013  version 3: incomp-statistics
# brg  2.7.2013: pecularity
# Brg 19.7.17: cosmetics

def selectopenfile():
    # brg  4.6.2013
    global fn,r,rred,obj,objred,dm,xred,prop,k

    fn=tkFileDialog.askopenfilename()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    lb1.config(text="opened "+fn,bg="yellow")
    

    prop=[]
    for j in range(0,k):
        prop.append(pro[j+1])
            
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
    for i in range(0,r):
        obj[i]=ob[i+1]

    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,dm,obj)  
    

def show_file():
    # br 2.7.2013, 18.11.2015
    tp2=Tkinter.Toplevel(hf)
    tp2.title('show DM')
    lbtp2=Tkinter.Label(tp2,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt2+="Original (not normalized) data matrix"+"\n"
    txt3="\n"
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt3+="\n normalized (columnwise) data matrix  \n"
    txt3+="\t"
    dmn=rmod2.matrixnorm(r,k,dm)
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,k):
            txt3+=str(round(dmn[i][j],3))+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)    


def HD():
    """based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"""
    # Brg 20.12.07, 28.12.07, 2.10.,3.10.09, 4.6.2013
    # If the number of representants > 70 then only the cover-matrix and the level-population
    #
    global zeta
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    buttstatistics.config(state="active")
        #
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    if rred>100:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram  ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()

def calc():
    # brg 4.6.2013
    # elements of the ac
    global k,cv1,objpair,adjm
    acx=eac.get()
    ac=acx.split(",")
    print ac
    lac=len(ac)
    lsuper=1.0*lac*(lac-1.0)/2.0
    adjm=rmod2.marray(int(lsuper),2*k)
    zahl=0
    objpair=[]
    objpairno=[]
    interimlist=[]
    for ob1 in ac:
        iob1=objred.index(ob1)
        interimlist.append(ob1)
        for ob2 in ac:
            if ob2 not in interimlist:
                iob2=objred.index(ob2)
                if zeta[iob1][iob2]==0 and zeta[iob2][iob1]==0:
                    # to be sure that only incomparable pairs will be constructed
                    superadjac=rmod2.vecgen1(2*k)
                    txt=str(ob1)+","+str(ob2)
                    objpair.append(txt)
                    objpairno.append(str(zahl))
                    for j in range(0,k):
                        if xred[iob1][j]>xred[iob2][j]:
                            superadjac[j]=1
                        else:
                            superadjac[1+j]=0
                            
                    for j in range(0,k):
                        if xred[iob1][j]<xred[iob2][j]:
                            superadjac[k+j]=1
                        else:
                            superadjac[k+j]=0
                    for j in range(0,2*k):         
                        adjm[zahl][j]=superadjac[j]
                    zahl+=1

    for ii in range(0,int(lsuper)):
        print objpair[ii],adjm[ii]
            
    tpacpotext=Tkinter.Toplevel(hf)
    tpacpotext.title(' Adjacency-matrix ')
    tacpotext=ScrolledText(tpacpotext,width=80,height=10)
    tacpotext.pack()
    txt="AC-fine-structure "+"\n"
    txt+="\t"+"    left object > right object "+4*"\t"+"   left object < right object"+"\n"
    txt+="\t"
    for j in range(0,k):
        txt+="\t"+str(prop[j])+", "
    txt+=2*"\t"
    for j in range(0,k):
        txt+="\t"+str(prop[j])
    txt+="\n"    
    for i in range(0,int(lsuper)):
        txt+=str(objpair[i])+":\t"           
        for j in range(0,k):
            txt+="\t"+str(adjm[i][j])+", "
        txt+=2*"\t"
        for j in range(k,2*k):
            txt+="\t"+str(adjm[i][j])+", "
        txt+="\n"
    txt+="\n"
    
        
    # Now the HD, based on adjm
    
    k1=2*k
    
    rred1,xred1,objred1,txt1,neq1=rmod2.equivcompactm(int(lsuper),k1,adjm,objpairno)
    txt+="Equivalence classes "+"\n"
    txt+=txt1
    txt+="\n"
    txt+=" -  -  -  e o f -  -  -"
    tacpotext.insert("end",txt)
    tpacpo=Tkinter.Toplevel(hf)
    print "objred1= ",objred1
    objpairred=[]
    for ob in objred1:
        objpairred.append(objpair[int(ob)])
    print "objpairred= ",objpairred
    zetahilf=rmod2.comp(rred1,k1,xred1)  #zeta matrix with col<row
    zeta1=rmod2.marray(rred1,rred1)
    print "objred1 ",objred1
    for i in range(0,rred1):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred1):
            zeta1[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj1,lext1,revlext1,zzmax1=rmod2.levtopsort(rred1,zeta1)
       
    levmax1=-10**20     #20.6.08
    for i in range(0,zzmax1):
        if len(lobj1[i])>=levmax1:
            levmax1=len(lobj1[i])
       
    #Adj-Listen

    adjc1=rmod2.adjacent(rred1,lext1,revlext1,zeta1)
        
    #Transitive reduced relations
    ts1,tr1=rmod2.trreduct(rred1,adjc1,lext1)
       
    
    cov1=rmod2.cover(rred1,tr1,lext1)

    if rred1>100:
        lbhd3=Tkinter.Label(tpacpo,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(tpacpo,text=" Hasse Diagram  (ALT-Mouse Left for further info)")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred1,levmax1,zzmax1)
        cv1=Tkinter.Canvas(tpacpo,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax1
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj1[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred1,rred1)
        geomy=rmod2.marray(rred1,rred1)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov1[lobj1[i1][j1]][lobj1[i][j]]==1:
                            cv1.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv1.create_oval(geomx[i][j]-15,geomy[i][j]+15,geomx[i][j]+15,geomy[i][j]-15,fill="white")
                cv1.create_text(geomx[i][j],geomy[i][j],text=objpair[int(objred1[lobj1[i][j]])],tags="object_"+objpair[int(objred1[lobj1[i][j]])])
        
        cv1.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv1.create_text(garrow1x+8,garrow1y-6,text="high")
        cv1.create_text(garrow1x+8,garrow2y-6,text="low")
        cv1.pack()
        cv1.bind("<Alt-Button 1>",mouseinfo) 
            
def mouseinfo(event):
    #brg 5.6.2013
    x=int(cv1.canvasx(event.x))
    y=int(cv1.canvasy(event.y))
    #print item2
    flag=0
    tu=cv1.gettags(cv1.find_closest(x,y))
    print "tu= ",tu[0]
    lt=len(tu[0])
    tagn=tu[0][7:lt]
    print "tagn= ",tagn
    tpinfo=Tkinter.Toplevel(hf)
    tpinfo.title('Info for vertex '+str(tagn))
    tinfo=ScrolledText(tpinfo,width=120,height=10)
    tinfo.pack(expand="yes")
    txt="Selected: "+str(tagn)+"\n"
    iob=objpair.index(tagn)
    txt+="\t"+"    left object > right object "+4*"\t"+"   left object < right object"+"\n"
    txt+="\t"
    for j in range(0,k):
        txt+="\t"+str(prop[j])+", "
    txt+=2*"\t"
    for j in range(0,k):
        txt+="\t"+str(prop[j])
    txt+="\n"+2*"\t"    
    for j in range(0,k):
        txt+=str(adjm[iob][j])+"\t"
    txt+=2*"\t"
    for j in range(k,2*k):
        txt+=str(adjm[iob][j])+"\t"
    txt+="\n"
    tinfo.insert("end",txt)
    
        
def incompstatistics():
    # brg 25.6.2013
    # first step: columnwise normalization
    yn=rmod2.matrixnorm(rred,k,xred)
    #print "yn= "
    #rmod2.matout(rred,k,yn)
    #print "  "
    # calculation of discrepancy-matrix
    nattpair=k*(k-1)/2
    nobjpair=rred*(rred-1)/2
    discrepancy=rmod2.marray(nobjpair,nattpair)
    listobjatt=rmod2.marray(nobjpair,nattpair)
    listatt=[]
    listobj=[]
    zahlatt=0
    for j1 in range(0,k):
        for j2 in range(j1+1,k):
            listatt.append((str(prop[j1]),str(prop[j2])))
            zahlobj=0
            for i1 in range(0,rred):
                for i2 in range(i1+1,rred):
                    if zeta[i1][i2]==0 and zeta[i2][i1]==0:
                        dis1=abs(yn[i1][j1]-yn[i2][j1])
                        dis2=abs(yn[i1][j2]-yn[i2][j2])
                        discrepancy[zahlobj][zahlatt]=min(dis1,dis2)
                        listobjatt[zahlobj][zahlatt]=((objred[i1],objred[i2]),(prop[j1],prop[j2]))
                        listobj.append((str(objred[i1]),str(objred[i2])))
                        zahlobj+=1
            zahlatt+=1            
    tpstat=Tkinter.Toplevel(hf)
    tpstat.title(' statistics of incomparability ')
    tstat=ScrolledText(tpstat,width=120,height=10)
    tstat.pack()
    txt=" Statistics of discrepancies of incomparable objects "+"\n"
    txt+=60*"="+"\n"
    txthilf=2*"\t"
    if zahlobj<=5:
        for i in range(0,zahlobj):
            txthilf+=str(listobj[i])+"\t"
        txthilf+="\n"
        for j in range(0,nattpair):
            txthilf+=str(listatt[j])+":    "+"\t"
            for i in range(0,zahlobj):
                txthilf+="\t"+str(round(discrepancy[i][j],2))+"\t"
            txthilf+="\n"
    else:
        nn=1
        while nn*5<zahlobj+5:
            print "nn= ",nn
            txthilf+="\n\t\t"
            for i in range((nn-1)*5,min(zahlobj,nn*5)):
                txthilf+=str(listobj[i])+"\t"
            txthilf+="\n"
            for j in range(0,nattpair):
                txthilf+=str(listatt[j])+":    "+"\t"
                for i in range((nn-1)*5,min(zahlobj,nn*5)):
                    txthilf+="\t"+str(round(discrepancy[i][j],3))+"\t"
                txthilf+="\n"
            nn+=1

    txt+=txthilf
    sumdiscr=rmod2.vecgen1(nattpair)
    mindiscr=rmod2.vecgen1(nattpair)
    maxdiscr=rmod2.vecgen1(nattpair)
    isternmax=rmod2.vecgen1(nattpair)
    isternmin=rmod2.vecgen1(nattpair)
    for j in range(0,nattpair):
        mindiscr[j]=99999
        maxdiscr[j]=-99999

    for j in range(0,nattpair):
        for i in range(0,zahlobj):
            sumdiscr[j]+=discrepancy[i][j]
            if discrepancy[i][j]>=maxdiscr[j]:
                maxdiscr[j]=discrepancy[i][j]
                isternmax[j]=i
            if discrepancy[i][j]<=mindiscr[j]:
                mindiscr[j]=discrepancy[i][j]
                isternmin[j]=i
        #print "j= ",j,"   sumdiscr= ",sumdiscr[j]
        sumdiscr[j]=1.0*sumdiscr[j]/(1.0*zahlobj)
    print "maxdiscr ",maxdiscr
    for j in range(0,nattpair):
        print "isternmax ",listobjatt[isternmax[j]][j]
    print "mindiscr ",mindiscr
    for j in range(0,nattpair):
        print "istermin ",listobjatt[isternmin[j]][j]
    print "mean ",sumdiscr
    txt+="\n"
    txt+="min-, max, mean for each indicator pair, taken over all (x,y) with x||y "+"\n"
    txthilf2=2*"\t"+"min  "+2*"\t"+" max   " + 2*"\t"+" mean  "+"\n"
    for j in range(0,nattpair):
        txthilf2+=str(listatt[j])+": "+2*"\t"+str(round(mindiscr[j],2))+2*"\t"+str(round(maxdiscr[j],2))+2*"\t"+str(round(sumdiscr[j],2))
        txthilf2+="\n"
    txt+=txthilf2
    txt+="\n"
    txt+=" which objectpair with maximal discrepancy? "+"\n"
    txthilf3="object-pair, indicator-pair"+"\n"
    for j in range(0,nattpair):
        txthilf3+=str(listobjatt[isternmax[j]][j])+"\n"
    txt+="\n"
    txt+=txthilf3
    tstat.insert("end",txt)
    
    # Graphics
    hilf=[]
    
    titel=[]
    app=rmod2.vecgen1(nattpair)
    tpst=Tkinter.Toplevel(hf)
    tpst.title(' histograms ')
    for j in range(0,nattpair):
        hilf=[]
        barth=[]
        titel.append("indicatorpair "+str(listatt[j]))
        for i in range(0,zahlobj):
            hilf.append(discrepancy[i][j])
            barth.append(str(listobj[i]))
        app[j]=raioop2.brgbar8(tpst,hilf,barth,titel[j])
        app[j].ausgabe()
                    
def bitcode(obj,hyp,k):
    # brg 11.12.15
    hilf = 0
    for i2 in range(0, k):
        hilf += (2**(k-1-i2))*hyp[i2]
    return hilf


def pecularity():
    # brg 2.7.2013, 18.11.2015, 19.11.15, 26.11.2015, 23.6.17
    # columnwise normalized. A slim HD should obtain objects which
    # are following the line (00000) to (11111). Profiles which are close to
    # (0,1,...,1), (0,0,1,..1) etc  (i.e. having profiles others than (00000) or
    # (11111) ) are called 'peculiar', because they don't follow the mainstream
    # from (00000) to (11111).
    global Distanceinfo, zahldist,yn,hyp
    try:
        f=float(ef.get())
    except:
        f=0.45/(1.0*k) # Minimal distanz between two corners of h(k) = 1
    # columnwise normalization
    yn=rmod2.matrixnorm(rred,k,xred)
    #
    x=2**k
    # Calculating the squared Euclidian, the distance between (00...00) and (111....11) is m
    # f*k ("k" not "m": 23.6.17) is the evaluation limit to recognize "peculiar" objects

    # determination of that pattern which is close to any data point.
    pec=[]
    pattern=[]
    Distancemin=[]
    Distanceinfo=[]
    zahl=0
    zahldist = 0
    hyp = []
    for i in range(0, x):
        hihi=rmod2.bitrep(k,i)
        hyp.append(hihi)
    #print "hyp = ",hyp    
    for i in range(0,rred):
        minD=9999999
        for ii in range(0, x):  #23.6.17 1 in range() replaced by 0
            y=rmod2.bitrep(k,ii)
            #print "y= (bit-pattern) ",y
            sumD=0
            for j in range(0,k):
                sumD+=(yn[i][j]-y[j])**2
            D=sumD
            Distanceinfo.append((objred[i],y,D))  #bug!!! obj replaced by objred
            zahldist+=1
            if D<=minD:
                minD=sumD
                imin=i
                ymin=y
        if minD<f*k:      # k is number of indicators, max dist = sum (1-0)**2 = k
            pec.append(objred[imin])
            pattern.append(ymin)
            Distancemin.append(minD)
            zahl+=1
    print "Distanceinfo "
    print Distanceinfo
    print "----"
    maxdist = -999999
    for i in range(0, zahldist):
        if Distanceinfo[i][2]>maxdist:
            maxdist=Distanceinfo[i][2]
    mindist = 999999        
    for i in range(0, zahldist):
        if Distanceinfo[i][2]<mindist:
            mindist=Distanceinfo[i][2]
            
    nrpec=zahl
    tppecul=Tkinter.Toplevel(hf)
    tppecul.title('  peculiar objects ')
    tpecul=ScrolledText(tppecul,width=120,height=10)
    tpecul.pack()
    txt="Peculiar objects on the basis of f=  "+str(f)+"\n"
    txt+="Distance to select the peculiar elements (= f*k): "+str(f*k)+"\n"
    txt+="1) Number of all representants      "+str(rred)+"\n"
    txt+="2) Number of peculiar representants "+str(nrpec)+"\n"
    txt+="3) Maximal distance found:          "+str(maxdist)+"\n"
    txt+="4) Minimal distance found:          "+str(mindist)+"\n" 
    txt+="fraction of peculiar elements \n(compared to all "+str(rred)+"  objects) in % "+str(round(100.0*nrpec/(1.0*rred),3))+"\n"
    for i in range(0, nrpec):
        txt+="object: "+str(pec[i])+"\t"+"data  :"
        for j in range(0,k):
            txt+=str(round(yn[objred.index(pec[i])][j],3))+", "
        txt+="\n"
        txt+="    pattern: "+str(pattern[i])+"   with minimal distance "+str(round(Distancemin[i],3))+"\n"
        txt+="----------------------------------------------------"+"\n"
    txt+="\n"
    txtext= "Objects having distance "+str(mindist)+"\n"
    objselpec = []
    for i in range(0, zahldist):
        if Distanceinfo[i][2]==mindist:
            objselpec.append(Distanceinfo[i][0])	
            txthilf1 =""
            for j in range(0,k):
                txthilf1+=str(Distanceinfo[i][1][j])+","
            txtext+=str(Distanceinfo[i][0])+" "+txthilf1+"\n"
    txtext+="\n Objects with distance "+str(maxdist)+"\n"
    for i in range(0, zahldist):
        if Distanceinfo[i][2]==maxdist:
            txthilf2=""
            for j in range(0,k):
                txthilf2+=str(Distanceinfo[i][1][j])+","
            txtext+=str(Distanceinfo[i][0])+" "+txthilf2+"\n"
    txtext+="\n"
    txt+=txtext
    tpecul.insert("end",txt)
    
    
def show_distances():
    # brg 18.11.2015, 29.11.15, 5.12.2015
    global objselpec, limitdist,patternpec, pattdecode

    try:
        limitdist=float(elimit.get())
    except:
        limitdist = 0.05*k
       
    tpdistances= Tkinter.Toplevel(hf)
    tpdistances.title(" Distances ")
    tdistances=ScrolledText(tpdistances,width=120, height=20)
    tdistances.pack()
    txtd = "Distances of objects to corners h(m) - {(0,...,0), (1,1,..,1)}"+"\n"
    txtd+="Distances < "+str(limitdist)+"\n"
    txtd+="Object "+"\t" + "corner" + "\t" + "    distance" + "\n"
    objselpec = []
    patternpec=[]
    pattdecode = []
    for i in range(0, zahldist):
        if Distanceinfo[i][2]<limitdist:
            txtd+=str(Distanceinfo[i][0])+"\t"
            objselpec.append(Distanceinfo[i][0])
            patternpec.append(Distanceinfo[i][1])
            hilftxt="("
            for i1 in range(0,k):
                if i1<k-1:
                    hilftxt+=str(Distanceinfo[i][1][i1])+","
                else:
                    hilftxt+=str(Distanceinfo[i][1][i1])
            hilftxt+=")"+"\t"
            txtd+=hilftxt+"\t"+str(round(Distanceinfo[i][2],3))+"\n"
    txtd+="\n"
    
    print "patternpec ",patternpec
    lenpp=len(patternpec)
    print "lenpp= ",lenpp
    for i1 in range(0, lenpp):
        hihi2 = 0
        for i2 in range(0,k):
            hihi2+=(2**(k-1-i2))*patternpec[i1][i2]
        pattdecode.append(hihi2)
    print "pattdecode = ",pattdecode
    txtd+="patterns and their code "+"\n"
    lpdc = len(pattdecode)
    for i in range(0, lpdc):
        for i1 in range(0, k):
            txtd+=str(patternpec[i][i1])+", "
        txtd+= ": "+str(pattdecode[i])+"\n"
    txtd+="\n"    
    tdistances.insert("end",txtd)
    
def show_obj():
    # brg 19.11.2015, 29.11.15
    tpsingleobj=Tkinter.Toplevel(hf)
    tsingleobj=ScrolledText(tpsingleobj,width=80,height=10)
    tsingleobj.pack()
    try:
        limitdist=float(elimit.get())
    except:
        limitdist = min(0.05*k,1)    
    objsel=eobsel.get()
    txtob=""
    if objsel in objred:
        txtob+="Selected object "+str(objsel)+"\n"
        txtob+="Profile (normalized): "+"\n"
        iob=obj.index(objsel)
        for j in range(0,k):
            txtob+=str(round(yn[iob][j],3))+", "
        txtob+="\n"
        d000=0
        for j in range(0,k):
            d000+=yn[iob][j]**2
        d111=0
        for j in range(0,k):
            d111+=(1-yn[iob][j])**2
        txtob+="Distance to (0,...,0)= "+str(round(d000,3))+"\n"
        txtob+="Distance to (1,...,1)= "+str(round(d111,3))+"\n"
        txtob+="\n"
        zahldistlimit = 0
        for i in range(0, zahldist):
            if Distanceinfo[i][0]==objsel and Distanceinfo[i][2]<limitdist:
                for j in range(0, k):
                    txtob+=str(Distanceinfo[i][1][j])+","
                txtob+="\n"
                txtob+="Selected limiting distance = "+str(limitdist)+"\n"
                txtob+="Distance= "+str(round(Distanceinfo[i][2],3))+"\n"
                txtob+="% of maximal distance ( "+str(k)+")=  "+str(100.0*Distanceinfo[i][2]/(1.0*k))+"%\n"
                txtob+=50*"-"+"\n"
                zahldistlimit+=1
        txtob+="\n"
        txtob+="Frequency of cases where "+str(objsel)+"\n  has distances to the h("+str(k)+")-corners"+"\n"
        txtob+= "which are < "+str(limitdist)+": "+str(zahldistlimit)+"\n"
    else:
        txtob+="+++ sorry , selected object is not in your list of objects ++++"
    tsingleobj.insert("end",txtob)    
                

def HDmarked():
    #brg 5.12.15, 12.12.2015
    global cv2,obact,limitdist
    hfhd3=Tkinter.Toplevel(hf)
    hfhd3.title('Hasse diagram bitpattern , limit distances = '+str(limitdist))
    freq=Tkinter.Frame(hfhd3,width=200,height=300)
    freq.pack()
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    if rred>200:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram  "+"\tlimit distance = "+str(limitdist))
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv2=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv2.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                obact = objred[lobj[i][j]] 
                if obact in objselpec:
                    cv2.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="grey")
                    iob=objred.index(obact)
                    lD = len(Distanceinfo)
                    flag=0
                    for i1 in range(0, lD):
                        if Distanceinfo[i1][2]< limitdist and Distanceinfo[i1][0] == obact:
                            hypact = []
                            for i2 in range(0,k):
                                hypact.append(Distanceinfo[i1][1][i2])
                            bcact = bitcode(obact,hypact,k)
                            flag += 1
                            if flag>1:
                                tagtxt = "+"
                            else:
                                tagtxt=""
                    cv2.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]]+tagtxt,tag = str(bcact))
                else:
                    cv2.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                    cv2.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])

        cv2.bind("<Alt-Button-1>",details2)
        cv2.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv2.create_text(garrow1x+8,garrow1y-6,text="high")
        cv2.create_text(garrow1x+8,garrow2y-6,text="low")
        cv2.pack()

def HDbool():
    #brg 5.12.2015, 6.12.2015
    global cvb, objredbit
    hfhd4=Tkinter.Toplevel(hf)
    hfhd4.title('Hasse diagram boolean , limit distances = '+str(limitdist))
    freq=Tkinter.Frame(hfhd4,width=200,height=300)
    freq.pack()
    r = 2**k
    objredbit = []
    for i1 in range(0, r):
        hilf = 0
        for i2 in range(0, k):
            hilf += (2**(k-1-i2))*hyp[i1][i2]
        objredbit.append(hilf)
        #print "objredbit= ",objredbit[i1]
    zetahilfbit=rmod2.comp(r,k,hyp)  #zeta matrix with col<row
    zetabit=rmod2.marray(r,r)
    for i1 in range(0,r):  #however we need for the 'normal' presentation: row < col. Transposition
        for i2 in range(0,r):
            zetabit[i1][i2]=zetahilfbit[i2][i1]
    #
    #One linear extension (based on levels)
    
    lobjbit,lextbit,revlextbit,zzmaxbit=rmod2.levtopsort(r,zetabit)
       
    levmaxbit=-10**20     #20.6.08
    for i in range(0,zzmaxbit):
        if len(lobjbit[i])>=levmaxbit:
            levmaxbit=len(lobjbit[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(r,lextbit,revlextbit,zetabit)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(r,adjc,lextbit)
       
    
    cov=rmod2.cover(r,tr,lextbit)

    if rred>200:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" bit-Hasse Diagram  "+"\tlimit distance = "+str(limitdist))
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(r,levmaxbit,zzmaxbit)
        cvb=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmaxbit
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobjbit[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(r,r)
        geomy=rmod2.marray(r,r)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobjbit[i1][j1]][lobjbit[i][j]]==1:
                            cvb.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                if objredbit[lobjbit[i][j]] in pattdecode:
                    cvb.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="grey")
                    cvb.create_text(geomx[i][j],geomy[i][j],text=objredbit[lobjbit[i][j]], tag = str(objredbit[lobjbit[i][j]]))
                else:
                    cvb.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                    cvb.create_text(geomx[i][j],geomy[i][j],text=objredbit[lobjbit[i][j]], tag = str(objredbit[lobjbit[i][j]]))
                
                
        cvb.bind("<Alt-Button-1>",details)
        cvb.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cvb.create_text(garrow1x+8,garrow1y-6,text="high")
        cvb.create_text(garrow1x+8,garrow2y-6,text="low")
        cvb.pack()

def details(event):
    #brg 6.12.2015
    Tpdetails=Tkinter.Toplevel(hf)
    Tpdetails.title("Info")
    tdetails=ScrolledText(Tpdetails,width=30,height=20)
    tdetails.pack()
    txt="Detail infos "+"\n"
    txt+=15*"=" + "\n"
    
    xmouse=int(cvb.canvasx(event.x))
    ymouse=int(cvb.canvasy(event.y))
    mouseflag=1  
    tu=cvb.gettags(cvb.find_closest(xmouse,ymouse))
    print "tu= ",tu
    lt=len(tu[0])
    tagn=tu[0][0:lt]
    print "tagn= ",tagn
    print "objredbit ",objredbit
    print "type of tagn = ",type(tagn)
    objredbitstr = []
    for i in range(0, len(objredbit)):
        objredbitstr.append(str(objredbit[i]))
    if tagn in objredbitstr:
        print "y e s "
    try:
       iobact=objredbitstr.index(str(tagn))
       print "iobact ",iobact
       mouseflag=1
    except:
       mouseflag=0
    print "mouseflag ",mouseflag
    if mouseflag == 1:
        ybit = rmod2.bitrep(k,int(tagn))
        print "ybit = ",ybit
        txt+="Selected corner = "+str(tagn)+"\n"
        txt+="Bitpattern= "
        for j in range(0,k):
            txt+=str(ybit[j])+", "
        txt+="\n"+"limit distance = "+str(limitdist)+"\n"
        txt+=" Objects near the selected bit-pattern"+"\n"
        for i in range(0, len(Distanceinfo)):
            if Distanceinfo[i][2]<limitdist and Distanceinfo[i][1] == ybit:
                txt+=str(Distanceinfo[i][0])+", "
        txt+="\n"        
    else:
        txt+="+++something is wrong +++"
    tdetails.insert("end",txt)    

def details2(event):
    #brg 6.12.2015, 12.12.2015
    Tpdetails2=Tkinter.Toplevel(hf)
    Tpdetails2.title("Info")
    tdetails=ScrolledText(Tpdetails2,width=30,height=20)
    tdetails.pack()
    txt="Detail infos "+"\n"
    txt+=15*"=" + "\n"
    
    xmouse=int(cv2.canvasx(event.x))
    ymouse=int(cv2.canvasy(event.y))
    mouseflag=1  
    tu=cv2.gettags(cv2.find_closest(xmouse,ymouse))
    print "tu= ",tu
    lt=len(tu[0])
    tagn=tu[0][0:lt]
    print "tagn= ",tagn
    print "type of tagn = ",type(tagn)
    try:
        zahl = int(tagn)
        ybit = rmod2.bitrep(k,int(tagn))
        txt+="Selected object has code = "+str(tagn)+"\n"
        txt+="Bitpattern= "
        for j in range(0,k):
            txt+=str(ybit[j])+", "
        txt+="\n"+"limit distance = "+str(limitdist)+"\n"
    except:
        txt+="+++ this oject is not a peculiar one ++"+"\n"
    tdetails.insert("end",txt)    


## Tkinter Plot
hf = Tkinter.Tk()
hf.title(' incompposet ')
aboutincompposet=raioop2.brgabout(hf,"tp1","about_incompposet.txt",7,\
            "Dec, the 6th,2015"," about incompposet ", "white", "t1",80,5,ScrolledText)
helpincompposet=raioop2.brgabout(hf,"tp1","help_incompposet.txt",7,\
            "Dec, the 6th,2015"," help_incompposet ", "white", "t1",80,5,ScrolledText)
    
fr=Tkinter.Frame(hf,width=60)
fr.pack()
buttselectopenfile= Tkinter.Button(fr,text=" Select and open file ",bg="cyan",width=30,command=selectopenfile)
buttselectopenfile.pack()
buttshowfile=Tkinter.Button(fr,text="Show file ",bg="cyan",width=30,command=show_file)
buttshowfile.pack()
buttHD = Tkinter.Button(fr, text=' HD',width=30,bg="cyan",command=HD)
buttHD.pack(pady=5)
lb1=Tkinter.Label(fr,text=" ",width=50)
lb1.pack()
lb2=Tkinter.Label(fr,text="selectelements of an antichain")
lb2.pack(pady=5)
eac=Tkinter.Entry(fr,width=20)
eac.pack()
buttcalc=Tkinter.Button(fr,text="poset of incomp-pairs ", bg="cyan",width=30,command=calc)
buttcalc.pack()
buttstatistics=Tkinter.Button(fr,text="Incomp-statistics ",bg="cyan",width=30,state="disabled",command=incompstatistics)
buttstatistics.pack()
fref=Tkinter.Frame(fr)
fref.pack()
lbintro=Tkinter.Label(fref,text="P e c u l a r i t y \nInternally the data matrix will be columnwise\nnormalized to [0,1]power m")
lbintro.pack()
lbef=Tkinter.Label(fref,text=" Select evaluation factor f (recommended: 0.05)>>>")
lbef.pack(side="left")
ef=Tkinter.Entry(fref,width=5)
ef.pack(side="right")
buttpecul=Tkinter.Button(fr,text="Calculation of peculiar objects ",bg="cyan",width=30,command=pecularity)
buttpecul.pack()
fr3= Tkinter.Frame(hf)
fr3.pack()
lblimit=Tkinter.Label(fr3,text="Only those distances less than your 'limit'\n(default: 0.05*k)...")
lblimit.pack(side="left")
elimit = Tkinter.Entry(fr3,width=5)
elimit.pack(side="right")
fr4=Tkinter.Frame(hf)
fr4.pack()
buttshowdistances = Tkinter.Button(fr4, text="Show distances of \nobjects to corners of h(m)' ",width=30,bg="cyan",command=show_distances)
buttshowdistances.pack()
fr5=Tkinter.Frame(hf)
fr5.pack()
lbobj=Tkinter.Label(fr5,text="Select an object of interest ")
lbobj.pack(side="left")
eobsel=Tkinter.Entry(fr5,width=10)
eobsel.pack(side="right")
fr6=Tkinter.Frame(hf)
fr6.pack()
buttshowsingleobj=Tkinter.Button(fr6,text="Show obj_related info ",width=30,bg="cyan",command=show_obj)
buttshowsingleobj.pack()
fr7=Tkinter.Frame(hf).pack()
buttshowHDpattern=Tkinter.Button(fr7,text="Show peculiar objects in HD ",bg="cyan",width=30,command=HDmarked)
buttshowHDpattern.pack()
fr8=Tkinter.Frame(hf).pack()
buttshowHDbit=Tkinter.Button(fr8,text="Show bitpattern as HD ",bg="cyan",width=30,command=HDbool)
buttshowHDbit.pack()
frende=Tkinter.Frame(hf)
frende.pack()
buttexit = Tkinter.Button(frende, text = 'exit', bg = 'red', width=30,command = hf.destroy)
buttexit.pack(pady=10)

hf.mainloop()

