# -*- coding: cp1252 -*-
import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import tkFileDialog
import raioop2
import math

#Brg derived from HDsimpl: 24.11.2012
# Heuristic after method suggested by Ghanima Al Sharrah
# 25.11.2012

def HD():
    """based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"""
    # Brg 20.12.07, 28.12.07, 2.10.,3.10.09
    # If the number of representants > 70 then only the cover-matrix and the level-population
    #
    global fn,r,k,rred,objred,xred,prop,obj
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    
    fn=tkFileDialog.askopenfilename()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    lb1.config(text="opened "+fn,bg="yellow")
    

    prop=[]
    for j in range(0,k):
        prop.append(pro[j+1])
            
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
    for i in range(0,r):
        obj[i]=ob[i+1]

    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,dm,obj)  
    
    #
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])

    
    
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    if rred>100:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram  ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()


def heuristic():
    #brg 24.11.2012
    #Brg after: Ghanima Al-Sharrah, see book in preparation, Springer publishing house
    global distance,zzmax,xrednorm
    tpheuristic=Tkinter.Toplevel(hf)
    theuristic=ScrolledText(tpheuristic, width=60, height=10)
    theuristic.pack()
    global k,rred
    weight=rmod2.vecgen1(k)
    sar1=rmod2.vecgen1(rred)
    sar2=rmod2.vecgen1(rred)
    for j in range(0,k):
        try:
            weight[j]=float(eweight[j].get())
        except:
            weight[j]=1.0/k

    txt="Heuristics related to the level structure of a poset "+"\n"
    txt+=50*"="+"\n"
    txt+="1) Composite indicator- weights:"+"\n"
    for j in range(0,k):
        txt+=str(prop[j])+": "+str(weight[j])+"\n"
    txt+=2*"\n"    
    #print "weights ",weight
    xrednorm=rmod2.matrixnorm(rred,k,xred)
    #print "normalized dm "
    #rmod2.matout(rred,k,xrednorm)
    #print " "
    for i in range(0,rred):
        for j in range(0,k):
            sar1[i]+=weight[j]*xrednorm[i][j]
    #print "sar1 = ",sar1
    #print " "
    txt+="2) Composite indicator (CI) - values "+"\n"
    txt+="object"+"\t"+"CI-value)"+"\n"
    for i in range(0,rred):
        txt+=str(objred[i])+"\t"+str(round(sar1[i],3))+"\n"
    txt+="\n3) Level - Info " +"\n"   
            
    for i in range(0,rred):
        sar2[i]=(rred*1.0*sar1[i]-1.0)/(1.0*rred-1.0)  #norm after Ghanima
    
    zetahilf=rmod2.comp(rred,k,xrednorm)  #zeta matrix with col<row
    zetaheu=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zetaheu[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zetaheu)
       
    levmax=-10**20     #20.6.08
    for lev in range(0,zzmax):
        if len(lobj[lev])>=levmax:
            levmax=len(lobj[lev])

    txt+="Number of levels: "+str(zzmax)+"\n"
    txt+="Number of elements in largest level "+str(levmax)+2*"\n"
    
    #print "levmax= ",levmax,"  zzmax= ",zzmax
    #print "Levelstructure"
    for lev in range(0,zzmax):
        llev=len(lobj[lev])
        for i in range(0,llev):
            print objred[lobj[lev][i]]," ",
        print " "
    av=rmod2.vecgen1(zzmax)
    distance=rmod2.marray(rred,zzmax)
    
    for lev in range(0,zzmax):
        llev=len(lobj[lev])
        #print "level ",lev,llev
        for i in range(0,llev):
            print objred[lobj[lev][i]],
            ihilf=objred.index(objred[lobj[lev][i]])
            av[zzmax-1-lev]+=1.0*sar1[ihilf]/(1.0*llev)
        #print " "    
    #print " "
    txt+="4) Average value of composite indicator values\n taken over the levels "+"\n"            
    for lev in range(0,zzmax):
        txt+="Level "+str(zzmax-lev)+": avlevel="+str(round(av[zzmax-1-lev],3))+"\n"
    txt+="\n"
    txt+="5) Distances of objects to avlevels "+"\n"
    txt+="Object \level "+"\t"
    for lev in range(0,zzmax):
        txt+=str(lev+1)+2*"\t"
    txt+="\n"
    
    for i in range(0,rred):
        txt+=str(objred[i])+" :\t\t"
        for lev in range(0,zzmax):
            distance[i][lev]=math.fabs((av[lev]-sar1[i])/(1.0*sar1[i]))
            txt+=str(round(distance[i][lev],2))+2*"\t"
        txt+="\n"
    txt+=2*"\n"
    txt+="6) Assignment to levels, based on 5)"+"\n"
    #print "distance "
    #rmod2.matout(rred,zzmax,distance)
    #print " "
    mindis=rmod2.marray(rred,2)
    for i in range(0,rred):
        mindistest=999999
        for lev in range(0,zzmax):
            if distance[i][lev]<mindistest:
                mindistest=distance[i][lev]
                levmin=lev
        mindis[i][0]=mindistest
        mindis[i][1]=levmin

    
    txt+="\n"
    for i in range(0,rred):
        txt+=str(objred[i])+"\t Level:\t"+str(1+mindis[i][1])+"\n"
    txt+="\n"

    print "mindis"
    rmod2.matout(rred,2,mindis)
    txt+="\n\n"+" -  -  -  e o f  -  -  - "
    theuristic.insert("end",txt)
    buttshowdm2=Tkinter.Button(tpheuristic,text="Show normalized dm ",command=showndm)
    buttshowdm2.pack()


def showndm():
    #brg 25.11.2012
    tp2n=Tkinter.Toplevel(hf)
    tp2n.title(' show DM ')
    lbtp2=Tkinter.Label(tp2n,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile2=ScrolledText(tp2n,width=60,height=4)
    tfile2.pack()
    
    txt3="\n (column-) normalized data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,rred):
        txt3+=objred[i]+"\t"
        for j in range(0,k):
            txt3+=str(xrednorm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    
    tfile2.insert("end",txt3)
    

def showDM():
    """ New routine : shows the data matrix """
    #Brg 13.1.08
    # brg 25.11.12: Taken from antag2.py
    tp2=Tkinter.Toplevel(hf)
    tp2.title(' show DM ')
    lbtp2=Tkinter.Label(tp2,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+ob[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+pro[j+1]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=pro[j+1]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=ob[i+1]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)


    
def weightdetermination():
    global k
    tpw=Tkinter.Toplevel(hf)
    tpw.title("weights")
    frw1=Tkinter.Frame(tpw)
    frw1.pack()
    lbw=Tkinter.Label(frw1,text="Input of weights \n default: equal weights ",bg="white")
    lbw.grid(row=0,column=0)
    frw2=Tkinter.Frame(tpw,relief="sunken",bd=3)
    frw2.pack()
    lbww=rmod2.vecgen1(k)
    for j in range(0,k):
        lbww[j]=Tkinter.Label(frw2,text=str(prop[j]))
        lbww[j].grid(row=1,column=j)

    eweight=rmod2.vecgen1(k)
    
    for j in range(0,k):
        eweight[j]=Tkinter.Entry(frw2,width=4)
        eweight[j].grid(row=2,column=j)


def histo_single_object():
    #brg 25.11.2012
    objact=eobj.get()
    if objact not in objred:
        lb3.config(text="+++ object not available +++\n please check your name of the object ",bg="yellow")
    else:
        iobj=objred.index(objact)
        levabsc=rmod2.vecgen1(zzmax)
        barheight=rmod2.vecgen1(zzmax)
        for lev in range(0,zzmax):
            barheight[lev]=distance[iobj][lev]
            levabsc[lev]=str(lev+1)
        app=raioop2.brgbar10(hf,barheight,levabsc,"level-distances of object "+str(objact),5,"red")    
        app.ausgabe()    
        

## Tkinter Plot
hf = Tkinter.Tk()
hf.title(' level heuristic ')
aboutlevheur=raioop2.brgabout(hf,"tp1","about_levelheuristic.txt",2,\
            "November, 25th,2012"," about levelheiutistic ", "white", "t1",80,5,ScrolledText)
helplevheur=raioop2.brgabout(hf,"tp1","help_levelheuristic.txt",2,\
            "November, the 25th,2012"," help_level heuristic ", "white", "t1",80,5,ScrolledText)
    
fr=Tkinter.Frame(hf,width=60)
fr.pack()
buttHD = Tkinter.Button(fr, text='select, open and HD',width=25,bg="cyan",command=HD)
buttHD.pack(pady=5)
lb1=Tkinter.Label(fr,text=" ",width=50)
lb1.pack()
buttshowdm1=Tkinter.Button(fr, text="Show data matrix ",width=25,command=showDM)
buttshowdm1.pack()
buttweight=Tkinter.Button(fr,text="Weights input ",bg="cyan",width=25,command=weightdetermination)
buttweight.pack()
buttheuristic=Tkinter.Button(fr,text="Heuristic ",bg="cyan",width=25,command=heuristic)
buttheuristic.pack()
lb2=Tkinter.Label(fr,text="Enter object of interest for a bar diagram ")
lb2.pack()
lb3=Tkinter.Label(fr,text="")
lb3.pack()
eobj=Tkinter.Entry(fr,width=10)
eobj.pack()
butthisto=Tkinter.Button(fr,text="bar diagram ",bg="cyan",width=25,command=histo_single_object)
butthisto.pack()
buttexit = Tkinter.Button(fr, text = 'exit', bg = 'red', width=25,command = hf.destroy)
buttexit.pack(pady=10)

hf.mainloop()

