import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import random
import tkFileDialog
import raioop2

import tkSimpleDialog
import stats
import pstat


# Brg 4.8.08 lin (ear ) agg (regation) 
# derived from stability3
# Brg 5.8.08: def showdm was eliminated as it is already contained in the class brgfileselect
# Brg 6.8.08: std-of rkagg will be calculated
# Brg 10.8.08: resulting ranking
# Brg 2.3.09: correction in parameters of HD-class and other large changes,
#.............implied by the changed HD-class
# Brg 3.3.09: linagg6. SOCNalt was eliminated, number of MC-simulations now as an input by the user
# Brg 8.7.10  Sometimes the simul. rank-interval of an object x is larger than U(x). Therefore a new controlling routine
# Brg 24.1.2011: Any case of MC leads to a ranking. All cases can be summarized by a HD
# Brg 25.1.2011: Work of 24.1. cont'd
# Brg 2.2.2011 : linagg10.py

def raihelp():
    """ Help about linagg """
    
    #  Use of OOP
    helplinagg=raioop2.brgabout(hf,"tp1","help_linagg.txt",10,\
            "February, the 2nd,2011"," help_linagg ", "white", "t1",80,5,ScrolledText)
    
def about():
    """ About linagg """
    # Brg 4.8.08
    aboutlinagg=raioop2.brgabout(hf,"tp2","about_linagg.txt",10,\
            "February, the 2nd,2011"," about_linagg ", "white", "t2",80,4,ScrolledText)
    

def mcsel():
    mcs=tkSimpleDialog.askinteger("Number of MC-simulations","No of MCsim ",maxvalue=3000)
    if mcs==None:
        factor=200
    else:
        factor=mcs
    return factor    

def SOCN():
    """ select, open, compare and normalizes the data matrix """
    # Brg 4.8.08
    global rred,y,objred,fn,k,r,obj,dm
    #select and open
    app1=raioop2.brgfileselectnew(hf,"tp3")   #
    #access to dimension of the matrix
    fn,r,k=app1.transfer_part1()
    #access to names
    ob,pro=app1.transfer_part2()
    #access to the dm itself
    dm=app1.transfer_part3()
    # 
    prop=rmod2.vecgentext1(k)
    obj=rmod2.vecgentext1(r)    #8.5.08 changed: ...text1
    #prop and obj contain the proper names of attributes and objects, resp.
    for i in range(0,k):
        prop[i]=pro[i+1]
    for i in range(0,r):
        obj[i]=ob[i+1]
    ################################################################
    rred,xred,objred,txtquot,txteq=rmod2.equivcompact3(r,k,dm,obj)    
    ################################################################
    #rmod2.strmatout(r,r,txteq)  #28.12.08
    y=rmod2.matrixnorm(rred,k,xred)
    buttHD.config(bg="cyan",state='active')
    buttscore.config(bg="cyan",state='active')
    buttMCHD.config(bg="cyan",state='active')
    return rred,r,k,y,objred,obj,prop,fn,txtquot,txteq       


def geomHD(zv, levm,zlev):
    """ from zv the graphical control for HDs is derived """
    #zv is the number of vertices
    # levm is the number of vertices in the maximal level (determines the x coord
    # zlev is the number of levels, determines the y coord
    # * Brg 10.6.08
    # akt: 10.6.08
    # brg 10.6.08
    awidth=zv*40
    aheight=zv*40
    if awidth<120:
        awidth=120
    if awidth>600:
        awidth=600
    if aheight<120:
        aheight=120
    if aheight>600:
        aheight=600
    
    #aheight and awidth: extent of canvas
    fx = int((awidth-40))
    fy = int((aheight-40))
    g0x=5   #Start of the HD-area x
    g0y=20   #Start of the HD-area y
    garr1x=fx +10.0  #location of the arrow
    garr1y=20
    garr2y=fy+10.0
    return awidth,aheight,fx,fy,g0x,g0y,garr1x,garr1y,garr2y



def HD():
    global raieq1,zeta,rred1,n1,objred1,y1,k1,txtquot1,r1,obj1,uloc   
    rred1,r1,k1,y1,objred1,obj1,prop1,fn1,txtquot1,raieq1=SOCN()
    "based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"
    # Brg 20.12.07, 28.12.07
    # If the number of representants > 50 then only the cover-matrix and the level-population
    #
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    
    n=rred1
    txtn="Number of representants "+str(n)+"\n"
    txtn+=txtquot1
    tpeqprof=Tkinter.Toplevel(hf)
    tpeqprof.title(' equivalence classes of DM ')
    teqprof=ScrolledText(tpeqprof,width=60,height=5)
    teqprof.pack()
    teqprof.insert("end",txtn)
    #
    uloc=rmod2.vecgen1(rred1)
    zetahilf=rmod2.comp(n,k1,y1)
    rmod2.matout(rred1,rred1,zetahilf)
    zeta=rmod2.marray(rred1,rred1)
    for i in range(0,rred1):
        for j in range(0,rred1):
            zeta[i][j]=zetahilf[j][i]
    for i in range(0,rred1):
        for j in range(0,rred1):
            if i!=j:
                if zeta[i][j]==0 and zeta[j][i]==0:
                    uloc[i]+=1

    
    #One linear extension (based on levels)
    lbhd1=Tkinter.Label(freq,text= "Level ")
    lbhd1.pack()

    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(n,zeta)
    #print "zzmax = ",zzmax
    tlev=ScrolledText(freq,width=60,height=4)
    tlev.pack()
    txt1="\n"
    levmax=-10**20
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
    tpbasic=Tkinter.Toplevel(hf)
    tpbasic.title(' basic characteristics of the Hasse diagram ')
    lbbasic=Tkinter.Label(tpbasic,text="number of level: \t\t\t\t"+str(zzmax)+"\n\
number of representants in the largest level:\t "+str(levmax),bd=3,bg="yellow",width=60)
    lbbasic.pack()
    
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= objred[lobj[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)

    txt2="\n One linear extension \n\n"
    for i in range(0,n):
        if i<n-1:
            txt2+=objred[revlext[i]]+" < "
        else:
            txt2+=objred[revlext[i]]+"\n"
    txt2+="\n"
    txt2+="\n -- end of list -- "
    tlinext=ScrolledText(freq,width=60, height=2)
    tlinext.pack()
    tlinext.insert("end",txt2)
    
    #Adj-Listen

    adjc=rmod2.adjacent(n,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(n,adjc,lext)
       
    
    zetaprof=rmod2.cover(n,tr,lext)
    if n>50:
        coverprof_show()                  #20.1.08
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram of File "+fn)
        lbhd3.pack()
        actwidth,actheight,factorx,factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=geomHD(n,levmax,zzmax)
##        print "actual width  ",actwidth
##        print "actual height ",actheight
##        print "factory       ",factory
##        print "factorx       ",factorx
##        print "garrow1x      ",garrow1x
        
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight, bg="white")
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(n,n)
        geomy=rmod2.marray(n,n)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if zetaprof[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-25,geomy[i][j]+20,geomx[i][j]+25,geomy[i][j]-20,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text="U("+objred[lobj[i][j]]+")="+str(uloc[lobj[i][j]]),font=("arial",8,"bold"))
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
##        cv.create_line(garrow1x-4,garrow2y-4,garrow1x,garrow2y)
##        cv.create_line(garrow1x+4,garrow2y-4,garrow1x,garrow2y)
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.pack()
        buttcover=Tkinter.Button(freq,text="show cover relation",command=showcov)
        buttcover.pack()
    buttranking.config(state='active')
    buttshow_MC.config(state='active')

def showcov():
    global utotal,u
    app1=raioop2.HDrigid(hf,"tphd",50,fn,txtquot1,raieq1,rred1,k1,y1,objred1,r1,obj1)
    utotal,u=app1.preHD()
    
    app1.cover_show()
    buttranking.config(state='active')
    buttshow_MC.config(state='active')
          
def MC_Simul():
    """ weights of each attribute are varied between 0,1
        ,normalized and the rank due to rkagg(x) = sum g(i)*qn(i) calculated.
        Finally a histogram is derived of distribution of rkagg(x)"""
    #brg 4.8.08
    global h,nhisto
    fac=mcsel()
    MCsim=fac*k
    nhisto=2*rred   # maximally rank = 1, in order to have a sufficient differentiation if rred
                    # objects populate the interval [0,1] nhisto is 2*rred
    g=rmod2.vecgen1(k)
    h=rmod2.marray(rred,nhisto)
    rkagg=rmod2.vecgen1(rred)
    avlinrk=rmod2.vecgen1(rred)
    sumsquare=rmod2.vecgen1(rred)
    varianz=rmod2.vecgen1(rred)
    
    

    
    for i in range(0,MCsim):
        sumg=0
        for j in range(0,k):
            g[j]=1.0*random.randint(0,100)/100.0
            sumg+=g[j]
        if sumg!=0.000:    
            for j in range(0,k):
                g[j]=g[j]/sumg
        else:
            lbwarn.config(text="weights are equal",bg="yellow")
            for j in range(0,k):
                g[j]=1.0/(1.0*k)
                
        for i_object in range(0,rred):
            rkagg[i_object]=0
            for j in range(0,k):
                rkagg[i_object]+=g[j]*y[i_object][j]  #8.7..2010: y is the columnwise normalized dm
            avlinrk[i_object]+=rkagg[i_object] #average value
            sumsquare[i_object]+=rkagg[i_object]*rkagg[i_object]
            
        for i_object in range(0,rred):
            for i_rk in range(0,nhisto):
                if 1.0*i_rk/(1.0*nhisto)<rkagg[i_object]<=1.0*(i_rk+1.0)/(1.0*nhisto):
                    h[i_object][i_rk]+=1

              
    for i_object in range(0,rred):
        varianz[i_object]=(sumsquare[i_object]-(1.0*avlinrk[i_object]*avlinrk[i_object])/(1.0*MCsim))/(1.0*MCsim-1.0)
        avlinrk[i_object]=1.0*avlinrk[i_object]/(1.0*MCsim)
    # end of MC
    #print "avlinrk ",avlinrk
    return h,MCsim,nhisto,avlinrk,varianz



def showMC():
    """ the results of MC-simulation are
    shown for any specified object"""

    h,MCsim,nhisto,avlrk,var=MC_Simul()
    objspec=eobject.get()
    hobject=rmod2.vecgen1(nhisto)
    iobj=objred.index(objspec)
    incomp=uloc[iobj]
    for i_rk in range(0,nhisto):
        hobject[i_rk]=h[iobj][i_rk]
    
    for i_rk in range(0,nhisto):
        if hobject[i_rk]>0: 
            i_rkmin=i_rk
            break
    for i_rk in range(nhisto-1,-1,-1):
        if hobject[i_rk]>0:
            i_rkmax=i_rk
            break
    #print "hobject = ",hobject
    title="MC-Simul1 "
    txt=""
    txt+="\nobject = "+objspec
    txt+="\n"+50*"--"
    txt+="\n"
    for i_rk in range(0,nhisto):
        txt+=str(i_rk)+":\t"+str(round(hobject[i_rk],3))+"\n"
    txt+="\n"
    txt+="\n Average lin aggreg: \t"+str(round(avlrk[iobj],2))
    txt+="\n variance: \t\t"+str(round(var[iobj],4))
    txt+="\n Min rank: \t\t"+str(round(0.5*i_rkmin,2))
    txt+="\n Max rank: \t\t"+str(round(0.5*i_rkmax,2))
    txt+="\n Span: \t\t\t"+str(round(0.5*(i_rkmax-i_rkmin)))
   
    txt+="\n"
    appsrtxt=raioop2.brgscrolltext2(hf,txt,title,"t4",60,5,"MC_1")
    appsrtxt.ausgabe()
    apphisto=raioop2.brghisto2(frhisto,"t3",nhisto,hobject,\
                               "red","white","MC-Simul2: object: "+ objspec+"\n  incomparability= "+str(incomp))
    apphisto.ausgabe()    

def MC_rank():
    """ weights of each attribute are varied between 0,1
        ,normalized and the rank due to rkagg(x) = sum g(i)*qn(i) calculated.
        Finally a histogram is derived of distribution of rkagg(x)"""
    #brg 4.8.08, 10.8.08
    global hr
    fac=mcsel()
    MCsim=fac*k
    #test
       
    g=rmod2.vecgen1(k)
    hr=rmod2.marray(rred,rred)
    rkagg=rmod2.vecgen1(rred)
    ranking=rmod2.vecgen1(rred)
    sumsquare=rmod2.vecgen1(rred)
    varianz=rmod2.vecgen1(rred)
 
    for i in range(0,MCsim):
        sumg=0
        for j in range(0,k):
            g[j]=1.0*random.randint(0,100)/100.0
            sumg+=g[j]
        if sumg!=0.000: 
            for j in range(0,k):
                g[j]=1.0*g[j]/(1.0*sumg)
        else:                     #in the improbable case that no one of the g-values is unzero
            lbwarn.config(text="weights are equal",bg="yellow")
            for j in range(0,k):
                g[j]=1.0/(1.0*k)
        #print "test = : g ",g
        for i_object in range(0,rred):
            rkagg[i_object]=0
            for j in range(0,k):
                rkagg[i_object]+=g[j]*y[i_object][j]
        #print "test rkagg : ",rkagg
        xr1,nr1=rmod2.raisort(rred,rkagg)
        #print "test nr1 : ",nr1
        for i_object in range(0,rred):
            for ir in range(0,rred):
                if i_object==nr1[ir]:
                    hr[i_object][ir]+=1
    #print "test hr "
    #rmod2.matout(rred,rred,hr)
    return hr,MCsim

def rankscore():
    #brg 8.7.10
    #as sometimes tha span of ranks is larger than U(x)
    # here is a control:
    """ weights of each attribute are varied between 0,1
        ,normalized and the rank due to rkagg(x) = sum g(i)*qn(i) calculated.
        Finally a histogram is derived of distribution of rkagg(x)"""
    #brg 4.8.08, 10.8.08
    global hr
    fac=mcsel()
    MCsim=fac*k
    #test
       
    g=rmod2.vecgen1(k)
    hr=rmod2.marray(rred,rred)
    rkagg=rmod2.vecgen1(rred)
    minsc=rmod2.vecgen1(rred)
    maxsc=rmod2.vecgen1(rred)
    rkscores=rmod2.vecgen1(MCsim) 
    for i in range(0,MCsim):
        sumg=0
        for j in range(0,k):
            g[j]=1.0*random.randint(0,100)/100.0
            sumg+=g[j]
        if sumg!=0.000: 
            for j in range(0,k):
                g[j]=g[j]/sumg
        else:                     #in the improbable case that no one of the g-values is unzero
            lbwarn.config(text="weights are equal",bg="yellow")
            for j in range(0,k):
                g[j]=1.0/(1.0*k)
        #print "test = : g ",g
        for i_object in range(0,rred):
            rkagg[i_object]=0
            for j in range(0,k):
                rkagg[i_object]+=g[j]*y[i_object][j]
        rkscores[i]=pstat.lrankdata(rkagg)        

    for iobj in range(0,rred):
       minsc[iobj]=rred
       for i in range(0,MCsim):
           if rkscores[i][iobj]<minsc[iobj]:
               minsc[iobj]=rkscores[i][iobj]
               
    for iobj in range(0,rred):
       maxsc[iobj]=-rred
       for i in range(0,MCsim):
           if rkscores[i][iobj]>maxsc[iobj]:
               maxsc[iobj]=rkscores[i][iobj]

    txt="Object:\tmin\tmax  rank \n"
    txt+=60*"="+"\n"
    for iobj in range(0,rred):
       txt+= objred[iobj]+"\t"+str(minsc[iobj])+"\t"+str(maxsc[iobj])+"\n"
    txt+="\n - - - e o f - - -"
    tpscore=Tkinter.Toplevel(hf)
    tpscore.title(" rank scores ")
    tscore=ScrolledText(tpscore,width=70,height=8)
    tscore.pack()
    tscore.insert("end",txt)
                                   
def showranking():
    """ the results of MC-rank are
    shown for any specified object"""

    hr,MCsim=MC_rank()
    objspec=eobject.get()
    hobject=rmod2.vecgen1(rred)
    barth=rmod2.vecgen1(rred1)
    iobj=objred.index(objspec)
    incomp=uloc[iobj]
    for i_rk in range(0,rred):
        hobject[i_rk]=hr[iobj][i_rk]
        if i_rk<10:
            barth[i_rk]=24*" "+str(i_rk)
        elif i_rk<100:
            barth[i_rk]=23*" "+str(i_rk)
        else:
            barth[i_rk]=22*" "+str(i_rk)

    title="MC-rankings "
    txt=""
    txt+="\n"+50*"--"
    txt+="\n\t"
    for i_rk in range(0,rred):
        txt+="rank "+str(i_rk+1)+"\t"
    txt+="\n"
##    print "test objred ",objred
##    print "test rred ",rred
##    print "test objred[1] objred[2] ",objred[1]," ",objred[2]
    for i_object in range(0,rred):
        #print i_object," ",objred[i_object]
        txt+=objred[i_object]+":"
        for i_rk in range(0,rred):
            txt+="\t"+str(hr[i_object][i_rk])
        txt+="\n"
    appsrtxt=raioop2.brgscrolltext2(hf,txt,title,"t5",10*rred,5,"MC_rank")
    appsrtxt.ausgabe()
    
      
    apphisto=raioop2.brgbar6(frhisto2,hobject,barth,"incomp = "+str(uloc[iobj])," LINAGG7", 25)
    apphisto.ausgabe() 



def MCHD():
    # nbrg 24.1.2011
    # Idea: The user may be interested in variation of m' weights, whereas m-m' are held constant
    # Within the MC-simulation any case represents a ranking.
    # All rankings can be put together to a HD (similar to the stability4.py)
    global eMCsim,tpMCHD,egbelow,egabove
    tpMCHDo=Tkinter.Toplevel(hf)
    egbelow=rmod2.vecgen1(k)
    egabove=rmod2.vecgen1(k)
    lbgMCHD=Tkinter.Label(tpMCHDo,text="weight-intervals (below-above) ")
    lbgMCHD.pack()
    frgMCHD=Tkinter.Frame(tpMCHDo,bd=3,relief="sunken")
    frgMCHD.pack()
    for j in range (0,k):
        lbhilf=Tkinter.Label(frgMCHD,text="g["+str(j)+"]:")
        lbhilf.grid(row=j,column=0)
        egbelow[j]=Tkinter.Entry(frgMCHD,width=5)
        egbelow[j].grid(row=j,column=1)
        egabove[j]=Tkinter.Entry(frgMCHD,width=5)
        egabove[j].grid(row=j,column=2)
    lbgsim=Tkinter.Label(tpMCHDo, text="How many MC-simulations")
    lbgsim.pack()
    eMCsim=Tkinter.Entry(tpMCHDo,width=10)
    eMCsim.pack()
    buttMCHD=Tkinter.Button(tpMCHDo,text="submit of g-intervals ",command=gsubmit)
    buttMCHD.pack()


def gsubmit():
    global zeta21, objred1,rred1
    tpMCHD=Tkinter.Toplevel(hf)
    freq1=Tkinter.Frame(tpMCHD)
    freq1.pack()
    idnr=random.randint(1,1000)
    print "k = ",k
    gbelow=rmod2.vecgen1(k)
    gabove=rmod2.vecgen1(k)
    MCsim=int(eMCsim.get())
    dmg=rmod2.marray(rred,MCsim)
    g=rmod2.vecgen1(k)
    for j in range(0,k):
        gbelow[j]=float(egbelow[j].get())
        gabove[j]=float(egabove[j].get())
##    print "y = "
##    rmod2.matout(rred,k,y)
##    print " "
    gmin=rmod2.vecgen1(k)
    gmax=rmod2.vecgen1(k)
    gmean=rmod2.vecgen1(k)
    ming=rmod2.vecgen1(k)
    maxg=rmod2.vecgen1(k)
    for j in range(0,k):
        ming[j]=9999
        maxg[j]=-9999
    for mc in range(0,MCsim):
        sumg=0
        for j in range(0,k):
            g[j]=0.0001*random.randint(int(10000*gbelow[j]),int(10000*gabove[j]))
            #print "j = ",j," g= ",g[j]
            sumg+=g[j]
        if sumg!=1:    # sumweight=1 -normalization
            for j in range(0,k):
                g[j]=1.0*g[j]/sumg
        for j in range(0,k):
            gmean[j]+=g[j]
            if g[j]>=maxg[j]:
                maxg[j]=g[j]
            if g[j]<=ming[j]:
                ming[j]=g[j]
        Gamma=rmod2.vecgen1(rred)
##        print "mc= ",mc
##        for j in range(0,k):
##            print "  g[",j,"]= ",round(g[j],3),ming[j],maxg[j]
        for io in range(0,rred):
            for j in range(0,k):
                Gamma[io]+=y[io][j]*g[j]   #normalized dm of representants
            #print "Gamma fuer ",io,"  : ",Gamma[io]    
            
        lio=pstat.lrankdata(Gamma)
        for io in range(0,rred):
            dmg[io][mc]=lio[io]     #dmg will be filled with the different rankings counted by mc

##    rmod2.matout(rred,MCsim,dmg)
##    print "Nach equivcompact "
    for j in range(0,k):
        gmean[j]=1.0*gmean[j]/(1.0*MCsim)
    
    tpg=Tkinter.Toplevel(hf)
    tpg.title(' g-characteristic ')
    lbgchar=Tkinter.Label(tpg,text="effective g-values in a simulation with "+str(MCsim)+"  runs")
    lbgchar.pack()
    txtg="identifier: "+str(idnr)+"\n"
    txtg+=60*"="+"\n"
    txtg+=60*"="+"\n"
    txtg+="g-characteristics\n"
    txtg+=60*"="+"\n"
    txtg+="Inputs"+"\n"
    txtg+="    gbelow"+"\t"+"gabove"+"\n"
    for j in range(0,k):
        txtg+=str(j)+": "+str(round(gbelow[j],3))+"\t\t"+str(round(gabove[j],3))+"\n"
    txtg+=2*"\n"    
    txtg+="    min-values"+"\t"+"mean-values"+"\t"+"  max-values\n"
    for j in range(0,k):
        txtg+=str(j)+": "+str(round(ming[j],3))+"\t\t"+str(round(gmean[j],3))+"\t\t"+str(round(maxg[j],3))+"\n"
    txtg+="\n"
    txtg+="   e o f   "
    tgc=ScrolledText(tpg,width=80,height=10)
    tgc.pack()
    tgc.insert("end",txtg)

    rred1,dmgred,objred1,txtquot,txteq=rmod2.equivcompact3(rred,MCsim,dmg,objred)
##    rmod2.matout(rred1,MCsim,dmgred)
    zetahilf1=rmod2.comp(rred1,MCsim,dmgred)
    zeta1=rmod2.marray(rred,rred)
    for i in range(0,rred1):
        for j in range(0,rred1):
            zeta1[i][j]=zetahilf1[j][i]
    #
    
    #rmod2.matout(rred,rred,zeta)
    lobj1,lext1,revlext1,zzmax1=rmod2.levtopsort(rred1,zeta1)
    #print "zzmax = ",zzmax
    tlev1=ScrolledText(freq1,height=10,width=60)
    tlev1.pack()
    txt1="\n"
    for i in range(0,zzmax1):
        txt1+="Level "+str(zzmax1-i)+" :"
        for j in range(0,len(lobj1[i])):
            txt1+= objred1[lobj1[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev1.insert("end",txt1)

        
    #Adj-Listen

    adjc1=rmod2.adjacent(rred1,lext1,revlext1,zeta1)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred1,adjc1,lext1)
       
    
    zeta21=rmod2.cover(rred1,tr,lext1)
    if rred1>100:
        lbhd2=Tkinter.Label(freq1,text=" graphical presentation not meaningful, see levels and cover-matrix ")
        lbhd2.pack()
        txt3="\n cover-matrix  \n"
        for i in range(0,rred1):
            txt3+="\t"+objred1[i]+"\t"
        txt3+="\n"
        for i in range(0,rred1):
            txt3+=objred1[i]+" :"
            for j in range(0,rred1):
                txt3+=str(zeta21[i][j])+"\t"
            txt3+="\n"
        txt3+=" -- end of list --"
        tcov=ScrolledText(freq1,width=60, height=4)
        tcov.pack()
        tcov.insert("end",txt3)
    else:
        lbhd3=Tkinter.Label(freq1,text=" Hasse Diagram of File "+fn)
        lbhd3.pack()
        cv=Tkinter.Canvas(freq1,width=300,height=240,bg="white")
        lz=zzmax1
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj1[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(rred1,rred1)
        geomy=rmod2.marray(rred1,rred1)

        geom0x=10
        geom0y=20
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(160.0/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(160.0/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if zeta21[lobj1[i1][j1]][lobj1[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred1[lobj1[i][j]])
        garrow1x=210
        garrow1y=20
        garrow2y=190
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.create_text(50,230,text="Identifier: "+str(idnr))
        
        
        buttcover=Tkinter.Button(freq1,text="show cover relation",command=cover1_show)
        buttcover.pack()
        cv.pack()


def cover1_show():
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: -
    hfcover1=Tkinter.Toplevel(hf)
    hfcover1.title(' cover-matrix ')
    
    lbhd2=Tkinter.Label(hfcover1,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,rred1):
        txt3+="\n"+objred1[i]+":\t"
        txt3+="is covered by "
        for j in range(0,rred1):
            if i!=j:
                if zeta21[i][j]==1:
                    txt3+=" "+objred1[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover1,width=50, height=4)
    tcov.pack()
    tcov.insert("end",txt3)

def gcheck():
    # Brg 2.2.2011
    global ge, idwcheck
    tpgcheck=Tkinter.Toplevel(hf)
    tpgcheck.title(' Interface to read-in single weight-tuples ')
    frg=Tkinter.Frame(tpgcheck)
    frg.pack()
    ge=rmod2.vecgen1(k)
    lbge=rmod2.vecgen1(k)
    idwcheck=random.randint(1,1000)
    for j in range(0,k):
        lbge[j]=Tkinter.Label(frg,text="weight: "+str(j))
        lbge[j].grid(row=j,column=0)
        ge[j]=Tkinter.Entry(frg,width=5)
        ge[j].grid(row=j,column=1)
    buttgchecksubmit=Tkinter.Button(tpgcheck,text="Identifier: "+str(idwcheck)+"\nsubmit your selected weights ",command=weightsubmit)
    buttgchecksubmit.pack()

def weightsubmit():
    tpweight=Tkinter.Toplevel(hf)
    tpweight.title(' weak or linear orders ; id-no: '+str(idwcheck))
    dmn=rmod2.matrixnorm(r,k,dm)
    CI=rmod2.vecgen1(r)
    w=rmod2.vecgen1(k)
    for j in range(0,k):
        w[j]=float(ge[j].get())
    for i in range(0,r):
        CI[i]=0
        for j in range(0,k):
            CI[i]+=dmn[i][j]*w[j]
    tweightcheck=ScrolledText(tpweight)
    tweightcheck.pack(expand="yes")
    txt="Composite Indicator "+"\n"
    txt+="Selected weights: "
    for j in range(0,k):
        txt+=str(round(w[j],3))+", "
    txt+="\n"+"Identifier: "+str(idwcheck)+"\n"
    txt+="Values of the CI : \n"
    for i in range(0,r):
        txt+=str(obj[i])+": "+str(round(CI[i],3))+"\n"
    txt+="\n"
    txt+="objects sorted "+"\n"
    CIn,objsort=rmod2.raisort(r,CI)
    for i in range(0,r):
        txt+=str(obj[objsort[i]])+" < "
    txt+="\n"
    txt+="- - - eof - - -"
    tweightcheck.insert("end",txt)
    
        
    
hf=Tkinter.Tk()
hf.title('-- GUI: linear aggregation -- ')
lb0=Tkinter.Label(hf,text="",width=60) #only to give the GUI a more attractive layout
lb0.pack()
about()
raihelp()

buttHD=Tkinter.Button(hf,text="Sel.,open file & show HD ",width=25,bg="cyan",command=HD)
buttHD.pack()
buttshowcover=Tkinter.Button(hf,text="show cover relations",width=25,command=showcov)
buttshowcover.pack()
frobject=Tkinter.Frame(hf,relief="groove",bd=3)
frobject.pack(pady=5)
lb1=Tkinter.Label(frobject,text="select an object>>>")
lb1.pack(side="left")
eobject=Tkinter.Entry(frobject,width=10)
eobject.pack(side="left")
buttshow_MC=Tkinter.Button(hf,text="show histogram ",bg="cyan",width=25,state='disabled',command=showMC)
buttshow_MC.pack()
frhisto=Tkinter.Frame(hf,relief="raised",bd=3)
frhisto.pack()
lbwarn=Tkinter.Label(frhisto,text="")
lbwarn.pack()
buttranking=Tkinter.Button(hf,text="rk-distribution ",bg="cyan",width=25, state='disabled',command=showranking)
buttranking.pack()
buttscore=Tkinter.Button(hf,text="min and max of ranks",bg="cyan",width=25,state='disabled',command=rankscore)
buttscore.pack()
frhisto2=Tkinter.Frame(hf,relief="raised",bd=3)
frhisto2.pack()
buttMCHD=Tkinter.Button(hf,text="Subset of g-values ",bg="cyan",state='disabled',width=25,command=MCHD)
buttMCHD.pack(pady=5)
buttgcheck=Tkinter.Button(hf, text="check with weight-tuples ",bg="cyan",width=25,command=gcheck)
buttgcheck.pack(pady=5)
buttexit=Tkinter.Button(hf,text="  Exit  ",bg="red",width=25,command=hf.destroy)
buttexit.pack(pady=10)
hf.mainloop()
