import csv
import tkFileDialog
import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import raioop2
import math
#from string import replace

# brg 26.7.2013
# CSV-readin using professional routines of csv-library
# HDsimpl specifically for CSV-files (CSV-separated by ";")
# 28.7.2013: "," in numbers in "." in numbers
# 29.7.2013 cosmetics
# 29.8.2013 enabling to read data files stored in different formats
# 22.3.2014 cover-relation
# 8.9.2014 precision when checking the equivalence classes (equivcompactm2)
# 8.9.2014: output equivalence classes
# 9.9.2014 interface: graphviz
# 17.8.2016: Basis for linguistic_indicators2_1.py
# 21.8.2016: weights applied on relational matrices as standard


###### editfenster ### 29.8.2013 #####

def mat_scalar(matrix,sc,r,k):
    # brg 21.8.16
    matrixcopy = rmod2.matcopy1(r,k,matrix)
    for i in range(0,r):
        for j in range(0, k):
            matrixcopy[i][j]= sc*matrixcopy[i][j]
    return matrixcopy        

def xsave_in_PyHasseformat():
    # brg 26.7.2013
    # 6.8.2013: taken from csvHDsimpl1.py, 27.8.2013
    global r,k,x
    la=r+1
    ls=k+1
    
    xext=rmod2.marray(la,ls)
    for i in range(0,la):
        for j in range(0,ls):
            if i==0 and j==0:
                xext[i][j]="dummy"
            elif j==0 and i>0:
                xext[i][j]=obj[i-1]
            elif j>0 and i==0:
                xext[i][j]=prop[j-1]
            else:
                xext[i][j]=x[i-1][j-1]


    print " xext-matrix "
    for i in range(0,la):
        for j in range(0,ls):
            print xext[i][j]," ",
        print " "
    print "  "    
    fnnew=tkFileDialog.asksaveasfilename(parent=hf,title="save orig dm in PyHasseformat")
    fcsv=open(fnnew,"w")
    for i in range(0,la):
        for j in range(0,ls):
            fcsv.write(str(xext[i][j])+"\t")
        fcsv.write("\n")
    fcsv.close()
   
def xsave_in_PyHasseformat_n():
    # brg 26.7.2013
    # 6.8.2013: taken from csvHDsimpl1.py, 27.8.2013
    global r,k,x
    xn=rmod2.matrixnorm(r,k,x)

    la=r+1
    ls=k+1
    
    xext=rmod2.marray(la,ls)
    for i in range(0,la):
        for j in range(0,ls):
            if i==0 and j==0:
                xext[i][j]="dummy"
            elif j==0 and i>0:
                xext[i][j]=obj[i-1]
            elif j>0 and i==0:
                xext[i][j]=prop[j-1]
            else:
                xext[i][j]=xn[i-1][j-1]


    print " xext-matrix "
    for i in range(0,la):
        for j in range(0,ls):
            print xext[i][j]," ",
        print " "
    print "  "    
    fnnew=tkFileDialog.asksaveasfilename(parent=hf,title="save normalized dm in PyHasseformat")
    fcsv=open(fnnew,"w")
    for i in range(0,la):
        for j in range(0,ls):
            fcsv.write(str(xext[i][j])+"\t")
        fcsv.write("\n")
    fcsv.close()

def interface_graphviz():
    # brg 9.9.2014
    #taken from mHDCl2
    covgr=rmod2.marray(rred,rred)
    for i1 in range(0,rred):
        for i2 in range(0,rred):
            if i1!=i2:
                covgr[i1][i2]=cov[i1][i2]
    txtgr=rmod2.covtxt(covgr,objred,rred,"digraph_x") #central routine! 
    app1=raioop2.brgsavefile3(fr,'t','w',txtgr,rred,rred) 
    import tkMessageBox
    tkMessageBox.showinfo(title="store graphviz-interface",message="successafull!")


    

def xselectfile():
    # brg 6.8.2013
    global fn
    fn=tkFileDialog.askopenfilename()
    print "fn ",fn
    Tpopener=Tkinter.Toplevel(hf)
    Tpopener.title(' Opening window: different formats ')
    fropen2=Tkinter.Frame(Tpopener,bd=3,bg="white")
    fropen2.pack()
    # +++ Grid-Geometry manager +++
    lb0=Tkinter.Label(fropen2,text=" Select the appropriate format: ",bg="yellow",font=("arial",12,"bold"))
    lb0.grid(row=0,column=0)
    lb1=Tkinter.Label(fropen2,text="(1a) Open files, txt, tab (or blank) as delimiter (PyHasse-standard) :                ",bg="white")
    lb1.grid(row=1,column=0)
    lb2=Tkinter.Label(fropen2,text="(1b) Open files, csv, ';' as delimiter (csv with ';') :                               ",bg="white")
    lb2.grid(row=2,column=0)
    lb3=Tkinter.Label(fropen2,text="(1c) Open files, csv, ',' as delimiter (csv with ',') :                               ",bg="white")
    lb3.grid(row=3,column=0)
    lb6=Tkinter.Label(fropen2,text="(1f) Open files, pdt, internal PyHasse-format to exchange interim-results:            ",bg="white") 
    lb6.grid(row=6,column=0)
    butt1=Tkinter.Button(fropen2,text="(1a) Open txt-file       ",bg="cyan",bd=4,command=xfileopen)
    butt1.grid(row=1,column=1)
    butt2=Tkinter.Button(fropen2,text="(1b) Open csv-file (';') ",bg="cyan",bd=4,command=xcsvopenS)
    butt2.grid(row=2,column=1)
    butt3=Tkinter.Button(fropen2,text="(1c) Open csv-file (',') ",bg="cyan",bd=4,command=xcsvopenK)
    butt3.grid(row=3,column=1)
    butt6=Tkinter.Button(fropen2,text="(1f) Open pdt-file       ",bg="cyan",bd=4,command=xopenfilepdt)
    butt6.grid(row=6,column=1)


def xcsvopenS():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,obj,prop,x,xred,rred,objred,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=';', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")
    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)
    print "rred ",rred
    print "Matrix "
    rmod2.matout(r,k,xred)
    print "neq= ",neq
    print "txteq = ", txteq

    

def xcsvopenK():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,x,fn,obj,prop,xred,objred,rred,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=',', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")

    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)   # 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq





def xfileopen():
    "Informs about the file-operations"
    # Excelreadin4 built in
    # Brg 29.11.07, 30.11.07, 15.1.08,18.2.08
    global fn,r,k,x,prop,obj,rred,xred,objred,txteq
    x,ob,pr,r,k=rmod2.EXCELreadin6(fn)
    print "r = ",r,"   k = ",k
    obj=rmod2.vecgentext1(r)                        # 29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  # recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pr[i+1]   # recoding, because pr[0] is a dummy string
    # rmod2.matout(r,k,x)
    
    lbopen1.config(bg="yellow")    # 18.2.08
    lbopen1["text"]="File "+fn+" was opened with "+str(r)+" rows and "+str(k)+"  columns"
    
    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)   # 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq


    

def xopenfilepdt():
    """ File selection of transformed data matrices
    through other PyHasse programs """
    # brg 29.10.2012 taken from sensitivity18_3
    #* 1.6.09
    # akt. 29.10.2012 (taken from sensitivity18_3), 6.8.2013
    # source: mainHD19
    global fn,r,k,x,prop,obj,rred,xred,objred,txteq
    
    r,k,x,obj,prop=rmod2.raireadin5(fn)
    lbpdtopen.config(bg="yellow")
    lbpdtopen["text"]="selected file (PyHasse (pdt) format) : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns"

    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)  # new 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq

##### end of editenster ### 29.8.2013 ####

def show_dm():
    #brg 18.8.16, taken and modified from interval9.py
    tpdm=Tkinter.Toplevel(hf)
    tpdm.title('show DM')
    lbtp2=Tkinter.Label(tpdm,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tpdm,width=80,height=20)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,k):
            txt3+=str(x[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)    

def HD():
    # brg 26.7.2013, 29.8.2013
    # HD based directly on the data matrix (concatenation of the weak order
    # due to the single indicators (syn.: attributes)
    global x,la,ls,cov, rred, objred
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
        #
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #rmod2.matout(rred,rred,zeta)
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    if rred>400:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram  ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()
        buttcov=Tkinter.Button(freq, text = "cover - relation ",width = 20, command = cover)
        buttcov.pack()
        buttequiv = Tkinter.Button(freq,text="show equivalence classes", width = 30,command = showeq)
        buttequiv.pack()
        

def cover():
    hfcover = Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    lbcov = Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbcov.pack()
    txt3 = "\n cover-matrix  \n"
    for i in range(0, rred):
        txt3 += "\n" + objred[i] + ":\t"
        txt3 += "is covered by "
        for j in range(0, rred):
            if i!=j:
                if cov[i][j] == 1:
                    txt3 += " " + objred[j] + " ,"
                else:
                    pass
            else:
                pass
        txt3 += "\n"    
    txt3 += "\n"
    txt3 += " -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)
    

def showeq():
    tpequiv = Tkinter.Toplevel(hf)
    tpequiv.title(" equivalence classes ")
    tequiv=ScrolledText(tpequiv,width=60, height=10)
    tequiv.pack()
    txteq2="Equivalence classes"+"\n"
    txteq2+=50*"="+"\n"
    txteq2+="File: "+str(fn) +"\n"
    txteq2+="equivalence classes: "+txteq
    txteq2+="\n"
    txteq2+="- - - e o f - - -"
    tequiv.insert("end",txteq2)

def calc_relat(r, k, x):
    #taken from rmod2 13.10.2014 and modified according to PyHasse_internet
    c= []
    flag=0    
    for i1 in range(0, r):
        c.append(0)
        c[i1] = []
        for i2 in range(0, r):
            flag=0
            for j in range(0, k):
                #print " kk =",kk," i=",i," j = ",j
                if x[i1][j] >= x[i2][j]:
                    flag += 1
            if flag == k:
                 c[i1].append(1)
            else:
                 c[i1].append(0)
            #print " "     
    return c

def calc_relatatt(r, x, j):
    #Brg 17.8.16
    # r number of all objects
    # k number of attributes
    # x: data matrix
    # j: number of a column of x 0<j<m-1
    c= rmod2.marray(r,r)
    for i1 in range(0, r):
        for i2 in range(0, r):
            if x[i1][j] <= x[i2][j]:
                c[i1][i2]=1
            else:
                c[i1][i2]=0
    return c


def view_relat():
    # brg 17.8.16, 21.8.16
    try:
        jmatrix=int(ematrix.get())
    except:
        jmatrix = 0
    tpview=Tkinter.Toplevel(hf)
    tpview.title("view relational matrix "+str(jmatrix) )
    tview=ScrolledText(tpview,width=80,height=20)
    tview.pack()
    txt="relational matrix of "+str(r)+"  objects "+"\n"
    txt+="and the "+ str(jmatrix)+"th  attribute of"+"\n"
    txt+=str(k)+" attributes"+"\n"
    txt+=str(prop[jmatrix])+": "+"\n"
    txt+="\t"
    relatq=calc_relatatt(r,x,jmatrix)
    for i in range(0, r):
        txt+=str(obj[i])+"\t"
    txt+="\n"    
    for i1 in range(0, r):
        txt+=str(obj[i1])+"\t"
        for i2 in range(0, r):
            txt+=str(relatq[i1][i2])+"\t "
        txt+="\n"
    txt+="\n"
    tview.insert("end",txt)
    


def rowequality(r,k,matrix):
    #brg 16.8.16
    listdel=[]
    eqlist=[]
    for i1 in range(0, r):
        for i2 in range(i1+1, r):
            flag=0
            for j in range(0,k):
                if matrix[i1][j]==matrix[i2][j]:
                    flag+=1
            #print i1,i2,flag
            if flag==k:
                if i2 not in listdel:
                    listdel.append(i2)
                    eqlist.append((i1,i2))
    return listdel,eqlist

def extractnew(r,k,matrix, obj, listdel):
    #brg 16.6.16
    newmatrix = []
    rred=r-len(listdel)
    for i in range(0, rred):
        newmatrix.append(0)
        newmatrix[i]=[]

    # objred
    objred=[]
    for i in range(0, r):
        if i not in listdel:
            objred.append(obj[i])
    #newmatrix
    zahl=0
    for i in range(0,r):
        if i not in listdel:
            for j in range(0,k):
                if j not in listdel:
                    newmatrix[zahl].append(matrix[i][j])
            zahl+=1        
    return rred,objred,newmatrix            
        
def calc_Gamma():
    # brg 17.8.16, 18.8.16, 21.8.16
    global weights, Gamma, txtweights
    # weights
    weights=rmod2.vecgen1(k)
    try:
        whilf=eweights.get()
        print "whilf= ",whilf
        w2=whilf.split(",")
        print "w2= ",w2
        print "weights="
        for j in range(0,k):
            weights[j]=float(w2[j])
            print weights[j],
        print " "    
    except:
        weights=[]
        for j in range(0,k):
            weights.append(1.0/(1.0*k))     #i.e. no OR or AND -structure
    weightssum=sum(weights)
    flagweights=0
    if weightssum!=1:
        flagweights=1
        for j in range(0,k):
            weights[j]=(1.0*weights[j])/(1.0*weightssum)
    else:
        pass
    txtweights="weights "+"\n"
    txtweights+="("
    for j in range(0,k):
        txtweights+=str(weights[j])+", "
    txtweights+=")"+"\n"    
    # Additional Info about weights
    Disp=weights_dispersion(weights)
    
    # Gamma
    Gamma=rmod2.marray(r,r)
    unit=rmod2.marray(r,r)
    relatq=rmod2.matcopy1(r,r,unit)
    j=0
    zahl=0
    while j<k:
        relatqhilf=calc_relatatt(r,x,j)
        relatq=rmod2.matadd1(r,1,relatq,weights[j],relatqhilf)
        j+=1
        zahl+=1
        if zahl>1000:
            print "++++Abbruch+++++ in while..."
            break
        
    for i1 in range(0,r):
        for i2 in range(0,r):
            Gamma[i1][i2]=relatq[i1][i2]
           
    rmod2.matout(r,r,Gamma)        
    #print " "
    tpGamma=Tkinter.Toplevel(hf)
    tpGamma.title("Gamma")
    tGamma=ScrolledText(tpGamma,width=60, height=20)
    tGamma.pack()
    txt="Aggregation "+"\n"
    if flagweights==0:
        txt+="weights: "+"\n"
    else:
        txt+="weights normalized to get sum weights = 1"+"\n"
    txt+=txtweights+"\n"    
    txt+="\n"
    txt+="According R.R.Yager, 1993:"+"\n"
    txt+="Dispersion: "+"\t"+str(round(Disp,2))+"\n"
    
    txt+="\n"
    txt+="Resulting relational matrix 'Gamma' "+"\n\t"
    for i in range(0,r):
        txt+=str(obj[i])+"\t"
    txt+="\n"
    for i1 in range(0,r):
        txt+=str(obj[i1])+"\t"
        for i2 in range(0,r):
            txt+=str(round(Gamma[i1][i2],2))+"\t"
        txt+="\n"
    txt+="\n"    
    tGamma.insert("end",txt)
    buttpreview.config(state="active")

def weights_dispersion(owa):
    # brg 18.8.16, 21.8.16
    sumsh=0
    for j in range(0,k):
        if owa[j]!=0:
            sumsh+=owa[j]*math.log(owa[j])
        else:
            sumsh=99999
    Disp=-sumsh
    return Disp

def fuzzyproduct(r, d):
    "see DeBaets,DeMeyer in Inf Sci 152, 2003, 167-179"
    #brg 14.11.07, 18.8.16
    
    flag=0
    eps=0.1
    zaehl=0
   
    #print "In fuzzyproduct r =",r,"   k= ",k
    q=rmod2.matcopy1(r,r,d)
    
    while flag==0:
        q1=rmod2.fuzzymatmult(r,q,q)
        flag=rmod2.comparematrices(r,r,eps,q1,q)
        q=rmod2.matcopy1(r,r,q1)
        zaehl+=1
        if zaehl>20:
            break
        else:
            pass
    return q,zaehl

def preview():
    # brg 18.8.16
    GammaC,iterations = fuzzyproduct(r,Gamma)   #transitive closure
    txt="The transitive closure operation: "+"\n"
    txt+="Iterations: "+str(iterations)+"\n"
    txt+=" The transitive closure of the Gamma-matrix (=GammaC)"+"\n"
    listalpha=[]
    for i1 in range(0,r):
        for i2 in range(0,r):
            txt+=str(GammaC[i1][i2])+", "
            if str(GammaC[i1][i2])not in listalpha:
                listalpha.append(str(GammaC[i1][i2]))
        txt+="\n"
    txt+="\n"
    txt+="alpha-values:"+"\n"    
    for elem in listalpha:
        txt+=elem+", "
    txt+="\n"
    alpha_sorted,dummy1,dummy2=rmod2.brgsort(listalpha)
    txt+="\n"
    txt+="alpha-values increasing:"+"\n"    
    for elem in alpha_sorted:
        txt+=elem+", "
    txt+="\n"
    tppreview=Tkinter.Toplevel(hf)
    tppreview.title("preview of transitive closure ")
    tpreview=ScrolledText(tppreview, width=60, height = 20)
    tpreview.pack()
    tpreview.insert("end",txt)
    
def HDGamma():
    #brg 17.8.16, 18.8.16
    global rredG, covG, objredG,eqlistG,alphacut, GammaC, zetaG, Gammadefuzz
    freqG=Tkinter.Toplevel(hf)
    freqG.title("HD based on Gamma ")
    alphacut=float(ealphacut.get())
    print "----alpha-cut--- ",alphacut
    #Defuzzification;
    tpdefuzz=Tkinter.Toplevel(hf)
    tpdefuzz.title("control results  ")
    tdefuzz=ScrolledText(tpdefuzz,width=60, height=20)
    tdefuzz.pack()
    GammaC,iterations = fuzzyproduct(r,Gamma)   #transitive closure
    txtdefuzz="The transitive closure operation: "+"\n"
    txtdefuzz+="Iterations: "+str(iterations)+"\n"
    listalpha=[]
    for i1 in range(0,r):
        for i2 in range(0,r):
            if str(GammaC[i1][i2])not in listalpha:
                listalpha.append(str(GammaC[i1][i2]))
        
    txtdefuzz+="\n"
    txtdefuzz+="Defuzzification: alpha-cut= "+str(alphacut)+"\n"    
    Gammadefuzz=rmod2.marray(r,r)
    for i1 in range(0, r):
        for i2 in range(0, r):
            if GammaC[i1][i2]<alphacut:
                Gammadefuzz[i1][i2]=0
            else:
                Gammadefuzz[i1][i2]=1
    
        
    listdel,eqlistG=rowequality(r,r,Gammadefuzz)
    leq=len(eqlistG)
    txtdefuzz+="\nEquivalent objects (in pairs)"+"\n"
    for i in range(0, leq):
        txtdefuzz+=str(eqlistG[i])+", "
    txtdefuzz+="\n"
    rredG,objredG,zetaG=extractnew(r,r,Gammadefuzz,obj,listdel)
    txtdefuzz+="number of representative elements "+str(rredG)+"\n"
    tdefuzz.insert("end",txtdefuzz)    
    print "objredG = ",objredG
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rredG,zetaG)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rredG,lext,revlext,zetaG)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rredG,adjc,lext)
       
    
    covG=rmod2.cover(rredG,tr,lext)

    if rredG>400:
        lbhdG=Tkinter.Label(freqG,text=" +++too many objects ++++  ",bg="yellow")
        lbhdG.pack()                  
    else:
        lbhdG=Tkinter.Label(freqG,text=" Hasse Diagram, based on Gamma, alphacut= "+str(alphacut)+"\n"\
                            +txtweights)
        lbhdG.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rredG,levmax,zzmax)
        cv=Tkinter.Canvas(freqG,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rredG,rredG)
        geomy=rmod2.marray(rredG,rredG)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if covG[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objredG[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()
        buttcovG=Tkinter.Button(freqG, text = "cover - relation ",width = 20, command = coverG)
        buttcovG.pack()
        buttequivG = Tkinter.Button(freqG,text="show equivalence classes", width = 30,command = showeqG)
        buttequivG.pack()
##        labselect=Tkinter.Label(freqG, text="Select one of the following matrices:\n 'Gamma', 'GammaC', 'Gammadefuzz', 'zetaG'")
##        labselect.pack()
##        eselectmatrix=Tkinter.Entry(freqG,width=20)
##        eselectmatrix.pack()
##        buttshowmatrices=Tkinter.Button(freqG,text="View on different matrices of aggregation ",bg="white",width=40,command=show_matrices)
##        buttshowmatrices.pack()
        
def coverG():
    # brg 17.8.16
    global alphacut
    hfcoverG = Tkinter.Toplevel(hf)
    hfcoverG.title(' coverG-matrix ')
    lbcov = Tkinter.Label(hfcoverG,text=" Cover-Relations based on Gamma and alpha-cut = "+str(alphacut))
    lbcov.pack()
    txt3 = "\n cover-matrix  \n"
    for i1 in range(0, rredG):
        txt3 += "\n" + objredG[i1] + ":\t"
        txt3 += "is covered by "
        for i2 in range(0, rredG):
            if i1!=i2:
                if covG[i1][i2] == 1:
                    txt3 += " " + objredG[i2] + " ,"
                else:
                    pass
            else:
                pass
        txt3 += "\n"    
    txt3 += "\n"
    txt3 += " -- end of list --"
    tcov=ScrolledText(hfcoverG,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)

def showeqG():
    global alphacut
    tpeqG=Tkinter.Toplevel(hf)
    tpeqG.title("Equivalences based on Gamma")
    teq=ScrolledText(tpeqG,width=60,height=20)
    teq.pack()
    leq=len(eqlistG)
    txt="Equivalences (simple presentation)  "+"\n"
    txt+="alpha-cut= "+str(alphacut)+"\n"
    for i in range(0,leq):
        txt+=str(obj[eqlistG[i][0]])+" eq with "+str(obj[eqlistG[i][1]])+"\n"
    txt+="\n"
    teq.insert("end",txt)
        
def show_matrices():
    #brg 18.8.16, 21.8.16
    global r, k,rredG
    tpm=Tkinter.Toplevel(hf)
    tpm.title("matrices")
    tm=ScrolledText(tpm,width=60,height=40)
    tm.pack()
    txt="Matrices of aggregation "+"\n"
    txt+="File = "+str(fn)+"\n"
    txt+="rows and columns are object related "+"\n"
    txt+="Generally: row <= col "+"\n"
    try:
        selectmatrix=eselectmatrix.get()
    except:
        selectmatrix="Gamma"
    titel=selectmatrix
    windowstitel = "Matrices of aggregation "
    if selectmatrix=="Gamma":
        txt+="result of aggregation (Gamma)."+"\n"
        matrixout=rmod2.matcopy1(r,r,Gamma)
        txthilf=""
        for i1 in range(0, r):
            for i2 in range(0, r):
                txthilf+=str(matrixout[i1][i2])+",  "
            txthilf+="\n"
        txt+=txthilf    
    elif selectmatrix=="GammaC":
        txt+="Gamma transit. closed\n"
        matrixout = rmod2.matcopy1(r,r,GammaC)
        txthilf=""
        for i1 in range(0, r):
            for i2 in range(0, r):
                txthilf+=str(matrixout[i1][i2])+",  "
            txthilf+="\n"
        txt+=txthilf    
    elif selectmatrix=="Gammadefuzz":
        txt+="GammaC defuzzified due to "+str(alphacut)+"\n"
        matrixout = rmod2.matcopy1(r,r,Gammadefuzz)
        txthilf=""
        for i1 in range(0, r):
            for i2 in range(0, r):
                txthilf+=str(matrixout[i1][i2])+",  "
            txthilf+="\n"
        txt+=txthilf    
    elif selectmatrix=="zetaG":
        txt+="zetaG = extract of Gammadefuzz based on alpha-cut= "+str(alphacut)+"\n"
        matrixout = rmod2.matcopy1(rredG,rredG,zetaG)
        txthilf=""
        for i1 in range(0, rredG):
            for i2 in range(0, rredG):
                txthilf+=str(matrixout[i1][i2])+",  "
            txthilf+="\n"
        txt+=txthilf    
    else:
        pass
    txt+="- - - e o f - - - "+"\n"
    tm.insert("end",txt)
    
## Tkinter Plot
hf = Tkinter.Tk()
hf.title(' linguistic indic ')
aboutling=raioop2.brgabout(hf,"tp1","about_linguistic_ind_standard.txt",4,\
            "August, the 21th, 2016"," about linguistic indic_standard ", "white", "t1",120,5,ScrolledText)
helpling=raioop2.brgabout(hf,"tp1","help_linguistic_ind_standard.txt",4,\
            "August, the 21th, 2016"," help_linguistic indic. ", "white", "t1",120,5,ScrolledText)
    
fr = Tkinter.Frame(hf, width=60)
fr.pack()
frinput1 = Tkinter.Frame(fr, width=100, height=10)
frinput1.pack()
text = "Select first the file, then decide the opening format "
lbinput1 = Tkinter.Label(frinput1,
                         text=text)
lbinput1.pack()
butt1 = Tkinter.Button(frinput1, text="Select filename  ",
                       bg="cyan", width=40, command=xselectfile)
butt1.pack()
                      
lbopen1 = Tkinter.Label(fr, text="")
lbopen1.pack()
buttshowdm = Tkinter.Button(fr,text="Show data matrix ",bg="white",width=40,command=show_dm)
buttshowdm.pack()
buttHD = Tkinter.Button(fr, text='Draw HD', width=40, bg="cyan", command=HD)
buttHD.pack(pady=5)

labmatrix=Tkinter.Label(fr,text="View: different relational matrics\n\
        according to the 0th,1s,2nd,3rd...attribute ")
labmatrix.pack()
ematrix=Tkinter.Entry(fr,width=3)
ematrix.pack()
buttview=Tkinter.Button(fr,text="View relatmatrices(qj) ",bg="white",width=40,command=view_relat)
buttview.pack()
labweights=Tkinter.Label(fr,text="weights related to indicators, separated by ','")
labweights.pack()
eweights=Tkinter.Entry(fr,width=20)
eweights.pack()
buttaggreg=Tkinter.Button(fr,text="Aggregation ",bg="cyan",width=40, command=calc_Gamma)
buttaggreg.pack()
buttpreview=Tkinter.Button(fr,text="Orientational view on alpha-values ",bg="white",width=40, command=preview)
buttpreview.pack()
labalphacut=Tkinter.Label(fr,text="Enter alphacut ; value<alphacut: value(crisp) = 0, else 1")
labalphacut.pack()
ealphacut=Tkinter.Entry(fr,width=5)
ealphacut.pack()
buttHDGamma=Tkinter.Button(fr,text="HD based on Aggregation ",bg="cyan",width=40, command=HDGamma)
buttHDGamma.pack()
labselect=Tkinter.Label(fr, text="Select one of the following matrices:\n 'Gamma', 'GammaC', 'Gammadefuzz', 'zetaG'")
labselect.pack()
eselectmatrix=Tkinter.Entry(fr,width=20)
eselectmatrix.pack()
buttshowmatrices=Tkinter.Button(fr,text="View on different matrices of aggregation ",bg="white",width=40,command=show_matrices)
buttshowmatrices.pack()
buttexit = Tkinter.Button(fr, text='exit', bg='red',
                          width=25, bd=3,command=hf.destroy)
buttexit.pack(pady=5)
hf.mainloop()
