# -*- coding: cp1252 -*-
import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import tkFileDialog
import raioop2
import random

#Brg 3.3.2011, 31.8.16, 2.9.16

def HD():
    """based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"""
    # Brg 20.12.07, 28.12.07, 2.10.,3.10.09, 28.07.18
    # If the number of representants > 70 then only the cover-matrix and the level-population
    #
    global fn, r, prop, objred, rred, dmneu, dmneu, k, objred2, rred, cov, xred, circle
    try:
        circle=int(ecircle.get())
    except:
        circle=10
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    fn=tkFileDialog.askopenfilename()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    lb1.config(text="opened "+"\n"+fn,bg="yellow")
    
    
    prop=[]
    for j in range(0,k):
        prop.append(pro[j+1])
            
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
    for i in range(0,r):
        obj[i]=ob[i+1]

    # avoiding row sums = 0
    # 12.03.2017 Add 1.0 to every entry
    for i in range(0, r):
        for j in range(0,k):
            dm[i][j]=dm[i][j]+1.0
    rred,xred,objred,txteq=rmod2.equivcompactMarch18(r,k,dm,obj)
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    if rred>200:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram of "+str(fn))
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-circle,geomy[i][j]+circle,geomx[i][j]+circle,geomy[i][j]-circle,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()
        buttcover=Tkinter.Button(hfhd2,text="cover",width=25,command = cover_show)
        buttcover.pack()
        tpequivalences=Tkinter.Toplevel(hf)
        teq=ScrolledText(tpequivalences,height=5,width=60)
        teq.pack()
        txteq1="Equivalences of the raw matrix "+"\n"
        txteq1+=txteq+"\n"
        teq.insert("end",txteq)

def cover_show():
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07, 28.6.2015
    #note: -
    #source: -
    hfcover=Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    
    lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i1 in range(0,rred):
        txt3+="\n"+objred[i1]+":\t"
        txt3+="is covered by "
        for i2 in range(0,rred2):
            if i1!=i2:
                if cov[i1][i2]==1:
                    txt3+=" "+objred[i2]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=10)
    tcov.pack()
    tcov.insert("end",txt3)


def sf():
    #brg  31.5.09, 1.6.09, taken from palg4
    fn=tkFileDialog.asksaveasfilename(parent=hf,title="save file")
    # brg  30.5.09
##    for i in range(0,r):
##        print obj[i]," ",
##    print " "    
    rmod2.raiwrite5(fn,dmneu2,objred2,prop,rred2,k)
    lbsuccess.config(text="matrix with \n"+str(rred2)+"  rows  and "+str(k)+"\n  columns stored",bg="yellow")

def showdm():
    # taken from sepanalsimpl2_0.py
    # brg 28.6.2015
    """  shows the original data matrix (without entries = entries +1) """
    tp2=Tkinter.Toplevel(hf)
    tp2.title(' show DM ')
    lbtp2=Tkinter.Label(tp2,text=" General information about the original read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=20)
    tfile.pack()
    dm,ob,pro,r,k=rmod2.EXCELreadin6(fn)
    txt1="Data of "+str(fn)+"\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+ob[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+pro[j+1]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=pro[j+1]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=ob[i+1]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)

def parsum():
    # brg 28.6.2015, 1.9.16, 3.9.16, 12.03.17, 28.07.18
    global ac, cov2, rred2, normprofile, objred2
    """  shows interim matrices toward partial sums and
    the majorization Hasse diagram"""
    
    ac=eac.get()
    if len(ac)==0:
        ac=[]
        for ob in objred:
            ac.append(ob)
    else:
        ac=ac.split(",")
##    print "ac= ",ac
##    print "k = ",k
    #Normierung Profile
    normprofile=rmod2.marray(len(ac),k)
    zahl=0
    print "Max      Min    Range "
    for ob in ac:
        print ob,
        iob=objred.index(ob)
        hilf=[]
        sumhilf=[]
        for j in range(0, k):
            hilf.append(xred[iob][j])
        maxhilf=max(hilf)
        minhilf=min(hilf)
        sumhilf=sum(hilf)
        delta=1.0*(maxhilf-minhilf)
        deltasum=1.0*delta*sumhilf    
        print maxhilf,"  ",minhilf,"  ",delta
        
    
    print "Scaling factors"
    zahl=0
    sumprofile=[]
    for ob in ac:
        iob=objred.index(ob)
        hilf=xred[iob]
        sumprof=sum(hilf)
        sumprofile.append(sumprof)
        for j in range(0, k):
            normprofile[zahl][j]=(1.0*xred[iob][j])/(1.0*sumprofile[zahl])   
        zahl+=1    
    print "normprofile normiert "
    rmod2.matout(len(ac),k,normprofile)
    #eval
    dmsort=rmod2.marray(len(ac),k)
    dmparsum=rmod2.marray(len(ac),k)
    # sorting for increasing values of each data row corresp. to an object
    zahl=0
    for ob in ac:
        hilf=rmod2.vecgen1(k)
        for j in range(0,k):
            hilf[j]=normprofile[zahl][j]
        hilf.sort()
        hilf.reverse()
        for j in range(0,k):
            dmsort[zahl][j]=hilf[j]
        zahl+=1    
    zahl=0
    for ob in ac:
        print ob,": ",
        for j in range(0,k):
            print round(dmsort[zahl][j],3)," ",
        print " "    
        zahl+=1
    
    zahl=0
    for ob in ac:
        iob=objred.index(ob)
        
        for j in range(0,k):
            parsum=rmod2.vecgen1(k)
            for j1 in range(0,j+1):
                parsum[j]+=dmsort[zahl][j1]
            dmparsum[zahl][j]=parsum[j]
        zahl+=1    
    print "matrix of partial sums"
    rmod2.matout(len(ac),k,dmparsum)
    # maybe that new equivalences are possible
    rred2,dmneu2,objred2,txt2,neq2=rmod2.equivcompactm(len(ac),k,dmparsum,ac)
    #
    print "txt2 = ",txt2
    print "neq2= ",neq2
    print "objred2 = ",objred2
    tp3=Tkinter.Toplevel(hf)
    tp3.title(' show parsum ')
    tfile=ScrolledText(tp3,width=80,height=10)
    tfile.pack()
    txt1="\n"
    txt1+="\n objects and their scalingfactors\n"
    zahl=0
    for ob in ac:
        txt1+=" "+ob+"\t"+str(round(sumprofile[zahl],3))+"\n"
        zahl+=1
    txt1+="\n"

    txt1+="\n sorted and partial sums  (Basis for Young diagrams) \n"
   
    txt1+="\t"
    for j in range(0,k):
        txt1+="col"+ str(j+1)+"\t"
    txt1+="\n"
    zahl=0
    for ob in objred2:
        iob=objred2.index(ob)
        txt1+=objred2[iob]+"\t"
        for j in range(0,k):
            txt1+=str(round(dmneu2[zahl][j],3))+"\t"
        txt1+="\n"
        zahl+=1
    txt1+="\n\n"
    tfile.insert("end",txt1)

    #HD
    hfhd3=Tkinter.Toplevel(hf)
    hfhd3.title('Hasse diagram (majoriz) / cover matrix ')
    freq=Tkinter.Frame(hfhd3,width=200,height=300)
    freq.pack()
    

   
    zetahilf=rmod2.comp(rred2,k,dmneu2)  #zeta matrix with col<row
    zeta2=rmod2.marray(rred2,rred2)
    for i in range(0,rred2):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred2):
            zeta2[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred2,zeta2)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred2,lext,revlext,zeta2)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred2,adjc,lext)
       
    
    cov2=rmod2.cover(rred2,tr,lext)

    if rred2>400:
        lbhd4=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd4.pack()                  
    else:
        try:
            perturb=float(eperturb.get())
        except:
            perturb=1
        
        lbhd4=Tkinter.Label(freq,text=" Majoriz. Hasse Diagram of  "+str(fn))
        lbhd4.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred2,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred2,rred2)
        geomy=rmod2.marray(rred2,rred2)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                if perturb==1:
                    frandom=1
                else:
                    frandom=10+random.random()
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)+perturb*frandom  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov2[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-circle,geomy[i][j]+circle,geomx[i][j]+circle,geomy[i][j]-circle,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred2[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+2,garrow1y-6,text="mixing low")
        cv.create_text(garrow1x+2,garrow2y-6,text="mixing high")
        cv.pack()
        buttcover=Tkinter.Button(hfhd3,text="cover (majoriz)",width=25,command = cover_show2)
        buttcover.pack()
        buttshownormprofile=Tkinter.Button(hfhd3, text="Show the normprofiles ",width=25, command=show_normprofile)
        buttshownormprofile.pack()
        tpequivalences2=Tkinter.Toplevel(hf)
        teq=ScrolledText(tpequivalences2,height=10,width=60)
        teq.pack()
        txteq="Equivalences of the sorted normprofile matrix "+"\n"
        txteq+=txt2+"\n"
        teq.insert("end",txteq)

def show_normprofile():
    # brg 12.03.2017
    tpnormprofile=Tkinter.Toplevel(hf)
    tpnormprofile.title("Norm profiles ")
    tnormprofile=ScrolledText(tpnormprofile, height=20, width=80)
    tnormprofile.pack()
    txt="Normprofiles "+"\n"
    for i in range(0, rred):
        txt+="object = "+str(objred[i])+":\t"
        for j in range(0,k):
            txt+=str(round(normprofile[i][j],3))+", "
        txt+="\n"
    txt+="\n - - -  e o  f  - - - "
    tnormprofile.insert("end",txt)
            
def cover_show2():
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07, 28.6.2015
    #note: -
    #source: -
    hfcover2=Tkinter.Toplevel(hf)
    hfcover2.title(' cover-matrix ')
    
    lbhd5=Tkinter.Label(hfcover2,text=" Cover-Relations ")
    lbhd5.pack()
    txt3="\n cover-matrix  \n"
    
    for i1 in range(0,rred2):
        txt3+="\n"+objred2[i1]+":\t"
        txt3+="is covered by "
        for i2 in range(0,rred2):
            if i1!=i2:
                if cov2[i1][i2]==1:
                    txt3+=" "+objred2[i2]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover2,width=50, height=10)
    tcov.pack()
    tcov.insert("end",txt3)

    

        
## Tkinter Plot
hf = Tkinter.Tk()
hf.title(' Majorization ')
aboutHDsimpl=raioop2.brgabout(hf,"tp1","about_majoriz.txt",4,\
            "June, 28th,2015"," about majoriz ", "white", "t1",80,5,ScrolledText)
helpHDsimpl=raioop2.brgabout(hf,"tp1","help_majoriz.txt",4,\
            "June, 28th,2015"," help_majoriz ", "white", "t1",80,5,ScrolledText)
    
fr=Tkinter.Frame(hf,width=60)
fr.pack()
lbecircle=Tkinter.Label(fr,text="Enter radius of the circles (of the Hasse diagrams)\
        \n(default=10)")
lbecircle.pack()
ecircle=Tkinter.Entry(fr,width=5)
ecircle.pack()
buttHD = Tkinter.Button(fr, text='select, open and HD',width=25,bg="cyan",command=HD)
buttHD.pack(pady=5)
lb1=Tkinter.Label(fr,text=" ",width=50)
lb1.pack()
buttshowdm = Tkinter.Button(fr, text = "Show data matrix ",width=25, bg="cyan",command=showdm)
buttshowdm.pack()
lbcontrol=Tkinter.Label(fr,text="")
lbcontrol.pack(pady=5)
lbac=Tkinter.Label(fr, text="Enter the objects of the antichain (ac) of interest\
    \n(Default: the whole set of representants)")
lbac.pack()
eac=Tkinter.Entry(fr,width=30)
eac.pack()
lbperturb=Tkinter.Label(fr,text="Enter a perturbation to acoid artificial overlapping of lines (10 -20, ......) \n\
                                 default=1")
lbperturb.pack()
eperturb=Tkinter.Entry(fr,width=5)
eperturb.pack()
buttshow_parsum = Tkinter.Button(fr, text="calculate partial sums \n\
    and the HD of majorization", width=25,bg="cyan", command=parsum)
buttshow_parsum.pack()
buttexit = Tkinter.Button(fr, text = 'exit', bg = 'red', width=25,command = hf.destroy)
buttexit.pack(pady=10)

hf.mainloop()

