# -*- coding: cp1252 -*-
import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import tkFileDialog
import raioop2


#Brg 26.11. 2011 METEOR: purely successive aggregation, no knowledge of all weights
# brg 27.11.2011
# brg weight-assitant: 28.11.2011
# brg 1.12.2011

def HDdm():
    #brg 26.11.2011
    global fn,obj
    fn=tkFileDialog.askopenfilename()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    lb1.config(text="opened "+fn+"\n"+str(r)+" objects"+"\n"+str(k)+" attributes",bg="yellow")
    prop=[]
    for j in range(0,k):
        prop.append(pro[j+1])
            
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
    for i in range(0,r):
        obj[i]=ob[i+1]

    txtagg="Original dm"
    HDcalc(dm,r,k,obj,txtagg)


def HDcalc(xx,r,k,obj,txta):
    """based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"""
    # Brg 20.12.07, 28.12.07, 2.10.,3.10.09
    # If the number of representants > 70 then only the cover-matrix and the level-population
    #
    global covcalc,objredcalc
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    
    rred,xred,objredcalc,txt,neq=rmod2.equivcompactm(r,k,xx,obj)  
    
    #
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    covcalc=rmod2.cover(rred,tr,lext)

    if rred>100:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram  "+txt+"\n"+txta)
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if covcalc[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objredcalc[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()
        buttcov=Tkinter.Button(freq,text="show cover relations ",command=cover_show)
        buttcov.pack()

def cover_show():
    """Cover-matrix is displayed"""
    #brg 28.12.07, 28.11.2011
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: mainHD20
    hfcover=Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    
    lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations of the actual aggregation ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,n):
        txt3+="\n"+objredcalc[i]+":\t"
        txt3+="is covered by "
        for j in range(0,n):
            if i!=j:
                if covcalc[i][j]==1:
                    txt3+=" "+objredcalc[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=20)
    tcov.pack(expand=1,fill="both")
    tcov.insert("end",txt3)


def mnorm():
    # brg 26.11.2011
    global dmn, dmnact,m,n
    dm,ob,pro,n,m=rmod2.EXCELreadin4(fn)
   
    prop=[]
    for j in range(0,m):
        prop.append(pro[j+1])
            
    obj=rmod2.vecgentext1(n)     #8.5.08 changed to ...text1
    for i in range(0,n):
        obj[i]=ob[i+1]

    dmn=rmod2.matrixnorm(n,m,dm)
    dmnact=rmod2.matcopy1(n,m,dmn) 
    lbnorm.config(text="col-normalization and other steps...",bg="yellow")
    buttcalc.config(state="active")
    buttprecalc.config(state="active")
    buttstore.config(state="active")
    buttshowdm.config(state="active")

def precalc():
    # brg 26.11.2011
    global m,n, dmhilf,dmrank,no_qtstart,atttest
    
    
    no_qtstart=int(startatt.get())
    
    hilf=rmod2.vecgen1(3)
    for j1 in range(0,3):
        hilf[j1]=float(mentry[j1].get())
        #hilf[0], hilf[1] are the weights, normalized to sum up to 1
        #hilf[2] is the number of attribute to be aggregated to the
        #already aggregated superattribut
    
    # the proper calc begins here
   
       
    Qt=rmod2.vecgen1(n)
    for i in range(0,n):
        Qt[i]=dmnact[i][no_qtstart]
        #print i," ",Qt[i]

    atttest=hilf[2]
    dmhilf=rmod2.marray(n,2)
    dmrank=rmod2.marray(n,2)
    for i in range(0,n): #to see the HD of (super)indicator and the new attribute
        dmhilf[i][0]=Qt[i]
        dmhilf[i][1]=dmnact[i][int(hilf[2])]
    
    for i in range(0,n):
        Qt[i]=hilf[0]*Qt[i]+hilf[1]*dmnact[i][int(hilf[2])]
        #print "i= ",i,"  agg Q= ",Qt[i]

    for i in range(0,n): #To obtain the ranking just by the new superindicator
        dmrank[i][0]=Qt[i]
        dmrank[i][1]=Qt[i]
    
    #print "useatt ",useatt
    
    

def calc():
    # brg 27.11.2011
    global m,n, dmhilf,dmrank
    
    
    no_qstart=int(startatt.get())
    
    hilf=rmod2.vecgen1(3)
    for j1 in range(0,3):
        hilf[j1]=float(mentry[j1].get())
        #hilf[0], hilf[1] are the weights, normalized to sum up to 1
        #hilf[2] is the number of attribute to be aggregated to the
        #already aggregated superattribut
    print no_qstart,hilf,m
    # the proper calc begins here
   
    useatt.append(no_qstart)
    useatt.append(hilf[2])
    
    Q=rmod2.vecgen1(n)
    QQ=rmod2.vecgen1(n)
    print "start Q"
    for i in range(0,n):
        Q[i]=dmnact[i][no_qstart]
        QQ[i]=dmnact[i][no_qstart]
        print i," ",Q[i]

    
    print "values of the attribute to be aggregated "
    for i in range(0,n):
        print "i= ",i," q= ",dmnact[i][int(hilf[2])]
        
    for i in range(0,n):
        Q[i]=hilf[0]*Q[i]+hilf[1]*dmnact[i][int(hilf[2])]
        print "g1= ",hilf[0],"  Q ",QQ[i],"  g2= ",hilf[1],"  attrib. no  ",int(hilf[2])," q= ",dmnact[i][int(hilf[2])]
        print "Result: ","i= ",i,"  agg Q= ",Q[i]

        #print "useatt ",useatt
    
    for i in range(0,n):
        dmnact[i][no_qstart]=Q[i]
        dmnact[i][int(hilf[2])]=0

    for i in range(0,n):    
        
        for j in range(1,m):
            if j not in useatt:
                dmnact[i][j]=dmnact[i][j]
                
    #print "aggregated  att-no: ",hilf[2]
    rmod2.matout(n,m,dmnact)
    agg=set([])
    for j1 in range(0,len(useatt)):
        agg.add(int(useatt[j1]))
        
    txtagg="aggregation of att. no.: "
    for j1 in agg:
        txtagg+=str(j1)+", "
    HDcalc(dmnact,n,m,obj,txtagg)


    
def HDaggact():
    #brg 27.11.2011
    txta="the HD of the (super) attribute "+str(no_qtstart)+ " \n\
and the second attr. "+str(int(atttest))
    HDcalc(dmhilf,n,2,obj,txta)


def rk():
    txta= "local (in the space of attributes) \
ranking due to the new superattr. "
    HDcalc(dmrank,n,2,obj,txta)
    

def showDM():
    """ New routine : shows the data matrix """
    #Brg 13.1.08 from mainHD20: 27.11.2011
    tp2=Tkinter.Toplevel(hf)
    tp2.title('showDM')
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack(expand=1,fill="both")
    #dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,n):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    
    txt3="\n data matrix  \n"
    txt3+="\n"
    
    for i in range(0,n):
        txt3+=obj[i]+"\t"
        for j in range(0,m):
            txt3+=str(dmnact[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt3
    tfile.insert("end",txt)
    
def sf():
    #brg  31.5.09, 1.6.09 from mainHD20: 27.11.2011
    fn1=tkFileDialog.asksaveasfilename(parent=hf,title="save actual data matrix")
    # brg  30.5.09
    propf=rmod2.vecgen1(m)
    for j in range(0,m):
        propf[j]="att"+str(j)
    rmod2.raiwrite5(fn1,dmnact,obj,propf,n,m)
    lbsuccess.config(text="matrix with \n"+str(n)+"  rows  and "+str(m)+"\n  columns stored",bg="yellow")
    
def wassist():
    # brg 28.11.2011
    tc=ScrolledText(tpc,width=60,height=10)
    tc.pack()
    txtw="weight assistant "+"\n"
    txtw+=50*"="+"\n"
    txtw+="This METEOR - version assumes that the weights for all attributes are not"+"\n"
    txtw+="simultaneously known, but that weights for pairs of attributes can be given." +"\n"
    txtw+="The successive aggregation implies that the weights will be successively changed too, due to"+"\n"
    txtw+="the internal algorithm. "+"\n"
    txtw+="Therefore here those pairwise weights are determined, which would in the"+"\n"
    txtw+="final aggregation lead to equal weights of the final superattribute"+"\n"
    txtw+="When "+str(m)+"  attributes are successively aggregated, you need " +"\n"
    txtw+=str(m-1)+"  pairs of weights"+"\n"
    txtw+="Any two weights of a pair must sum up to 1 , therefore here that sequence "+"\n"
    txtw+="of the  f i r s t weights of the "+str(m-1)+"  pairs are calculated "+"\n"
    txtw+="which would finally lead to equal weights for the weighted sum, leading to the"+"\n"
    txtw+="superattribute" +"\n"
    for j1 in range(1,m):
        sumwz=0
        sumwn=0
        for j11 in range(0,j1):
            sumwz+=1.0/(1.0*m)
        for j12 in range(0,j1+1):
            sumwn+=1.0/(1.0*m)
        txtw+="Hypoth. first weight for the "+str(j1)+"st pair: "+str(round(1.0*sumwz/(1.0*sumwn),3))+"\n"
    txtw+="\n"
    txtw+="- - -  e o f - - -"
    tc.insert("end",txtw)
    
## Tkinter Plot
hf = Tkinter.Tk()
hf.title(' GUI: meteorHD ')
aboutHDsimpl=raioop2.brgabout(hf,"tp1","about_meteorHD.txt",3,\
            "November, 27th,2011"," about meteorHD ", "white", "t1",80,5,ScrolledText)
helpHDsimpl=raioop2.brgabout(hf,"tp1","help_meteorHD.txt",3,\
            "November, 27th,2011"," help_meteorHD ", "white", "t1",80,5,ScrolledText)

global mentry,startatt,useatt,tpc
useatt=[]
fr=Tkinter.Frame(hf,width=60)
fr.pack()
buttHD = Tkinter.Button(fr, text='select, open and HD',width=25,bg="cyan",command=HDdm)
buttHD.pack(pady=5)
lb1=Tkinter.Label(fr,text=" ",width=50)
lb1.pack()
buttnorm=Tkinter.Button(fr,text="normalization of dm \nand other preparatory steps ",width=25,bg="cyan",command=mnorm)
buttnorm.pack()
lbnorm=Tkinter.Label(fr,text="")
lbnorm.pack()
lbentry1=Tkinter.Label(fr,text="start with attribut no (0,1,2,...)")
lbentry1.pack()
startatt=Tkinter.Entry(fr,width=4)
startatt.pack()
z=0
lbentry2=Tkinter.Label(fr,text=" weight no 1,weight no 2, attribute to be aggreg. ")
lbentry2.pack()
frentry=Tkinter.Frame(fr,bd=3, relief="sunken") # grid!!!
frentry.pack()
mentry=rmod2.vecgen1(3)
for j1 in range(0,3):
    mentry[j1]=Tkinter.Entry(frentry,width=4)
    mentry[j1].grid(row=0,column=j1)
tpc=Tkinter.Toplevel(hf)
tpc.title(' optional analysis ')
lbc=Tkinter.Label(tpc,text="buttons to test single aggregation steps" ,bg="yellow")
lbc.pack()

buttprecalc=Tkinter.Button(tpc,text="Preview on (super)attr. ranking\n\
and HD of the two attributes ",width=25,bg="cyan",command=precalc,state="disabled")
buttprecalc.pack()
# three buttons with optional help and previews
butt1=Tkinter.Button(tpc, text=" HD of the two actually \
columns to be aggregated",command=HDaggact,width=30)
butt1.pack()
butt2=Tkinter.Button(tpc, text= "ranking due to the superindicator alone ",width=30,command=rk)
butt2.pack()
butt3=Tkinter.Button(tpc,text="weights assistance ",command=wassist,width=30)
butt3.pack()
buttcalc=Tkinter.Button(fr,text="stepwise aggregation ",width=25, bg="cyan",command=calc,state="disabled")
buttcalc.pack()
buttshowdm=Tkinter.Button(fr,text="show actually generated\n data matrix ",width=25,bg="cyan",command=showDM,state="disabled")
buttshowdm.pack()
buttstore=Tkinter.Button(fr,text="save actually generated\n data matrix ",width=25, bg="cyan",command=sf,state="disabled")
buttstore.pack()
lbsuccess=Tkinter.Label(fr,text="")
lbsuccess.pack()
buttexit = Tkinter.Button(fr, text = 'exit', bg = 'red', width=25,command = hf.destroy)
buttexit.pack(pady=10)

hf.mainloop()

