# -*- coding: cp1252 -*-
import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import tkFileDialog
import raioop2


#Brg 26.11. 2011 METEOR: purely successive aggregation, no knowledge of all weights
# brg 27.11.2011
# brg weight-assitant: 28.11.2011
# brg 1.12.2011
# brg 1.12. meteorparallel. In contrast to meteorHD the weights of the attributes
#           are known but now different groups of attributes are forming a pillar.
#           then the pillars can be used as basis for a new poset
# brg 3.12.2011 Read-in of pdt-files,normalization as optional step

def HDdm():
    #brg 26.11.2011
    global fn,obj,n,m
    fn=tkFileDialog.askopenfilename()
    dm,ob,pro,n,m=rmod2.EXCELreadin4(fn)
    lb1.config(text="opened "+fn+"\n"+str(n)+" objects"+"\n"+str(m)+" attributes",bg="yellow")
    prop=[]
    for j in range(0,m):
        prop.append(pro[j+1])
            
    obj=rmod2.vecgentext1(n)     #8.5.08 changed to ...text1
    for i in range(0,n):
        obj[i]=ob[i+1]

    txtagg="Original dm"
    HDcalc(dm,n,m,obj,txtagg)

def fileselect_PyHasse():
    """ File selection of transformed data matrices
    through other PyHasse programs """
    #* 1.6.09
    # akt. 1.6.09
    # source: mainHD19_4, 3.12.2011
    global fn,n,m,dm,prop,obj,dmn
    fn=tkFileDialog.askopenfilename()
    n,m,dm,obj,prop=rmod2.raireadin5(fn)
    pro0=rmod2.vecgentext1(m+1)
    pro0[0]="prop"              #this 3 lines construction needed because attsel needs pro0
    for j in range(1,m+1):
        pro0[j]=prop[j-1]
    #print "in mainHD = : r= ",r,"  k= ",k0
    ob=rmod2.vecgentext1(n+1) #this 3 lines construction needed because filecomp needs ob
    ob[0]="dummy"
    for i in range(1,n+1):
        ob[i]=obj[i-1]
    
    lbfile.config(bg="yellow")
    lbfile["text"]="selected file : "+fn+"  with \n"+str(n)+" rows\n"+str(m)+" columns"
    txtb="pdt-file"
    HDcalc(dm,n,m,obj,txtb)
    dmn=rmod2.matcopy1(n,m,dm)
    tpnpdt=Tkinter.Toplevel(hf)
    tpnpdt.title('normaliz. of pdt-dm')
    buttcalc.config(state="active")
    buttstore.config(state="active")
    buttshowdm1.config(state="active")
    buttshowdm2.config(state="active")

    buttnpdt=Tkinter.Button(tpnpdt,text="normaliz. of pdt-File",width=25,command=pdtnorm)
    buttnpdt.pack()

def pdtnorm():
    #brg 3.12.2011
    global dmn,n,m
    dmn=rmod2.matrixnorm(n,m,dm)
    
    lbnorm.config(text="col-normalization and other steps...",bg="yellow")
    buttcalc.config(state="active")
    buttstore.config(state="active")
    buttshowdm1.config(state="active")
    buttshowdm2.config(state="active")
    
    
    

def HDcalc(xx,r,k,obj,txta):
    """based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"""
    # Brg 20.12.07, 28.12.07, 2.10.,3.10.09
    # If the number of representants > 70 then only the cover-matrix and the level-population
    #
    global covcalc,objredcalc
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    
    rred,xred,objredcalc,txt,neq=rmod2.equivcompactm(r,k,xx,obj)  
    
    #
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    covcalc=rmod2.cover(rred,tr,lext)

    if rred>100:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram  "+txt+"\n"+txta)
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if covcalc[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objredcalc[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()
        buttcov=Tkinter.Button(freq,text="show cover relations ",command=cover_show)
        buttcov.pack()

def cover_show():
    """Cover-matrix is displayed"""
    #brg 28.12.07, 28.11.2011
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: mainHD20
    hfcover=Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    
    lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations of the actual aggregation ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,n):
        txt3+="\n"+objredcalc[i]+":\t"
        txt3+="is covered by "
        for j in range(0,n):
            if i!=j:
                if covcalc[i][j]==1:
                    txt3+=" "+objredcalc[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=20)
    tcov.pack(expand=1,fill="both")
    tcov.insert("end",txt3)


def mnorm():
    # brg 26.11.2011
    global dmn, m,n
    dm,ob,pro,n,m=rmod2.EXCELreadin4(fn)
   
    prop=[]
    for j in range(0,m):
        prop.append(pro[j+1])
            
    obj=rmod2.vecgentext1(n)     #8.5.08 changed to ...text1
    for i in range(0,n):
        obj[i]=ob[i+1]

    dmn=rmod2.matrixnorm(n,m,dm)
    
    lbnorm.config(text="col-normalization and other steps...",bg="yellow")
    buttcalc.config(state="active")
    buttstore.config(state="active")
    buttshowdm1.config(state="active")
    buttshowdm2.config(state="active")


def submitweights():
    #brg 1.12.2011
    global m,tpdesign,eweight
    tpdesign=Tkinter.Toplevel(hf)
    tpdesign.title(' Design for pillars ')
    frweights=Tkinter.Frame(tpdesign,bd=3,relief="sunken")
    frweights.pack()
    
    eweight=rmod2.vecgen1(m)
    for j1 in range(0,m):
        eweight[j1]=Tkinter.Entry(frweights,width=5)
        eweight[j1].grid(row=0,column=j1)
    
    
    

def design():
    # brg 27.11.2011, 1.12.2011
    global m,n, weight,epillar,msup
   
    frdesign=Tkinter.Frame(tpdesign,bd=3,relief="sunken")
    frdesign.pack()
    
   
    weight=rmod2.vecgen1(m)
    for j1 in range(0,m):
        try:
            weight[j1]=float(eweight[j1].get())
        except:
            weight[j1]=1.0/(1.0*m)
        print "weights = ",weight[j1]
        
    msup=int(emsup.get())
    print "msup= ",msup
    design=rmod2.vecgen1(m)
    epillar=rmod2.marray(msup,m)
    for j2 in range(0,msup):
        lbpillar=Tkinter.Label(frdesign,text="pillar no "+str(j2)+":")
        lbpillar.grid(row=j2,column=0)
        for j1 in range(0,m):
            epillar[j2][j1]=Tkinter.Entry(frdesign,width=3)
            epillar[j2][j1].grid(row=j2,column=j1+1)
        
    #
                               
def calc():        
    #brg 1.12.2011
    global dmnact
    pillar=rmod2.marray(msup,m)
    
    for j2 in range(0,msup):
            for j1 in range(0,m):
                if epillar[j2][j1].get()=="x":
                    pillar[j2][j1]=weight[j1]
                else:
                    pillar[j2][j1]=0
                
    #rmod2.matout(msup,m,pillar)    
    #print "dmn"
    rmod2.matout(n,m,dmn)
    dmnact=rmod2.marray(n,msup)
    for i in range(0,n):
        z=0
        
        for j2 in range(0,msup):
            sumQ=0
            for j in range(0,m):
                sumQ+=pillar[j2][j]*dmn[i][j]
                #print i," j2",j2," j ",j,"  pilla ",pillar[j2][j],"  dmn ",dmn[i][j]," pillar*dmn= ",pillar[j2][j]*dmn[i][j],"  sumQ= ",sumQ
                
            dmnact[i][z]=sumQ
            z+=1
    print "pillar data matrix"
    rmod2.matout(n,msup,dmnact)
    txtagg="parallel aggregation"
    HDcalc(dmnact,n,msup,obj,txtagg)


def showDMn():
    """ New routine : shows the data matrix """
    #Brg 13.1.08 from mainHD20: 27.11.2011
    tp3=Tkinter.Toplevel(hf)
    tp3.title('showDM')
    tfile=ScrolledText(tp3,width=60,height=4)
    tfile.pack(expand=1,fill="both")
    #dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,n):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    
    txt3="\n data matrix (normalized)  \n"
    txt3+="\n"
    
    for i in range(0,n):
        txt3+=obj[i]+"\t"
        for j in range(0,m):
            txt3+=str(dmn[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt3
    tfile.insert("end",txt)    

def showDMnact():
    """ New routine : shows the data matrix """
    global msup
    #Brg 13.1.08 from mainHD20: 27.11.2011
    tp2=Tkinter.Toplevel(hf)
    tp2.title('showDM')
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack(expand=1,fill="both")
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,n):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    
    txt3="\n data matrix on pillar level  \n"
    txt3+="\n"
    
    for i in range(0,n):
        txt3+=obj[i]+"\t"
        for j in range(0,msup):
            txt3+=str(dmnact[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt3
    tfile.insert("end",txt)
    
def sf():
    #brg  31.5.09, 1.6.09 from mainHD20: 27.11.2011
    global msup
    fn1=tkFileDialog.asksaveasfilename(parent=hf,title="save actual data matrix")
    # brg  30.5.09
    propf=rmod2.vecgen1(msup)
    for j in range(0,msup):
        propf[j]="superatt"+str(j)
    rmod2.raiwrite5(fn1,dmnact,obj,propf,n,msup)
    lbsuccess.config(text="matrix with \n"+str(n)+"  rows  and "+str(msup)+"\n  columns stored",bg="yellow")
    

    
## Tkinter Plot
hf = Tkinter.Tk()
hf.title(' GUI: meteorparallel ')
aboutmeteorparallel=raioop2.brgabout(hf,"tp1","about_meteorparallel.txt",2,\
            "December, 3rd,2011"," about meteorparallel ", "white", "t1",80,5,ScrolledText)
helpmeteorparallel=raioop2.brgabout(hf,"tp1","help_meteorparallel.txt",2,\
            "December, 3rd,2011"," help_meteorparallel ", "white", "t1",80,5,ScrolledText)


fr=Tkinter.Frame(hf,width=60)
fr.pack()
frenter=Tkinter.Frame(fr)
frenter.pack()
buttHD = Tkinter.Button(frenter, text='(Excel) select, open and HD',width=25,bg="cyan",command=HDdm)
buttHD.pack(pady=5,side="left")
buttHD2=Tkinter.Button(frenter,text="(pdt-File),select, open and HD",width=25,bg="cyan",command=fileselect_PyHasse)
buttHD2.pack(pady=5,side="left")
lb1=Tkinter.Label(fr,text=" ",width=50)
lb1.pack()
lbfile=Tkinter.Label(fr,text="",width=50)
lbfile.pack()
buttnorm=Tkinter.Button(fr,text="normalization of dm \nand other preparatory steps ",width=25,bg="cyan",command=mnorm)
buttnorm.pack()
lbnorm=Tkinter.Label(fr,text="")
lbnorm.pack()
buttshowdm1=Tkinter.Button(fr,text="show normalized data matrix ",width=25,bg="cyan",command=showDMn,state="disabled")
buttshowdm1.pack()
lbweight=Tkinter.Label(fr,text="weight for all attributes")
lbweight.pack()
buttweights=Tkinter.Button(fr,text="readin weights",bg="cyan",width=25,command=submitweights)
buttweights.pack()
lbemsup=Tkinter.Label(fr,text="How many pillars?" )
lbemsup.pack()
                      
emsup=Tkinter.Entry(fr,width=3)#how many pillars
emsup.pack()
buttdesign=Tkinter.Button(fr,text="Design of pillar-construction",bg="cyan",command=design)
buttdesign.pack()
buttcalc=Tkinter.Button(fr,text="stepwise aggregation ",width=25, bg="cyan",command=calc,state="disabled")
buttcalc.pack()
buttshowdm2=Tkinter.Button(fr,text="show actually generated\n data matrix ",width=25,bg="cyan",command=showDMnact,state="disabled")
buttshowdm2.pack()
buttstore=Tkinter.Button(fr,text="save actually generated\n data matrix ",width=25, bg="cyan",command=sf,state="disabled")
buttstore.pack()
lbsuccess=Tkinter.Label(fr,text="")
lbsuccess.pack()
buttexit = Tkinter.Button(fr, text = 'exit', bg = 'red', width=25,command = hf.destroy)
buttexit.pack(pady=10)

hf.mainloop()

