import rmod2
import raioop2
import Tkinter
from ScrolledText import *
import os
import Canvas
import random
import pstat
import stats

#brg 9.12.09 derived from pyhassemenue6 (w.r.t. menue structure)
#Brg 10.12.09
#Brg 16.12.09 model 4 zigzag-posets generalized
#Brg 21.12.09 mcsim inserted
#Brg 28.12.09 model 5 generalized star posets
#brg 14.12.2011 sensi(parameter)
#brg 15.12.2011 sensi2
# brg 16.12.2011 sensi2 bug-elimination
# brg 17.12.2011 sensi4 test
# brg 18.12.2011 sensi5 and test
# brg 19.12.2011 additional graphics
# brg 20.12.2011reorgansiation 1: calc<i>progr
# brg 28.11.2012 cosmetics

def calc5progr(m,a,b,e,d,c):
    # brg 17.12.2011
    summ1=0
    summ2=0
    for i in range(0,m+1):
        for j in range(0,c+1):
            f0=1.0*rmod2.nueberk(j+d,d)
            f1=1.0*rmod2.nueberk(j+d+b+1+i,i)
                
            f2=1.0*rmod2.nueberk(c-j+e,e)
            
            f4=c+3.0+b+d+i+e
            f5=1.0*rmod2.nueberk(m-i+a,a)
            
            summ1+=f0*f1*f2*f4*f5
            summ2+=f0*f1*f2*f5

    rkav=1.0*summ1/(1.0*summ2)
    LT = summ2

    lpom0=(b+c+d+e+3.0)+m*(b+c+d+e+3.0)/(a+b+c+e+4.0)
    lpom=(c+d+e+b+3.0)+m*(c+b+d+2.0)/(c+b+d+a+3.0)
    return rkav,lpom,lpom0

def calc4progr(p,b,n,m):
    # brg 19.12.2011
    LT1=0
    for j in range(0,b+1):
        LT1+=rmod2.nueberk(j+n+m+1,m)

    LT2=0
    for j in range(0,m+1):
        for i in range(0,p+1):
            LT2+=rmod2.nueberk(i+m-j,m-j)*rmod2.nueberk(j+n+b+1,j)

    LT=LT1+LT2

    #zbelowx
    zbx=0
    for j in range(0,b+1):
        zbx+=rmod2.nueberk(j+n+m+1,m)*(n+3.0+m+b)


    #zabovex
    zax=0
    for j in range(0,m+1):
        for i in range(0,p+1):
            zax+=rmod2.nueberk(i+m-j,m-j)*rmod2.nueberk(j+n+b+1,j)*(j+b+n+2)
    rkav=(1.0*zbx+1.0*zax)/(1.0*LT)
    lpom=n+b+2+(b+1.0)/(b+p+2.0)+((n+b+2.0)/(n+b+p+3.0))*m
    lpom0=(b+2.0+n)*(n+b+p+m+4.0)/(n+3.0+b+p)
    return rkav,lpom,lpom0


def calc3progr(p,b,a,s,m):
    # brg 19.12.2011
    rkav=s+b+2+((1.0*b+1.0)*m/(1.0*b+1.0*a+2.0))
    lpom=rkav
    lpom0=(s+b+2.0)*(s+b+a+p+m+4.0)/(s+b+a+p+4.0)
    return rkav,lpom,lpom0

def calc2progr(p,b,a,t,m):
    # brg 20.12.2011
    g=t+3+b
    h=t+1+b
    summ1=0
    summ2=0

    for j in range(0,m+1):
        for k in range(0,t+1):
            f1=rmod2.nueberk(h+j-k,j)
            f2=rmod2.nueberk(m-j+a,a)
            summ1+=f1*j*f2
            summ2+=f1*f2
    rkav=g+1.0*summ1/(1.0*summ2)
    lpom=(t+b+3.0)+m*(b+t+2.0)/(b+a+t+3.0)                  
    lpom0=(b+3.0+t)*(t+b+a+p+m+4.0)/(t+4.0+b+p+a)
    return rkav,lpom,lpom0

def calc1progr(p,s,t,m):
    # brg 20.12.2011
    rkav=(s+1.0)*(m+1.0+(s+2.0)*(t+1.0))/(m+1.0+(t+1.0)*(s+1.0))
    lpom=s+1+(s+1.0)/(m-t+1.0+(s+1))
    lpom0=(s+1.0)*(1.0+(1.0/(s+t+p+2.0)))
    return rkav,lpom,lpom0



def grsubmit():
    # brg 20.12.2011
    # Organisation of graphics within the sensitivity ofone parameter
    sel=int(esel.get())
    sensiname=rmod2.vecgen1(5)
    sensiname[0]=str(pactual)
    sensiname[2]="One-parameter-sensitivity"
    
    sensiname[4]="Sensitivity"
    if sel==1:
        # graphics deltaex
        sensiname[1]="rkav-lpomext"
        sensiname[3]="Minimum= "+str(round(minparameterex,2))+"   Maximum= "+str(round(maxparameterex,2))
        app1=raioop2.brggraph3(hf,sensiname,50,50,"red",3,deltaex,pactualstart,pactualend)
        app1.ausgabe()
    elif sel==2:
        # graphics delta00
        sensiname[1]="rkav-lpom0"
        sensiname[3]="Minimum= "+str(round(minparameter00,2))+"   Maximum= "+str(round(maxparameter00,2))
        app2=raioop2.brggraph3(hf,sensiname,50,50,"red",3,delta00,pactualstart,pactualend)
        app2.ausgabe()
    elif sel==3:
        #graphics: rkav vs pactual
        minrkav=min(rkavvec)
        maxrkav=max(rkavvec)
        sensiname[1]="rkav"
        sensiname[3]="Minimum= "+str(round(minrkav,2))+"   Maximum= "+str(round(maxrkav,2))
        rkavn,dum1,dum2,dum3=rmod2.vectornorm2(len(rkavvec),rkavvec)
        app3=raioop2.brggraph3(hf,sensiname,50,50,"red",3,rkavn,pactualstart,pactualend)
        app3.ausgabe()
    elif sel==4:
        #graphics lpomext vs pactual
        minlpomext=min(lpomvec)
        maxlpomext=max(lpomvec)
        sensiname[1]="LPOMext"
        sensiname[3]="Minimum= "+str(round(minlpomext,2))+"   Maximum= "+str(round(maxlpomext,2))
        sensiname[4]="Sensitivity"
        lpomn,dum1,dum2,dum3=rmod2.vectornorm2(len(lpomvec),lpomvec)
        app4=raioop2.brggraph3(hf,sensiname,50,50,"red",3,lpomn,pactualstart,pactualend)
        app4.ausgabe()
    elif sel==5:
        sensiname[1]="rkav-lpomext"
        sensiname[3]="Minimum= "+str(round(minparameterex,2))+"   Maximum= "+str(round(maxparameterex,2))
        app1=raioop2.brggraph3(hf,sensiname,50,50,"red",3,deltaex,pactualstart,pactualend)
        app1.ausgabe()
        sensiname[1]="rkav-lpom0"
        sensiname[3]="Minimum= "+str(round(minparameter00,2))+"   Maximum= "+str(round(maxparameter00,2))
        app2=raioop2.brggraph3(hf,sensiname,50,50,"red",3,delta00,pactualstart,pactualend)
        app2.ausgabe()
        minrkav=min(rkavvec)
        maxrkav=max(rkavvec)
        minlpomext=min(lpomvec)
        maxlpomext=max(lpomvec)
        sensiname[1]="rkav"
        sensiname[3]="Minimum= "+str(round(minrkav,2))+"   Maximum= "+str(round(maxrkav,2))
        rkavn,dum1,dum2,dum3=rmod2.vectornorm2(len(rkavvec),rkavvec)
        app3=raioop2.brggraph3(hf,sensiname,50,50,"red",3,rkavn,pactualstart,pactualend)
        app3.ausgabe()
        sensiname[1]="LPOMext"
        sensiname[3]="Minimum= "+str(round(minlpomext,2))+"   Maximum= "+str(round(maxlpomext,2))
        sensiname[4]="Sensitivity"
        lpomn,dum1,dum2,dum3=rmod2.vectornorm2(len(lpomvec),lpomvec)
        app4=raioop2.brggraph3(hf,sensiname,50,50,"red",3,lpomn,pactualstart,pactualend)
        app4.ausgabe()
    else:
        pass
       

    
   


def read1():
    global tpread1,em,es,et,ep
    tpread1=Tkinter.Toplevel(hf,width=60,height=10)
    fr=Tkinter.Frame(tpread1,relief="sunken",bd=4)
    fr.pack()
    laboverview=Tkinter.Label(fr,text="parameters of model 1\nthe 'merry-go-around-poset'")
    laboverview.pack()
    labem=Tkinter.Label(fr, text="x-Incomp:  m (>t) = ")
    labem.pack(side='left')
    em=Tkinter.Entry(fr,width=2)
    em.pack(side='left')
    labes=Tkinter.Label(fr,text="tail:   s = ")
    labes.pack(side='left')
    es=Tkinter.Entry(fr,width=2)
    es.pack(side='left')
    labet=Tkinter.Label(fr,text="no of conn.  t = ")
    labet.pack(side='left')
    et=Tkinter.Entry(fr,width=2)
    et.pack(side='left')
    labep=Tkinter.Label(fr,text="predec.  p = ")
    labep.pack(side='left')
    ep=Tkinter.Entry(fr,width=2)
    ep.pack(side='left')
    

def read2():
    global tpread2,em,et,ea,eb,epred
    tpread2=Tkinter.Toplevel(hf,width=60,height=10)
    fr2=Tkinter.Frame(tpread2,relief="sunken",bd=4)
    fr2.pack(pady=3)
    laboverview2=Tkinter.Label(fr2,text="parameters of model 2 \n 'flag-poset'")
    laboverview2.pack()
    labem=Tkinter.Label(fr2, text="m = ")
    labem.pack(side='left')
    em=Tkinter.Entry(fr2,width=2)
    em.pack(side='left')
    labet=Tkinter.Label(fr2,text="t (tail) = ")
    labet.pack(side='left')
    et=Tkinter.Entry(fr2,width=2)
    et.pack(side='left')
    labea=Tkinter.Label(fr2,text="a (above x) = ")
    labea.pack(side='left')
    ea=Tkinter.Entry(fr2,width=2)
    ea.pack(side='left')
    labeb=Tkinter.Label(fr2,text="b (below x) = ")
    labeb.pack(side='left')
    eb=Tkinter.Entry(fr2,width=2)
    eb.pack(side='left')
    labepred=Tkinter.Label(fr2,text="p (predec.> x & > U(x)) = ")
    labepred.pack(side='left')
    epred=Tkinter.Entry(fr2,width=2)
    epred.pack(side='left')


def read3():
    global tpread3,em,ea,eb,es,ep
    tpread3=Tkinter.Toplevel(hf,width=60,height=10)
    fr=Tkinter.Frame(tpread3,relief="sunken",bd=4)
    fr.pack()
    text3="parameters of model 3\nthe 'handle-poset' and \n 'multihandle poset' (m elements ||x, are connected)"
    laboverview=Tkinter.Label(fr,text=text3)
    laboverview.pack()
    labem=Tkinter.Label(fr, text="x-incomp.: m = ")
    labem.pack(side='left')
    em=Tkinter.Entry(fr,width=2)
    em.pack(side='left')

    labea=Tkinter.Label(fr,text="above x: a = ")
    labea.pack(side="left")
    ea=Tkinter.Entry(fr,width=2)
    ea.pack(side="left")

    labeb=Tkinter.Label(fr,text="below x: b = ")
    labeb.pack(side="left")
    eb=Tkinter.Entry(fr,width=2)
    eb.pack(side="left")

    labes=Tkinter.Label(fr,text="tail s = ")
    labes.pack(side='left')
    es=Tkinter.Entry(fr,width=2)
    es.pack(side='left')

    labep=Tkinter.Label(fr,text="predec. >x & >U(x) = ")
    labep.pack(side='left')
    ep=Tkinter.Entry(fr,width=2)
    ep.pack(side='left')
    

def read4():
    global tpread4,em,ea,eb,en
    tpread4=Tkinter.Toplevel(hf,width=60,height=10)
    fr=Tkinter.Frame(tpread4,relief="sunken",bd=4)
    fr.pack()
    laboverview=Tkinter.Label(fr,text="parameters of model 4\nthe 'generalized zig-zag-poset'")
    laboverview.pack()
    labem=Tkinter.Label(fr, text="x-incomp. below z: m = ")
    labem.pack(side='left')
    em=Tkinter.Entry(fr,width=2)
    em.pack(side='left')

    labea=Tkinter.Label(fr,text="above x: p = ")
    labea.pack(side="left")
    ea=Tkinter.Entry(fr,width=2)
    ea.pack(side="left")

    labeb=Tkinter.Label(fr,text="between b0 and x: b = ")
    labeb.pack(side="left")
    eb=Tkinter.Entry(fr,width=2)
    eb.pack(side="left")

    laben=Tkinter.Label(fr,text="tail n = ")
    laben.pack(side='left')
    en=Tkinter.Entry(fr,width=2)
    en.pack(side='left')

    
def read5():
    global tpread5,em,ea,eb,en, ec,ed
    tpread5=Tkinter.Toplevel(hf,width=60,height=10)
    fr=Tkinter.Frame(tpread5,relief="sunken",bd=4)
    fr.pack()
    laboverview=Tkinter.Label(fr,text="parameters of model 5\nthe 'generalized star-poset'")
    laboverview.pack()

    labem=Tkinter.Label(fr, text="x-incomp.:  m = ")
    labem.pack(side='left')
    em=Tkinter.Entry(fr,width=2)
    em.pack(side='left')

    labea=Tkinter.Label(fr,text="above x: a = ")
    labea.pack(side="left")
    ea=Tkinter.Entry(fr,width=2)
    ea.pack(side="left")

    labeb=Tkinter.Label(fr,text="between b0 and x: b = ")
    labeb.pack(side="left")
    eb=Tkinter.Entry(fr,width=2)
    eb.pack(side="left")

    laben=Tkinter.Label(fr,text="tail (below d0): e = ")
    laben.pack(side='left')
    en=Tkinter.Entry(fr,width=2)
    en.pack(side='left')

    labed=Tkinter.Label(fr,text="between b0 and d0: d = ")
    labed.pack(side="left")
    ed=Tkinter.Entry(fr,width=2)
    ed.pack(side="left")
    
    labec=Tkinter.Label(fr,text="below b0:  c = ")
    labec.pack(side="left")
    ec=Tkinter.Entry(fr,width=2)
    ec.pack(side="left")



def calc1():
     #  Brg  6.12.09
    try:
        m=int(em.get())
    except:
        m=3
    try:    
        s=int(es.get())
    except:
        s=0
    try:    
        t=int(et.get())
    except:
        t=1
    try:
        p=int(ep.get())
    except:
        p=0
    labconfirm=Tkinter.Label(tpread1,text=" parameters model 1 read in ",bg="yellow")
    labconfirm.pack()
    #model 1
    rkav,lpom,lpom0=calc1progr(p,s,t,m)
    # end of model 1
    labresult1=Tkinter.Label(tpread1,text="Rkav_exact = "+str(round(rkav,3)))
    labresult1a=Tkinter.Label(tpread1,text="Rkav_LPOM(ext) = "+str(round(lpom,3)))
    labresult1b=Tkinter.Label(tpread1,text="Rkav_LPOM0     = "+str(round(lpom0,3)))
    labresult1.pack()
    labresult1a.pack()
    labresult1b.pack()
    txt="Dependence on t, given m="+str(m)+"   p=  "+str(p)+"   s= "+str(s)+"\n"
    txt+=40*"="
    if m>2:
        for t in range(0,m+1):
            rkav=(s+1.0)*(m+1.0+(s+2.0)*(t+1.0))/(m+1.0+(t+1.0)*(s+1.0))
            txt+="\n"+"t = "+str(t)+"   Rkav_exact= "+str(round(rkav,3))
        
        ttdep=ScrolledText(tpread1,width=60,height=3*m)
        ttdep.pack()
        ttdep.insert("end",txt)

def sensi1():
    # brg 14.12.2011
    global emap,esap,etap,epap,epvar,eprangelow,eprangeupper,tpsensi1,esel
    tpsensi1=Tkinter.Toplevel(hf)
    tpsensi1.title(' model 1: merry go around ')
    freingabe1=Tkinter.Frame(tpsensi1,relief="sunken",bd=2)
    freingabe1.pack()
    lbemap=Tkinter.Label(freingabe1,text="m0?>> ")
    lbemap.grid(row=0,column=0)
    emap=Tkinter.Entry(freingabe1,width=3)
    emap.grid(row=0,column=1)
    lbesap=Tkinter.Label(freingabe1,text="s0?>> ")
    lbesap.grid(row=0,column=2)
    esap=Tkinter.Entry(freingabe1,width=3)
    esap.grid(row=0,column=3)
    lbetap=Tkinter.Label(freingabe1,text="t0?>> ")
    lbetap.grid(row=0,column=4)
    etap=Tkinter.Entry(freingabe1,width=3)
    etap.grid(row=0,column=5)
    lbepap=Tkinter.Label(freingabe1,text="p0?>> ")
    lbepap.grid(row=0,column=6)
    epap=Tkinter.Entry(freingabe1,width=3)
    epap.grid(row=0,column=7)
    lbvar1=Tkinter.Label(freingabe1,text="select parameter to be varied and its range")
    lbvar1.grid(row=1,columnspan=7)
    lbpvarim1=Tkinter.Label(freingabe1,text="Parameter (m,s,t or p) >>")
    lbpvarim1.grid(row=2,column=0)
    epvar=Tkinter.Entry(freingabe1,width=3)
    epvar.grid(row=2,column=1)
    lbprangelow=Tkinter.Label(freingabe1,text="start value >>")
    lbprangelow.grid(row=2,column=2)
    eprangelow=Tkinter.Entry(freingabe1,width=3)
    eprangelow.grid(row=2,column=3)
    lbprangeupper=Tkinter.Label(freingabe1,text="end value >>")
    lbprangeupper.grid(row=2,column=4)
    eprangeupper=Tkinter.Entry(freingabe1,width=3)
    eprangeupper.grid(row=2,column=5)
    butt1=Tkinter.Button(tpsensi1,text="submit ..",bg="cyan",command=submit1)
    butt1.pack()
    
def submit1():
    #brg 14.12.2011
    global pactual,pactualstart,pactualend,rkavvec,lpomvec,lpom0vec,deltaex,delta00,rkav,lpom,esel
    global minparameterex,maxparameterex
    m=int(emap.get())
    s=int(esap.get())
    t=int(etap.get())
    p=int(epap.get())
    try:
        pactual=epvar.get()
    except:
        print "pactual not defined"
    pactualstart=min(int(eprangelow.get()),int(eprangeupper.get()))
    pactualend=max(int(eprangelow.get()),int(eprangeupper.get()))
    print m,s,t,p,str(pactual),pactualstart,pactualend
    rkavvec=[]
    lpomvec=[]
    lpom0vec=[]
    deltaex=[]
    delta00=[]
    imvec=[]
    txt="Merry go-around, Sensitivity , only one parameter: "+str(pactual)+"\n"
    txt+="start: "+str(pactualstart)+"   end: "+str(pactualend)+"\n"
    txt+=60*"="+"\n"
    txt+="parameter"+"\texact"+"\tLPOMext"+"\tLPOM0"+"\texact-LPOMext"+"\texact-LPOM0"+"\n"
    if pactual=="m":
        imvec=[]
        for im in range(pactualstart,pactualend):
            if im<=t:
                im=t
                # model specific
                rkav,lpom,lpom0=calc1progr(p,s,t,im)
                # end of model1
                deltaext=rkav-lpom
                delta0=rkav-lpom0
                rkavvec.append(rkav)
                lpomvec.append(lpom)                  
                lpom0vec.append(lpom0)
                deltaex.append(rkav-lpom)
                delta00.append(rkav-lpom0)
                txt+=str(im)+"\t"+str(round(rkav,3))+"\t"+str(round(lpom,3))+"\t"+str(round(lpom0,3))\
                      +"\t"+str(round(deltaext,3))+"\t\t"+str(round(delta0,3))+"\n"
            else:
                # model specific
                imvec.append(im)
                rkav,lpom,lpom0=calc1progr(p,s,t,im)
                # end of model 1
                deltaext=rkav-lpom
                delta0=rkav-lpom0
                rkavvec.append(rkav)
                lpomvec.append(lpom)                  
                lpom0vec.append(lpom0)
                deltaex.append(rkav-lpom)
                delta00.append(rkav-lpom0)
                txt+=str(im)+"\t"+str(round(rkav,3))+"\t"+str(round(lpom,3))+"\t"+str(round(lpom0,3))\
                      +"\t"+str(round(deltaext,3))+"\t\t"+str(round(delta0,3))+"\n"

                
        txt+="  - - - e o f - - -"    


    elif pactual=="s":
        jsvec=[]
        for js in range(pactualstart,pactualend):
            # model 1 specific
            jsvec.append(js)
            rkav,lpom,lpom0=calc1progr(p,js,t,m)
            # end of model 1
            deltaext=rkav-lpom
            delta0=rkav-lpom0
            rkavvec.append(rkav)
            lpomvec.append(lpom)                  
            lpom0vec.append(lpom0)
            deltaex.append(rkav-lpom)
            delta00.append(rkav-lpom0)
            txt+=str(js)+"\t"+str(round(rkav,3))+"\t"+str(round(lpom,3))+"\t"+str(round(lpom0,3))\
                  +"\t"+str(round(deltaext,3))+"\t\t"+str(round(delta0,3))+"\n"           
            
        txt+="  - - - e o f - - -"    


    elif pactual=="t":
        itvec=[]
        for it in range(pactualstart,pactualend):
            # model specific
            if it<=m:
                itvec.append(it)
                rkav,lpom,lpom0=calc1progr(p,s,it,m)
                deltaext=rkav-lpom
                delta0=rkav-lpom0
                rkavvec.append(rkav)
                lpomvec.append(lpom)                  
                lpom0vec.append(lpom0)
                deltaex.append(rkav-lpom)
                delta00.append(rkav-lpom0)
                txt+=str(it)+"\t"+str(round(rkav,3))+"\t"+str(round(lpom,3))+"\t"+str(round(lpom0,3))\
                      +"\t"+str(round(deltaext,3))+"\t\t"+str(round(delta0,3))+"\n"
            else:
                it=m
                itvec.append(it)
                rkav,lpom,lpom0=calc1progr(p,s,it,m)
                deltaext=rkav-lpom
                delta0=rkav-lpom0
                rkavvec.append(rkav)
                lpomvec.append(lpom)                  
                lpom0vec.append(lpom0)
                deltaex.append(rkav-lpom)
                delta00.append(rkav-lpom0)
                txt+=str(it)+"\t"+str(round(rkav,3))+"\t"+str(round(lpom,3))+"\t"+str(round(lpom0,3))\
                      +"\t"+str(round(deltaext,3))+"\t\t"+str(round(delta0,3))+"\n"

    elif pactual=="p":
        ipvec=[]
        for ip in range(pactualstart,pactualend):
            # model specific
            
            ipvec.append(ip)
            rkav,lpom,lpom0=calc1progr(ip,s,t,m)
            # end of model 1
            deltaext=rkav-lpom
            delta0=rkav-lpom0
            rkavvec.append(rkav)
            lpomvec.append(lpom)                  
            lpom0vec.append(lpom0)
            deltaex.append(rkav-lpom)
            delta00.append(rkav-lpom0)
            txt+=str(ip)+"\t"+str(round(rkav,3))+"\t"+str(round(lpom,3))+"\t"+str(round(lpom0,3))\
                  +"\t"+str(round(deltaext,3))+"\t\t"+str(round(delta0,3))+"\n"
            
            
    txt+="  - - - e o f - - -"
##    print "lpomvec= ",lpomvec
##    print "rkav = ",rkavvec
    minparameterex=min(deltaex)
    maxparameterex=max(deltaex)
    minparameter00=min(delta00)
    maxparameter00=max(delta00)
   
    
    tpsensi1result=Tkinter.Toplevel(hf)
    tpsensi1result.title("Sensitivity concerning parameter "+str(pactual))
    tsensi1result=ScrolledText(tpsensi1result,width=120,height=5)
    tsensi1result.pack()
    tsensi1result.insert("end",txt)
    lbesel=Tkinter.Label(tpsensi1,text="1: rkav-lpomext; 2:rkav-lpom0;\
 3: rkav   4: lpomext;  5:all four linegraphics ")
    lbesel.pack()
    esel=Tkinter.Entry(tpsensi1,width=3)
    esel.pack()
    buttesel=Tkinter.Button(tpsensi1,text="submit graphics ",width=30,bg="cyan",command=grsubmit)
    buttesel.pack()
   
def calc2():
    # Brg 7.12.09
    try:
        m=int(em.get())
    except:
        m=3
    try:    
        t=int(et.get())
    except:
        t=1
    try:    
        a=int(ea.get())
    except:
        a=0
    try:
        b=int(eb.get())
    except:
        b=0
    try:
        p=int(epred-get())
    except:
        p=0
    labconfirm2=Tkinter.Label(tpread2,text="parameters model 2 read in ",bg="yellow")
    labconfirm2.pack()
    ##model 2
    rkav,lpom,lpom0=calc2progr(p,b,a,t,m)
    ## end of model 2
    labresult2=Tkinter.Label(tpread2,text="Rkav_exact = "+str(round(rkav,3)))
    labresult2a=Tkinter.Label(tpread2,text="Rkav_LPOM(ext) = "+str(round(lpom,3)))
    labresult2b=Tkinter.Label(tpread2,text="Rkav_LPOM0     = "+str(round(lpom0,3)))
    labresult2.pack()
    labresult2a.pack()
    labresult2b.pack()
    txt="Dependence on b, given m="+str(m)+"   t=  "+str(t)+"   a= "+str(a)+"\n"
    txt+=40*"="
   
    ttdep2=ScrolledText(tpread2,width=60,height=2*m)
    ttdep2.pack()
    for bi in range(0,10):
        rkav,lpom,lpom0=calcprogr2(p,bi,a,t,m)
        txt+="\n"+"b = "+str(bi)+"   Rkav_exact= "+str(round(rkav,3))
        
    ttdep2.insert("end",txt)

def sensi2():
    # brg 15.12.2011
    global emap,eaap,ebap,etap,epap,epvar,eprangelow,eprangeupper,tpsensi2
    tpsensi2=Tkinter.Toplevel(hf)
    tpsensi2.title(' generalized flag, model 2 ')
    freingabe2=Tkinter.Frame(tpsensi2,relief="sunken",bd=2)
    freingabe2.pack()
    lbemap=Tkinter.Label(freingabe2,text="m0?>> ")
    lbemap.grid(row=0,column=0)
    emap=Tkinter.Entry(freingabe2,width=3)
    emap.grid(row=0,column=1)
    lbeaap=Tkinter.Label(freingabe2,text="a0?>> ")
    lbeaap.grid(row=0,column=2)
    eaap=Tkinter.Entry(freingabe2,width=3)
    eaap.grid(row=0,column=3)
    lbetap=Tkinter.Label(freingabe2,text="t0?>> ")
    lbetap.grid(row=0,column=4)
    etap=Tkinter.Entry(freingabe2,width=3)
    etap.grid(row=0,column=5)
    lbepap=Tkinter.Label(freingabe2,text="p0?>> ")
    lbepap.grid(row=0,column=6)
    epap=Tkinter.Entry(freingabe2,width=3)
    epap.grid(row=0,column=7)
    lbebap=Tkinter.Label(freingabe2,text="b0?>> ")
    lbebap.grid(row=0,column=8)
    ebap=Tkinter.Entry(freingabe2,width=3)
    ebap.grid(row=0,column=9)
    
    lbvar1=Tkinter.Label(freingabe2,text="select parameter to be varied and its range")
    lbvar1.grid(row=1,columnspan=7)
    lbpvarim1=Tkinter.Label(freingabe2,text="Parameter (m,t,a,b or p) >>")
    lbpvarim1.grid(row=2,column=0)
    epvar=Tkinter.Entry(freingabe2,width=3)
    epvar.grid(row=2,column=1)
    lbprangelow=Tkinter.Label(freingabe2,text="start value >>")
    lbprangelow.grid(row=2,column=2)
    eprangelow=Tkinter.Entry(freingabe2,width=3)
    eprangelow.grid(row=2,column=3)
    lbprangeupper=Tkinter.Label(freingabe2,text="end value >>")
    lbprangeupper.grid(row=2,column=4)
    eprangeupper=Tkinter.Entry(freingabe2,width=3)
    eprangeupper.grid(row=2,column=5)
    butt2=Tkinter.Button(tpsensi2,text="submit ..",bg="cyan",command=submit2)
    butt2.pack()
    
def submit2():
    #brg 14.12.2011,15.12.2011
    global pactual,pactualstart,pactualend,rkavvec,lpomvec,lpom0vec,deltaex,delta00,rkav,lpom,esel
    global minparameterex,maxparameterex
    m=int(emap.get())
    a=int(eaap.get())
    t=int(etap.get())
    b=int(ebap.get())
    p=int(epap.get())
    try:
        pactual=epvar.get()
    except:
        print "pactual not defined"
    pactualstart=min(int(eprangelow.get()),int(eprangeupper.get()))
    pactualend=max(int(eprangelow.get()),int(eprangeupper.get()))
    print m,a,b,t,p,str(pactual),pactualstart,pactualend
    rkavvec=[]
    lpomvec=[]
    lpom0vec=[]
    deltaex=[]
    delta00=[]
    imvec=[]
    txt="Generalized flag, Sensitivity , only one parameter: "+str(pactual)+"\n"
    txt+="start: "+str(pactualstart)+"   end: "+str(pactualend)+"\n"
    txt+=60*"="+"\n"
    txt+="parameter"+"\texact"+"\tLPOMext"+"\tLPOM0"+"\texact-LPOMext"+"\texact-LPOM0"+"\n"
    if pactual=="m":
        imvec=[]
        for im in range(pactualstart,pactualend):
            #model 2
            rkav,lpom,lpom0=calc2progr(p,b,a,t,im)
            # end model2
            deltaext=rkav-lpom
            delta0=rkav-lpom0
            rkavvec.append(rkav)
            lpomvec.append(lpom)                  
            lpom0vec.append(lpom0)
            deltaex.append(rkav-lpom)
            delta00.append(rkav-lpom0)
            txt+=str(im)+"\t"+str(round(rkav,3))+"\t"+str(round(lpom,3))+"\t"+str(round(lpom0,3))\
                  +"\t"+str(round(deltaext,3))+"\t\t"+str(round(delta0,3))+"\n"
                            
        txt+="  - - - e o f - - -"    

    elif pactual=="a":
        javec=[]
        for ja in range(pactualstart,pactualend):
            # model specific
            javec.append(ja)
            #model 2
            rkav,lpom,lpom0=calc2progr(p,b,ja,t,m)
            # end of model 2
            deltaext=rkav-lpom
            delta0=rkav-lpom0
            rkavvec.append(rkav)
            lpomvec.append(lpom)                  
            lpom0vec.append(lpom0)
            deltaex.append(rkav-lpom)
            delta00.append(rkav-lpom0)
            txt+=str(ja)+"\t"+str(round(rkav,3))+"\t"+str(round(lpom,3))+"\t"+str(round(lpom0,3))\
                  +"\t"+str(round(deltaext,3))+"\t\t"+str(round(delta0,3))+"\n"           
            
        txt+="  - - - e o f - - -"    


    elif pactual=="t":
        itvec=[]
        for it in range(pactualstart,pactualend):
            #model 2
            rkav,lpom,lpom0=calc2progr(p,b,a,it,m)
            # end of model 2
            deltaext=rkav-lpom
            delta0=rkav-lpom0
            rkavvec.append(rkav)
            lpomvec.append(lpom)                  
            lpom0vec.append(lpom0)
            deltaex.append(rkav-lpom)
            delta00.append(rkav-lpom0)
            txt+=str(it)+"\t"+str(round(rkav,3))+"\t"+str(round(lpom,3))+"\t"+str(round(lpom0,3))\
                  +"\t"+str(round(deltaext,3))+"\t\t"+str(round(delta0,3))+"\n"
        txt+="- - - e o f - -"    

    elif pactual=="p":
        ipvec=[]
        for ip in range(pactualstart,pactualend):
            # model specific
            
            ipvec.append(ip)
            #model 2
            rkav,lpom,lpom0=calc2progr(ip,b,a,t,m)
            #end of model 2
            deltaext=rkav-lpom
            delta0=rkav-lpom0
            rkavvec.append(rkav)
            lpomvec.append(lpom)                  
            lpom0vec.append(lpom0)
            deltaex.append(rkav-lpom)
            delta00.append(rkav-lpom0)
            txt+=str(ip)+"\t"+str(round(rkav,3))+"\t"+str(round(lpom,3))+"\t"+str(round(lpom0,3))\
                  +"\t"+str(round(deltaext,3))+"\t\t"+str(round(delta0,3))+"\n"
        txt+="- - - e o f - -"
    

    elif pactual=="b":
        ibvec=[]
        for ib in range(pactualstart,pactualend):
            # model 2 specific
            
            ibvec.append(ib)
            rkav,lpom,lpom0=calc2progr(p,ib,a,t,m)
            # end of model 2
            deltaext=rkav-lpom
            delta0=rkav-lpom0
            rkavvec.append(rkav)
            lpomvec.append(lpom)                  
            lpom0vec.append(lpom0)
            deltaex.append(rkav-lpom)
            delta00.append(rkav-lpom0)
            txt+=str(ib)+"\t"+str(round(rkav,3))+"\t"+str(round(lpom,3))+"\t"+str(round(lpom0,3))\
                  +"\t"+str(round(deltaext,3))+"\t\t"+str(round(delta0,3))+"\n"

        txt+="  - - - e o f - - -"

   
    minparameterex=min(deltaex)
    maxparameterex=max(deltaex)
    minparameter00=min(delta00)
    maxparameter00=max(delta00)
    tpsensi2result=Tkinter.Toplevel(hf)
    tpsensi2result.title("Sensitivity concerning parameter "+str(pactual))
    tsensi2result=ScrolledText(tpsensi2result,width=120,height=5)
    tsensi2result.pack()
    tsensi2result.insert("end",txt)
    lbesel=Tkinter.Label(tpsensi2,text="1: rkav-lpomext; 2:rkav-lpom0;\
 3: rkav   4: lpomext;  5:all four linegraphics ")
    lbesel.pack()
    esel=Tkinter.Entry(tpsensi2,width=3)
    esel.pack()
    buttesel=Tkinter.Button(tpsensi2,text="submit graphics ",width=30,bg="cyan",command=grsubmit)
    buttesel.pack()
    
#####################################################end of sensi2 ###################



def calc3():
     #  Brg  6.12.09
    try:
        m=int(em.get())
    except:
        m=3
    try:    
        a=int(ea.get())
    except:
        a=0
    try:    
        b=int(eb.get())
    except:
        b=0
    try:
        s=int(es.get())
    except:
        s=1
    try:
        p=int(ep.get())
    except:
        p=1

        
    labconfirm3=Tkinter.Label(tpread3,text=" parameters model 3 read in ",bg="yellow")
    labconfirm3.pack()
    ### model 3
    rkav,lpom,lpom0=calc3progr(p,b,a,s,m)
    ### end model 3
    
    labresult3=Tkinter.Label(tpread3,text="Rkav_exact = "+str(round(rkav,3)))
    labresult3a=Tkinter.Label(tpread3,text="Rkav_LPOM(ext) = "+str(round(lpom,3)))
    labresult3b=Tkinter.Label(tpread3,text="Rkav_LPOM0     = "+str(round(lpom0,3)))
    labresult3.pack()
    labresult3a.pack()
    labresult3b.pack()
    txt="Dependence on b, given m= "+str(m)+"   p=  "+str(p)+"   s= "+str(s)+"   a= "+str(a)+"\n"
    txt+=40*"="
    if m>0:
        for b in range(0,10):
            rkav=s+b+2+((1.0*b+1.0)*m/(1.0*b+1.0*a+2.0))
            txt+="\n"+"b = "+str(b)+"   Rkav_exact= "+str(round(rkav,3))
        
        ttdep=ScrolledText(tpread3,width=60,height=3*m)
        ttdep.pack()
        ttdep.insert("end",txt)

def sensi3():
    # brg 16.12.2011
    global emap,eaap,ebap,esap,epap,epvar,eprangelow,eprangeupper,tpsensi3
    tpsensi3=Tkinter.Toplevel(hf)
    tpsensi3.title(' generalized handle, model 3 ')
    freingabe3=Tkinter.Frame(tpsensi3,relief="sunken",bd=2)
    freingabe3.pack()
    lbemap=Tkinter.Label(freingabe3,text="m0?>> ")
    lbemap.grid(row=0,column=0)
    emap=Tkinter.Entry(freingabe3,width=3)
    emap.grid(row=0,column=1)
    lbeaap=Tkinter.Label(freingabe3,text="a0?>> ")
    lbeaap.grid(row=0,column=2)
    eaap=Tkinter.Entry(freingabe3,width=3)
    eaap.grid(row=0,column=3)
    lbesap=Tkinter.Label(freingabe3,text="s0?>> ")
    lbesap.grid(row=0,column=4)
    esap=Tkinter.Entry(freingabe3,width=3)
    esap.grid(row=0,column=5)
    lbepap=Tkinter.Label(freingabe3,text="p0?>> ")
    lbepap.grid(row=0,column=6)
    epap=Tkinter.Entry(freingabe3,width=3)
    epap.grid(row=0,column=7)
    lbebap=Tkinter.Label(freingabe3,text="b0?>> ")
    lbebap.grid(row=0,column=8)
    ebap=Tkinter.Entry(freingabe3,width=3)
    ebap.grid(row=0,column=9)
    
    lbvar1=Tkinter.Label(freingabe3,text="select parameter to be varied and its range")
    lbvar1.grid(row=1,columnspan=7)
    lbpvarim1=Tkinter.Label(freingabe3,text="Parameter (m,s,a,b or p) >>")
    lbpvarim1.grid(row=2,column=0)
    epvar=Tkinter.Entry(freingabe3,width=3)
    epvar.grid(row=2,column=1)
    lbprangelow=Tkinter.Label(freingabe3,text="start value >>")
    lbprangelow.grid(row=2,column=2)
    eprangelow=Tkinter.Entry(freingabe3,width=3)
    eprangelow.grid(row=2,column=3)
    lbprangeupper=Tkinter.Label(freingabe3,text="end value >>")
    lbprangeupper.grid(row=2,column=4)
    eprangeupper=Tkinter.Entry(freingabe3,width=3)
    eprangeupper.grid(row=2,column=5)
    butt3=Tkinter.Button(tpsensi3,text="submit ..",bg="cyan",command=submit3)
    butt3.pack()
    
def submit3():
    #brg 14.12.2011,15.12.2011
    global pactual,pactualstart,pactualend,rkavvec,lpomvec,lpom0vec,deltaex,delta00,rkav,lpom,esel
    global minparameterex,maxparameterex,minparameter00,maxparameter00
    m=int(emap.get())
    a=int(eaap.get())
    s=int(esap.get())
    b=int(ebap.get())
    p=int(epap.get())
    try:
        pactual=epvar.get()
    except:
        print "pactual not defined"
    pactualstart=min(int(eprangelow.get()),int(eprangeupper.get()))
    pactualend=max(int(eprangelow.get()),int(eprangeupper.get()))
    print m,a,b,s,p,str(pactual),pactualstart,pactualend
    rkavvec=[]
    lpomvec=[]
    lpom0vec=[]
    deltaex=[]
    delta00=[]
    imvec=[]
    txt="Generalized handle, Sensitivity , only one parameter: "+str(pactual)+"\n"
    txt+="start: "+str(pactualstart)+"   end: "+str(pactualend)+"\n"
    txt+=60*"="+"\n"
    txt+="parameter"+"\texact"+"\tLPOMext"+"\tLPOM0"+"\texact-LPOMext"+"\texact-LPOM0"+"\n"
    if pactual=="m":
        imvec=[]
        for im in range(pactualstart,pactualend):
            #model 3
            rkav,lpom,lpom0=calc3progr(p,b,a,s,im)
            #end of model3
            deltaext=rkav-lpom
            delta0=rkav-lpom0
            rkavvec.append(rkav)
            lpomvec.append(lpom)                  
            lpom0vec.append(lpom0)
            deltaex.append(rkav-lpom)
            delta00.append(rkav-lpom0)
            txt+=str(im)+"\t"+str(round(rkav,3))+"\t"+str(round(lpom,3))+"\t"+str(round(lpom0,3))\
                  +"\t"+str(round(deltaext,3))+"\t\t"+str(round(delta0,3))+"\n"
                            
        txt+="  - - - e o f - - -"    

    elif pactual=="a":
        javec=[]
        for ja in range(pactualstart,pactualend):
            # model specific
            javec.append(ja)
            #model 3
            rkav,lpom,lpom0=calc3progr(p,b,ja,s,m)
            #end of model 3
            deltaext=rkav-lpom
            delta0=rkav-lpom0
            rkavvec.append(rkav)
            lpomvec.append(lpom)                  
            lpom0vec.append(lpom0)
            deltaex.append(rkav-lpom)
            delta00.append(rkav-lpom0)
            txt+=str(ja)+"\t"+str(round(rkav,3))+"\t"+str(round(lpom,3))+"\t"+str(round(lpom0,3))\
                  +"\t"+str(round(deltaext,3))+"\t\t"+str(round(delta0,3))+"\n"           
            
        txt+="  - - - e o f - - -"    


    elif pactual=="s":
        jsvec=[]
        for js in range(pactualstart,pactualend):
            #model 3
            jsvec.append(js)#
            rkav,lpom,lpom0=calc3progr(p,b,a,js,m)
            #end of model 3        
            deltaext=rkav-lpom
            delta0=rkav-lpom0
            rkavvec.append(rkav)
            lpomvec.append(lpom)                  
            lpom0vec.append(lpom0)
            deltaex.append(rkav-lpom)
            delta00.append(rkav-lpom0)
            txt+=str(js)+"\t"+str(round(rkav,3))+"\t"+str(round(lpom,3))+"\t"+str(round(lpom0,3))\
                  +"\t"+str(round(deltaext,3))+"\t\t"+str(round(delta0,3))+"\n"
        txt+="- - - e o f - -"    

    elif pactual=="p":
        ipvec=[]
        for ip in range(pactualstart,pactualend):
            # model 3
            ipvec.append(ip)
            rkav,lpom,lpom0=rcalc3progr(ip,b,a,s,m)
            #end of model 3
            deltaext=rkav-lpom
            delta0=rkav-lpom0
            rkavvec.append(rkav)
            lpomvec.append(lpom)                  
            lpom0vec.append(lpom0)
            deltaex.append(rkav-lpom)
            delta00.append(rkav-lpom0)
            txt+=str(ip)+"\t"+str(round(rkav,3))+"\t"+str(round(lpom,3))+"\t"+str(round(lpom0,3))\
                  +"\t"+str(round(deltaext,3))+"\t\t"+str(round(delta0,3))+"\n"
        txt+="- - - e o f - -"
    

    elif pactual=="b":
        ibvec=[]
        for ib in range(pactualstart,pactualend):
            # model 3
            ibvec.append(ib)
            rkav,lpom,lpom0=calc3progr(p,ib,a,s,m)
            #end of model 3
            deltaext=rkav-lpom
            delta0=rkav-lpom0
            rkavvec.append(rkav)
            lpomvec.append(lpom)                  
            lpom0vec.append(lpom0)
            deltaex.append(rkav-lpom)
            delta00.append(rkav-lpom0)
            txt+=str(ib)+"\t"+str(round(rkav,3))+"\t"+str(round(lpom,3))+"\t"+str(round(lpom0,3))\
                  +"\t"+str(round(deltaext,3))+"\t\t"+str(round(delta0,3))+"\n"

        txt+="  - - - e o f - - -"

    minparameterex=min(deltaex)
    maxparameterex=max(deltaex)
    minparameter00=min(delta00)
    maxparameter00=max(delta00)
    
    tpsensi3result=Tkinter.Toplevel(hf)
    tpsensi3result.title("Sensitivity concerning parameter "+str(pactual))
    tsensi3result=ScrolledText(tpsensi3result,width=120,height=5)
    tsensi3result.pack()
    tsensi3result.insert("end",txt)
    lbesel=Tkinter.Label(tpsensi3,text="1: rkav-lpomext; 2:rkav-lpom0;\
 3: rkav   4: lpomext;  5:all four linegraphics ")
    lbesel.pack()
    esel=Tkinter.Entry(tpsensi3,width=3)
    esel.pack()
    buttesel=Tkinter.Button(tpsensi3,text="submit graphics ",width=30,bg="cyan",command=grsubmit)
    buttesel.pack()
    
           
#####################################################end of sensi3 ###################







def calc4():
     #  Brg  16.12.09
    try:
        m=int(em.get())
    except:
        m=1
    try:    
        p=int(ea.get())
    except:
        p=1
    try:    
        b=int(eb.get())
    except:
        b=0
    try:
        n=int(en.get())
    except:
        n=0
    

        
    labconfirm4=Tkinter.Label(tpread4,text=" parameters model 4 read in ",bg="yellow")
    labconfirm4.pack()
    # LT
    rkav,lpom,lpom0=calc4progr(p,b,n,m)
    
    ######## model 4 end ###### model 4 end########################## model4
    labresult4=Tkinter.Label(tpread4,text="Rkav = "+str(round(rkav,3)))
    labresult4a=Tkinter.Label(tpread4,text="Rkav_LPOM(ext) = "+str(round(lpom,3)))
    labresult4b=Tkinter.Label(tpread4,text="Rkav_LPOM0     = "+str(round(lpom0,3)))
    labresult4.pack()
    labresult4a.pack()
    labresult4b.pack()
    txt="Dependence on b, given m= "+str(m)+"   n= "+str(n)+"   p= "+str(p)+"\n"
    txt+=40*"="
    if m>0:
        for b in range(0,10):
            # LT
            LT1=0
            for j in range(0,b+1):
                LT1+=rmod2.nueberk(j+n+m+1,m)

            LT2=0
            for j in range(0,m+1):
                for i in range(0,p+1):
                    LT2+=rmod2.nueberk(i+m-j,m-j)*rmod2.nueberk(j+n+b+1,j)

            LT=LT1+LT2

            #zbelowx
            zbx=0
            for j in range(0,b+1):
                zbx+=rmod2.nueberk(j+n+m+1,m)*(n+3.0+m+b)


            #zabovex
            zax=0
            for j in range(0,m+1):
                for i in range(0,p+1):
                    zax+=rmod2.nueberk(i+m-j,m-j)*rmod2.nueberk(j+n+b+1,j)*(j+b+n+2)
            Rkav=(1.0*zbx+1.0*zax)/(1.0*LT)

            
            txt+="\n"+"b = "+str(b)+"   Rkav_exact= "+str(round(Rkav,3))
        
        ttdep=ScrolledText(tpread4,width=60,height=2*m)
        ttdep.pack()
        ttdep.insert("end",txt)

########calc4###########################calc4################################

def sensi4():
    # brg 16.12.2011,20.12.2011
    global emap,enap,ebap,epap,epvar,eprangelow,eprangeupper,tpsensi4
    tpsensi4=Tkinter.Toplevel(hf)
    tpsensi4.title(' generalized zig-zag, model 4 ')
    freingabe4=Tkinter.Frame(tpsensi4,relief="sunken",bd=2)
    freingabe4.pack()
    lbemap=Tkinter.Label(freingabe4,text="m0?>> ")
    lbemap.grid(row=0,column=0)
    emap=Tkinter.Entry(freingabe4,width=3)
    emap.grid(row=0,column=1)
    lbenap=Tkinter.Label(freingabe4,text="n0?>> ")
    lbenap.grid(row=0,column=2)
    enap=Tkinter.Entry(freingabe4,width=3)
    enap.grid(row=0,column=3)
    lbepap=Tkinter.Label(freingabe4,text="p0?>> ")
    lbepap.grid(row=0,column=4)
    epap=Tkinter.Entry(freingabe4,width=3)
    epap.grid(row=0,column=5)
    lbebap=Tkinter.Label(freingabe4,text="b0?>> ")
    lbebap.grid(row=0,column=6)
    ebap=Tkinter.Entry(freingabe4,width=3)
    ebap.grid(row=0,column=7)
    
    lbvar1=Tkinter.Label(freingabe4,text="select parameter to be varied and its range")
    lbvar1.grid(row=1,columnspan=7)
    lbpvarim1=Tkinter.Label(freingabe4,text="Parameter (m,n,b or p) >>")
    lbpvarim1.grid(row=2,column=0)
    epvar=Tkinter.Entry(freingabe4,width=3)
    epvar.grid(row=2,column=1)
    lbprangelow=Tkinter.Label(freingabe4,text="start value >>")
    lbprangelow.grid(row=2,column=2)
    eprangelow=Tkinter.Entry(freingabe4,width=3)
    eprangelow.grid(row=2,column=3)
    lbprangeupper=Tkinter.Label(freingabe4,text="end value >>")
    lbprangeupper.grid(row=2,column=4)
    eprangeupper=Tkinter.Entry(freingabe4,width=3)
    eprangeupper.grid(row=2,column=5)
    butt4=Tkinter.Button(tpsensi4,text="submit ..",bg="cyan",command=submit4)
    butt4.pack()
    
def submit4():
    #brg 14.12.2011,15.12.2011
    global pactual,pactualstart,pactualend,rkavvec,lpomvec,lpom0vec,deltaex,delta00,rkav,lpom,esel
    global minparameterex,maxparameterex,minparameter00,maxparameter00
    m=int(emap.get())
    n=int(enap.get())  #tail in SxP
    b=int(ebap.get())
    p=int(epap.get())
    try:
        pactual=epvar.get()
    except:
        print "pactual not defined"
    pactualstart=min(int(eprangelow.get()),int(eprangeupper.get()))
    pactualend=max(int(eprangelow.get()),int(eprangeupper.get()))
    print m,b,n,p,str(pactual),pactualstart,pactualend
    rkavvec=[]
    lpomvec=[]
    lpom0vec=[]
    deltaex=[]
    delta00=[]
    imvec=[]
    txt="Generalized zig-zag, Sensitivity , only one parameter: "+str(pactual)+"\n"
    txt+="start: "+str(pactualstart)+"   end: "+str(pactualend)+"\n"
    txt+=60*"="+"\n"
    txt+="parameter"+"\texact"+"\tLPOMext"+"\tLPOM0"+"\texact-LPOMext"+"\texact-LPOM0"+"\n"
    if pactual=="m":
        imvec=[]
        for im in range(pactualstart,pactualend):
            #model 4
            imvec.append(im)
            rkav,lpom,lpom0=calc4progr(p,b,n,im)
            #end of model4
            deltaext=rkav-lpom
            delta0=rkav-lpom0
            rkavvec.append(rkav)
            lpomvec.append(lpom)                  
            lpom0vec.append(lpom0)
            deltaex.append(rkav-lpom)
            delta00.append(rkav-lpom0)
            txt+=str(im)+"\t"+str(round(rkav,3))+"\t"+str(round(lpom,3))+"\t"+str(round(lpom0,3))\
                  +"\t"+str(round(deltaext,3))+"\t\t"+str(round(delta0,3))+"\n"
                            
        txt+="  - - - e o f - - -"    

   
    elif pactual=="n":
        jnvec=[]
        for jn in range(pactualstart,pactualend):
            #model 4
            jnvec.append(jn)
            rkav,lpom,lpom0=calc4progr(p,b,jn,m)
            
            #end of model 4        
            deltaext=rkav-lpom
            delta0=rkav-lpom0
            rkavvec.append(rkav)
            lpomvec.append(lpom)                  
            lpom0vec.append(lpom0)
            deltaex.append(rkav-lpom)
            delta00.append(rkav-lpom0)
            txt+=str(jn)+"\t"+str(round(rkav,3))+"\t"+str(round(lpom,3))+"\t"+str(round(lpom0,3))\
                  +"\t"+str(round(deltaext,3))+"\t\t"+str(round(delta0,3))+"\n"
        txt+="- - - e o f - -"    

    elif pactual=="p":
        ipvec=[]
        for ip in range(pactualstart,pactualend):
            # model 4
            ipvec.append(ip)
            rkav,lpom,lpom0=calc4progr(ip,b,n,m)

            #end of model 4
            deltaext=rkav-lpom
            delta0=rkav-lpom0
            rkavvec.append(rkav)
            lpomvec.append(lpom)                  
            lpom0vec.append(lpom0)
            deltaex.append(rkav-lpom)
            delta00.append(rkav-lpom0)
            txt+=str(ip)+"\t"+str(round(rkav,3))+"\t"+str(round(lpom,3))+"\t"+str(round(lpom0,3))\
                  +"\t"+str(round(deltaext,3))+"\t\t"+str(round(delta0,3))+"\n"
        txt+="- - - e o f - -"
    

    elif pactual=="b":
        ibvec=[]
        for ib in range(pactualstart,pactualend):
            # model 4
            ibvec.append(ib)
            rkav,lpom,lpom0=calc4progr(p,ib,n,m)

            #end of model 4
            deltaext=rkav-lpom
            delta0=rkav-lpom0
            rkavvec.append(rkav)
            lpomvec.append(lpom)                  
            lpom0vec.append(lpom0)
            deltaex.append(rkav-lpom)
            delta00.append(rkav-lpom0)
            txt+=str(ib)+"\t"+str(round(rkav,3))+"\t"+str(round(lpom,3))+"\t"+str(round(lpom0,3))\
                  +"\t"+str(round(deltaext,3))+"\t\t"+str(round(delta0,3))+"\n"

        txt+="  - - - e o f - - -"

    minparameterex=min(deltaex)
    maxparameterex=max(deltaex)
    minparameter00=min(delta00)
    maxparameter00=max(delta00)
    
    tpsensi4result=Tkinter.Toplevel(hf)
    tpsensi4result.title("Sensitivity concerning parameter "+str(pactual))
    tsensi4result=ScrolledText(tpsensi4result,width=120,height=5)
    tsensi4result.pack()
    tsensi4result.insert("end",txt)
    lbesel=Tkinter.Label(tpsensi4,text="1: rkav-lpomext; 2:rkav-lpom0;\
 3: rkav   4: lpomext;  5:all four linegraphics ")
    lbesel.pack()
    esel=Tkinter.Entry(tpsensi4,width=3)
    esel.pack()
    buttesel=Tkinter.Button(tpsensi4,text="submit graphics ",width=30,bg="cyan",command=grsubmit)
    buttesel.pack()
   
    
#####################################################end of sensi4 ###################
        




def calc5():
     #  Brg  28.12.09
    try:
        m=int(em.get())
    except:
        m=1
    try:    
        a=int(ea.get())
    except:
        a=1
    try:    
        b=int(eb.get())
    except:
        b=0
    try:
        e=int(en.get())
    except:
        e=0
    try:
        d=int(ed.get())
    except:
        d=1
    try:
        c=int(ec.get())
    except:
        c=2

        
    labconfirm5=Tkinter.Label(tpread5,text=" parameters model 5 read in ",bg="yellow")
    labconfirm5.pack()

    #calculation
    rkav,lpom,lpom0=calc5progr(m,a,b,e,d,c)
    
    labresult5=Tkinter.Label(tpread5,text="Rkav = "+str(round(rkav,3)))
    labresult5a=Tkinter.Label(tpread5,text="Rkav_LPOM(ext) = "+str(round(lpom,3))+"   LT = "+str(LT))
    labresult5b=Tkinter.Label(tpread5,text="Rkav_LPOM0     = "+str(round(lpom0,3)))
    labresult5.pack()
    labresult5a.pack()
    labresult5b.pack()
    txt="Dependence on b, given m= "+str(m)+"   e= "+str(e)+"   a= "+str(a)+"  d = "+str(d)+"   c= "+str(c)+"\n"
    txt+=40*"="
    if m>0:
        for b in range(0,10):
            # LT
            rkav,lpom,lpom0=calc5progr(m,a,b,e,d,c)                        
            txt+="\n"+"b = "+str(b)+"   Rkav_exact= "+str(round(rkav,3))+"   LT = "+str(LT)
        
        ttdep=ScrolledText(tpread5,width=60,height=2*m)
        ttdep.pack()
        ttdep.insert("end",txt)

#################calc5###########################calc5##########################
def sensi5():
    #brg 17.12.2011
    
    global emap,ecap,ebap,eaap,edap,eeap,epvar,eprangelow,eprangeupper,tpsensi5
    tpsensi5=Tkinter.Toplevel(hf)
    tpsensi5.title(' generalized star, model 5 ')
    freingabe5=Tkinter.Frame(tpsensi5,relief="sunken",bd=2)
    freingabe5.pack()

    lbemap=Tkinter.Label(freingabe5,text="m0?>> ")
    lbemap.grid(row=0,column=0)
    emap=Tkinter.Entry(freingabe5,width=3)
    emap.grid(row=0,column=1)

    lbecap=Tkinter.Label(freingabe5,text="c0?>> ")
    lbecap.grid(row=0,column=2)
    ecap=Tkinter.Entry(freingabe5,width=3)
    ecap.grid(row=0,column=3)

    lbeeap=Tkinter.Label(freingabe5,text="e0?>> ")
    lbeeap.grid(row=0,column=4)
    eeap=Tkinter.Entry(freingabe5,width=3)
    eeap.grid(row=0,column=5)

    lbebap=Tkinter.Label(freingabe5,text="b0?>> ")
    lbebap.grid(row=0,column=6)
    ebap=Tkinter.Entry(freingabe5,width=3)
    ebap.grid(row=0,column=7)

    lbeaap=Tkinter.Label(freingabe5,text="a0?>> ")
    lbeaap.grid(row=0,column=8)
    eaap=Tkinter.Entry(freingabe5,width=3)
    eaap.grid(row=0,column=9)

    lbedap=Tkinter.Label(freingabe5,text="d0?>> ")
    lbedap.grid(row=0,column=10)
    edap=Tkinter.Entry(freingabe5,width=3)
    edap.grid(row=0,column=11)
    
    
    lbvar1=Tkinter.Label(freingabe5,text="select parameter to be varied and its range")
    lbvar1.grid(row=1,columnspan=7)
    lbpvarim1=Tkinter.Label(freingabe5,text="Parameter (m,c,e,b,a,d) >>")
    lbpvarim1.grid(row=2,column=0)
    epvar=Tkinter.Entry(freingabe5,width=3)
    epvar.grid(row=2,column=1)
    lbprangelow=Tkinter.Label(freingabe5,text="start value >>")
    lbprangelow.grid(row=2,column=2)
    eprangelow=Tkinter.Entry(freingabe5,width=3)
    eprangelow.grid(row=2,column=3)
    lbprangeupper=Tkinter.Label(freingabe5,text="end value >>")
    lbprangeupper.grid(row=2,column=4)
    eprangeupper=Tkinter.Entry(freingabe5,width=3)
    eprangeupper.grid(row=2,column=5)
    butt5=Tkinter.Button(tpsensi5,text="submit ..",bg="cyan",command=submit5)
    butt5.pack()
    
def submit5():
    #brg 14.12.2011,15.12.2011,17.12.2011
    global pactual,pactualstart,pactualend,rkavvec,lpomvec,lpom0vec,deltaex,delta00,rkav,lpom,esel
    global minparameterex,maxparameterex,minparameter00,maxparameter00
    m=int(emap.get())
    c=int(ecap.get())  #
    e=int(eeap.get())
    b=int(ebap.get())
    a=int(eaap.get())
    d=int(edap.get())
    try:
        pactual=epvar.get()
    except:
        print "pactual not defined"
    pactualstart=min(int(eprangelow.get()),int(eprangeupper.get()))
    pactualend=max(int(eprangelow.get()),int(eprangeupper.get()))
    print m,c,e,b,a,d,str(pactual),pactualstart,pactualend
    rkavvec=[]
    lpomvec=[]
    lpom0vec=[]
    deltaex=[]
    delta00=[]
    imvec=[]
    txt="Generalized star, Sensitivity , only one parameter: "+str(pactual)+"\n"
    txt+="start: "+str(pactualstart)+"   end: "+str(pactualend)+"\n"
    txt+=60*"="+"\n"
    txt+="parameter"+"\texact"+"\tLPOMext"+"\tLPOM0"+"\texact-LPOMext"+"\texact-LPOM0"+"\n"
    if pactual=="m":
        imvec=[]
        for im in range(pactualstart,pactualend):
            imvec.append(im)
            #model 5
            rkav,lpom,lpom0=calc5progr(im,a,b,e,d,c)
            #end of model5
            deltaext=rkav-lpom
            delta0=rkav-lpom0
            rkavvec.append(rkav)
            lpomvec.append(lpom)                  
            lpom0vec.append(lpom0)
            deltaex.append(rkav-lpom)
            delta00.append(rkav-lpom0)
            txt+=str(im)+"\t"+str(round(rkav,3))+"\t"+str(round(lpom,3))+"\t"+str(round(lpom0,3))\
                  +"\t"+str(round(deltaext,3))+"\t\t"+str(round(delta0,3))+"\n"
                            
        txt+="  - - - e o f - - -"    

   
    elif pactual=="d":
        jdvec=[]
        for jd in range(pactualstart,pactualend):
            jdvec.append(jd)
            #model 5
            rkav,lpom,lpom0=calc5progr(m,a,b,e,jd,c)
            
            #end of model 5
            deltaext=rkav-lpom
            delta0=rkav-lpom0
            rkavvec.append(rkav)
            lpomvec.append(lpom)                  
            lpom0vec.append(lpom0)
            deltaex.append(rkav-lpom)
            delta00.append(rkav-lpom0)
            txt+=str(jd)+"\t"+str(round(rkav,3))+"\t"+str(round(lpom,3))+"\t"+str(round(lpom0,3))\
                  +"\t"+str(round(deltaext,3))+"\t\t"+str(round(delta0,3))+"\n"
        txt+="- - - e o f - -"    

    elif pactual=="a":
        iavec=[]
        for ia in range(pactualstart,pactualend):
            iavec.append(ia)
            #model 5
            rkav,lpom,lpom0=calc5progr(m,ia,b,e,d,c)

            #end of model 5
            deltaext=rkav-lpom
            delta0=rkav-lpom0
            rkavvec.append(rkav)
            lpomvec.append(lpom)                  
            lpom0vec.append(lpom0)
            deltaex.append(rkav-lpom)
            delta00.append(rkav-lpom0)
            txt+=str(ia)+"\t"+str(round(rkav,3))+"\t"+str(round(lpom,3))+"\t"+str(round(lpom0,3))\
                  +"\t"+str(round(deltaext,3))+"\t\t"+str(round(delta0,3))+"\n"
        txt+="- - - e o f - -"
    

    elif pactual=="b":
        ibvec=[]
        for ib in range(pactualstart,pactualend):
            ibvec.append(ib)
            #model 5
            rkav,lpom,lpom0=calc5progr(m,a,ib,e,d,c)
            #end of model 5
            deltaext=rkav-lpom
            delta0=rkav-lpom0
            rkavvec.append(rkav)
            lpomvec.append(lpom)                  
            lpom0vec.append(lpom0)
            deltaex.append(rkav-lpom)
            delta00.append(rkav-lpom0)
            txt+=str(ib)+"\t"+str(round(rkav,3))+"\t"+str(round(lpom,3))+"\t"+str(round(lpom0,3))\
                  +"\t"+str(round(deltaext,3))+"\t\t"+str(round(delta0,3))+"\n"

        txt+="  - - - e o f - - -"

    elif pactual=="e":
        ievec=[]
        for ie in range(pactualstart,pactualend):
            ievec.append(ie)
            #model 5
            rkav,lpom,lpom0=calc5progr(m,a,b,ie,d,c)
            #end of model 5
            deltaext=rkav-lpom
            delta0=rkav-lpom0
            rkavvec.append(rkav)
            lpomvec.append(lpom)                  
            lpom0vec.append(lpom0)
            deltaex.append(rkav-lpom)
            delta00.append(rkav-lpom0)
            txt+=str(ie)+"\t"+str(round(rkav,3))+"\t"+str(round(lpom,3))+"\t"+str(round(lpom0,3))\
                  +"\t"+str(round(deltaext,3))+"\t\t"+str(round(delta0,3))+"\n"

        txt+="  - - - e o f - - -"

    elif pactual=="c":
        icvec=[]
        for ic in range(pactualstart,pactualend):
            icvec.append(ic)
            #model 5
            rkav,lpom,lpom0=calc5progr(m,a,b,e,d,ic)
            #end of model 5
            deltaext=rkav-lpom
            delta0=rkav-lpom0
            rkavvec.append(rkav)
            lpomvec.append(lpom)                  
            lpom0vec.append(lpom0)
            deltaex.append(rkav-lpom)
            delta00.append(rkav-lpom0)
            txt+=str(ic)+"\t"+str(round(rkav,3))+"\t"+str(round(lpom,3))+"\t"+str(round(lpom0,3))\
                  +"\t"+str(round(deltaext,3))+"\t\t"+str(round(delta0,3))+"\n"

        txt+="  - - - e o f - - -"


    minparameterex=min(deltaex)
    maxparameterex=max(deltaex)
    minparameter00=min(delta00)
    maxparameter00=max(delta00)
    
    tpsensi5result=Tkinter.Toplevel(hf)
    tpsensi5result.title("Sensitivity concerning parameter "+str(pactual))
    tsensi5result=ScrolledText(tpsensi5result,width=120,height=5)
    tsensi5result.pack()
    tsensi5result.insert("end",txt)
    lbesel=Tkinter.Label(tpsensi5,text="1: rkav-lpomext; 2:rkav-lpom0;\
 3: rkav   4: lpomext;  5:all four linegraphics ")
    lbesel.pack()
    esel=Tkinter.Entry(tpsensi5,width=3)
    esel.pack()
    buttesel=Tkinter.Button(tpsensi5,text="submit graphics ",width=30,bg="cyan",command=grsubmit)
    buttesel.pack()
    #####################################################end of sensi5 ###################
        




def draw1():
    try:
        m=int(em.get())
    except:
        m=3
    try:    
        s=int(es.get())
    except:
        s=0
    try:    
        t=int(et.get())
    except:
        t=1
    try:
        p=int(ep.get())
    except:
        p=0
    
    
    rkav=(s+1.0)*(m+1.0+(s+2.0)*(t+1.0))/(m+1.0+(t+1.0)*(s+1.0))
    geomx=rmod2.vecgen1(m)
    geomy=rmod2.vecgen1(s+p+3)
    for j in range(0,m):
        geomx[j]=50+(400.0/m)*j
    for i in range(0,s+p+3):    
        geomy[i]=20+i*(400.0/(p+3.0+s))
    print geomx
    print geomy
    tphd=Tkinter.Toplevel(hf)        
    cv=Tkinter.Canvas(tphd,width=500,height=500,bg="white")
    cv.pack()
    gxhl=int(0.5*m+0.6)
    print "gxhl --> arg of geomx ",gxhl
    xhl=geomx[gxhl]
    
    hline=cv.create_line(xhl,geomy[0],xhl,geomy[p+2+s])
    for j in range(0,m):
        mline1=cv.create_line(geomx[j],geomy[p+1],xhl,geomy[p])
    for j in range(0,m):
        mline2=cv.create_line(geomx[j], geomy[p+1],xhl,geomy[p+2])
    for j in range(0,t):
        yline=cv.create_line(geomx[0],geomy[p+2],geomx[j],geomy[p+1])                         

    for j in range(0,m):
        cir=cv.create_oval(geomx[j]+5,geomy[p+1]-5,geomx[j]-5,geomy[p+1]+5,fill="orange")

    ciry=cv.create_oval(geomx[0]+5,geomy[p+2]-5,geomx[0]-5,geomy[p+2]+5,fill="cyan")
   
    for i in range(0,p+1):
        cirabove=cv.create_oval(xhl+5,geomy[i]-5,xhl-5,geomy[i]+5,fill="orange")
    for i in range(p+3,p+3+s):
        cirbelow=cv.create_oval(xhl+5,geomy[i]-5,xhl-5,geomy[i]+5,fill="orange")

    cirx=cv.create_oval(geomx[int(0.5*m+0.6)]-7,geomy[p+2]+7,geomx[int(0.5*m+0.6)]+7,geomy[p+2]-7,fill="red")
    result=cv.create_text(160,455,text="Rkav= "+str(round(rkav,2)),font=("Arial",14,"bold"))
    posettxt=cv.create_text(135,475,text="m= "+str(m)+"  s= "+str(s)+"  t= "+str(t)+"  p= "+str(p))
    posettxt2=cv.create_text(160,490,text="generaliz. merry go-round-poset ")
    

def draw2():
    
    try:
        m=int(em.get())
    except:
        m=3
    try:    
        t=int(et.get())
    except:
        t=1
    try:    
        a=int(ea.get())
    except:
        a=0
    try:
        b=int(eb.get())
    except:
        b=0
    try:
        p=int(epred.get())
    except:
        p=0

    g=t+3+b
    h=t+1+b
    summ1=0
    summ2=0
    print "m = ",m,"   t= ",t,"  a=  ",a,"  b= ",b, "    p= ",p
    for j in range(0,m+1):
        for k in range(0,t+1):
            f1=rmod2.nueberk(h+j-k,j)
            f2=rmod2.nueberk(m-j+a,a)
            summ1+=f1*j*f2
            summ2+=f1*f2
    rkav=g+1.0*summ1/(1.0*summ2)   
    labresult2=Tkinter.Label(tpread2,text="Rkav = "+str(round(rkav,3)))
    labresult2.pack()
    gg=t+p+a+b+3
    geomy=rmod2.vecgen1(gg+1)
    geomy2=rmod2.vecgen1(m+2)
    delta1 = 400.0/(gg)
    for i in range(1,gg+1):
        geomy[i]=20+delta1*i

    #print geomy[1]
    tphd2=Tkinter.Toplevel(hf)
    tphd2.title(' model 2 ')
    cv=Tkinter.Canvas(tphd2,width=500, height=500,bg="white")
    cv.pack()
    hline=cv.create_line(200,geomy[1],200,geomy[gg])
    nline=cv.create_line(300,geomy[p+2],300,geomy[gg])
    line1=cv.create_line(200,geomy[p+1],300,geomy[p+2])
    line2=cv.create_line(200,geomy[p+1+a+b+2],300,geomy[gg])                     
    ln=geomy[gg]-geomy[p+2]
    delta2=1.0*ln/(1.0*m+1.0)
    for i in range(0,m+2):
        geomy2[i]=geomy[p+2]+delta2*i
        
    for i in range(1,gg+1):
        cirh=cv.create_oval(200-5,geomy[i]+5,200+5,geomy[i]-5,fill="orange")
    for i in range(0,m):
        cirn=cv.create_oval(300-5,geomy2[i]+5,300+5,geomy2[i]-5,fill="cyan")
    ciru=cv.create_oval(300-5,geomy2[m]+delta2+5,300+5,geomy2[m]+delta2-5,fill="orange")
    cirx=cv.create_oval(200-7,geomy[p+a+2]+7,200+7,geomy[p+a+2]-7,fill="red")
    result=cv.create_text(160,455,text="Rkav= "+str(round(rkav,2)),font=("Arial",14,"bold"))
    posettxt=cv.create_text(135,475,text="m= "+str(m)+"  t= "+str(t)+"  a= "+str(a)+"  b= "+str(b)+"  p= "+str(p))
    posettxt2=cv.create_text(160,490,text="generaliz. flag-poset ")


def draw3():
    #print geomy[1]
    try:
        m=int(em.get())
    except:
        m=3
    try:    
        a=int(ea.get())
    except:
        a=0
    try:    
        b=int(eb.get())
    except:
        b=0
    try:
        s=int(es.get())
    except:
        s=1
    try:
        p=int(ep.get())
    except:
        p=1


    rkav=s+b+2+((1.0*b+1.0)*m/(1.0*b+1.0*a+2.0))
    tphd3=Tkinter.Toplevel(hf)
    tphd3.title(' model 3 ')
    cv=Tkinter.Canvas(tphd3,width=500, height=500,bg="white")
    cv.pack()
    g=s+1+b+1+a+1+p
    delta1=400.0/g
    geomy=rmod2.vecgen1(g)
    geomy2=rmod2.vecgen1(m)
    for i in range(0,g):
        geomy[i]=20+delta1*i
        
    hline=cv.create_line(200,geomy[0],200,geomy[g-1])
    
    line1=cv.create_line(200,geomy[p],300,geomy[p+1])
                         
    ln=geomy[2+a+b+p]-geomy[p+1]
    delta2=1.0*ln/(1.0*m)
    for i in range(0,m):
        geomy2[i]=geomy[p+1]+delta2*i
    nline=cv.create_line(300,geomy2[0],300,geomy2[m-1])
    line2=cv.create_line(200,geomy[p+1+a+1+b],300,geomy2[m-1])    
    for i in range(0,g):
        cir=cv.create_oval(200-5,geomy[i]+5,200+5,geomy[i]-5,fill="orange")
    for i in range(0,m):
        cirm=cv.create_oval(300-5,geomy2[i]+5,300+5,geomy2[i]-5,fill="cyan")
    cix=cv.create_oval(200-7,geomy[p+a+1]+7,200+7,geomy[p+a+1]-7,fill="red")
    
    result=cv.create_text(160,455,text="Rkav= "+str(round(rkav,2)),font=("Arial",14,"bold"))
    posettxt=cv.create_text(135,475,text="m= "+str(m)+"  s= "+str(s)+"  a= "+str(a)+"  b= "+str(b)+"  p= "+str(p))
    posettxt2=cv.create_text(160,490,text="generaliz. handle-poset ")


def draw4():
     #  Brg  16.12.09
    try:
        m=int(em.get())
    except:
        m=1
    try:    
        p=int(ea.get())
    except:
        p=1
    try:    
        b=int(eb.get())
    except:
        b=0
    try:
        n=int(en.get())
    except:
        n=0
    
      
    labconfirm4=Tkinter.Label(tpread4,text=" parameters model 4 read in ",bg="yellow")
    labconfirm4.pack()
    # LT
    LT1=0
    for j in range(0,b+1):
        LT1+=rmod2.nueberk(j+n+m+1,m)

    LT2=0
    for j in range(0,m+1):
        for i in range(0,p+1):
            LT2+=rmod2.nueberk(i+m-j,m-j)*rmod2.nueberk(j+n+b+1,j)

    LT=LT1+LT2

    #zbelowx
    zbx=0
    for j in range(0,b+1):
        zbx+=rmod2.nueberk(j+n+m+1,m)*(n+3.0+m+b)


    #zabovex
    zax=0
    for j in range(0,m+1):
        for i in range(0,p+1):
            zax+=rmod2.nueberk(i+m-j,m-j)*rmod2.nueberk(j+n+b+1,j)*(j+b+n+2)
    Rkav=(1.0*zbx+1.0*zax)/(1.0*LT)

    tphd4=Tkinter.Toplevel(hf)
    tphd4.title(' model 4 ')
    cv=Tkinter.Canvas(tphd4,width=500, height=600,bg="white")
    cv.pack()
    nm=max(n,m)
    g=nm+1+b+p+1
    delta1=400.0/g
    geomy=rmod2.vecgen1(g)
    geomy2=rmod2.vecgen1(m)
    for i in range(0,g):
        geomy[i]=20+delta1*i
        
    hline=cv.create_line(200,geomy[0],200,geomy[p+b+n+1])
    nline=cv.create_line(300,geomy[p+b],300,geomy[p+b+m])
    line=cv.create_line(200,geomy[p+b+1],300,geomy[p+b])
        
    for i in range(0,p+b+2+n):
        cir=cv.create_oval(200-5,geomy[i]+5,200+5,geomy[i]-5,fill="orange")
    for i in range(0,m+1):
        cirm=cv.create_oval(300-5,geomy[p+b+i]+5,300+5,geomy[p+b+i]-5,fill="cyan")
    cix=cv.create_oval(200-7,geomy[p]+7,200+7,geomy[p]-7,fill="red")
    result=cv.create_text(160,455,text="Rkav= "+str(round(Rkav,2)),font=("Arial",14,"bold"))
    posettxt=cv.create_text(135,475,text="m= "+str(m)+"  n= "+str(n)+"  p= "+str(p)+"  b= "+str(b))
    posettxt1=cv.create_text(135,490,text="z is the top of the x-incomparables")
    posettxt2=cv.create_text(160,510,text="generaliz. zig-zag-poset ")
    

def draw5():
     #  Brg  28.12.09
    try:
        m=int(em.get())
    except:
        m=1
    try:    
        a=int(ea.get())
    except:
        a=1
    try:    
        b=int(eb.get())
    except:
        b=0
    try:
        e=int(en.get())
    except:
        e=0
    try:
        d=int(ed.get())
    except:
        d=1
    try:
        c=int(ec.get())
    except:
        c=2

    tpread5=Tkinter.Toplevel(hf,width=60,height=10)
    tpread5.title('generalized star-poset')
    labconfirm5=Tkinter.Label(tpread5,text=" parameters model 5 read in ",bg="yellow")
    labconfirm5.pack()

    #calculation
    summ1=0
    summ2=0
    for i in range(0,m+1):
        for j in range(0,c+1):
            f0=1.0*rmod2.nueberk(j+d,d)
            f1=1.0*rmod2.nueberk(j+d+b+1+i,i)
                
            f2=1.0*rmod2.nueberk(c-j+e,e)
            
            f4=c+3.0+b+d+i+e
            f5=1.0*rmod2.nueberk(m-i+a,a)
            
            summ1+=f0*f1*f2*f4*f5
            summ2+=f0*f1*f2*f5

    rkav=1.0*summ1/(1.0*summ2)
    LT = summ2


    lch1=max(a+1+b+1+d,m)
    lch2=max(d+1+e,c)
   
    cv=Tkinter.Canvas(tpread5,width=600,height=500,bg="white")
    cv.pack()
    line1=cv.create_line(300,20,300,80)
    text1=cv.create_text(310,50,text="a-elements")
    circlex=cv.create_oval(300-7,88+7,300+7,88-7,outline="red")
    text2=cv.create_text(300,88,text="x")
    line2=cv.create_line(300,95,300,152)
    textb=cv.create_text(310,125,text="b-elements")
    textb0=cv.create_text(300,160,text="b0")
    line3=cv.create_line(300,165,200,210)
    line4=cv.create_line(200,210,200,270)
    textc=cv.create_text(200,240,text="c-elements")
    line5=cv.create_line(300,165,400,210)
    line6=cv.create_line(400,210,400,270)
    textd=cv.create_text(410,240,text="d-elements")
    textd0=cv.create_text(400,280,text="d0")
    line7=cv.create_line(400,290,400,350)
    texte=cv.create_text(410,320,text="e-elements")
    line8=cv.create_line(405,275,500,225)
    line9=cv.create_line(500,225,500,165)
    textu=cv.create_text(510,195,text="u-elements (m) ")
    textp=cv.create_text(300,400,text="parameters: m = "+str(m)+\
                         "  a = "+str(a)+"  b = "+str(b)+\
                         "  c = "+str(c)+"  d = "+str(d)+\
                         "  e = "+str(e))
    textresults=cv.create_text(330,450,text="Rkav_exact = "+str(round(rkav,2)), font=("Arial",14,"bold"))
                               




def mcsim1():
    #parameters s,t,p,m
    MC=4000
    delta12=rmod2.vecgen1(MC)
    delta13=rmod2.vecgen1(MC)
    delta23=rmod2.vecgen1(MC)
    for mc in range(0,MC):
        s=random.randint(0,10)
        m=random.randint(3,10)
        t=random.randint(1,m)
        p=random.randint(0,10)
        rkav=(s+1.0)*(m+1.0+(s+2.0)*(t+1.0))/(m+1.0+(t+1.0)*(s+1.0))
        lpom=s+1+(s+1.0)/(m-t+1.0+(s+1))
        lpom0=(s+1.0)*(1.0+(1.0/(s+t+p+2.0)))
        #delta12 = rkav-lpom, delta13=rkav-lpom0,delta23=lpom-lpom0
        #print "i = ",i
        delta12[mc]=rkav-lpom
        delta13[mc]=rkav-lpom0
        delta23[mc]=lpom-lpom0
    var12=pstat.lvar(delta12)
    var13=pstat.lvar(delta13)
    var23=pstat.lvar(delta23)
    med12=pstat.lmedian(delta12,MC)
    med13=pstat.lmedian(delta13,MC)
    med23=pstat.lmedian(delta23,MC)
    mean12=pstat.lmean(delta12)
    mean13=pstat.lmean(delta13)
    mean23=pstat.lmean(delta23)
    min12=min(delta12)
    max12=max(delta12)
    min13=min(delta13)
    max13=max(delta13)
    min23=min(delta23)
    max23=max(delta23)
    x0=100
    xe=400
    ax12=(1.0*xe-1.0*x0)/(1.0*max12-min12)
    bx12=x0-ax12*min12
    ax13=(1.0*xe-1.0*x0)/(1.0*max13-min13)
    bx13=x0-ax13*min13
    ax23=(1.0*xe-1.0*x0)/(1.0*max23-min23)
    bx23=1.0*x0-1.0*ax23*min23
    tpMC1=Tkinter.Toplevel(hf,width=500,height=500)
    tpMC1.title(' MC-Simul. Merry Go-around poset ')
    tMC1=ScrolledText(tpMC1,width=60,height=7)
    tMC1.pack()
    txt="MC-Simulation results, merry-go-around-posets\n"
    txt+=60*"="+"\n"
    txt+="\t"+"Rkavexact-LPOMext\t\tRkavexact-LPOM0\n"
    txt+="min:\t\t"+str(round(min12,4))+"\t\t"+str(round(min13,4))+"\n"
    txt+="max:\t\t"+str(round(max12,4))+"\t\t"+str(round(max12,4))+"\n"
    txt+="var:\t\t"+str(round(var12,4))+"\t\t"+str(round(var13,4))+"\n"
    txt+="mean:\t\t"+str(round(mean12,4))+"\t\t"+str(round(mean13,4))+"(black line)\n"
    txt+="median:\t\t"+str(round(med12,4))+"\t\t"+str(round(med13,4))+"(blue line)\n"
    tMC1.insert("end",txt)
    
    cvMC=Tkinter.Canvas(tpMC1,width=500,height=500,bg="white")
    cvMC.pack()
    
    line1=cvMC.create_line(x0,480,xe,480,width=4,fill="red")
    line2=cvMC.create_line(ax12*mean12+bx12,480,ax12*mean12+bx12,380,fill="black")
    line3=cvMC.create_line(ax12*med12+bx12,480,ax12*med12+bx12,380,fill="blue")
    text12min=cvMC.create_text(x0,490,text="min "+str(round(min12,3)))
    text12max=cvMC.create_text(xe,490,text="max "+str(round(max12,3)))
    text12mean=cvMC.create_text(ax12*mean12+bx12,490,text="mean "+str(round(mean12,3)))
    text12expla=cvMC.create_text(450,430,text="exact-LPOMext")
    line1=cvMC.create_line(x0,350,xe,350,width=4,fill="red")
    line2=cvMC.create_line(ax13*mean13+bx13,350,ax13*mean13+bx13,250,fill="black")
    line3=cvMC.create_line(ax13*med13+bx13,350,ax13*med13+bx13,250,fill="blue")
    text13min=cvMC.create_text(x0,360,text="min "+str(round(min13,3)))
    text13max=cvMC.create_text(xe,360,text="max "+str(round(max13,3)))
    text13mean=cvMC.create_text(ax13*mean13+bx13,360,text="mean "+str(round(mean13,3)))
    text13expla=cvMC.create_text(450,300,text="exact-LPOM0")
    line1=cvMC.create_line(x0,200,xe,200,width=4,fill="red")
    line2=cvMC.create_line(ax23*mean23+bx23,200,ax23*mean23+bx23,100,fill="black")
    line3=cvMC.create_line(ax23*med23+bx23,200,ax23*med23+bx23,100,fill="blue")
    text23min=cvMC.create_text(x0,210,text="min "+str(round(min23,4)))
    text23max=cvMC.create_text(xe,210,text="max "+str(round(max23,4)))
    text23mean=cvMC.create_text(ax23*mean23+bx23,210,text="mean "+str(round(mean23,3)))
    text23expla=cvMC.create_text(450,150,text="LPOMext-LPOM0")
    textgen1=cvMC.create_text(250,20,text="Merry-go-around-poset",font=("Arial",14,"bold"))
    
    

def mcsim2():
    #parameters flag-poset b,a,t,p,m
    MC=5000
    delta12=rmod2.vecgen1(MC)
    delta13=rmod2.vecgen1(MC)
    delta23=rmod2.vecgen1(MC)
    for mc in range(0,MC):
        b=random.randint(0,10)
        m=random.randint(1,10)
        a=random.randint(0,10)
        t=random.randint(0,10)  #tail
        p=random.randint(0,10)
        g=t+3+b
        h=t+1+b
        summ1=0
        summ2=0

        for j in range(0,m+1):
            for k in range(0,t+1):
                f1=rmod2.nueberk(h+j-k,j)
                f2=rmod2.nueberk(m-j+a,a)
                summ1+=f1*j*f2
                summ2+=f1*f2
        rkav=g+1.0*summ1/(1.0*summ2)
        lpom=(t+b+3.0)+m*(b+t+2.0)/(b+a+t+3.0)                  
        lpom0=(b+3.0+t)*(t+b+a+p+m+5.0)/(t+5.0+b+p+a)
        
        #delta12 = rkav-lpom, delta13=rkav-lpom0,delta23=lpom-lpom0
        #print "i = ",i
        delta12[mc]=rkav-lpom
        delta13[mc]=rkav-lpom0
        delta23[mc]=lpom-lpom0
    var12=pstat.lvar(delta12)
    var13=pstat.lvar(delta13)
    var23=pstat.lvar(delta23)
    med12=pstat.lmedian(delta12,MC)
    med13=pstat.lmedian(delta13,MC)
    med23=pstat.lmedian(delta23,MC)
    mean12=pstat.lmean(delta12)
    mean13=pstat.lmean(delta13)
    mean23=pstat.lmean(delta23)
    min12=min(delta12)
    max12=max(delta12)
    min13=min(delta13)
    max13=max(delta13)
    min23=min(delta23)
    max23=max(delta23)
    x0=100
    xe=400
    ax12=(1.0*xe-1.0*x0)/(1.0*max12-min12)
    bx12=x0-ax12*min12
    ax13=(1.0*xe-1.0*x0)/(1.0*max13-min13)
    bx13=x0-ax13*min13
    ax23=(1.0*xe-1.0*x0)/(1.0*max23-min23)
    bx23=1.0*x0-1.0*ax23*min23
    tpMC2=Tkinter.Toplevel(hf,width=500,height=500)
    tpMC2.title(' MC-Simul. flag-poset ')
    tMC2=ScrolledText(tpMC2,width=60,height=7)
    tMC2.pack()
    txt="MC-Simulation results, flag-posets\n"
    txt+=60*"="+"\n"
    txt+="\t"+"Rkavexact-LPOMext\t\tRkavexact-LPOM0\n"
    txt+="min:\t\t"+str(round(min12,4))+"\t\t"+str(round(min13,4))+"\n"
    txt+="max:\t\t"+str(round(max12,4))+"\t\t"+str(round(max13,4))+"\n"
    txt+="var:\t\t"+str(round(var12,4))+"\t\t"+str(round(var13,4))+"\n"
    txt+="mean:\t\t"+str(round(mean12,4))+"\t\t"+str(round(mean13,4))+"(black line)\n"
    txt+="median:\t\t"+str(round(med12,4))+"\t\t"+str(round(med13,4))+"(blue line)\n"
    tMC2.insert("end",txt)
    cvMC=Tkinter.Canvas(tpMC2,width=500,height=500,bg="white")
    cvMC.pack()
    
    line1=cvMC.create_line(x0,480,xe,480,width=4,fill="red")
    line2=cvMC.create_line(ax12*mean12+bx12,480,ax12*mean12+bx12,380,fill="black")
    line3=cvMC.create_line(ax12*med12+bx12,480,ax12*med12+bx12,380,fill="blue")
    text12min=cvMC.create_text(x0,490,text="min "+str(round(min12,3)))
    text12max=cvMC.create_text(xe,490,text="max "+str(round(max12,3)))
    text12mean=cvMC.create_text(ax12*mean12+bx12,490,text="mean "+str(round(mean12,3)))
    text12expla=cvMC.create_text(450,430,text="exact-LPOMext")
    line1=cvMC.create_line(x0,350,xe,350,width=4,fill="red")
    line2=cvMC.create_line(ax13*mean13+bx13,350,ax13*mean13+bx13,250,fill="black")
    line3=cvMC.create_line(ax13*med13+bx13,350,ax13*med13+bx13,250,fill="blue")
    text13min=cvMC.create_text(x0,360,text="min "+str(round(min13,3)))
    text13max=cvMC.create_text(xe,360,text="max "+str(round(max13,3)))
    text13mean=cvMC.create_text(ax13*mean13+bx13,360,text="mean "+str(round(mean13,3)))
    text13expla=cvMC.create_text(450,300,text="exact-LPOM0")
    line1=cvMC.create_line(x0,200,xe,200,width=4,fill="red")
    line2=cvMC.create_line(ax23*mean23+bx23,200,ax23*mean23+bx23,100,fill="black")
    line3=cvMC.create_line(ax23*med23+bx23,200,ax23*med23+bx23,100,fill="blue")
    text23min=cvMC.create_text(x0,210,text="min "+str(round(min23,4)))
    text23max=cvMC.create_text(xe,210,text="max "+str(round(max23,4)))
    text23mean=cvMC.create_text(ax23*mean23+bx23,210,text="mean "+str(round(mean23,3)))
    text23expla=cvMC.create_text(450,150,text="LPOMext-LPOM0")
    textgen2=cvMC.create_text(250,20,text="Generalized Flag-poset",font=("Arial",14,"bold"))

def mcsim3():
    MC=5000
    delta12=rmod2.vecgen1(MC)
    delta13=rmod2.vecgen1(MC)
    delta23=rmod2.vecgen1(MC)
    for mc in range(0,MC):
        b=random.randint(0,10)
        m=random.randint(1,10)
        a=random.randint(0,10)
        s=random.randint(0,10)  #tail
        p=random.randint(0,10)
        rkav=s+b+2+((1.0*b+1.0)*m/(1.0*b+1.0*a+2.0))
        lpom=rkav
        lpom0=(s+b+2.0)*(s+b+a+p+m+4.0)/(s+b+a+p+4.0)
        
        #delta12 = rkav-lpom, delta13=rkav-lpom0,delta23=lpom-lpom0
        #print "i = ",i
        delta12[mc]=rkav-lpom
        delta13[mc]=rkav-lpom0
        delta23[mc]=lpom-lpom0
    
    var13=pstat.lvar(delta13)
    var23=pstat.lvar(delta23)
    
    med13=pstat.lmedian(delta13,MC)
    med23=pstat.lmedian(delta23,MC)
    
    mean13=pstat.lmean(delta13)
    mean23=pstat.lmean(delta23)
    min12=min(delta12)
    max12=max(delta12)
    min13=min(delta13)
    max13=max(delta13)
    min23=min(delta23)
    max23=max(delta23)
    x0=100
    xe=400
    
    ax13=(1.0*xe-1.0*x0)/(1.0*max13-min13)
    bx13=x0-ax13*min13
    ax23=(1.0*xe-1.0*x0)/(1.0*max23-min23)
    bx23=1.0*x0-1.0*ax23*min23
    tpMC3=Tkinter.Toplevel(hf,width=500,height=500)
    tpMC3.title(' MC-Simul. handle-poset ')
    tMC3=ScrolledText(tpMC3,width=60,height=4)
    tMC3.pack()
    txt="MC-Simulation results, Generalized Handle-posets\n"
    txt+=60*"="+"\n"
    txt+="\t"+"Rkavexact-LPOMext\t\tRkavexact-LPOM0\n"
    txt+="min:\t\t"+str(round(min12,4))+"\t\t"+str(round(min13,4))+"\n"
    txt+="max:\t\t"+str(round(max12,4))+"\t\t"+str(round(max12,4))+"\n"
    
    tMC3.insert("end",txt)
    cvMC=Tkinter.Canvas(tpMC3,width=500,height=500,bg="white")
    cvMC.pack()
    
    line1=cvMC.create_line(x0,350,xe,350,width=4,fill="red")
    line2=cvMC.create_line(ax13*mean13+bx13,350,ax13*mean13+bx13,250,fill="black")
    line3=cvMC.create_line(ax13*med13+bx13,350,ax13*med13+bx13,250,fill="blue")
    text13min=cvMC.create_text(x0,360,text="min "+str(round(min13,3)))
    text13max=cvMC.create_text(xe,360,text="max "+str(round(max13,3)))
    text13mean=cvMC.create_text(ax13*mean13+bx13,360,text="mean "+str(round(mean13,3)))
    text13expla=cvMC.create_text(450,300,text="exact-LPOM0")
    text13expla=cvMC.create_text(250,480,text="exact-LPOMext = 0 (theoretically)",font=("Arial",12,"italic"))
    line1=cvMC.create_line(x0,200,xe,200,width=4,fill="red")
    line2=cvMC.create_line(ax23*mean23+bx23,200,ax23*mean23+bx23,100,fill="black")
    line3=cvMC.create_line(ax23*med23+bx23,200,ax23*med23+bx23,100,fill="blue")
    text23min=cvMC.create_text(x0,210,text="min "+str(round(min23,4)))
    text23max=cvMC.create_text(xe,210,text="max "+str(round(max23,4)))
    text23mean=cvMC.create_text(ax23*mean23+bx23,210,text="mean "+str(round(mean23,3)))
    text23expla=cvMC.create_text(450,150,text="LPOMext-LPOM0")
    textgen2=cvMC.create_text(250,20,text="Generalized Handle-poset",font=("Arial",14,"bold"))

def mcsim4():
    #parameters s,t,p,m
    MC=4000
    delta12=rmod2.vecgen1(MC)
    delta13=rmod2.vecgen1(MC)
    delta23=rmod2.vecgen1(MC)
    for mc in range(0,MC):
        n=random.randint(0,10)
        m=random.randint(1,10)
        b=random.randint(0,10)
        p=random.randint(0,10)
        # LT
        LT1=0
        for j in range(0,b+1):
            LT1+=rmod2.nueberk(j+n+m+1,m)

        LT2=0
        for j in range(0,m+1):
            for i in range(0,p+1):
                LT2+=rmod2.nueberk(i+m-j,m-j)*rmod2.nueberk(j+n+b+1,j)

        LT=LT1+LT2

        #zbelowx
        zbx=0
        for j in range(0,b+1):
            zbx+=rmod2.nueberk(j+n+m+1,m)*(n+3.0+m+b)


        #zabovex
        zax=0
        for j in range(0,m+1):
            for i in range(0,p+1):
                zax+=rmod2.nueberk(i+m-j,m-j)*rmod2.nueberk(j+n+b+1,j)*(j+b+n+2)

        rkav=(1.0*zbx+1.0*zax)/(1.0*LT)
        lpom=n+b+2+(b+1.0)/(b+p+2.0)+((n+b+2.0)/(n+b+p+3.0))*m
        lpom0=(b+2.0+n)*(n+b+p+m+4.0)/(n+3.0+b+p)

        
        #delta12 = rkav-lpom, delta13=rkav-lpom0,delta23=lpom-lpom0
        #print "i = ",i
        delta12[mc]=rkav-lpom
        delta13[mc]=rkav-lpom0
        delta23[mc]=lpom-lpom0

    var12=pstat.lvar(delta12)
    var13=pstat.lvar(delta13)
    var23=pstat.lvar(delta23)
    med12=pstat.lmedian(delta12,MC)
    med13=pstat.lmedian(delta13,MC)
    med23=pstat.lmedian(delta23,MC)
    mean12=pstat.lmean(delta12)
    mean13=pstat.lmean(delta13)
    mean23=pstat.lmean(delta23)
    min12=min(delta12)
    max12=max(delta12)
    min13=min(delta13)
    max13=max(delta13)
    min23=min(delta23)
    max23=max(delta23)
    x0=100
    xe=400
    ax12=(1.0*xe-1.0*x0)/(1.0*max12-min12)
    bx12=x0-ax12*min12
    ax13=(1.0*xe-1.0*x0)/(1.0*max13-min13)
    bx13=x0-ax13*min13
    ax23=(1.0*xe-1.0*x0)/(1.0*max23-min23)
    bx23=1.0*x0-1.0*ax23*min23
    tpMC4=Tkinter.Toplevel(hf,width=500,height=500)
    tpMC4.title(' MC-Simul. Generaliz. Zig-zag poset ')
    tMC4=ScrolledText(tpMC4,width=60,height=7)
    tMC4.pack()
    txt="MC-Simulation results, Generalized Zig-zag-posets\n"
    txt+=60*"="+"\n"
    txt+="\t"+"Rkavexact-LPOMext\t\tRkavexact-LPOM0\n"
    txt+="min:\t\t"+str(round(min12,4))+"\t\t"+str(round(min13,4))+"\n"
    txt+="max:\t\t"+str(round(max12,4))+"\t\t"+str(round(max12,4))+"\n"
    txt+="var:\t\t"+str(round(var12,4))+"\t\t"+str(round(var13,4))+"\n"
    txt+="mean:\t\t"+str(round(mean12,4))+"\t\t"+str(round(mean13,4))+"(black line)\n"
    txt+="median:\t\t"+str(round(med12,4))+"\t\t"+str(round(med13,4))+"(blue line)\n"
    tMC4.insert("end",txt)
    cvMC=Tkinter.Canvas(tpMC4,width=500,height=500,bg="white")
    cvMC.pack()
    
    line1=cvMC.create_line(x0,480,xe,480,width=4,fill="red")
    line2=cvMC.create_line(ax12*mean12+bx12,480,ax12*mean12+bx12,380,fill="black")
    line3=cvMC.create_line(ax12*med12+bx12,480,ax12*med12+bx12,380,fill="blue")
    text12min=cvMC.create_text(x0,490,text="min "+str(round(min12,3)))
    text12max=cvMC.create_text(xe,490,text="max "+str(round(max12,3)))
    text12mean=cvMC.create_text(ax12*mean12+bx12,490,text="mean "+str(round(mean12,3)))
    text12expla=cvMC.create_text(450,430,text="exact-LPOMext")
    line1=cvMC.create_line(x0,350,xe,350,width=4,fill="red")
    line2=cvMC.create_line(ax13*mean13+bx13,350,ax13*mean13+bx13,250,fill="black")
    line3=cvMC.create_line(ax13*med13+bx13,350,ax13*med13+bx13,250,fill="blue")
    text13min=cvMC.create_text(x0,360,text="min "+str(round(min13,3)))
    text13max=cvMC.create_text(xe,360,text="max "+str(round(max13,3)))
    text13mean=cvMC.create_text(ax13*mean13+bx13,370,text="mean "+str(round(mean13,3)))
    text13expla=cvMC.create_text(450,300,text="exact-LPOM0")
    line1=cvMC.create_line(x0,200,xe,200,width=4,fill="red")
    line2=cvMC.create_line(ax23*mean23+bx23,200,ax23*mean23+bx23,100,fill="black")
    line3=cvMC.create_line(ax23*med23+bx23,200,ax23*med23+bx23,100,fill="blue")
    text23min=cvMC.create_text(x0,210,text="min "+str(round(min23,4)))
    text23max=cvMC.create_text(xe,210,text="max "+str(round(max23,4)))
    text23mean=cvMC.create_text(ax23*mean23+bx23,210,text="mean "+str(round(mean23,3)))
    text23expla=cvMC.create_text(450,150,text="LPOMext-LPOM0")
    textgen1=cvMC.create_text(250,20,text="Generalized Zig-zag-poset",font=("Arial",14,"bold"))


def mcsim5():
    #parameters e,b,a,d,c,m
    MC=6000
    delta12=rmod2.vecgen1(MC)
    delta13=rmod2.vecgen1(MC)
    delta23=rmod2.vecgen1(MC)
    for mc in range(0,MC):
        e=random.randint(0,10)
        m=random.randint(1,10)
        b=random.randint(0,10)
        a=random.randint(0,10)
        c=random.randint(0,10)
        d=random.randint(0,10)
        
        #calculation
        summ1=0
        summ2=0
        for i in range(0,m+1):
            for j in range(0,c+1):
                f0=1.0*rmod2.nueberk(j+d,d)
                f1=1.0*rmod2.nueberk(j+d+b+1+i,i)
                    
                f2=1.0*rmod2.nueberk(c-j+e,e)
                
                f4=c+3.0+b+d+i+e
                f5=1.0*rmod2.nueberk(m-i+a,a)
                
                summ1+=f0*f1*f2*f4*f5
                summ2+=f0*f1*f2*f5

        rkav=1.0*summ1/(1.0*summ2)
        LT = summ2

        lpom0=(b+c+d+e+3.0)+m*(b+c+d+e+3.0)/(a+b+c+e+4.0)
        lpom=(c+d+e+b+3.0)+m*(c+b+d+2.0)/(c+b+d+a+3.0)
        #delta12 = rkav-lpom, delta13=rkav-lpom0,delta23=lpom-lpom0
        #print "i = ",i
        delta12[mc]=rkav-lpom
        delta13[mc]=rkav-lpom0
        delta23[mc]=lpom-lpom0

    var12=pstat.lvar(delta12)
    var13=pstat.lvar(delta13)
    var23=pstat.lvar(delta23)
    med12=pstat.lmedian(delta12,MC)
    med13=pstat.lmedian(delta13,MC)
    med23=pstat.lmedian(delta23,MC)
    mean12=pstat.lmean(delta12)
    mean13=pstat.lmean(delta13)
    mean23=pstat.lmean(delta23)
    min12=min(delta12)
    max12=max(delta12)
    min13=min(delta13)
    max13=max(delta13)
    min23=min(delta23)
    max23=max(delta23)
    x0=100
    xe=400
    ax12=(1.0*xe-1.0*x0)/(1.0*max12-min12)
    bx12=x0-ax12*min12
    ax13=(1.0*xe-1.0*x0)/(1.0*max13-min13)
    bx13=x0-ax13*min13
    ax23=(1.0*xe-1.0*x0)/(1.0*max23-min23)
    bx23=1.0*x0-1.0*ax23*min23
    tpMC5=Tkinter.Toplevel(hf,width=500,height=550)
    tpMC5.title(' MC-Simul. Generaliz. star-poset ')
    tMC5=ScrolledText(tpMC5,width=60,height=7)
    tMC5.pack()
    txt="MC-Simulation results, Generalized star-posets\n"
    txt+=60*"="+"\n"
    txt+="\t"+"Rkavexact-LPOMext\t\tRkavexact-LPOM0\n"
    txt+="min:\t\t"+str(round(min12,4))+"\t\t"+str(round(min13,4))+"\n"
    txt+="max:\t\t"+str(round(max12,4))+"\t\t"+str(round(max12,4))+"\n"
    txt+="var:\t\t"+str(round(var12,4))+"\t\t"+str(round(var13,4))+"\n"
    txt+="mean:\t\t"+str(round(mean12,4))+"\t\t"+str(round(mean13,4))+"(black line)\n"
    txt+="median:\t\t"+str(round(med12,4))+"\t\t"+str(round(med13,4))+"(blue line)\n"
    tMC5.insert("end",txt)
    cvMC=Tkinter.Canvas(tpMC5,width=500,height=550,bg="white")
    cvMC.pack()
    
    line1=cvMC.create_line(x0,490,xe,490,width=4,fill="red")
    line2=cvMC.create_line(ax12*mean12+bx12,490,ax12*mean12+bx12,390,fill="black")
    line3=cvMC.create_line(ax12*med12+bx12,490,ax12*med12+bx12,390,fill="blue")
    text12min=cvMC.create_text(x0,500,text="min "+str(round(min12,3)))
    text12max=cvMC.create_text(xe,500,text="max "+str(round(max12,3)))
    text12mean=cvMC.create_text(ax12*mean12+bx12,515,text="mean "+str(round(mean12,3)))
    text12expla=cvMC.create_text(450,430,text="exact-LPOMext")
    line1=cvMC.create_line(x0,350,xe,350,width=4,fill="red")
    line2=cvMC.create_line(ax13*mean13+bx13,350,ax13*mean13+bx13,250,fill="black")
    line3=cvMC.create_line(ax13*med13+bx13,350,ax13*med13+bx13,250,fill="blue")
    text13min=cvMC.create_text(x0,360,text="min "+str(round(min13,3)))
    text13max=cvMC.create_text(xe,360,text="max "+str(round(max13,3)))
    text13mean=cvMC.create_text(ax13*mean13+bx13,375,text="mean "+str(round(mean13,3)))
    text13expla=cvMC.create_text(450,300,text="exact-LPOM0")
    line1=cvMC.create_line(x0,200,xe,200,width=4,fill="red")
    line2=cvMC.create_line(ax23*mean23+bx23,200,ax23*mean23+bx23,100,fill="black")
    line3=cvMC.create_line(ax23*med23+bx23,200,ax23*med23+bx23,100,fill="blue")
    text23min=cvMC.create_text(x0,210,text="min "+str(round(min23,4)))
    text23max=cvMC.create_text(xe,210,text="max "+str(round(max23,4)))
    text23mean=cvMC.create_text(ax23*mean23+bx23,225,text="mean "+str(round(mean23,3)))
    text23expla=cvMC.create_text(450,150,text="LPOMext-LPOM0")
    textgen1=cvMC.create_text(250,20,text="Generalized star-poset",font=("Arial",14,"bold"))




hf=Tkinter.Tk()
hf.title('           model-posets          ')
fr=Tkinter.Frame(hf,width=60,height=4,bd=2,relief="sunken")
fr.pack()
lab0=Tkinter.Label(fr,text=" Simple Partial Order Models    ",font=("Arial",14,"bold"),width=60)
lab0.pack()
helpmodelHD3=raioop2.brgabout(hf,"tp1","help_modelHD.txt",9,\
            "Dec. the 20th,2011"," help_modelHD ", "white", "t1",120,5,ScrolledText)
aboutmodelHD3=raioop2.brgabout(hf,"tp1","about_modelHD.txt",9,\
            "Dec.the 20th,2011"," about_modelHD ", "white", "t1",120,5,ScrolledText)
buttexit=Tkinter.Button(hf,text=" exit ",bd=3,bg="red",width=25,command=hf.destroy)
buttexit.pack(pady=5)


mBar=Tkinter.Menu(hf,font=("Arial",16,"bold"))


mmodel1=Tkinter.Menu(mBar,bg="cyan")   #first model

mmodel1.add_command(label="1.0)Struct.param. (Merry-Go-Around-posets) ",command=read1)
mmodel1.add_command(label="1.1)Calc1", command=calc1)
mmodel1.add_command(label="1.2) Sensi1",command=sensi1)
mmodel1.add_command(label="1.3)Draw1", command=draw1)
mmodel1.add_command(label="1.4)MCsim1 ",command=mcsim1)
mmodel1.add_separator()
mmodel1.add_command(label="1.5)exit", command=hf.destroy)


mmodel2=Tkinter.Menu(mBar,bg="cyan")   #second model

mmodel2.add_command(label="2.0)Struct. param. (Generalized Flag-posets) ",command=read2)
mmodel2.add_command(label="2.1)Calc2", command=calc2)
mmodel2.add_command(label="2.2)Sensi2",command=sensi2)
mmodel2.add_command(label="2.3)Draw2", command=draw2)
mmodel2.add_command(label="2.4)MCsim2 ",command=mcsim2)
mmodel2.add_separator()
mmodel2.add_command(label="2.5)exit", command=hf.destroy)

mmodel3=Tkinter.Menu(mBar,bg="cyan")   #third model

mmodel3.add_command(label="3.0)Struct.param.(Generalized Handle-posets) ",command=read3)
mmodel3.add_command(label="3.1)Calc3", command=calc3)
mmodel3.add_command(label="3.2)Sensi3",command=sensi3)
mmodel3.add_command(label="3.2)Draw3", command=draw3)
mmodel3.add_command(label="3.3)MCsim3 ",command=mcsim3)
mmodel3.add_separator()
mmodel3.add_command(label="3.4)exit", command=hf.destroy)

mmodel4=Tkinter.Menu(mBar,bg="cyan")  #fourth model

mmodel4.add_command(label="4.0)Struct. param. (Generalized Zig-zag-posets ",command=read4)
mmodel4.add_command(label="4.1)Calc4", command=calc4)
mmodel4.add_command(label="4.2)Sensi4",command=sensi4)
mmodel4.add_command(label="4.3)Draw4", command=draw4)
mmodel4.add_command(label="4.4)MCsim4 ",command=mcsim4)
mmodel4.add_separator()
mmodel4.add_command(label="4.5)exit", command=hf.destroy)

mmodel5=Tkinter.Menu(mBar,bg="cyan")  #fifth model

mmodel5.add_command(label="5.0)Struct. param. (Generalized star-posets ",command=read5)
mmodel5.add_command(label="5.1)Calc5", command=calc5)
mmodel5.add_command(label="5.2)Sensi5",command=sensi5)
mmodel5.add_command(label="5.2)Draw5", command=draw5)
mmodel5.add_command(label="5.3)MCsim5 ",command=mcsim5)
mmodel5.add_separator()
mmodel5.add_command(label="5.4)exit", command=hf.destroy)

mBar.add_cascade(label="model 1  (1)",menu=mmodel1)
mBar.add_cascade(label="model 2  (2)",menu=mmodel2)
mBar.add_cascade(label="model 3  (3)",menu=mmodel3)
mBar.add_cascade(label="model 4  (4)",menu=mmodel4)
mBar.add_cascade(label="model 5  (5)",menu=mmodel5) 
hf["menu"]=mBar


hf.mainloop()

