
import rmod2
import raioop2
import Tkinter
from ScrolledText import *
import Canvas

# 12.3.08 Brg 17.3.08, 14.4.08
# 23.5.08
# Brg 12.10.08: help text external. Loading by a OOP-function


def oreste(n,beta,Cstern,gamma):
    """ Brg  12.3.08 """
    #akt 17.3.08
    #* 12.3.08
    #
       
    Cab=rmod2.vecgen1(n)
    Cba=rmod2.vecgen1(n)
    delta=rmod2.marray(n,n)
    punkt=rmod2.marray(n,n)

    for i in range(0,n):
        for j in range(0,n):
            Cab[i]=1.0*i/(1.0*n)
            Cba[j]=1.0*j/(1.0*n)
            if Cab[i]+Cba[j]<=1:
                delta[i][j]=abs(Cab[i]-Cba[j])
                if delta[i][j]<=beta:
                    if Cab[i]<=Cstern and Cba[j]<=Cstern:
                        punkt[i][j]=0    #indifferent
                    else:
                        punkt[i][j]=8    #incomparable low level
                else:
                    if Cba[j]>gamma*Cab[i]:
                        punkt[i][j]=1    #a > b
                    elif Cab[i]>gamma*Cba[j]:
                            punkt[i][j]=2    # a wird gegenueber b praeferiert
                    else:
                            punkt[i][j]=9   # b || a auf hohem Level
            else:
               punkt[i][j]=10
    return punkt

def calc_oreste():
    """caclulation of ORESTE"""
    #brg 17.3.08
    #*17.3.08
    #akt 17.3.08
    global pu
    n=int(en.get())
    beta=float(ebeta.get())
    Cstern=float(eCstern.get())
    gamma=float(egamma.get())
##    print "n=",n
##    print "beta=",beta
##    print "Cstern=",Cstern
##    print "gamma=",gamma
    pu=rmod2.marray(n,n)
    pu=oreste(n,beta,Cstern,gamma)
    tp2=Tkinter.Toplevel(hf,width=200,height=200)
    tp2.title('ORESTE-diagram')
    cv=Tkinter.Canvas(tp2,width=200,height=200)
    ordin=cv.create_line(10,180,10,20,arrow="last")
    absziss=cv.create_line(10,180,170,180,arrow="last")
    info="beta:= "+str(beta)+"  C*:= "+str(Cstern)+"  gamma:= "+str(gamma)
    charact=cv.create_text(80,10,text=info)
    for i in range(0,n):
        for j in range(0,n):
            xc=20.0+(140.0/(1.0*n))*i
            yc=160.0-(140.0/(1.0*n))*j
            if pu[i][j]==0:    
                farbe="white"
            elif pu[i][j]==8:
                farbe="orange"
            elif pu[i][j]==9:
                farbe="red"
            elif pu[i][j]==2:
                farbe="blue"
            elif pu[i][j]==1:
                farbe="green"
            else:
                farbe="grey"
            ci=cv.create_oval(xc-2,yc+2,xc+2,yc-2,fill=farbe,outline=farbe)
            pref1=cv.create_text(180,150,text="a>b")
            pref2=cv.create_text(30,20,text="b>a")
    ab=float(eCabown.get())
    ba=float(eCbaown.get())
    xg=140*ab+20
    yg=160-140*ba
    cg=cv.create_oval(xg-3,yg+3,xg+3,yg-3,fill="black",outline="black")
    cv.pack()

def calc_about():
    """About for ORESTE"""
    #brg  17.3.08
    #akt 17.3.08
    #* 17.3.08
    tp1=Tkinter.Toplevel(hf,width=100,height=5)
    tp1.title(' about ORESTE ')
    lbabout=Tkinter.Label(tp1,text=' Bruggemann, 17.3.08 after C.Schneeweiss:\n\
Planung 1. Systemanalytische und entscheidungstheoretische Grundlagen,\
\nSpringer-Verlag, Berlin, 1991')
    lbabout.pack()

def calc_help():
    """help for ORESTE"""
    #brg 17.3.08, 14.4.08, 25.5.08
    #akt 25.4.08
    #* 17.3.08
    # 17.10.09
    
    txt="\n"
    txt+="Aim \n"
    txt+="Calculation of a typical ORESTE-graphic \n"
    txt+="Analysis of Conflicts \n\n"
    txt+="Prerequisites\n"
    txt+="It is assumed that C(a,b) and C(b,a) are normalized preferences \n"
    txt+="C(a,b)+C(b,a)<=1 , C(a,b) expresses preference a over b\n"
    txt+="C(b,a) expresses preferences of b over a \n\n"
    txt+="Steps \n"
    txt+="number of runs: Just the quality of the giagram. n=50 recommended \n"
    txt+="beta: 'tolerance' or 'indifference' \n\n"
    txt+="Cstern: 'limit for considering C(a,b) and C(b,a)| resp. as small\n"
    txt+="gamma: ' degree of preferences' in case |C(a,b)-C(b,a) is large \n"
    txt+="\n\n"
    txt+="Result \n"
    txt+="The role of the steering parameters beta, Cstern and gamma \n"
    txt+="The actual preference (scale 0..1) and Cab+Cba<=1 is shown as a black\n"
    txt+="...circle\n"
    txt+="The black circle may located in one of the (at maximum) 6 fields\n"
    txt+="Green and blue: clear preferences\n"
    txt+="white: indifference\n"
    txt+="orange and red: remaining contradiction\n"
    
    
    txt+="\n\n -- end of file --"
    hfhelp=Tkinter.Toplevel(hf)
    hfhelp.title("help of ORESTE")
    frhelp=Tkinter.Frame(hfhelp,width=120, height=5)
    frhelp.pack(expand="yes")
    thelp=ScrolledText(frhelp,width=120,height=5)
    thelp.pack(expand="yes")
    thelp.insert("end",txt)
    
    
#


hf=Tkinter.Tk()
hf.title(' PyHasse: Oreste')

helporeste=raioop2.brgabout(hf,"tp1","help_oreste.txt",6,\
            "May. 23rd,2008"," help_oreste ", "white", "t1",120,5,ScrolledText)
    
    

fr=Tkinter.Frame(hf,width=100,height=200)
fr.pack()
lb=Tkinter.Label(fr, text="Demo ORESTE ")
lb.pack()
buttabout=Tkinter.Button(fr,text="about",bg="green",command=calc_about)
buttabout.pack(pady=20)
frdata=Tkinter.Frame(fr,width=50,height=10,bd=4,relief="sunken")
frdata.pack()

frinput=Tkinter.Frame(frdata,width=20,height=10)
frinput.pack(side='left')
frparam=Tkinter.Frame(frdata,width=20,height=10)
frparam.pack(side="left")
lb1=Tkinter.Label(frinput,text='number of runs (>50 recommended)')
lb1.pack()
lb2=Tkinter.Label(frinput,text=' tolerance (beta)')
lb2.pack()
lb3=Tkinter.Label(frinput,text=' C(a,b) and C(b,a) small if less than Cstern')
lb3.pack()
lb4=Tkinter.Label(frinput, text=' Factor gamma, by which C(a,b) \
\n is considered as greater than C(b,a)')
lb4.pack()
en=Tkinter.Entry(frparam,width=3)
en.pack()
ebeta=Tkinter.Entry(frparam,width=3)
ebeta.pack()
eCstern=Tkinter.Entry(frparam,width=3)
eCstern.pack()
egamma=Tkinter.Entry(frparam,width=3)
egamma.pack()
frown=Tkinter.Frame(fr,width=100,height=20)
frown.pack()
lbownab=Tkinter.Label(frown,text="actual value of a preferred over b")
lbownba=Tkinter.Label(frown,text="actual value of b preferred over a")
lbownab.grid(column=0,row=0)
lbownba.grid(column=0,row=1)
eCabown=Tkinter.Entry(frown,width=3)
eCbaown=Tkinter.Entry(frown,width=3)
eCabown.grid(column=1,row=0)
eCbaown.grid(column=1,row=1)
buttcalc=Tkinter.Button(fr,text="calculation",bg="cyan",bd=3,command=calc_oreste)
buttcalc.pack(pady=30)
buttexit=Tkinter.Button(hf,text=" exit  ", bg="red", command=hf.destroy)
buttexit.pack(pady=40)

hf.mainloop()

                 
            
            




          
