# -*- coding: cp1252 -*-
import math
import Tkinter
import tkFileDialog
from ScrolledText import *
import Canvas
import rmod2
import raioop2
import random

# Brg outrkhd1.py (derived from condor7.py)  4.7.10
# 29.9.10: The HD is not in a good format. Therefore new version: outrk3.py
# 10.4.2011 Adaption to the screen of laptops
# 12.4.2011 change to outrkhd6 (outrkhd5 can be thrown away.

def about():
    """ About outrkhd """
    # Brg 17.6.10
    aboutsensi=raioop2.brgabout(hf,"tp2","about_outrkhd.txt",6,\
            "April, the 14th ,2011"," about_outrkhd ", "white", "t2",120,5,ScrolledText)
    

def raihelp():
    """ Help about outrkhd """
    
    #  Use of OOP
    helpsensi=raioop2.brgabout(hf,"tp1","help_outrkhd.txt",6,\
            "April, the 1st,2011"," help_outrkhd ", "white", "t1",120,10,ScrolledText)

def File_select():
    """select a file and open it """
    #Brg 17.1.08
    #*:17.1.08
    #akt: 17.1.08
    global dm,ob,obj,pro,prop,r,k,fn
    fn=tkFileDialog.askopenfilename()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    lbopen.config(bg="yellow")
    lbopen["text"]="File "+fn+"\n opened with "+str(r)+" rows \n and "\
                         +str(k) +" columns"
    lbopen.pack()

    obj=rmod2.vecgentext1(r)                        #29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  #recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pro[i+1]   #recoding, because pro[0] is a dummy string
    global rred,xred,objred,txtred,tpsub
    tpsub=Tkinter.Toplevel(hf,width=60,height=10)
    tpsub.title(' submit window')
    rred,xred,objred,txtred=rmod2.equivcompact(r,k,dm,obj)
    labew=Tkinter.Label(tpsub,text="Select weights for "+str(k)+" attributes")
    labew.pack(side="left")
    frc=Tkinter.Frame(tpsub)
    frc.pack(pady=2)
    global ew
    ew=rmod2.vecgen1(k)
    for i in range(0,k):
        ew[i]=Tkinter.Entry(frc,width=4)
        ew[i].grid(row=0,column=i)
    return        
    

def showDM():
    """shows the DM"""
    # taken from fuzzyHD7
    tp2a=Tkinter.Toplevel(hf)
    tp2a.title(' show DM ')
    lbtp2=Tkinter.Label(tp2a,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2a,width=60,height=4)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)    


def inreadweights():
    #brg 17.8.10
    txtb1=""
    txtb1+="user defined weights \n"
    weights1=[]
    for i in range(0,k):
        try:
            weights1.append(float(ew[i].get()))
        except:
            weights1.append(1.0/(1.0*k))
    
    txtb1+="\n"
    txtw1="weights: "
    for i in range(0,k):
        txtw1+=str(round(weights1[i],2))+"\t"
    
    txtb1+=txtw1+"\n"
    return weights1,txtb1

def calc():
    # Brg  17.6.10, 17.8.10
    # calc the outranking matrix
    # takes the weights
    # Performs the Kemenyi-algorithm (CKYL algorithm after Munda)
    ovec=rmod2.vecgentext1(rred)
    for i in range(0,rred):
        ovec[i]=objred[i]      #to make otimal use of condor7
    
    global txtb,outrk1,txtranking,cut,lov,zetout    
    
    weights,txtb=inreadweights()
    # Outranking matrix corresponding to the Munda, Nardo paper, 2008
    # Outranking matrix rows(columns in an arbitrary sequence as the objects are found in the set
    
    outrk1,lov=rmod2.outranking(ovec,weights,xred,k)
    #rmod2.matout(lov,lov,outrk1)
    #print " "
    cut=float(ecut.get())
    #print "cut = ",cut
    cut=1.0*cut/100.0
    zetout=rmod2.marray(lov,lov)
    for i in range(0,lov):
        for j in range(0,lov):
            if outrk1[i][j]>=cut:
                zetout[i][j]=1
    #rmod2.matout(lov,lov,zetout)
    zetabr,fltrans=rmod2.transtest(rred,zetout)
    
    txtb+="\n Cut-Level: "
    txtb+=str(100*cut)
    if fltrans==0:
        txtb+="\nbinary matrix can be interpreted as zeta matrix "
    else:
        txtb+="\n+++ binary matrix is not a zeta matrix !!+++ "

def show_basics():
    app1=raioop2.brgscrolltext2(hf,txtb," basics of outranking ","tp1",60,5,"basics")
    app1.ausgabe()

def show_results():
    app2=raioop2.brgmatrixoutput2(hf,outrk1,"tp1","outranking matrix",txtb,lov,lov,objred,objred,"outranking")
    app2.ausgabe()

def copelandrule():
    # brg 30.9.10, 1.10.10
    global cope
    stweights=rmod2.vecgen1(k)
    for i in range(0,k):
        stweights[i]=1
    outcope,loutcope=rmod2.copeland(objred,xred,stweights,k)
    #rmod2.matout(rred,rred,cope)
    cope=rmod2.matrixrowsum(outcope,rred,rred)
    txtcopel=" Weak order due to Copeland rule "
    txtcopel+="\n"+60*"="+"\n"
    for i in range(0,rred):
        txtcopel+=str(objred[i])+"\t:"+str(cope[i])+"\n"
    txtcopel+="- - - e o f - - - "
    tpcopeland=Tkinter.Toplevel(hf)
    tpcopeland.title(" -- Copeland - results --- ")
    tcopeland=ScrolledText(tpcopeland,width=60, height=10)
    tcopeland.pack()
    tcopeland.insert("end",txtcopel)
    
    appcp=raioop2.brgmatrixoutput2(hf,outcope,"tpoutcope","outcope","-",rred,rred,objred,objred,"outranking cope")
    appcp.ausgabe()    

def u_cut():
    frucut.config(relief="raised",bd=4)
    ovec=rmod2.vecgentext1(rred)
    for i in range(0,rred):
        ovec[i]=objred[i]      #to make otimal use of condor7
    
    global txtb,outrk,txtranking    
    weights,txtb=inreadweights()

    # Outranking matrix corresponding to the Munda, Nardo paper, 2008
    # Outranking matrix rows(columns in an arbitrarx sequence as the objects are found in the set
    global outrk1,zetout,cut,lov
    outrk1,lov=rmod2.outranking(ovec,weights,xred,k)
    #rmod2.matout(lov,lov,outrk1)
    #print " "
    try:   
        cut0=int(ecut0.get())
        cut1=int(ecut1.get())
        delta=int(ecut2.get())
    except:
        cut0=50
        cut1=102
        delta=2
    uvec=[]
    cutv=[]
    utest=0
    for cu in range(cut0,cut1,delta):
        cutv.append(cu)
        cut=1.0*cu/100.0
        zetout=rmod2.marray(lov,lov)
        for i in range(0,lov):
            for j in range(0,lov):
                if outrk1[i][j]>=cut:
                    zetout[i][j]=1
##        print "cut= ",cu," zetout: "
##        rmod2.matout(lov,lov,zetout)
        utest=0
        for i in range(0,lov):
            for j in range(0,lov):
                if i!=j:
                    if zetout[i][j]==0 and zetout[j][i]==0:
                        utest+=0.5
        uvec.append(utest)
    tpucut=Tkinter.Toplevel(hf)
    tpucut.title(' cut-variation ')
    tucut=ScrolledText(tpucut,width=60,height=10)
    tucut.pack()
    txtucut="\t"+"cut\t\tU\n"
    txtucut+=60*"="+"\n"
    lu=len(uvec)
    for i in range(0,lu):
        txtucut+="\t"+ str(cutv[i])+"\t\t"+str(uvec[i])+"\n"
    txtucut+="\n"
    txtucut+="- - - e o f - - - "
    tucut.insert("end",txtucut)
    nam=["cut","U","   graph U(cut) "]
    app1=raioop2.brggraph5(tpucut,nam,"blue",2,uvec,cut0,cut1)
    app1.ausgabe()
    

def show_detail2():
    #brg  29.6.10, 1.7.10, 4.7.10
    txt1=txtb+"\n"
    txt1+="zeta-matrix as basis for HD of selected objects"+"\n"
    txt1+=80*"="+"\n"
    txt1h="" 
    
    txt1h+="\n"    
    for i in range(0,len(objred)):
        txt1h+=objred[i]+":\t"
        for i1 in range(0,len(objred)):
            txt1h+=str(zetout[i][i1])+"\t"
        txt1h+="\n"
    txt1+=txt1h+"\n"
    txt1+="- - - e o f - - - "
    tpdetails2=Tkinter.Toplevel(hf)
    tpdetails2.title(' new zeta-matrix ')
    tdetails2=ScrolledText(tpdetails2,width=120,height=5)
    tdetails2.pack()
    tdetails2.insert("end",txt1)
    
        



def HD():
    """based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"""
    # Brg 20.12.07, 28.12.07
    # If the number of representants > 20 then only the cover-matrix and the level-population
    #
    try:
        perturb=int(eperturb.get())
    except:
        perturb=0
        
    global zeta,cov,rred,n,objred    
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    global fn
    #dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    rred,xred,objred,obj,txteq0,neq=filecomp(r,dm,prop,fn)
    n=rred
    labeq=Tkinter.Label(freq,text="file = "+fn+": calc. is based on representants ")
    labeq.config(bg="yellow")
    labeq.pack()
    tp00=Tkinter.Toplevel(hf)
    t00=ScrolledText(tp00,width=120,height=5)
    t00.pack()
    txt="Equivalence classes of the ordinary data matrix "+"\n"
    txt+=60*"="+"\n"
    txt+=txteq0
    txt+="\n"
    txt+=" -  -  - e o f -  -  -  "+"\n"
    txt+="\n"
    t00.insert("end",txt)
    #
    zetahilf=rmod2.comp(n,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    lbhd1=Tkinter.Label(freq,text= "Level ")
    lbhd1.pack()

    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(n,zeta)
    #print "zzmax = ",zzmax
    tplev=Tkinter.Toplevel(hf)
    tplev.title(' Level population ')
    tlev=ScrolledText(tplev,width=60,height=4)  
    tlev.pack()
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
    txt1="\n"
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= objred[lobj[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)

    txt2="\n One linear extension \n\n"
    for i in range(0,n):
        if i<n-1:
            txt2+=objred[revlext[i]]+" < "
        else:
            txt2+=objred[revlext[i]]+"\n"
    txt2+="\n"
    txt2+="\n -- end of list -- "
    tlinext=ScrolledText(tplev,width=60, height=2)
    tlinext.pack()
    tlinext.insert("end",txt2)
    
    #Adj-Listen

    adjc=rmod2.adjacent(n,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(n,adjc,lext)
       
    
    cov=rmod2.cover(n,tr,lext)

    if n>200:
        cover_show()                  #20.1.08
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram of File "+fn)
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(n,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(n,n)
        geomy=rmod2.marray(n,n)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=(perturb*random.randint(1,5)+1)*geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-17,geomy[i][j]+17,geomx[i][j]+17,geomy[i][j]-17,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")

        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()
        
        buttcover=Tkinter.Button(freq,text="show cover relation",command=cover_show)
        buttcover.pack(side="left",padx=5)


def cover_show():
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: -
    hfcover=Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    
    lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,n):
        txt3+="\n"+objred[i]+":\t"
        txt3+="is cover_less than "
        for j in range(0,n):
            if i!=j:
                if zeta[i][j]==1:
                    txt3+=" "+objred[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)

def filecomp(r,dm,pro,fn):
    """ reduces a dm with equiv objects to a dm of a quotient set """
    # Brg 12.12.07, 13.1.08, 8.5.08, 20.6.08
    #r,k,dm,ob,pro,fn are globals and should be available after open
    
    #dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    #recoding ob to obj and pro to prop
    if r==0:
        hfwarning=Tkinter.Toplevel(hf)
        hfwarning.title(' ++warning++ ')
        frwarning=Tkinter.Frame(hfwarning,width=10,height=3)
        frwarning.pack()
        bwarning=Tkinter.Button(frwarning,text="++warning ++",command=msgwarning)
        bwarning.pack()
        
    #prop=rmod2.vecgentext1(k)
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
##    for i in range(0,k):
##        prop[i]=pro[i+1]
    for i in range(0,r):
        obj[i]=ob[i+1]
    #############################dieser Teil ist neu 21.12.07
    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,dm,obj)    
    ###############################################################
    #print objred
    #print "reduzierte matrix"
    #rmod2.matout(rred,k,xred)
    return rred,xred,objred,obj,txt,neq   #20.6.08        
                



    hfhelp=Tkinter.Toplevel(hf)
    hfhelp.title(' help ')
    lbhelp2=Tkinter.Label(hfhelp,text="   help: mainHD7    ")
    lbhelp2.pack()
    frhelp=Tkinter.Frame(hfhelp,width=400,height=400)  #3.2.08
    frhelp.pack()
    thelp=ScrolledText(frhelp,width=80, height=40)
    thelp.pack(expand=1)
    
    thelp.insert("end",txthelp)




def HDoutranking():
    "based on objcon (zeta-matrix) the Hasse diagram is generated and one linear extension)"
    # Brg 20.12.07, 28.12.07
    # If the number of representants > 20 then only the cover-matrix and the level-population
    # This module I took from mainHD5
    # 8.6.08 
    global zeta,zeta2,rred,n,objred,zetout1    
    hfhd3=Tkinter.Toplevel(hf)
    hfhd3.title('Hasse diagramCYCL / cover matrix ')
    freq=Tkinter.Frame(hfhd3,width=200,height=300)
    freq.pack()
    
    n=lov
    rred=n  #just because I don't want to relabel all lines
    #print "lov= ",lov

    #
    for i in range(0,n):
        zetout[i][i]=1  #        
    
    #rmod2.matout(n,n,zetout)
    zetout0=rmod2.marray(n,n)    
    for i in range(0,lov):
        for j in range(0,lov):
            zetout0[i][j]=zetout[j][i]
    
    

    flag=True
    try:        
        lobj,lext,revlext,zzmax=rmod2.levtopsort(n,zetout0)
        print "lext=",lext,"  zzmax= ",zzmax
        levmax=-10**20     #20.6.08
        for i in range(0,zzmax):
            if len(lobj[i])>=levmax:
                levmax=len(lobj[i])
    except:
        flag=False
    if flag==True:    
    
            
        #Adj-Listen

        adjc=rmod2.adjacent(n,lext,revlext,zetout0)
            
        #Transitive reduced relations
        ts,tr=rmod2.trreduct(n,adjc,lext)
           
        
        zeta2=rmod2.cover(n,tr,lext)
        if n>200:
            cover_show()                  #20.1.08
        else:
            lbhd3rk=Tkinter.Label(freq,text=" Hasse Diagram of File "+fn+"  Cut= "+str(100*cut))
            lbhd3rk.pack()
            actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(n,levmax,zzmax)
            cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
            lz=zzmax
            l=rmod2.vecgen1(lz)
            for i in range(0,lz):
                l[i]=len(lobj[i])

            pos=rmod2.vecgen1(lz)
            for i in range(0,lz):
                pos[i]=l[i]
            
            geomx=rmod2.marray(n,n)
            geomy=rmod2.marray(n,n)

            geom0x=10
            geom0y=20
            for i in range(0,lz):
                for j in range(0,l[i]):
                    geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)
                    geomy[i][j]=geom0y+(factory/lz)*i
                

            for i in range(0,lz-1):
                for j in range(0,l[i]):
                    #print obj[lobj[i][j]]
                    for i1 in range(i+1,lz):
                        for j1 in range(0,l[i1]):
                            #print obj[lobj[i1][j1]]
                            if zeta2[lobj[i1][j1]][lobj[i][j]]==1:
                                #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                                cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


            for i in range(0,lz):
                for j in range(0,l[i]):
                    cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                    cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
            
            cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
    ##        cv.create_line(garrow1x-4,garrow2y-4,garrow1x,garrow2y)
    ##        cv.create_line(garrow1x+4,garrow2y-4,garrow1x,garrow2y)
            cv.create_text(garrow1x+8,garrow1y-6,text="high")
            cv.create_text(garrow1x+8,garrow2y+6,text="low")
            cv.pack()
            buttcover2=Tkinter.Button(freq,text="show cover relation",command=cover_show2)
            buttcover2.pack(side="left",padx=5)

    else:
        lbhd3rk=Tkinter.Label(freq, text="Cycles !!",bg="yellow",font=("Arial",14,"bold"))
        lbhd3rk.pack()

def cover_show2():
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: -
    hfcover2=Tkinter.Toplevel(hf)
    hfcover2.title(' cover-matrix of outrk ')
    
    lbhd22=Tkinter.Label(hfcover2,text=" Cover-Relations of outrk-PO")
    lbhd22.pack()
    txt3="\n cover-matrix of outrk_PO  \n"
    for i in range(0,n):
        txt3+="\n"+objred[i]+":\t"
        txt3+="is covered by "
        for j in range(0,n):
            if i!=j:
                if zeta2[i][j]==1:
                    txt3+=" "+objred[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover2,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)
    
def sf():
    #brg 29.9.2010
    # taken from interval7.py
    zetout2=rmod2.marray(rred,rred)
    for i in range(0,rred):
        for j in range(0,rred):
            if i!=j:
                zetout2[i][j]=zetout[j][i]
            else:
                zetout2[i][j]=0
    fn=tkFileDialog.asksaveasfilename(parent=hf,title="save file")
    rmod2.raiwrite5(fn,zetout2,objred,objred,rred,rred)
    lbsuccess.config(text="matrix with \n"+str(rred)+"  rows  and "+str(rred)+"\n  columns stored",bg="yellow")

def stogv():
    """ stores the cover matrix in graphviz
        format """
    # brg 15.3.09
    # File-name is a request within 'brgsavefile1'
    global zetout
    txtgr=rmod2.covtxt(zetout,objred,rred,"digraph_x") #central routine! 
    app1=raioop2.brgsavefile1(hf,'yellow','t','w',txtgr,r,r)

def simpsonr():
    # brg 30.9.10, 1.10.2010
    global simsp
    simsp=rmod2.simpsonrule(lov,outrk1)
    txtsimp=" Weak order due to Simpson rule "
    txtsimp+="\n"+60*"="+"\n"
    for i in range(0,lov):
        txtsimp+=str(objred[i])+"\t:"+str(simsp[i])+"\n"
    txtsimp+="- - - e o f - - - "
    tpsimp=Tkinter.Toplevel(hf)
    tpsimp.title(" -- Simpson - results --- ")
    tsimp=ScrolledText(tpsimp,width=60, height=10)
    tsimp.pack()
    tsimp.insert("end",txtsimp)


def HDcopesimsp():
    # brg 1.10.10
    hfhd4=Tkinter.Toplevel(hf)
    hfhd4.title('Hasse diagram copeland/simpson-indicators ')
    freq4=Tkinter.Frame(hfhd4)
    freq4.pack()
    dmsimpscope=rmod2.marray(rred,2)
    for i in range(0,rred):
        dmsimpscope[i][0]=simsp[i]
        dmsimpscope[i][1]=cope[i]
    rred2,xred2,objred2,txt2,neq2=rmod2.equivcompactm(rred,2,dmsimpscope,objred)
    print "rred2= ",rred2
    print "txt20 ",txt2
    zetahilf3=rmod2.comp(rred2,2,xred2)  #zeta matrix with col<row
    zeta3=rmod2.marray(rred2,rred2)
    for i in range(0,rred2):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred2):
            zeta3[i][j]=zetahilf3[j][i]
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred2,zeta3)
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
    
    
            
    #Adj-Listen

    adjc=rmod2.adjacent(rred2,lext,revlext,zeta3)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred2,adjc,lext)
       
    
    cov3=rmod2.cover(rred2,tr,lext)
    if rred2>200:
        cover_show()                  #20.1.08
    else:
        lbhd4rk=Tkinter.Label(freq4,text=" Hasse Diagram of File "+fn+"  Cut= "+str(100*cut)+"\n based on simpson and copeland rules")
        lbhd4rk.pack()
        actwidth,actheight,factorx,\
            factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred2,levmax,zzmax)
        cv=Tkinter.Canvas(freq4,width=actwidth,height=actheight,bg="white")
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(rred2,rred2)
        geomy=rmod2.marray(rred2,rred2)

        
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(factory/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if cov3[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred2[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
##        cv.create_line(garrow1x-4,garrow2y-4,garrow1x,garrow2y)
##        cv.create_line(garrow1x+4,garrow2y-4,garrow1x,garrow2y)
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.pack()
        buttcover2=Tkinter.Button(freq,text="show cover relation",command=cover_show2)
        buttcover2.pack(side="left",padx=5)






hf=Tkinter.Tk()
hf.title(' GUI Outranking/Cut analysis')
about()
raihelp()
fropen=Tkinter.Frame(hf,width=60,height=40,relief="sunken",bd=2)
fropen.pack()
lbopen=Tkinter.Label(fropen,text=120*"_")
lbopen.pack()
buttfileselect=Tkinter.Button(fropen,text="select and open file",width=25, bg="white",command=File_select)
buttfileselect.pack(pady=2)
frshow=Tkinter.Frame(hf,width=60,height=4,relief="sunken",bd=2)
frshow.pack(fill="x")
buttshow=Tkinter.Button(frshow,text="show data matrix ",width=25,command=showDM)
buttshow.pack(pady=2)
fr2a=Tkinter.Frame(hf)
fr2a.pack()
fr2b=Tkinter.Frame(hf)
fr2b.pack()
buttHD=Tkinter.Button(frshow,text="show  HD ",width=25,command=HD)
buttHD.pack(pady=2)
frcut=Tkinter.Frame(hf)
frcut.pack(pady=2)
lbcut=Tkinter.Label(frcut,text="cut-level in % >>")
lbcut.pack(side="left")
ecut=Tkinter.Entry(frcut,width=3)
ecut.pack(side="left")
frcalc=Tkinter.Frame(hf,relief="sunken",bd=2)
frcalc.pack(pady=2)

buttcalc=Tkinter.Button(frcalc,text="(1) calc ",bg="cyan",width=25,command=calc)
buttcalc.pack(pady=5)
frresults=Tkinter.Frame(hf,relief="groove",bd=4)
frresults.pack(pady=2)
buttshowbasics=Tkinter.Button(frresults,text="basics (selected objects\nselected weights)",command=show_basics)
buttshowbasics.pack()
buttshowresults=Tkinter.Button(frresults,text="outranking matrix: ",width=30,command=show_results)
buttshowresults.pack(pady=2)
##buttshowdetails1=Tkinter.Button(frresults,text="Look at all rankings" ,command=show_detail1)
##buttshowdetails1.pack(pady=3)
buttshowdetails2=Tkinter.Button(frresults,text="Look at the new zeta-matrix" ,command=show_detail2)
buttshowdetails2.pack(pady=2)

buttHDRk=Tkinter.Button(frresults,text="(2) HD depending on Cut-level",width=30,command=HDoutranking)
buttHDRk.pack()
buttcope=Tkinter.Button(frresults,text="(3) Copeland - weak order ",bg="cyan",width=30,command=copelandrule)
buttcope.pack(pady=1)
buttsimpson=Tkinter.Button(frresults, text="(4) Simpson rule - wealk order ",width=30, bg="cyan",command=simpsonr)
buttsimpson.pack(pady=1)
buttHDcombi=Tkinter.Button(frresults,text="HD of cope and simpson-indicators ",width=30,bg="cyan",command=HDcopesimsp)
buttHDcombi.pack(pady=1)
frucut=Tkinter.Frame(hf,relief="raised",bd=1)
frucut.pack()
lbucut=Tkinter.Label(frucut,text="start-cut (50), end-cut (100), steps (2) ")
lbucut.pack()
fru_entry=Tkinter.Frame(frucut)
fru_entry.pack()
ecut0=Tkinter.Entry(fru_entry,width=3)
ecut0.pack(side="left")
ecut1=Tkinter.Entry(fru_entry,width=3)
ecut1.pack(side="left")
ecut2=Tkinter.Entry(fru_entry,width=3)
ecut2.pack(side="left")
buttstore=Tkinter.Button(hf,text="save new partial order,\n corresponding to cut ",width=30,bg="cyan",command=sf)
buttstore.pack(pady=2)
buttgv=Tkinter.Button(hf,text="save dichotomic outrk matrix in graphviz",bg="cyan",command=stogv)
buttgv.pack()
lbsuccess=Tkinter.Label(hf,text="")
lbsuccess.pack()
buttucut=Tkinter.Button(frucut,text="U-cut-graphs ",bg="cyan",width=30,command=u_cut)
buttucut.pack()
buttexit=Tkinter.Button(hf,text="  Exit  ",bg="red",width=25,command=hf.destroy)
buttexit.pack()




























hf.mainloop()
