# -*- coding: cp1252 -*-
import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import tkFileDialog
import raioop2
import random

#Brg 14.4.2013, 15.4.2013, 16.4.2013
# Vs 2: 19.4.2013
# Brg 26.4.2013
# brg 28.3.2015

def file_selectopenHD():
    """based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"""
    # Brg 20.12.07, 28.12.07, 2.10.,3.10.09, 14.4.2013
    # If the number of representants > 70 then only the cover-matrix and the level-population
    #
    global obj,prop,r,k,fn,dm
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    
    fn=tkFileDialog.askopenfilename()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    lb1.config(text="opened "+fn,bg="yellow")
    

    prop=[]
    for j in range(0,k):
        prop.append(pro[j+1])
            
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
    for i in range(0,r):
        obj[i]=ob[i+1]

    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,dm,obj)  
    
    #
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    print "zeta-Matrix "
    rmod2.matout(rred,rred,zeta)
    print " "
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    if rred>70:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram  ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()

def showDM():
    """ New routine : shows the data matrix """
    #Brg 13.1.08
    global fn,r,k,obj,prop
    tp2=Tkinter.Toplevel(hf)
    tp2.title(' show DM ')
    lbtp2=Tkinter.Label(tp2,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+ob[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+pro[j+1]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=pro[j+1]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=ob[i+1]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)
    




def submit_uncertainty():
    # brg 14.4.2013, 15.4.2013, 19.9.15
    global elowerlimit,eupperlimit, edefault
    elowerlimit=rmod2.marray(r,k)
    eupperlimit=rmod2.marray(r,k)
    
    lbvar1=rmod2.vecgen1(r*k)
    tpMC=Tkinter.Toplevel(hf)
    tpMC.title(' MC-simulation ')
    lbdefault1 = Tkinter.Label(tpMC,text=" Here you can select what to do with non-filled entries\n see below ")
    lb1.pack()
    lbdefault2=Tkinter.Label(tpMC,text=" if you select 0 then the empty entry fields will get just the orig. dm-values")
    lbdefault2.pack()
    lbdefault3=Tkinter.Label(tpMC,text=" if you select unequl 0 (for example 10 (percentages) then the empty entry \n\
                                         fields will get just the  x*(1-10/100), x*(1+10/100), with x = orig. dm-value")
    lbdefault3.pack()
    
    edefault = Tkinter.Entry(tpMC,width=5)
    edefault.pack()
    frsubmit = Tkinter.Frame(tpMC)
    frsubmit.pack()
    
    for j in range(0,k):
        zahl = 0
        tpMC2=Tkinter.Toplevel(hf)
        tpMC2.title('inputs...')
        frsubmitinput=Tkinter.Frame(tpMC2)
        frsubmitinput.pack()
        lbprop = Tkinter.Label(frsubmitinput, text = str(prop[j]))
        lbprop.grid(row=0,columnspan=4)
        lbMC=Tkinter.Label(frsubmitinput,text="lower limit --- upper limit\n default: (depends on your selection) ",bg="white")
        lbMC.grid(row=1,columnspan=4)
        for i in range(0,r):
            lbvar1[zahl]=Tkinter.Label(frsubmitinput,text="object "+str(obj[i])+", "+str(prop[j]))
            lbvar1[zahl].grid(row=2+zahl,column=0)
            elowerlimit[i][j]=Tkinter.Entry(frsubmitinput,width=10)
            elowerlimit[i][j].grid(row=zahl+2,column=2)
            eupperlimit[i][j]=Tkinter.Entry(frsubmitinput,width=10)
            eupperlimit[i][j].grid(row=zahl+2,column=3)
            zahl+=1
        


def calc():
    # brg 14.4.2013
    global elowerlimit,eupperlimit,nMC,k,r,perc,probabmax,probabmin,avrred,rangeprob,objmax,objmin
    global factorlower, factorhigher,objneither,probabneither,objiso,probabiso, lowerlimit, upperlimit
    try:
        nMC=int(eMC.get())
    except:
        nMC=min(1000**k,100000)
    try:
        perc=float(edefault.get())
    except:
        perc=10.0
        
    lowerlimit=rmod2.marray(r,k)
    upperlimit=rmod2.marray(r,k)
    rangeprob=rmod2.marray(r,k)
    objmin=rmod2.vecgen1(r)
    objmax=rmod2.vecgen1(r)
    objneither=rmod2.vecgen1(r)
    objiso=rmod2.vecgen1(r)
    probabmax=rmod2.vecgen1(r)
    probabmin=rmod2.vecgen1(r)
    probabneither=rmod2.vecgen1(r)
    probabiso=rmod2.vecgen1(r)
    factorlower=(1.0-perc/100.0)
    factorhigher=(1.0+perc/100.0)
    rredprob=[]
    flag=0                
    for i in range(0,r):
        for j in range(0,k):
            try:
                lowerlimit[i][j]=float(elowerlimit[i][j].get())
            except:
                lowerlimit[i][j]=factorlower*dm[i][j]
    
            try:
                upperlimit[i][j]=float(eupperlimit[i][j].get())
            except:
                upperlimit[i][j]=factorhigher*dm[i][j]
                    
            rangeprob[i][j]=upperlimit[i][j]-lowerlimit[i][j]
            if dm[i][j]<lowerlimit[i][j] or dm[i][j]>upperlimit[i][j]:
                flag=1
    
    
    #print "rangeprob-matrix "
    #rmod2.matout(r,k,rangeprob)
    if flag==1:
        lbwarn.config(text="+++values of data matrix not within your selected intervals ! +++",bg="yellow")
    else:
        lbwarn.config(text=" values of the data matrix are within your selected intervals ",bg="white")
    rredsum=0     
    for mc in range(0,nMC):
         dmperturb=rmod2.marray(r,k)
         sumobjmax=rmod2.vecgen1(r)
         sumobjmin=rmod2.vecgen1(r)
         sumobjmax2=rmod2.vecgen1(r)
         sumobjmin2=rmod2.vecgen1(r)
         sumobjiso=rmod2.vecgen1(r)
         for i in range(0,r):
             for j in range(0,k):
                 dmperturb[i][j]=random.uniform(lowerlimit[i][j], upperlimit[i][j])

         
         rredperturb,xredperturb,objredperturb,txtperturb,neqperturb=rmod2.equivcompactm(r,k,dmperturb,obj)
         #print "mc_run ",mc
         #print "dmperturbed "
         #print " "
         #rmod2.matout(rredperturb,k,dmperturb)
         rredprob.append(rredperturb)
         rredsum+=rredperturb
         #
         zetahilfp=rmod2.comp(rredperturb,k,xredperturb)  #zeta matrix with col<row
         zetap=rmod2.marray(rredperturb,rredperturb)
         for i in range(0,rredperturb):  #however we need for the 'normal' presentation: row < col. Transposition
             for i1 in range(0,rredperturb):
                 if i==i1:
                     zetap[i][i1]=0
                 else:    
                     zetap[i][i1]=zetahilfp[i1][i]
         
         #check for proper maximal, minimal,iso, neither
         for i in range(0,rredperturb):
             ob=objredperturb[i]
             iob=obj.index(ob)
             for i1 in range(0,rredperturb):
                 sumobjmax[iob]+=zetap[i][i1]
                 sumobjmin[iob]+=zetap[i1][i]
             #print "ob= ",ob,"   sumobjmax  ",sumobjmax[iob]
             if sumobjmax[iob]==0 and sumobjmin[iob]!=0:
                 objmax[iob]+=1
             elif sumobjmax[iob]!=0 and sumobjmin[iob]==0:
                 objmin[iob]+=1
             elif sumobjmax[iob]==0 and sumobjmin[iob]==0:
                 objiso[iob]+=1
             else:
                 objneither[iob]+=1
             #print "ob= ",ob,"   objmax= ",objmax[iob]    

        
    
    
    for i in range(0,r):
           probabmin[i]=(1.0*objmin[i])/(1.0*nMC)
           probabmax[i]=(1.0*objmax[i])/(1.0*nMC)
           probabneither[i]=(1.0*objneither[i])/(1.0*nMC)
           probabiso[i]=(1.0*objiso[i])/(1.0*nMC)
           
    avrred=1.0*rredsum/(1.0*nMC)
    buttdetOut.config(state="active")
    buttobj.config(state="active")
    butthist.config(state="active")
    

def detailledOutput():
    #brg 19.4.2013, 28.3.2015
    global elowerlimit,eupperlimit,nMC,k,r,perc,probabmax,probabmin,avrred,rangeprob,objmax,objmin
    global factorlower, factorhigher 
    tpcalc=Tkinter.Toplevel(hf)
    tpcalc.title(' prob_max_min_Calculation ')
    tcalc=ScrolledText(tpcalc,width=120,height=20)
    tcalc.pack()
    txt=" MC-Simulation "+"\n"
    txt+=60*"="+"\n"
    txt+=" User inputs "+"\n"
    txt+=60*"-"+"\n"
    txt+=" File: "+str(fn)+"\n"
    txt+=" number of MC-runs "+str(nMC)+"\n"
    txt+=" percentual reduction/enhancement (may be the default-value "+str(perc)+"\n"
    txt+=" Ranges "+"\n"
    txt+="\t"
    for j in range(0,k):
        txt+=str(prop[j])+"\t"
    txt+="\n"    
    for i in range(0,r):
        txt+=" "+str(obj[i])+": "
        for j in range(0,k):
            txt+=str(rangeprob[i][j])+", "
        txt+="\n"
    txt+="\n"
    txt += "ranges of the perturbed dm "+"\n"  
    for j in range(0,k):
        txt+=str(prop[j])+2*"\t"
    txt+="\n"    
    for i in range(0, r):    
        txt+=" "+str(obj[i])+": "
        for j in range(0,k):
            txt+="("+str(round(lowerlimit[i][j],3))+", "+str(round(upperlimit[i][j],3))+")..."
        txt+="\n"        
    txt+="\n"
    txt+=60*"-"+"\n"
    txt+="\n" +" Main results "+"\n"
    txt+=60*"-"+"\n"
    for i in range(0,r):
        txt+=" "+str(obj[i])+" prob (proper) min = "+str(round(probabmin[i],3))+"\n"
    txt+="\n"    
    for i in range(0,r):    
        txt+=" "+str(obj[i])+" prob (proper) max = "+str(round(probabmax[i],3))+"\n"
    txt+="\n"
    for i in range(0,r):
        txt+=" "+str(obj[i])+" prob iso =          "+str(round(probabiso[i],3))+"\n"
    txt+="\n"
    for i in range(0,r):
         txt+=" "+str(obj[i])+" prob neither =     "+str(round(probabneither[i],3))+"\n"
    txt+="\n"
        
    tcalc.insert("end",txt)
         
def singleobjan():
    # brg 19.4.2013
    global elowerlimit,eupperlimit,nMC,k,r,perc,probabmax,probabmin,probabneither, probabiso, avrred,rangeprob,objmax,objmin
    global factorlower, factorhigher,objneither,objiso
    tpsingle=Tkinter.Toplevel(hf)
    tpsingle.title(' Results for the user-selected object ')
    tsingle=ScrolledText(tpsingle,width=80,height=10)
    tsingle.pack()
    txt="File = "+str(fn)+"\n"
    try:
        objspec=eob.get()
    except:
        objspec=obj[0]
    #print "selected object = ",eob
    txt+="Selected object  "+str(objspec)+"\n"
    flagobj=0
    try:
        iobspec=obj.index(objspec)
    except:
        txt+="+++Object not found +++"+"\n"
        flagobj=1

    if flagobj!=1:
        txt+="\nUser selected parameters: "+"\n"
        txt+="number of MC-runs "+str(nMC)+"\n"
        txt+=" "+str(obj[iobspec])+"\n"
        txt+="\tlowerlimit"+ 4*"\t"+"upperlimit"+"\n"
        for j in range(0,k):
                txt+=str(prop[j])+"\t: "
                if lowerlimit[iobspec][j]==upperlimit[iobspec][j]:
                    txt+=2*"\t"+str(lowerlimit[iobspec][j])+"\n"
                else:
                    txt+=str(round(lowerlimit[iobspec][j],3))+4*"\t"+str(round(upperlimit[iobspec][j],3))+"\n"
        txt+="\n"            
        txt+="Object "+str(objspec)+" proper maximal element with probability "+str(probabmax[iobspec])+"\n"
        txt+="Object "+str(objspec)+" proper minimal element with probability "+str(probabmin[iobspec])+"\n"
        tsingle.insert("end",txt)
    else:
        txt+="please select a correct objectname +++"
        tsingle.insert("end",txt)
            
def histoall():
    # brg 26.4.2013
    global elowerlimit,eupperlimit,nMC,k,r,perc,probabmax,probabmin,probabneither, probabiso, avrred,rangeprob,objmax,objmin
    global factorlower, factorhigher,objneither,objiso
    tpsingle2=Tkinter.Toplevel(hf)
    tpsingle2.title(' Results given a single user selected object ')
    tsingle2=ScrolledText(tpsingle2,width=80,height=10)
    tsingle2.pack()
    txt = "File = "+str(fn)+"\n"
    txt += "Abridged text info: bar diagram " 
    txt += "MC-runs "+str(nMC)
    try:
        objspec=eob.get()
    except:
        objspec=obj[0]
    #print "selected object = ",eob
    iobspec=obj.index(objspec)    
    txt += "Selected object  "+str(objspec)+"\n"
    hpo=rmod2.vecgen1(4)
    hpo[0]=probabmin[iobspec]
    hpo[1]=probabmax[iobspec]
    hpo[2]=probabiso[iobspec]
    hpo[3]=probabneither[iobspec]
    txt += "probability for being a proper minimal object:      \t"+str(hpo[0])+"\n"
    txt += "probability for being a proper maximal object:      \t"+str(hpo[1])+"\n"
    txt += "probability for being an isolated object:           \t"+str(hpo[2])+"\n"
    txt += "probability for being neither maximal, nor minimal: \t"+str(hpo[3])+"\n"
    tsingle2.insert("end",txt)
    barth=["min","max","iso","neither"]
    app1=raioop2.brgbar10(hf,hpo,barth,"probability min-max-iso-neither\nobject= "+str(objspec),35,"red")
    app1.ausgabe()
    

## Tkinter Plot
hf = Tkinter.Tk()
hf.title(' prob_max_min ')
aboutHDsimpl=raioop2.brgabout(hf,"tp1","about_prob_max.txt",5,\
            "Sept, 19th,2015"," about prob_max ", "white", "t1",80,5,ScrolledText)
helpHDsimpl=raioop2.brgabout(hf,"tp1","help_prob_max.txt",5,\
            "Sept, 19th, 2015"," help_prob_max", "white", "t1",80,5,ScrolledText)
    
fr=Tkinter.Frame(hf,width=60)
fr.pack()
buttHD = Tkinter.Button(fr, text='select, open and HD',width=25,bg="cyan",command=file_selectopenHD)
buttHD.pack(pady=5)
lb1=Tkinter.Label(fr,text="")
lb1.pack()
buttshowdm=Tkinter.Button(fr,text="show dm ",bg="white",width=25,command=showDM)
buttshowdm.pack()
lbMC=Tkinter.Label(fr,text="number of MC-runs")
lbMC.pack()
eMC=Tkinter.Entry(fr,width=10)
eMC.pack()
buttsubmit=Tkinter.Button(fr,text="Select the ranges\n of each object and each indicator ",width=25,command=submit_uncertainty)
buttsubmit.pack()
buttcalc=Tkinter.Button(fr,text="Perform MC-calculation ",width=25,bg="cyan",command=calc)
buttcalc.pack()
buttdetOut=Tkinter.Button(fr,text="Detailled results (all objects )",width=25,bg="cyan",state="disabled",command=detailledOutput)
buttdetOut.pack()
lbwarn=Tkinter.Label(fr,text="",width=50)
lbwarn.pack()
frobj1=Tkinter.Frame(fr)
frobj1.pack()
lbobj=Tkinter.Label(frobj1, text="enter objectname ")
lbobj.pack(side="left")
eob=Tkinter.Entry(frobj1,width=10)
eob.pack(side="right")
frobj2 = Tkinter.Frame(fr)
frobj2.pack()
buttobj=Tkinter.Button(frobj2,text="Single-object analysis based \non your selections in the former steps", width=25, bg="cyan",state="disabled",command=singleobjan)
buttobj.pack()
butthist=Tkinter.Button(frobj2,text= "Histogram for that selected object",width=25,bg="cyan",state="disabled",command=histoall)
butthist.pack()
              
buttexit = Tkinter.Button(fr, text = 'exit', bg = 'red', width=25,command = hf.destroy)
buttexit.pack(pady=10)

hf.mainloop()

