import rmod2
import raioop2
import Tkinter
import stats
import pstat
import Canvas
from ScrolledText import ScrolledText

# Brg  29.1.2013
# After Thiessen Achari, 2012
# brg 30.1.2013
# brg 31.1.2013
# brg 22.4.2013 Line 71 int replaced by float

def rkmatrix(R,n):
    # brg 29.1.2013
    rk=rmod2.marray(n,n)
    for i in range(0,n):
        for j in range(0,n):
            if R[i]>=R[j]:
                rk[i][j]=1
            else:
                rk[i][j]=-1
    return rk

def rkdiff(R,n):
    #brg 29.1.2013
    rkdiffm=rmod2.marray(n,n)
    for i in range(0,n):
        for j in range(0,n):
            rkdiffm[i][j]=R[i]-R[j]
    return rkdiffm


def truerank(rkmatrix1,rkmatrix2,rkdiff,n):
    # brg 29.1.2013
    counttrue=rmod2.vecgen1(n)
    countall=rmod2.vecgen1(n)
    probth=rmod2.vecgen1(n)
    for delta in range(0,n):
        for i in range(0,n):
            for j in range(0,n):
                if i!=j:
                    if rkdiff[i][j]==delta:
                        countall[delta]+=1
                        if rkmatrix1[i][j]==rkmatrix2[i][j]:
                            counttrue[delta]+=1
        if countall[delta]==0:
            probth[delta]=0
        else:    
            probth[delta]=1.0*counttrue[delta]/(1.0*countall[delta])
    return probth,counttrue, countall
                                           

def calc():
    # brg 29.1.2013
    global R1,R2,rk1,rk2,rkdiffm2,n
    rank1=erank1.get().split(",")
    rank2=erank2.get().split(",")
    n1=len(rank1)
    n2=len(rank2)
    tp=Tkinter.Toplevel(hf)
    tp.title("results")
    tresults=ScrolledText(tp,width=60,height=10)
    tresults.pack()
    if n1==n2:
        lbmessage.config(text="Two series of "+str(n1) +"  ranks read in")
        n=n1
        R1=rmod2.vecgen1(n)
        R2=rmod2.vecgen1(n)
        for i in range(0,n1):
            R1[i]=float(rank1[i])
            R2[i]=float(rank2[i])
        rspear,prspear=pstat.lspearmanr(R1,R2)    
        rk1=rkmatrix(R1,n)
        rk2=rkmatrix(R2,n)
        rkdiffm2=rkdiff(R2,n)
        probthact,counttrueact,countallact=truerank(rk1,rk2,rkdiffm2,n)
        print probthact
        txt="Thiessen-Achari-Analysis "+"\n"
        txt+=60*"="+"\n"
        txt+="Ranks "+"\n"
        txt+="rank-series 1 "
        for i in range(0,n):
            txt+=str(R1[i])+", "
        txt+="\n"    
        txt+="rank-series 2 "
        for i in range(0,n):
            txt+=str(R2[i])+", "
        txt+=2*"\n"
        txt+="Spearman correlation "+"\n"
        txt+="Spearman correlation coefficient: "+str(rspear)+"\n"
        txt+="Spearman, two sided prob:         "+str(prspear)+2*"\n"
        txt+="Thiessen-Achari-probability, assuming rank-series 2 is to be tested "+"\n"
        txt+="delta rankdiff"+"\t"+"count_all "+"\t"+ "count_true "+"\t"+"probability"+"\n"
        txt+=55*"-"+"\n"
        for i in range(0,n):
            txt+=str(i)+2*"\t"+str(countallact[i])+1*"\t"+str(counttrueact[i])+"\t"+str(round(probthact[i],3))+"\n"
        txt+="\n"
        # Graphhic
        names=[]
        for i in range(0,n):
            names.append(str(i))
        app1=raioop2.brggraph5(hf,names,"red",2,probthact,0,n)
        app1.ausgabe()
        button_show_matrices.config(state="active")
    else:
        lbmessage.config(text="Length of the two rank-lists differ. Please check ")
        button_show_matrices.config(state="disabled")
        txt="+++ Sorry, there is an error +++, \nprobably different length of rank-lists" +"\n"
        n=0
    tresults.insert("end",txt)
    
                           
def show_inter():
    #brg 29.1.2013
    tpmatrices=Tkinter.Toplevel(hf)
    tpmatrices.title('interim resuls ')
    txtm="Matrices "+"\n"
    txtm=">= (1), else (-1) - matrix 1"+"\n"
    for i in range(0,n):
        for j in range(0,n):
            txtm+=str(rk1[i][j])+"\t"
        txtm+="\n"
    txtm+=2*"\n"
    txtm=">= (1), else (-1) - matrix 2"+"\n"
    for i in range(0,n):
        for j in range(0,n):
            txtm+=str(rk2[i][j])+"\t"
        txtm+="\n"
    txtm+=2*"\n"
    txtm+="rank differences of rank series 2"+"\n"
    for i in range(0,n):
        for j in range(0,n):
            txtm+=str(rkdiffm2[i][j])+"\t"
        txtm+="\n"
    txtm+="\n"
    tmatrices=ScrolledText(tpmatrices,width=60,height=20)
    tmatrices.pack()
    tmatrices.insert("end",txtm)

def HD():
    # brg 29.1.2013, taken from HDsimpl and modified
    global cov
    dm=rmod2.marray(n,2)
    for i in range(0,n):
        dm[i][0]=R1[i]
        dm[i][1]=R2[i]

    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    
    prop=["R1","R2"]
    k=2
            
    obj=[]
    for i in range(0,n):
        obj.append(str(i))

    rred,xred,objred,txt,neq=rmod2.equivcompactm(n,k,dm,obj)  
    
    #
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    # Incomparabilities
    U = 0
    for i in range(0,n):
        for j in range(0,n):
            if zeta[i][j]==0 and zeta[j][i]==0:
                U+=0.5
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    if rred>70:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram  ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.create_text(100,actheight-20,text="incomparabilities= "+str(U))
        cv.pack()  
    buttcov=Tkinter.Button(hfhd2,text="show cover relations ",width=30,command=show_cov)
    buttcov.pack()
                           
def show_cov():
    """Cover-matrix is displayed"""
    #brg 28.12.07, 30.1.2013
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: interval8.py
    hfcover=Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    
    lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,n):
        txt3+="\n"+str(i)+":\t"
        txt3+="is covered by "
        for j in range(0,n):
            if i!=j:
                if cov[i][j]==1:
                    txt3+=" "+str(j)+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)
    


hf=Tkinter.Tk()
hf.title(" GUI probTh ")
aboutth=raioop2.brgabout(hf,"tp1","about_probth.txt",2,\
            "January, 29th, 2013"," about probth ", "white", "t1",120,5,ScrolledText)
helpth=raioop2.brgabout(hf,"tp1","help_probth.txt",2,\
            "January,29th, 2013"," help_probth ", "white", "t1",120,10,ScrolledText)
    
lb1=Tkinter.Label(hf,text="Enter first the ranks of series 1 \n then the ranks of series 2\nRanks of series 2 are tested against ranks of series 1 ")
lb1.pack()
erank1=Tkinter.Entry(hf,width=20)
erank1.pack(pady=5)
erank2=Tkinter.Entry(hf,width=20)
erank2.pack()
lbmessage=Tkinter.Label(hf,text="")
lbmessage.pack()
buttcalc=Tkinter.Button(hf,text="Calculate probabilities ", bg="cyan",width=30, command=calc)
buttcalc.pack()
button_show_matrices=Tkinter.Button(hf,text="Show interim results ",width=30, command=show_inter)
button_show_matrices.pack(pady=5)
buttHD=Tkinter.Button(hf,text="Hassediagram of the two ranks combined",bg="cyan",width=30,command=HD)
buttHD.pack()                      
buttexit=Tkinter.Button(hf,text="  exit  ",bg="red",bd=3,command=hf.destroy)
buttexit.pack(pady=5)
                                     
hf.mainloop()                                           
