#prom6.py 
# Programm for a variant of PROMETHEE
# see the preliminary steps promethee6.py
# Basis of the GUI is taken from Disco2.py

#Now with Tkinter
# 17.4.08
# 23.5.08 Correction vecgentext in vecgentext1
# 26.5.08 Implemented preview-command
# 8.12.2010: Rearrangement concerning a better fit to laptop formats
# 22-10-2011 cosmetics
# 8.11.2014: Calculations restricted to the representative elements only
# as well as to all elements.

import rmod2
import raioop2
import Tkinter
import Canvas
from ScrolledText import *
import tkFileDialog

def preview():
    # brg 23.5.08, am 26.5. von Disco2 auf Prom6 uebertragen
    
    tpprev=Tkinter.Toplevel(hf)
    tfileprev=ScrolledText(tpprev,width=60,height=4)
    tfileprev.pack()
    fn=tkFileDialog.askopenfilename()
    global dm,ob,pro,r
    dm,ob,pro,r,k=rmod2.EXCELreadin6(fn)
    
    
    txt1="\n"
    txt1+="\n "+str(r)+"  objects\n"
    txt1+="\n "+str(k)+"  attributes\n"
    txt1+="\n========================= \n"
    for i in range(0,r):
        txt1+=str(i)+":"+ob[i+1]+",\n"
    txt1+="\n\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=str(j)+":"+pro[j+1]+",\n"
    txt2+="\n\n"
    txt3="\n"
    txt3+="\n Sorry, even if this is the correct matrix "
    txt3+="\n you must once again select and open the file, "
    txt3+="\n after selecting the weights and the qk-values."
    txt3+="\n  - - -  end of file - - - "
    
    txt=txt1+txt2+txt3
    tfileprev.insert("end",txt)

def scheme():
    """ scheme of one Promethee-function """
    #brg  17.4.08, 17.10.09
    #*:ArithmeticError 17.4.08
    #akt: 17.10.09
    tps=Tkinter.Toplevel(hf)
    tps.title(' promethee functional scheme ')
    cvs=Tkinter.Canvas(tps, width=200,height=200)
    line1=cvs.create_line(20,170,20,30,arrow="last")
    line2=cvs.create_line(20,170,190,170,arrow="last")
    line3=cvs.create_line(20,170,50,170,fill="red",width=2)
    line4=cvs.create_line(50,170,120,100,fill="red",width=2)
    line5=cvs.create_line(120,100,170,100,fill="red",width=2)
    line6=cvs.create_line(50,170,50,180)
    line7=cvs.create_line(120,100,120,180)
    text1=cvs.create_text(50,190,text="low qk ")
    text2=cvs.create_text(115,190, text="high qk ")
    text3=cvs.create_text(170,190,text="k_th attr.")
    text4=cvs.create_text(30, 10,text=" transform")
    cvs.pack()
    

def how_many_attributes():
    """read in how many weights, qk (low and high) """
    global k
    k = int(ek.get())
    global egew, eqk1, eqk2
    egew=rmod2.vecgen1(k)
    eqk1=rmod2.vecgen1(k)
    eqk2=rmod2.vecgen1(k)

    scheme()
    

    lbgew1.config(text=" weights for  "+str(k)+"  attributes")
    for j in range(0,k):
        egew[j]=Tkinter.Entry(frinput3,width=4)
        egew[j].grid(row=2,column=j)

    lbgew2.config(text=" low qk for  "+str(k)+"  attributes")
    for j in range(0,k):
        eqk1[j]=Tkinter.Entry(frinput3,width=4)
        eqk1[j].grid(row=3,column=j)

    lbgew3.config(text=" high qk for  "+str(k)+"  attributes")
    for j in range(0,k):
        eqk2[j]=Tkinter.Entry(frinput3,width=4)
        eqk2[j].grid(row=4,column=j)
    
def confirm_weights():
    """read in weights """
    #brg 22.3.08 , 23.3.08
    global g
    g=rmod2.vecgen1(k)
    gsum=0
    txtw=""
    for j in range(0,k):
        g[j]=float(egew[j].get())
        gsum+=g[j]
    if gsum!=1.0 and gsum!=0:
        for j in range(0,k):
            g[j]=g[j]/gsum
        txtw=" +++note: renormalized! +++"
    elif gsum>0.9999 and gsum<1.0001:
        txtw="weights: ok"
    else:
        txtw="+++please control the weights +++"
    lbconfirm1.config(text=str(k)+" weights read in, "+txtw,bg="yellow")     

def confirm_lowqk():
    """read in qk1 """
    #brg 22.3.08 , 23.3.08
    global qk1
    qk1=rmod2.vecgen1(k)
    
    txtw=""
    for j in range(0,k):
        qk1[j]=float(eqk1[j].get())
    lbconfirm2.config(text=str(k)+" low qk read in, "+txtw,bg="yellow")

def confirm_highqk():
    """read in qk2 """
    #brg 22.3.08 , 23.3.08
    global qk2
    qk2=rmod2.vecgen1(k)
    
    txtw=""
    for j in range(0,k):
        qk2[j]=float(eqk2[j].get())
    lbconfirm3.config(text=str(k)+" high qk read in, "+txtw,bg="yellow")

def fselectopencalcrepresenobjects():
    """ File selection and opening by Tkinter-Standards"""
    #*13.1.08
    #akt: 13.1.08
    #note: There may be conflicts with other moduls
    #source:-
    tp=Tkinter.Toplevel(hf)
    global fn
    fn=tkFileDialog.askopenfilename()
    global dm,ob,pro,r
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    obj=rmod2.vecgen1(r)
    for i in range(0,r):
        obj[i]=ob[i+1]
    rred, xred,objred,exlist,eqm=rmod2.equivcompactgr(r,k,dm,obj)

    lbfile=Tkinter.Label(tp,text="selected file : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns")
    lbfile.pack()
    
              
    fl1,fl2,qres=rmod2.prom(rred,k,xred,qk1,qk2,g)
    totalfl=rmod2.vecgen1(rred)
    
    for i in range(0,rred):
        totalfl[i]=fl1[i]-fl2[i]
        
    
    txtg=""
    txtqk1=""
    txtqk2=""
    txtobj=""
    txtfl1=""
    txtfl2=""
    txttotalfl=""
    for j in range(0,k):
        txtg+=str(round(g[j],3))+",  "
        txtqk1+=str(round(qk1[j],3))+" ,  "
        txtqk2+=str(round(qk2[j],3))+" ,  "
    for i2 in range(0,rred):
        txtobj+=objred[i2]+"\t"
        txtfl1+=str(round(fl1[i2],2))+"\t"
        txtfl2+=str(round(fl2[i2],2))+"\t" 
        txttotalfl+=str(round(totalfl[i2],2))+"\t"
                   
                   
    tpred=Tkinter.Toplevel(hf,width=60,height=25)    
    tpromred=ScrolledText(tpred,width=60,height=20)
    tpromred.pack()
    txtprom="\n"
    txtprom+="\n Results of PROMETHEE - Analysis: Representative elements "
    txtprom+="\n --- weights and qk ---"
    txtprom+="\n weight-vector: "+txtg
    txtprom+="\n low qk-vector: "+txtqk1
    txtprom+="\n high qk-vector: "+txtqk2
    txtprom+="\n Flows: first line: Dominances, second line subdominances "
    txtprom+="\n Totalflow: : third line "                    
    txtprom+="\n "+txtobj
    txtprom+="\n"+50*"-"
    txtprom+="\n"+ txtfl1
    txtprom+="\n"
    txtprom+="\n"+ txtfl2
    txtprom+="\n"
    txtprom+="\n"+ txttotalfl
    txtprom+="\n"
    txtprom+="  - - -  end of file  - - - "
    
    tpromred.insert("end",txtprom)

    # Ranking due to totalflow =dom - subdom
    
    
        

    
def fselectopencalcallobjects():
    """ File selection and opening by Tkinter-Standards"""
    #*13.1.08
    #akt: 13.1.08
    #note: There may be conflicts with other moduls
    #source:-
    tp=Tkinter.Toplevel(hf)
    global fn
    fn=tkFileDialog.askopenfilename()
    global dm,ob,pro,r,totalflow1
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    

    lbfile=Tkinter.Label(tp,text="selected file : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns")
    lbfile.pack()
    
              
    fl1,fl2,qres=rmod2.prom(r,k,dm,qk1,qk2,g)
    obj=rmod2.vecgen1(r)
    for i in range(0,r):
        obj[i]=ob[i+1]
    txtg=""
    txtqk1=""
    txtqk2=""
    txtobj=""
    txtfl1=""
    txtfl2=""
    for i in range(0,k):
        txtg+=str(round(g[i],3))+",  "
        txtqk1+=str(round(qk1[i],3))+" ,  "
        txtqk2+=str(round(qk2[i],3))+" ,  "
    for j in range(0,r):
        txtobj+=obj[j]+"\t"
        txtfl1+=str(round(fl1[j],2))+"\t"
        txtfl2+=str(round(fl2[j],2))+"\t" 
    
                   
                   
    tp=Tkinter.Toplevel(hf,width=60,height=25)    
    tprom=ScrolledText(tp,width=60,height=20)
    tprom.pack()
    txtprom="\n"
    txtprom+="\n Results of PROMETHEE - Analysis: all objects "
    txtprom+="\n --- weights and qk ---"
    txtprom+="\n weight-vector: "+txtg
    txtprom+="\n low qk-vector: "+txtqk1
    txtprom+="\n high qk-vector: "+txtqk2
    txtprom+="\n Flows: first line: Dominances, second line subdominances "
    txtprom+="\n "+txtobj
    txtprom+="\n"+50*"-"
    txtprom+="\n"+ txtfl1
    txtprom+="\n"
    txtprom+="\n"+ txtfl2
    txtprom+="\n"
    txtprom+="  - - -  end of file  - - - "
    
    tprom.insert("end",txtprom)

    # Ranking due to totalflow =dom - subdom
    
    totalflow=rmod2.vecgen1(r)
    txttfl=""
    totalflow1=[]
    for i in range(0,r):
        totalflow[i]=fl1[i]-fl2[i]
        totalflow1.append(fl1[i]-fl2[i])
        txttfl+=str(round(totalflow[i],2))+"\t"
        
    tfl,nfl=rmod2.raisort(r,totalflow)    
    txtsortobj=""
    for i in range(0,r):
        txtsortobj+=obj[nfl[i]]+"\t"
        
    tp2=Tkinter.Toplevel(hf,width=60,height=10)
    tprom2=ScrolledText(tp2,width=60,height=10)
    tprom2.pack()
    txtprom2="\n"
    txtprom2+="\n Totalflow = Dominance - Subdominance  "
    txtprom2+="\n"+100*"-"
    txtprom2+="\n"+txtobj
    txtprom2+="\n"+txttfl
    txtprom2+="\n\n Sorted after totalflow (left to right: increasing values)"
    txtprom2+="\n"+txtsortobj
    txtprom2+="\n"+100*"-"
    tprom2.insert("end",txtprom2)
    
    
    
        
    
    # HD
    hfhd3=Tkinter.Toplevel(hf)
    #hfhd2.title('Hasse diagram or cover matrix ')
    freq2=Tkinter.Frame(hfhd3,width=300,height=300)
    freq2.pack()
    
    dm2=rmod2.marray(r,2)
    k2=2
    for i in range(0,r):
        dm2[i][0]=fl1[i]
        dm2[i][1]=qres[i]
    
    
    
    #############################dieser Teil ist neu 21.12.07
    rred2,xred2,objred2,txt=rmod2.equivcompact(r,k2,dm2,obj)    
    ###############################################################
    nr=rred2
    labeq=Tkinter.Label(freq2,text=" calc. is based on representants ")
    labeq.config(bg="yellow")
    labeq.pack()

    #
    zetahilf=rmod2.comp(nr,k2,xred2)
    zeta=rmod2.marray(nr,nr)  #n or rred2 --> nr
    for i in range(0,nr):
        for j in range(0,nr):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    lbhd1=Tkinter.Label(freq2,text= "Level ")
    lbhd1.pack()

    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(nr,zeta)
    #print "zzmax = ",zzmax
    tlev=ScrolledText(freq2,width=60,height=4)
    tlev.pack()
    txt1="\n"
    
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= objred2[lobj[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)

    txt2="\n One linear extension \n\n"
    for i in range(0,nr):
        if i<nr-1:
            txt2+=objred2[revlext[i]]+" < "
        else:
            txt2+=objred2[revlext[i]]+"\n"
    txt2+="\n"
    txt2+="\n -- end of list -- "
    tlinext=ScrolledText(freq2,width=60, height=2)
    tlinext.pack()
    tlinext.insert("end",txt2)
    
    #Adj-Listen

    adjc=rmod2.adjacent(nr,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(nr,adjc,lext)
       
    
    zeta2=rmod2.cover(nr,tr,lext)
    if nr>100:  #changed 22.10.2011
        lbhd2=Tkinter.Label(freq2,text=" graphical presentation not meaningful, see levels and cover-matrix ")
        lbhd2.pack()
        txt3="\n cover-matrix  \n"
        for i in range(0,nr):
            txt3+="\t"+objred2[i]+"\t"
        txt3+="\n"
        for i in range(0,nr):
            txt3+=objred2[i]+" :"
            for j in range(0,nr):
                txt3+=str(zeta2[i][j])+"\t"
            txt3+="\n"
        txt3+=" -- end of list --"
        tcov=ScrolledText(freq2,width=60, height=10)
        tcov.pack()
        tcov.insert("end",txt3)
    else:
        lbhd3=Tkinter.Label(freq2,text=" Hasse Diagram based on the dominance and subdominance ")
        lbhd3.pack()
        cv=Tkinter.Canvas(freq2,width=400,height=350,bg="white") #changed 22.10.2011
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(nr,nr)
        geomy=rmod2.marray(nr,nr)

        geom0x=10
        geom0y=20
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(320.0/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(320.0/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if zeta2[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred2[lobj[i][j]])
        garrow1x=380
        garrow1y=20
        garrow2y=190
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
##        cv.create_line(garrow1x-4,garrow2y-4,garrow1x,garrow2y)
##        cv.create_line(garrow1x+4,garrow2y-4,garrow1x,garrow2y)
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.create_text(60,340,text="weights: " + txtg)
        
        cv.pack()
        tpcv=Tkinter.Toplevel(hf,width=60,height=30)
        tpcv.title(' cover relations of the Promethee orders ')
        lbhd2=Tkinter.Label(tpcv,text="  cover-matrix  of the promethee orders ")
        lbhd2.pack()
        txt3="\n cover-matrix  \n"
        txt3+="\t"
        for i in range(0,nr):
            txt3+=objred2[i]+"\t"
        txt3+="\n"
        for i in range(0,nr):
            txt3+=objred2[i]+" :\t"
            for j in range(0,nr):
                txt3+=str(zeta2[i][j])+"\t"
            txt3+="\n"
        txt3+=" -- end of list --"
        tcv=ScrolledText(tpcv,width=60, height=10)
        tcv.pack()
        tcv.insert("end",txt3)

         
def showDM():
    """ New routine : shows the data matrix """
    #Brg 13.1.08
    tp2=Tkinter.Toplevel(hf)
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+ob[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+pro[j+1]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=pro[j+1]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=ob[i+1]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)


def HDorigDM():
    "based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"
    # Brg 20.12.07, 28.12.07
    # If the number of representants > 40 then only the cover-matrix and the level-population
    # Note, this is the HD of the original data matrix
    global zeta2,n,objred    
    hfhd2=Tkinter.Toplevel(hf)
    #hfhd2.title('Hasse diagram or cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    global fn
    #dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    rred,xred,objred,obj,prop,txt=filecomp(r,dm,pro,fn)
    n=rred
    labeq=Tkinter.Label(freq,text="file = "+fn+": calc. is based on representants ")
    labeq.config(bg="yellow")
    labeq.pack()

    #
    zetahilf=rmod2.comp(n,k,xred)
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    lbhd1=Tkinter.Label(freq,text= "Level ")
    lbhd1.pack()

    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(n,zeta)
    #print "zzmax = ",zzmax
    tlev=ScrolledText(freq,width=60,height=4)
    tlev.pack()
    txt1="\n"
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= objred[lobj[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)

    txt2="\n One linear extension \n\n"
    for i in range(0,n):
        if i<n-1:
            txt2+=objred[revlext[i]]+" < "
        else:
            txt2+=objred[revlext[i]]+"\n"
    txt2+="\n"
    txt2+="\n -- end of list -- "
    tlinext=ScrolledText(freq,width=60, height=2)
    tlinext.pack()
    tlinext.insert("end",txt2)
    
    #Adj-Listen

    adjc=rmod2.adjacent(n,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(n,adjc,lext)
       
    
    zeta2=rmod2.cover(n,tr,lext)
    if n>200:
        lbhd2=Tkinter.Label(freq,text=" graphical presentation not meaningful, see levels and cover-matrix ")
        lbhd2.pack()
        txt3="\n cover-matrix  \n"
        for i in range(0,n):
            txt3+="\t"+objred[i]+"\t"
        txt3+="\n"
        for i in range(0,n):
            txt3+=objred[i]+" :"
            for j in range(0,n):
                txt3+=str(zeta2[i][j])+"\t"
            txt3+="\n"
        txt3+=" -- end of list --"
        tcov=ScrolledText(freq,width=60, height=4)
        tcov.pack()
        tcov.insert("end",txt3)
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram of File "+fn)
        lbhd3.pack()
        cv=Tkinter.Canvas(freq,width=300,height=200)
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(n,n)
        geomy=rmod2.marray(n,n)

        geom0x=10
        geom0y=20
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(160.0/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(160.0/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if zeta2[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        garrow1x=210
        garrow1y=20
        garrow2y=190
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
##        cv.create_line(garrow1x-4,garrow2y-4,garrow1x,garrow2y)
##        cv.create_line(garrow1x+4,garrow2y-4,garrow1x,garrow2y)
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.pack()
        buttcover=Tkinter.Button(freq,text="show cover relation",command=cover_show)
        buttcover.pack()

def cover_show():
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: -
    hfcover=Tkinter.Toplevel(hf)
    #hfcover.title(' cover-matrix ')
    
    lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,n):
        txt3+="\n"+objred[i]+":\t"
        txt3+="is cover_less than "
        for j in range(0,n):
            if i!=j:
                if zeta2[i][j]==1:
                    txt3+=" "+objred[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=4)
    tcov.pack()
    tcov.insert("end",txt3)

def save_relat():
    # Brg taken from Electresimpl 13.10.2014
    # 27.12.2014
    dmtotalflow = rmod2.marray(r,2)
    for i in range(0,r):
        dmtotalflow[i][0]=totalflow1[i]
        dmtotalflow[i][1]=totalflow1[i]
    relathilf=rmod2.comp(r,2,dmtotalflow)  #zeta matrix with col<row
    relat=rmod2.marray(r,r)
    for i1 in range(0,r):  #however we need for the 'normal' presentation: row < col. Transposition
        for i2 in range(0,r):
            relat[i1][i2]=relathilf[i2][i1]
        
    fnrelat=tkFileDialog.asksaveasfilename(parent=hf,title="save relation-files in PyHasseformat")
    try:
        fcsv=open(fnrelat,"w")
        fcsv.write(str(r)+"\n")
        for i1 in range(0,r):
            for i2 in range(0,r):
                fcsv.write(str(relat[i1][i2])+"\t")
            fcsv.write("\n")
        fcsv.close()
        flag=1
    except:
        flag=0

    if flag==1:
        lbsave.config(text="successfull",bg="yellow")
    else:
        lbsave.config(text="+++not successfull +++",bg="red")






def raihelp():
    """ Help about promethee """
    
    #  brg 22.3.08, 23.3.08 aus Disco2: 17.4.08, 18.4.08, 26.5.08, 11.10.08
    
    scheme()
    
    


def about():
    """About prom6.py """
    #brg: 22.3.08, 17.4.08, 11.10.08
    hfabout=Tkinter.Toplevel(hf,width=60, height=4)
    txt1="Brans,J.P. and P.H.Vincke, 1985. A Preference Ranking Organisation Method \
(The PROMETHEE Method for Multiple Criteria Decision - Making). Management Science 31: 647-656."
    txt2="Brans,J.P., P.H.Vincke, and B.Mareschal, 1986. How to select and how to \
rank projects: The PROMETHEE method. European Journ. Oper. Research 24: 228-238."
    txt3="Brans,J.P. and B.Mareschal, 1994. The PROMCALC & GAIA decision support system \
for multicriteria decision aid. Decision support systems 12: 297-310."
    txt4="Example of Application "
    txt5="Drechsler,M., 2004. Model-based conservation decision aiding in the presence \
of goal conflicts and uncertainty. Biodiversity and Conservation 13: 141-164."
    txt6="Simon,U., R.Bruggemann, and S.Pudenz, 2004. Aspects of decision support \
in water management - example Berlin and Potsdam (Germany) I - spatially differentiated \
evaluation. Wat. Res. 38: 1809-1816."
    txt6=" Program written by Bruggemann,R., vs of 8.11.14 "
    lbabout=Tkinter.Label(hfabout,bg="white",text=" About ...")
    lbabout.pack()
    tabout=ScrolledText(hfabout, width=60, height=20)
    txtabout="\n"+txt6+"\n\n"+txt1+"\n"+txt2+"\n"+txt3+"\n"+txt4+"\n"+txt5+"\n"
    txtabout+="\n  - - -  end  of  file  - - - "
    tabout.insert("end",txtabout)
    tabout.pack()

def filecomp(r,dm,pro,fn):
    """ reduces a dm with equiv objects to a dm of a quotient set """
    # Brg 12.12.07, 13.1.08, 23.5.08
    #r,k,dm,ob,pro,fn are globals and should be available after open
    
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    #recoding ob to obj and pro to prop
    if r==0:
        hfwarning=Tkinter.Toplevel(hf)
        frwarning=Tkinter.Frame(hfwarning,width=10,height=3)
        frwarning.pack()
        bwarning=Tkinter.Button(frwarning,text="++warning ++",command=msgwarning)
        bwarning.pack()
        
    prop=rmod2.vecgentext1(k)
    obj=rmod2.vecgentext1(r)    #changed 23.5.08
    for i in range(0,k):
        prop[i]=pro[i+1]
    for i in range(0,r):
        obj[i]=ob[i+1]
    #############################dieser Teil ist neu 21.12.07
    rred,xred,objred,txt=rmod2.equivcompact(r,k,dm,obj)    
    ###############################################################
    #print objred
    #print "reduzierte matrix"
    #rmod2.matout(rred,k,xred)
    return rred,xred,objred,obj,prop,txt           
    

    



hf=Tkinter.Tk()
hf.title('     promethee      ')
helpprom=raioop2.brgabout(hf,"tp1","help_prom.txt",7,\
            "Dec. the 8th,2010 "," help_promethee ", "white", "t1",120,10,ScrolledText)
widthgui = 40    
frmain=Tkinter.Frame(hf,width=200,height=10)
frmain.pack()
lbgeom=Tkinter.Label(frmain,text="                                                               ")
lbgeom.pack()
butthelp=Tkinter.Button(frmain,text="help_transformation function",width=30,bg="green",command=raihelp)
butthelp.pack(pady=10)
buttabout=Tkinter.Button(frmain,text="about",bg="green",width=30,command=about)
buttabout.pack(pady=5)

buttpreview=Tkinter.Button(frmain, text="preview",width=widthgui,command=preview)
buttpreview.pack(pady=5)
frinput=Tkinter.Frame(frmain,width=widthgui,height=10)
frinput.pack()

frinput2=Tkinter.Frame(frmain,width=widthgui,height=10)
frinput2.pack()
lb_how_many_weights=Tkinter.Label(frinput2,text="how many attributes ")
lb_how_many_weights.pack(side="left")
ek=Tkinter.Entry(frinput2,width=3)
ek.pack(side="left")
butt1=Tkinter.Button(frmain,text="confirm, open fields \nfor the weights and qk",width=widthgui,bg="cyan",command=how_many_attributes)
butt1.pack()
lbgew1=Tkinter.Label(frmain,text="")
lbgew1.pack()
lbgew2=Tkinter.Label(frmain,text="")
lbgew2.pack()
lbgew3=Tkinter.Label(frmain,text="")
lbgew3.pack()
frinput3=Tkinter.Frame(frmain,width=2*widthgui,height=10,relief="groove",bd=2)
frinput3.pack()

butt2=Tkinter.Button(frmain,text="confirm weights ",width=widthgui,bg="cyan",command=confirm_weights)
butt2.pack()
lbconfirm1=Tkinter.Label(frmain,text="")
lbconfirm1.pack()
butt3=Tkinter.Button(frmain,text="confirm low qk ",bg="cyan",width=widthgui,command=confirm_lowqk)
butt3.pack()
lbconfirm2=Tkinter.Label(frmain,text="")
lbconfirm2.pack()
butt4=Tkinter.Button(frmain,text="confirm high qk ",bg="cyan",width=widthgui,command=confirm_highqk)
butt4.pack()
lbconfirm3=Tkinter.Label(frmain,text="")
lbconfirm3.pack()

buttfile=Tkinter.Button(frmain,text="Select, open file and calc (all objects)",width=widthgui,\
                        bg="cyan",bd=2,command=fselectopencalcallobjects)
buttfile.pack(pady=10)
buttfile2=Tkinter.Button(frmain,text="Select, open file and calc (represent. elements)",width=widthgui,\
                         bg="cyan",bd=2,command=fselectopencalcrepresenobjects)
buttfile2.pack(pady=2)

buttshow=Tkinter.Button(frmain,text="show data matrix ",width=widthgui,command=showDM)
buttshow.pack()
buttHD=Tkinter.Button(frmain,text=" Hasse diagram of orig. DM", width=widthgui,command=HDorigDM)
buttHD.pack(pady=10)
buttsave=Tkinter.Button(frmain,text="Save relation matrix based on totalflow",width=widthgui,bg="cyan",command=save_relat)
buttsave.pack()
lbsave=Tkinter.Label(frmain,text="")
lbsave.pack()
buttexit=Tkinter.Button(frmain,text=" exit ",bg="red",bd=4,width=widthgui,command=hf.destroy)
buttexit.pack(pady=10)
hf.mainloop()



