# Random generation of dms
# brg 15.9.09, 16.9.09
# The dms can be directly read by mainHD16 and avrank4.py.
# They correspond to EXCEL - tab-format
# 23.9.09 As support module in PyHasse
# 17.10.09 More flexibility in search for folders


import rmod2
import raioop2
import random
import Tkinter
from ScrolledText import *
from tkFileDialog import askdirectory


import os

def showDM():
    """ New routine : shows the data matrix """
    #Brg 13.1.08, 23.9.09 (taken from palg4.py)
    # 23.9.09  modified
    tp2=Tkinter.Toplevel(hf)
    tp2.title('showDM')
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,n):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,m):
        txt2+=" "+att[j]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,m):
        txt3+=att[j]+"\t"
    txt3+="\n"    
    for i in range(0,n):
        txt3+=obj[i]+"\t"
        for j in range(0,m):
            txt3+=str(round(dmn[i][j],2))+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)

def selectfn():
    global fn,dir1
    try:
        fn=efn.get()
    except:
        fn="z"+str(random.randint(1,10))
    fn+=".txt"
    dir1=askdirectory(parent=hf,title="select a folder",mustexist=1)
    dir1=dir1+"/"
    
def savedm():
    print "dir1 = ",dir1
    print "filename = ",fn
    rmod2.raiwritematrix(dir1,fn,dmn,n,m)
    lbsave.config(text="dm will be stored in: "+dir1+"  name is : "+fn,bg="yellow")

def parameter():
    #brg 23.09.09
    global n_min,n_max,m_min,m_max

    try:
        n_min=int(enmin.get())
    except:
        n_min=10
    try:
        n_max=int(enmax.get())
    except:
        n_max=30
    try:
        m_min=int(emmin.get())
    except:
        m_min=2
    try:
        m_max=int(emmax.get())
    except:
        m_max=5
    labinfo.config(text="n_min="+str(n_min)+"\nn_max="+str(n_max)+"\nm_min="+str(m_min)+\
                   "\nm_max="+str(m_max),bg="yellow")
    
def calc():
    global n,m,dmn,att,obj,dmnchar
    n=random.randint(n_min,n_max)
    m=random.randint(m_min,m_max)
    dm=rmod2.marray(n,m)
    obj=rmod2.vecgen1(n)
    att=rmod2.vecgen1(m)
 
    for i in range(0,n):
        obj[i]=str(i)
        for j in range(0,m):
            dm[i][j]=random.randint(0,20)

    for j in range(0,m):
        att[j]="q"+str(j)

    labcalc.config(text="actual sel. n "+str(n)+"  actual sel. m "+str(m),bg="yellow")
    

    dmn=rmod2.matrixnorm(n,m,dm)
    dmnchar=rmod2.matrixchar(n,m,dmn)
    

def show():
    tpshow=Tkinter.Toplevel(hf)
    tpshow.title('characteristics of dm (normalized ')
    tshow=ScrolledText(tpshow,width=60,height=10)
    tshow.pack()
    txt=" Characteristics of randomly generated dm "
    txt+="\n"+60*"="+"\n"
    txt+="mean-values of normalized dm\n"
    for j in range(0,m):
        txt+=str(round(dmnchar[2][j],2))+"\t"
    txt+="\n"    

    txt+="std of normalized dm\n"
    for j in range(0,m):
        txt+=str(round(dmnchar[3][j],2))+"\t"
    txt+="\n"
    txt+="   -  -  - E O F -   -    - "
    tshow.insert("end",txt)
    

def geomHD(zv, levm,zlev):
    """ from zv the graphical control for HDs is derived """
    #zv is the number of vertices
    # levm is the number of vertices in the maximal level (determines the x coord
    # zlev is the number of levels, determines the y coord
    # * Brg 10.6.08
    # akt: 29.5.09
    # brg 10.6.08, 29.5.09
    # taken from interval4.py
    awidth=zv*40
    aheight=zv*40
    if awidth<120:
        awidth=120
    if awidth>600:
        awidth=600
    if aheight<120:
        aheight=120
    if aheight>600:
        aheight=600
    
    #aheight and awidth: extent of canvas
    fx = int((awidth-40))
    fy = int((aheight-40))
    g0x=5   #Start of the HD-area x
    g0y=20   #Start of the HD-area y
    garr1x=fx +10.0  #location of the arrow
    garr1y=20
    garr2y=fy+10.0
    return awidth,aheight,fx,fy,g0x,g0y,garr1x,garr1y,garr2y     

def HD():
    #Brg  23.09.2009
    ################################################################
    rred,xred,objred,txtquot=rmod2.equivcompact(n,m,dmn,obj)    
    ################################################################
    # routine taken from discretiz1.py
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    
    tpeqorig=Tkinter.Toplevel(hf)
    tpeqorig.title(' equivalence classes of the original DM ')
    teqorig=ScrolledText(tpeqorig,width=60,height=5)
    teqorig.pack()
    teqorig.insert("end",txtquot)
    #
    zetahilf=rmod2.comp(rred,m,xred)
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    lbhd1=Tkinter.Label(freq,text= "Level ")
    lbhd1.pack()

    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
    #print "zzmax = ",zzmax
    tlev=ScrolledText(freq,width=60,height=4)
    tlev.pack()
    txt1="\n"
    levmax=-10**20
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
    tpbasic2=Tkinter.Toplevel(hf)
    tpbasic2.title(' basic characteristics of the orig HD ')
    lbbasic2=Tkinter.Label(tpbasic2,text="number of level: \t\t\t"+str(zzmax)+"\n\
number of representants in the largest level:\t "+str(levmax),bd=3,bg="yellow",width=60)
    lbbasic2.pack()
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= objred[lobj[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)

    txt2="\n One linear extension \n\n"
    for i in range(0,rred):
        if i<rred-1:
            txt2+=objred[revlext[i]]+" < "
        else:
            txt2+=objred[revlext[i]]+"\n"
    txt2+="\n"
    txt2+="\n -- end of list -- "
    tlinext=ScrolledText(freq,width=60, height=2)
    tlinext.pack()
    tlinext.insert("end",txt2)
    
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    global zeta2
    zeta2=rmod2.cover(rred,tr,lext)
    
    if rred>50:
        cover_show()                  #20.1.08
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
        factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=geomHD(rred,levmax,zzmax)

        
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)
     
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(factory/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if zeta2[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.pack()
       


hf=Tkinter.Tk()
aboutrandomdm=raioop2.brgabout(hf,"tp1","about_rd.txt",2,\
            "September, the 23rd,2009"," about_rd ", "white", "t1",120,5,ScrolledText)
helprandomrd=raioop2.brgabout(hf,"tp1","help_rd.txt",2,\
            "September, the 23rd,2009"," help_rd ", "white", "t1",120,5,ScrolledText)
        
frinput=Tkinter.Frame(hf,relief="sunken",bd=3)
frinput.pack(pady=5)
lb0=Tkinter.Label(frinput,text="Interval for number of objects n")
lb1=Tkinter.Label(frinput,text="n_min = ")
enmin=Tkinter.Entry(frinput,width=3)
lb2=Tkinter.Label(frinput,text=" < n < ")
enmax=Tkinter.Entry(frinput,width=3)
lb3=Tkinter.Label(frinput,text=" = n_max ")
lb0.grid(row=0,columnspan=3)
lb1.grid(row=1,column=0)
enmin.grid(row=1,column=1)
lb2.grid(row=1,column=2)
enmax.grid(row=1,column=3)
lb3.grid(row=1,column=4)

lb0a=Tkinter.Label(frinput,text="Interval for number of attributes ")
lb1a=Tkinter.Label(frinput,text="m_min = ")
emmin=Tkinter.Entry(frinput,width=3)
lb2a=Tkinter.Label(frinput,text=" < m < ")
emmax=Tkinter.Entry(frinput,width=3)
lb3a=Tkinter.Label(frinput,text=" = m_max ")
lb0a.grid(row=2,columnspan=3)
lb1a.grid(row=3,column=0)
emmin.grid(row=3,column=1)
lb2a.grid(row=3,column=2)
emmax.grid(row=3,column=3)
lb3a.grid(row=3,column=4)
buttsubmit=Tkinter.Button(hf,text="submit parameters",bg="cyan",width=25,command=parameter)
buttsubmit.pack()
labinfo=Tkinter.Label(hf,text=4*"\n")
labinfo.pack()
buttcalc=Tkinter.Button(hf,text="generate random dm ",width=25,bg="cyan",command=calc)
buttcalc.pack()
labcalc=Tkinter.Label(hf,text="")
labcalc.pack()
buttshow=Tkinter.Button(hf,text="show characteristics of dm ",width=25,bg="cyan",command=show)
buttshow.pack()
lbshow=Tkinter.Label(hf,text="")
lbshow.pack()
buttshowdm=Tkinter.Button(hf,text="show dm ",width=25,bg="cyan",command=showDM)
buttshowdm.pack()
buttHD=Tkinter.Button(hf,text="Hasse diagram ",width=25,bg="cyan",command=HD)
buttHD.pack()
frsave=Tkinter.Frame(hf,relief="sunken",bd=3)
frsave.pack()
lbefn=Tkinter.Label(frsave,text="read_in filename (without extension txt) and select folder>>>")
lbefn.grid(row=0,column=0)
efn=Tkinter.Entry(frsave,width=10)
efn.grid(row=0,column=1)

lbsave=Tkinter.Label(hf,text="dm will be stored... ")
lbsave.pack()
buttsel=Tkinter.Button(hf,text=" submit filename and select folder ",width=25,bg="cyan",command=selectfn)
buttsel.pack()
buttsav=Tkinter.Button(hf,text=" submit save-infos ",width=25,bg="cyan",command=savedm)
buttsav.pack()
buttexit=Tkinter.Button(hf,text="  exit  ",bg="red",command=hf.destroy)
buttexit.pack(pady=10)



hf.mainloop()


