import rmod2
import Tkinter
import Canvas
from ScrolledText import *
import random
import raioop2
import tkFileDialog
import psyco

psyco.full()

# 4.3.2010 Rearrangement from version 1 to version 2

def HD(objred,zeta,n, fontsize):
    """based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"""
    # Brg 20.12.07, 28.12.07
    # If the number of representants > 20 then only the cover-matrix and the level-population
    #
        
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    if n<512:   
        lobj,lext,revlext,zzmax=rmod2.levtopsort(n,zeta)
        #print "zzmax = ",zzmax
        
        levmax=-10**20     #20.6.08
        for i in range(0,zzmax):
            if len(lobj[i])>=levmax:
                levmax=len(lobj[i])
        

        #Adj-Listen

        adjc=rmod2.adjacent(n,lext,revlext,zeta)
            
        #Transitive reduced relations
        ts,tr=rmod2.trreduct(n,adjc,lext)
           
        
        cov=rmod2.cover(n,tr,lext)

    
        freq=Tkinter.Frame(hfhd2,width=200,height=300)
        freq.pack()
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(n,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(n,n)
        geomy=rmod2.marray(n,n)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-17,geomy[i][j]+17,geomx[i][j]+17,geomy[i][j]-17,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]],font=("Arial",fontsize))
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")

        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        
        cv.pack()
    else:
        lbsorry=Tkinter.Label(hfhd2,text= "+++ sorry the Hasse diagram is too large \n to be displayed +++",bg="yellow")
        lbsorry.pack()
                              
        
def selopenfile():
    global objred,zetaobj,fn,rred
    fn=tkFileDialog.askopenfilename()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    lb1.config(text="opened "+fn+"\n with "+str(r)+"  rows and "+str(k)+" columns",bg="yellow")
    
    prop=[]
    for j in range(0,k):
        prop.append(pro[j+1])
            
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
    for i in range(0,r):
        obj[i]=ob[i+1]

    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,dm,obj)  
    
    #
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zetaobj=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zetaobj[i][j]=zetahilf[j][i]
    #
    
def findsepsets():
    """ given a listset the procedure findsepset trys to find separated subsets """
    # listset is a consequence of the input of the user
    global pairs, seppairs,sepzahl,powset,zeta,n
    powset=[]   #only a subset of power set
    pair1=[]
    pair2=[]
    z=int(2.0**len(listset))
    clistset=len(listset)
    sublist=rmod2.vecgentext1(z)
    setsublist=[]
    zahlt=0
    lbs.config(text=" ok ",bg="yellow")
    i2=0
    zu=int(z/4.0)
    zo=int(3*z/4.0)
    print "zu = ",zu,"   zo = ",zo
    for i1 in range(zu,zo):
        b=rmod2.bitrep(clistset,i1) #a binary pattern will be generated
        sublist[i1]=[]
        for j in range(0,clistset):   #generating all possible subsets out of listset
            if b[clistset-1-j]==1:
                sublist[i1].append(listset[j])
        
        setsublist.append(set(sublist[i1])) #for the needed set theor. operations: sets are used
        i2+=1   
    zl=len(setsublist)
    print "No of subsets considered ",zl
               
    for i3 in range(0,zl):
        for i4 in range(i3+1,zl):
            if len(setsublist[i3])>0 and len(setsublist[i4])>0 and len(setsublist[i3]& setsublist[i4])==0:
                #print setsublist[i1],"  ",setsublist[i2]
                pair1.append(setsublist[i3])
                pair2.append(setsublist[i4])
                zahlt+=1
    
    for i0 in range(0,zahlt):           #labels for the lattice of subsets of listset
        powset.append(pair1[i0])
        powset.append(pair2[i0])
    zpow=len(powset)
    print "reduced powerset = ",zpow
    
        
    #second part: all elements of both subsets for each pair are checked for comparbaility in the dm-poset
    seppairs=rmod2.marray(zahlt,2)
    zahl2=0
    for i in range(0,zahlt):
        flag=0
        for i1 in pair1[i]:
            for i2 in pair2[i]:
                if zetaobj[i1][i2]!=0 or zetaobj[i2][i1]!=0:
                    flag=1
        if flag==0:
            seppairs[zahl2][0]=pair1[i]
            seppairs[zahl2][1]=pair2[i]
            zahl2+=1
    sepzahl=zahl2
    
            
def showDM():
    """ New routine : shows the data matrix """
    #Brg 13.1.08
    tp2=Tkinter.Toplevel(hf)
    tp2.title(' show DM ')
    lbtp2=Tkinter.Label(tp2,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+ob[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+pro[j+1]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=pro[j+1]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=ob[i+1]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)

def showallpairs():
    tppairs=Tkinter.Toplevel(hf,width=60,height=60)
    tppairs.title('   all pairs  ')
    tpairs=ScrolledText(tppairs,width=60,height=60)
    tpairs.pack()
    txt=str(sepzahl)+" separated subsets \n"
    txt+=60*"="+"\n"
    for i in range(0,sepzahl):
        thilf1=""
        for ix in seppairs[i][0]:
            thilf1+=objred[ix]+","
        thilf2=""
        for iy in seppairs[i][1]:
            thilf2+=objred[iy]+","
        txt+=thilf1+"\t"+"separ. "+thilf2+"\n"
    txt+="\n"
    txt+=" - - -  e o f - - - "
    tpairs.insert("end",txt)
    
def showbestpairs():
    tppairs2=Tkinter.Toplevel(hf,width=60,height=60)
    tppairs2.title('   best pairs  ')
    tpairs2=ScrolledText(tppairs2,width=60,height=10)
    tpairs2.pack()
    txt=str(sepzahl)+" separated subsets \n"
    txt+=60*"="+"\n"
    
    testsep12=rmod2.vecgen1(sepzahl)
    maxsep=0
    for i in range(0,sepzahl):
        test1=len(seppairs[i][0])
        test2=len(seppairs[i][1])
        testsep12[i]=test1*test2
        if testsep12[i]>maxsep:
            maxsep=testsep12[i]
            imax=i
                        
    for i in range(0,sepzahl):
        if maxsep-2<=testsep12[i]<=maxsep:
            thilf1=""
            for ix in seppairs[i][0]:
                thilf1+=objred[ix]+","
            thilf2=""
            for iy in seppairs[i][1]:
                thilf2+=objred[iy]+","
            txt+=str(testsep12[i])+": "+thilf1+"\t"+"separ. "+thilf2+"\n"
    txt+="\n"
    txt+=" - - -  e o f - - - "
    tpairs2.insert("end",txt)
    

def listset_entry():
    """opens an entryfield"""
    #brg 26.12.07, taken from dds8, modified for recognizesepset 20.2.10
    global elistset
    elistset=Tkinter.Entry(fr2,width=40)
    elistset.pack()
    return 

def confirm():
    """ hfs entries are opened to read in hfs strings """
    #brg 26.12.07, taken from dds8, modified for recognizesepset 20.2.10
    # if obj-identifier are in the entry field then listset gets these
    # if not then automatically listset consists of the complete objred
    global listset
    lob=len(objred)
    print "lob = ",lob
    print objred
    try:
        ra=elistset.get()
        print ra
        if ra=="":
            ra=""
            for i in range(0,lob):
                if i<lob-1:
                    ra+=objred[i]+","
                else:
                    ra+=objred[i]
            #print "ra (objred) ",ra        
    except:
        if ra=="":
            ra=""
            for i in range(0,lob):
                if i<lob-1:
                    ra+=objred[i]+","
                else:
                    ra+=objred[i]
            #print "ra (objred) ",ra        
    x=ra.split(",")
    #print x
    lx=len(x)

    
    listset=[]
    
    for j in range(0,lx):
        for k in range(0,lob):
            if x[j]==objred[k]:    #clarify whether all entries are elements of objred
                listset.append(k)
    
    print "listset in confirm   ",listset 
    
def HDobj():
    HD(objred,zetaobj,len(objred),12)
    
##def HDpowset():
##    HD(powset,zeta,n,6)

    

hf=Tkinter.Tk()
hf.title(' Recognize separated subsets ')
aboutHDsimpl=raioop2.brgabout(hf,"tp1","about_recogsepset.txt",3,\
            "February, the 20th,2010","about recogsepset ", "white", "t1",80,5,ScrolledText)
helpHDsimpl=raioop2.brgabout(hf,"tp1","help_recogsepset.txt",3,\
            "February, the 20th,2010"," help_recogsepset ", "white", "t1",80,5,ScrolledText)
lbtitle=Tkinter.Label(hf,text= "    Recognize separated subsets by walking through the lattice of all subsets   ",bg="yellow")
lbtitle.pack(pady=5)
fr=Tkinter.Frame(hf,width=60)
fr.pack(pady=5)

buttselopen=Tkinter.Button(fr,text="Select and open file", width=30,bg="cyan",command=selopenfile)
buttselopen.pack()
buttshow=Tkinter.Button(fr,text="Show data matrix ",width=30,bg="cyan",command=showDM)
buttshow.pack()
lb1=Tkinter.Label(fr,text="  \n  ")
lb1.pack()

fr1=Tkinter.Frame(hf,width=60)
fr1.pack(pady=3)
buttHDobj=Tkinter.Button(fr1,text="HD due to data matrix ",width=30,bg="cyan",command=HDobj)
buttHDobj.pack()


fr2=Tkinter.Frame(hf,width=60,relief="sunken",bd=3)
fr2.pack(pady=3)
lbset=Tkinter.Label(fr2,text="list of objects which eventually are candidates\nof subsets, separation by ','")
lbset.pack()
listset_entry()
buttconfirm=Tkinter.Button(fr2,text="confirm your listset-selection ",width=30,bg="cyan",command=confirm)
buttconfirm.pack()

fr3=Tkinter.Frame(hf,width=60)
fr3.pack(pady=3)
buttsepset=Tkinter.Button(fr3,text="find separated sets out of your list ",width=30,bg="cyan",command=findsepsets)
buttsepset.pack(side="left")
lbs=Tkinter.Label(fr3,text=" ")
lbs.pack(side="left")
fr3a=Tkinter.Frame(hf,width=60)
fr3a.pack()
buttshowsepset=Tkinter.Button(fr3a,text="Show all separated subset pairs ",width=30,command=showallpairs)
buttshowsepset.pack()
buttshowbestsepset=Tkinter.Button(fr3a,text="Show best separated subset pairs ",width=30,bg="cyan",command=showbestpairs)
buttshowbestsepset.pack()

frexit=Tkinter.Frame(hf,width=60)
frexit.pack(pady=10)
buttexit=Tkinter.Button(hf,text=" Exit ",bg="red",width=10,command=hf.destroy)
buttexit.pack()

    


hf.mainloop()
