# -*- coding: cp1252 -*-
import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import tkFileDialog
import raioop2

#Brg in cooperation with Korbinian Freier, MPI Hamburg, 2.10. and 3.10.09
# 31.5.2013 scanincomp1.py
# 1.6.2013 scanincomp2.py
# 3.6.2013 scanincomp3.py
# 29.9.2013 scanincomp4.py
# 18.11.2013 scanincomp4_3.py

def selectopen():
    # brg 31.5.2013, 18.11.2013
    global dm,dmn,obj,prop,r,k, rred,xred,objred
    # opening
    fn=tkFileDialog.askopenfilename()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    lb1.config(text="opened "+fn,bg="yellow")
    # obj and prop
    prop=[]
    for j in range(0,k):
        prop.append(pro[j+1])
            
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
    for i in range(0,r):
        obj[i]=ob[i+1]

    
    # representants

    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,dm,obj)  
    # equivalence classes
    tpequiv=Tkinter.Toplevel(hf)
    tpequiv.title('equiv classes ')
    tequiv=ScrolledText(tpequiv,width=60,height=5)
    tequiv.pack()
    tequiv.insert("end",txt)




def HD():
    """based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"""
    # Brg 20.12.07, 28.12.07, 2.10.,3.10.09
    # If the number of representants > 70 then only the cover-matrix and the level-population
    #
    global cov, zeta
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    #
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    if rred>100:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram  ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()
    buttcalc.config(state="active")        

                                       
def showdm():
    # brg 8.1.2014
    """ New routine : shows the data matrix """
    #Brg taken from discretiz3.py
    tpdm=Tkinter.Toplevel(hf)
    tpdm.title(' show DM ')
    lbtp2=Tkinter.Label(tpdm,text=" General information about data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tpdm,width=60,height=4)
    tfile.pack()
    try:
        hn=enorm.get()
    except:
        hn=="n"
    if hn=="y":
        dmn=rmod2.matrixnorm(r,k,dm)
    else:
        dmn=rmod2.matcopy1(r,k,dm)
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,k):
            txt3+=str(round(dmn[i][j],3))+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    
    tfile.insert("end",txt)

def calcvar():
    #brg 19.07.17, 21.07.17
    #Here all incomparable pairs (x,y) are checked and the delta
    # values between qj1(x), qj1(y) and qj2(x) and qj2(y) determined. If deltaj1 opposite to delta qj2
    # then the result is stored.
    # After this, the maximum will be determined
    try:
        filterdelta=float(efilterdelta.get())
    except:
        filterdelta=0.5
    dmn=rmod2.matrixnorm(r,k,dm)
    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,dmn,obj)
    txt="Discrepancies among incomparable objects"+"\n"
    for iob1 in range(0, rred):
        for iob2 in range(iob1+1,rred):
            if zeta[iob1][iob2]==0 and zeta[iob2][iob1]==0:
                for j1 in range(0, k):
                    delta1=(xred[iob1][j1]-xred[iob2][j1])
                    for j2 in range(j1+1,k):
                        delta2=(xred[iob1][j2]-xred[iob2][j2])
                        if delta1*delta2<0:
                            if abs(delta1)>filterdelta and abs(delta2)>filterdelta:
                                txt+=str(objred[iob1])+"--"+str(objred[iob2])+" :"
                                indic1=prop[j1]
                                indic2=prop[j2]
                                txt+="indicators: ("+indic1+", "+indic2+")  :("+str(round(delta1,3))+", "+str(round(delta2,3))+")\n"
                                txt+="\n"
        txt+="\n"
            
    tpdiscrep=Tkinter.Toplevel(hf)
    tdiscrep=ScrolledText(tpdiscrep,width=80,height=20)
    tdiscrep.pack()
    tdiscrep.insert("end",txt)
    
def checkcrucweight():
    #brg 22.07.17, 23.07.17
    dmn=rmod2.matrixnorm(r,k,dm)
    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,dmn,obj)
    try:
        filt2=float(efilter.get())
    except:
        filt2=10
    txt="check-quantities potentially responsible for the role of weights"+"\n"
    txt+="Only values for pruef2 will be shown with abs(pruef2) > 10"+"\n"
    txt+="+++first experiences: nothing to do whether or not weighted posets will have...\n"
    txt+="...remaining incomparabilities+++++"+"\n"
    for iob1 in range(0, rred):
        for iob2 in range(iob1+1,rred):
            if zeta[iob1][iob2]==0 and zeta[iob2][iob1]==0:
                for j1 in range(0, k):
                    delta1=(xred[iob1][j1]-xred[iob2][j1])
                    for j2 in range(j1+1,k):
                        delta2=(xred[iob1][j2]-xred[iob2][j2])
                        if delta1*delta2<0:
                            hilf=1.0*delta1/delta2
                            hilf2=-1.0/(hilf-1.0)
                            pruef1=round((1.0/k)*hilf2,3)  #take into account the number of indic
                            pruef2=1.0/(delta1-delta2)
                            if abs(pruef2)>=filt2:
                                txt+=str(objred[iob1])+"--"+str(objred[iob2])+": "\
                                  +str(prop[j1])+", "+str(prop[j2])+"   pruef1: "\
                                  +str(round(pruef1,3))+"  pruef2: "+str(round(pruef2,3))+"\n"
    tppruef=Tkinter.Toplevel(hf)
    tpruef=ScrolledText(tppruef,width=120,height=20)
    tpruef.pack()
    tpruef.insert("end",txt)
     
                                       
## Tkinter Plot
# brg 21.7.17    
hf = Tkinter.Tk()
hf.title(' scan_incomp ')
global euscan,eoscan,escanstep
aboutHDscan=raioop2.brgabout(hf,"tp1","about_scanincomp.txt",5,\
            "July, 22, 2017"," about scanincomp ", "white", "t1",80,5,ScrolledText)
helpHDscan=raioop2.brgabout(hf,"tp1","help_scanincomp.txt",5,\
            "July, 22,2017"," help_scanincomp", "white", "t1",80,5,ScrolledText)
    
fr=Tkinter.Frame(hf,width=60)
fr.pack()
buttos=Tkinter.Button(fr,text="Select and open file ",bg="cyan",width=25,command=selectopen)
buttos.pack()
buttHD = Tkinter.Button(fr, text=' HD',width=25,bg="cyan",command=HD)
buttHD.pack(pady=5)
lb1=Tkinter.Label(fr,text=" ",width=50)
lb1.pack()
lb2=Tkinter.Label(fr,text="For showing the data matrix:\n\
                        [0,1]-normalization wanted (y/n) (default no )")
lb2.pack()
enorm=Tkinter.Entry(fr,width=1)
enorm.pack()
buttshowdata=Tkinter.Button(fr,text="Show data matrix ",bg="cyan",width=25,command=showdm)
buttshowdata.pack()
frcalc=Tkinter.Frame(fr,bd=2,relief="sunken")
frcalc.pack()


lb3=Tkinter.Label(frcalc,text="Only those pairs x||y and their delta-values will be shown\n\
                                whose values are exceeding 'filterdelta' (for details, see 'help' \n\
                                default value=0.5")
lb3.pack()
efilterdelta=Tkinter.Entry(frcalc,width=5)
efilterdelta.pack()
buttcalc=Tkinter.Button(frcalc,text="Discrepancies ",bg="cyan", width=25, command=calcvar)
buttcalc.pack()
lb4=Tkinter.Label(frcalc,text="the 'check of quantities...' can render a very\n\
                        list of results. Therefore it is convenient to set filt>0 \n\
                        default value=10")
lb4.pack()
efilter=Tkinter.Entry(frcalc,width=5)
efilter.pack()
buttcheck=Tkinter.Button(frcalc,text="check of quantities,\n helpful for evaluating weights ",bg="cyan",width=25,command=checkcrucweight)
buttcheck.pack()
buttexit = Tkinter.Button(fr, text = 'exit', bg = 'red', width=25,command = hf.destroy)
buttexit.pack(pady=10)

hf.mainloop()

