# -*- coding: cp1252 -*-
import rmod2
import raioop2
import Tkinter
from ScrolledText import *
import random
import os
import Canvas

#Brg 9.12.07, 16.12.07,2.1.08, 8.1.08, 12.1.08, 15.1.08, 3.2.08, 4.2.08
# Brg 19.2.08: daughter windows with titles
# Brg 19.2.08: help modified
# Brg  8.5.08: adaptations because of changes in rmod2
# Brg 29.5.08: marginal corrections in HD2
# Brg 10.10.08 : help text now external. Load in by an OOP-function
# Brg 25.3.2010: simi version 4: some corrections
# Brg 13.6.10: Histogram similarity and histogram obcets contribution to antitone now in separated windows.
# Brg 31.1.11: List of object pairs which contribute to indiff
# 11.2.2011: Count of >||- of || ||, and of =|| combinations
# 16.10.2011: pdt_edit
# 26.2.2012: correction in cover of second dm
# 9.4.2012 In detailled analysis correction thanks to Lars Carlsen
# 1.6.2012: Start to extend similarity by analysis due to RKAV of both posets
# 4.7.2012: correction related to activation of buttons for correl of rkav1 and rkav2
# 6.7.2012: partitioning of objects due to their degree in antitone relation
# 9.7.2012: quartiles now for antitone degree
# 25.7.2012: Comparison on the basis of incomp. with artifcial dms
# 2.8.2012: New tool: If attributes are just different samples then
#           the comparison of m1 with m2 (m2>m1) is hampered because just
#           the greater number of attributes (which however are not essentially
#           describing per se other qualities. The new tool is called stochastic similarity.
# 4.8.2012: Many tests showed that for large number of attributes the random
#           selection of attributcombinations is inappropriate.
#           In that case a new module combsim is better suited.
#           Therefore here a restriction to 12 attributes is done.
#           For larger number: select combsim
# 12.9.2012: bug in line 1606 eliminated

tech=rmod2.vecgen1(20)
x=rmod2.marray(200,200)
y=rmod2.marray(200,200)


def dmprob(r,m,alpha):
    # brg 25.7.2012
    
    dm=rmod2.marray(r,m)

    for i in range(0,r):
        dm[i][0]=random.randint(0,r+1)
        for j in range(1,m):
            if random.random()>alpha:
                dm[i][j]=dm[i][j-1]+random.randint(1,r+1)
            else:
                dm[i][j]=random.randint(0,r+1)
    
    return dm


def spearmatrix(r,m,dm):
    # brg 25.7.2012
    import stats
    import pstat
    spearm=rmod2.marray(m,m)

    for j1 in range(0,m):
        for j2 in range(0,m):
            hilf1=rmod2.vecgen1(r)
            hilf2=rmod2.vecgen1(r)
            for i in range(0,r):
                hilf1[i]=dm[i][j1]
                hilf2[i]=dm[i][j2]
            spearm[j1][j2],hilf3=pstat.lspearmanr(hilf1,hilf2)

    
    #rmod2.matout(m,m,spearm)
    #print " "
    minspear=99999
    maxspear=-99999
    for j1 in range(0,m):
        for j2 in range(0,m):
            if j1!=j2:
                if spearm[j1][j2]<minspear:
                    minspear=spearm[j1][j2]
                if spearm[j1][j2]>maxspear:
                    maxspear=spearm[j1][j2]
            else:
                pass

    return spearm,minspear,maxspear
    
def zetainfo(zeta,rred):
    #brg 25.7.2012
    Utotal=0
    for i in range(0,rred):
        for j in range(0,rred):
            if zeta[i][j]==0 and zeta[j][i]==0:
                Utotal+=0.5


    comparabilities=0
    for i in range(0,rred):
        for j in range(0,rred):
            comparabilities+=zeta[i][j]


    minimal=0
    cs=rmod2.matrixcolsum(zeta,rred,rred)
    for i in range(0,rred):
        if cs[i]==1:
            minimal+=1

    maximal=0
    rs=rmod2.matrixrowsum(zeta,rred,rred)
    #print "cs= ",cs
    for i in range(0,rred):
        if rs[i]==1:
            maximal+=1
    return Utotal,comparabilities,minimal,maximal



def charanti(z):
    # brg 6.7.2012
    # z: inlist (corresponding to the usage in pstat)
    import pstat
    import stats
    meananti=pstat.mean(z)
    sdanti=pstat.lstdev(z)
    msd1=meananti-sdanti
    msd2=meananti+sdanti
    minlist=99999
    maxlist=-99999
    for i in range(0,len(z)):
        if z[i]<=minlist:
            minlist=z[i]
        if z[i]>=maxlist:
            maxlist=z[i]
        
    return meananti,sdanti,msd1,msd2, minlist,maxlist
    
def simi_fileselect():
    """ file open 1, file open 2"""
    # Brg 15.1.08
    #*:15.1.08
    #akt: 15.1.08, 4.3.16
    #note: a variant of fileselect, used in other HD programs
    #source:-
    import tkFileDialog
    global y1,y2,obj1,obj2,obj,prop1,prop2,r,k1,k2,fn1,fn2
    fn1=tkFileDialog.askopenfilename()
    fn2=tkFileDialog.askopenfilename()

    
    y1,obj1,prop1,r1,k1=rmod2.EXCELreadin6(fn1)
    y2,obj2,prop2,r2,k2=rmod2.EXCELreadin6(fn2)
    print obj1
    print obj2
    obj = []    #4.3.16 obj1 = obj2 = obj
    for i in range(0,len(obj1)):
        obj.append(obj1[i])
                   
                   
    # it may be that there are the same objects but in different order in the two different files
    tp1=Tkinter.Toplevel(hf)
    tp1.title('open/select')
    lbfileselect=Tkinter.Label(tp1, bg="yellow",text = "opened file1 with "+str(r1)+" rows and "+str(k1)+" columns\n\
and file2 with "+str(r2)+" rows and "+str(k2)+"  columns")
    lbfileselect.pack()
    if r1!=r2:
        lberror=Tkinter.Label(tp1,bg="yellow",text="++++ error : unequal number of objects +++"\
                              ,font=14 )
        lberror.pack()
        buttexit=Tkinter.Button(tp1,text=" quit ",command=hf.destroy)
        buttexit.pack()
    else:
        r=r1
                                
    return


def pdt_open():
    """ File selection of transformed data matrices
    through other PyHasse programs """
    #* 1.6.09
    # akt. 1.6.09
    # source: -
    import tkFileDialog
    global fn1,fn2,r1,r2,r,k1,k2,y1,y2,obj1,obj2,prop1,prop2
    fn1=tkFileDialog.askopenfilename()
    fn2=tkFileDialog.askopenfilename()
    
    r1,k1,y1,objt1,propt1=rmod2.raireadin5(fn1)
    r2,k2,y2,objt2,propt2=rmod2.raireadin5(fn2)

    #this part serves to adapt obj and prop-lists
    #concerning the format of EXCEL-derived lists
    # brg 17.10.2011
    obj1=rmod2.vecgen1(r1+1)
    obj2=rmod2.vecgen1(r2+1)
    obj1[0]="dummy"
    obj2[0]="dummy"
    for i in range(1,r1+1):
        obj1[i]=objt1[i-1]
    for i in range(1,r2+1):
        obj2[i]=objt2[i-1]
    print obj1
    print obj2
    
    lo1=len(obj1)
    lo2=len(obj2)
    print "len obj1 = ",lo1
    print "len obj2 = ",lo2
    prop1=rmod2.vecgen1(k1+1)
    prop2=rmod2.vecgen1(k2+1)
    prop1[0]="dummy"
    prop2[0]="dummy"
    for j in range(1,k1+1):
        prop1[j]=propt1[j-1]
    for j in range(1,k2+1):
        prop2[j]=propt2[j-1]
    print prop1
    print prop2
    ######################
    
    tp1=Tkinter.Toplevel(hf)
    tp1.title('open/select')
    lbfileselect=Tkinter.Label(tp1, bg="yellow",text = "opened file1 with "+str(r1)+" rows and "+str(k1)+" columns\n\
    and file2 with "+str(r2)+" rows and "+str(k2)+"  columns")
    lbfileselect.pack()
    if r1!=r2:
        lberror=Tkinter.Label(tp1,bg="yellow",text="++++ error : unequal number of objects +++"\
                              ,font=14 )
        lberror.pack()
        buttexit=Tkinter.Button(tp1,text=" quit ",command=hf.destroy)
        buttexit.pack()
    else:
        r=r1
        print "pdt-File: r = ",r                        
    return
    
def showDM1():
    """ New routine : shows the data matrix """
    #Brg 13.1.08, 15.1.08
    #*: 13.1.08
    #akt: 15.1.08
    #note: modified from the routine, taken from dds7.py
    global r
    tp2=Tkinter.Toplevel(hf)
    tp2.title(' show DM1 ')
    lbtp2=Tkinter.Label(tp2,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj1[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k1):
        txt2+=" "+prop1[j+1]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k1):
        txt3+=prop1[j+1]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj1[i+1]+"\t"
        for j in range(0,k1):
            txt3+=str(y1[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)

def showDM2():
    """ New routine : shows the data matrix """
    #Brg 13.1.08, 15.1.08
    #*: 13.1.08
    #akt: 15.1.08
    #note: modified from the routine, taken from dds7.py
    tp3=Tkinter.Toplevel(hf)
    tp3.title('show DM2 ')
    lbtp2=Tkinter.Label(tp3,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp3,width=60,height=4)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj2[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k2):
        txt2+=" "+prop2[j+1]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k2):
        txt3+=prop2[j+1]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj2[i+1]+"\t"
        for j in range(0,k2):
            txt3+=str(y2[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)    




def matchar1():
    """ characterizes the original dm """
    # brg 9.12.07, 16.12.07
    hfchar1=Tkinter.Toplevel(hf)
    hfchar1.title('characteristics 1')
    lbhfchar1=Tkinter.Label(hfchar1,text=' dm1 and characteristics of the dm1 ')
    lbhfchar1.pack()
    tm=ScrolledText(hfchar1,width=60,height=5)
    tm.pack()
    txtm="\n Data matrix (dm) 1  \n"
    txtm+="\t"
    for j in range(0,k1):
        txtm+=prop1[j+1]+"\t"
    for i in range(0,r):
        txtm+="\n"+obj1[i+1]+" :\t"    
        for j in range(0,k1):
            txtm+=str(round(y1[i][j],2))+"\t"
        txtm+="\n"
    tm.insert("end",txtm)
    
    tchar=ScrolledText(hfchar1, width=60, height=5)
    tchar.pack()
    
    a1=rmod2.matrixchar(r,k1,y1)
    #rmod2.matout(4,k,a)
    txt="\n characteristics of the dm1-properties \n"
    txt+="number of rows  "+str(r)+ "  number of columns "+str(k1)+"\n"
    for j in range(0,k1):
        txt+="\t"+prop1[j+1]+"       "
    txt+="\n"
    txt+="max   :\t"
    for j in range(0,k1):
        txt+=str(a1[0][j])+"\t"
    txt+="\nmin   :\t"
    for j in range(0,k1):
        txt+=str(a1[1][j])+"\t"
    txt+="\nmean  :\t"
    for j in range(0,k1):
        txt+=str(a1[2][j])+"\t"
    txt+="\nstdev :\t"
    for j in range(0,k1):
        txt+=str(a1[3][j])+"\t"
    txt+="\n"
    tchar.insert("end",txt)

def matchar2():
    """ characterizes the original dm """
    # brg 9.12.07, 16.12.07
    hfchar2=Tkinter.Toplevel(hf)
    hfchar2.title('characteristics 2')
    lbhfchar2=Tkinter.Label(hfchar2,text=' dm2 and characteristics of dm2 ')
    lbhfchar2.pack()
    tm=ScrolledText(hfchar2,width=60,height=5)
    tm.pack()
    txtm=""
    txtm+="\n Data matrix (dm) 2  \n"
    txtm+="\t"
    for j in range(0,k2):
        txtm+=prop2[j+1]+"\t"
    for i in range(0,r):
        txtm+="\n"+obj2[i+1]+" :\t"    
        for j in range(0,k2):
            txtm+=str(round(y2[i][j],2))+"\t"
        txtm+="\n"
    tm.insert("end",txtm)
    tchar=ScrolledText(hfchar2, width=60, height=5)
    tchar.pack()
    
    a2=rmod2.matrixchar(r,k2,y2)
    
    txt="\n characteristics of the dm2-properties \n"
    txt+="number of rows  "+str(r)+ "  number of columns "+str(k2)+"\n"
    for j in range(0,k2):
        txt+="\t"+prop2[j+1]+"       "
    txt+="\n"
    txt+="max   :\t"
    for j in range(0,k2):
        txt+=str(a2[0][j])+"\t"
    txt+="\nmin   :\t"
    for j in range(0,k2):
        txt+=str(a2[1][j])+"\t"
    txt+="\nmean  :\t"
    for j in range(0,k2):
        txt+=str(a2[2][j])+"\t"
    txt+="\nstdev :\t"
    for j in range(0,k2):
        txt+=str(a2[3][j])+"\t"
    txt+="\n"
    tchar.insert("end",txt)


def HD1():
    """ reduces a dm with equiv objects to a dm of a quotient set and \
    generates a Hasse diagram """
    # Brg 12.12.07, 13.1.08, 14.1.08
    # von mainHD3 uebernommen und geringfuegig angepasst
    #r,k,dm,ob,pro,fn are globals and should be available after open
    global zeta21,n1,objred1,r,eqm1,zeta1,objn1  
   
    #recoding ob to obj and pro to prop
    if r==0:
        hfwarning=Tkinter.Toplevel(hf)
        hfwarning.title('warning 1')
        frwarning=Tkinter.Frame(hfwarning,width=10,height=3)
        frwarning.pack()
        bwarning=Tkinter.Button(frwarning,text="++warning ++",command=msgwarning)
        bwarning.pack()
        
    propn1=rmod2.vecgentext1(k1)
    objn1=rmod2.vecgentext1(r)    #8.5.08 changed to ...text1
    for i in range(0,k1):
        propn1[i]=prop1[i+1]
    for i in range(0,r):
        objn1[i]=obj1[i+1]
    #############################dieser Teil ist neu 21.12.07
    n1,yred1,objred1,txt1,eqm1=rmod2.equivcompactgr(r,k1,y1,objn1)    
    ###############################################################
    #print objred
    #print "reduzierte matrix"
    #rmod2.matout(rred,k,xred)
      
    hfhd1=Tkinter.Toplevel(hf)
    hfhd1.title('HD 1')
    lbhfhd1=Tkinter.Label(hfhd1,text='Hasse diagram or cover matrix ')
    lbhfhd1.pack()
    freq=Tkinter.Frame(hfhd1,width=200,height=300)
    freq.pack()
    
   
    labeq=Tkinter.Label(freq,text="file = "+fn1+": calc. is based on representants ")
    labeq.config(bg="yellow")
    labeq.pack()

    #
    zetahilf1=rmod2.comp(n1,k1,yred1)
    zeta1=rmod2.marray(n1,n1)
    for i in range(0,n1):
        for j in range(0,n1):
            zeta1[i][j]=zetahilf1[j][i]

    
    #
    #One linear extension (based on levels)
    lbhd1=Tkinter.Label(freq,text= "Level ")
    lbhd1.pack()

    #rmod2.matout(n,n,zeta)
    lobj1,lext1,revlext1,zzmax1=rmod2.levtopsort(n1,zeta1)
    #print "zzmax = ",zzmax
    tlev=ScrolledText(freq,width=60,height=4)
    tlev.pack()
    txt1="\n"
    for i in range(0,zzmax1):
        txt1+="Level "+str(zzmax1-i)+" :"
        for j in range(0,len(lobj1[i])):
            txt1+= objred1[lobj1[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)

    txt2="\n One linear extension \n\n"
    for i in range(0,n1):
        if i<n1-1:
            txt2+=objred1[revlext1[i]]+" < "
        else:
            txt2+=objred1[revlext1[i]]+"\n"
    txt2+="\n"
    txt2+="\n -- end of list -- "
    tlinext=ScrolledText(freq,width=60, height=2)
    tlinext.pack()
    tlinext.insert("end",txt2)
    
    #Adj-Listen

    adjc1=rmod2.adjacent(n1,lext1,revlext1,zeta1)
        
    #Transitive reduced relations
    ts1,tr1=rmod2.trreduct(n1,adjc1,lext1)
       
    
    zeta21=rmod2.cover(n1,tr1,lext1)
    buttrkav.config(state="active")   #4.7.2012
    if n1>100:
        lbhd2=Tkinter.Label(freq,text=" graphical presentation not meaningful, see levels and cover-matrix ")
        lbhd2.pack()
        txt3="\n cover-matrix  \n"
        for i in range(0,n1):
            txt3+="\t"+objred1[i]+"\t"
        txt3+="\n"
        for i in range(0,n1):
            txt3+=objred1[i]+" :"
            for j in range(0,n1):
                txt3+=str(zeta21[i][j])+"\t"
            txt3+="\n"
        txt3+=" -- end of list --"
        tcov=ScrolledText(freq,width=60, height=4)
        tcov.pack()
        tcov.insert("end",txt3)
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram of File "+fn1)
        lbhd3.pack()
        cv=Tkinter.Canvas(freq,width=300,height=200,bg="white")
        lz=zzmax1
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj1[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(n1,n1)
        geomy=rmod2.marray(n1,n1)

        geom0x=10
        geom0y=20
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(160.0/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(160.0/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if zeta21[lobj1[i1][j1]][lobj1[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred1[lobj1[i][j]])
        garrow1x=210
        garrow1y=20
        garrow2y=190
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
##        cv.create_line(garrow1x-4,garrow2y-4,garrow1x,garrow2y)
##        cv.create_line(garrow1x+4,garrow2y-4,garrow1x,garrow2y)
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.pack()
       
        buttcover=Tkinter.Button(freq,text="show cover relation",command=cover_show1)
        buttcover.pack()

def cover_show1():
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: -
    hfcover=Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix 1')
    
    lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,n1):
        txt3+="\n"+objred1[i]+":\t"
        txt3+="is covered by "
        for j in range(0,n1):
            if i!=j:
                if zeta21[i][j]==1:
                    txt3+=" "+objred1[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=4)
    tcov.pack()
    tcov.insert("end",txt3)

    
def HD2():
    """ reduces a dm with equiv objects to a dm of a quotient set and \
    generates a Hasse diagram """
    # Brg 12.12.07, 13.1.08, 14.1.08
    # von mainHD3 uebernommen und geringfuegig angepasst
    #r,k,dm,ob,pro,fn are globals and should be available after open
    
    global zeta22,n2,objred2,r,eqm2,zeta2,objn2
    #recoding ob to obj and pro to prop
    if r==0:
        hfwarning2=Tkinter.Toplevel(hf)
        hfwarning2.title('warning 2')
        frwarning2=Tkinter.Frame(hfwarning,width=10,height=3)
        frwarning2.pack()
        bwarning2=Tkinter.Button(frwarning,text="++warning ++",command=msgwarning)
        bwarning2.pack()
        
    propn2=rmod2.vecgentext1(k2)
    objn2=rmod2.vecgentext1(r)   #changed to ...text1 8.5.08
    for i in range(0,k2):
        propn2[i]=prop2[i+1]
    for i in range(0,r):
        objn2[i]=obj2[i+1]
    #############################dieser Teil ist neu 21.12.07
    n2,yred2,objred2,txt2,eqm2=rmod2.equivcompactgr(r,k2,y2,objn2)    
    ###############################################################
    #print objred
    #print "reduzierte matrix"
    #rmod2.matout(rred,k,xred)
       
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title(' HD 2')
    lbhfhd2=Tkinter.Label(hfhd2,text='Hasse diagram or cover matrix ')
    lbhfhd2.pack()
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    
   
    labeq=Tkinter.Label(freq,text="file = "+fn2+": calc. is based on representants ")
    labeq.config(bg="yellow")
    labeq.pack()

   
    #
    zetahilf2=rmod2.comp(n2,k2,yred2)
    zeta2=rmod2.marray(n2,n2)
    for i in range(0,n2):
        for j in range(0,n2):
            zeta2[i][j]=zetahilf2[j][i]

    
    #
    #One linear extension (based on levels)
    lbhd2=Tkinter.Label(freq,text= "Level ")
    lbhd2.pack()

    #rmod2.matout(n,n,zeta)
    lobj2,lext2,revlext2,zzmax2=rmod2.levtopsort(n2,zeta2)
    #print "zzmax = ",zzmax
    tlev=ScrolledText(freq,width=60,height=4)
    tlev.pack()
    txt1="\n"
    for i in range(0,zzmax2):
        txt1+="Level "+str(zzmax2-i)+" :"
        for j in range(0,len(lobj2[i])):
            txt1+= objred2[lobj2[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)

    txt2="\n One linear extension \n\n"
    for i in range(0,n2):
        if i<n2-1:
            txt2+=objred2[revlext2[i]]+" < "
        else:
            txt2+=objred2[revlext2[i]]+"\n"
    txt2+="\n"
    txt2+="\n -- end of list -- "
    tlinext=ScrolledText(freq,width=60, height=2)
    tlinext.pack()
    tlinext.insert("end",txt2)
    
    #Adj-Listen

    adjc2=rmod2.adjacent(n2,lext2,revlext2,zeta2)
        
    #Transitive reduced relations
    ts2,tr2=rmod2.trreduct(n2,adjc2,lext2)
       
    
    zeta22=rmod2.cover(n2,tr2,lext2)
    buttrkav.config(state="active")  #4.7.2012
    if n2>100:
        lbhd3=Tkinter.Label(freq,text=" graphical presentation not meaningful, see levels and cover-matrix ")
        lbhd3.pack()
        txt3="\n cover-matrix  \n"
        for i in range(0,n2):
            txt3+="\t"+objred2[i]+"\t"
        txt3+="\n"
        for i in range(0,n2):
            txt3+=objred2[i]+" :"
            for j in range(0,n2):   #correction n1--> n2: 26.2.2012
                txt3+=str(zeta22[i][j])+"\t"
            txt3+="\n"
        txt3+=" -- end of list --"
        tcov=ScrolledText(freq,width=60, height=4)
        tcov.pack()
        tcov.insert("end",txt3)
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram of File "+fn2)
        lbhd3.pack()
        cv=Tkinter.Canvas(freq,width=300,height=200,bg="white")
        lz=zzmax2
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj2[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(n2,n2)
        geomy=rmod2.marray(n2,n2)

        geom0x=10
        geom0y=20
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(160.0/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(160.0/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if zeta22[lobj2[i1][j1]][lobj2[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred2[lobj2[i][j]])  #29.5.08 Korrektur objred 2 
        garrow1x=210
        garrow1y=20
        garrow2y=190
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
##        cv.create_line(garrow1x-4,garrow2y-4,garrow1x,garrow2y)
##        cv.create_line(garrow1x+4,garrow2y-4,garrow1x,garrow2y)
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.pack()
       
        buttcover=Tkinter.Button(freq,text="show cover relation",command=cover_show2)
        buttcover.pack()

def cover_show2():
    """Cover-matrix is displayed"""
    #brg 28.12.07, 8.2.2012
    #*28.12.07
    #akt28.12.07, 8.2.2012 hfcover2 
    #note: -
    #source: -
    hfcover2=Tkinter.Toplevel(hf)
    hfcover2.title(' cover-matrix 2')
    
    lbhd2=Tkinter.Label(hfcover2,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,n2):
        txt3+="\n"+objred2[i]+":\t"
        txt3+="is covered by "
        for j in range(0,n2):
            if i!=j:
                if zeta22[i][j]==1:
                    txt3+=" "+objred2[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover2,width=50, height=4)
    tcov.pack()
    tcov.insert("end",txt3)



    
def siman():
    """ similarity analysis of partial order for two dms """
    #brg 9.12.07, 13.6.10, 9.4.2012
    global zaehlnorm
    
        
    hfsim1=Tkinter.Toplevel(hf)
    hfsim1.title(' similarity')
    lbhfsim=Tkinter.Label(hfsim1, text=' Similarity ')
    lbhfsim.pack()
    tsim=ScrolledText(hfsim1, width=60, height=4)
    tsim.pack()
    
    # start with analysis: derivation of quobx
    objx1=rmod2.marray(r,r)
    quobx1=rmod2.marray(r,r)
    objx1=rmod2.comp(r,k1,y1)
    rmod2.qualcomp(r,objx1,quobx1)
    
    #start with analysis: derivation of quoby
    objx2=rmod2.marray(r,r)
    quobx2=rmod2.marray(r,r)
    objx2=rmod2.comp(r,k2,y2)
    rmod2.qualcomp(r,objx2,quobx2)
    

    #heart of similarity analysis:
    # Based on quobx and quoby the sim-matrix will be prepared
    global simi
    
    simi=[]   #preparation of similarity matrix
    for i in range(0,12):  #preparation of similarity matrix
        simi.append(0)
    simi=rmod2.similarity1(r,quobx1,quobx2)
    txt="\nResults of similarity analysis \n"
    txt+="isoton\tantiton\twiso\tindiff\tident\n"
    for i in range(0,5):
        txt+=str(simi[i])+"\t"
    txt+="\n\n"
    txt+= "fraction of  ...\n"
    txt+="isoton\tantiton\twiso\tindiff\tident\n"
    for i in range(6,11):
        txt+=str(round(simi[i],2))+"\t"   #3.2.08
    txt+="\n\n"
    tsim.insert("end",txt)
    
    frcv=Tkinter.Frame(hfsim1,width=450,height=450)
    frcv.pack()
    cv=Tkinter.Canvas(frcv,width=450,height=450,bd=2,relief="sunken")
    cv.pack()
    cv.create_rectangle(20,0,470,450)
    stext=rmod2.vecgentext1(5)
    stext[0]="iso   "
    stext[1]="anti  "
    stext[2]="wiso  "
    stext[3]="indiff"
    stext[4]="ident "
    for i in range(0,5):
        cv.create_rectangle(20+84*i,350,50+84*i,(1.0-simi[6+i])*350,fill="blue")
    li1=cv.create_line(20,350,450,350)
    for i in range(0,5):
        cv.create_text(30+84*i,370,text=stext[i])
    cv.create_text(250,400,text="S i m i l a r i t y - p r o f i l e  ")
    cv.create_text(160,420,text="\n"+fn1+"\n"+fn2,font=("Arial",8))
    zaehl=rmod2.vecgen1(r)
    zaehlnorm=rmod2.vecgen1(r)
    
    hfsim2=Tkinter.Toplevel(hf)
    hfsim2.title(" object's contribution to antitone")
    for i in range(0,r):
        for i1 in range(0,r):
            if i!=i1:
                if (quobx1[i][i1]=="lt" and quobx2[i][i1]=="gt")\
                    or(quobx1[i][i1]=="gt" and quobx2[i][i1]=="lt"):
                       zaehl[i]+=1
    txtobj="\n Contribution of objects to antitone \n"
    txtobj2=""
    txtobj3=""
    if r>6:
        txtobjheader="Object\t #antitone\t #degree_antitone\n"
        txtobjheader+=40*"="+"\n"
        txtobj+=txtobjheader
        for i in range(0,r):
            zaehlnorm[i]=zaehl[i]/(1.0*r)
            txtobj2+=obj1[i+1]+"\t\t"+str(zaehl[i])+"\t\t"+str(round(zaehlnorm[i],3))+"\n"
        txtobj+=txtobj2                               
    else:
        for i in range(0,r):
            zaehlnorm[i]=zaehl[i]/(1.0*r)
            txtobj2+=obj1[i+1]+"\t"
            txtobj3+=str(zaehl[i])+"\t"
        txtobj+=txtobj2+"\n"+txtobj3+"\n"
    manti,sdanti,sdmean1,sdmean2,mindanti,maxdanti=charanti(zaehlnorm)
    rangeanti=maxdanti-mindanti
    deltaantid=1.0*rangeanti/5.0
    quartile1,quartile2,quartile3=rmod2.quartile(zaehlnorm)
    txtobj+="\n"
    txtobj+="Statistical characterization of the antitone degree of the "+str(r)+"  objects "+"\n"
    txtobj+="Mean=\t"+str(round(manti,4))+"\n"
    txtobj+="sd=\t"+str(round(sdanti,4))+"\n"
    txtobj+="Mean-sd=\t"+str(round(sdmean1,4))+"\n"
    txtobj+="Mean+sd=\t"+str(round(sdmean2,4))+"\n"
    txtobj+="First quartile=\t"+str(round(quartile1,4))+"\n"
    txtobj+="Median =\t"+str(round(quartile2,4))+"\n"
    txtobj+="Thrird quartile =\t"+str(round(quartile3,4))+"\n"
    txtobj+="Minimal value of antitone degree =\t"+str(round(mindanti,5))+"\n"
    txtobj+="Maximal value of antitone degree =\t"+str(round(maxdanti,5))+"\n"
    txtobj+="Range of degree of antitone =\t"+str(round(rangeanti,5))+"\n"
    txtobj+="Range/5 = \t"+str(round(deltaantid,7))+"\n"
    txtobj+=" - -  e o f - - -  "
    tcontrib=ScrolledText(hfsim2,width=60,height=4)
    tcontrib.pack()
    tcontrib.insert("end",txtobj)
    frcv2=Tkinter.Frame(hfsim2,width=400, height=400)
    frcv2.pack()
    cv2=Tkinter.Canvas(frcv2,width=400,height=400,bd=2,relief="sunken")
    cv2.pack()
    cv2.create_rectangle(0,400,400,0,outline="black")
    cv2.create_rectangle(20,380,380,0,outline="black")
    #delta=-6.5*r+48.0
    delta=int(360.0/(1.0*r))  #change 8.1.08, 25.3.2010
    for i in range(0,r):
        cv2.create_rectangle(20+delta*i,380,20+delta*(i+1),(-360.0/(1.0*r))*zaehl[i]+360,fill="red", outline="black")
        cv2.create_text(25+(360.0/(1.0*r))*i,390,text=obj1[i+1],font=("Arial",6))
    cv2.create_text(150,10,text=" Object's contribution to antitone ")    

    hfsim3=Tkinter.Toplevel(hf)
    hfsim3.title(" object's contribution to indifferent")
        
    indiff1=[]    # combi of >,< with ||
    indiff2=[]    # combi of ||, ||
    indiff3=[]    # combi of =, ||
    zic1co2=0
    zic2co1=0
    for i in range(0,r):
        for i1 in range(i+1,r):
            print "1",obj1[i+1],"  ",obj1[i1+1]," ",quobx1[i][i1]
            print "2",obj2[i+1],"  ",obj2[i1+1]," ",quobx2[i][i1]
            if quobx1[i][i1]=="lt" and quobx2[i][i1]=="ic":
                indiff1.append((obj1[i+1]+"<1 "+obj1[i1+1]+",  "+obj2[i+1]+"||2 "+obj2[i1+1]))
                zic2co1+=1
            elif quobx1[i][i1]=="gt" and quobx2[i][i1]=="ic":
                indiff1.append((obj1[i+1]+">1 "+obj1[i1+1]+",  "+obj2[i+1]+"||2 "+obj2[i1+1]))
                zic2co1+=1
            elif quobx1[i][i1]=="ic" and quobx2[i][i1]=="lt":
                indiff1.append((obj1[i+1]+"||1 "+obj1[i1+1]+",  "+obj2[i+1]+"<2  "+obj2[i1+1]))
                zic1co2+=1
            elif quobx1[i][i1]=="ic" and quobx2[i][i1]=="gt":
                indiff1.append((obj1[i+1]+"||1 "+obj1[i1+1]+",  "+obj2[i+1]+">2 "+obj2[i1+1]))
                zic1co2+=1
            elif quobx1[i][i1]=="eg" and quobx2[i][i1]=="ic":
                indiff3.append((obj1[i+1]+"=1 "+obj1[i1+1]+",  "+obj2[i+1]+"||2 "+obj2[i1+1])) #changed 9.4.2012: eq replaced by eg
                zic2co1+=1
            elif quobx1[i][i1]=="ic" and quobx2[i][i1]=="eg":
                indiff3.append((obj1[i+1]+"||1 "+obj1[i1+1]+",  "+obj2[i+1]+"=2  "+obj2[i1+1])) #9.4.2012 eq replaced by eg
                zic1co2+=1
            elif quobx1[i][i1]=="ic" and quobx2[i][i1]=="ic":
                indiff2.append((obj1[i+1]+"||1 "+obj1[i1+1]+",  "+obj2[i+1]+"||2 "+obj2[i1+1]))
                        
                        
    txtobj="\n Contribution of objects to indifferent  \n"
    txtobj+=60*"="+"\n"
    txtobj+="number of < or > with ||-combinations: "+str(len(indiff1))+"\n"
    txtobj+="number of = with || combinations "+str(len(indiff3))+"\n"
    txtobj+="number of || with || combinations "+str(len(indiff2))+"\n"
    txtobj+="\n"
    txtobj+="Further differentiation: a) || , > or < or =\n"
    txtobj+="Labels 1 and 2 refer to the first and the second dm "+"\n"
    txtobj+="||1, >2 or <2 or =2 combinations: "+str(zic1co2)+"\n"
    txtobj+="                         b) > or < or = , || \n"
    txtobj+="||2, >1 or <1 or =1 combinations: "+str(zic2co1)+"\n"
    txtobj+="\n"
    txtobj+="Detailled lists "+"\n"
    txtobj+="a) > or < with || :"+"\n"
    for i in range(0,len(indiff1)):
        txtobj+=str(indiff1[i])+"\n"
    txtobj+="\n"                          
    txtobj+="\n b) Contribution of objects to indifferent (comb = with ||) \n"
    txtobj+=60*"="+"\n"
    for i in range(0,len(indiff3)):
        txtobj+=str(indiff3[i])+"\n"
    txtobj+="\n"
    txtobj+="\n c) Contribution of objects to indifferent (comb ||with ||) \n"
    txtobj+=60*"="+"\n"
    for i in range(0,len(indiff2)):
        txtobj+=str(indiff2[i])+"\n"
    txtobj+="\n" 
    tcontrib=ScrolledText(hfsim3,width=60,height=10)
    tcontrib.pack()
    tcontrib.insert("end",txtobj)                         
                             
def partantitone():
    #brg 6.7.2012
    limit1=float(elimit1.get())
    limit2=float(elimit2.get())
    listsmall=[]
    countsmall=0
    listlarge=[]
    countlarge=0
    listmiddle=[]
    countmiddle=0
    for i in range(0,r):
        if zaehlnorm[i]<=limit1:
            listsmall.append(obj1[i+1])
            countsmall+=1
        if zaehlnorm[i]>limit2:
            listlarge.append(obj1[i+1])
            countlarge+=1
        if limit1<zaehlnorm[i]<=limit2:
            listmiddle.append(obj1[i+1])
            countmiddle+=1
    print "listsmall= ",listsmall
    print "listmiddle = ",listmiddle
    print "listlarge = ",listlarge
    tppanti=Tkinter.Toplevel(hf)
    tppanti.title('lists of objects partitioned due to their antitone degree')
    tanti=ScrolledText(tppanti,width=60,height=10)
    tanti.pack()
    txtanti="Partitioning of the objects due to "+str(limit1)+", "+str(limit2)+"\n"
    txtanti+="<= "+str(limit1)+"\n"
    for ob in listsmall:
        txtanti+=ob+", "
    txtanti+="\ncount = "+str(countsmall)+"\n"
    txtanti+=str(limit1)+" < degree of antitone <= "+str(limit2)+"\n"
    for ob in listmiddle:
        txtanti+=ob+", "
    txtanti+="\ncount = "+str(countmiddle)+"\n"
    txtanti+="degree of antitone> "+str(limit2)+"\n"
    for ob in listlarge:
        txtanti+=ob+", "
    txtanti+="\n"+"count= "+str(countlarge)+"\n"
    txtanti+="\n - - - e o f  - - - "
    tanti.insert("end",txtanti)



def SaPaUa(rred,r,objred,obj,zeta):
    #Brg 30.9.09, 2.3,2012, 1.6.2012 taken from LPOMext2
    # 1.6.2012 rearranged as a procedure with a parameterlist
    global Ua,Sa,Pa,countUa,countSa,rkav
    Sa=rmod2.marray1(rred,rred,-1)
    Pa=rmod2.marray1(rred,rred,-1)
    Ua=rmod2.marray1(rred,rred,-1)
    countSa=rmod2.vecgen1(rred)
    countPa=rmod2.vecgen1(rred)
    countUa=rmod2.vecgen1(rred)
    
    for ob in objred:
        obi=objred.index(ob)
        
        #obi the selected element whose rkav will be deternmined
        z=0
        for i1 in range(0,rred):
            if zeta[i1][obi]==1:
                z+=1
                Sa[obi][i1]=i1
        #print "ob = ",ob,"  its order ideal:  ",Sa[obi]
        countSa[obi]=z
    for ob in objred:
        obi=objred.index(ob)
        
        #obi the selected element whose rkav will be deternmined
        z=0
        for i1 in range(0,rred):
            if zeta[obi][i1]==1:
                z+=1
                Pa[obi][i1]=i1
        #print "ob = ",ob,"  its order filter:  ",Pa[obi]
        countPa[obi]=z
    for ob in objred:
        obi=objred.index(ob)
        
        #obi the selected element whose rkav will be deternmined
        z=0
        for i1 in range(0,rred):
            if zeta[i1][obi]==0 and zeta[obi][i1]==0:
                z+=1
                Ua[obi][i1]=i1
        #print "ob = ",ob,"  its incomparables  ",Ua[obi]
        countUa[obi]=z

   
    
    rkav=rmod2.vecgen1(rred)
    for i2 in range(0,rred):
        rkav[i2]=countSa[i2]  #note Sa includes the interesting element a too
    
    
    #print " "
    for ob in objred:
        obi=objred.index(ob)
        increment=0
        
        for y in Ua[obi]:
            #print "y in increment loop: ",objred[y]," ",
            Uy=[]
            Pdown=0
            Pup=0
            
            if y!=-1:
                for i1 in range(0,rred):
                    if zeta[i1][y]==0 and zeta[y][i1]==0:
                        Uy.append(i1)
                
                for x in Uy:
                    if x in Sa[obi]:
                        Pdown+=1
                            
                for x in Uy:
                    if x in Pa[obi]:
                        Pup+=1
                
                dinc=1.0*Pdown/(1.0*Pdown+1.0*Pup)
                
                increment+=dinc
                #print "obi = ",obi,"  y= ",y,"  Pdown= ",Pdown,"   Pup = ",Pup
        rkav[obi]+=increment
    # 1.6.2012 Baustelle: hier Einbauen weak1(....)

        
    return rkav    
    
    
    


        
def rkavanal():
    #brg 1.6.2012, 4.3.2016
    global rkav1ext,rkav2ext,obj,trkavanal,nc 
    tprkavanal=Tkinter.Toplevel(hf)
    tprkavanal.title(' rkav-based similarities ')
    txtr=" Rkav-background info and result "+"\n"
    txtr+=40*"="+"\n"
    txtr+="rkav of first and second quotient set: "+"\n"
    # calculation common to both commands
    if objn1==objn2:
        obj=[]
        for iob in range(0,len(objn1)):
            obj.append(objn1[iob])
        rkav1=SaPaUa(n1,r,objred1,obj,zeta1)
        rkav2=SaPaUa(n2,r,objred2,obj,zeta2)
        txtr+="First set: "+"\n"
        for i in range(0,len(rkav1)):
            txtr+=str(round(rkav1[i],3))+" "
        txtr+="\nSecond set: "+"\n"
        for i in range(0,len(rkav2)):
            txtr+=str(round(rkav2[i],3))+" "
        txtr+="\n"              
        rkav1ext=rmod2.weak1(r,obj,objred1,rkav1,eqm1)
        rkav2ext=rmod2.weak1(r,obj,objred2,rkav2,eqm2)
        nc=len(rkav1ext)
        txtr+="rkav as weak order for the full object set: "+"\n"
        txtr+="          "
        for i in range(0,len(obj)):
            txtr+=str(obj[i])+"    "
        txtr+="\n"
        txtr+="First set: "
        for i in range(0,len(rkav1ext)):
            txtr+=str(round(rkav1ext[i],2))+" "
        txtr+="\nSecnd set: "
        for i in range(0,len(rkav2ext)):
            txtr+=str(round(rkav2ext[i],2))+" "
        txtr+="\n"    
        print rkav1ext
        print rkav2ext
    else:
        txtr= "+++ Objects are different in both sets +++"
    butt1=Tkinter.Button(tprkavanal,text="spearman correlation of two rkav-vectors ",width=40,command=correl)
    butt1.pack()
    butt2=Tkinter.Button(tprkavanal,text="HD based on both rkav-vectors ",width=40,command=hpor)
    butt2.pack()
    butt3=Tkinter.Button(tprkavanal,text="   exit   ",width=40,bg="red",command=tprkavanal.destroy)
    butt3.pack(pady=5)
    trkavanal=ScrolledText(tprkavanal,width=50,height=5)
    trkavanal.pack()
    trkavanal.insert("end",txtr)

def correl():
    #brg 1.6.2012
    import pstat
    import stat
    spear,probspear=pstat.lspearmanr(rkav1ext,rkav2ext)
    txtrr="Spearman correlation of the two extended rkav-vectors "+"\n"
    txtrr+=str(spear)+"\n"
    txtrr+="two-sided probability: "+str(round(probspear,3))
    trkavanal.insert("end",txtrr)
    
    



def hpor():
    #brg 1.6.2012
    # basically this is the idea of Carlsen, now applied to the similarity analysis
    # preparing the new dm based on the extended rkav
    global objredc, nc, coverc
    dmnew=rmod2.marray(r,2)
    for i in range(0,r):
        dmnew[i][0]=rkav1ext[i]
        dmnew[i][1]=rkav2ext[i]
    rmod2.matout(r,2,dmnew)    
    # now the usual HD procedure
    #############################dieser Teil ist neu 21.12.07
    nc,yredc,objredc,txtc,eqmc=rmod2.equivcompactgr(r,2,dmnew,obj)    
    ###############################################################
    
      
    hfhd3=Tkinter.Toplevel(hf)
    hfhd3.title('HD of the two (extended) Rkav-vectors ')
    lbhfhd1=Tkinter.Label(hfhd3,text='Hasse diagram or cover matrix ')
    lbhfhd1.pack()
    freq=Tkinter.Frame(hfhd3,width=200,height=300)
    freq.pack()
    
   
    labeq=Tkinter.Label(freq,text=" calc. is based on representants ")
    labeq.config(bg="yellow")
    labeq.pack()

    #
    zetahilfc=rmod2.comp(nc,2,yredc)
    zetac=rmod2.marray(nc,nc)
    for i in range(0,nc):
        for j in range(0,nc):
            zetac[i][j]=zetahilfc[j][i]
    #
    #One linear extension (based on levels)
    lbhd1=Tkinter.Label(freq,text= "Level ")
    lbhd1.pack()

    #rmod2.matout(n,n,zeta)
    lobjc,lextc,revlextc,zzmaxc=rmod2.levtopsort(nc,zetac)
    #print "zzmax = ",zzmax
    tlev=ScrolledText(freq,width=60,height=4)
    tlev.pack()
    txt1="\n"
    for i in range(0,zzmaxc):
        txt1+="Level "+str(zzmaxc-i)+" :"
        for j in range(0,len(lobjc[i])):
            txt1+= objredc[lobjc[i][j]]+" " #15032013 error list index out of range objred1 replaced by objredc
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)

    txt2="\n One linear extension \n\n"
    for i in range(0,nc):
        if i<nc-1:
            txt2+=objredc[revlextc[i]]+" < "
        else:
            txt2+=objredc[revlextc[i]]+"\n"
    txt2+="\n"
    txt2+="\n -- end of list -- "
    tlinext=ScrolledText(freq,width=60, height=2)
    tlinext.pack()
    tlinext.insert("end",txt2)
    
    #Adj-Listen

    adjcc=rmod2.adjacent(nc,lextc,revlextc,zetac)
        
    #Transitive reduced relations
    tsc,trc=rmod2.trreduct(nc,adjcc,lextc)
       
    
    coverc=rmod2.cover(nc,trc,lextc)
    if nc>300:
        lbhd2=Tkinter.Label(freq,text=" graphical presentation not meaningful, see levels and cover-matrix ")
        lbhd2.pack()
        txt3="\n cover-matrix  \n"
        for i in range(0,nc):
            txt3+="\t"+objredc[i]+"\t"
        txt3+="\n"
        for i in range(0,nc):
            txt3+=objredc[i]+" :"
            for j in range(0,nc):
                txt3+=str(coverc[i][j])+"\t"
            txt3+="\n"
        txt3+=" -- end of list --"
        tcov=ScrolledText(freq,width=60, height=4)
        tcov.pack()
        tcov.insert("end",txt3)
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram based on rkav ")
        lbhd3.pack()
        cv=Tkinter.Canvas(freq,width=300,height=200,bg="white")
        lz=zzmaxc
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobjc[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(nc,nc)
        geomy=rmod2.marray(nc,nc)

        geom0x=10
        geom0y=20
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(160.0/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(160.0/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if coverc[lobjc[i1][j1]][lobjc[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objredc[lobjc[i][j]])
        garrow1x=210
        garrow1y=20
        garrow2y=190
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.pack()
        buttcover=Tkinter.Button(freq,text="show cover relation",command=coverc_show1)
        buttcover.pack()

def coverc_show1():
    #brg 1.6.2012, 4.3.16
    hfcoverc=Tkinter.Toplevel(hf)
    hfcoverc.title(' cover-matrix of rkav1extt,rkav2ext ')
    
    lbhd2=Tkinter.Label(hfcoverc,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n rkav1,2-cover-matrix  \n"
    txt3+="number of objects= "+str(nc)+"\n"
    for i in range(0,nc):
        txt3+="\n"+str(objredc[i])+":\t"
        txt3+="is covered by "
        for j in range(0,nc):
            if i!=j:
                if coverc[i][j]==1:
                    txt3+=" "+str(objredc[j])+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcoverc,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)

def simartif():
    #brg 25.7.2012
    global r
    # Basics of poset1:
    propn1=rmod2.vecgentext1(k1)
    objn1=rmod2.vecgentext1(r)    #8.5.08 changed to ...text1
    for i in range(0,k1):
        propn1[i]=prop1[i+1]
    for i in range(0,r):
        objn1[i]=obj1[i+1]
    #############################dieser Teil ist neu 21.12.07
    n1,yred1,objred1,txteq1,eqm1=rmod2.equivcompactgr(r,k1,y1,objn1)    
    ###############################################################
        #
    zetahilf1=rmod2.comp(n1,k1,yred1)
    zeta1=rmod2.marray(n1,n1)
    for i in range(0,n1):
        for j in range(0,n1):
            zeta1[i][j]=zetahilf1[j][i]

    U1,hilf11,hilf12,hilf13=zetainfo(zeta1,n1)
    U1norm=2.0*U1/(n1*(n1-1.0))

    # basics of poset2
    propn2=rmod2.vecgentext1(k2)
    objn2=rmod2.vecgentext1(r)    #8.5.08 changed to ...text1
    for i in range(0,k2):
        propn2[i]=prop2[i+1]
    for i in range(0,r):
        objn2[i]=obj2[i+1]
    #############################dieser Teil ist neu 21.12.07
    n2,yred2,objred2,txteq2,eqm2=rmod2.equivcompactgr(r,k2,y2,objn2)    
    ###############################################################
        #
    zetahilf2=rmod2.comp(n2,k2,yred2)
    zeta2=rmod2.marray(n2,n2)
    for i in range(0,n2):
        for j in range(0,n2):
            zeta2[i][j]=zetahilf2[j][i]

    U2,hilf21,hilf22,hilf23=zetainfo(zeta2,n2)
    U2norm=2.0*U2/(n2*(n2-1.0))




    MCsim=5 #number of trials per prob-level
    cal=5  #number of prob-levels to be tested
    
    try:
        mact=int(emact.get())
    except:
        mact=max(k1,k2)
    txt=" alpha-loop "+"\n"
    txt+="\n"
    Ual=rmod2.vecgen1(cal)
    alphal=rmod2.vecgen1(cal)
    for al in range(0,cal):
        alphainput=0.1+0.2*al
        
        alpha=(alphainput)**mact   #as more indic. as lower the prob-limit
        alphal[al]=alpha
        ustatistik=rmod2.vecgen1(MCsim)
        maxSpstatistik=rmod2.vecgen1(MCsim)
        minSpstatistik=rmod2.vecgen1(MCsim)
        levmaxstatistik=rmod2.vecgen1(MCsim)
        zzmaxstatistik=rmod2.vecgen1(MCsim)

        for mc in range(0,MCsim):
            dmartif=dmprob(r,mact,alpha)

            spearm,minspear,maxspear=spearmatrix(r,mact,dmartif)
            minSpstatistik[mc]=minspear
            maxSpstatistik[mc]=maxspear
                
            prop=[]
            for j in range(0,mact):
                prop.append("q"+str(j))
                    
            obj=[]
            for i in range(0,r):
                obj.append(str(i))

            rred,xred,objred,txteq,neq=rmod2.equivcompactm(r,mact,dmartif,obj)  
            
            #
            zetahilf=rmod2.comp(rred,mact,xred)  #zeta matrix with col<row
            zeta=rmod2.marray(rred,rred)
            for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
                for j in range(0,rred):
                    zeta[i][j]=zetahilf[j][i]
            #
            ustatistik[mc],hilfx,hilfx2,hilfx3=zetainfo(zeta,rred)
            lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
            zzmaxstatistik[mc]=zzmax   
            levmax=-10**20     #20.6.08
            for i in range(0,zzmax):
                if len(lobj[i])>=levmax:
                    levmax=len(lobj[i])
            levmaxstatistik[mc]=levmax   
            
        minU=min(ustatistik)
        maxU=max(ustatistik)
        AvU=1.0*sum(ustatistik)/MCsim
        AvSpmin=1.0*sum(minSpstatistik)/MCsim
        AvSpmax=1.0*sum(maxSpstatistik)/MCsim
        minzzmax=min(zzmaxstatistik)
        maxzzmax=max(zzmaxstatistik)
        Avlevmax=1.0*sum(levmaxstatistik)/MCsim
        Avzzmax=1.0*sum(zzmaxstatistik)/MCsim
        Ual[al]=2.0*AvU/(rred*(rred-1))
        txt+="\n m                           = "+str(mact)
        txt+="\n alphainput                  = "+str(alphainput)
        txt+="\n alpha                       = "+str(alpha)
        txt+="\n number of objects           = "+str(r)
        txt+="\n number of representants     = "+str(rred)
        txt+="\n number of simulations       = "+str(MCsim)+"\n"
        txt+="\n min(Incomp)                 = "+str(minU)
        txt+="\n Average Incomparabilities   = "+str(round(AvU,3))
        txt+="\n Number of repres.poset1     = "+str(n1)     
        txt+="\n Incomp of poset1            = "+str(round(U1norm*n1*(n1-1.0)/2.0,3))
        txt+="\n Number of repres.poset2     = "+str(n2)
        txt+="\n Incomp of poset2            = "+str(round(U2norm*n2*(n2-1.0)/2.0,3))
        txt+="\n max(incomp)                 = "+str(maxU)
        txt+="\n maximal possible incomp     = "+str(rred*(rred-1)/2.0)
        txt+="\n minimal possible incomp     = "+str(0)
        txt+="\n"
        txt+="\n min (maxchainlength)        = "+str(minzzmax)
        txt+="\n Average Length of max chn   = "+str(round(Avzzmax,3))
        txt+="\n max (maxchainlength)        = "+str(maxzzmax)+"\n"
        txt+="\n AvSpearman-min              = "+str(round(AvSpmin,3))
        txt+="\n AvSpearman-max              = "+str(round(AvSpmax,3))
        txt+="\n"
        txt+=" - - e o detail-info - - "+"\n"


    for al in range(0,cal):
        txt+="\n alpha="+str((0.1+0.2*al)**mact)+"    U norm = "+str(Ual[al])+"\n"

    txt+="  - - - -  e o f - - - -"

    tpartif=Tkinter.Toplevel(hf)
    tpartif.title(' Comparison with artificial dm with different degree\nof correlation')
    tinfo=ScrolledText(tpartif,width=60,height=10)
    tinfo.pack()

    tinfo.insert("end",txt)
    cvartif=Tkinter.Canvas(tpartif,width=400,height=200,bg="white")
    cvartif.pack()
    line1=cvartif.create_line(50,100,355,100,arrow="last",fill="red")
    lineUnull=cvartif.create_line(50,75,50,125)
    lineUeins=cvartif.create_line(350,75,350,125)
    aline=300.0
    bline=50.0
    pos=rmod2.vecgen1(cal)
    txtvinfo=cvartif.create_text(10,150,text="alpha")
    txtvinfo2=cvartif.create_text(10,160,text="Unorm")
    for al in range(0,cal):
        u=Ual[al]
        pos[al]=aline*u+bline
        print pos[al]
        linev=cvartif.create_line(pos[al],85,pos[al],115,width=3)
        txtv=cvartif.create_text(50+72*al,150,text=str(round(alphal[al],5)))
        txtvU=cvartif.create_text(50+72*al,160,text=str(round(Ual[al],3)))
    
    cir1=cvartif.create_line(aline*U1norm+bline,60,aline*U1norm+bline,100,arrow="last",fill="red")
    cir2=cvartif.create_line(aline*U2norm+bline,40,aline*U2norm+bline,100,arrow="last",fill="red")
    txtv2=cvartif.create_text(aline*U1norm+bline-10,50,text="poset1")
    txtv3=cvartif.create_text(aline*U2norm+bline-10,30,text="poset2")

def stochsim():
    # brg 2.8.2012
    # Assume two posets: one with m1 and one with m2 attributes (m2>>m1).
    # m1-poset has causal context C1
    # m2-poset has another causal context C2
    # Because m2>m1, just the greater number of attributes causes changes.
    # Therefore MC randomly selected tuples of length m1 out of tuple with m2 attributes.
    # Then discuss the MC proximity profiles
    #
    import itertools
    import math
    import random
    import stats
    import pstat
    import tkFileDialog
        
    y1,obj1,prop1,r1,k1=rmod2.EXCELreadin6(fn1)
    y2,obj2,prop2,r2,k2=rmod2.EXCELreadin6(fn2)
    lbstochsiminfo.config(text="opened dm1 with "+str(k1)+"...dm2 with "+str(k2)+" attributes",bg="yellow")
    if max(k1,k2)>12:
        lbstochsim.config(text="+++ Too many attributes! Please use the module combsim +++",bg="yellow")
    else:
        try:
            seluser=int(eseluser.get())
        except:
            seluser=999
        if seluser==1:
            dm_to_be_sampled=rmod2.matcopy1(r1,k1,y1)
            dm_remaining=rmod2.matcopy1(r2,k2,y2)
        elif seluser==2:
            dm_to_be_sampled=rmod2.matcopy1(r2,k2,y2)
            dm_remaining=rmod2.matcopy1(r1,k1,y1)
        else:
            txtstochsim=" +++  Your decision is needed: which dm has the more attributes, "+"\n"
            txtstochsim+=" Enter '1' for the first dm, or a '2' for the second matrix +++"

        #self-similarities
        # dm 1    
        objx1s=rmod2.marray(r1,r1)
        quobx1s=rmod2.marray(r1,r1)
        objx1s=rmod2.comp(r1,k1,y1)
        rmod2.qualcomp(r1,objx1s,quobx1s)

        #start with analysis: derivation of quoby
        objx2s=rmod2.marray(r1,r1)
        quobx2s=rmod2.marray(r1,r1)
        objx2s=rmod2.comp(r1,k1,y1)
        rmod2.qualcomp(r1,objx2s,quobx2s)

        simiself1=[]   #preparation of similarity matrix
        for i5 in range(0,12):  #preparation of similarity matrix
            simiself1.append(0)
            simiself1=rmod2.similarity1(r1,quobx1s,quobx2s)
        isoss1=1.0*simiself1[0]/(r1*(r1-1.0))
        antiss1=1.0*simiself1[1]/(r1*(r1-1.0))
        weakss1=1.0*simiself1[2]/(r1*(r1-1.0))
        indiffss1=1.0*simiself1[3]/(r1*(r1-1.0))
        equalss1=1.0*simiself1[4]/(r1*(r1-1.0))

        # now selfsimilarity with dm 2
        objx3s=rmod2.marray(r2,r2)
        quobx3s=rmod2.marray(r2,r2)
        objx3s=rmod2.comp(r2,k2,y2)
        rmod2.qualcomp(r2,objx3s,quobx3s)

        #start with analysis: derivation of quoby
        objx4s=rmod2.marray(r2,r2)
        quobx4s=rmod2.marray(r2,r2)
        objx4s=rmod2.comp(r2,k2,y2)
        rmod2.qualcomp(r2,objx4s,quobx4s)

        simiself2=[]   #preparation of similarity matrix
        for i6 in range(0,12):  #preparation of similarity matrix
            simiself2.append(0)
            simiself2=rmod2.similarity1(r1,quobx3s,quobx4s)
        #print "self-similarity dm2 ",simiself2
        isoss2=1.0*simiself2[0]/(r2*(r2-1.0))
        antiss2=1.0*simiself2[1]/(r2*(r2-1.0))
        weakss2=1.0*simiself2[2]/(r2*(r2-1.0))
        indiffss2=1.0*simiself2[3]/(r2*(r2-1.0))
        equalss2=1.0*simiself2[4]/(r2*(r2-1.0))

        # preparation of the output window
        tpstochsim=Tkinter.Toplevel(hf)
        tstochsim=ScrolledText(tpstochsim,width=60,height=10)
        tstochsim.pack()
        if seluser!=999:
            # start of the combinatorial analysis           
            r=r1
            
            
            ksample=min(k1,k2)
            anz,txtactx=rmod2.estimanz(max(k1,k2),min(k1,k2))
            classanz=int(anz+0.5)

            propstochsim=[]
            for j in range(0,max(k1,k2)):
                propstochsim.append(j)
                
            
            dmnew=rmod2.marray(r,ksample)
            x=itertools.combinations(propstochsim,ksample) #combinatorial generation of ksample - tuples from propstochsim
            
            veciso=rmod2.vecgen1(classanz)
            vecanti=rmod2.vecgen1(classanz)
            vecindiff=rmod2.vecgen1(classanz)
            vecweakiso=rmod2.vecgen1(classanz)
            vecequal=rmod2.vecgen1(classanz)
            vec=rmod2.vecgen1(classanz)
            normalizer=1.0*r*(r-1.0)

            for i in range(0,classanz):
                zahl=0
                vec[i]=x.next()  #corresponds to yield in itertools.combinations
                #print "vec= ",vec[i]
                for j in vec[i]:
                    for i1 in range(0,r):
                        dmnew[i1][zahl]=dm_to_be_sampled[i1][j]
                    zahl+=1
                #print ksample,"-Matrix"
                #rmod2.matout(r,ksample,dmnew)
                #print " "
                #now a matrix is obtained having the same number (randomly selected) of attributes as dm_remaining
                # start with analysis: derivation of quobx
                objx1=rmod2.marray(r,r)
                quobx1=rmod2.marray(r,r)
                objx1=rmod2.comp(r,min(k1,k2),dm_remaining)
                rmod2.qualcomp(r,objx1,quobx1)
            
                #start with analysis: derivation of quoby
                objx2=rmod2.marray(r,r)
                quobx2=rmod2.marray(r,r)
                objx2=rmod2.comp(r,ksample,dmnew)
                rmod2.qualcomp(r,objx2,quobx2)
            

                #heart of similarity analysis:
                # Based on quobx and quoby the sim-matrix will be prepared for each i (run through all attribute combinations
            
            
                simistoch=[]   #preparation of similarity matrix
                for i4 in range(0,12):  #preparation of similarity matrix
                    simistoch.append(0)
                simistoch=rmod2.similarity1(r,quobx1,quobx2)
                
                veciso[i]=simistoch[0]
                #print "i= ",i,"  veciso= ",veciso[i]
                vecanti[i]=simistoch[1]
                #print "i= ",i,"  vecanti = ",vecanti[i]
                vecweakiso[i]=simistoch[2]
                #print "i= ",i,"  vecweakiso= ",vecweakiso[i]
                vecindiff[i]=simistoch[3]
                #print "i= ",i,"  vecindiff =",vecindiff[i]
                vecequal[i]=simistoch[4]

            aviso=1.0*sum(veciso)/classanz/normalizer
            miniso=min(veciso)/normalizer
            maxiso=max(veciso)/normalizer
            avanti=1.0*sum(vecanti)/classanz/normalizer
            minanti=min(vecanti)/normalizer
            maxanti=max(vecanti)/normalizer
            avindiff=1.0*sum(vecindiff)/classanz/normalizer
            minindiff=min(vecindiff)/normalizer
            maxindiff=max(vecindiff)/normalizer
            avweak=1.0*sum(vecweakiso)/classanz/normalizer
            minweak=min(vecweakiso)/normalizer
            maxweak=max(vecweakiso)/normalizer
            avequal=1.0*sum(vecequal)/classanz/normalizer
            minequal=min(vecequal)/normalizer
            maxequal=max(vecequal)/normalizer


            txtstochsim="Result of stochastic selection of attributes "+"\n"
            txtstochsim+=60*"-"+"\n"
            txtstochsim+=" Basics "+"\n"
            txtstochsim+=" Order of complexitxy (estim. niumber of combinations "+str(int(anz+0.5))+"\n" 
            txtstochsim+=" Number of classes for the actual analysis "+str(classanz)+"\n"
            txtstochsim+=" Matrix from which samples are to be drawn : matrix No "+str(seluser)+"\n"
            txtstochsim+=" Number of attributes in the larger dm: "+str(max(k1,k2))+"\n" 
            txtstochsim+=" Number of attributes in the remaining dm "+str(min(k1,k2))+"\n"
            txtstochsim+=" Similarity "+"\n"
            txtstochsim+=" minimum of iso: \t"+str(round(miniso,3))+"\n"
            txtstochsim+=" average of iso: \t"+str(round(aviso,3))+"\n"
            txtstochsim+=" maximum of iso: \t:"+str(round(maxiso,3))+"\n"
            txtstochsim+="\n"
            txtstochsim+=" minimum of anti: \t"+str(round(minanti,3))+"\n"
            txtstochsim+=" average of antti: \t"+str(round(avanti,3))+"\n"
            txtstochsim+=" maximum of anti: \t:"+str(round(maxanti,3))+"\n"
            txtstochsim+="\n"
            txtstochsim+=" minimum of weak iso: \t"+str(round(minweak,3))+"\n"
            txtstochsim+=" average of weak iso: \t"+str(round(avweak,3))+"\n"
            txtstochsim+=" maximum of weak iso: \t:"+str(round(maxweak,3))+"\n"
            txtstochsim+="\n"
            txtstochsim+=" minimum of indiff: \t"+str(round(minindiff,3))+"\n"
            txtstochsim+=" average of iindiff: \t"+str(round(avindiff,3))+"\n"
            txtstochsim+=" maximum of indiff: \t:"+str(round(maxindiff,3))+"\n"
            txtstochsim+="\n"
            txtstochsim+=" minimum of equal: \t"+str(round(minequal,3))+"\n"
            txtstochsim+=" average of equal: \t"+str(round(avequal,3))+"\n"
            txtstochsim+=" maximum of equal: \t:"+str(round(maxequal,3))+2*"\n"

            txtstochsim+="Comparison with the two possible self-similarities "+"\n"
            txtstochsim+="self-similarity of dm1 :"+"\n"
            txtstochsim+="iso-self "+str(round(isoss1,3))+"\n"
            txtstochsim+="anti-self "+str(round(antiss1,3))+"\n"
            txtstochsim+="weakiso-self "+str(round(weakss1,3))+"\n"
            txtstochsim+="indiff-self "+str(round(indiffss1,3))+"\n"
            txtstochsim+="equal-self "+str(round(equalss1,3))+2*"\n"
            txtstochsim+="self-similarity of dm2 :"+"\n"
            txtstochsim+="iso-self "+str(round(isoss2,3))+"\n"
            txtstochsim+="anti-self "+str(round(antiss2,3))+"\n"
            txtstochsim+="weakiso-self "+str(round(weakss2,3))+"\n"
            txtstochsim+="indiff-self "+str(round(indiffss2,3))+"\n"
            txtstochsim+="equal-self "+str(round(equalss2,3))+"\n"
        else:
            txtstochsim+=" Sorry for that inconvenience! ++++"+"\n"
        
        #result preparation
        
        
        
        tstochsim.insert("end",txtstochsim)

    

    

    

        
    



hf=Tkinter.Tk()
hf.title("Similarity of posets")
lblayout=Tkinter.Label(hf,text="                             Proximity/similarity analysis                    ")
lblayout.pack(pady=5)
helpabout=raioop2.brgabout(hf,"tp1","about_simi.txt",10,\
            "August, the 4th,2012"," about_simi ", "white", "t1",120,5,ScrolledText)
    

helpsimi=raioop2.brgabout(hf,"tp1","help_simi.txt",10,\
            "August, the 4th, 2012"," help_simi ", "white", "t1",120,5,ScrolledText)
    
fr=Tkinter.Frame(hf,width=600,height=600)
fr.pack()


    

lbopenfile=Tkinter.Label(fr,text="select the files")
lbopenfile.pack()
fro=Tkinter.Frame(fr)
fro.pack()
butt1=Tkinter.Button(fro,text="(1a)select and open the files",bg="white",command=simi_fileselect)
butt1.pack(pady=10, side="left")
lbbutt12=Tkinter.Label(fro,text= " or..")
lbbutt12.pack(pady=10,side="left")
butt1a=Tkinter.Button(fro,text="(1b) select and open pdt-files ",bg="white",command=pdt_open)
butt1a.pack(pady=10,side="left")
butt2=Tkinter.Button(fr,text="(2a) show data matrix 1",command=showDM1)
butt2.pack()
butt3=Tkinter.Button(fr,text="(2b) show data matrix 2",command=showDM2)
butt3.pack()

buttchar1=Tkinter.Button(fr,text="(3a) characteristics of data matrix1",command=matchar1)
buttchar1.pack()
buttchar2=Tkinter.Button(fr,text="(3b) characteristics of data matrix2",command=matchar2)
buttchar2.pack()

butt2=Tkinter.Button(fr,text="(4)calculation of similarity",width=25,bg="cyan",bd=4,command=siman)
butt2.pack(pady=10)
frapart=Tkinter.Frame(fr,relief="sunken",bd=3)
frapart.pack()
lbantipart=Tkinter.Label(frapart,text="insert lower limit (left entry) \nand upper limit (right entry) for degree of antitone")
lbantipart.pack()
elimit1=Tkinter.Entry(frapart,width=5)
elimit1.pack(side="left")
elimit2=Tkinter.Entry(frapart,width=5)
elimit2.pack(side="right")
buttpanti=Tkinter.Button(fr,text="partitoning of objects due to the given limits ",bg="cyan",command=partantitone)
buttpanti.pack()
butthd1=Tkinter.Button(fr,text=" Calc. PO and\n show Hasse diagram 1",width=25,bg="cyan",command=HD1)
butthd1.pack(pady=5)
butthd2=Tkinter.Button(fr,text=" Calc. PO and\n show Hasse diagram 2",width=25,bg="cyan",command=HD2)
butthd2.pack()
buttrkav=Tkinter.Button(fr,text="Analysis due to rkav (LPOMext) ",width=25, bg="cyan",command=rkavanal, state="disabled")
buttrkav.pack()
lbmact=Tkinter.Label(fr,text="insert number of attributes for a U-based similarity ")
lbmact.pack(pady=2)
emact=Tkinter.Entry(fr,width=4)
emact.pack()
buttsimartif=Tkinter.Button(fr,text="U-based similarity",width=25,bg="cyan",command=simartif)
buttsimartif.pack()
fr2=Tkinter.Frame(hf,bd=3,relief="sunken")
fr2.pack(pady=5)
lbstochsim=Tkinter.Label(fr2,text=" ")
lbstochsim.pack()
lbstochsim2=Tkinter.Label(fr2,text="which of the matrix has more attributes (1 or 2?) ")
lbstochsim2.pack()
eseluser=Tkinter.Entry(fr2,width=3)
eseluser.pack()
buttstochsim=Tkinter.Button(fr2,text="stochastic similarity ",width=25,bg="cyan",command=stochsim)
buttstochsim.pack()
lbstochsiminfo=Tkinter.Label(fr2, text=" ")
lbstochsiminfo.pack()
frexit=Tkinter.Frame(hf)
frexit.pack(pady=5)
buttexit=Tkinter.Button(frexit,text = " Exit ", width=25,bg="red",command=hf.destroy)
buttexit.pack()


hf.mainloop()
