import Tkinter
import rmod2
import raioop2
from ScrolledText import *
import Canvas
import os
import tkMessageBox
import tkFileDialog
import stats
import pstat
import random



# Brg 14.12.07, 17.12.07, 13.1.08, 4.2.08
# g-stability fields
# Brg 19.2.08: Toplevel: titles
# May 08: Brg adaptations because of changes in rmod2
# 7.6.08: Important step: How to avoid the case where no incomp. pair is found
# Brg 10.10.08 Help text now as external file. Loading by an OOP-function
# HD of a weight-interval
# Brg 20.6.2012 cosmetics
# Brg 21.6.2012 rearrangements to stability6.py
# Brg 24.6.2012 further steps toward stability8
# Brg 25.6.2012 stability9 (once again a change in ideas)
# Brg 23.4.2013;: about: extended

   

def msgwarning2():
    tkMessageBox.showwarning("++Wrong attribute Number selected ++"," you must select a file")

def msgwarning():
    tkMessageBox.showwarning("++No data matrix available ++"," you must select a file")

    
def fileselect():
    """ File selection and opening by Tkinter-Standards"""
    #*13.1.08
    #akt: 13.1.08
    #note: There may be conflicts with other moduls
    #source:-
    tp=Tkinter.Toplevel(hf)   #19.2.08
    tp.title(' select/open ')
    global fn
    fn=tkFileDialog.askopenfilename()
    
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    

    lbfile=Tkinter.Label(tp,bg="yellow",text="selected file : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns")
    lbfile.pack()
    return r,k,dm,ob,pro,fn

         
def showDM():
    """ New routine : shows the data matrix """
    #Brg 13.1.08
    tp2=Tkinter.Toplevel(hf)
    tp2.title(' show DM ')
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+ob[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+pro[j+1]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=pro[j+1]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=ob[i+1]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)

def shownormalizedDM():
    """ New routine : shows the data matrix """
    #Brg 13.1.08
    tp2n=Tkinter.Toplevel(hf)
    tp2n.title(' show normalized DM ')
    tfilen=ScrolledText(tp2n,width=60,height=4)
    tfilen.pack()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+ob[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+pro[j+1]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=pro[j+1]+"\t"
    txt3+="\n"
    xn=rmod2.matrixnorm(r,k,dm)
    for i in range(0,r):
        txt3+=ob[i+1]+"\t"
        for j in range(0,k):
            txt3+=str(xn[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfilen.insert("end",txt)



def about():
    """ About stability """
    # Brg 12.12.07, 10.10.08, 23.4.2013
    hfabout=Tkinter.Tk()
    
    lbstart0=Tkinter.Label(hfabout,text="Some information ")
    lbstart0.pack(fill="x",pady=20)
    lbstart1=Tkinter.Label(hfabout,text="                         ",relief="sunken")
    lbstart1.pack(fill="x",pady=15)
    lbstart2=Tkinter.Label(hfabout,text="                         ",relief="sunken")
    lbstart2.pack(fill="x",pady=15)
    lbstart3=Tkinter.Label(hfabout,text="                         ",relief="sunken")
    lbstart3.pack(fill="x",pady=15)
    lbstart4=Tkinter.Label(hfabout,text="                         ",relief="sunken")
    lbstart4.pack(fill="x",pady=15)
    lbstart5=Tkinter.Label(hfabout,text="                         ",relief="sunken")
    lbstart5.pack(fill="x",pady=15)
    lbstart6=Tkinter.Label(hfabout,text="                         ",relief="sunken")
    lbstart6.pack(fill="x",pady=15)
    lbstart7=Tkinter.Label(hfabout,text="                         ",relief="sunken")
    lbstart7.pack(fill="x",pady=15)
    lbstart1["text"]="Author: R. Bruggemann: e-mail: brg_home@web.de\nDec,14th,2007\nstability\
        version 1 see\n Ecological Modeling and Software 23, 1000-1012, 2008 (see also help function)"
    lbstart2["text"]="The progam stability reads an EXCEL.txt-file (separators are tabs"
    lbstart3["text"]="Your Excel-File should be in the same directory as the calling\nprogram, to avoid errors in environmental variables"
    lbstart4["text"]="rows <= 200, columns <= 200"
    lbstart5["text"]="For more information, press Button 'help' "
    lbstart6.config(bg="yellow")
    lbstart6["text"]="Note: Calculation of the crucial weight spectrum \
is based on the quotient set! \nThe corresp. reduction is automatically done"
    lbstart7["text"]="Statistical software: pstat, stats: taken from Internet,\ngranted: Gary Strangman, version of 2007."

def filecomp(fn):
    """ reduces a dm with equiv objects to a dm of a quotient set """
    # Brg 12.12.07, 13.1.08, 8.5.08
    # von mainHD3 uebernommen und geringfuegig angepasst
    #r,k,dm,ob,pro,fn are globals and should be available after open
    global prop, obj
    dm,ob,pro,r,k1=rmod2.EXCELreadin4(fn)
    #recoding ob to obj and pro to prop
    print "in filecomp k1: ",k1
    if r==0:
        hfwarning=Tkinter.Toplevel(hf)
        hfwarning.title('warning')
        frwarning=Tkinter.Frame(hfwarning,width=10,height=3)
        frwarning.pack()
        bwarning=Tkinter.Button(frwarning,text="++warning ++",command=msgwarning)
        bwarning.pack()
        
    prop=rmod2.vecgentext1(k1)
    obj=rmod2.vecgentext1(r)    #8.5.08 changed: ...text1
    for i in range(0,k1):
        prop[i]=pro[i+1]
    for i in range(0,r):
        obj[i]=ob[i+1]
    #############################dieser Teil ist neu 21.12.07
    rred,xred,objred,txt=rmod2.equivcompact(r,k1,dm,obj)    
    ###############################################################
    #print objred
    #print "reduzierte matrix"
    #rmod2.matout(rred,k,xred)
    return rred,k1,xred,objred,obj,prop,txt           

def stabcalc():
    """ calculates the g-spectrum  """
    # Brg 14.12.07, 03.06.18
    # 03.06.18: The output of crucial weights should be subpressed if the user wants
    global fn,x,xn,y,r,rred,obj,objred,prop, att1,att2,k,gc,np   #21.1.08, 21.1.11 
    r,km,x,ob,pro,fn=fileselect()
    print "r nach Einlesen ",r, "   km nach Einlesen",km
    subpress=esubpress.get()
    obj=rmod2.vecgentext1(r)
    prop=rmod2.vecgentext1(km)
    # recodings
    for i in range(0,r):
        obj[i]=ob[i+1]
    for j in range(0,km):
        prop[j]=pro[j+1]
    # extract the equivalent elements
    xn=rmod2.matrixnorm(r,km,x)
    rred,k,xred,objred,obj,prop,txt=filecomp(fn)
    flageq=0
    print "rred nach filecomp ",rred
    #rmod2.matout(rred,k,xred)
    # folgender Teil von mainHD3 uebernommen
    l1=len(obj)
    l2=len(objred)
    if l1!=l2:
        hfeq=Tkinter.Toplevel(hf)
        hfeq.title('equivalence classes')
        lbeq1=Tkinter.Label(hfeq,text="Structure: quotient set")
        lbeq1.pack()
        labeq=Tkinter.Label(hfeq,text="representants and their\n equivalent objects")
        labeq.pack()
        txteq=ScrolledText(hfeq,width=60,height=4)
        txteq.pack()
        txteq.insert("end",txt)
    ######################################
    
    # matrix characteristics
    txtchar="\nsome characteristics of the complete data matrix\n"
    #rmod2.matout(rred,k,xred)
    ch=rmod2.matrixchar(rred,k,xred)
    txtchar+= "\tcol\tmax\tmin\tmean\tstdev\n"
    
    for i in range(0,k):
        txtchar+="property "+prop[i]+":\t"
        for j in range(0,4):
            txtchar+=str(round(ch[j][i],2))+"\t"
        txtchar+="\n"    
    txtchar+=" -- end of 'characteristics ' --"
    hfresults=Tkinter.Toplevel(hf)
    hfresults.title('results')
    
    lbresults2=Tkinter.Label(hfresults,text=" stability: Results ")
    lbresults2.pack()
    frresults=Tkinter.Frame(hfresults,width=200,height=400)
    frresults.pack()
    tr1=ScrolledText(frresults,width=60,height=3)
    tr1.pack()
    tr1.insert("end",txtchar)
    
    # normalization
    y=rmod2.matrixnorm(rred,k,xred)
    #rmod2.matout(rred,k,y)

    
    ############################################################
    # main calculation                                         #
    ############################################################

    #generating gc-values (normalized to interval (0,1): called a)

    gc=[]

    lbinform1=Tkinter.Label(frresults,text=" Select two attributes out of "+str(k)+"  atrributes")
    lbinform1.pack()
    text=""
    att1=int(attribut1.get())
    att2=int(attribut2.get())
    print "at line 258 "
    print "prop= ",prop
    print "att1= ",att1,"   att2 = ",att2
    lbinform2=Tkinter.Label(frresults,text="attributes "+prop[att1]+" and "+prop[att2]+"  selected\n\
        weight g is related to "+str(prop[att1])+", weight 1-g is related to "+str(prop[att2]))
    lbinform2.pack()
    #print "rred in maincalculation ",rred
    if att1>k-1 or att2>k-1:
        hfwarning2=Tkinter.Tk()
        frwarning2=Tkinter.Frame(hfwarning2,width=10,height=3)
        frwarning2.pack()
        bwarning2=Tkinter.Button(frwarning2,text="++warning2 ++",command=msgwarning2)
        bwarning2.pack()

    zaehlgc=0    
    for i in range(0,rred):
        for j in range(i,rred):
            if i!=j:
                delta2=y[i][att2]-y[j][att2]
                delta1=y[i][att1]-y[j][att1]
                nenner=1.0*(delta2-delta1)
                if abs(nenner)!=0:
                     zaehlgc+=1
                     q=1.0*delta2/nenner
                     gc.append(q)
                     text=text+"("+objred[i]+","+objred[j]+")"+";"
                else:
                     pass
                         
                
    tp=text.split(";")
    np=zaehlgc
    txtpair="\n"+str(np)+" nonpurified critical object pairs  \n"
    tpl=len(tp)
    for i in range(0,tpl-1):
        txtpair+=str(prop[att1])+": "+str(round(gc[i],2))+" : "+tp[i]+"\n"
        
    txtpair+="\n"
    tr2=ScrolledText(frresults,width=60, height=3)
    tr2.pack()
    tr2.insert("end",txtpair)
        
    z=0
    for i in range(0,np):
        if gc[i]>0 and gc[i]<1:   
            z+=1
    npur=z
    
    lbres=Tkinter.Label(frresults,text=str(npur)+" cruc. weights in open interval (0,1)")
    lbres.pack()
    a=rmod2.vecgen1(npur)
    zaehl=rmod2.vecgen1(npur)
    iz=0
    for i in range(0,np):
        if gc[i]>0 and gc[i]<1:
            a[iz]=round(gc[i],3)
            iz+=1
    lb=Tkinter.Label(frresults,text="")
    lb.pack()
    lb.config(bg="yellow")    
    if npur!=0:   #check whether npur =0 because by chance both
                    #   ....attribute make a chain
        amax=max(a)
        amin=min(a)
        a.sort()
        for i in range(0,npur):
            zaehl[i]=1
        for i in range(0,npur-1):
            
            for i1 in range(i+1,npur):
                if a[i]==a[i1]:
                    zaehl[i]+=1
    ##    for i in range(0,n):
    ##        print zaehl[i]," ",
    ##    print " "    
        zmax=max(zaehl)
        faktor=int(80.0/(1.0*zmax))
        txt=""
        
        
        
        for i in range(0,npur):
            txt+=str(a[i])+"   "
            if i>0 and i%15==0:
                txt+="\n"
        if subpress!="n":        
            lb["text"]=txt            #03.06.18
            
        cv=Tkinter.Canvas(frresults,width=210,height=125)
        delta=1.0*(amax-amin)/(1.0*npur)
        deltapres=int(200.0*delta/5.0)
        deltapress=max(deltapres,3)
        
    ##  print "Characteristics: ",amin," ",amax," ",deltapres
        cv.create_rectangle(0,100,210,0,fill="white",outline="black",width=2)
        for i3 in range(0,210):
            if int(1.0*i3/50.0)-(1.0*i3/50.0)==0:
                cv.create_text(i3,110,text=str(round(1.0*i3/200.0,2)))
        
        for i in range(0,npur):
            cv.create_rectangle(200*a[i],100,200*a[i]+deltapress,100-zaehl[i]*faktor,fill="blue")
            
        cv.create_line(0,100,200,100,fill="black")
        
        cv.create_text(95,120,text="g-spectrum ")    

        cv.pack()

        txtpair2="\n purified g-values and their crucial object pairs \n"
        txtpair2+="No "+"\t"+"obj-pair"+"\t"+"attr1"+":\t"+"gc1"+"\t"+"attr2"+"\t"+"gc2"+"\n"
        for i in range(0,np):
            if gc[i]>0 and gc[i]<1:   
                txtpair2+=str(i)+":\t"+tp[i]+"\t"+str(prop[att1])+":\t"\
                           +str(round(gc[i],3))+"|\t"+str(prop[att2])+":\t"+str(round(1.0-gc[i],3))+"\n"
                
        tr4=ScrolledText(frresults,width=60,height=4)
        tr4.pack()
        tr4.insert("end",txtpair2)
           
    else:   #npur=0
        lb.config(text="+++ there is no incomparability +++ ",bg="yellow")


def submitemord():
    # brg 22.6.2012
    empord=eord.get().split(",")
    flord=[]
    lempord=len(empord)
    sumtest=0
    for i in range(0,lempord): #string--> float
        flord.append(float(empord[i]))
        sumtest+=float(empord[i])
       
    if sumtest!=1.0:
        txtwarn= "warning: your weight do not sum up to 1.0 \n"
        txtwarn+= "correction internally done"
        lbwarn.config(text="+++"+txtwarn+"+++",bg="yellow") 
        for i in range(0,lempord):
            flord[i]=1.0*flord[i]/sumtest
            #print "corrected: ",flord[i]
    #print flord[0]
    #print flord[1]
    
    return flord



def gdist():
    # brg 21.6.2012, 24.6.2012
    #
    # analysis of linear orders
    # On the one hand one may have an empirical weigh system
    # On the other hand in stability-module one is interested in the contribution of
    # a selected attribute pair. How does this fit.
    import math
    global pempnew,empweight,pemp,distance, delta,testcases
    empweight=submitemord()  # empirical weights
    pemp=rmod2.vecgen1(r)   #empirical CI
    for i in range(0,r):
        for j in range(0,k):
            pemp[i]+=empweight[j]*xn[i][j]

    pempnew=pstat.lrankdata(pemp)

    #control
##    print "empirical"
##    for i in range(0,r):          
##        print obj[i],"   pempnew= ",pempnew[i]
##    print " "
    distance=[]
    
    testcases=50   #24.6.2012 
    delta=1.0/(1.0*testcases)
    g1vec=[]
    g1=0.0
    for ig in range(0,testcases+1):   #scanning weights
        g2=1.0-g1
        g1vec.append(g1)
        p=rmod2.vecgen1(r) #p now according to a certain stability field
        for io in range(0,r):
            p[io]=g1*xn[io][att1]+g2*xn[io][att2]

        
        #generating ranks
        pnew=pstat.lrankdata(p)
        #if 0.8<g1<=1.0:
            #print "g1= ",g1
            #for itest in range(0,r):
                #print obj[itest],"    pnew ",pnew[itest]
            #print " "    
        
        dis_act=rmod2.rankdistance(r,pempnew,pnew)
        distance.append(dis_act)    
          
        g1+=delta
    
    #for ig in range(0,testcases+1):
        #print g1vec[ig]," ",distance[ig]
    #print " "
    names=rmod2.vecgen1(3)
    names[0]="weights"
    names[1]="distance"
    names[2]="distance vs g"+str(prop[att1])+", "+str(prop[att2])
    app1=raioop2.brggraph5(hf,names,"red",2,distance,0,1)
    app1.ausgabe()

def detailsdistance():
    #brg 25.6.2012
    empweight=submitemord()  # empirical weights
    mindis=99999
    ld=len(distance)
    for i in range(0,ld):
        if distance[i]<=mindis:
            ispez=i
            mindis=distance[i]
    print "mindis= ",mindis
    txt1="empirical weights:"+"\n"
    for j in range(0,k):
        txt1+=str(empweight[j])+", "
    txt1+=2*"\n"    
    txt1="Minimal distance = "+str(round(mindis,3))+"\n"
    txt1+="largest g-value in the 2-att-system with minimal distance"+"\n"
    txt1+=str(ispez*delta)+"\n"
    for i in range(0,ld):
        if distance[i]<=mindis:
            ispez2=i
            break
    txt1+="smallest g-value in the 2-att-system with minimal distance"+"\n"
    txt1+=str(ispez2*delta)+"\n"
    txt1+=" - - - e o f - - -  "
    tpdetails=Tkinter.Toplevel(hf)
    tdetails=ScrolledText(tpdetails,width=60,height=5)
    tdetails.pack()
    tdetails.insert("end",txt1)
    
def linordanalysis():
    # brg 25.6.2012
    # based on the result og gdist one may be interested in the role of a
    # specific weight in the two-attribute-system
    gcheck=float(egcheck.get())
    txtlinorder="Comparison with an empirical CI "+"\n"
    txtlinorder+=60*"="+"\n"
       
    
    txthilf="order in nearby stability field    due to CI empirical"+"\n"
    pspez=rmod2.vecgen1(r)
    for i in range(0,r):
        pspez[i]=gcheck*xn[i][att1]+(1.0-gcheck)*xn[i][att2]
    rankspez=pstat.lrankdata(pspez)
    
    print "pspez ",pspez
    newpext=rmod2.objsort2(r,obj,rankspez)
    print "newpext= ",newpext
    newpemp=rmod2.objsort2(r,obj,pempnew)
    print "newpemp = ",newpemp
    txtpext=rmod2.objsort2print4(r,newpext)
    txtpemp=rmod2.objsort2print4(r,newpemp)
    txtpextresult=rmod2.objsort2print6(r,txtpext)
    txtpempresult=rmod2.objsort2print6(r,txtpemp)
    #note txtpextresult, txtpempresults are vectors of length r
    
    txtranks="ranks of the weight "+str(gcheck)+" of "+str(prop[att1])+" within the two-attribute-system "+"\n"
    txtranks+=str(prop[att1])+", "+str(prop[att2])+"\n"
    txtranks+="Objects:  CI("+str(prop[att1])+","+str(prop[att2])+")     "+"emp_CI     emp_ranks\n"
    txtranks+=60*"-"+"\n"
    for i in range(0,r):
        txtranks+=str(obj[i])+":       "+str(round(pspez[i],3))+"      "+str(rankspez[i])\
                   +"                "+str(round(pemp[i],3))+"     "+str(pempnew[i])+"\n"
    txtranks+="\n- - - e o f - - - "+"\n"

    txtlinorder+="\nSorting of objects based on weight "+str(gcheck)+" based on "+str(prop[att1])+","+str(prop[att2])\
                  +"   (left side)"+"\n"+"versus empirical CI with the weights: (right side)"+"\n"
    for j in range(0,k):
        txtlinorder+=str(empweight[j])+", "
    txtlinorder+="\n"    
    tpspez=Tkinter.Toplevel(hf)
    tpspez.title(' detail info to best fit ')
    tspez=ScrolledText(tpspez,width=120,height=10)
    tspez.pack()
    tspez.insert("end",txtranks)
       
    for i in range(0,r):
        txtlinorder+=str(txtpextresult[i])+2*"\t"+str(txtpempresult[i])+"\n"

    tplinorder=Tkinter.Toplevel(hf)
    tplinorder.title(' comparison with empirical CI ')
    tlinorder=ScrolledText(tplinorder,width=80,height=20,tabs=('2c','10c','50c'))
    tlinorder.pack()
    tlinorder.insert("end",txtlinorder)
     
def order_in_stabfields():
    # brg 21.6.2012
    txtstab="order in stabfields "+"\n"
    txtstab+=60*"="+"\n"
    gcorder,ngc=rmod2.raisort(np,gc)  # gc ordered increasingly
    gcorderpos=[]
    gcorderpos.append(0)
    for ig in range(0,np):
        if 0<gcorder[ig]<1:
            gcorderpos.append(gcorder[ig])
    gcorderpos.append(1)
    print "gcorderpos= ",gcorderpos
    lg=len(gcorderpos)
    objgc=[]
    
    for inp in range(0,lg):
        objgc.append(str(round(gcorderpos[inp],2)+0.01))#crucial weight+0.01 to meet the stabfield
        gtrial=gcorderpos[inp]+0.01
        ptrial=[]
        for i in range(0,r):
            ptrial.append(gtrial*xn[i][att1]+(1.0-gtrial)*xn[i][att2])
            
        ptrialranks=pstat.lrankdata(ptrial)
        txtstab+=str(objgc[inp])+":\t"
        hilfnew=rmod2.objsort2(r,obj,ptrialranks)
        txthilf2=rmod2.objsort2print4(r,hilfnew)
        txthilf3=rmod2.objsort2print7(r,txthilf2)
        txthilf4=""
        for i in range(0,r):
            txthilf4+=str(txthilf3[i])    
        txtstab+=txthilf4+2*"\n"
    txtstab+="- - - e o f - - - "    
    tpstab=Tkinter.Toplevel(hf)
    tpstab.title(' linear orders near crucial weights ')
    tstab=ScrolledText(tpstab,width=80,height=10)
    tstab.pack()
    tstab.insert("end",txtstab)
    
            

def HDinterval():
    # Brg 21.1.2011
    global zeta21,rred1,objred1
    uplimit=int(euplimit.get())
    g1=float(eg1.get())
    g2=float(eg2.get())
    delta=1.0*(g2-g1)/(1.0*uplimit)
    
    tpginterval=Tkinter.Toplevel(hf)
    tpginterval.title(" HD of g-interval ")
    lbginterval=Tkinter.Label(tpginterval,text= "  g-interval "+str(g1)+"........"+str(g2)+"\n  no of steps "+str(uplimit)\
                              +"   width of steps: "+str(delta),bg="yellow")
    lbginterval.pack()
    freq1=Tkinter.Frame(tpginterval)
    freq1.pack()
##    print "npur = ",npur
##    print "g1= ",g1,"  g2= ",g2
    #uplimit number of test rankings within the given g-interval
    y=rmod2.matrixnorm(r,k,x)   #21.1.2010
    rred1,xred1,objred1,txtquot=rmod2.equivcompact2(r,att1,att2,y,obj)
    print "###structure of xred1  ##"

    dmg=rmod2.marray(rred1,uplimit+1)
    
    for ig in range(0,uplimit+1):
        g11=g1+delta*ig
        g21=1.0-g11
        p=rmod2.vecgen1(rred1)
        for io in range(0,rred1):
            p[io]=g11*xred1[io][0]+g21*xred1[io][1]  #21.1.2011 crucial change
        lio=pstat.lrankdata(p)
        for io in range(0,rred1):
            dmg[io][ig]=lio[io]     #dmg will be filled with the different rankings counted by ig
                

    zetahilf1=rmod2.comp(rred1,uplimit,dmg)
    zeta1=rmod2.marray(rred1,rred1)
    for i in range(0,rred1):
        for j in range(0,rred1):
            zeta1[i][j]=zetahilf1[j][i]
    #
    
    #rmod2.matout(rred,rred,zeta)
    lobj1,lext1,revlext1,zzmax1=rmod2.levtopsort(rred1,zeta1)
    #print "zzmax = ",zzmax
    tlev1=ScrolledText(freq1,height=10,width=60)
    tlev1.pack()
    txt1="\n"
    for i in range(0,zzmax1):
        txt1+="Level "+str(zzmax1-i)+" :"
        for j in range(0,len(lobj1[i])):
            txt1+= objred1[lobj1[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev1.insert("end",txt1)

        
    #Adj-Listen

    adjc1=rmod2.adjacent(rred1,lext1,revlext1,zeta1)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred1,adjc1,lext1)
       
    
    zeta21=rmod2.cover(rred1,tr,lext1)
    if rred1>150:
        lbhd2=Tkinter.Label(freq1,text=" graphical presentation not meaningful, see levels and cover-matrix ")
        lbhd2.pack()
        txt3="\n cover-matrix  \n"
        for i in range(0,rred1):
            txt3+="\t"+objred1[i]+"\t"
        txt3+="\n"
        for i in range(0,rred1):
            txt3+=objred1[i]+" :"
            for j in range(0,rred1):
                txt3+=str(zeta21[i][j])+"\t"
            txt3+="\n"
        txt3+=" -- end of list --"
        tcov=ScrolledText(freq1,width=60, height=4)
        tcov.pack()
        tcov.insert("end",txt3)
    else:
        lbhd3=Tkinter.Label(freq1,text=" Hasse Diagram of File "+fn)
        lbhd3.pack()
        cv=Tkinter.Canvas(freq1,width=300,height=240,bg="white")
        lz=zzmax1
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj1[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(rred1,rred1)
        geomy=rmod2.marray(rred1,rred1)

        geom0x=10
        geom0y=20
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(160.0/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(160.0/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if zeta21[lobj1[i1][j1]][lobj1[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred1[lobj1[i][j]])
        garrow1x=210
        garrow1y=20
        garrow2y=190
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.create_text(50,230,text="file :"+fn)
        
        
        buttcover=Tkinter.Button(freq1,text="show cover relation",command=cover1_show)
        buttcover.pack()
        cv.pack()

def HD():
    "based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"
    # Brg 20.12.07, 28.12.07, 21.1.08, 24.6.2012
    # If the number of representants > 100 then only the cover-matrix and the level-population
    # almost the same as in mainHD3
    # from stabcalc r,k,prop, obj, x are known  (21.1.08)
    global zeta2,objred,fn,n
    try:
        perturb=int(eperturb.get())
    except:
        perturb=0
    
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram or cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    
    #print "att1 = ",att1,"   att2 =",att2   
    rred,xred,objred,txtquot=rmod2.equivcompact2(r,att1,att2,x,obj)    
    #rred is now the number of representants of the dm-matrix with columns att1 and att2
    #xred is the correspondingly reduced data matrixc with two columns
    n=rred
    labeq=Tkinter.Label(freq,text="file = "+fn+": calc. is based on representants\n\
        selected attributes: "+str(prop[att1])+", "+str(prop[att2]))
    labeq.config(bg="yellow")
    labeq.pack()
    
    l1=len(obj)
    l2=len(objred)
    if l1!=l2:
        hfeq2=Tkinter.Toplevel(hf)
        hfeq2.title('equiv. classes')
        lbeq1=Tkinter.Label(hfeq2,text="Structure: quotient set")
        lbeq1.pack()
        labeq=Tkinter.Label(hfeq2,text="representants and their\n equivalent objects")
        labeq.pack()
        txteq=ScrolledText(hfeq2,width=60,height=4)
        txteq.pack()
        txteq.insert("end",txtquot)
    #print "att1 =",att1,"  att2  =",att2,"  n=",n
    
    zetahilf,at1,at2=rmod2.comp2(n,0,1,xred)
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    Utotal=0
    for i1 in range(0,rred):
        for i2 in range(0,rred):
            if zeta[i1][i2]==0 and zeta[i2][i1]==0:
                Utotal+=0.5
    print "Utotal= ",Utotal            
    #One linear extension (based on levels)
    lbhd1=Tkinter.Label(freq,text= "Utotal("+str(prop[att1])+", "+str(prop[att2])+") = "+str(Utotal))
    lbhd1.pack()

    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
    #print "zzmax = ",zzmax
    tlev=ScrolledText(freq,width=60,height=4)
    tlev.pack()
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
    txt1="\n"
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= objred[lobj[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)

    txt2="\n One linear extension \n\n"
    for i in range(0,n):
        if i<n-1:
            txt2+=objred[revlext[i]]+" < "
        else:
            txt2+=objred[revlext[i]]+"\n"
    txt2+="\n"
    txt2+="\n -- end of list -- "
    tlinext=ScrolledText(freq,width=60, height=2)
    tlinext.pack()
    tlinext.insert("end",txt2)
    
    #Adj-Listen

    adjc=rmod2.adjacent(n,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(n,adjc,lext)
       
    
    zeta2=rmod2.cover(n,tr,lext)
    if n>200:
        lbhd2=Tkinter.Label(freq,text=" graphical presentation not meaningful, see levels and cover-matrix ")
        lbhd2.pack()
        txt3="\n cover-matrix  \n"
        for i in range(0,n):
            txt3+="\t"+objred[i]+"\t"
        txt3+="\n"
        for i in range(0,n):
            txt3+=objred[i]+" :"
            for j in range(0,n):
                txt3+=str(zeta2[i][j])+"\t"
            txt3+="\n"
        txt3+=" -- end of list --"
        tcov=ScrolledText(freq,width=60, height=4)
        tcov.pack()
        tcov.insert("end",txt3)
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram of File "+fn+\
                            "  attributes: "+str(prop[att1])+", "+str(prop[att2])+"\n Utotal = "+str(Utotal))
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

               
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=(perturb*random.randint(1,5)+1)*geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if zeta2[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
##        cv.create_line(garrow1x-4,garrow2y-4,garrow1x,garrow2y)
##        cv.create_line(garrow1x+4,garrow2y-4,garrow1x,garrow2y)
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.create_text(20,10,text="file :"+fn+"  1. attr: "+prop[att1]+"  2.attr: "+prop[att2])
        
        cv.pack()
        buttcover=Tkinter.Button(freq,text="show cover relation",command=cover_show)
        buttcover.pack()

def cover_show():
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: -
    hfcover=Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    
    lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,n):
        txt3+="\n"+objred[i]+":\t"
        txt3+="is covered by "
        for j in range(0,n):
            if i!=j:
                if zeta2[i][j]==1:
                    txt3+=" "+objred[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=4)
    tcov.pack()
    tcov.insert("end",txt3)
          
def cover1_show():
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: -
    hfcover1=Tkinter.Toplevel(hf)
    hfcover1.title(' cover-matrix ')
    
    lbhd2=Tkinter.Label(hfcover1,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,rred1):
        txt3+="\n"+objred1[i]+":\t"
        txt3+="is covered by "
        for j in range(0,rred1):
            if i!=j:
                if zeta21[i][j]==1:
                    txt3+=" "+objred1[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover1,width=50, height=4)
    tcov.pack()
    tcov.insert("end",txt3)

hf=Tkinter.Tk()
hf.title('-- stability analysis -- ')

helpstability=raioop2.brgabout(hf,"tp1","help_stability.txt",9,\
            "June, the 3rd,2018"," help_stability ", "white", "t1",120,6,ScrolledText)
    

buttabout=Tkinter.Button(hf,bg="green",text="About..",command=about)
buttabout.pack()


frinput=Tkinter.Frame(hf,width=60,height=2, relief="sunken",bd=4)
frinput.pack(pady=20)
lbe=Tkinter.Label(frinput,text="1.attribute(please column nr 0,1,2....)")
lbe.grid(row=0,column=0)
attribut1=Tkinter.Entry(frinput,width=3)
attribut1.grid(row=0,column=1)
lbe2=Tkinter.Label(frinput,text="2.attribute(please column nr 0,1,2....)")
lbe2.grid(row=1,column=0)
attribut2=Tkinter.Entry(frinput,width=3)
attribut2.grid(row=1,column=1)
lbesubpress=Tkinter.Label(hf,text="the output may be very large, to subpress it: enter 'n'")
lbesubpress.pack()
esubpress=Tkinter.Entry(hf,width=5)
esubpress.pack()
buttmain=Tkinter.Button(hf,text=" Select\nopen and\n start program ",bd=5,bg="cyan",width=30,command=stabcalc)
buttmain.pack(pady=10)
frshow=Tkinter.Frame(hf)
frshow.pack()
butt2=Tkinter.Button(frshow,text="show   dm",command=showDM)
butt2.pack(side="left")
butt2n=Tkinter.Button(frshow,text="show normal. dm",command=shownormalizedDM)
butt2n.pack(side="right")
lbCIcruc=Tkinter.Label(hf,text="enter empirical weights ")
lbCIcruc.pack()
lbwarn=Tkinter.Label(hf,text="")
lbwarn.pack()
eord=Tkinter.Entry(hf,width=20)
eord.pack()
buttdistance=Tkinter.Button(hf,text="Distance vs g \nin the two attribute's system",\
                            width=30,bg="cyan",command=gdist)
buttdistance.pack()
buttdetails=Tkinter.Button(hf,text="details to distances ",bg="cyan",width=30,command=detailsdistance)
buttdetails.pack()
lbgcheck=Tkinter.Label(hf,text="Enter a weight related to the two-attribute-system ")
lbgcheck.pack()
egcheck=Tkinter.Entry(hf,width=5)
egcheck.pack()
buttCIcruc=Tkinter.Button(hf,text=" Comparison crucial weights\n and empirical weights ",bg="cyan",width=30,command=linordanalysis)
buttCIcruc.pack()
buttoistab=Tkinter.Button(hf,text="linear orders near crucial weights ",bg="cyan",width=30,command=order_in_stabfields)
buttoistab.pack()
frinterval=Tkinter.Frame(hf,bd=3,relief="sunken")
frinterval.pack(pady=5)
lbexplan=Tkinter.Label(frinterval,text="no test-rankings, lower limit, upper limit of g")
lbexplan.pack()
euplimit=Tkinter.Entry(frinterval,width=12)
euplimit.pack(side="left")
eg1=Tkinter.Entry(frinterval,width=10)
eg1.pack(side="left")
eg2=Tkinter.Entry(frinterval,width=10)
eg2.pack(side="left")
buttginterval=Tkinter.Button(hf, text="HD of the selected g-interval ",bg="cyan", command=HDinterval)
buttginterval.pack()
lbperturb=Tkinter.Label(hf,text="Enter 0: no perturbation, 1,2,... for increasingperturbation of the Hassediagram")
lbperturb.pack()
eperturb=Tkinter.Entry(hf,width=3)
eperturb.pack()
buttHD=Tkinter.Button(hf,text="show HD for selected attributes",command=HD)
buttHD.pack()

buttexit=Tkinter.Button(hf,text="  Exit  ",bg="red",width=25,command=hf.destroy)
buttexit.pack(pady=30)
hf.mainloop()
