# -*- coding: cp1252 -*-
import csv
import tkFileDialog
import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import raioop2
import polib
import stats
import pstat
#from string import replace

# brg 26.7.2013
# CSV-readin using professional routines of csv-library
# HDsimpl specifically for CSV-files (CSV-separated by ";")
# 28.7.2013: "," in numbers in "." in numbers
# 29.7.2013 cosmetics
# 29.8.2013 enabling to read data files stored in different formats
# 22.3.2014 cover-relation
# 8.9.2014 precision when checking the equivalence classes (equivcompactm2)
# 8.9.2014: output equivalence classes
# 9.9.2014 interface: graphviz
# 19.12.17 Control prints
# 24.11.2018: based on hdsimpl04: subset_sensitivity1_1
# 26.11.2018: Distance between indicators (depending on object subsets)...
#............by Spearman correlation analysis
# 27.11.2018: Beside the HD of the complete original dm, the whole residual
# ............part is now including equivalent objects.
# 28.11.2018  Adaptation for large data sets


###### editfenster ### 29.8.2013 #####
def xsave_in_PyHasseformat():
    # brg 26.7.2013
    # 6.8.2013: taken from csvHDsimpl1.py, 27.8.2013
    global r,k,x
    la=r+1
    ls=k+1
    
    xext=rmod2.marray(la,ls)
    for i in range(0,la):
        for j in range(0,ls):
            if i==0 and j==0:
                xext[i][j]="dummy"
            elif j==0 and i>0:
                xext[i][j]=obj[i-1]
            elif j>0 and i==0:
                xext[i][j]=prop[j-1]
            else:
                xext[i][j]=x[i-1][j-1]


    print " xext-matrix "
    for i in range(0,la):
        for j in range(0,ls):
            print xext[i][j]," ",
        print " "
    print "  "    
    fnnew=tkFileDialog.asksaveasfilename(parent=hf,title="save orig dm in PyHasseformat")
    fcsv=open(fnnew,"w")
    for i in range(0,la):
        for j in range(0,ls):
            fcsv.write(str(xext[i][j])+"\t")
        fcsv.write("\n")
    fcsv.close()
   
def xsave_in_PyHasseformat_n():
    # brg 26.7.2013
    # 6.8.2013: taken from csvHDsimpl1.py, 27.8.2013
    global r,k,x
    xn=rmod2.matrixnorm(r,k,x)

    la=r+1
    ls=k+1
    
    xext=rmod2.marray(la,ls)
    for i in range(0,la):
        for j in range(0,ls):
            if i==0 and j==0:
                xext[i][j]="dummy"
            elif j==0 and i>0:
                xext[i][j]=obj[i-1]
            elif j>0 and i==0:
                xext[i][j]=prop[j-1]
            else:
                xext[i][j]=xn[i-1][j-1]


    print " xext-matrix "
    for i in range(0,la):
        for j in range(0,ls):
            print xext[i][j]," ",
        print " "
    print "  "    
    fnnew=tkFileDialog.asksaveasfilename(parent=hf,title="save normalized dm in PyHasseformat")
    fcsv=open(fnnew,"w")
    for i in range(0,la):
        for j in range(0,ls):
            fcsv.write(str(xext[i][j])+"\t")
        fcsv.write("\n")
    fcsv.close()

def interface_graphviz():
    # brg 9.9.2014
    #taken from mHDCl2
    covgr=rmod2.marray(rred,rred)
    for i1 in range(0,rred):
        for i2 in range(0,rred):
            if i1!=i2:
                covgr[i1][i2]=cov[i1][i2]
    txtgr=rmod2.covtxt(covgr,objred,rred,"digraph_x") #central routine! 
    app1=raioop2.brgsavefile3(fr,'t','w',txtgr,rred,rred) 
    import tkMessageBox
    tkMessageBox.showinfo(title="store graphviz-interface",message="successafull!")

def xselectfile():
    # brg 6.8.2013
    global fn
    fn=tkFileDialog.askopenfilename()
    print "fn ",fn
    Tpopener=Tkinter.Toplevel(hf)
    Tpopener.title(' Opening window: different formats ')
    fropen2=Tkinter.Frame(Tpopener,bd=3,bg="white")
    fropen2.pack()
    # +++ Grid-Geometry manager +++
    lb0=Tkinter.Label(fropen2,text=" Select the appropriate format: ",bg="yellow",font=("arial",12,"bold"))
    lb0.grid(row=0,column=0)
    lb1=Tkinter.Label(fropen2,text="(1a) Open files, txt, tab (or blank) as delimiter (PyHasse-standard) :                ",bg="white")
    lb1.grid(row=1,column=0)
    lb2=Tkinter.Label(fropen2,text="(1b) Open files, csv, ';' as delimiter (csv with ';') :                               ",bg="white")
    lb2.grid(row=2,column=0)
    lb3=Tkinter.Label(fropen2,text="(1c) Open files, csv, ',' as delimiter (csv with ',') :                               ",bg="white")
    lb3.grid(row=3,column=0)
    lb6=Tkinter.Label(fropen2,text="(1f) Open files, pdt, internal PyHasse-format to exchange interim-results:            ",bg="white") 
    lb6.grid(row=6,column=0)
    butt1=Tkinter.Button(fropen2,text="(1a) Open txt-file       ",bg="cyan",bd=4,command=xfileopen)
    butt1.grid(row=1,column=1)
    butt2=Tkinter.Button(fropen2,text="(1b) Open csv-file (';') ",bg="cyan",bd=4,command=xcsvopenS)
    butt2.grid(row=2,column=1)
    butt3=Tkinter.Button(fropen2,text="(1c) Open csv-file (',') ",bg="cyan",bd=4,command=xcsvopenK)
    butt3.grid(row=3,column=1)
    butt6=Tkinter.Button(fropen2,text="(1f) Open pdt-file       ",bg="cyan",bd=4,command=xopenfilepdt)
    butt6.grid(row=6,column=1)


def xcsvopenS():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,obj,prop,x,xred,rred,objred,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=';', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")
    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)
    print "rred ",rred
    print "Matrix "
    rmod2.matout(r,k,xred)
    print "neq= ",neq
    print "txteq = ", txteq

    

def xcsvopenK():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,x,fn,obj,prop,xred,objred,rred,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=',', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")

    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)   # 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq


def xfileopen():
    "Informs about the file-operations"
    # Excelreadin4 built in
    # Brg 29.11.07, 30.11.07, 15.1.08,18.2.08, 19.12.17
    global fn,r,k,x,prop,obj,rred,xred,objred,txteq
    x,ob,pr,r,k=rmod2.EXCELreadin6(fn)
    print "fn= ",fn, "r = ",r,"   k = ",k
    obj=rmod2.vecgentext1(r)                        # 29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  # recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pr[i+1]   # recoding, because pr[0] is a dummy string
    # rmod2.matout(r,k,x)
    
    lbopen1.config(bg="yellow")    # 18.2.08
    lbopen1["text"]="File "+fn+" was opened with "+str(r)+" rows and "+str(k)+"  columns"
    
    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)   # 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq

def xopenfilepdt():
    """ File selection of transformed data matrices
    through other PyHasse programs """
    # brg 29.10.2012 taken from sensitivity18_3
    #* 1.6.09
    # akt. 29.10.2012 (taken from sensitivity18_3), 6.8.2013
    # source: mainHD19
    global fn,r,k,x,prop,obj,rred,xred,objred,txteq
    
    r,k,x,obj,prop=rmod2.raireadin5(fn)
    lbpdtopen.config(bg="yellow")
    lbpdtopen["text"]="selected file (PyHasse (pdt) format) : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns"

    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)  # new 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq

##### end of editenster ### 29.8.2013 ####

def show_dm():
    #brg taken from HDweightMC8_7
    #Brg 13.1.08, 15.1.08, 11.1.2015, 31.07.18
    #*: 13.1.08
    #akt: 31.07.18, 25.11.2018
    #note: modified from the routine, taken from interval9.py
    tp2=Tkinter.Toplevel(hf)
    tp2.title('show DM')
    lbtp2=Tkinter.Label(tp2,text=" General information about the data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=20)
    tfile.pack()
    
    txt1="\n"
    txt1+="File = "+str(fn)+"\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,k):
            txt3+=str(x[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)    

def HDgen():
    #brg 24.11.2018
    covdm = polib.HD(hf, fn, xred, rred, k, objred, 10)

def show_indicatorlabels():
    #brg 26.11.2018
    txthilf=""
    for indicator in prop:
        txthilf+=str(indicator)+", "
    txthilf+="\n"
    lbindicators.config(text=txthilf)

def selsub1():
    #brg 24.11.2018, 25.11.2018, 27.11.2018
    global eselect, orghilf
    
    q=eq.get()
    if q in prop:
        i_indic=prop.index(q)
        print q,i_indic
    else:
        print "++++ wrong name/label for the indicator +++"
        print "the first indicator-column is taken as default"
        i_indic=0
    dmcolumn=[]
    for i in range(0,r):   #27.11.18  rred replaced by r
        dmcolumn.append(x[i][i_indic])  #xred replaced by x
        print obj[i],dmcolumn[i]                
    tpsel=Tkinter.Toplevel(hf)
    frsel=Tkinter.Frame(tpsel,relief="sunken",bd=4)
    frsel.pack()
    hilf,orghilf=rmod2.raisort(r,dmcolumn)
##    for i in range(0,r):
##        print obj[orghilf[i]],x[orghilf[i]][i_indic]
    eselect=rmod2.vecgen1(r)
    labselect1=rmod2.vecgen1(r)
    labselect2=rmod2.vecgen1(r)
    for i in range(0,r):
        labselect1[i]=Tkinter.Label(frsel,text=str(obj[orghilf[i]]))
        labselect1[i].grid(row=i+1,column=1)
        labselect2[i]=Tkinter.Label(frsel,text=str(x[orghilf[i]][i_indic]))
        labselect2[i].grid(row=i+1,column=2)
        eselect[i]=Tkinter.Entry(frsel,width=3)
        eselect[i].grid(row=i+1,column=3)
    

def submit1():
    #brg24.11.2018, 20.11.2018
    global subset
    select=rmod2.vecgen1(r)
    subset=[]
    for i in range(0,r):
        select[i]=eselect[i].get()
        if select[i]=="1":
            subset.append(obj[orghilf[i]])
        else:
            pass
    print "selected objects "
    print subset

def selsub2():
    #brg 24.11.2018, 25.11.2018, 27.11.2018, 29.11.2018
    global eselect
    frsel=Tkinter.Frame(tp2,width=120,bd=4,relief="sunken")
    frsel.pack()
    rows=int(erows.get())
    rowlength=int(1.0*r/rows)
    residual=r-rowlength*rows
    labselect=rmod2.vecgen1(r)
    eselect=rmod2.vecgen1(r)
    select=rmod2.vecgen1(r)
    #print "rowlength= ",rowlength
    #print "residual ",residual
    zahl=0
    for i1 in range(0,rows):
        for i2 in range(0, rowlength):
            labselect[i2]=Tkinter.Label(frsel, text=str(obj[zahl]))
            labselect[i2].grid(row=2*i1+1,column=i2)
            eselect[zahl]=Tkinter.Entry(frsel,width=2)
            eselect[zahl].grid(row=2*i1+2,column=i2)
            zahl+=1
    yy=2*rows+3
    #print "yy= ",yy
    for i3 in range(0,residual):
        labselect[i3]=Tkinter.Label(frsel,text=str(obj[zahl+i3]))
        labselect[i3].grid(row=yy,column=[i3])
        eselect[zahl+i3]=Tkinter.Entry(frsel,width=2)
        eselect[zahl+i3].grid(row=yy+1,column=i3)
    
       
def submit2():
    global subset, eselect
    select=rmod2.vecgen1(r)
    for i in range(0,r):
        select[i]=eselect[i].get()
        #print "select ",i,"  = ",select[i]
    subset=[]
    for i in range(0,r):
        if select[i]=="1":
            subset.append(obj[i])
     


def calc_newdm():
    # brg 26.11.2018
    xsubset=rmod2.marray(len(subset),k)
    zahl=0
    for objects in obj:
        if objects in subset:
            iob=obj.index(objects)
            for j in range(0, k):
                xsubset[zahl][j]=x[iob][j]
            zahl+=1
    print "adaptierte data matrix (rows in order of the original object set ) "
    rmod2.matout(len(subset),k,xsubset)
    return xsubset
    

def show_dmsubset():
    #brg taken from HDweightMC8_7
    #Brg 13.1.08, 15.1.08, 11.1.2015, 31.07.18, 26.11.2018
    #*: 13.1.08
    #akt: 31.07.18, 26.11.2018
    #note: modified from the routine, taken from interval9.py
    global subset, xsubset
    tpshowdmsubset=Tkinter.Toplevel(hf)
    tpshowdmsubset.title('show the DM of subset')
    tfile2=ScrolledText(tpshowdmsubset,width=60,height=20)
    tfile2.pack()
    xsubset=calc_newdm()
    print "adapted dm "
    rmod2.matout(len(subset),k,xsubset)
    
    txt1="\n"
    txt1+="File = "+str(fn)+"\n"
    txt1+="\n objects\n"
    for i1 in range(0, len(subset)):
        txt1+=" "+str(subset[i1])+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    txt3+="\n"
    zahl=0
    for objects in obj:
        if objects in subset:
            txt3+=str(objects)+"\t"
            iob=obj.index(objects)
            for j in range(0,k):
                txt3+=str(x[iob][j])+"\t"
            zahl+=1
            txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile2.insert("end",txt)        
    
def compneu(r,x,k, propvec):
    """dm x will be compared and the zeta-matrix zeta generated"""
    #brg 9.3.07, 22.3.07, 25.11.2018
    #*9.3.07
    #akt 25.11.18
    #note:in all partial order programs
    #source:-
    #r: rows
    #x data matrix
    #k total number of indicators 
    #propvec a list of all, or a subset of indicators.
    # No labels but their identification numbers!!
    #zeta: resulting zeta matrix die to a indicatorsubset
    
    zeta=rmod2.marray(r,r)
    subindic=[]
    for j in range(0,len(propvec)):
        subindic.append(propvec[j])
    print "subsystem of indicators "
    print subindic
    
    for i1 in range(0,r):
        for i2 in range(0,r):
            flag=0
            for kk in subindic:
                if round(x[i1][kk],10)>=round(x[i2][kk],10):
                    flag+=1
            if flag==len(subindic):
                 zeta[i1][i2]=1
            else:
                 zeta[i1][i2]=0
    return zeta
        
def zetasubset(zeta_all,obj,subset):
    # brg 25.11.2018
    # zeta_all: zeta matrix (row >) col) of all objects
    # obj: list of all objects
    # subset: sublist of objects, must be a subset of list
    #.....    of obj
    # results:
    # zetass: zetamatrix in suborder of obj even is the subset =
    # .....  ["d","a","e"] whereas obj=["a","b","c","d","e","f",...]
    #...... then zetass is in order a,d,e
    # Note diagonal of zetass : 1 
    r=len(obj)
    rss=len(subset)
    zetass=rmod2.marray(rss,rss)
    # zetass is the zeta matrix of object subset and of all indicators
    i1ss=0
    for i1 in range(0,r):
        i2ss=0
        if obj[i1] in subset:
            for i2 in range(0,r):
                if obj[i2] in subset:
                    zetass[i1ss][i2ss]=zeta_all[i1][i2]
                    i2ss+=1
            i1ss+=1
    return zetass, rss

def calc_distance(zetaall,zetasubset,r):
    # brg 25.11.2018
    # calculates Dpower2 of Euclidian distance between the entries of zetaall
    #...( all indicators) and zetasubset (the subset of m-1 indicators, m being
    #... the number of all indicators).
    #  Note: In any case the zeta matrices refer to a subset of the object set
    # In rmod2 instead of power 2 the abs - values are used. This should not make any difference!
    D2=0
    for i1 in range(0,r):
        for i2 in range(0,r):
            D2+=(zetaall[i1][i2]-zetasubset[i1][i2])*(zetaall[i1][i2]-zetasubset[i1][i2])
    return D2            
                

def calc_sensi():
    # brg 25.11.2018
    global xsubset
    # step 1: zeta_all from a subset of objects
    #...
    propvecall=[]
    for j in range(0, len(prop)):
        propvecall.append(j)
        
    zetaall=compneu(r,x, k, propvecall)
    print "zetaall"
    rmod2.matout(r,r,zetaall)
    zetass,rss=zetasubset(zetaall,obj,subset)
    print "subset ",subset
    print "zetamatrix of subset and all indicators"
    rmod2.matout(rss,rss, zetass)
    # step 2: data matrix adapted corrsponding to the subset
    print " "
    xsubset=calc_newdm()
    
    # step 3: generation of a property vector with just one indicator skipped
    setprop=set([])
    for j in range(0,len(prop)):
        setprop.add(prop[j])
    #print "setprop ",setprop

    D2vec=[]
    for j1 in range(0,k):
        propsubset=set([])
        singleset=set([])
        singleset.add(prop[j1])
        propsubset=setprop-singleset
        propsubvec=[]
        for element in propsubset:
            jod=prop.index(element)
            propsubvec.append(jod)
        print "j1= ",j1, " ",propsubvec
        # step 4: based on propsubvec the zetamatrix will be calculated
        
        zetasselim = compneu(rss,xsubset,k, propsubvec)
        print "zeta without one indicator ", prop[j1]
        rmod2.matout(rss,rss,zetasselim)
        # step 5: Distance of the zeta-matrices (zeta (object subset, all indicators),
        # ........zeta (object subset, all indic. but one)
        D2=calc_distance(zetass,zetasselim,rss)
        D2vec.append((j1,D2))
    print "D2vec = ",D2vec    
    tpresults=Tkinter.Toplevel(hf)
    tpresults.title("Sensitivity ")
    tresults=ScrolledText(tpresults, width=60, height=20)
    tresults.pack()
    txt=" Sensitivity with respect to object-subsets "+"\n"
    txt+=" File =  "+str(fn)+"\n"
    txt+="Actual selected subset: "+"\n"
    for i in range(0, rss):
        txt+=str(subset[i])+", "
    txt+="\n"
    txt+="Sensitivity  following the scheme: "+"\n"
    txt+="Distancesquared of..."+"\n"
    txt+="(zeta_of_all_indicators),zeta_of_all_indicators but one)"+"\n"
    for j in range(0,k):
        print prop[D2vec[j][0]],": ",D2vec[j][1]
        txt+=str(prop[D2vec[j][0]])+":\t"+str(D2vec[j][1])+"\n"
    txt+="\n"
    txt+=" - - -  e o f  - - - "
    tresults.insert("end",txt)
    bcorr.config(state="active")

def all_objects():
    #brg30.11.2018
    global r, subset
    subset=[]
    for i in range(0, r):
        subset.append(obj[i])
    print "subset/object set= ",subset
    bselect1.config(state="disabled")
    bsubmit1.config(state="disabled")
    bselgen.config(state="disabled")
    bsubmit2.config(state="disabled")

def spearm():
    # brg 26.11.2018
    global xsubset
    """
    Calculates a Spearman rank-order correlation coefficient.  Taken
    from Heiman's Basic Statistics for the Behav. Sci (1st), p.192.

    Usage:   lspearmanr(x,y)      where x and y are equal-length lists
    Returns: Spearman's r, two-tailed p-value
    """    
    
    tpspear=Tkinter.Toplevel(hf)
    tpspear.title("Spearman correlation ")
    tspear=ScrolledText(tpspear,width=60, height=20)
    tspear.pack()
    txt=" Spearman correlation between the indicator values"+"\n"
    txt+="Data from file: "+str(fn)+"\n"
    txt+= "of two columns of the data matrix, according to the "+"\n"
    txt+="selected subset: "+"\n"
    for objects in subset:
        txt+=str(objects)+", "
    txt+="\n"
    txt+="ind1, ind2:  spear-corr.coeff., two-tailed p-val"+"\n"
    for j1 in range(0,k-1):
        hilf1=[]
        for i in range(0,len(subset)):
            hilf1.append(xsubset[i][j1])
        for j2 in range(j1+1 ,k):
            hilf2=[]
            txt+=str(prop[j1])+", "
            txt+=str(prop[j2])+": "
            for i in range(0, len(subset)):
                hilf2.append(xsubset[i][j2])
            rspear,pspear=pstat.lspearmanr(hilf1,hilf2)
            txt+=3*"\t"+str(round(rspear,3))+",\t "+str(round(pspear,4))+"\n"
    txt+="\n"
    txt+="- - -   e o f - - - "
    tspear.insert("end",txt)
   
                
                 
    


## Tkinter Plot
hf = Tkinter.Tk()
hf.title(' subset_sensitivity ')
aboutHDsimpl=raioop2.brgabout(hf,"tp1","about_subset_sensitivity.txt",4,\
            "Nov, the 30th, 2018"," about subset_sensitivity ", "white", "t1",80,5,ScrolledText)
helpHDsimpl=raioop2.brgabout(hf,"tp1","help_subset_sensitivity.txt",4,\
            "Nov., the 30th, 2018"," help_subset_sensitivity ", "white", "t1",80,5,ScrolledText)
    
fr = Tkinter.Frame(hf, width=60)
fr.pack()
frinput1 = Tkinter.Frame(fr, width=100, height=10)
frinput1.pack()
text = "Select first the file, then decide in which format to be opened "
lbinput1 = Tkinter.Label(frinput1,
                         text=text)
lbinput1.pack()
butt1 = Tkinter.Button(frinput1, text="Select filename  ",
                       bg="white", command=xselectfile)
butt1.pack()
                      
lbopen1 = Tkinter.Label(fr, text="")
lbopen1.pack()
buttshow_datamatrix = Tkinter.Button(fr,text="Show data matrix (dm)",bg="cyan",width=25, command=show_dm)
buttshow_datamatrix.pack()
buttHD = Tkinter.Button(fr, text='Draw HD', width=25, bg="cyan", command=HDgen)
buttHD.pack(pady=5)
tp1=Tkinter.Toplevel(hf)
lbinfo=Tkinter.Label(tp1,text="Platform for indicator specific subset selection", bg="yellow")
lbinfo.pack()
lb1 = Tkinter.Label(tp1,text=" ", width=50)
lb1.pack()
buttall_objects=Tkinter.Button(tp1,text="all objects ",bg="cyan",width=25, command=all_objects)
buttall_objects.pack()
buttshowindic=Tkinter.Button(tp1,text="Show the indicator labels ",bg="white",width=25,command=show_indicatorlabels)
buttshowindic.pack()
lbindicators=Tkinter.Label(tp1,text="")
lbindicators.pack()
lb2=Tkinter.Label(tp1, text="Enter the label of indicator\n which induces an object-sorting")
lb2.pack()
eq=Tkinter.Entry(tp1,width=5)
eq.pack()
bselect1=Tkinter.Button(tp1,text="select subset ",width=25, bg="cyan",command=selsub1)
bselect1.pack()
bsubmit1=Tkinter.Button(tp1,text="submit subset-selection",width=25, bg="cyan",command=submit1)
bsubmit1.pack(pady=5)
tp2=Tkinter.Toplevel(hf)
lbinfo2=Tkinter.Label(tp2,text="Platform for general subset selection ",bg="yellow")
lbinfo2.pack()
buttall_objects2=Tkinter.Button(tp2,text="all objects ",bg="cyan",width=25, command=all_objects)
buttall_objects2.pack()
lbsetting=Tkinter.Label(tp2, text = "how many rows (of equal length)  ")
lbsetting.pack()
erows = Tkinter.Entry(tp2, width=5)
erows.pack()
bselgen=Tkinter.Button(tp2,text="open the selection field ",bg="cyan",width=25, command=selsub2)
bselgen.pack()
bsubmit2=Tkinter.Button(tp2, text="Submit selected objects ",bg="cyan",width=25,command=submit2)
bsubmit2.pack()
bshowdmsubset=Tkinter.Button(fr, text="show data matrix\n of the subset", width=25,bg="cyan",command=show_dmsubset)
bshowdmsubset.pack()
bcalc=Tkinter.Button(fr,text="Calc sensitivity ",bg="cyan",width=25, command=calc_sensi)
bcalc.pack()
bcorr=Tkinter.Button(fr,text="Spearman correlation ",bg="cyan",width=25, state="disabled",command=spearm)
bcorr.pack()

buttexit = Tkinter.Button(fr, text='exit', bg='red',
                          width=25, command=hf.destroy)
buttexit.pack(pady=10)

hf.mainloop()
