# -*- coding: cp1252 -*-
import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import tkFileDialog
import raioop2
import math

#Brg topsissimpl1.py , 2.11.2011 aus HDsimpl

def HD():
    """based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"""
    # Brg 20.12.07, 28.12.07, 2.10.,3.10.09
    # If the number of representants > 70 then only the cover-matrix and the level-population
    #
    global ob, prop,dm,r,k,rred,objred,cov,xred
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    
    fn=tkFileDialog.askopenfilename()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    lb1.config(text="opened "+fn,bg="yellow")
    

    prop=[]
    for j in range(0,k):
        prop.append(pro[j+1])
            
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
    for i in range(0,r):
        obj[i]=ob[i+1]

    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,dm,obj)  
    
    #
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    if rred>70:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram  ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()
    buttcover=Tkinter.Button(freq,text="cover-relations ",width=30,bg="cyan",command=covershow)
    buttcover.pack()


def covershow():
    """Cover-matrix is displayed"""
    #brg 28.12.07, taken 2.11.2011 from mainHD19_4_1
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: -
    hfcover=Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    
    lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,rred):
        txt3+="\n"+objred[i]+":\t"
        txt3+="is covered by "
        for j in range(0,rred):
            if i!=j:
                if cov[i][j]==1:
                    txt3+=" "+objred[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=20)
    tcov.pack(expand=1,fill="both")
    tcov.insert("end",txt3)
    

def showDM():
    """ New routine : shows the data matrix """
    #Brg 13.1.08, taken from mainHD19_4_1 2.11.2011
    global r,k
    tp2=Tkinter.Toplevel(hf)
    tp2.title('showDM')
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack(expand=1,fill="both")
    #dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+ob[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=ob[i+1]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)

def perform():
    # brg 2.11.2011
    global sumdist1, sumdist2
    weight=rmod2.vecgen1(k)
    for j in range(0,k):
        try:
            weight[j]=float(eweight[j].get())
        except:
            weight[j]=1.0/(1.0*k)    #equal weights as default
        print weight[j]
    #modification of maxxred and xredn due to the weights
    #maxxred and xredn will be overwritten    
    for j in range(0,k):
        maxxred[j]=maxxred[j]*weight[j]
    for i in range(0,rred):
        for j in range(0,k):
            xredn[i][j]=xredn[i][j]*weight[j]

    # distances to maxxred
    sumdist1=rmod2.vecgen1(rred)
    for i in range(0,rred):
        for j in range(0,k):
            sumdist1[i]+=(xredn[i][j]-maxxred[j])**2
        sumdist1[i]=math.sqrt(sumdist1[i])    

    # distances to minxred
    sumdist2=rmod2.vecgen1(rred)
    for i in range(0,rred):
        for j in range(0,k):
            sumdist2[i]+=(xredn[i][j]-minxred[j])**2  #defacto only xredn**2
        sumdist2[i]=math.sqrt(sumdist2[i])    

    #calculation of C according to Hwang, Yoon, 1981
    CHY=rmod2.vecgen1(rred)
    for i in range(0,rred):
        CHY[i]=1.0*sumdist2[i]/(1.0*sumdist1[i]+1.0*sumdist2[i])
    txtchy=" TOPSIS-values according Hwang, Yoon, 1981"+"\n"
    txtchy+="Selected weights "+"\n"
    for j in range(0,k):
        txtchy+=str(prop[j])+": "+str(round(weight[j],3))+"\n"
    txtchy+="\n"
    txtchy+="maximal values "+"\n"
    for j in range(0,k):
        txtchy+=str(prop[j])+": "+str(round(maxxred[j],3))+"\n"
    txtchy+="\n"
    txtchy+="minimal values "+"\n"
    for j in range(0,k):
        txtchy+=str(prop[j])+": "+str(round(minxred[j],3))+"\n"
    txtchy+="\n"   
    txtchy+="Distance to max-values "+"\n"
    for i in range(0,rred):
        txtchy+=str(objred[i])+": "+str(round(sumdist1[i],3)) +"\n"
    txtchy+="\n"
    txtchy+="Distance to min-values "+"\n"
    for i in range(0,rred):
        txtchy+=str(objred[i])+": "+str(round(sumdist2[i],3)) +"\n"
    txtchy+="\n"
    txtchy+="Now the CHY-Index: "+"\n"                                    
    for i in range(0,rred):
        txtchy+=str(objred[i])+"\t"+str(round(CHY[i],3))+"\n"
    tCHY=ScrolledText(tpcalc,width=60,height=10)
    tCHY.pack()
    txtchy+="\n"
    txtchy+="- - - e o f  - - - "
    tCHY.insert("end",txtchy)
    buttHDtopsis=Tkinter.Button(tpcalc,text="TOPSIS-HD",bg="cyan",width=25,command=topsis)
    buttHDtopsis.pack()

def topsis():
    #brg 2.11.2011
    global cov2,rred2,objred2
    hfhd3=Tkinter.Toplevel(hf)
    hfhd3.title('Topsis - Hasse diagram / cover matrix ')
    freq2=Tkinter.Frame(hfhd3,width=200,height=300)
    freq2.pack()
    # equal orientation
    max1=max(sumdist1)
    xtopsis=rmod2.marray(rred,2)
    for i in range(0,rred):
        xtopsis[i][0]=max1-sumdist1[i]
    for i in range(0,rred):
        xtopsis[i][1]=sumdist2[i]
        
    rred2,xred2,objred2,txt2,neq2=rmod2.equivcompactm(rred,2,xtopsis,objred)  
    k2=2
    #
    zetahilf2=rmod2.comp(rred2,k2,xred2)  #zeta matrix with col<row
    zeta2=rmod2.marray(rred2,rred2)
    for i in range(0,rred2):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred2):
            zeta2[i][j]=zetahilf2[j][i]
    #
    #One linear extension (based on levels)
    
    lobj2,lext2,revlext2,zzmax2=rmod2.levtopsort(rred2,zeta2)
       
    levmax2=-10**20     #20.6.08
    for i in range(0,zzmax2):
        if len(lobj2[i])>=levmax2:
            levmax2=len(lobj2[i])
       
    #Adj-Listen

    adjc2=rmod2.adjacent(rred2,lext2,revlext2,zeta2)
        
    #Transitive reduced relations
    ts2,tr2=rmod2.trreduct(rred2,adjc2,lext2)
       
    
    cov2=rmod2.cover(rred2,tr2,lext2)

    if rred2>100:
        lbhd3=Tkinter.Label(freq2,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq2,text=" Hasse Diagram  ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred2,levmax2,zzmax2)
        cv=Tkinter.Canvas(freq2,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax2
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj2[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred2,rred2)
        geomy=rmod2.marray(rred2,rred2)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov2[lobj2[i1][j1]][lobj2[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred2[lobj2[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()
    buttcover2=Tkinter.Button(freq2,text="cover-relations ",width=30,bg="cyan",command=covershow2)
    buttcover2.pack()


def covershow2():
    # brg 2.11.2011
    """Cover-matrix is displayed"""
    #brg 28.12.07, taken 2.11.2011 from mainHD19_4_1
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: -
    hfcover2=Tkinter.Toplevel(hf)
    hfcover2.title(' cover-matrix (topsis) ')
    
    lbhd3=Tkinter.Label(hfcover2,text=" Cover-Relations (topsis)")
    lbhd3.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,rred2):
        txt3+="\n"+objred2[i]+":\t"
        txt3+="is covered by "
        for j in range(0,rred2):
            if i!=j:
                if cov2[i][j]==1:
                    txt3+=" "+objred2[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov2=ScrolledText(hfcover2,width=50, height=20)
    tcov2.pack(expand=1,fill="both")
    tcov2.insert("end",txt3)




def calc():
    #brg 2.11.2011
    # [0,1]-column-normalization (contrasting the normalization suggested by
    # Hwang/Yoon
    global eweight,xredn,minxred,maxxred,rred,k,tpcalc
    xredn=rmod2.matrixnorm(rred,k,xred)
    minxred=rmod2.vecgen2(k,0)
    maxxred=rmod2.vecgen2(k,1)
    eweight=rmod2.vecgen1(k)
    tpcalc=Tkinter.Toplevel(hf)
    tpcalc.title(' simplified topsis ')
    frweight=Tkinter.Frame(tpcalc,width=60,relief="sunken",bd=3)
    frweight.pack()
    lbweight=Tkinter.Label(frweight,text="insert the weights for each attribute")
    lbweight.grid(row=0)
    for j in range(0,k):
        eweight[j]=Tkinter.Entry(frweight,width=5)
        eweight[j].grid(row=j+1)
    buttperform=Tkinter.Button(tpcalc,text="submit ",bg="cyan",width=25, command=perform)
    buttperform.pack()
       
    
    
## Tkinter Plot
hf = Tkinter.Tk()
hf.title(' GUI-TOPSISsimpl ')
aboutHDsimpl=raioop2.brgabout(hf,"tp1","about_topsissimple.txt",1,\
            "November, 2nd,2011"," about topsissimpl ", "white", "t1",80,5,ScrolledText)
helpHDsimpl=raioop2.brgabout(hf,"tp1","help_topsissimpl.txt",1,\
            "November, 2nd,2011"," help_topsissimpl ", "white", "t1",80,5,ScrolledText)
    
fr=Tkinter.Frame(hf,width=60)
fr.pack()

buttHD = Tkinter.Button(fr, text='select, open and HD',width=25,bg="cyan",command=HD)
buttHD.pack(pady=5)
buttshow=Tkinter.Button(fr,text="show data matrix ",width=25, command=showDM)
buttshow.pack()
lb1=Tkinter.Label(fr,text=" ",width=50)
lb1.pack()
buttcalc=Tkinter.Button(fr,text="calculation ",width=25, bg="cyan",command=calc)
buttcalc.pack()
buttexit = Tkinter.Button(fr, text = 'exit', bg = 'red', width=25,command = hf.destroy)
buttexit.pack(pady=10)

hf.mainloop()

