import csv
import tkFileDialog
import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import raioop2
import pstat
import stats
#from string import replace

# brg 26.7.2013
# CSV-readin using professional routines of csv-library
# HDsimpl specifically for CSV-files (CSV-separated by ";")
# 28.7.2013: "," in numbers in "." in numbers
# 29.7.2013 cosmetics
# 29.8.2013 enabling to read data files stored in different formats
# 22.3.2014 cover-relation
# 8.9.2014 precision when checking the equivalence classes (equivcompactm2)
# 8.9.2014: output equivalence classes
# 9.9.2014 interface: graphviz
# 18.2.2017: From HDsimple development of weightstability1
# 22.2.2017: weightstability2_2.py


###### editfenster ### 29.8.2013 #####
def xselectfile():
    # brg 6.8.2013
    global fn
    fn=tkFileDialog.askopenfilename()
    print "fn ",fn
    Tpopener=Tkinter.Toplevel(hf)
    Tpopener.title(' Opening window: different formats ')
    fropen2=Tkinter.Frame(Tpopener,bd=3,bg="white")
    fropen2.pack()
    # +++ Grid-Geometry manager +++
    lb0=Tkinter.Label(fropen2,text=" Select the appropriate format: ",bg="yellow",font=("arial",12,"bold"))
    lb0.grid(row=0,column=0)
    lb1=Tkinter.Label(fropen2,text="(1a) Open files, txt, tab (or blank) as delimiter (PyHasse-standard) :                ",bg="white")
    lb1.grid(row=1,column=0)
    lb2=Tkinter.Label(fropen2,text="(1b) Open files, csv, ';' as delimiter (csv with ';') :                               ",bg="white")
    lb2.grid(row=2,column=0)
    lb3=Tkinter.Label(fropen2,text="(1c) Open files, csv, ',' as delimiter (csv with ',') :                               ",bg="white")
    lb3.grid(row=3,column=0)
    lb6=Tkinter.Label(fropen2,text="(1f) Open files, pdt, internal PyHasse-format to exchange interim-results:            ",bg="white") 
    lb6.grid(row=6,column=0)
    butt1=Tkinter.Button(fropen2,text="(1a) Open txt-file       ",bg="cyan",bd=4,command=xfileopen)
    butt1.grid(row=1,column=1)
    butt2=Tkinter.Button(fropen2,text="(1b) Open csv-file (';') ",bg="cyan",bd=4,command=xcsvopenS)
    butt2.grid(row=2,column=1)
    butt3=Tkinter.Button(fropen2,text="(1c) Open csv-file (',') ",bg="cyan",bd=4,command=xcsvopenK)
    butt3.grid(row=3,column=1)
    butt6=Tkinter.Button(fropen2,text="(1f) Open pdt-file       ",bg="cyan",bd=4,command=xopenfilepdt)
    butt6.grid(row=6,column=1)


def xcsvopenS():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,obj,prop,x,xred,rred,objred,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=';', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")
    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)
    print "rred ",rred
    print "Matrix "
    rmod2.matout(r,k,xred)
    print "neq= ",neq
    print "txteq = ", txteq

    

def xcsvopenK():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,x,fn,obj,prop,xred,objred,rred,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=',', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")

    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)   # 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq


def xfileopen():
    "Informs about the file-operations"
    # Excelreadin4 built in
    # Brg 29.11.07, 30.11.07, 15.1.08,18.2.08
    global fn,r,k,x,prop,obj,rred,xred,objred,txteq
    x,ob,pr,r,k=rmod2.EXCELreadin6(fn)
    print "r = ",r,"   k = ",k
    obj=rmod2.vecgentext1(r)                        # 29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  # recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pr[i+1]   # recoding, because pr[0] is a dummy string
    # rmod2.matout(r,k,x)
    
    lbopen1.config(bg="yellow")    # 18.2.08
    lbopen1["text"]="File "+fn+" was opened with "+str(r)+" rows and "+str(k)+"  columns"
    
    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)   # 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq


def xopenfilepdt():
    """ File selection of transformed data matrices
    through other PyHasse programs """
    # brg 29.10.2012 taken from sensitivity18_3
    #* 1.6.09
    # akt. 29.10.2012 (taken from sensitivity18_3), 6.8.2013
    # source: mainHD19
    global fn,r,k,x,prop,obj,rred,xred,objred,txteq
    
    r,k,x,obj,prop=rmod2.raireadin5(fn)
    lbpdtopen.config(bg="yellow")
    lbpdtopen["text"]="selected file (PyHasse (pdt) format) : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns"

    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)  # new 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq

##### end of editenster ### 29.8.2013 ####

def show_dm():
    #brg taken from HDweightMC8_7
    #Brg 13.1.08, 15.1.08, 11.1.2015
    #*: 13.1.08
    #akt: 15.1.08
    #note: modified from the routine, taken from interval9.py
    tp2=Tkinter.Toplevel(hf)
    tp2.title('show DM')
    lbtp2=Tkinter.Label(tp2,text=" General information about the [0,1]-columnwise data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,k):
            txt3+=str(x[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)    



def HD():
    # brg 26.7.2013, 29.8.2013, 2.11.16
    
    global x,la,ls,cov, rred, objred, Utotal
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
        #
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    rmod2.matout(rred,rred,zeta)
    Utotal = rmod2.incompzeta(rred,zeta)
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    if rred>400:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram , Utotal =  "+str(Utotal))
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()
        buttcov=Tkinter.Button(freq, text = "cover - relation ",width = 20, command = cover)
        buttcov.pack()
        buttequiv = Tkinter.Button(freq,text="show equivalence classes", width = 30,command = showeq)
        buttequiv.pack()
        
def cover():
    hfcover = Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    lbcov = Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbcov.pack()
    txt3 = "\n cover-matrix  \n"
    for i in range(0, rred):
        txt3 += "\n" + objred[i] + ":\t"
        txt3 += "is covered by "
        for j in range(0, rred):
            if i!=j:
                if cov[i][j] == 1:
                    txt3 += " " + objred[j] + " ,"
                else:
                    pass
            else:
                pass
        txt3 += "\n"    
    txt3 += "\n"
    txt3 += " -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)
    

def showeq():
    tpequiv = Tkinter.Toplevel(hf)
    tpequiv.title(" equivalence classes ")
    tequiv=ScrolledText(tpequiv,width=60, height=10)
    tequiv.pack()
    txteq2="Equivalence classes"+"\n"
    txteq2+=50*"="+"\n"
    txteq2+="File: "+str(fn) +"\n"
    txteq2+="equivalence classes: "+txteq
    txteq2+="\n"
    txteq2+="- - - e o f - - -"
    tequiv.insert("end",txteq2)

def calc_relat(r, k, x):
    #taken from rmod2 13.10.2014 and modified according to PyHasse_internet
    c= []
    flag=0    
    for i1 in range(0, r):
        c.append(0)
        c[i1] = []
        for i2 in range(0, r):
            flag=0
            for j in range(0, k):
                #print " kk =",kk," i=",i," j = ",j
                if x[i1][j] >= x[i2][j]:
                    flag += 1
            if flag == k:
                 c[i1].append(1)
            else:
                 c[i1].append(0)
            #print " "     
    return c

def save_relat():
    # Brg taken from Electresimpl 13.10.2014
    # brg 6.2.2017
    relat = calc_relat(r, k, x)
    fnrelat=tkFileDialog.asksaveasfilename(parent=hf,title="save relation-files in PyHasseformat")
    fcsv=open(fnrelat,"w")
    fcsv.write(str(r)+"\n")
    for i1 in range(0,r):
        for i2 in range(0,r):
            fcsv.write(str(relat[i1][i2])+"\t")
        fcsv.write("\n")
    fcsv.close()

#### here the new part
def submitweighttuples():
    # brg 18.2.2017
    global now
    now=int(enow.get())
    print "now = ",now
    readin_weight_tuples(now)
    
    
def readin_weight_tuples(now):
    #brg 18.2.2017
    global ewrows
    tpread=Tkinter.Toplevel(hf)
    tpread.title("Read in: weight tuples ")
    ewrows=rmod2.vecgen1(now)
    for i in range(0,now):
        ewrows[i]=Tkinter.Entry(tpread,width=60)
        ewrows[i].pack()

def submitweightvalues():
    # brg 18.2.17, 24.2.17
    global cs, wrows
    wrows=rmod2.vecgen1(now)
    try:
        testw=erows.get()
    except:
        testw=0
    print "testw ",testw
    
        
    for i in range(0,now):
        wrows[i]=ewrows[i].get().split(",")
        print "i= ",i,"  ",wrows[i]
    countrenorm=0    
    for i in range(0, now):
        sumw=0
        for j in range(0, k):
            wrows[i][j]=float(wrows[i][j])
            sumw+=wrows[i][j]
        if sumw==0:
            wrows[i][j]=random.random()
        else:    
            if sumw<0.99 or sumw>1.01:
                for j in range(0,k):
                    wrows[i][j]=1.0*wrows[i][j]/(1.0*sumw)
                countrenorm+=1    
    print "weight tuples"
    if countrenorm>0:
        lbweight.config(text="+++ weights were "+str(countrenorm)+" times renormalized +++",bg="orange")
    rmod2.matout(now,k,wrows)
    cs=calc_cs(now,wrows)

def calc_cs(now,wrows):
    #brg 18.2.17
    global cs
    xredn=rmod2.matrixnorm(rred,k,xred)
    cs=rmod2.marray(rred,now)    #
    for i2 in  range(0, now):
        for i in range (0, rred):
            for j in range(0,k):
                cs[i][i2]+=wrows[i2][j]*xredn[i][j]
    print "new MIS by ",now," weight tuples "
    rmod2.matout(rred,now,cs)
    return cs
                      
def HDnewMIS():
    #brg 19.2.17
    
    global x,la,ls,covnewMIS, rred, objred
    hfhdnewMIS=Tkinter.Toplevel(hf)
    hfhdnewMIS.title('Hasse diagram / cover matrix based on the new MIS')
    freq2=Tkinter.Frame(hfhdnewMIS,width=200,height=300)
    freq2.pack()
        #
    print "cs= ",cs
    print " "
    rmod2.matout(rred,now,cs)    
    zetahilf1=rmod2.comp(rred,now,cs)  #zeta matrix with col<row
    zeta1=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta1[i][j]=zetahilf1[j][i]
    
    UtotalnewMIS = rmod2.incompzeta(rred,zeta1)
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta1)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta1)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    covnewMIS=rmod2.cover(rred,tr,lext)

    if rred>400:
        lbhd3=Tkinter.Label(freq2,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq2,text=" HD and Utotal of the new MIS  "+str(UtotalnewMIS))
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq2,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if covnewMIS[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()
        buttcov=Tkinter.Button(freq2, text = "cover - relation ",width = 20, command = covernewMIS)
        buttcov.pack()
        
def covernewMIS():
    hfcover2 = Tkinter.Toplevel(hf)
    hfcover2.title(' cover-matrix ')
    lbcov = Tkinter.Label(hfcover2,text=" Cover-Relations ")
    lbcov.pack()
    txt3 = "\n cover-matrix  \n"
    for i1 in range(0, rred):
        txt3 += "\n" + objred[i1] + ":\t"
        txt3 += "is covered by "
        for i2 in range(0, rred):
            if i1!=i2:
                if covnewMIS[i1][i2] == 1:
                    txt3 += " " + objred[i2] + " ,"
                else:
                    pass
            else:
                pass
        txt3 += "\n"    
    txt3 += "\n"
    txt3 += " -- end of list --"
    tcov2=ScrolledText(hfcover2,width=50, height=20)
    tcov2.pack()
    tcov2.insert("end",txt3)

def calc_UR_ranges():
    # brg 18.2.17
    global uloc,rrange,txtresults,txtsets, limitsets, r0
    try:
        limitsets=int(elimitsets.get())
    except:
        limitsets = rred
    print "limitsets = ",limitsets
    r0=[]
    for i in range(0,rred):
        hilf=[]
        for j1 in range(0,k):
            for j2 in range(j1+1,k):
                hilf.append(abs(xred[i][j1]-xred[i][j2]))
        maxr0=max(hilf)        
        r0.append(maxr0)
        
    txtresults="file = "+"\t"+str(fn)+"\n"
    txtresults+="U of original dm = "+"\t"+str(Utotal)+"\n"
    txtresults+="Count of different weight tuples: "+"\t"+str(now)+"\n"
    for i in range(0, now):
        txtresults+="weight tuple No "+str(i+1)+": "+"\t"
        for j in range(0, k):
            txtresults+=str(round(wrows[i][j],3))+", "
        txtresults+="\n"    
           
    
    # first the U-ranges
    zetahilf0=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta0=rmod2.marray(rred,rred)
##    zetahilf=rmod2.comp(rred,now,cs)  #zeta matrix with col<row
##    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta0[i][j]=zetahilf0[j][i]
    uloc=rmod2.vecgen1(rred)
    txtresults+="U local "+"\n"
    for i1 in range(0,rred):
        ux=0
        for i2 in range(0,rred):
            if zeta0[i1][i2]==0 and zeta0[i2][i1]==0:
                ux+=1
        uloc[i1]=ux
        txtresults+="U("+str(objred[i1])+"): "+str(uloc[i1])+"\n"
    print "uloc = ", uloc
    # now the r-ranges
    rrange=rmod2.vecgen1(rred)
    print "rrange"
    txtresults+="ranges due to the "+str(now)+"  weight tuples "+"\n"
    for i in range(0,rred):
        hilf=[]
        for j in range(0, now):
            hilf.append(cs[i][j])
        maxhilf=max(hilf)
        minhilf=min(hilf)
        rrange[i]=maxhilf-minhilf
        print round(rrange[i],2)
        txtresults+="RangeCs("+str(objred[i])+")"+":= "+str(round(rrange[i],3))+"\n"
    txtresults+="\n Ranges with respect to the original indicators 'r0' (+++note scaling level: real numbers++++!)"+"\n"    
    for i in range(0,rred):
        txtresults+="Range0("+str(objred[i])+"):= "+str(round(r0[i],3))+"\n"
    txtresults+="\n  Spearman correlations \n"    
    r,p=pstat.spearmanr(uloc,rrange)
    rsquared= r*r
    txtresults+="(squared )rrange vs Uloc "+str(round(rsquared,3))+"\n"
    r1,p1=pstat.spearmanr(uloc,r0)
    r1squared=r1*r1
    txtresults+="(squared )r0 vs Uloc "+str(round(r1squared,3))+"\n"
    r2,p2=pstat.spearmanr(r0,rrange)
    r2squared=r2*r2
    txtresults+="(squared )r0 (orig indic.) vs rrange (Cs) "+str(round(r2squared,3))+"\n"
    txtresults+="\n"
    d1,d2,d3=rmod2.brgsort(rrange)
    print "sorting according to rrange "
    for i in range(0,rred):
        print d1[i],objred[d3[i]]
    
    print "sorting according to uloc "
    u1,u2,u3=rmod2.brgsort(uloc)
    for i in range(0,rred):
        print u1[i],objred[u3[i]]
    # list of objects belongig to a certain uloc
    
    listu=[]
    for j in range(0, rred):
        hilflist=[]
        for i in range(0,rred):
            if u1[i]==u1[j]:
                hilflist.append(objred[u3[i]])
        if hilflist not in listu:        
            listu.append(hilflist)
                               
    print listu, len(listu), listu[len(listu)-1]

    # list of objects belonging to a certain rrange-value
    listr=[]
    for j in range(0, rred):
        hilflist=[]
        for i in range(0,rred):
            if d1[j]-0.00001 <=d1[i]<= d1[j]+0.00001:
                hilflist.append(objred[d3[i]])
        if hilflist not in listr:
            listr.append(hilflist)
    print listr, len(listr), listr[len(listr)-1]
    zahl=0
    tani=[]
    lr=len(listr)
    lu=len(listu)
    print "lr = ",lr
    print "lu = ",lu
    print listr[lr-1-1]
    setr=set([])
    setu=set([])
    anzsetr=[]
    txtresults+="Tanimoto-index of the merging sets"+"\n"
    txtresults+="(decreasing order of the ranges by the new MIS )"+"\n"
    txtsets="Sets according to Ulocal and the range over the set of consensus functions "+"\n"
    txtsets+="Your limit was "+str(limitsets)+"\n"
    for i1 in range(0,lr):
        for obj1 in listr[lr-1-i1]:
            setr.add(obj1)
        anzsetr.append(len(setr))    
        if lu-1-zahl>=0:
            for obj2 in listu[lu-1-zahl]:
                setu.add(obj2)
        else:
            for obj3 in objred:
                setu.add(obj3)
        if i1<=limitsets:        
            txtsets+=str(i1)+"  Ulocal: {"
            for elem1 in setu:
                txtsets+=str(elem1)+", "
            txtsets+="}\t Ranges: {"
            for elem2 in setr:
                txtsets+=str(elem2)+", "
            txtsets+="}\n"
          
        tani.append(1.0*len(setr&setu)/(1.0*len(setr)+1.0*len(setu)-1.0*len(setu&setr)))    
        print setr, setu,tani[zahl],len(setr)
        txtresults+=str(len(setr))+"\t"+str(round(tani[zahl],3))+"\n"
        
        zahl+=1
    txtsets+="\n  - - - e o f - - - "      
    tpresults=Tkinter.Toplevel(hf)
    tpresults.title('results of weight stability module ')
    tresults=ScrolledText(tpresults,width=60,height=20)
    tresults.pack()
    tresults.insert("end",txtresults)
    names=[" merging sets"," Tanimoto", "Weight stability "]
    app=raioop2.brggraph5(hf,names,"red",3,tani,1,lr)
    app.ausgabe()

def viewsets():
    #brg 19.2.2017
    tpsets=Tkinter.Toplevel(hf)
    tpsets.title(" View on tthe sets ")
    tsets=ScrolledText(tpsets,width=120, height=20)
    tsets.pack()
    tsets.insert("end",txtsets)
    
## Tkinter Plot
hf = Tkinter.Tk()
hf.title(' weightstability ')
aboutHDsimpl=raioop2.brgabout(hf,"tp1","about_weightstability.txt",3,\
            "February, the 24th, 2017"," about weightstability ", "white", "t1",80,5,ScrolledText)
helpHDsimpl=raioop2.brgabout(hf,"tp1","help_weightstability.txt",3,\
            "February, the 24th, 2017"," help_weightstability ", "white", "t1",80,5,ScrolledText)
    
fr = Tkinter.Frame(hf, width=60)
fr.pack()
frinput1 = Tkinter.Frame(fr, width=100, height=10)
frinput1.pack()
text = "Select first the file, then decide in which format to be opened "
lbinput1 = Tkinter.Label(frinput1,
                         text=text)
lbinput1.pack()
butt1 = Tkinter.Button(frinput1, text="Select filename  ",
                       bg="white", width=40,command=xselectfile)
butt1.pack()
                      
lbopen1 = Tkinter.Label(fr, text="")
lbopen1.pack()
buttshow_datamatrix = Tkinter.Button(fr,text="Show data matrix (dm)",bg="cyan",width=40, command=show_dm)
buttshow_datamatrix.pack()
buttHD = Tkinter.Button(fr, text='Draw HD', width=40, bg="cyan", command=HD)
buttHD.pack(pady=5)
lb1 = Tkinter.Label(fr,text=" ", width=50)
lb1.pack()
lb2=Tkinter.Label(fr,text="Enter number of weight tuples you would like to test ")
lb2.pack()
enow=Tkinter.Entry(fr,width=10)
enow.pack()
buttsubmit1=Tkinter.Button(fr,text="Submit the number of weight tuples ",bg="cyan",width=40,command=submitweighttuples)
buttsubmit1.pack()
buttsubmit2=Tkinter.Button(fr,text="Enter the weight values of each weight tuple ",bg="cyan",width=40,command=submitweightvalues)
buttsubmit2.pack()
##lbinweight=Tkinter.Label(fr,text="")
##lbinweight.pack()
lbweight=Tkinter.Label(fr,text="")
lbweight.pack()
buttnewMIS=Tkinter.Button(fr,text="HD based on the set of consensus-functions ",bg="cyan",width=40, command=HDnewMIS)
buttnewMIS.pack()
lb3=Tkinter.Label(fr,text="Insert how many sets \n\
                  (starting with smallest sets) \nyou would like to see (default: all)\n\
                  +++Note this has only to do with the viewing, not with the calculation itself+++")
lb3.pack()
elimitsets=Tkinter.Entry(fr,width=5)
elimitsets.pack()
buttUR=Tkinter.Button(fr,text="Calculate the Uloc- and R-ranges",bg="cyan",width=40, command=calc_UR_ranges)
buttUR.pack()
buttsetinfo=Tkinter.Button(fr,text="View the sets",bg="white",width=40,command=viewsets)
buttsetinfo.pack()
buttexit = Tkinter.Button(fr, text='exit', bg='red',
                          width=25, command=hf.destroy)
buttexit.pack(pady=10)

hf.mainloop()
