import rmod2
import raioop2
import Tkinter
from ScrolledText import *
import random
import os
import tkFileDialog
import stats
import pstat

# zetareader: Brg 19.6.08  derived from fuzzyHD10
# a program reading the zeta matrix
# Brg: 14.10.08 : help text external. Loading by an OOP-function
# 23.12.2012,
# 3.7.2013 slight changes 
# 19.12.2015



global q1,tech,r
tech=rmod2.vecgen1(20)
x=rmod2.marray(200,200)
y=rmod2.marray(200,200)



    
def fileopen():
    "Informs about the file-operations"
    # Excelreadin4 built in
    # Brg 29.11.07, 30.11.07, 15.1.08,18.2.08, 3.7.2013, 19.12.2015
    import tkFileDialog
    global fn,zetaMC,zetaav_vector,r, obj
    fn = tkFileDialog.askopenfilename()
    lfn=len(fn)
    if lfn>30:
        txt="<truncated>..."+fn[lfn-30:lfn]
    else:
        txt=fn
    zetaMC,ob,pr,r,k=rmod2.EXCELreadin4(fn)
    obj = []
    for i in range(0, r):
        obj.append(ob[i+1])
    zetaav_vector = []
    for i1 in range(0,r):
        for i2 in range(0,r):
            if i1 != i2:    
                zetaav_vector.append(zetaMC[i1][i2])                      #29.11.07
    lbopen1.config(bg="yellow")    #18.2.08
    lbopen1["text"]="File "+txt+"\n"+" was opened with "+"\n"+str(r)+" rows and "+str(k)+"  columns"
    return 

def tranzet():
    # brg 19.12.2015
    global zetaMC
    hilf=rmod2.marray(r,r)
    for i1 in range(0, r):
        for i2 in range(0, r):
            hilf[i1][i2] = zetaMC[i2][i1]
    for i1 in range(0, r):
        for i2 in range(0, r):
            zetaMC[i1][i2] = hilf[i1][i2]
            

def show_zetaMC():
    """ New routine : shows the zeta matrix """
    #Brg 13.1.08, 15.1.08, 19.12.2015
    #*: 13.1.08
    #akt: 19.12.15
    #note: modified from the routine, taken from simi3
    tp2=Tkinter.Toplevel(hf)
    tp2.title('show DM')
    lbtp2=Tkinter.Label(tp2,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i1 in range(0,r):
        txt1+=" "+obj[i1]+",\t"
    txt1+="\n"
    txt2="\n objects  \n"
    for i2 in range(0,r):
        txt2+=" "+obj[i2]+",\t"
    txt2+="\n"
    txt3="\n zeta matrix  \n"
    txt3+="\t"
    for i in range(0,r):
        txt3+=obj[i]+"\t"
    txt3+="\n"    
    for i1 in range(0,r):
        txt3+=obj[i1]+"\t"
        for i2 in range(0, r):
            txt3+=str(zetaMC[i1][i2])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)    



def fuzzyproduct(zetaMC):
    "see DeBaets,DeMeyer in Inf Sci 152, 2003, 167-179"
    #brg 14.11.07
    
    flag=0
    eps=0.01
    zaehl=0
   
    
    q=rmod2.matcopy1(r,r,zetaMC)
    
    while flag==0:
        q1=rmod2.fuzzymatmult(r,q,q)
        flag=rmod2.comparematrices(r,r,eps,q1,q)
        q=rmod2.matcopy1(r,r,q1)
        zaehl+=1
        if zaehl>100:
            break
        else:
            pass
    
    print "flag=",flag   
    txt=""
    hilf1=rmod2.vecgen1(r*r)
    hilf2=rmod2.vecgen1(r*r)
    hilf3=rmod2.vecgen1(r*r)
    alpha=rmod2.vecgen1(r*r)
    nn=rmod2.vecgen1(r*r)
    zaehl=0
    for i in range(0,r):
        for j in range(0,r):
            hilf1[zaehl]=round(q[i][j],3)
            zaehl+=1
    
    hilf2,nn=rmod2.raisort(r*r,hilf1)
    for i in range(0,r*r):
        hilf3[i]=hilf2[i]
        
    for i in range(0,r*r):
        z=hilf2[i]
        for i1 in range(i+1,r*r):
            if z==hilf2[i1]:
                hilf3[i1]="*"
    nr_of_cuts=0
    for i in range(0,r*r):
        if hilf3[i]!="*":
            alpha[nr_of_cuts]=float(hilf3[i])
            nr_of_cuts+=1
    txt1="Number of cuts = "+str(nr_of_cuts)+"\n"
    lbalpha.config(bg="yellow")
    lbalpha["text"]=txt1
    nhisto=5         #graphics  neu 20.2.08
    nal=nr_of_cuts   #graphics
    balpha=rmod2.vecgen1(nhisto)
    for j in range(0,nhisto):
        for i in range(0,nal):
            if j<nhisto-1 and j<=nhisto*alpha[i]<j+1:
                balpha[j]+=1
            if j==nhisto-1 and j<=nhisto*alpha[i]<=j+1:
                balpha[j]+=1
    histo=Tkinter.Toplevel(hf)
    histo.title(' alpha-values  ')
    talfa=ScrolledText(histo,width=60,height=5)
    talfa.pack(expand="yes",fill="both")
    txt2="alpha-values\n "  #16.3.09
    for i in range(0,nal):
        if i>0 and i%20==0:                        #18.2.08
            txt2+=str(alpha[i])+" \n"
        else:
            txt2+=str(alpha[i])+"   "
    #txt+="\n"
    txt2+="\n"+"  - - -   eof  - - - "        
    talfa.insert("end",txt2)
    return q

def crispq(q,r,acuser):
    "depending on alpha: crisp matrices"
    # brg 14.11.07, 26.7.2015, 19.12.2015
    global ior, nior   
    lbextract.config(bg="white")
    lbextract["text"]=""
    cq=rmod2.marray(r,r)
    for i1 in range(0,r):
        for i2 in range(0,r):
            if q[i1][i2]>=acuser:
                cq[i1][i2]=1
            else:
                cq[i1][i2]=0
    return cq,acuser


    
def extract(cq,r,acut):
    """extracts from the crisp matrix the order relations"""
    global eqtext
    lbextract.config(bg="yellow")
    lbextract["text"]="Extraction performed: Selected alpha-cut: "+str(acut)
    #brg 30.11.07, 11.4.08
    # the matrix order corresponds to objec
    
    # order is the matrix rs*rs which results after extract
    # rs is the number of rows/ columns of the square matrix order
    eqtext="\n"
    ec=rmod2.dmcompress(r,r,cq)             #30.11. from cq the equivalent relations
    eqtxt,Ksum_act=rmod2.eqcguiout2(r,ec,obj)        #30.11. matrix output 16.7.2013: eqc... version 2
    print "eqtxt = ",eqtxt
    eqtext+="Equivalence classes"+"\n"
    eqtext+=eqtxt
    eqtext+="\n"
    eqtext+="K = "+str(Ksum_act)+"\n"
    
    
    #print "r  = ",r
    txt=rmod2.irc_elim(r,ec)    #7.5.08 identifycolrows replaced by icr_elim
                                #in txt are the rows (and columns)
                                #...which can be eliminated
    
    ltxt=len(txt)
    b = rmod2.recogempty(txt,ltxt)
    # Not only the matrix cq is to be contracted but also the object vector obj
    # txt is a code of row numbers and as such ok for the matrixeliminations
    # however, to perform a new object list, txt must
    # be transformed in the corresponding object names
    an1,ldel1=rmod2.matrixcoldel(txt,r,r,cq) # columns eliminated
    order,ldel2=rmod2.matrixrowdel(txt,r,r-ldel1,an1)
    rs=r-ldel1
    
   
    if b=="true":
        #there is nothing to be reduced hence
        objec=rmod2.vecgentext1(r)
        for i in range(0,r):
            objec[i]=obj[i]
    else:        
        conobj=rmod2.vecgentext1(ltxt)
        for i in range(0,ltxt):
            conobj[i]=obj[int(txt[i])]
        #print "conobj = ",conobj    
        objec=rmod2.vecgentext1(rs)
        zaehl=0
        for i in range(0,r):
            #print "obj i  ",obj[i],"  in conobj  ",conobj
            if obj[i]not in conobj:
                objec[zaehl]=obj[i]
                zaehl+=1
    return order,objec,rs

def info_window(zetaav_vector, qmc, acut, rred, utotal, comptot, zzmax):
    #brg 6.6.2015, 27.11.2015, 19.12.2015
    hfeq=Tkinter.Toplevel(hf)
    hfeq.title(' Basic infos concerning the MC-study' )
    nav,mmav,mav,sdav,kav,kurtav = pstat.ldescribe(zetaav_vector)                                 
    txt = ' alpha-cut= '+str(acut)+"\n"
    txt += "\n"    
    txt += "zetaav - matrix (statistics of nondiagonal elements" +"\n" 
    txt += "no of nondiagonal elements of zetaav: "+str(nav)+"\n"
    txt += "minimal value of nondiagonal entries "+str(mmav[0])+"\n"
    txt += "maximal value of nondiagonal entries "+str(mmav[1])+"\n"
    txt += "mean of zetaav(i,j), i ne j          "+str(round(mav,4))+"\n"
    txt += "standard deviation of zetaav(i,j) i ne j "+str(round(sdav,4))+"\n"
    txt += "\n"
    txt+= "zetath-statistic (nondiagonal terms) "+"\n"
    zetath_vector = []
    for i1 in range(0, rred):
        for i2 in range(0, rred):
            if i1!=i2:
                zetath_vector.append(qmc[i1][i2])
    qmcnav,qmcmm, qmcmav,qmcsdav,qmckav, qmckurtav = pstat.ldescribe(zetath_vector)
    txt+="min =  "+str(qmcmm[0])+"\n"
    txt+="max =  "+str(qmcmm[1])+"\n"
    txt+="mean = "+str(round(qmcmav,4)) +"\n"
    txt+="std  = "+str(round(qmcsdav,4))+"\n"
    txt+="\n"                   
    txt+= ' file: '+str(fn)
    txt+="\n" +20*"- "+"\n" 
    txt+=eqtext+"\n"
    txt+="Incomparabilities    "+str(utotal)+"\n"
    txt+="Comparabilities      "+str(comptot)+"\n"
    txt+="No of levels         "+str(zzmax)+"\n"
    txt+= "- - -    e o f  - - -  "+"\n"
    teq=ScrolledText(hfeq,width=70,height=10)
    teq.pack(expand="yes",fill="both")
    teq.insert("end",txt)
    return
    

def HDMC(order,rs,r,objec,acut):
    "based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"
    # Brg 20.12.07, 28.12.07
    # If the number of representants > 200 then only the cover-matrix and the level-population
    #
    global covmc,n,objr,objredmc
        
    if r==0:
        hfwarning=Tkinter.Toplevel(hf)
        hfwarning.title('++warning++')
        frwarning=Tkinter.Frame(hfwarning,width=10,height=3)
        frwarning.pack()
        bwarning=Tkinter.Button(frwarning,text="++warning ++",command=msgwarning)
        bwarning.pack()
    #print "test 7.5.08 rs  = ",rs    
    n=rs  #14.4.08 
    objredmc=rmod2.vecgentext1(rs)  #changed to ..text1: 7.5.08
    
    for i in range(0,rs):
        objredmc[i]=objec[i]  #control 15.1.08
         
    hfhd1=Tkinter.Toplevel(hf)
    hfhd1.title(' Hasse diagram / cover matrix ')
   
    txt="\n"+" alpha-cut = "+str(acut)+"\n"    
    lbhfhd1=Tkinter.Label(hfhd1,text='Hasse diagram or cover matrix , Parameters: '+txt)
    lbhfhd1.pack()
    freq=Tkinter.Frame(hfhd1,width=400,height=480)
    freq.pack()
       
    
    zetamcmc=rmod2.marray(rs,rs)
    for i in range(0,rs):
        for j in range(0,rs):
            zetamcmc[i][j]=order[i][j]   #15.1.08 evtl. diese Manipul weglassen
    #
    #One linear extension (based on levels)
    lbhd1=Tkinter.Label(freq,text= "Level ")
    lbhd1.pack()
    utotal=rmod2.incompzeta(rs,zetamcmc)   #9.2.2008
    #print "rs= ",rs      #16.7.2013
    comptot=rs*(rs-1.0)/2.0 - utotal
    #rmod2.matout(n,n,zeta)
    lobjmc,lextmc,revlextmc,zzmaxmc=rmod2.levtopsort(rs,zetamcmc)
    
    #print "zzmax = ",zzmax
    tlev=ScrolledText(freq,width=60,height=4)
    tlev.pack(expand="yes",fill="both")
    txt1="\n"
    txt1+=" L e v e l  , alphacut = "+str(acut)+"\n"
    for i in range(0,zzmaxmc):
        txt1+="Level "+str(zzmaxmc-i)+" :"
        for j in range(0,len(lobjmc[i])):
            txt1+= objredmc[lobjmc[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)
    lbequiv=Tkinter.Label(freq,text="Nontrivial Equivalence classes")
    lbequiv.pack()
    txt2="\n equivalence classes \n\n"
    txt2+="Alpha-cut = "+str(acut)+"\n"
    txt2+=eqtext
    txt2+="\n"
    txt2+="\n -- end of list -- "
    tlinext=ScrolledText(freq,width=60, height=2)
    tlinext.pack(expand="yes",fill="both")
    tlinext.insert("end",txt2)
    
    #Adj-Listen

    adjc=rmod2.adjacent(n,lextmc,revlextmc,zetamcmc)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(n,adjc,lextmc)
       
    
    covmc=rmod2.cover(n,tr,lextmc)
    
    
    lbhd3=Tkinter.Label(freq,text=" Hasse Diagram, parameters:  "+txt)
    lbhd3.pack()
    cv=Tkinter.Canvas(freq,width=400,height=480,bg="white")  #5.3.09
    lz=zzmaxmc
    l=rmod2.vecgen1(lz)
    for i in range(0,lz):
        l[i]=len(lobjmc[i])

    pos=rmod2.vecgen1(lz)
    for i in range(0,lz):
        pos[i]=l[i]
    
    geomx=rmod2.marray(n,n)
    geomy=rmod2.marray(n,n)

    geom0x=10
    geom0y=20
    ff = 320.0
    for i in range(0,lz):  #random positions 22.11.2010, 5.1.2011
        for j in range(0,l[i]):
            geomx[i][j]=geom0x+(ff/(pos[i]+1.0))*(j+1)  #22.11.2010    
            geomy[i][j]=geom0y+(320.0/lz)*i

    for i in range(0,lz-1):
        for j in range(0,l[i]):
            #print obj[lobj[i][j]]
            for i1 in range(i+1,lz):
                for j1 in range(0,l[i1]):
                    #print obj[lobj[i1][j1]]
                    if covmc[lobjmc[i1][j1]][lobjmc[i][j]]==1:
                        #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                        cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


    for i in range(0,lz):
        for j in range(0,l[i]):
            cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
            cv.create_text(geomx[i][j],geomy[i][j],text=objredmc[lobjmc[i][j]])
    garrow1x=380
    garrow1y=20
    garrow2y=230
    cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
    cv.create_text(garrow1x+8,garrow1y-6,text="high")
    cv.create_text(garrow1x+8,garrow2y+6,text="low")
    cv.pack()
    buttcover=Tkinter.Button(freq,text="show cover relation",command=cover_show)
    buttcover.pack()
    return utotal, comptot, zzmaxmc
        
        
def cover_show():
    hfcover2 = Tkinter.Toplevel(hf)
    hfcover2.title(' cover-matrix ')
    lbcov = Tkinter.Label(hfcover2,text=" Cover-Relations ")
    lbcov.pack()
    txt3 = "\n cover-matrix  \n"
    for i in range(0, len(covmc)):
        txt3 += "\n" + objredmc[i] + ":\t"
        txt3 += "is covered by "
        for j in range(0, len(covmc)):
            if i!=j:
                if covmc[i][j] == 1:
                    txt3 += " " + objredmc[j] + " ,"
                else:
                    pass
            else:
                pass
        txt3 += "\n"    
    txt3 += "\n"
    txt3 += " -- end of list --"
    tcov=ScrolledText(hfcover2,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)

    


def towardsmcHD():
    #brg 7.5.2015, 19.12.2015
    try:
        acut = float(eacut.get())
    except:    
        acut = 0.5
    print "acut = ",acut
    qmc = fuzzyproduct(zetaMC)
    cq,acut = crispq(qmc,r,acut)
    order_act,objec_act,rs = extract(cq,r,acut)
    utotal,comptot,zzmax = HDMC(order_act,rs,r,objec_act,acut)
    info_window(zetaav_vector,qmc,acut,rs,utotal, comptot,zzmax)
  

hf=Tkinter.Tk()
hf.title("      zetaMC --> HD: vs Dec. 2015         ")
aboutzetareader2=raioop2.brgabout(hf,"tp1","about_zetabiodiv.txt",1,\
            "Dec., 19th, 2015"," about_zetabiodiv ", "white", "t1",80,5,ScrolledText)
helppyhassemenue=raioop2.brgabout(hf,"tp1","help_zetabiodiv.txt",1,\
            "Dec., the 19th,2015"," help_zetabiodiv ", "white", "t1",80,5,ScrolledText)

fr=Tkinter.Frame(hf,width=400,height=400)
fr.pack()
lbinfo=Tkinter.Label(fr,text="Author: R.Bruggemann, vs of 19.12.2015", width=70)
lbinfo.pack(pady=10)

frinput1=Tkinter.Frame(fr,width=100,height=10)
frinput1.pack()

butt1=Tkinter.Button(fr,text="(1)select and open zeta-file ",bg="white",width=25,command=fileopen)
butt1.pack()
lbopen1=Tkinter.Label(fr,text="")
lbopen1.pack()
buttshow=Tkinter.Button(fr,text="show zeta matrix",bg="cyan",width=25,command=show_zetaMC)
buttshow.pack()
lbacut = Tkinter.Label(fr, text=" Enter defuzzific. parameter acut (0...1) ")
lbacut.pack()
eacut = Tkinter.Entry(fr,width=5)
eacut.pack()
lbalpha=Tkinter.Label(fr,text="")
lbalpha.pack()
lbextract=Tkinter.Label(fr,text="")
lbextract.pack()
butttranspose=Tkinter.Button(fr,text="Transpose the zeta-matrix ",bg ="cyan", width=25, command = tranzet)
butttranspose.pack()
butt6=Tkinter.Button(fr,text="(2) Generate HD",bg="cyan",width=25,command=towardsmcHD)
butt6.pack()
buttexit=Tkinter.Button(hf,text=" exit ",bg="red", bd=4, width=25,command=hf.destroy)
buttexit.pack(pady=20)
hf.mainloop()
