import Tkinter
import rmod2
import raioop2
from ScrolledText import *
import tkFileDialog

import Canvas
import os
from math import *

# po_lib.py
# derived  24.10.2018
# 30.10.2018
# 31.10.2018

# fileselect(); return: -
# HD(master, fn, matrix,no_vertex,no_indic,vertex_labels,radius_vertex);
#     return: cover_matrix
# cover_show(covermatrix, vertex_labels):
# show_DM(master, fn, datamatrix, labels_indicator, vertex_labels):
# filecomp(fn); return rred,k1,xred,objred,obj,prop,txt
# show_equivalencies(master, txteq):

def fileselect():
    """ File selection and opening by Tkinter-Standards for discretization"""
    #*13.1.08
    #akt: 13.1.08, 28.5.09, 12.1.2015, 23.10.2018
    #note: Taken from antag
    #source:-
    #tp=Tkinter.Toplevel(hf)   #18.2.08
    global fn,k,r,dm,e_mina,e_maxa,e_K,prop,obj, eKdefault, prop, dmred, objred,rred
    fn=tkFileDialog.askopenfilename()
    
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    obj=[]
    for i in range(1,len(ob)):
        obj.append(ob[i])
    prop=[]
    for j in range(1, len(pro)):
        prop.append(pro[j])
    lbopen1.config(bg="yellow")
    lbopen1["text"]="selected initial file : "+fn+"\n"+str(r)+" rows\n"+str(k)+" columns"
    #############################this part is of 21.12.07 #########
    rred,dmred,objred,txt=rmod2.equivcompact(r,k,dm,obj)    
    ###############################################################
    



def HD(master, fn, matrix,no_vertex,no_indic,vertex_labels,radius_vertex):
    # Brg  23.10.2018, 24.10.2018
    # master: usually hf, a call of hf without ""
    # fn: filename, usually fn
    # actual conventions
    # note; equivalence reduction must be done outside
    Tphd=Tkinter.Toplevel(master)
    Tphd.title('Hasse diagram / cover matrix ')
    frhd=Tkinter.Frame(Tphd,width=200,height=300)
    frhd.pack()
    zetahilf=rmod2.comp(no_vertex,no_indic, matrix)
    zeta=rmod2.marray(no_vertex,no_vertex)
    for i1 in range(0,no_vertex):
        for i2 in range(0,no_vertex):
            zeta[i1][i2]=zetahilf[i2][i1]
                 
    #One linear extension (based on levels)
    lbhd1=Tkinter.Label(frhd,text= "Level ")
    lbhd1.pack()
                 

    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(no_vertex,zeta)
    #print "zzmax = ",zzmax
    tlev=ScrolledText(frhd,width=60,height=4)
    tlev.pack()
    txt1="\n"
    levmax=-10**20
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
    txtHD="file = "+str(fn)+"\n"
    txtHD+="Basics: a) number of level: \t\t\t"+str(zzmax)+"\n"
    txtHD+="no of representants in largest level:\t"+str(levmax)+"\n"
    lbbasic2=Tkinter.Label(frhd,text=txtHD,bd=3,bg="yellow",width=60)
    lbbasic2.pack()
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= vertex_labels[lobj[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)

        
    #Adj-Listen

    adjc=rmod2.adjacent(no_vertex,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(no_vertex,adjc,lext)
       
    
    cover_matrix=rmod2.cover(no_vertex,tr,lext)
                 
    
    if no_vertex>400:
        cover_show(cover_matrix,vertex_labels)                 #20.1.08
    else:
        lbhd3=Tkinter.Label(frhd,text=" Hasse Diagram of File "+fn)
        lbhd3.pack()
        actwidth,actheight,factorx,factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=geomHD(no_vertex,levmax,zzmax)
        cv=Tkinter.Canvas(frhd,width=actwidth,height=actheight,bg="white")
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(no_vertex,no_vertex)
        geomy=rmod2.marray(no_vertex,no_vertex)

        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(factory/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cover_matrix[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-radius_vertex,\
                               geomy[i][j]+radius_vertex,geomx[i][j]+radius_vertex,\
                               geomy[i][j]-radius_vertex,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=vertex_labels[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.pack()
    return cover_matrix

def HDzeta(master, fn, zeta,no_vertex,vertex_labels,radius_vertex):
    # Brg  23.10.2018, 24.10.2018, 30.10.2018, 31.10.2018
    # master: usually hf, a call of hf without ""
    # fn: filename, usually fn
    # actual conventions
    # note; equivalence reduction must be done outside
    # Example for the inputs
    # obj=["a","b","c","d"]
    # zeta=[[1,1,1,1],[0,1,0,0],[0,0,1,1],[0,0,0,1]]
    # a < b, a < c, a < d, c < d
    # zeta[i,j]=1 means i = < j
    # Example how to use HDzeta: see "AnderePythonprogramme\, Uebungsprogramme\towardsTodeschini1.py"
    


    Tphd=Tkinter.Toplevel(master)
    Tphd.title('Hasse diagram / cover matrix ')
    frhd=Tkinter.Frame(Tphd,width=200,height=300)
    frhd.pack()
    #One linear extension (based on levels)
    lbhd1=Tkinter.Label(frhd,text= "Level ")
    lbhd1.pack()
                 

    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(no_vertex,zeta)
    #print "zzmax = ",zzmax
    tlev=ScrolledText(frhd,width=60,height=4)
    tlev.pack()
    txt1="\n"
    levmax=-10**20
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
    txtHD=str(fn)+"\n"
    lbbasic2=Tkinter.Label(frhd,text=txtHD,bd=3,bg="yellow",width=60)
    lbbasic2.pack()
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= vertex_labels[lobj[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)

        
    #Adj-Listen

    adjc=rmod2.adjacent(no_vertex,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(no_vertex,adjc,lext)
       
    
    cover_matrix=rmod2.cover(no_vertex,tr,lext)
                 
    
    if no_vertex>400:
        cover_show(cover_matrix,vertex_labels)                 #20.1.08
    else:
        lbhd3=Tkinter.Label(frhd,text=" Hasse Diagram of File "+fn)
        lbhd3.pack()
        actwidth,actheight,factorx,factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=geomHD(no_vertex,levmax,zzmax)
        cv=Tkinter.Canvas(frhd,width=actwidth,height=actheight,bg="white")
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(no_vertex,no_vertex)
        geomy=rmod2.marray(no_vertex,no_vertex)

        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(factory/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cover_matrix[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-radius_vertex,\
                               geomy[i][j]+radius_vertex,geomx[i][j]+radius_vertex,\
                               geomy[i][j]-radius_vertex,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=vertex_labels[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.pack()
    return cover_matrix

                 
def HDzeta2(master, fn, zeta,no_vertex,vertex_labels,radius_vertex,txt):
    # Brg  23.10.2018, 24.10.2018, 30.10.2018, 31.10.2018
    # master: usually hf, a call of hf without ""
    # fn: filename, usually fn
    # actual conventions
    # note; equivalence reduction must be done outside
    # Example for the inputs
    # obj=["a","b","c","d"]
    # zeta=[[1,1,1,1],[0,1,0,0],[0,0,1,1],[0,0,0,1]]
    # a < b, a < c, a < d, c < d
    # zeta[i,j]=1 means i = < j
    # Example how to use HDzeta: see "AnderePythonprogramme\, Uebungsprogramme\towardsTodeschini1.py"
    


    Tphd=Tkinter.Toplevel(master)
    Tphd.title('Hasse diagram / cover matrix ')
    frhd=Tkinter.Frame(Tphd,width=200,height=300)
    frhd.pack()
    #One linear extension (based on levels)
    lbhd1=Tkinter.Label(frhd,text= "Level ")
    lbhd1.pack()
                 

    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(no_vertex,zeta)
    #print "zzmax = ",zzmax
    tlev=ScrolledText(frhd,width=60,height=4)
    tlev.pack()
    txt1="\n"
    levmax=-10**20
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
    txtHD=txt+"\n"
    lbbasic2=Tkinter.Label(frhd,text=txtHD,bd=3,bg="yellow",width=60)
    lbbasic2.pack()
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= vertex_labels[lobj[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)

        
    #Adj-Listen

    adjc=rmod2.adjacent(no_vertex,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(no_vertex,adjc,lext)
       
    
    cover_matrix=rmod2.cover(no_vertex,tr,lext)
                 
    
    if no_vertex>400:
        cover_show(cover_matrix,vertex_labels)                 #20.1.08
    else:
        lbhd3=Tkinter.Label(frhd,text=" Hasse Diagram of File "+fn)
        lbhd3.pack()
        actwidth,actheight,factorx,factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=geomHD(no_vertex,levmax,zzmax)
        cv=Tkinter.Canvas(frhd,width=actwidth,height=actheight,bg="white")
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(no_vertex,no_vertex)
        geomy=rmod2.marray(no_vertex,no_vertex)

        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(factory/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cover_matrix[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-radius_vertex,\
                               geomy[i][j]+radius_vertex,geomx[i][j]+radius_vertex,\
                               geomy[i][j]-radius_vertex,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=vertex_labels[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.pack()
    return cover_matrix




def cover_show(master, covermatrix, vertex_labels):
    """Cover-matrix is displayed"""
    #brg 28.12.07, 25.1.2014
    #*28.12.07
    #akt25.1.14, 23.10.2018
    #note: -
    #source: -
    n=len(covermatrix)             
    hfcover=Tkinter.Toplevel(master)
    hfcover.title(' cover-matrix ')
    
    lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i1 in range(0,n):
        txt3+="\n"+vertex_labels[i1]+":\t"
        txt3+="is covered by "
        for i2 in range(0,n):
            if i1!=i2:
                if covermatrix[i1][i2]==1:
                    txt3+=" "+vertex_labels[i2]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)
                 
def geomHD(zv, levm,zlev):
    """ from zv the graphical control for HDs is derived """
    #zv is the number of vertices
    # levm is the number of vertices in the maximal level (determines the x coord
    # zlev is the number of levels, determines the y coord
    # * Brg 10.6.08
    # akt: 29.5.09
    # brg 10.6.08, 29.5.09
    # taken from interval4.py
    awidth=zv*40
    aheight=zv*40
    if awidth<120:
        awidth=120
    if awidth>600:
        awidth=600
    if aheight<120:
        aheight=120
    if aheight>600:
        aheight=600
    
    #aheight and awidth: extent of canvas
    fx = int((awidth-40))
    fy = int((aheight-40))
    g0x=5   #Start of the HD-area x
    g0y=20   #Start of the HD-area y
    garr1x=fx +10.0  #location of the arrow
    garr1y=20
    garr2y=fy+10.0
    return awidth,aheight,fx,fy,g0x,g0y,garr1x,garr1y,garr2y            
         
def show_DM(master, fn, datamatrix, labels_indicator, vertex_labels):
    """ New routine : shows the data matrix """
    #Brg 13.1.08, 23.10.2018, 24.10.18, 30.10.18
    global mindm,maxdm
    tp2=Tkinter.Toplevel(master)
    tp2.title(' show data matrix ')
    lbtp2=Tkinter.Label(tp2,text=" General information about data matrices ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=20)
    tfile.pack()
    #print "filename= ",fn
    #print "vertex_labels  ",vertex_labels
    txt1="basical filename "+str(fn)+"\n"
    txt1+="labels1\n"
    r=len(datamatrix)
    #print "r= ",r
    k=len(labels_indicator)
    for i in range(0,r):
        txt1+=" "+str(vertex_labels[i])+",\t"
    txt1+="\n"
    txt2="\labels2  \n"
    for j in range(0,k):
        txt2+=" "+str(labels_indicator[j])+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=labels_indicator[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=vertex_labels[i]+"\t"
        for j in range(0,k):
            txt3+=str(round(datamatrix[i][j],3))+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    print "txt= ",txt
    
    txtext="\n\nMin and Max of any column\n"
    mindm=rmod2.vecgen1(k)
    maxdm=rmod2.vecgen1(k)
    for j in range(0,k):
        txtext+="q("+str(j)+")\t"
    txtext+="\n"
    for j in range(0,k):
        dmc=rmod2.vecgen1(r)
        for i in range(0,r):
            dmc[i]=datamatrix[i][j]
        mindm[j]=min(dmc)
        txtext+=str(min(dmc))+"\t"
    txtext+="\n"
    for j in range(0,k):
        dmc=rmod2.vecgen1(r)
        for i in range(0,r):
            dmc[i]=datamatrix[i][j]
        maxdm[j]=max(dmc)
        txtext+=str(max(dmc))+"\t"
    txtext+="\n"
    txt+=txtext
    txt+="- - - - e o f   - - -  "
    tfile.insert("end",txt)

def show_DM2(master, fn, datamatrix, name_of_matrix, labels_indicator, vertex_labels):
    """ New routine : shows the data matrix """
    #Brg 13.1.08, 23.10.2018, 24.10.18, 30.10.18
    global mindm,maxdm
    tp2=Tkinter.Toplevel(master)
    tp2.title(' show '+name_of_matrix)
    lbtp2=Tkinter.Label(tp2,text=" General information about "+ name_of_matrix)
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=20)
    tfile.pack()
    #print "filename= ",fn
    #print "vertex_labels  ",vertex_labels
    txt1="basical filename "+str(fn)+"\n"
    txt1+=name_of_matrix+"\n"
    txt1+="labels1\n"
    r=len(datamatrix)
    #print "r= ",r
    k=len(labels_indicator)
    for i in range(0,r):
        txt1+=" "+str(vertex_labels[i])+",\t"
    txt1+="\n"
    txt2="\labels2  \n"
    for j in range(0,k):
        txt2+=" "+str(labels_indicator[j])+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=labels_indicator[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=vertex_labels[i]+"\t"
        for j in range(0,k):
            txt3+=str(round(datamatrix[i][j],3))+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    print "txt= ",txt
    
    txtext="\n\nMin and Max of any column\n"
    mindm=rmod2.vecgen1(k)
    maxdm=rmod2.vecgen1(k)
    for j in range(0,k):
        txtext+="q("+str(j)+")\t"
    txtext+="\n"
    for j in range(0,k):
        dmc=rmod2.vecgen1(r)
        for i in range(0,r):
            dmc[i]=datamatrix[i][j]
        mindm[j]=min(dmc)
        txtext+=str(min(dmc))+"\t"
    txtext+="\n"
    for j in range(0,k):
        dmc=rmod2.vecgen1(r)
        for i in range(0,r):
            dmc[i]=datamatrix[i][j]
        maxdm[j]=max(dmc)
        txtext+=str(max(dmc))+"\t"
    txtext+="\n"
    txt+=txtext
    txt+="- - - - e o f   - - -  "
    tfile.insert("end",txt)


def filecomp(master, fn):
    """ reduces a dm with equiv objects to a dm of a quotient set """
    # Brg 12.12.07, 13.1.08, 14.1.08, 8.5.08, 2.8.16
    # von mainHD3 uebernommen und geringfuegig angepasst
    #r,k,dm,ob,pro,fn are globals and should be available after open
    global r,dm,prop 
    dm,ob,pro,r,k1=rmod2.EXCELreadin4(fn)
    #recoding ob to obj and pro to prop
    if r==0:
        hfwarning=Tkinter.Toplevel(master)
        hfwarning.title('++warning++')
        frwarning=Tkinter.Frame(hfwarning,width=10,height=3)
        frwarning.pack()
        bwarning=Tkinter.Button(frwarning,text="++warning ++",command=msgwarning)
        bwarning.pack()
        
    prop=rmod2.vecgentext1(k1)
    obj=rmod2.vecgentext1(r)     #changed to ...text1: 8.5.08
    for i in range(0,k1):
        prop[i]=pro[i+1]
    for i in range(0,r):
        obj[i]=ob[i+1]
    #############################this part is of 21.12.07 #########
    rred,xred,objred,txt=rmod2.equivcompact(r,k1,dm,obj)    
    ###############################################################
    return rred,k1,xred,objred,obj,prop,txt           
     
def show_equivalencies(master,fn, txteq):
    # brg 24.10.18
    
    tpequiv = Tkinter.Toplevel(master)
    tpequiv.title(" equivalence classes ")
    tequiv=ScrolledText(tpequiv,width=60, height=10)
    tequiv.pack()
    txteq2="Equivalence classes"+"\n"
    txteq2+=50*"="+"\n"
    txteq2+="File: "+str(fn) +"\n"
    txteq2+="equivalence classes: "+"\n"
    txteq2+=txteq+"\n"
    txteq2+="\n"
    txteq2+="- - - e o f - - -"
    tequiv.insert("end",txteq2)

    



    
