from math import *
import random
import copy
import os
import sys
import pstat
import stats
import heapq
from string import *

# brg 28.2.07-20.6.08 
# 25.6.08: some print commands manually commented out
# 25.6.08: New: Warshall algorithm
# 1.7.08 New: geometry-, vectornorm-procedures
# 2.7.08 slightly modified: vectornorm
# 15.7.08: Function 'version' to verify the version and the actual date
# 12.10.08 : new: suchlist
# 13.10.08: new mattransp
# 19.11.08 porgraph modified (original version: not logical and adds one digit)
# 27.11.08
# 28.11.08 new: optimattr
# 24.12.08 new raiwrite3
# 28.12.08 new routine to estimate the height of a ScrolledText
# 5.2. 09 partialseparability
# 1.3.09  inclusion of graphcovdict, prim(graph), covadjlist, countC, countCC1
# 18.3.09 qualcomp1
# 10.1.10 textpartitioning
# 24.2.10  EXCELreadin4 changed (more info if opening fails)
# 4.7.10: Outranking-matrix as basic procedure
# 6.8.10: New: msort
# 20.8.10: A series of list-no and pair assignment procedures
# 2.2.2011 Changes in the copeland procedure
# 4.4.2011 New equivcompactgr: The equivalences are stored in eqm as a adjacence matrix
# 11-12.4. some changes in equivcompact, leading to a trial version equicompactm1
# 13.4.2011 new procedures: genoutrk, rktrafo and rkinterval
# 19.1.2012 genlistpaar (0,1],(0,2),..,(1,2),(1,3),...(n-1,n)
#           Hasse_matrix
# 24.3.2012 New routines now generally at the end , today extendeddm.
# 27.3.2012: quartile
# 23.6.2012 new procedures to topic 'weak order'
# 16.7.2012 New trred (may once replace adjacent and trrediuct
# 2.8.2012: New routines combinatorics
# 20.3.2013 New: binaercode and permutration (perm)
# 21.8.2013: Excelreadin5 for matrices with rows and columns <= 50000
# 15.11.2013: routines equivect and weak2
# 9.11.2014 massively trouble with output of equivwlenceclasses when they are very large
# 19.1.2015 bug eliminated in matrxchar
# 24.1.2015 new procedures mattransp2 and table
# 25.1.2015 New Excelreadin (after the catstrophe with Bach data)
# 01.08.2018 An improved levtopsort is now inserted, called levtop


def binaercode(z):
    # brg 20.3.2013
    # bin is a built_in function in Python
    x=bin(z)
    # x is coded as follows 0b<2power0,2power1,2power2,...>
    bc=x[2:]
    return bc

def version():
    """rmod2 version and updating """
    txt="rmod version 2 of March, the 18th, 2009"
    # Brg
    # txt: info about version
    return txt

def sign(x):
    """ sign of a variable +1.0, -1.0 or 0 """
    # brg 16.11.10
    if x!=0:
        sx=1.0*x/abs(x)
    else:
        sx=0
    return sx


def yes_no(text):
    """question 'text' answer y or n  """
    #brg  25.7.07
    #*25.07.07
    #akt25.07.07
    #source:-
    response=None
    while response not in ("y","n"):
        print "answer 'y'  or 'n'"
        response=raw_input(text).lower()
    return response    



def hallo_rainer():
    """ einfacher Test um rmod2 zu testen"""
    # brg 6.5.08
    # * 6.5.08
    # akt: 6.5.08
    print "=============================="
    print "==   Hallo   Rainer !!!    ==="
    print "=============================="
    return



def fakult(n):
    """n !"""
    #brg 15.11.07
    #*13.01.04
    #akt15.11.07
    #source:-
    m=1
    for i in range(1,n+1):
        m=m*i
    return m

def nueberk(n,k):
    """n over k"""
    #Brg 15.11.07
    #*1.1.04
    #akt15.11.07
    #source:LINUX
    nf=fakult(n)
    kf=fakult(k)
    knf=fakult(n-k)
    erg=1.0*nf/(1.0*kf*knf)
    return erg

def nueberk1(n,k):
    """n over k"""
    #Brg 15.11.07, 28.2.2013
    #*1.1.04
    #akt 28.2.2013
    #source:LINUX
    nf=fakult(n)
    kf=fakult(k)
    knf=fakult(n-k)
    erg=1.0*nf/(1.0*kf)
    erg=1.0*erg/(1.0*knf)
    return erg


def estfakult(n):
    """ n! approximated by Stirling """ 
    # brg *2.8.2012
    # brg akt: 2.8.2012
    # brg Examplefile: estimationsclasses
    #
    # approximation of faculty n!
    # Following Bronstein, Semendjajew page 103,25th edition
    import math
    x=(n+0.5)*math.log(n)-n+0.5*math.log(6.28)
    y=math.exp(x)
    return y


def estimanz(lt,r):
    """ either exact or by use of Stirling approximation: (lt over r)"""
    # brg * 2.8.2012
    # brg act: 2.8.2012, 5.8.2012
    # brg 2.8.2012
    # n!/(n-r)!/r! either estimated or exact
    # Note, result may have rounding errors
    #       therefore the applying program must be aware of this
    txt=""
    f1est=estfakult(lt)
    f2est=estfakult(lt-r)
    f3est=estfakult(r)
    anzest=1.0*f1est/(1.0*f2est*f3est)
    if anzest>1000000:
        txt+= "approx no of combinations: "
        result=anzest
    else:
        txt+="exact no of combinations: "
        f1=fakult(lt)
        f2=fakult(lt-r)
        f3=fakult(r)
        anz=1.0*f1/(1.0*f2*f3)
        result=anz
    return result,txt    



def dicgen(name,n):
    """generates a dictionary with name 'name'"""
    #Brg 15.11.07
    #*30.1.04
    #akt15.11.07
    #source:LINUX
    name={}
    for i in range(0,n):
        name[i]=i
    return name

def repres(suc):
    """eliminates repetitions in a list suc and sorts"""
    # brg von LINUX (19.1.07) uebernommen am 15.11.07
    #*19.1.07
    #akt15.11.07
    #source:LINUX
    # suc input list
    # ac reduced and sorted list
    test="*"
    ac=[]
    for j in suc:
        if j!=test and j not in ac:
            test=j
            ac+=[test]
    ac.sort()
    return ac

def norm(s,x):
    """a string gets a standard length of x (integer)"""
    #brg 30.9.07
    #*30.9.07
    #akt30.9.07
    #source:-
    # s is a string
    # x is an integer counting the wanted length
    
    while len(s)<x:
        s+="."
        
    return s

def lifi():
    """List of the path and of all files in the directory of the running program"""
    #brg 14.7.07
    #*14.7.07
    #akt14.7.07
    #source:-
    #note: module os and sys must be imported
    #  brg 14.7.07
    path=os.getcwd()
    print path
    fil=os.listdir(path)
    lfile=len(fil)
    print "Number of files in ",path,"  = ",lfile
    zaehl=0

    for i in range(0,lfile):
        print fil[i]
        zaehl+=1
        if int(zaehl/10)-float(zaehl)/10.0 ==0:
            but=raw_input('  CRF  ... ')

def searchpy():
    """list of all py-files in current directory"""
    #brg 14.7.07
    #*14.7.07
    #akt14.7.07
    #source:-
    #note: module os and sys must be imported
    path=os.getcwd()
    fil=os.listdir(path)
    lfile=len(fil)
    for i in range(0,lfile):
        lfdateiname=len(fil[i])
        exta=fil[i][-2:]
        if exta!="py":
            print fil[i]


def rsearch(text):
    """if the extension is - text -
    then a list of files of the current directory"""
    #brg 14.7.07
    #*14.7.07
    #akt14.7.07
    #source:-
    #note: module os must be imported
    
    path=os.getcwd()
    fil=os.listdir(path)
    lfile=len(fil)
    lte=len(text)
    for i in range(0,lfile):
        lfdateiname=len(fil[i])
        exta=fil[i][-lte:]
        if exta==text:
            print fil[i]


def vecgen(n,x):
    """Defines a vector of length n"""
    # brg  17.4.07
    #*14.7.07
    #akt14.7.07
    #source:-
    #note:use of append
    for i in range(0,n):
        x.append(0)
    return

def vecgen1(n):
    """Defines a vector of length n"""
    # brg  17.4.07, 26.4.07
    #*17.4.07
    #akt26.4.07
    #source:-
    #note: append 
    x=[]
    for i in range(0,n):
        x.append(0)
    return x

def vecgen2(n,x):
    """Defines a vector of length n and fills with 'x' """
    # brg 18.12.07, 7.5.08
    #*18.12.07
    #akt7.5.08
    #source:vecgen1
    #note.-
    y=[]
    for i in range(0,n):
        y.append(x)
    return y


def vecgentext(n):
    """Defines a strg-vector of length n+1"""
    # brg 26.5.07, 7.5.08
    #*: 26.5.08
    # akt: 7.5.08
    # source: vecgen2
    # note: from vecgen, 8.5.08: wird irgendwann eliminiert. Ist komplett
    #        ersetzt durch vecgentext1
    x=[]
    for i in range(0,n-1):  #changed 7.5.08
        x.append(" ")
    return x    

def vecgentext1(n):
    "Defines a strg-vector of length n"
    # brg 26.5.07, 18.11.07
    # *: 26.5.08
    # akt: 8.5.08
    # note: wird vecgentext ersetzen
    
    x=[" "]
    for i in range(1,n):
        x.append(" ")
    return x    

def reverselist(k,list1):
    """ list1 will reverted and stored in a new list """
    # brg 18.9.08
    # *: 18.9.08
    # akt: 8.9.08
    # tested with reverse1.py
    list2=vecgen1(k)
    for i in range(0,k):
        list2[i]=list1[k-1-i]
    return list2    



def ende():
    sys.exit(0)

def rainer(pc):
    """juhu - in TEST2"""
    #brg 28.2.07, 19.3.07, 20.4.07, 22.6.08
    #*28.2.07
    #akt22.6.08
    #note:music
    #source:-
    if pc=="homePC":
        path="F:/Python/Uebungsprogramme/wav/"
    elif pc=="labtop":
        path="C:/Dokumente und Einstellungen/brg/Eigene Dateien/Python/Uebungsprogramme/wav/"
    else:
        path=raw_input(' Individueller path ')
    print "juhu"
    print "und Dralala"
    print " Hallo World!!"
    import winsound
    winsound.PlaySound(path+"Trumpet1.wav",1)

def matrin(n,K,x):
    """Define and read in a matrix from Python-shell"""
    #n number of rows"
    #K number of columns"
    #brg 1.3.07, 20.3.07
    
    for i in range(0,n):
        x.append(0)
        x[i]=[]
    for i in range(0,n):
        print "row ",i
        for k in range(0,K):
            print "column ",k," ",
            r=float(raw_input(' matrix entry '))
            x[i].append(r)
    return x       

def matrin1(n,k,x):
    """Define and read in a matrix from Python-shell
    n number of rows"
    K number of columns"""
    #brg 1.3.07, 20.3.07, 18.12.07
    #*1.3.07
    #akt18.12.07
    #source:matrin
    #note: append
    
    for i in range(0,n):
        x.append(0)
        x[i]=[]
    for i in range(0,n):
        print "row ",i
        for j in range(0,k):
            r=float(raw_input(' col '+str(k)+': matrix entry '))
            x[i].append(r)
    return x       


def simplematout(r,k,a):
    "Output of a matrix in Python-shell"
    # brg just the matrix without any special cosmetic"
    for i in range(0,r):
        for j in range(0,k):
            print a[i][j],"\t",
        print " "
    print " "

def matout(rows,columns,x):
    """Output of matrix x in P-shell """
    #brg 1.3.07, 2.3.07, 23.4.07, 13.5.07
    #*1.3.07
    #akt13.5.07
    #note:-
    #source:-
    # n rows
    # K columns
    print " "
    print "rows    = ",rows
    print "columns = ",columns
    for i in range(0,rows):
        for j in range(0,columns):
            print round(float(x[i][j]),3)," ",
        
        print " "
    print 20*"="
    return

def matout2(n,a,b,x):
    """Output of square matrix x in P-shell """
    #brg 1.3.07, 2.3.07, 23.4.07, 13.5.07, 2.7.07
    #*1.3.07
    #akt2.7.07
    #note:-
    #source:-
    #  n no of rows (= number of columns)
    #   a: a vector with names
    print 40*"="
    #print "rows    = ",rows
    #print "columns = ",columns
    print "    ",
    for i in range(0,n):
        print a[i],"   ",
    print " "    
    for i in range(0,n):
        print b[i]," :",
        for j in range(0,n):
            print round(float(x[i][j]),2)," ",
        
        print " "
    print 40*"="
    return

def matout3(r,k,x):
    """Output of matrix x in P-shell """
    #brg 1.3.07, 2.3.07, 23.4.07, 13.5.07, 11.9.07,19.12.07
    #*1.3.07
    #akt19.12.07
    #note:-
    #source:-
    # r rows
    # k columns
    print " "
    print "rows    = ",r
    print "columns = ",k
    for i in range(0,r):
        for j in range(0,k):
            print round(float(x[i][j]),3),"\t",
        
        print " "
    print 20*"="
    return


def strmatout(n,k,x):
    """Output of string-matrix x in P-shell """
    #brg 1.3.07, 2.3.07,9.3.07, 18.9.08, 28.12.08
    #*1.3.07
    #akt28.12.08
    #note: -
    #source:-
    # n rows
    # K columns
    print " "
    for i in range(0,n):
        for j in range(0,k):
            print x[i][j]," ",               
        
        print " "
    print 20*"="
    return

def freematout(a):
    """ fields may have components which are
        themselves fields of different lengths
        this procedure put them into a readable
        txt-format"""
    #* Brg: 3.3.09
    # akt Brg: 3.3.09
    # test by readoffieldswithdifflengths1.py
    # a is such a field (e.g. [[1,2,3],[],[2,3],[3,4,5,6]])
    txt=""
    zaehl=0
    for i in a:
        txt+=str(zaehl)+" :"
        for j in i:
            txt+=str(j)+" ,"
        txt+="\n"
        zaehl+=1
    return txt    

def comp(r,k,x):
    """dm x will be compared and the zeta-matrix objx generated"""
    #brg 9.3.07, 22.3.07
    #*9.3.07
    #akt22.3.07
    #note:in all partial order programs
    #source:-
    #r: rows
    #k: columns
    #x data matrix
    #objx: resulting zeta matrix
    # 9.3.07 ,22.3.07 brg
    #print "r in comp = ",r
    #print "k in comp = ",k
    c=marray(r,r)
    flag=0    
    for i in range(0,r):
        for j in range(0,r):
            flag=0
            for kk in range(0,k):
                #print " kk =",kk," i=",i," j = ",j
                if x[i][kk]>=x[j][kk]:
                    flag+=1
            if flag==k:
                 c[i][j]=1
            else:
                 c[i][j]=0
            #print " "     
    return c

def comp2(r,att1,att2,dm):
    """dm x will be compared and the zeta-matrix objx generated"""
    #brg 9.3.07, 22.3.07, 13.1.08, 21.1.08
    #*9.3.07
    #akt 21.1.08
    #note:in program stability2
    #source: derived from comp
    #r: rows
    #att1,att2: identifier for attributes
    #x data matrix
    #objx: resulting zeta matrix
    # 9.3.07 ,22.3.07 brg
    #print "r in comp2 = ",r
    #print "att1 = ",att1,"   att2 = ",att2
    c=marray(r,r)
       
    for i in range(0,r):
        for j in range(0,r):
            if dm[i][att1]>=dm[j][att1] and dm[i][att2]>=dm[j][att2]:
                #print  i,"  >= ",j
                c[i][j]=1
            else:
                c[i][j]=0
            #print " "
    #matout(r,r,c)            
    return c,att1,att2

def comp3(r,k,case,ksel,x):
    """dm x will be compared and the zeta-matrix objx \
    corresponding to the case-matrix generated"""
    #brg 9.3.07, 22.3.07, 13.1.08, 14.1.08, 16.1.08
    #*9.3.07
    #akt 16.1.08
    #note:in program sensitivity
    #source: derived from comp
    #r: rows
    #case: case-matrix: each row: numbers >-1: attributes to be con-
    #      sidered.
    #ksel: which specific case
    #x data matrix
    #objx: resulting zeta matrix
    # 9.3.07 ,22.3.07 brg
    #print "r in comp = ",r
    #print "k in comp = ",k
    c=marray(r,r)
    flag=0
    for i in range(0,r):
        for j in range(0,r):
            flag=0
            for kk in case[ksel]:
                if kk!=-1:
                    if x[i][kk]>=x[j][kk]:
                        flag+=1
                    else:
                        pass
                if flag==k-1:  #only k-1 attributes in the case[1], case[2],...
                    c[i][j]=1
                else:
                    c[i][j]=0
            #print " "     
    return c

def comp4(r,k,case,ksel,x):
    """dm x will be compared and the zeta-matrix objx \
    corresponding to the case-matrix generated"""
    #brg 9.3.07, 22.3.07, 13.1.08, 14.1.08, 16.1.08
    #*9.3.07
    #akt 16.1.08
    #note:in program sensitivity, second part
    #source: derived from comp3
    #r: rows
    #case: case-matrix: each row: numbers >-1: attributes to be con-
    #      sidered.
    #ksel: which specific case
    #x data matrix
    #objx: resulting zeta matrix
    # 9.3.07 ,22.3.07 brg
    #print "r in comp = ",r
    #print "k in comp = ",k
    kl=k-ksel
    c=marray(r,r)
    flag=0
    
    for i in range(0,r):
        for j in range(0,r):
            flag=0
            for kk in case[ksel]:
                if kk!=-1:
                    if x[i][kk-1]>=x[j][kk-1]:
                        flag+=1
                    else:
                        pass
                if flag==kl:  #only k-1 attributes in the case[1], case[2],...
                    c[i][j]=1
                else:
                    c[i][j]=0
            #print " "     
    return c


def posetdistanz(r,c,cs):
    """ c and cs are zeta matrices then the result is a distance between them"""
    #brg 14.1.08
    #*: 14.1.08
    #akt: 14.1.08
    #note:-
    #source:-
    distanz=0
    for i in range(0,r):
        for j in range(0,r):
            distanz+=abs(c[i][j]-cs[i][j])
    return distanz        


def qualcomp(r,objx,quobx):
    """from zeta matrix 'objx' (see comp ) a matrix
        'quobx' is obtained whose entries ar lt,gt,eq,ic"""
    #brg 9.3.07
    #*9.3.07
    #akt9.3.07
    #note: objx is a zeta matrix,    
    #......quobx is output and specifies the relation between two objects
    #......as lt, gt,eq or ic.
    #source:-
    # 
    for i in range(0,r):
        for j in range(0,r):
            if objx[i][j]==1 and objx[j][i]==1:
                quobx[i][j]="eg"
            if objx[i][j]==1 and  objx[j][i]==0:
                quobx[i][j]="gt"
            if objx[i][j]==0 and objx[j][i]==1:
                quobx[i][j]="lt"
            if objx[i][j]==0 and objx[j][i]==0:
                quobx[i][j]="ic"
    return quobx


def qualcomp1(r,objx):
    """from zeta matrix 'objx' (see comp ) a matrix
        'quobx' is obtained whose entries ar lt,gt,eq,ic"""
    #brg 9.3.07, 18.3.09
    #*9.3.07
    #akt 18.3.09
    #note: objx is a zeta matrix,    
    #......quobx is output and specifies the relation between two objects
    #......as lt, gt,eq or ic.
    #source:-
    #
    quobx=marray(r,r)
    for i in range(0,r):
        for j in range(0,r):
            if objx[i][j]==1 and objx[j][i]==1:
                quobx[i][j]="eg"
            if objx[i][j]==1 and  objx[j][i]==0:
                quobx[i][j]="gt"
            if objx[i][j]==0 and objx[j][i]==1:
                quobx[i][j]="lt"
            if objx[i][j]==0 and objx[j][i]==0:
                quobx[i][j]="ic"
    return quobx



def matout1(n,k,name,x):
    """Output of matrix x and of a namelist in P-shell """
    #brg 1.3.07, 2.3.07, 3.3.07, 20.4.07
    #*1.3.07
    #akt 20.4.07
    #note:-
    #source:-
    # n rows
    # k columns
    # name: object identifiers (rows)
    # x: data matrix
    print " "
    for i in range(0,n):
        print name[i]," ",
        for k in range(0,K):
            print round(x[i][k],3)," ",
        
        print " "
    print 20*"="
    return
    
def vecout(m,v):
    """Output to P-shell: vectorial quantity"""
    #brg 1.3.07, 2.3.07, 15.11.07
    #*1.3.07
    #akt:15.11.07
    #note:-
    #source:-
    #m : components
    #v: vector with m components
    print " "
    for i in range(0,m):
        print round(v[i],3), " ",
    print " "
    print 20*"="


def vecout1(m,x,dig):
    """Output to P-shell: vectorial quantity"""
    #brg 1.3.07, 2.3.07, 13.11.07, 15.11.07, 30.12.07
    #*1.3.07
    #akt30.12.07
    #note: x may be a string or a numerical quantity
    #source: vecout
    #m : components
    #x: vector
    #dig: figures after the decimal point
    print " "
    for i in range(0,m):
        if type(x[i]) == str or type(x[i])== int:
            print x[i],"\t",
        elif type(x[i])==float:
            print round(x[i],dig),"\t",
    print " "
    print 8*m*"="

def matrixnorm(n,K,x):
    """normalization matrix x to [0,1]"""
    #Brg 3.3.07,27.2.08, 22.3.08,7.5.08, 1.7.08, 13.10.17
    #*3.3.07
    #akt: 1.7.08
    #note:-
    #source:-
    # normalization
    # n: number of objects
    # K: number of attributes
    # x: data matrix
    # y: normalized data matrix
    # absolute matrix entries > 0 and < 10 power 20
    y=marray(n,K) 
    for k in range(0,K):
        mini=10**20
        maxi=-10**20
        for i in range(0,n):
            if x[i][k]<mini:
                mini=x[i][k]
            if x[i][k]>maxi:
                maxi=x[i][k]
        #print "in column ",k," the min = ",min,"... the max = ",max
        for i in range(0,n):
            if maxi-mini!=0:
                y[i][k]=float((x[i][k]-mini)/(1.0*(maxi-mini)))
            else:
                y[i][k]=0.5     #27.2.08 arbitrarily fixed
                #print "Achtung"
    #matout(n,K,x)    #7.5.08
    return y

def vectornorm(n,x):
    """normalization of just a vector """
    #Brg 1.7.08,2.7.08
    #*1.7.08
    #akt: 2.7.08
    #note:-
    #source: derived from matrixnorm-
    # normalization
    # n: number of components
    
    # x: input vector
    # y: normalized output vector
    # absolute entries > 0 and < 10 power 20
    y=vecgen1(n) 
    
    mini=10**20
    maxi=-10**20
    for i in range(0,n):
        if x[i]<mini:
            mini=x[i]
        if x[i]>maxi:
            maxi=x[i]
    #print "in column ",k," the min = ",min,"... the max = ",max
    for i in range(0,n):
        if maxi-mini!=0:
            y[i]=float((x[i]-mini)/(1.0*(maxi-mini)))
        else:
            y[i]=0.5     #27.2.08 arbitrarily fixed
    return y,maxi,mini

def vectornorm2(n,x):
    """normalization of just a vector x
    taking into regard that x can also have
    negative values """
    #Brg 1.7.08,2.7.08, 27.11.08
    #*1.7.08
    #akt: 2.7.08
    #note:-
    #source: derived from vectornorm
    # normalization 
    # n: number of components
    
    # x: input vector
    # y: normalized output vector
    
    y=vecgen1(n) 
    
    mini=10**20
    maxi=-10**20
    for i in range(0,n):
        if x[i]<mini:
            mini=x[i]
        if x[i]>maxi:
            maxi=x[i]
    
    for i in range(0,n):
        if maxi-mini!=0:
            y[i]=float((x[i]-mini)/(1.0*(maxi-mini)))
        else:
            y[i]=0.5     #27.2.08 arbitrarily fixed
    null=1.0*abs(mini)/(1.0*(abs(mini)+abs(maxi)))
    return y,maxi,mini,null


def matrixchar(r,k,x):
    """characteristics of matrix"""
    #brg 20.3.07, 9.12.07, 19.1.2015
    #*20.3.07
    #akt19.1.2015
    #note:very large numbers or very low numbers may difficutl
    #source:-
    # max min of each column , mean and std-dev
    # matrix entries > 0 and < 10 power 20
    
    a=marray(5,k)
    # column i of matrix a is associated with column i of x
    # first row: max, sec. row min, third row mean, fourth row std.dev
    # fifth row still undefined
    for i in range(0,k):  #any column
        raimin=10**20
        raimax=-10**20
        a[2][i]=0
        for j in range(0,r):  #row iterating
            a[2][i]+=x[j][i]
            #print "col = ",i," row = ",j," sum = ",a[2][i]
            if x[j][i]<raimin:
                raimin=x[j][i]
            if x[j][i]>raimax:
                raimax=x[j][i]
        a[0][i]=raimax
        a[1][i]=raimin
        a[2][i]=float(1.0*a[2][i]/r)
    for i in range(0,k):
        summ=0
        for j in range(0,r):
            summ+=(x[j][i]-a[2][i])*(x[j][i]-a[2][i])
        a[3][i]=(1.0/(r-1)**0.5)*(summ**0.5)

    for i in range(0,4):
        for j in range(0,k):
            a[i][j]=round(a[i][j],2)
    return a

def find_all_paths(graph,start,end,path=[]):
    """ Pythonkurs 16-17.6.07
    finds all paths between start and end
    of a directed graph """
    #brg 13.6.10
    #*3.7.07
    #akt13.6.10
    #note: Pythonkurs
    #source:Pythonkurs
    # Version wo das aufgerufen wird: digraph1.py
    # graph has to be obtained from the procedure graphinput"
    # start   and  end can be dynamically read in
    # path: default
    # result: a list, eventually an encapsulated list like [[1,2,3],[1,4,3]]
    # brg 13.6.10
    path=path+[start]
    if start==end:
        return [path]
    if not graph.has_key(start):
        return []
    paths=[]
    for node in graph[start]:
        if node not in path:
            newpaths=find_all_paths(graph,node,end,path)
            for newpath in newpaths:
                paths.append(newpath)
    return paths


def find_path(graph,start,end,path=[]):
    """ Find a path from start to end
    within a directed graph"""
    #brg 3.7.07
    #*3.7.07
    #akt3.7.07
    #note: Pythonkurs
    #source:Pythonkurs
    # Version wo das aufgerufen wird: digraph1.py
    # graph has to be obtained from the procedure graphinput"
    # start   and  end can be dynamically read in
    # path: default
    # brg 3.7.07
    path=path+[start]
    if start==end:
        return path
    if not graph.has_key(start):
        return None
    for node in graph[start]:
        if node not in path:
            newpath=find_path(graph,node,end,path)
            if newpath: return newpath
    return None


def find_shortest_path(graph, start, end, path=[]):
    """ find shortest path in a directed graph """
    #brg 3.7.07
    #*3.7.07
    #akt3.7.07
    #note: Pythonkurs
    #source:Pythonkurs
    # Pythonkurs 16-17.6.07"
    # Version wo das aufgerufen wird: digraph1.py
    # graph has to be obtained from the procedure graphinput"
    # start   and  end can be dynamically read in
    # path: default
    # brg 3.7.07
    path=path+[start]
    if start==end:
        return path
    if not graph.has_key(start):
        return None
    shortest = None
    for node in graph[start]:
        if node not in path:
            newpath=find_shortest_path(graph,node,end,path)
            if newpath:
                if not shortest or len(newpath)<len(shortest):
                    shortest=newpath
    return shortest

def dist_graph(cov,n,start,ziel):
    """from the cover matrix cov i,j =1 if row i covered by column j
    which represents a directed graph the cover matrix of the undirected graph
    will be calculated, and the distance of incomparable objects determined """
    # cov Input-cover matrix of directed Hasse graph
    # n number of vertices
    # start: vertex from wehre to be started
    # ziel: vertex to which the path is to be found
    # *  17.9.09
    # act: 17.9.09
    # note: infinite distance = 999
    graph=graphcovdict(cov,n)
    test1=find_shortest_path(graph,start,ziel)
    test2=find_shortest_path(graph,ziel,start)
    if test1==None and test2==None:
        covun=marray(n,n)
        for i in range(0,n):
            for j in range(0,n):
                if cov[i][j]==1:
                    covun[i][j]=1
                if cov[i][j]==0 and cov[j][i]==1:
                    covun[i][j]=1

        #rmod2.matout(6,6,covun)            
        graphun=graphcovdict(covun,n)    
        path=[]
        shortpath=find_shortest_path(graphun,start,ziel,path)

        #print shortpath
        if shortpath==None:
            lshortpath=999
        else:    
            lshortpath=len(shortpath)-1
    else:
        lshortpath=-999
        #print "distance nondirected",lshortpath
    return lshortpath




def graphinput(n):
    """
    a dictionary will be generated by an interactive modus
    where the upward cover relation is stored in a dictionary
    """
    #brg 17.6.07, 21.6.07, als Module: 4.7.06
    #*17.6.07
    #akt 1.3.09
    #note: reads in cover relation from Python shell
    #source: brg
    #result is graph_own
    cov=['']
    nodename=[]
    print "first part"
    for i in range(0,n):
        n1=raw_input(' name of node ')
        nodename.append(n1)
        
    
    print "second part "
    gr={}
    
    for i in range(0,n):
        li=[]
        name2='rainer'
        z=0
        while name2!='':
              print "from ",nodename[i],"  to  "
              name2=raw_input(' node (Rtn for stop) ')  
              if name2!='':
                  li.append(name2)
              gr[nodename[i]]=li
              z+=1
              if z>n:
                  print "Ueberlauf"
                  break
    return nodename,gr

def graphcovdict(cov,n):
    """from a cover matrix (row < column-label then 1 else 0)
        a dictionary is generated"""
    #* 1.3.09
    # akt 1.3.09
    # note: still in a testing version
    # brg 1.3.09
    # cov is the cover-matrix of aposet
    # n: the number of rows = columns
    # result: a dictionary
    gr={}

    for i in range(0,n):
        li=[]
        name2='rainer'
        for j in range(0,n):
            if cov[i][j]==1:
                  li.append(j)
        gr[i]=li
    return gr     

def covadjlist(cov,n):
    """a cover matrix is transformed into
        an adjacency matrix (without weights)"""
    #cov : matrix row-label < column label then 1 else 0
    # n dimension
    # result: an adjacency list [[....],[...],[..]...]
    # vertex 0 and its neighbored elements, vertex 1 and its neighbored elements, etc
    # * brg 1.3.09
    # akt : brg 1.3.09
    # note: testing
    #
    adjlist=[]
    for i in range(0,n):
        adjlist.append(0)
        adjlist[i]=[]

    for i in range(0,n):
        for j in range(0,n):
            if cov[i][j]==1:
                adjlist[i].append(j)
    return adjlist            

def prim(graph,i):
    """ from ALDA / Internet, uni-heidelberg. Calculates a
        minimal spanning tree according to edge weights """
    # * Brg 1.3.09
    # akt 1.3.09,3.3.09
    # graph must be given as follows [[(i, weight edge 0,i),(j, weight 0,j)],..
    # for example a valid list of weighted graph is:
    # adjliste=[[(1,0.2),(2,0.3),(4,0.1)],[(3,0.1)],[(3,0.6)],[],[]]
    # the directed graph is: 0-1, 1-2, 0-4, 1-3, 1-4
    # depending on the weights a MST is found in that way that the
    # sum of the weights in MST is minimized. Note however that prim is a greedy
    # ...algorithm , hence it renders not necessarily the optimal MST
    # i: starting element
    # some places: 0 replaced by i  3.3.09 there is however still a bug
    heap=[]
    visited=[False]*len(graph)
    summ=0
    r=[]
    visited[i]=True
    for neighbor in graph[i]:
        heapq.heappush(heap,(neighbor[1],0,neighbor[0]))
    while len(heap):
        wn,start,ziel=heapq.heappop(heap)
        if visited[ziel]:continue
        visited[ziel]=True
        summ+=wn
        r.append([start,ziel])
        for neighbor in graph[ziel]:
            if visited[neighbor[0]]:continue
            heapq.heappush(heap,(neighbor[1],ziel,neighbor[0])) 

    return summ,r        


def prim0(graph):
    """ from ALDA / Internet, uni-heidelberg. Calculates a
        minimal spanning tree according to edge weights """
    # * Brg 1.3.09
    # akt 1.3.09,3.3.09
    # graph must be given as follows [[(i, weight edge 0,i),(j, weight 0,j)],..
    # for example a valid list of weighted graph is:
    # adjliste=[[(1,0.2),(2,0.3),(4,0.1)],[(3,0.1)],[(3,0.6)],[],[]]
    # the directed graph is: 0-1, 1-2, 0-4, 1-3, 1-4
    # depending on the weights a MST is found in that way that the
    # sum of the weights in MST is minimized. Note however that prim is a greedy
    # ...algorithm , hence it renders not necessarily the optimal MST
    # i: starting element
    heap=[]
    visited=[False]*len(graph)
    summ=0
    r=[]
    visited[0]=True
    for neighbor in graph[0]:
        heapq.heappush(heap,(neighbor[1],0,neighbor[0]))
    while len(heap):
        wn,start,ziel=heapq.heappop(heap)
        if visited[ziel]:continue
        visited[ziel]=True
        summ+=wn
        r.append([start,ziel])
        for neighbor in graph[ziel]:
            if visited[neighbor[0]]:continue
            heapq.heappush(heap,(neighbor[1],ziel,neighbor[0]))

    return summ,r        


def covadjlistweighted(cov,n,weight):
    """a weighted adajency list will generated from
        the cover matrix (row-label<column-label then 1 else 0
        the structure: [[(i,weight0-i),(j, weight0-j),...][(k,weight 1-k),..]]"""
    # * 1.3.09
    # akt 1.3.09
    # test version
    # cov the cover matrix
    # n dimension of the cover matrix
    # weights: matrix with dimension n
    # result adjlistw  (w to indicate that the structure is
    # ... slightly different from adjlist.
    # the result can be used in the rooutine prim
    adjlistw=[]
    for i in range(0,n):
        adjlistw.append(0)
        adjlistw[i]=[]

    for i in range(0,n):
        for j in range(0,n):
            if cov[i][j]==1:
                adjlistw[i].append((j,weight[i][j]))
    return adjlistw

def connectedComponents(graph):
    """from alda uni Heidelberg ,
        defines representants (anchors)
        of any component """
    # dfs recursive scheme
    # strong components. When connections of posets are
    # ... to be analyzed one has to do more operations.
    # see graph_CC5.py (i.e. one has to analyze the undirected graph
    # i.e. one has to transpose covermatrix and add covver with transposed  cover.
    # graph as adj list
    # * 1.3.09
    # akt: Brg 1.3.09
    # note: testing
    def visit(graph,node,anchors,anchor):
        if anchors[node] is not None: return
        anchors[node]=anchor
        for neighbor in graph[node]:
            visit(graph,neighbor,anchors,anchor)
    anchors=[None]*len(graph)
    for node in range(len(graph)):
        visit(graph,node,anchors,node)
    return anchors    


def countCC(ac):
    """ uses as input the output of connectedComponents
        result: number of components """
    # ac list of values as outcome of connectedComponents
    # for instance ac=[1,1,0,1,2,0,3,2,0] meaning a graph o fnine vertices
    #... has 4 different representatives. Each one indicates a connected
    # ...component
    # the result would be acred=[1,0,2,3] and has length 4
    # * 1.3.09
    # akt : brg 1.3.09
    # note: testing
    n=len(ac)
    x=ac[0]
    acred=[]
    acred.append(x)
    for i in range(1,n):
        if ac[i]!=x and ac[i] not in acred:
            acred.append(ac[i])
    noCC=len(acred)        
    return acred,noCC

def countCC1(ac):
    """ as countC, however additionally the number of elements in any component
        will be rendered and a label-set for use in graphics"""
    # ac list of values as outcome of connectedComponents
    # for instance ac=[1,1,0,1,2,0,3,2,0] meaning a graph o fnine vertices
    #... has 4 different representatives. Each one indicates a connected
    # ...component
    # the result would be acred=[1,0,2,3] and has length 4
    # * 2.3.09
    # akt : brg 2.3.09
    # note: testing
    # source: countCC
    # testing file: graph_CC8.py and graph_CC9.py
    n=len(ac)
    x=ac[0]
    acred=[]
    acred.append(x)
    for i in range(1,n):
        if ac[i]!=x and ac[i] not in acred:
            acred.append(ac[i])
    noCC=len(acred)
    contentC=vecgen1(noCC)
    zaehl=0
    for i in acred:
        for j in ac:
            if i==j:
                contentC[zaehl]+=1  #if a=[0,3] and ac=[0,0,0,3,3] then ...
                                    # ... contentC=[3,2]
        zaehl+=1       

    lb=vecgentext1(noCC)        #lb would be "0" and "3"
    for i in range(0,noCC):
        lb[i]=str(acred[i])

    return acred,noCC,contentC,lb


def marray(n,m):
    """definition of a matrix scheme """
    # Brg 6.3.07
    #*6.3.07
    #akt6.3.07
    #note:-
    #source:-
    # n: rows
    # m: columns 
    # 
    x=[]
    for i in range(0,n):
        x.append(0)
        x[i]=[]
    for i in range(0,n):
        for j in range(0,m):
            x[i].append(0)
    return x        

def marray3(n,m,k):
    """definition of a 3D-field """
    #brg 28.3.08
    #* 28.3.08
    # akt 28.3.08
    # note: developed on basis of marray
    #n:, m: field
    # k: third direction
    x=[]
    for i in range(0,n):
        x.append(0)
        x[i]=[]
    for i in range(0,n):
        for j in range(0,m):
            x[i].append(0)
            x[i][j]=[]
    for i1 in range (0,n):
        for i2 in range(0,m):
            for i3 in range(0,k):
                x[i1][i2].append(0)
    return x        

def marray4(n,m,k,l):
    """definition of a 4D-field """
    #brg 28.3.08, 14.10.08
    #* 28.3.08
    # akt 14.10.08
    # note: developed on basis of marray
    # n:, m: field
    # k: third direction
    # l: fourth dimension 
    x=[]
    for i in range(0,n):
        x.append(0)
        x[i]=[]
    for i in range(0,n):
        for j in range(0,m):
            x[i].append(0)
            x[i][j]=[]
    for i1 in range (0,n):
        for i2 in range(0,m):
            for i3 in range(0,k):
                x[i1][i2].append(0)
                x[i1][i2][i3]=[]
    for i4 in range (0,n):
        for i5 in range(0,m):
            for i6 in range(0,k):
                for i7 in range(0,l):
                    x[i4][i5][i6].append(0)            
    return x        

def strmarray(n,m):
    """definition of a matrix scheme for string"""
    #brg 6.3.07, 17.11.07
    #*brg 6.3.07
    #akt 17.11.07
    #note:-
    #source:-
    # n: rows
    # m: columns 
    
    x=[" "]
    for i in range(0,n):
        x.append("")
        x[i]=[" "]
    for i in range(0,n):
        for j in range(0,m):
            x[i].append(" ")
    return x

def strmarray1(n,m,v):
    """definition of a matrix scheme for string and a default string v"""
    #brg 6.3.07, 17.11.07, 28.12.08
    #*brg 6.3.07
    #akt 28.12.08
    #note:-
    #source:strmarray
    # n: rows
    # m: columns
    # v: string value
    
    x=[""]
    for i in range(0,n):
        x.append("")
        x[i]=[""]
    for i in range(0,n):
        for j in range(0,m):
            x[i].append(v)
    return x


def marray1(n,m,vorb):
    """definition of a matrix scheme with default values"""
    # brg 6.3.07, 26.4.07
    #*6.3.07
    #akt26.4.07
    #note:-
    #source:-
    # n: rows
    # m: columns
    # vorb: value with which the matrix is filled up
    # in marray vorb=0
    
    x=[]
    for i in range(0,n):
        x.append(vorb)
        x[i]=[]
    for i in range(0,n):
        for j in range(0,m):
            x[i].append(vorb)
    return x        

def vecmat(l,rows,k,s,x):
    """vector of length l is rearranged into
    a matrix with r rows and k columns"""
    #Brg 8.3.07
    #*8.3.07
    #akt8.3.07
    #note:-
    #source:-
    # l: lenght = k*r
    # k: number of columns
    # rows : number of rows
    # s: vector with data with length l (input)
    # x: matrix entries with 0 . matrix generated y  marray
    # brg 8.3.07
    rows=0
    j=0
    for t in s:
        x[rows][j]=t
        j=j+1
        if int(j/k)==float(1.0*j/(1.0*k)):
            rows=rows+1
            j=0
    return x

def matunit(r):
    """generates a unit-matrix r*r"""
    #brg 13.2.07
    #*13.2.07
    #akt13.2.07
    #note:-
    #source:-
    #in the diagonal only 1 else 0
    # a r * r square matrix
    # brg 13.2.07
    a=marray(r,r)
    for i in range(0,r):
        for j in range(0,r):
            if i==j:
                a[i][j]=1
            else:
                a[i][j]=0
    return a


def matcopy(r,k,a,b):
    """copy of a  to b"""
    #brg10.3.07
    #*10.3.07
    #akt10.3.07
    #note:-
    #source:-
    #r rows
    #k columns
    #a known matrix
    #b matrix is a copy of a
    #  brg 10.3.07
    for i in range(0,r):
        for j in range(0,k):
            b[i][j]=a[i][j]
    return b

def matcopy1(r,k,a):
    """copy of a  to b"""
    #brg 10.3.07,14.3.07,15.3.07
    #*10.3.07
    #akt15.3.07
    #note:-
    #source:matcopy
    #r rows
    #k columns
    #a known matrix
    #b matrix is a copy of a
    #  brg 10.3.07, 14.11.07
    b=marray(r,k)   #15.11.07
    for i in range(0,r):
        for j in range(0,k):
            b[i][j]=a[i][j]
    #print "in matcopy1: b"
    #matout(r,k,b)
    return b       

def mattransp(r,k,a):
    """transpose of matrix a: result: matrix b"""
    #brg 10.3.07,14.3.07,15.3.07, 13.10.08
    #*10.3.07
    #akt13.10.08
    #note:-
    #source:matcopy1
    #r rows
    #k columns
    #a known matrix
    #b matrix is the transponed matrix a
    #  brg 10.3.07, 14.11.07
    b=marray(k,r)   #15.11.07
    for i in range(0,r):
        for j in range(0,k):
            b[j][i]=a[i][j]
    return b       

def mattransp2(r,k,x):
    #Brg 24.1.2015
    """ in contrast to mattransp
    the new field is organized in
    dynamical manner  and it accepts also vectors
    which are to be transposed """
    flag = 0
    try:
        test = x[0][0]
    except:
        flag = 1
    if flag == 1:
        y = []
        for i in range(0, r):
            y.append(0)
            y[i]=[]
            for j in range(0,k):
                y[i].append(x[i])
        print "y = ",y
        x = []
        for i in range(0,r):
            x.append(0)
            x[i] = []
            for j in range(0,k):
                x[i].append(y[i][j])
        print "x formally as 2 dim field ",x
    #     
    xtr = []
    for j in range(0, k):
        xtr.append(0)
        xtr[j] = []
        for i in range(0, r):
            xtr[j].append(x[i][j])
    rtr = k
    ktr = r
    
    return rtr, ktr, xtr 

def matadd(r,sk1,a,sk2,b,c):
    """c=sk1*a  +  sk2*b  """
    #brg 10.3.07
    #*10.3.07
    #akt10.3.07
    #note:-
    #source:-
    # sk1, sk2: scalars
    # a,b square matrices, r rows, r columns
    # c  result
    # brg 10.3.07
    for i in range(0,r):
        for j in range(0,r):
            c[i][j]=1.0*sk1*a[i][j]+1.0*sk2*b[i][j]
    return c

def matadd1(r,sk1,a,sk2,b):
    """c=sk1*a  +  sk2*b  """
    #brg 10.3.07,2.12.07
    #*10.3.07
    #akt2.12.07
    #note:-
    #source:-
    # sk1, sk2: scalars
    # a,b square matrices, r rows, r columns
    # c  result
    # brg 10.3.07, 2.12.07
    c=marray(r,r)
    for i in range(0,r):
        for j in range(0,r):
            c[i][j]=1.0*sk1*a[i][j]+1.0*sk2*b[i][j]
    return c

def matmult(r,a,b,c):
    """matrixmultiplikation  c = a*b"""
    # brg 10.3.07
    #*10.3.07
    #akt10.3.07
    #note:take care for suitale matrices (square, dimension)
    #source:-
    # square matrices with column=rows = r
    # a and b factors
    # c is the product
    for i in range(0,r):
        for j in range(0,r):
            msum=0.0
            for k in range(0,r):
                msum+=1.0*a[i][k]*b[k][j]
            c[i][j]=msum
    return c

def matmult1(r1,k1,a,r2,k2,b):
    """matrixmultiplikation  c = a*b"""
    # brg 10.3.07, 14.9.08
    #*10.3.07
    #akt14.9.08
    #note:any suitable matrix
    #source: matmult
    # 
    # a and b factors
    # c is the product of matrix-dimension r1*k2
    c=marray(r1,k2)
    #print "r1= ",r1,"  k1= ",k1
    #matout(r1,k1,a)
    #print "r2= ",r2,"  k2= ",k2
    #matout(r2,k2,b)
    if k1!= r2:
        print "++++ error +++"
        print "+++ wrong matrix-dimensions +++ "
    else:    
        for i in range(0,r1):
            for j in range(0,k2):
                msum=0.0
                for j2 in range(0,r2):
                    msum+=1.0*a[i][j2]*b[j2][j]
                c[i][j]=1.0*msum
    return c

def matmultnew(r,a,b):
    """matrixmultiplikation  c = a*b"""
    # brg 30.9.10
    #*10.3.07
    #akt10.3.07
    #note:take care for suitale matrices (square, dimension)
    #source:-
    # square matrices with column=rows = r
    # a and b factors
    # c is the product
    c=marray(r,r)
    for i in range(0,r):
        for j in range(0,r):
            msum=0.0
            for k in range(0,r):
                msum+=1.0*a[i][k]*b[k][j]
            c[i][j]=msum
    return c





def matvecmult(r1,k1,a,b):
    """multiplication matrix a with vector b:  c = a*b"""
    # brg 10.3.07, 14.9.08, 23.7.09
    #*10.3.07
    #akt23.7.09
    #note:any suitable matrix
    #source: matmult
    # 
    # a and b factors
    # c is a vector with dimension r1
    c=vecgen1(r1)
           
    for i in range(0,r1):
        msum=0
        for j2 in range(0,k1):
            msum+=1.0*a[i][j2]*b[j2]
        c[i]=1.0*msum
    return c

def msort(newcase,dm,prop,k,r):
    """ msort sorts the columns of a matrix dm
    corresponding the list of newcase[0]. newcase is
    obtained from sensi..py."""
    # brg 6.8.10
    # * 6.8.10
    # newcase is a matrix, here only the first row is of interest
    # dm is the original data matrix with k columns and r rows.
    # If for example newcase[]0]=[2,1,4,3,0] then the new matrix
    # first column is the third of the original
    # second column the second of the original
    # third column the fifth of the original , etc.
    # Output:
    # dmnew is the new sorted matrix
    # flag = True if newcase has as many columns as dm.
    # flag=False if not.
    lnew=len(newcase[0])
    propnew=vecgen1(k)
    for i in range(0,lnew):
        iz=newcase[0][lnew-1-i]-1   #in sensi16 newcase[0] sensitivity in increasing importance
        #print "in msort: iz= ",iz
        propnew[i]=prop[iz]

    dmnew=marray(r,k)
    
##    print "in msort: r = ",r,"   k= ",k
##    print "in msort: newcase[0] : ",newcase[0]
##    print "lnew in msort =",lnew
    flag=True
    if lnew!=k:
        print "+++ error +++"
        print " +++ mismatch: number of attributes must be equal the length of newcase[0]+++"
        dmnew=matcopy(r,k,dm,dmnew)
        flag=False
    else:    
        
        for i in range(0,lnew):
            iz=newcase[0][lnew-1-i]-1   #in sensi16 newcase[0] sensitivity in increasing importance
            #print "in msort: iz= ",iz
            for i1 in range(0,r):
                dmnew[i1][i]=dm[i1][iz]
            
        #matout(r,k,dmnew)
    return dmnew,propnew, flag




def raireadin(fn):
    """read in from a file"""
    #brg 12.3.07,19.3.07
    #*12.3.07
    #akt 19.3.07
    #note:-
    #source:-
    #file: first line: no of rows, number of columns
    #      sec. line: data
    # cooperates with raiwrite()
    # output a tuple of lenght rows*columns
    # fn: filename
    # A transform into matrix bei vecmat may be necessary
    # brg 12.3.07, 19.3.07
    xy=[]
    fn=fn+".txt"
    f=open('/Python25/EigProgramme/'+fn,'r')
    s=f.readline()
    r=int(s.split(",")[0])
    k=int(s.split(",")[1])
    for i in range(0,r*k):  # preparation of the tuple xy
        xy.append(0)
        
    x=f.readline()
    f.close()
    for i in range(0,r*k):
        xy[i]=float(x.split(",")[i])
        #print xy[i]," ",
    return r,k,xy

def raireadin1(path, fn):
    """read in from a file, given the path-information"""
    #brg 12.3.07, 19.3.07, 20.4.07
    #*12.3.07
    #akt 19.3.07
    #note:-
    #source:-
    #file: first line: no of rows, number of columns
    #      sec. line: data
    # cooperates with raiwrite()
    # output a tuple of lenght rows*columns
    # fn: filename
    # A transform into matrix bei vecmat may be necessary
    # brg 12.3.07, 19.3.07, 20.4.07
    xy=[]
    print "You are here...",os.getcwd()
    print "filename = ",fn
    h=raw_input(' correction (RTN if not necessary) ')
    if h!="":
        fn=h
    print "corrected filename  ", fn
    f=open(path+fn,'r')
    s=f.readline()
    r=int(s.split(",")[0])
    k=int(s.split(",")[1])
    for i in range(0,r*k):  # preparation of the tuple xy
        xy.append(0)
        
    x=f.readline()
    f.close()
    for i in range(0,r*k):
        xy[i]=float(x.split(",")[i])
        #print xy[i]," ",
    return r,k,xy

def raireadin2(path, fn):
    """read in from a file, given the path-information"""
    # brg 12.3.07, 19.3.07, 20.4.07, 3.6.07
    #*12.3.07
    #akt3.6.07
    #note:-
    #source:-
    #file: first line: no of rows, number of columns
    #      sec. line: data
    # cooperates with raiwrite()
    # output a tuple of lenght rows*columns
    # fn: filename
    # A transform into matrix bei vecmat may be necessary
   
    xy=[]
    f=open(path+fn,'r')
    s=f.readline()
    r=int(s.split(",")[0])
    k=int(s.split(",")[1])
    for i in range(0,r*k):  # preparation of the tuple xy
        xy.append(0)
        
    x=f.readline()
    f.close()
    for i in range(0,r*k):
        xy[i]=float(x.split(",")[i])
        #print xy[i]," ",
    return r,k,xy


def raiwritecov(path,fn,r,cov,obj):
    """writes number of rows(=columns)
        then the list of names of rows (or columns)
        (most often object names) and finally the
        square matrix -- cov --
        Corresponds with raireadin3 and raireadin4  """
    # Brg 13.3.09
    # * 13.3.09
    # act 13.3.09
    # source: -
    # raiwritecov is thougth of as save of square matrices
    # especially cover-matrices
    # corresponds with raireadin3
    # Example Python program: covsave3.py
    f=open(path+fn,'w')
    f.write(str(r)+"\n")
    for i in range(0,r):
        if i<r-1:
            f.write(obj[i]+",")
        else:
            f.write(obj[i])
    f.write("\n")    
    for i in range(0,r):
        for j in range(0,r):
          zahl=cov[i][j]
          f.write(str(zahl)+",")
    f.close()
    return

def raiwritecovold(fn,r,cov,obj):
    """writes number of rows(=columns)
        then the list of names of rows (or columns)
        (most often object names) and finally the
        square matrix -- cov --
        Corresponds with raireadin3 and raireadin4
        Note: It is assumed that the path is included in
        the filename (for example because tkSimpleDialog-
        routines are used)"""
    # Brg 13.3.09, 14.3.09
    # * 13.3.09
    # act 13.3.09
    # source: -
    # raiwritecov is thougth of as save of square matrices
    # especially cover-matrices
    # corresponds with raireadin3
    # Example Python program: covsave3.py
    f=open(fn,'w')
    f.write(str(r)+"\n")
    for i in range(0,r):
        if i<r-1:
            f.write(obj[i]+",")
        else:
            f.write(obj[i])
    f.write("\n")    
    for i in range(0,r):
        for j in range(0,r):
          zahl=cov[i][j]
          f.write(str(zahl)+",")
    f.close()
    return


def raiwritecov1(fn,matrix,obj,r):
    """writes a data matrix -matrix- in a file, path info is to be used"""
    #  brg 12.3.07, 19.3.07, 20.4.07, 3.6.07, 24.12.08, 30.5.09, 21.6.09
    #*12.3.07
    #akt 31.5.09noch in testphase
    #note: cooperates with raireadin1. As raiwrite3 will cooperate with
    #      asksaveasfilename of tkFileDialog the print-commands are
    #      misleading.
    #      Special use in PyHasse
    #source: raiwrite5
    # fn filename
    # typ: a for append and w for new/overwrite
    # matrix: a matrix with r rows and k columns is expected
    # r rows
    # k  columns
    # obj : a list of objects 
    f=open(fn,"w")
    f.write(str(r)+"\n")  #30.5.09 \n am Anfang entfernt
    for i in range(0,r):
        f.write(obj[i]+",")
    f.write("\n")    
    for i in range(0,r):
        for j in range(0,r):
          zahl=matrix[i][j]
          f.write(str(zahl)+",")
    f.close()
    return


def raireadin3old(path,fn):
    """ reads in a file with:
        first line : a number r
        second line: a list of r names
        third line : a list of length r*r
        Output is the list of names -- nn--and a r*r matrix
        called -- ma --
        raireadin3 corresponds with raiwritecov """
    #Brg 13.3.09
    # act: 13.3.09
    # * 13.3.09
    # Example Python program graphviz4.py
    xy=[]
    f=open(path+fn,'r')
    s=f.readline()
    r=int(s.split(",")[0])

    for i in range(0,r*r):  # preparation of the tuple xy
        xy.append(0)
            
    nam=f.readline()
    nn=[]
    for i in range(0,r):
        nn.append(nam.split(",")[i])

    xl=len(nn[r-1])
    nn[r-1]=nn[r-1][:xl-1]
    x=f.readline()
    f.close()
    for i in range(0,r*r):
        xy[i]=float(x.split(",")[i])
        
    ma=raivecmat1(r,r,xy)
    for i in range(0,r):
        for j in range(0,r):
            ma[i][j]=int(ma[i][j])
    return r,nn,ma                       


def raireadin3(path,fn):
    """read in from a file, given the path-information"""
    # brg 12.3.07, 19.3.07, 20.4.07, 3.6.07, 30.5.09
    #*12.3.07
    #akt30.5.09
    #note:-
    #source:-
    #file: first line: no of rows, number of columns
    #      sec. line: data
    # cooperates with raiwrite()
    # output a tuple of lenght rows*columns
    # fn: filename
    # A transform into matrix through vecmat may be necessary
   
    xy=[]
    f=open(path+fn,'r')
    s=f.readline()
    r=int(s.split(",")[0])
    k=int(s.split(",")[1])
    for i in range(0,r*k):  # preparation of the tuple xy
        xy.append(0)
        
    x=f.readline()
    f.close()
    for i in range(0,r*k):
        xy[i]=float(x.split(",")[i])
        
    ma=marray(r,k)
    j=0
    ob=-1
    for i in range(0,r*k):
        if int(1.0*i/k)==float((1.0*i)/(1.0*k)):  #21.10.07
            j=0
            ob+=1

        ma[ob][j]=xy[i]
        j+=1
    return r,k,ma


def raireadin4(fn):
    """ reads in a file with:
        first line : a number r
        second line: a list of r names
        third line : a list of length r*r
        Output is the list of names -- nn--and a r*r matrix
        called -- ma --
        raireadin4 corresponds with raiwritecov
        and should only be used when tkFileDialog is used  """
    #Brg 13.3.09
    # act: 13.3.09
    # * 13.3.09
    # Example Python program graphviz4.py
    xy=[]
    f=open(fn,'r')
    s=f.readline()
    r=int(s.split(",")[0])

    for i in range(0,r*r):  # preparation of the tuple xy
        xy.append(0)
            
    nam=f.readline()
    nn=[]
    for i in range(0,r):
        nn.append(nam.split(",")[i])

    xl=len(nn[r-1])
    nn[r-1]=nn[r-1][:xl-1]
    x=f.readline()
    f.close()
    for i in range(0,r*r):
        xy[i]=float(x.split(",")[i])
        
    ma=raivecmat1(r,r,xy)
    for i in range(0,r):
        for j in range(0,r):
            ma[i][j]=int(ma[i][j])
    return fn,r,nn,ma                       



def raireadin2a(fn):
    """read in from a file, given the filename fn whereby the
        the path may be included """
    # brg 12.3.07, 19.3.07, 20.4.07, 3.6.07, 7.10.08
    #*12.3.07
    #akt 7.10.08
    #note:-
    #source: from raireadin2-
    #file: first line: no of rows, number of columns
    #      sec. line: data
    # cooperates with raiwrite()
    # output a tuple of lenght rows*columns
    # fn: filename
    # A subsequent transform into matrix by vecmat may be necessary
   
    xy=[]
    f=open(fn,'r')
    s=f.readline()
    r=int(s.split(",")[0])
    k=int(s.split(",")[1])
    for i in range(0,r*k):  # preparation of the tuple xy
        xy.append(0)
        
    x=f.readline()
    f.close()
    for i in range(0,r*k):
        xy[i]=float(x.split(",")[i])
        #print xy[i]," ",
    return r,k,xy

def raireadin2b(fn,flag):
    """read in from a file, given the filename fn whereby the
        the path may be included """
    # brg 12.3.07, 19.3.07, 20.4.07, 3.6.07, 7.10.08, 4.2.2012, 9.2.2012
    #*12.3.07
    #akt 7.10.08, 4.2.2012, 9.2.2012
    #note:-
    #source: from raireadin2-
    #file: first line: no of rows, number of columns
    #      sec. line: data
    # cooperates with raiwrite()
    # output a tuple of lenght rows*columns
    # fn: filename
    # flag: =1 then the loading will shown in the shell
    # A subsequent transform into matrix by vecmat may be necessary
    #  4.2.2012 In order to use readin2a-philosophy for mixed matrices the...
    #            float before x.split was omitted
   
    xy=[]
    f=open(fn,'r')
    s=f.readline()
    r=int(s.split(",")[0])
    k=int(s.split(",")[1])
    for i in range(0,r*k):  # preparation of the tuple xy
        xy.append(0)
        if flag==1 and i<10:
            print i,
    print " "    
    x=f.readline()
    f.close()
    for i in range(0,r*k):
        xy[i]=x.split(",")[i]
        #print xy[i]," ",
    return r,k,xy


def raireadin5(fn):
    """read in from a file, given the path-information"""
    # brg 12.3.07, 19.3.07, 20.4.07, 3.6.07, 30.5.09, 1.6.09
    #*12.3.07
    #akt1.6.09
    #note:-
    #source:raireadin3
    #file: first line: no of rows, number of columns
    #      sec. line: data
    # cooperates with raiwrite5() and with Tkinter tkFleDialog-class
    # output a tuple of lenght rows*columns
    # fn: filename
    # A transform into matrix is performed
    # Special use for data exchange within PyHasse
    #print "Hi! In raireadin5 "
    xy=[]
    f=open(fn,'r')
    s=f.readline()
    r=int(s.split(",")[0])
    k=int(s.split(",")[1])
    #print "r= ",r,"  k= ",k
    objects=[]
    xobjects=f.readline()    
    for i in range(0,r):
        objects.append(xobjects.split(",")[i])
    properties=[]
    xprop=f.readline()
    for j in range(0,k):
        properties.append(xprop.split(",")[j])
    for i in range(0,r*k):  # preparation of the tuple xy
        xy.append(0)
        
    x=f.readline()
    f.close()
    for i in range(0,r*k):
        xy[i]=float(x.split(",")[i])
        
    ma=marray(r,k)
    j=0
    ob=-1
    for i in range(0,r*k):
        if int(1.0*i/k)==float((1.0*i)/(1.0*k)):  #21.10.07
            j=0
            ob+=1

        ma[ob][j]=xy[i]
        j+=1
    return r,k,ma,objects,properties



def raivecreadin2(path, fn):
    """read in from a file, given the path-information"""
    # brg 12.3.07, 19.3.07, 20.4.07, 3.6.07, 5.6.07
    #*12.3.07
    #akt:5.6.07
    #note._
    #source:raivecreadin
    #file: first line: no of components
    #      sec. line: data
    # cooperates with raivecwrite()
    # output a tuple of lenght rows*columns
    # fn: filename
    # A transform into matrix bei vecmat may be necessary
    
    xy=[]
    f=open(path+fn,'r')
    s=f.readline()
    k=int(s.split(",")[0])
    for i in range(0,k):  # preparation of the tuple xy
        xy.append(0)
        
    x=f.readline()
    f.close()
    for i in range(0,k):
        xy[i]=float(x.split(",")[i])
        #print xy[i]," ",
    return k,xy

def raivecreadin2a(fn):
    """read in from a file, given the filename"""
    # brg 12.3.07, 19.3.07, 20.4.07, 3.6.07, 5.6.07, 7.10.08
    #*12.3.07
    #akt:7.10.08
    #note._
    #source:raivecreadin
    #file: first line: no of components
    #      sec. line: data
    # cooperates with raivecwrite()
    # output a tuple of lenght rows*columns
    # fn: filename
    # A transform into matrix bei vecmat may be necessary
    
    xy=[]
    f=open(fn,'r')
    s=f.readline()
    k=int(s.split(",")[0])
    for i in range(0,k):  # preparation of the tuple xy
        xy.append(0)
        
    x=f.readline()
    f.close()
    for i in range(0,k):
        xy[i]=float(x.split(",")[i])
        #print xy[i]," ",
    return k,xy


def raiwrite1(path, fn,r,k):
    """writes a data matrix in a file, path info is to be used"""
    #  brg 12.3.07, 19.3.07, 20.4.07
    #*12.3.07
    #akt20.4.07
    #note:-
    #source: raiwrite (eliminated)
    # cooperates with raireadin1
    # fn filename
    # r rows
    # k  columns
    
    j=0
    ob=0
    print "You are here...",os.getcwd()
    print "filename = ",fn
    h=raw_input(' correction (RTN if not necessary) ')
    if h!="":
        fn=h
    print "(corrected) filename ",fn
    print "argument in open: ",path+fn          #problem with pathdef
    f=open(path+fn,'w')
    f.write(str(r)+","+str(k)+"\n")
    for i in range(0,k*r):  
          
          if int(i/k)==float(1.0*i/(1.0*k)):
             j=0
             print " "
             print "object no ",ob
             ob+=1
          print "attribut no ",j   
          zahl=float(raw_input(' entry '))
          f.write(str(zahl)+",")
          j+=1
    f.close()
    return

def raiwrite2(path, fn,matrix, r,k):
    """writes a data matrix -matrix- in a file, path info is to be used"""
    #  brg 12.3.07, 19.3.07, 20.4.07, 3.6.07
    #*12.3.07
    #akt 3.6.07
    #note: cooperates with raireadin1
    #source:-
    # fn filename
    # r rows
    # k  columns
    
    print "You are here...",os.getcwd()
    print "filename = ",fn
    print "argument in open: ",path+fn          #problem with pathdef
    f=open(path+fn,'w')
    f.write(str(r)+","+str(k)+"\n")
    for i in range(0,r):
        for j in range(0,k):
          zahl=matrix[i][j]
          f.write(str(zahl)+",")
    f.close()
    return

def raiwritematrix(path, fn,matrix, r,k):
    """writes a data matrix -matrix- in a file, path info is to be used"""
    #  brg 12.3.07, 19.3.07, 20.4.07, 3.6.07, 16.9.09,23.9.,09
    #*12.3.07
    #akt 23.9.09
    #note: write a matrix so that it can be read in in EXCEL
    #source:from raiwrite2-
    # fn filename
    # r rows
    # k  columns
    
    #print "You are here...",os.getcwd()
    #print "filename = ",fn
    #print "argument in open: ",path+fn          #problem with pathdef
    f=open(path+fn,'w')
    for j in range(0,k+1):
        if j==0:
            f.write("dummy\t")
        else:
            f.write("q"+str(j)+"\t")
    f.write("\n")        
    for i in range(0,r):
        f.write(str(i)+"\t")
        for j in range(0,k):
          zahl=matrix[i][j]
          if j<k-1:
              f.write(str(round(zahl,3))+"\t")
          else:
              f.write(str(round(zahl,3))+"\n")
              
    f.close()
    return


def raiwrite3(path, fn,typ,matrix, r,k):
    """writes a data matrix -matrix- in a file, path info is to be used"""
    #  brg 12.3.07, 19.3.07, 20.4.07, 3.6.07, 24.12.08
    #*12.3.07
    #akt 24.12.08
    #note: cooperates with raireadin1. As raiwrite3 will cooperate with
    #      asksaveasfilename of tkFileDialog the print-commands are
    #      mosleading
    #source:-
    # path: path
    # fn filename
    # typ: a for append and w for new/overwrite
    # matrix: a matrix with r rows and k columns is expected
    # r rows
    # k  columns
    f=open(path+fn,typ)
    f.write("\n"+str(r)+","+str(k)+"\n")
    for i in range(0,r):
        for j in range(0,k):
          zahl=matrix[i][j]
          f.write(str(zahl)+",")
    f.close()
    return

def raiwrite4(path, fn,typ,txt):
    """writes a text in a file, path info is to be used"""
    #  brg 12.3.07, 19.3.07, 20.4.07, 3.6.07, 24.12.08
    #*12.3.07
    #akt 24.12.08
    #note: cooperates with raireadin1. As raiwrite3 will cooperate with
    #      asksaveasfilename of tkFileDialog the print-commands are
    #      mosleading
    #source:-
    # path: path
    # fn filename
    # typ: a for append and w for new/overwrite
    # txt: a free text can be saved
    f=open(path+fn,typ)
    f.write("\n"+txt+"\n")
    f.close()
    return

def raiwrite5old(fn,matrix,r,k):
    """writes a text in a file, path info is to be used"""
    #  brg 12.3.07, 19.3.07, 20.4.07, 3.6.07, 24.12.08, 31.5.09
    #*12.3.07
    #akt 23.7.09
    #note: cooperates with raireadin1. As raiwrite3 will cooperate with
    #      asksaveasfilename of tkFileDialog the print-commands are
    #      misleading
    #source:-
    # path: path
    # fn filename
    # typ: a for append and w for new/overwrite
    # txt: a free text can be saved
    
    f=open(fn,"w")
    f.write(str(r)+","+str(k)+"\n")
    for i in range(0,r):
        for j in range(0,k):
            f.write(str(matrix[i][j])+",")
            
    f.close()
    return

def raiwrite5(fn,matrix,obj,prop,r,k):
    """writes a data matrix -matrix- in a file, path info is to be used"""
    #  brg 12.3.07, 19.3.07, 20.4.07, 3.6.07, 24.12.08, 30.5.09
    #*12.3.07
    #akt 31.5.09noch in testphase
    #note: cooperates with raireadin1. As raiwrite3 will cooperate with
    #      asksaveasfilename of tkFileDialog the print-commands are
    #      misleading.
    #      Special use in PyHasse
    #source:-
    # fn filename
    # typ: a for append and w for new/overwrite
    # matrix: a matrix with r rows and k columns is expected
    # r rows
    # k  columns
    f=open(fn,"w")
    f.write(str(r)+","+str(k)+"\n")  #30.5.09 \n am Anfang entfernt
    for i in range(0,r):
        f.write(obj[i]+",")
    f.write("\n")    
    for j in range(0,k):
        f.write(prop[j]+",")
    f.write("\n")    
    for i in range(0,r):
        for j in range(0,k):
          zahl=matrix[i][j]
          f.write(str(zahl)+",")
    f.close()
    return

def raiwrite6(fn,matrix,r,k):
    """writes a data matrix -matrix- in a file, path info is to be used"""
    #  brg 12.3.07, 19.3.07, 20.4.07, 3.6.07, 24.12.08, 30.5.09, 4.2.2012
    #*12.3.07
    #akt 31.5.09noch in testphase
    #      Special use in PyHasse
    #source:-
    # fn filename
    # typ: a for append and w for new/overwrite
    # matrix: a matrix with r rows and k columns is expected
    # r rows
    # k  columns
    f=open(fn,"w")
    f.write(str(r)+","+str(k)+"\n")  #30.5.09 \n am Anfang entfernt
    
    for i in range(0,r):
        for j in range(0,k):
          zahl=matrix[i][j]
          f.write(str(zahl)+",")
    f.close()
    return




def raivecwrite(path, fn,vector,k):
    """writes a data vector in a file, path info is to be used"""
    #  brg 12.3.07, 19.3.07, 20.4.07, 3.6.07, 5.6.07
    #*12.3.07
    #akt5.5.07
    #note: -
    #source:-
    # cooperates with raireadin1
    # fn filename
    # r rows
    # k  columns
    
    #print "argument in open: ",path+fn          #problem with pathdef
    f=open(path+fn,'w')
    f.write(str(k)+"\n")
    for i in range(0,k):
        zahl=vector[i]
        f.write(str(zahl)+",")
    f.close()
    return


def raivecwrite2(path, fn,status,vector,k):
    """writes a data vector in a file, path info is to be used"""
    #  brg 12.3.07, 19.3.07, 20.4.07, 3.6.07, 5.6.07
    #*12.3.07
    #akt26.12.08
    #note: used in class brgfilesave
    #source:raivecwrite
    # cooperates with raireadin1
    # fn filename
    # status: a for append , w for new or overwrite
    # k  columns
    
    #print "argument in open: ",path+fn          #problem with pathdef
    f=open(path+fn,status)
    f.write("\n"+str(k)+"\n")
    for i in range(0,k):
        zahl=vector[i]
        f.write(str(zahl)+",")
    f.close()
    return


def raivecmat(r,k,xy,ma):
    """a tuple will be transformed into a matrix"""
    # brg  12.3.07
    #*12.3.07
    #akt12.3.07
    #note:-
    #source:-
    # see similar module vecmat
    # the entries of matrix ma will be filled by
    # components of xy.
    # note : the components are thought of as
    # being a matrix linearly written
    # r: rows
    # k: columns
    # for example: xy was filled as if a matrix
    #     1   2    3
    #     4   5    6
    #     ... ...  ...
    # was put in by the user.
    # xy = 1 2 3 4 5 6 ....
    # Now raivecmat generates from xy again the matrix
    # reason: the write and read procedures of Python need
    # the detour of writing linearly a matrix in a file
    #
    
    j=0
    ob=-1
    for i in range(0,r*k):
        if int(1.0*i/k)==float((1.0*i)/(1.0*k)):  #21.10.07
            j=0
            ob+=1

        ma[ob][j]=xy[i]
        j+=1
    return ma

def raivecmat1old(r,k,xy):
    """a tuple xy of length r*k will be transformed into a matrix
        with r rows and k columns"""
    # brg  12.3.07, 13.3.09
    #*12.3.07
    #akt13.3.09
    #note:-
    #source: raivecmat
    # see similar module vecmat
    # the entries of matrix ma will be filled by
    # components of xy.
    # note : the components are thought of as
    # being a matrix linearly written
    # r: rows
    # k: columns
    # for example: xy was filled as if a matrix
    #     1   2    3
    #     4   5    6
    #     ... ...  ...
    # was put in by the user.
    # xy = 1 2 3 4 5 6 ....
    # Now raivecmat generates from xy again the matrix
    # reason: the write and read procedures of Python need
    # the detour of writing linearly a matrix in a file
    #
    ma=marray(r,k)
    j=0
    ob=-1
    for i in range(0,r*k):
        if int(1.0*i/k)==float((1.0*i)/(1.0*k)):  #21.10.07
            j=0
            ob+=1

        ma[ob][j]=xy[i]
        j+=1
    return ma

def raivecmat1(r,k,xy):
    """a tuple will be transformed into a matrix"""
    # brg  12.3.07, 30.5.09
    #*12.3.07
    #akt30.5.09
    #note:-
    #source:raivecmat
    # see similar module vecmat
    # the entries of matrix ma will be filled by
    # components of xy.
    # note : the components are thought of as
    # being a matrix linearly written
    # r: rows
    # k: columns
    # for example: xy was filled as if a matrix
    #     1   2    3
    #     4   5    6
    #     ... ...  ...
    # was put in by the user.
    # xy = 1 2 3 4 5 6 ....
    # Now raivecmat generates from xy again the matrix
    # reason: the write and read procedures of Python need
    # the detour of writing linearly a matrix in a file
    #
    ma=marray(r,k)
    j=0
    ob=-1
    for i in range(0,r*k):
        if int(1.0*i/k)==float((1.0*i)/(1.0*k)):  #21.10.07
            j=0
            ob+=1

        ma[ob][j]=xy[i]
        j+=1
    return ma


def chainlevel(r,redobjx):
    """calculates the number of chains of certain length
    and the number of levels"""
    #brg 13.3.07, 7.11.07, 19.1.10
    #*13.3.07
    #akt7.11.07
    #note:-
    #source: needs a reduced zetamatrix
    # pr[i] is the number of chains of length i
    # redobjx is the (zeta-matrix) - (unit-matrix)
    # brg  13.3.07, 7.11.07
    #print "r in chainlevel ",r
    pr=vecgen1(10000)               #19.1.10, 18.8.2011
    unit=marray(r,r)
    for i in range(0,r):
        
        unit[i][i]=1
    
    prod=marray(r,r)
    prod1=marray(r,r)
    matcopy(r,r,unit,prod)
    
        
    zaehler=0
    level=0
    while zaehler<=r:
        zaehler+=1
        chaincount=0
        matmult(r,prod,redobjx,prod1)
        matcopy(r,r,prod1,prod)
        
        for i in range(0,r):
            for j in range(0,r):
                
                chaincount+=prod[i][j]
        #print "in CL: chaincount = ",chaincount
        pr[zaehler]=chaincount   #fehler?? 7.11.07
        #print "in chainlevel :chaincount ",chaincount
        level+=1
        if chaincount==0:
            break
        if level>200 :  #18.8.2011: 200 instead of 50
            print "+++ error while loop in chainlevel +++"
            break
    return level,pr

def maxminiso1(r,quobx):
    """calc. from quobx the list of max, min and isolated elements"""
    # brg 13.7.07, 15.3.07,16.3.07, 20.3.07, 21.3.07, 7.11.07, 10.11.07,17.6.08
    #*13.7.07
    #akt17.6.08
    #note:-
    #source:quobx
    # derived from maxminiso (21.3.07 passed away)
    # quobx is the matrix with lt,gt,eq,ic information
    # r is the number of rows
    # a,b,iso are lists of max, min and iso elements and are the output
    # count of maximal minimal and isolated elements as result too
    
    
    a=[]
    b=[]
    iso=[]
    for i in range(0,r):
        a.append(-1)   #store of row numbers
        b.append(-1)   #store of row numbers
        iso.append(-1)  #store of row numbers
         
    z1=0
    z2=0
    z3=0
    for i in range(0,r):
        if "lt" not in quobx[i]:
            
            a[z1]=i
            z1+=1
        else:
            pass
        if "gt" not in quobx[i]:
            
            b[z2]=i
            z2+=1
        else:
            pass
    # isolated elem.  17.6.08
    #print "max elements = ",a
    #print "min elements = ",b
    for i in range(0,r):
        if i in a and i in b:
            #print "in max and in min ",i
            iso[z3]=i
            z3+=1
        else:
            z3+=0  #17.6.08
    #print "iso =  ",iso        
    return a,b,iso

def porgraph(r,quobx,txt1,txt2):
    """Calculates order characteristica of each object
    depending on what txt1 (le, gt, ic ) and txt2 (eq) specifiy """
    # brg  21.3.07, 18.9.08, 19.9.08 (PSU), 19.11.08, 3.4.09
    # * : 21.3.07
    # akt: 3.4.09
    # derived from rai_inc
    # r number of objects (number of rows)
    # quobx is the matrix containing le, eq, gt, ic as relation among column and row
    # txt1 must contain either lt,ic, gt
    # txt2 must contain either eg or any symbol which is not lt,ic,gt
    # c: matrix which stores the result
    # rows of c: object i. in the columns: object j: the obj. i in relation...
    # defined by txt1 and txt2 with j
    c=marray1(r,r,-1)
    #strmatout(r,r,quobx)  #testing
    if txt2!="eg":   #erroneously the central quobx matrix uses eg fur equality instead of eq
        txt2="none"
    
    for i in range(0,r):
        #print " i= ",i
        for j in range(0,r):
            if quobx[i][j]==txt1 or quobx[i][j]==txt2:
                c[i][j]=1   
                        
    return c,txt1,txt2

def rai_inc(r,quobx):
    "Calculates the incomparable elem. of each object"
    # brg  21.3.07, 18.9.08 (PSU)
    #r number of objects (number of rows)
    # quobx is the matrix containing le,gt, eq and ic
    #c: matrix which stores the result
    # rows of c: object i. in the columns: the obj. inc. with i
    c=marray(r,r)
    for i in range(0,r):
        for j in range(0,r):
            c[i][j]=-1   #default value -1 because objectname "0" is possible
    for i in range(0,r):
        z=0    
        for j in range(0,r):
            if quobx[i][j]=="ic":
                z+=1
                c[i][z]=j
        #print " in ic abfrage: i = ",i,"  z = ",z,"  c= ",c[i][z]
    return c


def matcorr(r,k,x):
    """Interactiv correction of a matrix """
    #  brg 14.3.07, 16.3.07
    #*14.3.07
    #akt16.3.07
    #note: P-shell
    #souce:-
    # r: rows
    # k: columns
    # x: matrix
    
    h="n"
    while h!="*":
        h=raw_input(' stop correction modus ? Then *  ')
        if h!="*":
            ii=int(raw_input(' row  no '))
            jj=int(raw_input(' column no '))
            print "up to now ",x[ii][jj]
            x[ii][jj]=float(raw_input(' new value '))
        else:
            print "++ end of correction mode "
    return x         

def similarity(r,quobx,quoby):
    """calculates on basis of the qu... matrices similarity indices"""
    #brg 14.3.07
    #*14.3.07
    #akt14.3.07
    #note: similarity1 is better tested
    #source:-
    # quobx, quoby contain the lt,gt,eq,ic info
    # similarity will be calculated and
    # some prints given
    # later it is planned to write the info on a tuple
    # wich can be used in graphic programs
    # brg  14.3.07
    isoton=0      # a<b associated to a<'b or a>b associated to a>'b
    antiton=0     # a<b associated to a>'b or a>b is associated to a<'b
    weakisoton=0  # all strict orders associated to a='b
    indiff=0      # everything associated to incomparability
    ident=0       # eq,eq
    for i in range(0,r):
        for j in range(0,r):
            if i!=j:
                text=quobx[i][j]+","+quoby[i][j]
                if text=="lt,lt" or text=="gt,gt":
                    isoton+=1
                if text=="lt,gt" or text=="gt,lt":
                    antiton+=1
                if text=="lt,eg" or text=="gt,eg" or text=="eg,lt" or text=="eg,gt":
                    weakisoton+=1
                if "ic" in text:
                    indiff+=1
                if text=="eg,eg":
                    ident+=1
    print "isoton =     ",isoton
    print "antiton =    ",antiton
    print "weakisoton = ",weakisoton
    print "indiff =     ",indiff
    print "ident  =     ",ident
    frisoton=float(1.0*isoton/(r*(r-1)))
    frantiton=float(1.0*antiton/(r*(r-1)))               
    frweakisoton=float(1.0*weakisoton/(r*(r-1)))
    frindiff=float(1.0*indiff/(r*(r-1)))
    frident=float(1.0*ident/(r*(r-1)))

    print "Fractions"               
    print "fraction, isoton =     ",round(frisoton,3)
    print "fraction, antiton =    ",round(frantiton,3)
    print "fraction, weakisoton = ",round(frweakisoton,3)
    print "fraction, indiff =     ",round(frindiff,3)
    print "fraction, ident  =     ",round(frident,3)
    print " "
    print 60*"="
    print" analysis of the x - system  "
    print "  identifier succ    pre         incom"
    print "             essors  decessors   comparables"
    print 60*"-"
    return

def similarity1(r,quobx,quoby):
    """calculates on basis of the qu... matrices similarity indices"""
    # brg  14.3.07, 15.3.07
    #*14.3.07
    #akt14.3.07
    #note:in use in GUI-program simi2.py
    #source: similarity
    
    # quobx, quoby contain the lt,gt,eq,ic info
    # similarity will be calculated and
    # written on tuple a
    # 
    
    a=[]
    for i in range(0,12):
        a.append(0)

    isoton=0      # lt,lt  or gt,gt
    antiton=0     # lt,gt  or gt,lt
    weakisoton=0  #lt or gt in combin with =
    indiff=0      # all combination with ic
    ident=0       # eq,eq

    for i in range(0,r):
        for j in range(0,r):
            if i!=j:
                text=quobx[i][j]+","+quoby[i][j]
                if text=="lt,lt" or text=="gt,gt":
                    isoton+=1
                if text=="lt,gt" or text=="gt,lt":
                    antiton+=1
                if text=="lt,eg" or text=="gt,eg" or text=="eg,lt" or text=="eg,gt":
                    weakisoton+=1
                if "ic" in text:
                    indiff+=1
                if text=="eg,eg":
                    ident+=1

    a[0]=isoton #isoton
    a[1]=antiton  #    antiton
    a[2]=weakisoton  #weak isoton
    a[3]=indiff
    a[4]=ident   #equivalent objects
    a[6]=float(1.0*isoton/(r*(r-1)))  #fraction isoton
    a[7]=float(1.0*antiton/(r*(r-1)))  #fraction antitone             
    a[8]=float(1.0*weakisoton/(r*(r-1)))  #fraction weakisoton
    a[9]=float(1.0*indiff/(r*(r-1))) #fraction indifferent
    a[10]=float(1.0*ident/(r*(r-1))) #fraction equivalces

    return a

def sucpredinc(r,quobx):
    """from quobx the successors, predeccessors ,
    incomparabilities of each element i will be calculated"""
    # brg  14.3.07-16.3.07, 21.3.07, 29.11.2013
    #*14.3.07
    #akt29.11.2013
    #note:used in the LPOM0-series
    #source:-
    #quobx is the matrix with lt,gt,ic,eq info
    # r number of rows
    
    a=[]    #successors (downwards)
    b=[]    #predecessors (upwards)
    c=[]    #incomparable elements
    d=[]    #equivalent elements
    # for example [1,0,2,1,3] means first element has 1, second 0, third 2 etc elements
    for i in range(0,r):
        a.append(0)
        b.append(0)
        c.append(0)
        d.append(0)
    
    for i in range(0,r):
        for j in range(0,r):
            if quobx[i][j]=="gt":
                b[i]+=1
            if quobx[i][j]=="lt":
                c[i]+=1
            if quobx[i][j]=="ic":
                a[i]+=1
            if quobx[i][j]=="eg":  #29.11.2013
                d[i]+=1
    return b,c,a,d

def lpom0(r,quobx):
    """local partial order model 0"""
    # Brg 15.3.07, 16.3.07,21.3.07
    #*15.3.07
    #akt21.3.07
    #note: very important
    #source:-
    # basis quobx with lt,gt,ic,eq information
    # output: a rk- tuple with the rkav - values according to lpom0
    # output : a tuple with the two prob-values
    
    a=[]
    b=[]
    c=[]
    d=[]
    e=[]
    rk=[]
    for i in range(0,r):
        rk.append(0)
        a.append(0)
        b.append(0)
        c.append(0)
        d.append(0)
    pro=marray(r,2)    
    for i in range(0,r):
        for j in range(0,r):
            if quobx[i][j]=="gt":
                b[i]+=1   #successor
            if quobx[i][j]=="lt":
                c[i]+=1   #predecessors
            if quobx[i][j]=="ic":
                a[i]+=1   #incomparables
            if quobx[i][j]=="eq":
                d[i]+=1   #equivalent objects
        
    for i in range(0,r):
        prob1=((1.0*c[i]+1.0)/(1.0*c[i]+1.0*b[i]+2.0))
        prob2=((1.0*b[i]+1.0)/(1.0*c[i]+1.0*b[i]+2.0))
        
        rk[i]=prob2*(1.0*b[i]+1.0+a[i])+prob1*(1.0*b[i]+1.0)
        pro[i][0]=prob2
        pro[i][1]=prob1
    return rk,pro,b,c,a,d

def pyhassehelp():
    """help for Simil_Stability.py """
    # Brg 16.3.07  , 20.4.07 , 27.4.07  22.10.07
    #*16.3.07
    #akt22.10.07
    #note: will be once eliminated
    #source:-
    print "  "
    print "pyhasse7 , vs. 0.01 of 27.4.07"
    print "  "
    print "author: R.Brueggemann"
    print " A) three ways to get inputs: "
    print " 1. create your own file and perform the calculations"
    print "    within Pyhasse7"
    print " 2. create your file within Pyhasse7 and store it (menue point 2)"
    print "    Later you may read in this file (menuepoint 3)"
    print "     +++ D o n' t  f o r g e t : before starting any calculation++++"
    print "     +++ After menuepoint 2 (write a matrix) , you must reload the matrix "
    print "     +++ Reload the matrix by menue 3  ++++"
    print " 3. By EXCEL (german version with decimal colon) a txt - file"
    print "    is created (with blanks as separators). Then by menue point 4"
    print "    a read in can be performed."
    h=raw_input('  ready, then RTN-button ')
    print " B) organisation of the program: "
    print " After several write and read in of matrices "
    print " one may normalize the matrix (menue 6)"
    print " one may correct or modify the matrix  (menue 7)" 
    print " one may calculate typical statistical quantities for any attribute "
    print " if not a special analysis (stability or similarity) is wanted"
    print " then leave the menue-block by enter 40 "
    print " Some typical quantities of partial order will be calculated (see below)"
    h=raw_input('   ready, then RTN-button ')
    print "Pyhasse 7 calculates:"
    print "level nr, chains,maximal, minimal, isol. elements"
    print "level population"
    print "the successors , predecessors and incomparables  "
    print "LPOM(0)"
    print "similarity "
    print "stability "
    print "Note 'quit of menue' only meaningful if  default values"
    print " or a matrix was read in or a new matrix was created"
    print " "
    h=raw_input(' ready, then RTN-button ')
    print "similarity "
    print "It is expected that both datamatrices are EXCEL-files"
    print "From Excelfiles without names (just the data body) a text-file"
    print "with tab  is to be prepared "
    print "Then go directly to menuepoint 10"
    print "import the first and after that the second file "
    print "the analysis will subsequently be performed"
    
    print "  "
    print " "
    print "  "
    h=raw_input('  ready, then RTN-button ')
    return

def raisort(r,x):
    """sorts a tuple of numbers and traceback the permutations"""
    #brg  18.3.07, 19.3.07, 20.4.07, 15.11.07
    #*18.3.07
    #akt 10.8.08
    #note:vector x will be overwritten
    #source:-
    # r number of objects (rows)
    # x: vector to be sorted,
    #    note x will be overwritten by the new sorted components
    # n: vector of components-nr of x rearranged according to increasing values
    #    of x
    # x=[2,3,1,4,5] --> n=[2,0,1,3,4]
    # meaning that component 2 takes the lowest rank, component 1 the next rank etc
    # testprogram: testraisort1.py
    n=[]
    y=[]
    for i in range(0,r):
        n.append(0)
        y.append(0)
        
    y=copy.deepcopy(x)
    for i in range(0,r-1):
        for j in range(0,r-1):
            if x[j]>x[j+1]:
                h=x[j+1]
                x[j+1]=x[j]
                x[j]=h
    for i in range(0,r):
        n[i]=y.index(x[i])
        y[n[i]]=str(y[n[i]])
    #print y
    return x,n    

def brgsort(x):
    """sorts a tuple of numbers and traceback the permutations"""
    #brg  18.3.07, 19.3.07, 20.4.07, 15.11.07, 3.8.2012
    #*18.3.07
    #akt 10.8.08, 3.8.2012
    #note:vector x will be overwritten
    #source:-
    # x: vector to be sorted,
    #    note x will be overwritten by the new sorted components
    # n: vector of components-nr of x rearranged according to increasing values
    #    of x
    # x=[2,3,1,4,5] --> n=[2,0,1,3,4]
    # meaning that component 2 takes the lowest rank, component 1 the next rank etc
    # testprogram: testraisort1.py
    n=[]
    y=[]
    r=len(x)
    for i in range(0,r):
        n.append(0)
        y.append(0)
        
    y=copy.deepcopy(x)
    for i in range(0,r-1):
        for j in range(0,r-1):
            if x[j]>x[j+1]:
                h=x[j+1]
                x[j+1]=x[j]
                x[j]=h
    for i in range(0,r):
        n[i]=y.index(x[i])
        y[n[i]]=str(y[n[i]])
    #print y
    return x,y,n    

def raisort2(x):
    """sorts a tuple of numbers and traceback the permutations
    the vector x will   n o  t  be overwritten """
    #brg  18.3.07, 19.3.07, 20.4.07, 15.11.07, 16.11.2013
    #*18.3.07
    #akt 16.11.2013, 31.1.2016
    #source:raisort
    # r number of objects (rows), x: vector to be sorted, n: vector of components-nr
    # ...of x rearranged according to increasing values of x
    # x=[2,3,1,4,5] --> n=[2,0,1,3,4]
    # meaning that component 2 takes the lowest rank, component 1 the next rank etc
    # Output: orig values, sorted, tracing back info (by n)
    # testprogram: Uebungsprogramme/sorting: sort161113_2.py
    import copy
    rx=len(x)
    n=[]
    y=[]
    for i in range(0,rx):
        n.append(0)
        y.append(0)

    xhilf=copy.deepcopy(x)    
    y=copy.deepcopy(x)
    for i in range(0,rx-1):
        for i1 in range(0,rx-1):
            if xhilf[i1]>xhilf[i1+1]:
                h=xhilf[i1+1]
                xhilf[i1+1]=xhilf[i1]
                xhilf[i1]=h
    for i in range(0,rx):
        n[i]=y.index(xhilf[i])
        y[n[i]]=str(y[n[i]])
    #print y
    return x,xhilf,n    



def CSVreadin(n,K,path,fn):
    """read in from EXCEL Files"""
    # brg  17.4.07, 25.7.2013
    #*17.4.07
    #akt17.4.07, 25.7.2013
    #note:a string matrix as result
    #source:-
    # The EXCEL file must be stored in CSV - format with blanks as separation
    # Please note the number of rows (n)
    # Please note the number of columns (K)
    # Default: 100*100 matrix
    #path=D:/pythonbrg/RainerPYs/eigProg/   for example
    #fn=test11.txt   for example
    # Note : if path and filename (fn) is read in by standard raw_input
    # then without "" or ''
    print os.getcwd()
    aa=marray(100,100)
    a=[]
    a=vecgen1(100)
    
    myfile=open(path+fn)
    a=myfile.readlines()
    print "Read in from EXCEL-File, first line..."
    print a[0]
    print "  "
    for i in range(0,n):
        for j in range(0,K):
            aa[i]=a[i].split(";")
    print "Control "
    print aa            #Note aa is a matrix of strg and in German EXCEL with
                        # , as decimal-separation. 
    return aa

def conversion(n,K,aa,x):
    """converses aa a string with colons as decimal point
    into a float number with decimal point"""
    #brg  17.4.07
    #*17.4.07
    #akt17.4.07
    #note:-
    #source:-
    # n number of rows
    # K number of columns
    for i in range(0,n):
        for j in range(0,K):
            x[i][j]=float(aa[i][j].replace(',','.'))
    return        

def EXCELreadin(path,fn):
    """read in from EXCEL txt-Files"""
    # brg  18.4.07, 20.4.07, 13.11.07
    #*18.4.07
    #akt13.11.07
    #note:only the numerical values of the dm
    #source:-
    # The EXCEL file must be as txt-file with blanks as separation
    # path=D:/pythonbrg/RainerPYs/  for example
    # fn=test12.txt   for example
    # Note : if path and filename (fn) is read in by standard raw_input
    # then without "" or ''
    # Note : Automatic conversion from colon to decimal-point
    aa=marray(200,200)
    xx=marray(200,200)
    a=[]
    a=vecgen(200,a)
    myfile=open(path+fn)
    a=myfile.readlines()
    #print "  "
    na=len(a)
    for i in range(0,na):
        aa[i]=a[i].split()
        #print "i = ",i,"  aa= ",aa[i],"  ",len(aa[i])
        #print "  "
    Ka=len(aa[0])
    #print "components of aa ",Ka
    for i in range(0,na):
        for j in range(0,Ka):
            xx[i][j]=float(aa[i][j].replace(',','.'))

    #matout(na,Ka,xx)
    return xx,na,Ka



def EXCELreadin3(path,fn):
    """read in from EXCEL txt-Files inclus object and property names"""
    # brg  aus EXCELreadin 14.11.07, 29.11.07, 30.11.07
    #*14.11.07
    #akt30.11.07
    #note : Automatic conversion from colon to decimal-point
    #source: EXCELreadin
    # properties are stored in prop .
    # Objects are stored in obj.
    # Note blanks in the objectname are not accepted
    #print "path = ",path
    #print "fn =",fn
    myfile=open(path+fn)
    a=myfile.readlines()
    na=len(a)
    n=na    #15.11. 23.20: tests mit Excel-Eingaben haben
            # ergeben, dass im allgem. keine zusaetzliche Leerzeile entsteht
            # so dass man besser n=na  und weiter unten rm=na-1 setzen sollte.
            # Ich muss aber noch etwas mit EXCEL herumexperimentieren
            #Es scheint als wenn eine Leerzeile eher die Ausnahme ist.
            # Note please control the row numbers of your EXCEL-File
            # There should be no additional empty line.
            # Control bei page-preview
    #print "actual rows ",na  #Property Zeile+Matrix + ?
    aa=marray(200,200)
    global obj   
    obj=vecgentext(n-1)       #14.11.07
    
    for i in range(0,n):
        aa[i]=a[i].split()
        #print aa[i]
    
    Ka=len(aa[0])               # objectname column + Matrix data columns
    prop=vecgentext(Ka-1)
    
    #print "Ka  = ",Ka
    km=Ka-1                #number of matrix data columns
    rm = na-1              #number of matrix data rows
    xx=marray(rm,km)
    #strmatout(n,Ka,aa)
    for i in range(1,n):
        for j in range(1,Ka):
            xx[i-1][j-1]=float(aa[i][j].replace(',','.'))
    #matout(rm,km,xx)
    for j in range(0,Ka):
        prop[j]=str(aa[0][j])
    #print prop
      
    for i in range(0,n):
        obj[i]=str(aa[i][0])
    #print obj
       
    return xx,obj,prop, rm,km   #rm and km matrix xx

def EXCELreadin4(fn):
    """read in from EXCEL txt-Files inclus object and property names"""
    # brg  aus EXCELreadin3 14.11.07, 29.11.07, 30.11.07, 13.1.08, 7.5.08, 23.6.10
    #*14.11.07
    #akt 23.6.2010
    #note : Automatic conversion from colon to decimal-point. It is assumed
    #note (cont'd): that the calling program is in the correct directory
    #source: EXCELreadin
    # properties are stored in prop .
    # Objects are stored in obj.
    # Note blanks in the objectname are not accepted
    #
    #
    txt1="ok"
    if fn!="":
        try:                    #new 24.2.2010
            myfile=open(fn)
            if myfile!=None:
                a=myfile.readlines()
                na=len(a)   # number of rows including the heading row (<text> properties)
                n=na    #15.11. 23.20 
                aa=marray(500,500)   #24.2.10: change from 200 to 500
                global obj   
                obj=vecgentext1(n)       #14.11.07, 7.5.08 changed to vecgentext1
                #print "length of obj = ",len(obj)
                for i in range(0,n):
                    aa[i]=a[i].split()
                    #print aa[i]
                
                Ka=len(aa[0])               # objectname column + Matrix- data- columns
                                            # Ka = m+1 if m is the number of attributes
                prop=vecgentext1(Ka)      #changed to vecgentext1
                
                #print "Ka  = ",Ka
                #print "length of prop ",len(prop)
                km=Ka-1                #number of matrix data columns
                rm = na-1              #number of matrix data rows
                xx=marray(rm,km)
                #strmatout(n,Ka,aa)
                for i in range(1,n):
                    for j in range(1,Ka):
                        xx[i-1][j-1]=float(aa[i][j].replace(',','.'))
                #matout(rm,km,xx)
                for j in range(0,Ka):     #7.5.08 range(0,Ka) replaced by range(1,Ka)
                    prop[j]=str(aa[0][j])
                #print "prop-names : ",prop
                  
                for i in range(0,n):
                    obj[i]=str(aa[i][0])
                #print "object names ",obj
                #print "rm = ",rm
                # prop = <text> prop1, prop2,...
                # obj =  <text> obj1, obj2, ....
            else:
                txt2="file not opened"
                print txt2
            return xx,obj,prop,rm,km
        except:
            txt="Sorry, no file opened"
            print txt
            return txt             #xx,obj,prop, rm,km   #rm and km matrix xx
    else:
        txt3="readin cancelled"
        print txt3
        return txt3

def EXCELreadin5(fn):
    """read in from EXCEL txt-Files inclus object and property names"""
    # brg  aus EXCELreadin3 14.11.07, 29.11.07, 30.11.07, 13.1.08, 7.5.08, 23.6.10
    #*14.11.07
    #akt 21.8.2013
    #note : Automatic conversion from colon to decimal-point. It is assumed
    #note (cont'd): that the calling program is in the correct directory
    #source: EXCELreadin
    # properties are stored in prop .
    # Objects are stored in obj.
    # Note blanks in the objectname are not accepted
    #
    #
    txt1="ok"
    if fn!="":
        try:                    #new 24.2.2010
            myfile=open(fn)
            if myfile!=None:
                a=myfile.readlines()
                na=len(a)   # number of rows including the heading row (<text> properties)
                n=na    #15.11. 23.20 
                aa=marray(50000,50000)   #21.8.13: change from 200 to 50000
                global obj   
                obj=vecgentext1(n)       #14.11.07, 7.5.08 changed to vecgentext1
                #print "length of obj = ",len(obj)
                for i in range(0,n):
                    aa[i]=a[i].split()
                    #print aa[i]
                
                Ka=len(aa[0])               # objectname column + Matrix- data- columns
                                            # Ka = m+1 if m is the number of attributes
                prop=vecgentext1(Ka)      #changed to vecgentext1
                
                #print "Ka  = ",Ka
                #print "length of prop ",len(prop)
                km=Ka-1                #number of matrix data columns
                rm = na-1              #number of matrix data rows
                xx=marray(rm,km)
                #strmatout(n,Ka,aa)
                for i in range(1,n):
                    for j in range(1,Ka):
                        xx[i-1][j-1]=float(aa[i][j].replace(',','.'))
                #matout(rm,km,xx)
                for j in range(0,Ka):     #7.5.08 range(0,Ka) replaced by range(1,Ka)
                    prop[j]=str(aa[0][j])
                #print "prop-names : ",prop
                  
                for i in range(0,n):
                    obj[i]=str(aa[i][0])
                #print "object names ",obj
                #print "rm = ",rm
                # prop = <text> prop1, prop2,...
                # obj =  <text> obj1, obj2, ....
            else:
                txt2="file not opened"
                print txt2
            return xx,obj,prop,rm,km
        except:
            txt="Sorry, no file opened"
            print txt
            return txt             #xx,obj,prop, rm,km   #rm and km matrix xx
    else:
        txt3="readin cancelled"
        print txt3
        return txt3
        
def EXCELreadin6(fn):
    """read in from EXCEL txt-Files inclus object and property names"""
    # brg  aus EXCELreadin3 14.11.07, 29.11.07, 30.11.07, 13.1.08, 7.5.08, 23.6.10, 25.1.2015
    #*14.11.07
    #akt 23.6.2010, 25.1.2015
    #note : Automatic conversion from colon to decimal-point. It is assumed
    #note (cont'd): that the calling program is in the correct directory
    #source: EXCELreadin
    # properties are stored in prop .
    # Objects are stored in obj.
    # Note blanks in the objectname are not accepted
    # Note the (0,0)-position in your dm must be filled with a dummy string
    #
    import Tkinter
    from ScrolledText import ScrolledText
    from string import replace
    tpinput=Tkinter.Toplevel()
    tpinput.title(" Input control ")
    lbinput=Tkinter.Label(tpinput,text=" +++Control Input+++ ",font=16)
    lbinput.pack()
    lbinput2=Tkinter.Label(tpinput, text="", font = ("Bold",16))
    lbinput2.pack()
    txt="Inputcontrol"+"\n"
    txt+=50*"="+"\n"
    flag = 0
    try:
        txt+=str(fn)+"\n"
        myfile=open(fn)
        a=myfile.readlines()
        aa = []
        obj = []         
        for i in range(0,len(a)):
            aa.append(a[i].split())
        if len(aa[0]) != len(aa[1]):
            txt += "+++(0,0)-position of your data matrix: Please check!!+++"+"\n"
            lbinput2.config(text = txt,font=("Bold",16),bg="red")
            flag = 1
            
        k = len(aa[0])-1
        r = len(a)-1
        txt+="number of objects = "+str(r)+"\n"
        txt+="number of attributes(indicators, properties) = "+str(k)+"\n"
        txt+="\n"
        x = []
        for i in range(0, r):
            x.append(0)
            x[i] = []
            for j in range(0,k):
                x[i].append(float(aa[i+1][j+1].replace(',','.')))
                
        if flag == 0:    
            txt += "Input ok: "+"\n"
        else:
            txt += "Propably the (0,0)-position is empty "+"\n"
        ob = []
        for i in range(0,r+1):
            ob.append(aa[i][0])
        pr = []
        for j in range(0,k+1):
            pr.append(aa[0][j])
        txt+=5*"\n"
        txt+="Please close inputcontrol "+"\n"
    except:
        txt+="Input not ok, please check your data matrix "+"\n"
        txthilf="The correct structure would be:"+"\n"
        txthilf+="dummy-string\tindicator1\tindicator2\t   ..."+"\n"
        txthilf+="objectlabel1\t number\t    number\t      ..."+"\n"
        txthilf+="objectlabel2\t number\t    number\t      ..."+"\n"
        txthilf+="...."+"\n"
        txt+=txthilf+"\n"
        txt+="+++ See help text for more information+++ "+"\n"
        txt+=5*"\n"
        txt+="Please close inputcontrol "+"\n"
        
    tinput=ScrolledText(tpinput,width=60, height=20,bg="yellow")
    tinput.pack()
    tinput.insert("end",txt)
    
    
    return x,ob,pr,r,k


def railevel(r,level,zeta):
    """from the zeta matrix the level after Patil"""
    # brg 26.4.07, 8.11.07, 8.12.07, 7.2.09
    #*26.4.07
    #akt 7.2.09
    #note: only quotient sets
    #source:-
    # number of representatives (rows or columns of zeta
    # level, number of levels
    # zeta-matrix 1 if matrixelement i is above or equal j , 0 else
    # testprogram level4.py
    # diffobj contains: first row: the level = 'level' and its elements
    #                   second row: the level 'level'-1 and its elements
    #                   last row: level 1 and its elements
    zetaext=vecgen1(r)
    diffobj=marray1(level,r,-1)
    rowsum=vecgen1(r)

    for j in range(0,r):        #columns
        summ=0
        for i in range(0,r):        #rows
            summ+=zeta[i][j]
        zetaext[j]=summ


    for iz in range(0,level):
        #print zetaext
        for i in range(0,r):    #rows
            summ=0
            for j in range(0,r):
                if zetaext[j]==1:
                    diffobj[iz][j]=j
                    summ+=zeta[j][i]
            rowsum[i]=summ
        #print rowsum    
        for j in range(0,r):
            zetaext[j]=zetaext[j]-rowsum[j]
    return diffobj            

def fuzzymatmult(r,a,b):
    """Matrixmethod after de Baets"""
    # Brg 13.5.07, 14.5.07
    #*13.5.07
    #akt14.5.07
    #note:-
    #source:-
    # r rows number (number of objects)
    # a, b matrices
    # c the result max (min )
    
    c=marray(r,r)
    hilf4=vecgen1(r)
    for i in range(0,r):
        for j in range(0,r):
            for k in range(0,r):
                hilf4[k]=0.0
            for k in range(0,r):
                #print k," ",a[i][k]," ",b[k][j]," ",min(a[i][k],b[k][j])
                hilf4[k]=min(a[i][k],b[k][j])
            c[i][j]=round(max(hilf4),3)
    return c

def fuzzylessthan(r,K,dm):
    """fuzzy representation of less than Klosko-method"""
    # brg 13.5.07, 7.5.08, 8.2.09, 17.3.09
    #*13.5.07
    #akt 17.3.09
    #note:-
    #source:-
    # see Van de Walle et al. 1995
    # r number of rows of dm (= number of objects)
    # K number of attributes (number of columns of dm)
    # dm data matrix
    # rf relational matrix
    # usually not transitivity closed
    rf=marray(r,r)
    hilf=vecgen1(K)                   
    for i in range(0,r):
        sumh=0
        sumnenner=0
        for j in range(0,r):
            sumh=0
            if i==j:
                rf[i][j]=1.0
            else:    
                sumnenner=0
                for l in range(0,K):
                    hilf[l]=min(dm[i][l],dm[j][l])
                    #print "i = ",i," j= ",j,"hilf[",k,"] = ",  hilf[k]," ",
                    sumnenner+=dm[i][l]
                    sumh+=hilf[l]
                if sumnenner>0:     #change 8.2.09 see v.d.Walle,1995 p. 119 
                    rf[i][j]=float(1.0*sumh/(1.0*sumnenner))
                else:
                    rf[i][j]=1.0   #change 8.2.09
                #print " "
            #print "zaehler fuer ",i,"  j ",j,sumh
            #print "Nenner fuer ",i,"   j ",j,"  ",sumnenner
    return rf

def comparematrices(r,K,eps,a,b):
    """if the sum of all abs diff. of matrix entries < eps than flag = 1 else 0"""
    # brg 13.5.07, 14.5.07
    #*13.5.07
    #akt14.5.07
    #note: fuzzy analysis
    #source:-
    # r number of rows, K number of columns
    # eps tolerance
    # a, b two matrices
    
    sumh=0
    for i in range(0,r):
        for j in range(0,K):
            sumh+=abs(a[i][j]-b[i][j])
            #print "Test in comp",a[i][j]," ",b[i][j]," ",abs(a[i][j]-b[i][j])
    if sumh<=eps:
        flag=1
    else:
        flag=0
    return flag                   

def msign(a,b):
    """a>b yields -1 a<b yields 1, a=b yields 0"""
    # brg  8.7.07
    #"8.7.07
    #akt8.7.07
    #note:-
    #source:-
    if a>b:
        dd=-1
    if a<b:
        dd=1
    if a==b:
        dd=0
    return dd    


def gui1(n):
    """Variable GUI for labels, entries buttons """
    # Brg  29.8.07, 4.10.07, 2.11.2011
    #*29.8.07
    #akt4.10.07
    #note: as a blue print
    #source:-
    # Four frames: a general one and three slaves, side at side arranged
    # From the left to the right:
    # (1) Labels with text for entries
    # (2) The entries
    # (3) The buttons
    # Nota bene: dieses Modul funktioniert nicht mit Aufruf
    # sondern wird am besten in das Hauptprogramm kopiert.
    import Tkinter

    lb=vecgen1(n)
    eing=vecgen1(n)
    butt=vecgen1(n)
    txt=vecgen1(n)
    cdtext=vecgen1(n)

    hf=Tkinter.Tk()
    frgen=Tkinter.Frame(hf,relief="sunken")  #allgemein
    frgen.pack()
    fr1=Tkinter.Frame(frgen,relief="groove")  #Eingabebeschriftung
    fr1.pack(side="left",pady=1)
    fr2=Tkinter.Frame(frgen,relief="groove")  #Entries
    fr2.pack(side="left",pady=1)
    fr3=Tkinter.Frame(frgen,relief="raised")  #Buttton
    fr3.pack(side="right")

    for i in range(0,n):
        txt[i]="Eingabe "+str(i)

    for i in range(0,n):
        lb[i]=Tkinter.Label(fr1,text=txt[i],relief="sunken",bd=2)
        lb[i].pack(pady=1)


    for i in range(0,n):
        eing[i]=Tkinter.Entry(fr2,width=5)
        eing[i].pack(pady=1)

    for i in range(0,n):
        butt[i]=Tkinter.Button(fr3,text="command"+str(i),command=cdtext[i])
        butt[i].pack()

    hf.mainloop()
    return cdtext

def raisave():
    """gui-save  """
    # Brg  4.10.07 corresp. mit rairead()
    #*4.10.07
    #akt4.10.07
    #note:-
    #source:-
    # im Hauptprogramm muss Tkinter mit Label lbrai1
    # ... ein Button mit command=raisave
    # ... ein Entry mit ename=Tkinter.Entry vorhanden sein
    # Nota bene: dieses Modul funktioniert nicht mit Aufruf
    # sondern wird am besten in das Hauptprogramm kopiert.
    
    name=ename.get()
    path="D:/pythonbrg/rainerPYs/"
    rmod2.raiwrite2(path,name,a,tech[0],tech[1]) 
    
    lbrai1.config(bg="yellow")
    lbrai1["text"]="matrix auf "+name+" eingelesen"
                    

def rairead():
    """gui-read """
    # Brg  4.10.07 correspondiert mit raisave()
    #*4.10.07
    #akt4.10.07
    #note:-
    #source:-
    # Voraussetzung: global vereinbart ein Vektor der Laenge..
    # cols*rows.
    # Im Hauptprogramm ... ein Button mit command = rairead
    # und label lbrai1 (also lbrai1=Tkinter.Label(....)
    # dieses Modul kann nicht aufgerufen werden
    # sondern muss in die entsprechenden Programme
    # kopiert werden.
    name=ename.get()
    path=os.getcwd()+"/"
    rows,cols,vec=rmod2.raireadin2(path,name)
    rmod2.raivecmat(rows,cols,vec,a)
    lbrai1.config(bg="yellow")
    lbrai1["text"]=name+" eingelesen "


def vectorfill(n):
    "vector a filled with numbers from 1 to n"
    # brg
    # wie vecgen1 aber fuellt mit 1,2,3,... auf
    
    a=vecgen1(n)
    
    for i in range(0,n):
        #print "Laufparameter i = ",i
        
        a[i]=i+1
        
    return a

def matrowcorr(r,k,rr,a):
    "correction of a complete row of a matrix"
    #Brg 21.11.07, 8.12.07
    # Interactiv : Python-Shell
    # r number of rows
    # k number of columns
    # rr selected row to be changed
    # a matrix. Note the matrix will be overwritten
    
    if rr>r:
        print "That row does not exist!"
    else:
        print "original values "
        for j in range(0,k):
            print a[rr][j],"\t",
        print " "
        print "Now your values:"
        for j in range(0,k):
            a[rr][j]=float(raw_input(str(j)+" "))

    return a                        

def dmcompress(r,k,x):
    """equivalent elements will be indicated"""
    # Brg 12.11.07, 20.11.07, 21.11.07
    #*12.11.07
    #akt21.11.07
    #note: dmcompress may be replaced by equicompact
    # r rows
    # k columns
    # x a date matrix which may contain equivalent elements
    # 
    # 
    # interim result: ec: matrix: which element is with which equivalent
    # ############################################################################
    # ####Note that -1 is a default for ec, take care for object names      ######
    # ############################################################################
    # ec[i][j] = -1 if no equivalent element and >0 if there is an equivalent element unequal i
    ###############
    #
    # a reduction for equivalence needs
    # (1) dmcompress --> ec
    # (2) identifyclowows --> txt (the relevant information of rows to be eliminated
    # (3) if a symmetric matrix is to be reduced:
    # (3a) del and matrixrowdel
    # (3b) else: only matrixrowdel
    y=marray(r,k)
    ec=marray1(r,r,-1)
    zaehl=vecgen1(r)
    for i in range(0,r):
        zaehl[i]=0
        for j in range(0,r):
            if j!=i:
                if x[i]==x[j]:
                    ec[i][int(zaehl[i])]=j
                    zaehl[i]+=1
                else:
                    pass
            else:
                pass
            
    return ec           

def dmcompress2(r,k,dm):
    # brg 14.7.2012
    # dm start matrix which may have
    # columns with 0.
    # For example, because by default a matrix with 10 columns was defined
    # bu the only six columns are filled.
    # then this routine keeps the order of nontrivial coolumsn but now
    # in a matrix of only six columns.

    # step 1: elimcol inciates the nontrivial columns
    # If for example in dm col1 is filled, col 2 not, col3 filled, col 4
    #... filled , col 5 not filled (i.e. only with 0) col6 not filled, col 7 filled
    # ...col 8 filled, col 9 not filled, col 10 filled, then elimcol = [*,2,*,*,5,6,*,*,9,*]
    # and dmreduced: col1 = old col1, col2 = old col3, etc.
    # I decided that the stars indicate the columns to be kept.
    # Note: if negative values are possible as entries for dm then dmcompress2 should not be used.
    # Reason: test for all entries of a col = 0 by checking their sum.
    # return: dmreduced , elimcol, celicol
    
    elimcol=vecgen1(k)
    for j in range(0,k):
        elimcol[j]="*"
        
    for j in range(0,k):
        sumtest=0
        for i in range(0,r):
            sumtest+=dm[i][j]
        if sumtest==0.0:
            elimcol[j]=j

    # step 2
    # how many nontrivial columns (needed to prepare a corresponding field
    #matout(r,k,dm)

    celicol=0
    for j in range(0,k):
        if elimcol[j]=="*":
            celicol+=1


    print "celicol= ",celicol

    dmreduced=marray(r,celicol)

    # step 3 generating the compressed "reduced" matrix
    zahl=0
    for j in range(0,k):
        if elimcol[j]=="*":
            for i in range(0,r):
                dmreduced[i][zahl]=dm[i][j]
            zahl+=1

    return dmreduced, elimcol, celicol



def eqcout(r,ec,obj):
    """Python-Shell print of equivalent objects"""
    # Brg 21.11.07
    #*21.11.07
    #akt21.11.07
    #note:-
    #source:-
    # cooperates with dmcompress
    # just a more or less comfortable output of equivalent objects
    # ... based on a data matrix
    # matc8.py is the corresponding testprogram
    
    txt=[""]
    for i in range(0,r):
        txt.append(str(i))

    for i in range(0,r):
        flag=0
        for j in range(0,r):
            if ec[i][j]!=-1:
                flag=1
            
        if str(i) in txt and flag==1:
            print "object ",obj[i]," :",
            for j in range(0,r):
                if ec[i][j]!=-1:
                    print obj[ec[i][j]]," ",
                txt[ec[i][j]+1]="*"
            print " "    
                           
def eqcguiout(r,ec,obj):
    """Python-Shell print of equivalent objects"""
    # Brg 21.11.07, 9.12.07, 17.2.2013
    #*21.11.07
    #akt9.12.07, 17.2.2013
    #note:-
    #source:-
    # cooperates with dmcompress
    # just a more or less comfortable output of equivalent objects
    # ... based on a data matrix
    # 
    # matc9.py is the corresponding variant suitable for GUI
    # matc10.py is the wrapping program in GUI
    # wenn EXCELreadin3 verwendet wird ist obj[0] immer ein beliebiger
    # string. D.h. obj[1] ist die row 0 der DM
    txt=[""]
    for i in range(0,r):
        txt.append(str(i))

    
    text="\n"
    for i in range(0,r):
        flag=0
        for j in range(0,r):
            if ec[i][j]!=-1:
                flag=1
            
        if str(i) in txt and flag==1:
            text+="object "+str(obj[i])+" :"    #30.11.07 evtl: obj[i+1] etc, changed (str) 17.2.2013, 30.11.2015
            for j in range(0,r):
                if ec[i][j]!=-1:
                    text+=str(obj[ec[i][j]])+" "  #30.11.2015
                    txt[ec[i][j]+1]="*"
            text+="\n"    
    return text

def eqcguiout1(r,ec,obj):
    """ Equivalent objects"""
    # Brg 21.11.07, 7.12.07, 17.2.2013
    #*21.11.07
    #akt7.12.07, 17.2.2013
    #note: needs ec from dmcompress
    #source:-
    # The same as eqcguiout, but now obj[0] is the object name of row 0
    # obj[1] is the object name of row 1 , etc.
    # That means a recoding of the object vector has been performed in the calling
    # program.
    # cooperates with dmcompress
    
    # 
    txt=[]    #8.12.07
    for i in range(0,r):
        txt.append(str(i))
    #print "in eg1 obj ",obj
    #print "test in eqcguiout1 (eg1)"
    #matout(r,r,ec)
    text="\n"
    for i in range(0,r):
        flag=0
        for j in range(0,r):
            if ec[i][j]!=-1:
                flag=1           #that means there is an equivalent matrix row
            
        if str(i) in txt and flag==1:
            text+="object "+str(obj[i])+" :"  # 17.2.2013 str  
            for j in range(0,r):
                if ec[i][j]!=-1:
                    text+=str(obj[ec[i][j]])+" "   #17.2.2013
                    txt[ec[i][j]]="*"      #8.12. in den if Block
            text+="\n"
            #print " in eg1 ",i," txt = ",txt
    #print "in eg1  ",text
    return text


def eqcguiout2(r,ec,obj):
    """ Equivalent objects"""
    # Brg 21.11.07, 7.12.07, 17.2.2013, 16.7.2013
    #*21.11.07
    #akt7.12.07, 17.2.2013, 16.7.2013
    #note: needs ec from dmcompress
    #source:-
    # The same as eqcguiout, but now obj[0] is the object name of row 0
    # obj[1] is the object name of row 1 , etc.
    # That means a recoding of the object vector has been performed in the calling
    # program.
    # cooperates with dmcompress
    # difference to version 1: as result also the comparabilities due to equivalences 
    
    # 
    txt=[]    #8.12.07
    for i in range(0,r):
        txt.append(str(i))
    #print "in eg1 obj ",obj
    #print "test in eqcguiout1 (eg1)"
    #matout(r,r,ec)
    text="\n"
    Ksum=0
    for i in range(0,r):
        flag=0
        for j in range(0,r):
            if ec[i][j]!=-1:
                flag=1           #that means there is an equivalent matrix row
                Ksum+=1
        if str(i) in txt and flag==1:
            text+="object "+str(obj[i])+" :"  # 17.2.2013 str  
            for j in range(0,r):
                if ec[i][j]!=-1:
                    text+=str(obj[ec[i][j]])+" "   #17.2.2013
                    txt[ec[i][j]]="*"      #8.12. in den if Block
            text+="\n"
            #print " in eg1 ",i," txt = ",txt
    #print "in eg1  ",text
    print "Ksum= ",Ksum        
    return text,Ksum


def identifycolrows(r,ec):
    """from a matrix: identifies the rows to be eliminated"""
    # Brg 20.11.07, 12.4.08, 13.4.08, 06.5.08
    #*20.11.07
    #akt: 06.05.08
    #note: mainly important in fuzzy analysis
    #source: see dmcompress (input), matrixrowdel,matrixcoldel use 'txt'
    #r : rows
    #ec: a matrix as a result of dmcompress: each row i contains the rows-numbers...
    #    ... which can be eliminated
    # see explanation in dmcompress
##    print "==================================="
##    print "  control in identifycolrows (icr) "
##    print "==================================="
    lec=vecgen1(r)
    txt2=[]  #13.4.08
    for i in range(0,r):
        for j in range(0,r):  
            if ec[i][j]!=-1:
                lec[i]+=1      #lec[i]+1: number of elements unequal -1 in ec[i]
    #print "icr1 : lec = ",lec
    #print " "
    for i in range(0,r):
        for j in range(1,r):
            if ec[i][j]!=-1:
                if str(ec[i][j]) not in txt2:
                    txt2.append(str(ec[i][j]))
    #ec has the structur: elements unequal -1 then filled up with -1
    #if an equivalence class has only two elements then ec has just the
    #alternative as a first element in the corresponding row.
    #the j loop starts with j=1 ...
    # therefore typically eq.classes with only two elements could be overseen
##    print "icr2: txt2 unmittelbar nach der Haupt-Doppelschleide"
##    print "icr2: ",txt2 
    escape=0
    i=0
    while i<r:
        if lec[i]==1:
            txt2.append(str(i))
            i+=2
        else:
            i+=1
                
        escape+=1
        if escape>r:
            break
    
        
        
        
          
    #print "icr3: txt2= ",txt2
    #print "  "
    ltext=len(txt2)
    #print "icr4: ltext = ",ltext
    if ltext>r:
        print "+++warning++++"
    #print "icr5: txt ",txt2
    #print " "
    return txt2                   
    
def irc_kept(r,ec):
    """ from a matrix: identifies the rows to be kept """
    #Brg  6.5.08
    # *: 6.5.08
    # akt: 6.5.08
    # note: if successfully tested, replaces identifycolrows
    # source: -
    otxt2=""
    otxt1=""
    for i in range(0,r):
        if str(i) not in otxt1:
            otxt2+=str(i) 
            for j in range(0,r):
                if ec[i][j]!=-1:
                    otxt1+=str(ec[i][j])
    
    return otxt2

def irc_elim(r,ec):
    """ from a matrix: identifies the rows to be eliminated"""
    #Brg  6.5.08, 7.5.08
    # *: 6.5.08
    # akt: 7.5.08
    # note: if successfully tested, replaces identifycolrows
    # source: irc
    otxt2=[]
    otxt1=[]
    for i in range(0,r):
        if str(i) not in otxt1:
            #print "i = ",i," not in otxt1  ",otxt1
            #print "  "
            otxt2.append(str(i)) 
            for j in range(0,r):
                if ec[i][j]!=-1:
                    otxt1.append(str(ec[i][j]))
    ltxt2=len(otxt2)
    #print "in irc_elim otxt2: ",otxt2
    txtintern=vecgentext1(r)
    for i in range(0,r):
        txtintern[i]=str(i)

    txt3=vecgentext1(r-ltxt2)
    j=0
    for i in range(0,r):
        if txtintern[i] not in otxt2:
            txt3[j]=txtintern[i]
            j+=1

    return txt3



    
def matrixcoldel(txt,r,k,a):
    """columns of matrx a are deleted corresp to txt & a new matrix 'an' is generated"""
    #brg 18.11.07, 19.11.07, 30.11.07
    #*18.11.07
    #akt:30.11.07
    #note: see matrixrowdel
    #source:-
    # a is the input matrix
    # txt is a string vector , containing the identifier
    # of the columns which are to be erased
    # r the number of rows (which is invariant)
    # k the number of columns of a (which will be changed when an is generated)
    # For example txt=["","0","3"," "] the first and fourth matrixcolumns are
    # disregarded. Correspondingly the new matrix an contains only the other columns of a
    # see explanation in dmcompress
    tdel=[" "]
    ldel=len(txt)
    print "in mcd : txt ",txt
    print "in mcd:ldel ",ldel
    #print "in mcd matout of a"
    #matout(r,k,a)
    b=recogempty(txt,ldel)
    if b=="true":
        ldel=0
        an=marray(r,k)                   #30.11.07
        for i in range(0,r):
            for j in range(0,k):
                an[i][j]=a[i][j]
    else:             
            
        for i in range(0,k):
            if i<ldel:
                tdel.append(txt[i])
            else:
                tdel.append("")
        #print "in mcd: tdel ",tdel        
        an=marray(r,k-ldel)
        
        for i in range(0,r):
            j1=0
            for j in range(0,k):
                if str(j) in tdel:
                    pass
                else:
                    an[i][j1]=a[i][j]
                    
                    #print "j =",j," j1 = ",j1
                    j1+=1
           
        #print "in mcd matout of an "
        #matout(r,k-ldel,an)    
    return an,ldel


def matrixrowdel(txt,r,k,a):
    """columns of matrx a are deleted corresp. to txt & a new matrix an is generated"""
    #brg 18.11.07
    #*18.11.07
    #akt18.11.07
    #note: see also matrixcoldel
    #source:-
    # a is the input matrix
    # txt is a string vector , containing the identifier
    # of the rows which are to be erased
    # r the number of rows (which will be changed)
    # k the number of columns of a (which is invariant)
    # For example txt=["","0","3"," "] the first and fourth matrixrows are
    # eliminated. Correspondingly the new matrix 'an' contains only the other rows of a
    # see explanation in dmcompress
    tdel=[" "]
    ldel=len(txt)
    #print "in mrd: txt ",txt
    #print "In mrd: ldel ",ldel
    for i in range(0,r):      #30.11.07 muss es hier nicht r heissen??
                              # Ich setzte versuchsweise r
                              # scheint in der Tat der Fehler gewesen zu sein
        if i<ldel:
            tdel.append(txt[i])
        else:
            tdel.append("")
    #print "in mrd :tdel ",tdel
    #print "in mrd eingabe matrix "
    #matout(r,k,a)
    b=recogempty(txt,ldel)
    if b=="true":
        ldel=0
        an=marray(r,k)                   #30.11.07
        for i in range(0,r):
            for j in range(0,k):
                an[i][j]=a[i][j]
    else:            
        an=marray(r-ldel,k)
        i1=0
        for i in range(0,r):
            if str(i) in tdel:
                pass
            else:
                for j in range(0,k):
                    #print "i1 = ",i1,"  i = ",i,"   j = ",j  
                    an[i1][j]=a[i][j]  #30.11.07 error-meldg
                        
                i1+=1      
               
        #print "in mrd : ergebnis matrix "
        
        #matout(r-ldel,k,an)
        #print "in mrd ldel ganz unten  ",ldel
        
    return an,ldel

def matrixrowdel1(del_nr,r,k,a):
    """ eliminates from matrix a the row with number 'del-nr'"""
    # brg 28.2.2013
    # del_nr: number whose row in matrix a is to be deleted
    # r: number of original rows
    # k: number of columns
    # a: matrix
    zahl=0
    an=marray(r-1,k)
    for i in range(0,r):
        if i!=del_nr:
            for j in range(0,k):
                an[zahl][j]=a[i][j]
            zahl+=1
        else:
            pass
    return an    

def matrixcoldel1(del_nr,r,k,a):
    """ eliminates from matrix a the column with number 'del_nr'"""
    # Brg 28.2.2013
    # del_nr: this column is to be eliminated from matrix a
    # r: number of rows
    # k: number of columns in the original matrix a
    # output: new matrix with one column eliminated
    zahl=0
    an=marray(r,k-1)
    for i in range(0,r):
        zahl=0
        for j in range(0,k):
            if j!=del_nr:
                an[i][zahl]=a[i][j]
                zahl+=1
            else:
                pass
    return an       





def recogempty(vec,n):
    """ a string vector may have n components , however all are empty"""
    # brg 30.11.07
    #*30.11.07
    #akt30.11.07
    #note:-
    #source:-
    t1=""
    t2=" "
    booltest="false"
    flag=0
    for i in range(0,n):
        if t1==vec[i] or t2==vec[i]:
            flag+=1
    if flag==n:
        booltest="true"
    return booltest    

def pattrecog(nobj,rows,obj,a,jact):
    """ which object has a pattern like a[i] """
    #  brg 4.12.07
    #*4.12.07
    #akt4.12.07
    #note:-
    #source:-
    # nobj: length of the object list (taken from an EXCEL file ...
    # .... including a dummy string in the 0,0 position
    # rows number of rows of the data matrix
    # obj is a list, starting with obj[0] a dummy string, obj[1] the object ...
    # ...belonging to the first row, etc.
    # a is the matrix (without object and property names
    # jact  which actual row?
    # txt includes pattern and the objects with that pattern
    # Note this version accepts equivalence relations, i.e. objects with the same
    #... matrix row
    pattern={}
    for i in range(1,nobj):
        pattern[obj[i]]=a[i-1]
    txt="\n"
    txt+=str(a[jact])+":\t"
    for i in range(1,nobj):
        if pattern[obj[i]]==a[jact]:
            txt+=obj[i]+"\t"
    txt+="\n"
    return txt

def pattrecog1(nobj,rows,obj,a,jact):
    """ which object has a pattern like a[i] """
    #  brg 4.12.07, 5.12.07
    #*4.12.07
    #akt5.12.07
    #note:-
    #source:-
    # nobj: length of the object list (taken from an EXCEL file ...
    # .... including a dummy string in the 0,0 position
    # rows number of rows of the data matrix
    # obj is a list, starting with obj[0] a dummy string, obj[1] the object ...
    # ...belonging to the first row, etc.
    # a is the matrix (without object and property names
    # jact  which actual row?
    # txt includes pattern and the objects with that pattern
    # Note this version assumes a quotient set
    
    pattern={}
    for i in range(1,nobj):
        pattern[obj[i]]=a[i-1]
    txt=""
    
    for i in range(1,nobj):
        if pattern[obj[i]]==a[jact]:
            txt=obj[i]
    
    return txt

def veccopy(n,a):
    """kopiert vector mit n Komponenten  a --> b """
    # brg 5.12.07
    #*5.12.07
    #akt5.12.07
    #note:-
    #source:-
    # n: Zahl der Komponenten
    # a: zu kopierender Vektor
    b=vecgen1(n)
    for i in range(0,n):
        b[i]=a[i]
    return b    

def veccopy1(n,a):
    """kopiert vector mit n Komponenten  a --> b """
    # brg 5.12.07
    #*5.12.07
    #akt5.12.07
    #note:-
    #source:veccopy
    # n: Zahl der Komponenten
    # a: zu kopierender TextVektor
    b=vecgentext1(n)
    for i in range(0,n):
        b[i]=a[i]
    return b    



def levtopsort(n,matrix):
    """from the zeta-matrix 'matrix' the matrix levobj and
    the vectors tps, revtps are calculated
    after Patil, Taillie, 2004 """
    #brg 19.12.07, 13.1.-21.1.08, 11.4.08, 1.6.08, 4.8.08
    #*:19.12.07
    #akt: 4.8.08
    #note: zeta matrix=1 if row number less column number
    #source:topsort3.py
    #test:topsort4
    # tps: topological sort following the level population
    # revtps: reverse order of tps
    # 1.6.08 important change: tps.reverse() instead of an explicit loop
##    print "============================="
##    print " control in levtopsort (lts) "
##    print "============================="
##    print "lts1: n (=rred) ",n
    levobj=marray1(n+1,n+1,-1)  #20.1.08 statt n,n nun n+1,n+1
    zhilf=0
    tps=[]
    lx=1
    zz=0
    #print " Eingabe Matrix "
    #matout(n,n,matrix)
    #print " "
    while lx>0:     
        listhilf=[]
        for i in range(0,n):
            #print "i= ",i
            summe=0
            if i not in tps:
                for j in range(0,n):
                    #print "j = ",j," ",
                    if j not in tps:
                        summe+=matrix[i][j]
                if summe==1:
                    listhilf.append(i)
        #print "lts2: zz = ",zz,"  listhilf = ",listhilf
        levobj[zz]=listhilf
        
        lx=len(listhilf)
        #print "lts3: zz= ",zz,"  lx = ",lx," levobj = ",levobj[zz]
        zz+=1
        tps.extend(listhilf)        
        #print listhilf
          
        #print "lts4: length of listhilf ",lx
        zhilf+=1         # program safety in while
        if zhilf>=1800:   #20.1.08  26.3.10 changed from 800 to 1800
            print "Abbruch in levtopsort !!"
            break
    #print "lts5: listmax = topsort ",tps

    zzma=zz-1
    #revtps=rmod2.vecgen1
##    revtps=[]  #21.1.08 outcommented 11.4.2011
##    ltps=len(tps)
##    
##    print "lts6: length of tps  ",ltps
##    print "lts7: tps  = ",tps
##    print "lts8: n    = ",n 
##    for i in range(n-1,-1,-1):
##        #print "lts9: n = ",n,"  tps = ",tps[i]
##        revtps.append(tps[i])   # 21.1.08 vorher revtps[zaehl]=tps[i]
        
    
    ltps=len(tps)
    print "n= ", n
    print "ltps= ",ltps
    copytps=vecgen1(ltps)
    for i in range(0,ltps):
        copytps[i]=tps[i]
    tps.reverse()
    # now tps is reversed, therefore in takes the place in return where in earlier versions
    # revtps was located.
    # similar copytps, the proper tps is located in return where tps was.
    #print tps
    return levobj,copytps,tps,zzma


def levtopsortoutrk(n,matrix):
    """from the zeta-matrix 'matrix' the matrix levobj and
    the vectors tps, revtps are calculated
    after Patil, Taillie, 2004 """
    #brg 19.12.07, 13.1.-21.1.08, 11.4.08, 1.6.08, 4.8.08,11.4.2011
    #*:19.12.07
    #akt: 11.4.2011
    #note: zeta matrix=1 if row number less column number
    #source:topsort3.py
    #test:topsort4
    # tps: topological sort following the level population
    # revtps: reverse order of tps
    # 1.6.08 important change: tps.reverse() instead of an explicit loop
    # for outrk5 changer (as a test) to levtopsortoutrk
##    print "============================="
##    print " control in levtopsort (lts) "
##    print "============================="
##    print "lts1: n (=rred) ",n
    levobj=marray1(n+1,n+1,-1)  #20.1.08 statt n,n nun n+1,n+1
    zhilf=0
    tps=[]
    lx=1
    zz=0
    #print " Eingabe Matrix "
    #matout(n,n,matrix)
    #print " "
    while lx>0:     
        listhilf=[]
        for i in range(0,n):
            #print "i= ",i
            summe=0
            if i not in tps:
                for j in range(0,n):
                    #print "j = ",j," ",
                    if j not in tps:
                        summe+=matrix[i][j]
                if summe==1:
                    listhilf.append(i)
        #print "lts2: zz = ",zz,"  listhilf = ",listhilf
        levobj[zz]=listhilf
        
        lx=len(listhilf)
        #print "lts3: zz= ",zz,"  lx = ",lx," levobj = ",levobj[zz]
        zz+=1
        tps.extend(listhilf)        
        #print listhilf
          
        #print "lts4: length of listhilf ",lx
        zhilf+=1         # program safety in while
        if zhilf>=1800:   #20.1.08  26.3.10 changed from 800 to 1800
            print "Abbruch !!"
            break
    #print "lts5: listmax = topsort ",tps

    zzma=zz-1

    ltps=len(tps)
    print "n= ", n
    print "ltps= ",ltps
    copytps=vecgen1(ltps)
    for i in range(0,ltps):
        copytps[i]=tps[i]
    tps.reverse()
    # now tps is reversed, therefore it takes the place in return where in earlier versions
    # revtps was located.
    # similar copytps, the proper tps is located in return where tps was.
    #print tps
    return levobj,copytps,tps,ltps,zzma

def levtop(n,matrix):
    """from the zeta-matrix 'matrix' the matrix levobj and
    the vectors tps, revtps are calculated
    after Patil, Taillie, 2004 """
    #brg 19.12.07, 13.1.-21.1.08, 11.4.08, 1.6.08, 4.8.08,11.4.2011, 1.8.2018
    #*:19.12.07
    #akt: 1.8.2018
    #note: zeta matrix=1 if row number less column number
    
    levobj = []  #20.1.08 statt n,n nun n+1,n+1
    zhilf=0
    tps=[]
    lx=1
    zz=0
    
    while lx>0:     
        listhilf=[]
        for i in range(0,n):
            #print "i= ",i
            summe=0
            if i not in tps:
                for j in range(0,n):
                    #print "j = ",j," ",
                    if j not in tps:
                        summe+=matrix[i][j]
                if summe==1:
                    listhilf.append(i)
        if listhilf!=[]:
            levobj.append(listhilf)
        
        lx=len(listhilf)
        #print "lts3: zz= ",zz,"  lx = ",lx," levobj = ",levobj[zz]
        zz+=1
        tps.extend(listhilf)        
        #print listhilf
          
        #print "lts4: length of listhilf ",lx
        zhilf+=1         # program safety in while
        if zhilf>=1800:   #20.1.08  26.3.10 changed from 800 to 1800
            print "Abbruch !!"
            break
    #print "lts5: listmax = topsort ",tps

    zzma=zz-1

    ltps=len(tps)
    print "n= ", n
    print "ltps= ",ltps
    copytps=rmod2.vecgen1(ltps)
    for i in range(0,ltps):
        copytps[i]=tps[i]
    tps.reverse()
    return levobj,copytps,tps,zzma


def adjacent(n,tps,revtps,matrix):
    """generates the adjacency list in the correct manner"""
    #brg 19.12.07
    #*19.12.07
    #akt 19.12.07
    #note: needs levtopsort
    #source: topsort3.py
    #test: topsort4
    
    adj=marray1(n,n,-1)
    #print "Adjacency lists"
    for i in range(0,n):
        for j in range(0,n):
            if matrix[tps[i]][revtps[j]]==1:
                adj[i][j]=revtps[j]

    return adj            

    
        



def trreduct(n,adj,tps):
    """from adj and tsp (lin.extension) a matrix trr will be generated"""
    # brg 19.12.07
    #*19.12.07
    #akt19.12.07
    #note: tps is generated in levtopsort, adj is obtained from 'adjacent'
    #source:topsort3.py
    #test: topsort4
    #adj must be increasing sorted (revlext) obtained from routine adjacent
    trs=vecgentext1(n*n)  #18.8.2011 instead of n: n*n
    trr=vecgentext1(n*n)   #18.8.2011 Instead of n: n*n

    for i in range(0,n):
        v=tps[i]
        #print "v = ",v
        trs[v]=[str(v)]
        trr[v]=[]
        #print "i= ",i,"  trs =",trs[v]
        #print "i= ",i,"  trr =",trr[v]
        #print "  adj[",v,"]=",adj[i]
        for w in adj[i]:
            if w !=-1:
                #print "adj = ",adj[i]
                #print "w = ",w," ",trs[tps[i]]
                if str(w) not in trs[tps[i]]:
                    listes=trs[v]
                    lister=trr[v]
                    #print "w= ",w,"  trs= ",trs[w]
                    listes.extend(trs[w])
                    #print "w=  ",w,"  listes= ",listes
                    lister.append(str(w))
                    trs[v]=listes
                    trr[v]=lister
                    #h1=raw_input(' w-Schleife ')        
        #print "trsextended",trs[tps[i]]
        #print "trrextended",trr[tps[i]]
        
        #h2=raw_input(' v-Schleife ')             
    return  trs,trr    

def trreduct2(n,adj,tps,dimt):
    """from adj and tsp (lin.extension) a matrix trr will be generated"""
    # brg 19.12.07, 12.7.2012
    #*19.12.07
    #akt12.7.2012
    #note: tps is generated in levtopsort, adj is obtained from 'adjacent'
    # dimt a value between n or n*n to organize the fields trs and trr
    
    #source:topsort3.py
    #test: topsort4
    #adj must be increasing sorted (revlext) obtained from routine adjacent
    trs=vecgentext1(dimt)  #12.7.2012 instead of n*n
    trr=vecgentext1(dimt)   #12.7.2012 Instead of n*n

    for i in range(0,n):
        v=tps[i]
        #print "v = ",v
        trs[v]=[str(v)]
        trr[v]=[]
        #print "i= ",i,"  trs =",trs[v]
        #print "i= ",i,"  trr =",trr[v]
        #print "  adj[",v,"]=",adj[i]
        for w in adj[i]:
            if w !=-1:
                #print "adj = ",adj[i]
                #print "w = ",w," ",trs[tps[i]]
                if str(w) not in trs[tps[i]]:
                    listes=trs[v]
                    lister=trr[v]
                    #print "w= ",w,"  trs= ",trs[w]
                    listes.extend(trs[w])
                    #print "w=  ",w,"  listes= ",listes
                    lister.append(str(w))
                    trs[v]=listes
                    trr[v]=lister
                    #h1=raw_input(' w-Schleife ')        
        #print "trsextended",trs[tps[i]]
        #print "trrextended",trr[tps[i]]
        
        #h2=raw_input(' v-Schleife ')             
    return  trs,trr    

def trred(n,ad):
    #brg 18.8.2011
    #ad: zeta matrix: row >= column
    # ++++ this procedure needs the zetaq matrix (procedure comp)
    # then the direct analysis to get the HD with help of cover-matrix
    # return: cover matrix
    # applications in HDweight2 and in HDalter2
    # trreducti and adjacent - procedures seem to be get out of memory when large dms are
    # considered. (16.7.2012)
    covh=marray(n,n)
    for i in range(0,n):
        for j in range(0,n):
            covh[i][j]=ad[i][j]
    for i in range(0,n):
        for j in range(0,n):
            if i!=j:
                for k in range(0,n):
                    if j!=k:
                    
                        testsum=ad[i][j]+ad[j][k]
                        if testsum>ad[i][k]:
                            covh[i][k]=0
    return covh            



def cover(n,trr,tps):
    """ from trr the cover matrix is generated """
    #brg 19.12.07
    #*19.12.07
    #akt 19.12.07
    #note: trr is generated by trreduct
    #source: topsort3
    #test: topsort4
    # Covermatrix
    cov=marray(n,n)
    ltps=vecgen1(n)

    for i in range(0,n):
        ltps[i]=len(trr[tps[i]])
        #print "ltps = ",ltps[i],"  tps ",tps[i]
        for j in range(0,ltps[i]):
            #print "trr tps  ",j,"  = ",trr[tps[i]][j]
            o=int(trr[tps[i]][j])
            #print "i = ",i,"  j= ",j,"  o = ",o
            cov[tps[i]][o]=1
    return cov

def equivcompactold(r,k,x,obj):
    """calculates the dm of the quotient set and gives a list of equivalence classes"""
    #Brg21.12.07,20.6.08, 17.3.09
    #*21.12.07
    #akt20.6.08
    #note: the object list should not contain '*' as identifier for objects
    #      comparison up to the 4th position after decimal point
    #source:-
    #r rows
    #k columns
    for i in range(0,r):
        for j in range(0,k):
            x[i][j]=round(x[i][j],4)

    obh=[] #obj should be not changed during this procedure, hence obh
    for i in range(0,r):
        obh.append(obj[i])
        
    neq=vecgen1(r)
    jneq=0
    extralist=""
    for i in range(0,r):
        if obh[i] not in extralist and obh[i]!="*":
            extralist+="\n"+obh[i]+": "
            neq[i]+=1
        for j in range(i+1,r):
            if x[j]==x[i] and obh[i]!="*":
                extralist+=obh[j]+","
                neq[i]+=1
                obh[j]="*" # this is the crucial line
                
        #extralist+="\n"

    xred=[]
    objred=[]
    iz=0
    for i in range(0,r):
        if obh[i]!="*":
            objred.append(obh[i])
            xred.append(x[i])
            iz+=1

    rred=iz
    
    return rred,xred,objred,extralist

def equivcompact(r,k,x,obj):
    """calculates the dm of the quotient set and gives a list of equivalence classes"""
    #Brg21.12.07,20.6.08,1.6.09
    #*21.12.07
    #akt1.6.09
    #note: the object list should not contain '*' as identifier for objects
    #      comparison up to the 4th position after decimal point
    #      to protect obj for being overwritten, objh is introduced
    #      objh is at the beginning = obj, but may get some "*"
    #source:-
    #x  data matrix with reell numbers 
    #r rows
    #k columns
    for i in range(0,r):
        for j in range(0,k):
            x[i][j]=round(x[i][j],4)

    objh=vecgentext1(r)
    for i in range(0,r):
        objh[i]=obj[i]

    neq=vecgen1(r)
    jneq=0
    extralist=""
    for i in range(0,r):
        if objh[i] not in extralist and objh[i]!="*":
            extralist+="\n"+objh[i]+": "
            neq[i]+=1
        for j in range(i+1,r):
            if x[j]==x[i] and objh[i]!="*":
                extralist+=objh[j]+","
                neq[i]+=1
                objh[j]="*"
                
        #extralist+="\n"

    xred=[]
    objred=[]
    iz=0
    for i in range(0,r):
        if objh[i]!="*":
            objred.append(objh[i])
            xred.append(x[i])
            iz+=1

    rred=iz
    
    return rred,xred,objred,extralist

def equivcompactgr(r,k,x,obj):
    """calculates the dm of the quotient set and gives a list of equivalence classes"""
    #Brg21.12.07,20.6.08,1.6.09,4.4.2011, 1.6.2012
    #*21.12.07
    #akt4.4.2011, 1.6.2012
    #note: the object list should not contain '*' as identifier for objects
    #      comparison up to the 4th position after decimal point
    #      to protect obj for being overwritten, objh is introduced
    #      objh is at the beginning = obj, but may get some "*"
    #source:equivcompact
    # equivalences are stored in a matrix eqm
    #x  data matrix with real numbers 
    #r rows
    #k columns
    for i in range(0,r):
        for j in range(0,k):
            x[i][j]=round(float(x[i][j]),4)

    #eqm[i]8j]=1 if obj i is equivalent to object j
    eqm=marray(r,r)
    for i in range(0,r):
        for j in range(0,r):
            if x[i]==x[j]:
                eqm[i][j]=1

    objh=vecgentext1(r)
    for i in range(0,r):
        objh[i]=obj[i]

    neq=vecgen1(r)
    jneq=0
    extralist=""
    for i in range(0,r):
        if objh[i] not in extralist and objh[i]!="*":
            extralist+="\n"+objh[i]+": "
            neq[i]+=1
        for j in range(i+1,r):
            if x[j]==x[i] and objh[i]!="*":
                extralist+=objh[j]+","
                neq[i]+=1
                objh[j]="*"
                
        #extralist+="\n"

    xred=[]
    objred=[]
    iz=0
    for i in range(0,r):
        if objh[i]!="*":
            objred.append(objh[i])
            xred.append(x[i])
            iz+=1

    rred=iz
    
    return rred,xred,objred,extralist,eqm


def equivcompactgr1(r,k,x,obj):
    """calculates the dm of the quotient set and gives a list of equivalence classes"""
    #Brg21.12.07,20.6.08,1.6.09,4.4.2011, 1.6.2012, 7.11.2014
    #*21.12.07
    #akt4.4.2011, 1.6.2012, 7.11.2014,8.11.2014
    #note: the object list should not contain '*' as identifier for objects
    #      comparison up to the 4th position after decimal point
    #      to protect obj for being overwritten, objh is introduced
    #      objh is at the beginning = obj, but may get some "*"
    #source:equivcompact
    # equivalences are stored in a matrix eqm
    #x  data matrix with real numbers 
    #r rows
    #k columns
    for i in range(0,r):
        for j in range(0,k):
            x[i][j]=round(x[i][j],4)

    #eqm[i]8j]=1 if obj i is equivalent to object j
    eqm=marray(r,r)
    for i1 in range(0,r):
        for i2 in range(0,r):
            flag = 0
            for j in range(0, k):
                if x[i1][j]==x[i2][j]:
                    flag += 1
            if flag == k:    
                eqm[i1][i2] = 1

    objh=vecgentext1(r)
    for i in range(0,r):
        objh[i]=obj[i]

    extralist=""
    for i1 in range(0,r):
        if objh[i1] not in extralist and objh[i1]!="*":
            extralist+="\n"+objh[i1]+": "
        for i2 in range(i1+1,r):
            flag = 0
            for j in range(0, k):
                if x[i2][j]==x[i1][j]:
                    flag +=1
            if flag == k and objh[i1]!="*":
                extralist+=objh[i2]+","
                objh[i2]="*"
                
        #extralist+="\n"
    xred=[]
    objred=[]
    iz=0
    for i in range(0,r):
        if objh[i]!="*":
            objred.append(objh[i])
            xred.append(x[i])
            iz+=1

    rred=iz
    
    return rred,xred,objred,extralist,eqm

##def equivcompactgr2(r,k,x,obj):
##    """calculates the dm of the quotient set and gives a list of equivalence classes"""
##    #Brg21.12.07,20.6.08,1.6.09,4.4.2011, 1.6.2012, 7.11.2014
##    #*21.12.07
##    #akt4.4.2011, 1.6.2012, 7.11.2014
##    #note: the object list should not contain '*' as identifier for objects
##    #      comparison up to the 4th position after decimal point
##    #      to protect obj for being overwritten, objh is introduced
##    #      objh is at the beginning = obj, but may get some "*"
##    #source:equivcompact
##    # equivalences are stored in a matrix eqm
##    #x  data matrix with real numbers 
##    #r rows
##    #k columns
##    for i in range(0,r):
##        for j in range(0,k):
##            x[i][j]=round(x[i][j],4)
##
##    #eqm[i]8j]=1 if obj i is equivalent to object j
##    eqm=marray(r,r)
##    for i1 in range(0,r):
##        for i2 in range(0,r):
##            flag = 0
##            for j in range(0, k):
##                if x[i1][j]==x[i2][j]:
##                    flag+=1
##                if flag==k:    
##                    eqm[i1][i2] = 1
##
##    objh=vecgentext1(r)
##    for i in range(0,r):
##        objh[i]=obj[i]
##
##    neq=vecgen1(r)
##    jneq=0
##    extralist=""
##    for i1 in range(0,r):
##        if objh[i1] not in extralist and objh[i1]!="*":
##            extralist+="\n"+objh[i1]+": "
##            neq[i1]+=1
##        for i2 in range(0, r):  # instead of i2 in range(i1+1,r)
##            flag = 0
##            for j in range(0, k):
##                if x[i2][j]==x[i1][j]:
##                    flag +=1
##                if flag == k and objh[i1]!="*":
##                    extralist+=objh[i2]+","
##                    neq[i1]+=1
##                    objh[i2]="*"
##                
##        #extralist+="\n"
##
##    xred=[]
##    objred=[]
##    iz=0
##    for i in range(0,r):
##        if objh[i]!="*":
##            objred.append(objh[i])
##            xred.append(x[i])
##            iz+=1
##
##    rred=iz
##    
##    return rred,xred,objred,extralist,eqm

def equivcompactgr3(r,k,x):
    """calculates the dm of the quotient set and gives a list of equivalence classes"""
    #Brg21.12.07,20.6.08,1.6.09,4.4.2011, 1.6.2012, 7.11.2014, 9.11.2014
    #*21.12.07
    #akt4.4.2011, 1.6.2012, 7.11.2014
    #note: the object list should not contain '*' as identifier for objects
    #      comparison up to the 4th position after decimal point
    #      to protect obj for being overwritten, objh is introduced
    #      objh is at the beginning = obj, but may get some "*"
    #source:equivcompact
    # equivalences are stored in a matrix eqm
    #x  data matrix with real numbers 
    #r rows
    #k columns
    for i in range(0,r):
        for j in range(0,k):
            x[i][j]=round(x[i][j],4)

    #eqm[i]8j]=1 if obj i is equivalent to object j
    eqm = marray(r,r)
    for i1 in range(0,r):
        for i2 in range(0,r):
            flag = 0
            for j in range(0, k):
                if x[i1][j]==x[i2][j]:
                    flag+=1
                if flag==k:    
                    eqm[i1][i2] = 1

    return eqm

def equivcompactMarch18(r,k,x,obj):
    """calculates the dm of the quotient set and gives a list of equivalence classes"""
    #Brg 21.12.07, 20.6.08, 1.6.09, 24.03.18
    #*21.12.07
    #akt 24.03.18
    #note: the object list should not contain '*' as identifier for objects
    #      comparison up to the 4th position after decimal point
    #      to protect obj for being overwritten, objh is introduced
    #      objh is at the beginning = obj, but may get some "*"
    #source:-
    #x  data matrix with reell numbers 
    #r rows
    #k columns
    for i in range(0,r):
        for j in range(0,k):
            x[i][j]=round(x[i][j],4)

    objh=vecgentext1(r)
    for i in range(0,r):
        objh[i]=obj[i]

    neq=vecgen1(r)
    jneq=0
    extralist="\n"
    for i in range(0,r):
        if objh[i] not in extralist and objh[i]!="*":
            extralist+=objh[i]+": "
            neq[i]+=1
        for j in range(i+1,r):
            if x[j]==x[i] and objh[i]!="*":
                extralist+=objh[j]+","
                neq[i]+=1
                objh[j]="*"
                
        extralist+="::"

    xred=[]
    objred=[]
    iz=0
    for i in range(0,r):
        if objh[i]!="*":
            objred.append(objh[i])
            xred.append(x[i])
            iz+=1

    rred=iz
    
    return rred,xred,objred,extralist


def deliver_readable_eqclasses(r, eqm, obj):
    # brg 9.11.2014
    helplist = []
    eqcl1 = []
    #initialisation
    for i1 in range(0,r):
        eqcl1.append(0)
        eqcl1[i1]= []
        if obj[i1] in helplist:
            print obj[i1],"  obj is in helplist"
            pass
        else:
            for i2 in range(0,r):
                if eqm[i1][i2]==1:
                    helplist.append(obj[i2])
                    eqcl1[i1].append(obj[i2])
    # refinement
    eqcl=[]
    zaehl=0
    for i1 in range(0, len(eqcl1)):
        if len(eqcl1[i1])==0:
            pass
        else:
            eqcl.append(0)
            eqcl[zaehl]=[]
            
            for i2 in range(0, len(eqcl1[i1])):
                eqcl[zaehl].append(eqcl1[i1][i2])
            zaehl+=1
    rred = zaehl        
    reducedlist = []
    for i in range(0, rred):
        reducedlist.append(eqcl[i][0])
    return eqcl, reducedlist, rred

def calc_reduceddm(r,k,dm,obj,objred):
    # brg 9.11.2014
    zaehl=0
    xred=[]
    for i in range(0,r):
        if obj[i] in objred:
            xred.append(0)
            xred[zaehl]=[]
            for j in range (0,k):
                xred[zaehl].append(dm[i][j])
            zaehl+=1
    return xred        
            
        

def generate_equivalenceclasses(r,k,x,ndec=4):
    """calculates the dm of the quotient set

    And gives a list of equivalence classes

    adapted for the new PyHasse-core

    :var r:  number of rows (i.e. of objects)
    :var k: number of columns (i.e. of attributes)
    :var eqm: an irregular 2-dim field, i.e. lists
                of different length within a list
    :var already_visited: list of visited object
                           indices in the i2-loop
    :var hilf: list generated for any i1 not already visited
    """
    eqm = []

    for i in range(0, r):
       for j in range(0, k):
           x[i][j] = round(x[i][j],4)
    # the proper block to calculate equivalence classes
    # idea: objects (their indices) already visited in the
    # second loop will no more visited by the first loop

    already_visited = []
    for i1 in range(0, r):
        if i1 not in already_visited:
            helplist = []
            helplist.append(i1)
            for i2 in range(i1+1, r):
                if x[i1] == x[i2]:
                    helplist.append(i2)
                    already_visited.append(i2)
            eqm.append(helplist)
        rred = len(eqm)
    return eqm, rred

def find_representative_elements(eqm):
    """ given eqm of the method 'generate_equivalence_classes'

    representative elements are selcted.

    :var x: list of lists. The sublists may have different lengths
    :var reqm: length of list eqm

    """
    reducedlist = []
    reqm = len(eqm)
    for i1 in range(0, reqm):
        reducedlist.append(eqm[i1][0])
    return self.reducedlist


def strequivcompact(r,k,x,obj):
    """calculates the dm of the quotient set and gives a list of equivalence classes"""
    #Brg21.12.07,20.6.08,1.6.09, 10.8.10
    #*21.12.07
    #akt10.8.09
    #note: the object list should not contain '*' as identifier for objects
    #      comparison up to the 4th position after decimal point
    #      to protect obj for being overwritten, objh is introduced
    #      objh is at the beginning = obj, but may get some "*"
    #source:-
    #r rows
    #k columns
    #x contains string-type information
    objh=vecgentext1(r)
    for i in range(0,r):
        objh[i]=obj[i]

    neq=vecgen1(r)
    jneq=0
    extralist=[]
    for i in range(0,r):
        hili=""
        if objh[i] not in extralist and objh[i]!="*":
            hili+=str(objh[i])
            neq[i]+=1
            
        for j in range(i+1,r):
            
            if x[j]==x[i] and objh[i]!="*":
                hili+=","+str(objh[j])
                neq[i]+=1
                objh[j]="*"
        extralist.append(hili)
        
        #extralist+="\n"

    xred=[]
    objred=[]
    iz=0
    for i in range(0,r):
        if objh[i]!="*":
            objred.append(objh[i])
            xred.append(x[i])
            iz+=1

    rred=iz
    
    return rred,xred,objred,extralist

def equivect(r,x,obj):
    """calculates the quotient set and a list of equivalence classes on basis of the vector x
    the difference to equivcompactgr is that the input x is a  v e c t o r"""
    #Brg21.12.07,20.6.08,1.6.09,4.4.2011, 1.6.2012, 15.11.2013
    #*21.12.07
    #akt4.4.2011, 1.6.2012, 15.11.2013
    #note: the object list should not contain '*' as identifier for objects
    #      comparison up to the 6th position after decimal point
    #      to protect obj for being overwritten, objh is introduced
    #      objh is at the beginning = obj, but may get some "*"
    #source:equivcompact
    # equivalences are stored in a matrix eqm
    #x  data matrix with reell numbers 
    #r rows
    # output: xred (a vector!!), objred and eqm (the matrix describing the equivalences)
    
    for i in range(0,r):
        x[i]=round(x[i],6)

    eqm=marray(r,r)
    for i in range(0,r):
        for i1 in range(0,r):
            if x[i]==x[i1]:
                eqm[i][i1]=1

    objh=vecgentext1(r)
    for i in range(0,r):
        objh[i]=obj[i]

    neq=vecgen1(r)
    jneq=0
    extralist=""
    for i in range(0,r):
        if objh[i] not in extralist and objh[i]!="*":
            extralist+="\n"+objh[i]+": "
            neq[i]+=1
        for i1 in range(i+1,r):
            if x[i1]==x[i] and objh[i]!="*":
                extralist+=objh[i1]+","
                neq[i]+=1
                objh[i1]="*"
                
    xred=[]
    objred=[]
    iz=0
    for i in range(0,r):
        if objh[i]!="*":
            objred.append(objh[i])
            xred.append(x[i])
            iz+=1

    rred=iz
    
    return xred,objred,eqm


def readstrequivcompact(x):
    """ specific read routine of strequivcompact
    x is the extralist as outcome of strequivcompact.
    Output is a list, whose components have lists of variable length """
    # Brg  10.8.10
    # x is a list which looks like ['0','1,3','2,4,5','6','']
    # Output looks like [['0'],['1','3'],['2','4','5'],['6']].
    # Application example: equivausw6.py
    lx=len(x)
    xneu=[]
    for i in range(0,lx):
        xneu.append(x[i].split(','))
    return xneu,lx    

##def equivcompactm1(r,k,x,obj): 4.8.2011 rechnet falsch!!!!
##    """calculates the dm of the quotient set and gives a list of equivalence classes"""
##    #Brg21.12.07,20.6.08, 2.7.08, 14.10.08, 17.3.09, 12.4.2011
##    #*21.12.07
##    #akt 12.4.2011
##    #note: the object list should not contain '*' as identifier for objects
##    #      the comparison of real values: up to the fourth position after dec.point
##    # difference to equivcompact: return...neq
##    #source:equivcompact
##    #r rows
##    #k columns
##    # obj will be overwritten. Therefore copy obj in objtemp
##    #print "Obj in equivcompactm  ",obj
##    objtemp=vecgen1(r)
##    for i in range(0,r):
##        objtemp[i]=obj[i]
##    #########################################    
##    neq=vecgen1(r)
##    jneq=0
##    extralist=""
##    #zaehl=0                 # zu testzwecken 2.7.08
##    for i in range(0,r):
##        for j in range(0,k):
##            x[i][j]=round(x[i][j],4)
##    for i in range(0,r):
##        if objtemp[i] not in extralist and objtemp[i]!="*":  #obj --> objtemp
##            extralist+="}{"+objtemp[i]+": "   #obj --> objtemp 14.10.08 \n raus
##            neq[i]+=1
##        for j in range(i+1,r):
##            #print "x[i], x[j] ",x[i],"  ",x[j]
##            flag=1
##            for iprop in range(0,k):  #12.4.2011
##                if x[j][iprop]==x[i][iprop]:
##                    flag=1
##                else:
##                    flag=0
##            if flag==1 and objtemp[i]!="*":    
##                extralist+=objtemp[j]+","
##                neq[i]+=1
##                objtemp[j]="*"
##            else:
##                pass
##            
##               
##        #extralist+="\n"
##
##    xred=[]
##    objred=[]
##    iz=0
##    for i in range(0,r):
##        if objtemp[i]!="*": #14.10.08 
##            objred.append(objtemp[i])  #14.10.08
##            xred.append(x[i])
##            iz+=1
##
##    rred=iz
##    #print neq
##    return rred,xred,objred,extralist,neq       

def equivcompactm(r,k,x,obj):
    """calculates the dm of the quotient set and gives a list of equivalence classes"""
    #Brg21.12.07,20.6.08, 2.7.08, 14.10.08, 17.3.09, 12.4.2011(reconstructed)
    #*21.12.07
    #akt 12.4.2011 II
    #note: the object list should not contain '*' as identifier for objects
    #      the comparison of real values: up to the fourth position after dec.point
    # difference to equivcompact: return...neq
    # a trial to improve this routine is in equivcompactm1, which however is
    # up to now (12.4.2011) not working
    #source:equivcompact
    #r rows
    #k columns
    # obj will be overwritten. Therefore copy obj in objtemp
    #print "Obj in equivcompactm  ",obj
    objtemp=vecgen1(r)
    for i in range(0,r):
        objtemp[i]=obj[i]
    #########################################
    #print objtemp      #13.4.2011    
    neq=vecgen1(r)
    jneq=0
    extralist=""
    #zaehl=0                 # zu testzwecken 2.7.08
    for i in range(0,r):
        for j in range(0,k):
            x[i][j]=round(x[i][j],6)
    for i in range(0,r):
        #print "objtemp ",i," before the conditions ",objtemp[i]  #13.4.2011
        if objtemp[i] not in extralist and objtemp[i]!="*":  #obj --> objtemp
            extralist+="}{"+objtemp[i]+": "   #obj --> objtemp 14.10.08 \n raus
            neq[i]+=1
            #print "objtemp",i," = ",objtemp[i],"  extralist= ",extralist   #13.4.2011
        for j in range(i+1,r):
            #print "x[i], x[j] ",x[i],"  ",x[j]
            if x[j]==x[i] and objtemp[i]!="*":
                extralist+=objtemp[j]+", "
                neq[i]+=1
                objtemp[j]="*"
            else:
                pass
            
               
        #extralist+="\n"

    xred=[]
    objred=[]
    iz=0
    for i in range(0,r):
        if objtemp[i]!="*": #14.10.08 
            objred.append(objtemp[i])  #14.10.08
            xred.append(x[i])
            iz+=1

    rred=iz
    #print neq
    return rred,xred,objred,extralist,neq       

def equivcompactm2(r,k,x,obj, prec = 10):
    """calculates the dm of the quotient set and gives a list of equivalence classes"""
    #Brg21.12.07,20.6.08, 2.7.08, 14.10.08, 17.3.09, 12.4.2011(reconstructed)
    #*21.12.07
    #akt 8.9.2014
    #note: the object list should not contain '*' as identifier for objects
    #      the comparison of real values: up to the fourth position after dec.point
    # difference to equivcompact: return...neq
    # a trial to improve this routine is in equivcompactm1, which however is
    # up to now (12.4.2011) not working
    #source:equivcompact
    #r rows
    #k columns
    # obj will be overwritten. Therefore copy obj in objtemp
    #print "Obj in equivcompactm  ",obj
    objtemp=vecgen1(r)
    for i in range(0,r):
        objtemp[i]=obj[i]
    #########################################
    #print objtemp      #13.4.2011    
    neq=vecgen1(r)
    jneq=0
    extralist=""
    #zaehl=0                 # zu testzwecken 2.7.08
    for i in range(0,r):
        for j in range(0,k):
            x[i][j]=round(x[i][j],6)
    for i in range(0,r):
        #print "objtemp ",i," before the conditions ",objtemp[i]  #13.4.2011
        if objtemp[i] not in extralist and objtemp[i]!="*":  #obj --> objtemp
            extralist+="}{"+objtemp[i]+": "   #obj --> objtemp 14.10.08 \n raus
            neq[i]+=1
            #print "objtemp",i," = ",objtemp[i],"  extralist= ",extralist   #13.4.2011
        for j in range(i+1,r):
            #print "x[i], x[j] ",x[i],"  ",x[j]
            if x[j]==x[i] and objtemp[i]!="*":
                extralist+=objtemp[j]+", "
                neq[i]+=1
                objtemp[j]="*"
            else:
                pass
            
               
        #extralist+="\n"

    xred=[]
    objred=[]
    iz=0
    for i in range(0,r):
        if objtemp[i]!="*": #14.10.08 
            objred.append(objtemp[i])  #14.10.08
            xred.append(x[i])
            iz+=1

    rred=iz
    #print neq
    return rred,xred,objred,extralist,neq       


def equivcompact2(r,at1,at2,x,obj):
    """calculates the dm of the quotient set given the attributes at1 and at2
    and generates a list of equivalence classes"""
    #Brg 21.12.07, 2.7.08, 5.2.09, 17.3.09
    #*21.12.07
    #akt 5.2.09
    #note: the object list should not contain '*' as identifier for objects
    #      comparison up to fourth position after decimal point
    #source:-
    #r rows
    #at1 column1
    #at2 column2
    # equivcompact is to be used in stability-program
    # In the future there must be a module equivcompact<new> where
    # the case with a subset of attributes is in the parameterlist
    obh=[]
    for i in range(0,r):
        obh.append(obj[i])

    
    for i in range(0,r):
        #print "i = ", i,"  at1 = ",at1," x at1 ",x[i][at1]
        #print "  at2 ",at2,"  x at2  ",x[i][at2]
        x[i][at1]=round(x[i][at1],4)
        x[i][at2]=round(x[i][at2],4)
        
    xx=marray(r,2)
    for i in range(0,r):
        #print x[i][at1]
        #print x[i][at2]
        xx[i][0]=x[i][at1]
        xx[i][1]=x[i][at2]
        
    #print "equivcompact2: attr. i ",at1,"  attr.  ",at2
    #matout(r,2,xx)

    extralist=""
    for i in range(0,r):
        if obh[i] not in extralist and obh[i]!="*":
            extralist+="\n"+obh[i]+": "
        for j in range(i+1,r):
            if xx[j]==xx[i] and obj[i]!="*":
                extralist+=obh[j]+","    
                obh[j]="*"
            
        #extralist+="\n"

    xred=[]
    objred=[]
    iz=0
    for i in range(0,r):
        if obh[i]!="*":
            objred.append(obh[i])
            xred.append(xx[i])
            iz+=1

    rred=iz
    return rred,xred,objred,extralist

def equivcompact3(r,k,x,obj):
    """calculates the dm of the quotient set and gives a list of equivalence classes"""
    #Brg21.12.07,20.6.08,28.12.08, 17.3.09
    #*21.12.07
    #akt 17.3.09
    #note: the object list should not contain '*' as identifier for objects
    #      comparison up to the 4th position after decimal point
    #      the list of equivalent elements is rendered in a way that
    #      a better access to the equivalent elements is possible.
    #      In comparison to equivcompact the extralist will be changed
    #source:equivcompact
    #r rows
    #k columns
    obh=[]
    for i in range(0,r):
        obh.append(obj[i])

    for i in range(0,r):
        for j in range(0,k):
            x[i][j]=round(x[i][j],4)
            
    neq=vecgen1(r)
    jneq=0
    extralist=""
    eqlist=strmarray1(r,r,"*")
    for i in range(0,r):
        if obh[i] not in extralist and obh[i]!="*":
            extralist+="\n"+obh[i]+": "
            neq[i]+=1
            eqlist[i][0]=obh[i]
            #print eqlist[i][0],"---"
        else:
            eqlist[i][0]="*"
        for j in range(i+1,r):
            if x[j]==x[i] and obh[i]!="*":
                extralist+=obh[j]+","
                eqlist[i][j]=obh[j]
                #print eqlist[i][j]
                neq[i]+=1
                obh[j]="*"  # crucial line
            else:
                eqlist[i][j]="*"
                
                
                
        #extralist+="\n"

    xred=[]
    objred=[]
    iz=0
    for i in range(0,r):
        if obh[i]!="*":
            objred.append(obh[i])
            xred.append(x[i])
            iz+=1

    rred=iz
    #strmatout(r,r,eqlist)
    return rred,xred,objred,extralist,eqlist


def equivcompact4(r,k,x,obj):
    """calculates the dm of the quotient set and gives a list of equivalence classes"""
    #Brg21.12.07,20.6.08,28.12.08, 16.3.09, 17.3.09
    #*21.12.07
    #akt 17.3.09
    #note: the object list should not contain '*' as identifier for objects
    #      comparison up to the 4th position after decimal point
    #      the list of equivalent elements is rendered in a way that
    #      a better access to the equivalent elements is possible.
    #      In comparison to equivcompact the extralist will be changed
    #source:equivcompact
    #r rows
    #k columns
    # error: 16.3.09  obj will be overwritten. Therefore a copy of obj --> obh
    # 
    obh=[]
    for i in range(0,r):
        obh.append(obj[i])

    for iy in range(0,r):
        for jy in range(0,k):
            x[iy][jy]=round(x[iy][jy],6)# 12.4.2011
            
    
    extralist=""
    for ie in range(0,r):
        if obh[ie] not in extralist and obh[ie]!="*":
            extralist+="\t"+obh[ie]+":"
        for je in range(ie+1,r):
            if x[je]==x[ie] and obh[ie]!="*":
                extralist+=obh[je]+","
                obh[je]="*"
            
    xred=[]
    objred=[]
    iz=0
    for ie in range(0,r):
        if obh[ie]!="*":
            objred.append(obh[ie])
            xred.append(x[ie])
            iz+=1

    rred=iz
    #strmatout(r,r,eqlist)
    return rred,xred,objred,extralist


def readequiv(txt, such):
    """ if one of the results of one of the equivcompact\
    routines is in form txteq='}{a: c, e,}{b: f,}{d: }{g: h, i, j'\
    then often one would like to know specifically which elements
    belong to a nontrivial equivalence class. This is the routine for that"""
    # brg 16.12.2012
    # * 16.12.2012
    # akt: 16.12.2012
    # Input: txt: is one of the result of the equivcompact routines
    # Input : such: is the text of an object to be searched
    # Output: the equivalence class to which it belongs
    # In uebungsprogramme: txtinterpreationfuerequiv4.py as example
    # and test program
    #from string import *   outcommented: 24.3.2013
    txtvec=txt.split("}{")
    lt=len(txtvec)
    #print "txtvec= ",txtvec
    #print "such= ",such
    
    for i in range(0,lt):
        #print "i= ",i,"   txtvec= ",txtvec[i]
        testtxt=txtvec[i]
        if such in testtxt:
            txt=testtxt
            break
        else:
            txt="+++ object "+such+"  +++ not found ++++"
    return txt      



def eqclassesread(r,obj,li2, searchobj):
    """equivcompact3 renders the information about equivalence classes
        in a very unhandsome way. This procedure delivers a dynamic field xy and
        informs which representant can be found for a certain suchobj

        return list: xy,lxy,isearch,jsearch,representant
        If searchobject not in original obj.list then isearch=-9999, jsearch=-9999
        and representant='+++object is not in object list+++'

        How to use it: See eg program 'towardsreadeqclasses2.py' """
    # r : number of objects (complete list)
    # obj: complete list of objectnames
    # li2: lst as outcome of several equivcompact-routines. li2 is a r*r matrix 
    # searchobj: name of an object for which its representant is to be found
    # Brg 17.3.09
    # * : 17.3.09
    # 
    # elimination of "*" amd of ":"
    txttot=vecgentext1(r)
    for i in range(0,r):
        txt=""
        for i1 in range(0,r):
            if obj[i1] in li2[i]:
                txt+=obj[i1]+","
        txttot[i]=txt

    # elimination of empty components
    txttotreduz=[]
    for i in range(0,r):
        if txttot[i]!="":
            txttotreduz.append(txttot[i])

    #
    # representation by field xy with rred rows
    # but with different number of components for each row
    # corresponding to the fact that some eq.classes ...
    # have only one , some others more than one element
    lt=len(txttotreduz)
    xy=[]
    for i in range(0,lt):  # preparation of the tuple xy
        xy.append(' ')
        xy[i]=[]
    for i in range(0,lt):
        for tobj in obj:
            if tobj in txttotreduz[i]:
                xy[i].append(tobj)

    lxy=len(xy)
    # searchfunction     
    if searchobj in obj:
        
        for i in range(0,lxy):
            lxyz=len(xy[i])
            for j in range(0,lxyz):
                if searchobj in xy[i][j]:
                    isearch =i
                    jsearch=j
                    representant=xy[isearch][0]
    else:
        isearch=-9999
        jsearch=-9999
        representant=" +++object is not in object list ++++" 
    return xy, lxy,isearch,jsearch,representant           


def eqclassesread2(n,obj,li2):
    """equivcompact delivers a very uncomfortable info about equivalence classes.
    In contrast to eqclassesread this procedure renders the nontrivial equivalence classes
    Application in sensi14.py """
    #n : number of rows of original dm
    #obj: list of objectnames (original full set)
    #li2: n*n-matrix of equivalence classes (obtained from equivcompact3)
    #Brg 26.3.2010
    txt=""
    for i in range(0,n):
        flag=0
        flag2=0
        for j in range(1,n):
            if li2[i][j]!="*" and flag==0:
                txt+="["+str(li2[i][0])+": "+str(li2[i][j])+", "
                flag=1
                flag2=1
            elif li2[i][j]!="*" and flag==1:
                txt+=str(li2[i][j])+", "
            if j==n-1 and flag2==1:
                txt+="]  "
    return txt    

             
            

def equiv_hpor(r,k,x,obj):
    """calculates the dm of the quotient set and gives a matrix informing about equivalences"""
    #Brg 21.12.07,20.6.08, 25.7.08, 17.3.09
    #* 21.12.07
    #akt 17.3.09
    #note: the object list should not contain '*' as identifier for objects
    #      comparison up to the 4th position after decimal point
    #source:equivcompact. Here no text is given but a matrix
    #                     where the equivalent elements are coded by their original number 
    #r rows
    #k columns
    for i in range(0,r):
        for j in range(0,k):
            x[i][j]=round(x[i][j],4)
    

    neq=vecgen1(r)
    jneq=0
    extralist=""
    eqc=marray1(r,r,-1)
    for i in range(0,r):
        eqc[i][0]=i
        for j in range(i+1,r):
            if x[j]==x[i]:         #25.7.08 Aenderung
                jneq+=1
                eqc[i][jneq]=j
    return eqc


def equiv_assign(r,obj,x):
    """equivalence classes due to data matrix x are put in
    a dictionary, from which a list of equivalence classes is obtained"""
    # brg 9.10.2010
    # r number of objects in object set
    # obj: list of objects
    # x: original data matrix 
    eqdir={}

    for i in range(0,r):
        li=[]
        for j in range(0,r):
            if x[i]==x[j]:
                li.append(obj[j])
        
        eqdir[obj[i]]=li


    #print eqdir    
    wliste=eqdir.values()
    return wliste

def level_in_objectset(obj,objred,lobj,eqliste,r):
    """ By eqliste and lobj all objects of the object set get the correct
    level no """
    #brg 10.10.2010
    #examples in towardconflict4.py and conflict5.py
    #obj: object list in object space
    #objred: list of representative elements
    #lobj1: outcome of levtopsort
    #eqliste: outcome of equiv_assign
    #r number of objects in object set


    levelno=vecgen1(r)      
    leq=len(eqliste)      
          
    for level in range(0,len(lobj)):   #level search
        for iobr in lobj[level]:  #no of the objects in the level (coded by objred)
            ob=objred[iobr]
            iob=obj.index(ob)      #recoding the no corresponding to obj
            for i in range(0,leq):  # search the equivalence classes of equiv_assign
                if obj[iob] in eqliste[i]:  # if an object found in prededing steps is in eqliste[i]
                        for obh in eqliste[i]: #then for all objects of this class:
                            if obh!="*":        #check whether this calss was already visited
                                levelno[obj.index(obh)]=level #if not: all elements of this class get the level-no
                        for jj in range(0,len(eqliste[i])):  #the fact that this calss was visited: replace object names by *
                            eqliste[i][jj]="*"
    return levelno



def preparcases(k):
    """ prepares a cases matrix for subsequent sensitivity study """
    #brg 14.1.08, 16.8.08
    #*: 14.1.08
    #akt: 16.8.08
    #note: -
    #source:-
    #k number of attributes
    #the matrix contains -1 for nonrelevant positions and a number 0,..,k-1
    # ... for the different cases
    #testfile: case1.py
    
    a=marray(k+1,k)
    
    # defaults
    for i in range(0,k+1):
        for j in range(0,k):
            a[i][j]=-1
            
    for j in range(0,k):
        a[0][j]=j

    for i in range(1,k+1):
        for j in range(0,k):
            if j!=i-1:
                a[i][j]=j
    return a

def incompzeta(n,zeta):
    """calculates from zeta matrix the number of incomparable pairs"""
    #Brg 9.2.08
    #*:9.2.08
    #akt: 9.2.08
    #note:-
    #source-
    #n: number of rows and columns resp. of the square matrix zeta
    #zeta: matrix row <= column
    u=0
    for i in range(0,n):
        for j in range(i+1,n):
            if zeta[i][j]==0 and zeta[j][i]==0:
                u+=1
    return u            

def discon(dm,n,m,refnr,obj,g):
    """Calculates the discordance and concordance vector"""
    #Brg 22.3.08, 25.10.2012
    #*: 22.3.08
    # akt: 25.10.2012
    # source : see towardsCoDi1
    # dm (unnormalized data matrix n objects , m attributes
    # refnr: which object 0,..,m-1 is the reference object
    # g: weight vector , note sum g(i) = 1
    # note: dm will be internally normalized
    
    #matout(n,m,dm)
    co=marray(n,m)  #co: Konkordanzmatrix: 1 wenn besser oder gleich Referenz
    di=marray(n,m)  #Di: Diskordanzmatrix: 1 wenn schlechter als Referenz (qi(x) > qi(ref)

    dmnorm=matrixnorm(n,m,dm)
    #print "objects ",obj
    #print "dmnorm= ",dmnorm
    #matout(n,m,dmnorm)
    print "refnr= ",refnr, "object = ",obj[refnr]
    for i in range(0,n):
        for j in range(0,m):
            if dmnorm[i][j]>dmnorm[refnr][j]:
                di[i][j]=1
            else:
                co[i][j]=1
    #print " "
    #print "Concordance = "
    #matout(n,m,co)

    #print " "
    #print "discordance = "
    #matout(n,m,di)
        
    sumco=vecgen1(n)
    for i in range(0,n):
        for j in range(0,m):
            sumco[i]+=g[j]*co[i][j]

    #print "concordance vector = "
    for i in range(0,n):
        sumco[i]=round(sumco[i],2)
        #print sumco[i]," ",
    #print " "    



    disve=marray(n,m)
    dive=vecgen1(n)
    for i in range(0,n):
        for j in range(0,m):
            disve[i][j]=g[j]*di[i][j]*(dmnorm[i][j]-dmnorm[refnr][j])

    #print " "
    #print "weights (once again, just for convenience) "
    
    
    #matout(n,m,disve)

    #print "discordance vector = "
    for i in range(0,n):
        dive[i]=max(disve[i])
        dive[i]=round(dive[i],2)
        #print dive[i]," ",
    #print " "    
    return co,di,sumco,dive


def prom(n,m,dm,qk1,qk2,g):
    """kernel of PROMETHEE """
    #Brg 17.4.08, 18.4.08
    #*: 17.4.08
    #akt. 18.4.08
    # dm as given! No coulumnwise normalization
    delta=marray3(n,n,m)
    mm=vecgen1(m)
    tt=vecgen1(m)
    ep=marray3(n,n,m)
    p=marray(n,n)
    q=vecgen1(n)

    #differenz option i vs option j fuer jedes Attribut
    for j1 in range(0,m):
        for i in range(0,n):
            for j in range(0,n):
                delta[i][j][j1]=dm[i][j1]-dm[j][j1]

    for j1 in range(0,m):
        if qk2[j1]-qk1[j1] ==0:
            den=0.001
            print "++warning+++"
        else:
            den=qk2[j1]-qk1[j1]
        mm[j1]=1.0/(1.0*den)
        tt[j1]=-mm[j1]*qk1[j1]
                      
    
    for j1 in range(0,m):
        for i in range(0,n):
            for j in range(0,n):
                if delta[i][j][j1]<=qk1[j1]:
                    ep[i][j][j1]=0
                elif qk1[j1]<=delta[i][j][j1]<=qk2[j1]:    
                    ep[i][j][j1]=mm[j1]*delta[i][j][j1]+tt[j1]
                else:
                    ep[i][j][j1]=1
            
            
    for i in range(0,n):
        for j in range(0,n):
            p[i][j]=0
            for j1 in range(0,m):
                p[i][j]+=g[j1]*ep[i][j][j1]
            p[i][j]=(1.0/m)*p[i][j]    

    #matout(n,n,p)

    fluss1=vecgen1(n)
    fluss2=vecgen1(n)
    for i in range(0,n):
        fluss1[i]=0
        fluss2[i]=0
        for j in range(0,n):
            fluss1[i]+=p[i][j]
            fluss2[i]+=p[j][i]

##    print "  "
##    print "Results"
##    print "Dominance of options over the others..."
##    for i in range(0,n):
##        print round(fluss1[i],2)," ",
##    print " "
##    print "subdominance of options under the others..."
##    for i in range(0,n):
##        print round(fluss2[i],2)," ",
    fl2max=max(fluss2)
##    print " "
##    print "subdominance re-oriented: q-values "
    for i in range(0,n):
        q[i]=fl2max-fluss2[i]
##        print round(q[i],2)," ",
        
##    print " "    
    return fluss1,fluss2,q

def bitrep(nq,x):
    """ Integer number >0 will be translated into a bit-list
    ( binary numbers ) """
    #Brg 28.5.08, 30.7.2012
    #*: 28.5.08
    #akt. 25.5.08
    # nq number of components
    # x the integer which is to be transferred into a bit - code
    # result is bx = 1 or 0 with the order 2 hoch nq, 2 hoch nq-1,...,2 hoch 0
    # for example: 26 = (1,1,0,1,0)
    # to be read as: from right to the left: 0*(2**0)+1*(2**1)+0*(2**2)+1*(2**3)+1*(2**4)
    # note: x will be overwritten
    bx=[]
    for i in range(0,nq):
        
        u=2**(nq-(i+1))
        o=2**(nq-i)
        #print "x1= ",x1,i,u,"<?",x,"<?",o
        if u<=x<=o:
            bx.append(1)
            x-=2**(nq-(i+1))
        else:
            bx.append(0)
    return bx

def distance(r,K,x):
    """calculates the squared euclidian distance of a normalized data matrix"""
    #* Brg 22.6.08
    # akt. Brg 22.6.08
    # brg 22.6.08
    # r number of rows
    # K number of columns
    # x is data matrix
    # it is recommended to have x as normalized matrix (columnwise)
    dist=marray(r,r)
    for i in range(0,r):
        for j in range(0,r):
            dist[i][j]=0
            for k in range(0,K):
                dist[i][j]+=(x[i][k]-x[j][k])**2
    return dist             

def warshall(n,m1):
    """Warshall algorithm"""
    # * Brg 25.6.08
    # akt: 25.6.08
    # Brg 25.6.08
    # See K.H.Rosen, 4th edition 1999: Discrete Mathematics and its Applications
    # Pages 399-406
    # n dimension of the square  matrix m1
    # m1 matrix describing the relation which is to be transitively closed
    # Note m1 will be overwritten
    for k in range(0,n):
        for i in range(0,n):
            for j in range(0,n):
                m1[i][j]=m1[i][j] or (m1[i][k] and m1[k][j])
    return m1             


def geomHD(zv, levm,zlev):
    """ from zv the graphical control for HDs is derived """
    #zv is the number of vertices
    # levm is the number of vertices in the maximal level (determines the x coord
    # zlev is the number of levels, determines the y coord
    # * Brg 10.6.08
    # akt: 21.6.08
    # brg 10.6.08, 21.6.08
    awidth=zv*40
    aheight=zv*40
    if awidth<400:
        awidth=400
    if awidth>600:
        awidth=600
    if aheight<120:
        aheight=120
    if aheight>600:
        aheight=600
    
    #aheight and awidth: extent of canvas
    fx = int((awidth-40))
    fy = int((aheight-40))
    g0x=5   #Start of the HD-area x
    g0y=20   #Start of the HD-area y
    garr1x=fx +10.0  #location of the arrow
    garr1y=20
    garr2y=fy+10.0
    return awidth,aheight,fx,fy,g0x,g0y,garr1x,garr1y,garr2y

def geomHD1(zv, levm,zlev):
    """ from zv the graphical control for HDs is derived """
    #zv is the number of vertices
    # levm is the number of vertices in the maximal level (determines the x coord
    # zlev is the number of levels, determines the y coord
    # * Brg 10.6.08
    # akt: 21.6.08, 16.8.2012
    # brg 10.6.08, 21.6.08, 16.8.2012
    awidth=levm*40
    aheight=zlev*40+50
    if awidth<400:
        awidth=400
    if awidth>600:
        awidth=600
    if aheight<200:
        aheight=200
    if aheight>600:
        aheight=600
    
    #aheight and awidth: extent of canvas
    fx = int((awidth-40))
    fy = int((aheight-40))
    g0x=5   #Start of the HD-area x
    g0y=30   #Start of the HD-area y
    garr1x=fx +10.0  #location of the arrow
    garr1y=20
    garr2y=fy+10.0
    return awidth,aheight,fx,fy,g0x,g0y,garr1x,garr1y,garr2y


def streuung(x,n):
    """ standarddeviation sd and variance v are  calculated """
    #x is a list from which sd and v are to be calc.
    #n number of components of that list
    # * Brg 6.8.08
    # akt: 6.8.08
    # brg 6.8.08
    
    sumq=0
    sume=0

    for i in range(0,n):
        sumq+=x[i]*x[i]
        sume+=x[i]

    v=(sumq-(1.0*sume*sume)/(1.0*n))/(n-1.0)
    sd=(v)**0.5
    return v,sd
    

def enrich(s,z,n):
    """ tests whether the permutation s is a linear extension
    of the poset, described by the zeta matrix """
    #brg 3.1.08
    #s is a permutatin of an initial linear extension
    #z is a zeta matrix
    #n is the number of objects
    flag=1
    for i in range(0,n):
        for j in range(0,n):
            if i!=j:
                try:
                    if z[i][j]==1 and s.index(i)> s.index(j):
                        flag=0
                except:       
                    flag=0
            else:
                pass
            
    return flag

def BubleyDyer(sigma,zeta,n, nMC,unif_sampl):
    """MC-calculation of a random set of linear extensions
    after Bubley and Dyer , see also Denoeux-paper
    from this set dynamically rkav is calculated """
    #brg 3.1.08, 17.6.08, 18.6.08
    #sigma is the initial linear extension
    #zeta is the zeta matrix, orientation row defining number <
    #......columndefining number then corresp. entry =1
    # n is the number of objects
    #nMC is the number of MC-trials at least 4000, better more
    #unif_sampl. if e.g. unif_sampl=100 and nMC=10000 then the
    #          rkav will be calculated after each 100.step
    sigmanew=rmod2.vecgen1(n)
    rkav0=rmod2.vecgen1(n)
    rkav=rmod2.vecgen1(n)
    rkavalt=rmod2.vecgen1(n)
    for i in range(0,n):
        rkav[i]=sigma.index(i)+1
        rkav0[i]=sigma.index(i)+1
        rkavalt[i]=sigma.index(i)+1
    #Initial average rank rkav0

    #print " initial sigma ",sigma
    for i in range(0,n):
        sigmanew[i]=sigma[i]

    zaehl=0
    lint=1

   #18.6.: check the loop-finishing condition
    while zaehl<nMC:
        r=random.randint(0,1)  #17.6.08 8 changed to n 18.6 changed to (0,1)
        if r==0:        #17.6.08 18.6.08 changed
            for i in range(0,n):
                sigmanew[i]=sigma[i]
##            if zaehl%unif_sampl==0:   #17.6.08
##                for i in range(0,n):    
##                    rkav[i]+=sigmanew.index(i)+1.0
##                lint+=1
        else:
            irandom=random.randint(0,n)  ## better: take f(i)
            if 0<=irandom<n-1:   #25.6.08 changed from < to =<
                sigmanew[irandom+1]=sigma[irandom] #transposition of width =1
                sigmanew[irandom]=sigma[irandom+1]  # transpos. of width=1
            else:
                sigmanew[0]=sigma[n-1]
                sigmanew[n-1]=sigma[0]

            flag=enrich(sigmanew,zeta,n)
            if flag==1:
                
                #print sigmanew
                for i in range(0,n):
                    sigma[i]=sigmanew[i]
                if zaehl%unif_sampl==0:  #18.7.08
                    for i in range(0,n):
                        rkav[i]+=sigma.index(i)+1.0
                    lint+=1    
            else:
                for i in range(0,n):
                    sigmanew[i]=sigma[i]
##                for i in range(0,n): ##heikel 17.6.08
##                    rkav[i]+=sigmanew.index(i)+1.0
##                lint+=1    
        
        zaehl+=1
        if zaehl==nMC-2:
            for i in range(0,n):
                rkavalt[i]=rkav[i]
            
    # MC-loop finished
    return rkav, rkav0,lint,rkavalt


def suchlist(listel,liste):
    """ searches the list number of 'listel' in the list 'liste' """
    #Brg *: 12.10.08
    #Brg act: 12.10.08
    #Brg : 12.10.08
    # listel = list - el  ement
    # liste = the list which is to be searched for
    r=len(liste)
    for i in range(0,r):
        if listel==liste[i]:
            iob=i
            break
        else:
            iob=999999     #default value for not in list
    booltxt='false'
    if iob<=r:
        booltxt='true'
    return booltxt,iob    

def loof(r,klimit,c):
    """ mutual probability iteration """
    # Brg *: 13.10.08
    # Brg akt: 13.10.08
    # Brg 13.10.08
    # number of objects
    # who many iterations (around 10 recommended)
    # zeta matrix a<=b: 1 else 0
    # see paper De Loof, Warsaw 23-24.10.08
    # Input c-matrix will be overwritten
    c0=matcopy1(r,r,c)
    Nd=marray(r,r)
    Nu=marray(r,r)
    k=1
    while k<=klimit:
        for i1 in range(0,r):
            for j1 in range(0,r):
            
                sumd=0
                sumu=0
                for i in range(0,r):
                    sumd+=c[i][i1]*(1.0-c[i][j1])
                    sumu+=c[i1][i]*(1.0-c[j1][i])
                    
                Nd[i1][j1]=sumd
                Nu[i1][j1]=sumu

        for i1 in range(0,r):
            for j1 in range(0,r):
                hilfu=(Nu[j1][i1])
                hilfd=(Nd[i1][j1])
                hilfu1=(Nu[i1][j1])
                hilfd1=(Nd[j1][i1])
                if c0[i1][j1]==0 and c0[j1][i1]==0: #only for incomp. elements the correction
                    c[i1][j1]=(hilfu+hilfd+1.0)/(1.0*(hilfu1+hilfd1+hilfu+hilfd+2.0))
                else:
                    c[i1][j1]=c0[i1][j1]
        k+=1    
    return c,c0            

def optimattr(n,m,dm):
    """from dm (n*m) the Spearman correl. matrix (corrm) is determined
    and from that the attribute pair (index iopt, jopt) with the minimal
    correlation coefficient.
    The method is based on the library pstat and stats of Gary Strangman"""
    # Brg *: 28.11.08
    # Brg : 28.11.08, 29.11.08
    # Brg akt: 29.11.08
    # Brg source: see pstat and stats
    # n: number of rows
    # m: number of columns (of attributes)
    # dm: the data matrix 
    corrm=marray1(m,m,1)
    for i in range(0,m):
        col1=vecgen1(n)
        for k in range(0,n):
            col1[k]=dm[k][i]
            
        for j in range(0,m):
            col2=vecgen1(n)
            for k1 in range(0,n):
                col2[k1]=dm[k1][j]
                corrm[i][j],p=pstat.lspearmanr(col1,col2)
                
    
    #print "in opimattr"
    #matout(m,m,corrm)
    mini=10**20
    maxi=-10**20
    for i in range(0,m):
        for j in range(i,m):
            if corrm[i][j]<=mini:
                mini=corrm[i][j]
                iopt=i
                jopt=j
                copt=corrm[iopt][jopt]
            else:
                pass
    return corrm,iopt,jopt,copt


def dynheight(text,maxheight=60):
    """estimates the needed dimensions of a ScrolledTextbox"""
    #brg * 28.12.08
    #brg akt: 28.12.08
    #
    #text: to be inserted in the Textbox
    #
    #maxheight: ca 60 depending on the physical height of a screen
    # note: maxheight is given as default. If a call is ...dynheight(text) then
    #       the default of 60 will be taken.
    #       If , however, a call is ...dynheight(text,10) then the height of
    #       the scrollbox will at maximum 10.
    #output: ad: number of \n
    #output: heightdyn: the most important quantity the needed height
    #output: ltdyn: the length of a text
    ltdyn=len(text)
    ad=text.count("\n")   #7.5.2012
    if ad<=maxheight:
        heightdyn=ad+2
    else:
        heightdyn=maxheight+2
    return ad,heightdyn,ltdyn    
    
def rai_x(rai,objred):
    """ transformation of sequence (rai) into a vectorial quantity (x)"""
    #brg 26.12.07, 31.12.07
    #brg 14.1.08: renamed: calc --> rai_x, because there is no calculation 
    #needed in antag-program versions
    x=vecgentext1(2)
    y=vecgen1(2)
    lx=vecgen1(2)
    #print rai
    for i in range(0,2):
        x[i]=rai[i].split(",")
    for i in range(0,2):
        lx[i]=len(x[i])
        y[i]=[]
    lob=len(objred)
    
    for i in range(0,2):
        for j in range(0,lx[i]):
            for k in range(0,lob):
                if x[i][j] ==objred[k]:
                    y[i].append(k)
    #print y[0]
    #print y[1]
    return y,x,lx


def partialseparability(r,att1,att2,rai,lrai,x):
    """ based on two object subsets in ra and on columns att1 and att2 of xred the
    separability will be calculated"""
    #Brg  31.12.07, 14.1.08, 4.2.09
    #* brg 4.2.09
    #  brg 4.2.09, 5.2.09
    #  Note: derived from dds8
    #  Needed in antag-program versions
    #  r: Number of rows in the original dm
    #  att1, att2: labels of attributes, usually 0 and 1 as
    #              in the preceding step (equivcompact2)
    #              always a r*2 matrix is obtained, so that within
    #              this procedure the attributes labels are not variabel
    #  number of elements in the subsets
    #  rai contains the two subsets

    rred,xred,objred,txtquot=equivcompact2(r,att1,att2,x,obj)  
    #rred, xred depend on the number of attributes regarded
    #hence equivcompact2 must be selected 
    zeta=marray(rred,rred)   
    zeta,att1,att2=comp2(rred,att1,att2, xred) #zeta matrix

    #here we have the central matrix zeta matrix which
    #is based on the actually selected attributes (labels) att1 and att2
    
    #print lrai     
    #that is the central part: based on rai the separability degree
    partsep=0
    #print "attribut i ",att1, "attribut j  ",att2
    #matout(rred,rred,zeta)
    
    for i2 in range(0,lrai[0]):
        for i4 in range(0,lrai[1]):
            if zeta[rai[0][i2]][rai[1][i4]]==0 and zeta[rai[1][i4]][rai[0][i2]]==0:
                partsep+=1            
    
    return partsep

def partialseparability1(r,rai,lrai,zeta):
    """ based on two object subsets in ra and on columns att1 and att2 of xred the
    separability will be calculated"""
    #  Brg  31.12.07, 14.1.08, 4.2.09, 6.2.09
    #* brg 4.2.09
    #akt: 6.2.09
    #  Note: derived from partialseprability
    #  Needed in antag-program versions
    #  r: Number of rows in the original dm
    #  att1, att2: labels of attributes, usually 0 and 1 as
    #              in the preceding step (equivcompact2)
    #              always a r*2 matrix is obtained, so that within
    #              this procedure the attributes labels are not variabel
    # rai: the two subsets rai[0][0,...] first subset
    #                      rai[1][0,...] second subset
    # lrai: number of elements in the subsets of rai
    # zeta: zeta matrix based on the reduced dm (based on a subset of attributes
    # Note: zeta may contain equivalent elements

    #that is the central part: based on rai the separability degree
    partsep=0
    for i2 in range(0,lrai[0]):
        for i4 in range(0,lrai[1]):
            if zeta[rai[0][i2]][rai[1][i4]]==0 and zeta[rai[1][i4]][rai[0][i2]]==0:
                partsep+=1            
    
    return partsep


def newmatrix(n,m,x,t):
    """ Those columns of the n*m matrix x
    which correspond to the numbers in list t
    will be used to form the new matrix xx """
    # Brg* 6.2.09
    # Brg 6.2.09, 27.3.2010
    # n: number of rows of original matrix
    # m: number of columns of orig. matrix
    # t: a list of variable length. Numbers in t indicate...
    #    which columns are to be selected
    xx=marray(n,len(t))
    maxt=max(t)
    txt=""
    print "max t ",maxt, "length of t ",len(t)
    if maxt>m-1:
        txt+="++not an accessible col.-number++"
    if len(t)>m:  #changed 27.3.2010 instead m-1 now m
        txt+="++length of t greater than the number of cols of x++"

    if maxt<=m-1 and len(t)<=m:  #27.3.2010 changed len(t)<=m-1 to <=m
        

        for i in range(0,n):
            zaehl=0
            for j in range(0,m):
                if j in t:
                    xx[i][zaehl]=x[i][j]
                    zaehl+=1
    return txt,xx

def levelincomp(zeta,r,level):
    """ incomp per level """
    #"7.2.09
    #akt 7.2.09
    # zeta : zetamatrix row >= column This is important
    #       for a correct level identification
    # r : number of objects (may be (depending on application) also rred)
    # level: number of levels
    # testprograms: series of ulevel...py. ulevel7.py and ulevel8.py towards
    #      the final version

    
    output=railevel(r,level,zeta) #this routine is based on Patil,Taillie2005
    # Note: toplevel = 1 bottomlevel = level


    u = marray(level,r)
    ulevel=vecgen1(level)
    numbperlevel=vecgen1(level)
    avlevel=vecgen1(level)

    for i in range(0,level):
        for j in range(0,r):
            u[i][j]=0
            if output[i][j]!=-1:
                numbperlevel[i]+=1
                for i1 in range(0,r):
                    if zeta[output[i][j]][i1]==0 and zeta[i1][output[i][j]]==0:
                        u[i][j]+=1
                        
                    
    for i in range(0,level):
        for j in range(0,r):
            ulevel[i]+=u[i][j]
           

    for i in range(0,level):
        if numbperlevel[i]!=0:
            avlevel[i]=1.0*ulevel[i]/(1.0*numbperlevel[i])
        
    return numbperlevel,ulevel,avlevel


def covtxt(cov,obj,r,name):
    """ a cover matrix row < col , diagonal =0
        will be transformed into a data format which is understandable
        by graphviz """
    # * 13.3.09
    # brg 13.3.09
    # act 13.3.09
    # The standard convention: objects as high as possible is not fulfilled
    txt=""
    txt+="graph "+name+" {"+"\n"
    for i in range(0,r):
        txt+=obj[i]+" "
    txt+="\n"            
                
    for i in range(0,r):
        for j in range(0,r):
            if cov[j][i]==1:
                txt+=obj[i]+" -- "+obj[j]+";"+"\n"
    txt+="}"
    return txt


def covtxt1(cov,obj,r,name):
    """ a cover matrix row < col , diagonal =0
        will be transformed into a data format which is understandable
        by graphviz """
    # * 13.3.09
    # brg 13.3.09, 14.3.09
    # act 13.3.09
    # The standard convention: objects as high as possible is not fulfilled
    # a variant. Note, this facility is still under development
    txt=""
    txt+="digraph "+name+" {"+"\n"
##    if r>10:
##        "graph" fontsize=8
##        "edge" fontsize=8
##        "node" fontsize=8
##        ranksep=0.3
##        nodesep=0.1
##        edge style="setlinewidth(1)"
    for i in range(0,r):
        txt+=obj[i]+" "
    txt+="\n"            
                
    for i in range(0,r):
        for j in range(0,r):
            if cov[j][i]==1:
                txt+=obj[i]+" -- "+obj[j]+";"+"\n"
    txt+="}"
    return txt

def geomHD(zv, levm,zlev):
    """ from zv the graphical control for HDs is derived """
    #zv is the number of vertices
    # levm is the number of vertices in the maximal level (determines the x coord
    # zlev is the number of levels, determines the y coord
    # * Brg 10.6.08
    # akt: 21.6.08
    # brg 10.6.08, 21.6.08
    # +++Nota bene the info levm and zlev is not used!!!+++ (Brg 26.3.2010)
    awidth=zv*40
    aheight=zv*40
    if awidth<400:
        awidth=400
    if awidth>600:
        awidth=600
    if aheight<120:
        aheight=120
    if aheight>600:
        aheight=600
    
    #aheight and awidth: extent of canvas
    fx = int((awidth-40))
    fy = int((aheight-40))
    g0x=5   #Start of the HD-area x
    g0y=20   #Start of the HD-area y
    garr1x=fx +10.0  #location of the arrow
    garr1y=20
    garr2y=fy+10.0
    return awidth,aheight,fx,fy,g0x,g0y,garr1x,garr1y,garr2y


def enrich(s,z,n):
    """ tests whether the permutation s is a linear extension
    of the poset, described by the zeta matrix
    flag=1 when permutation is a linear extension """
    #brg 3.1.08
    # transferred to rmod2: 14.3.09
    #s is a permutation of an initial linear extension
    #z is a zeta matrix
    #n is the number of objects
    flag=1
    for i in range(0,n):
        for j in range(0,n):
            if i!=j:
                try:
                    if z[i][j]==1 and s.index(i)> s.index(j):
                        flag=0
                except:       
                    flag=0
            else:
                pass
            
    return flag

def txtpart(txt,segments):
    # Brg  10.1.10
    # segments: maximal length of the parts of the text
    # txt: input-txt
    # slicetxt: vector with the partitioned txt
    # lst: number of components of the partitioned text, if the length of the txt
    #      is less than segements, then lst=1 and newtxt consists of one component
    
    ltxt=len(txt)
    #print "length of text = ",ltxt
    slicetxt=[]
    if ltxt>segments:
        i1=0
        while i1*segments<ltxt:
            slicetxt.append(txt[i1*segments:(i1+1)*segments])
            i1+=1
            if i1>1.0*ltxt/(1.0*segments):
                break
    else:
        i1=1
        slicetxt.append(txt)
    lst=i1
    return slicetxt,lst
    
def matrixrowsum(matrix,norow,nocol):
    """ determines from a matrix the rowsums """
    # Brg 9.3.2010
    rowsum=[]
    summ=0
    for i in range(0,norow):
        summrow=0
        for j in range(0,nocol):
            summrow+=matrix[i][j]
        rowsum.append(summrow)
    return rowsum

def matrixcolsum(matrix,norow,nocol):
    """ determines from a matrix the columnsums"""
    # brg 9.3.2010, 22.9.10
    colsum=[]
    for j in range(0,nocol):
        summcol=0
        for i in range(0,norow):
            summcol+=matrix[i][j]  #correction 22.9.10
        colsum.append(summcol)    
    return colsum

def findmax(rowsum,norow):
    maxtest=-1
    for i in range(0,norow):
        if rowsum[i]>maxtest:
            imax=i
            maxtest=rowsum[i]
    #print "max row sum ",maxtest,"  max row = ",imax
    return imax,maxtest

def matrixcolred(matrix,nocol,norow,listobj):
    """ all matrixelements =0 whose columns belong to listobj """
    # brg 9.3.2010
    mneu=marray(norow,nocol)
    for i in range(0,norow):
        for j in range(0,nocol):
            if j in listobj:
                mneu[i][j]=0
            else:
                mneu[i][j]=matrix[i][j]
    return mneu
    
def optimallist(matrix,rowsum,norow,nocol):
    """ from matrix the row is found which has the largest
    rowsum . All columns which contribute with 1 in that row will be gathered
    in the vector listobj """
    istern,mm=findmax(rowsum,norow)  
    listobj=[]
    for i in range(0,nocol):
        if matrix[istern][i]==1:
            listobj.append(i)
    return listobj,istern


def deltalist(listobj,listtotal):
    listnew=[]
    for i in range(0,len(listtotal)):
        if listtotal[i] not in listobj:
            listnew.append(listtotal[i])
        else:
            pass
    return listnew    


def outranking(objred,weights,xred,k):
    # brg 4.7.10
    # objred list of representative objects
    # weights  list of k weights
    # xred dm of quotient set , representatives of eq.cl.
    # k: number of columns of xred (number of attributes)
    lovec=len(objred)
    outrk=marray(lovec,lovec)
    for i in range(0,lovec):
        for j in range(0,lovec):
            if i!=j:
                for l in range(0,k):
                    if xred[i][l]>xred[j][l]:
                        outrk[i][j]+=weights[l]
                    elif xred[i][l]==xred[j][l]:
                        outrk[i][j]+=0.5*weights[l]
                    else:
                        outrk[i][j]+=0
            else:
                outrk[i][j]=0  #11.4.2011
    return outrk,lovec

def copeland(objred,xred,weights,k):
    # brg 7.7.10, 2.2.2011, 3.2.2011
    # objred list of representative objects
    # weights  list of k weights, will be overwritten (2.2.2011)
    # xred dm of quotient set , representatives of eq.cl.
    # k: number of columns of xred (number of attributes)
    sumw=0                #2.2.2011 
    for j in range(0,k):
        sumw+=weights[j]
    for j in range(0,k):
        weights[j]=1.0*weights[j]/(1.0*sumw)  #2.2.2011
    lovec=len(objred)
    outrk=marray(lovec,lovec)
    for i in range(0,lovec):
        for j in range(0,lovec):
            if i!=j:
                for l in range(0,k):
                    if xred[i][l]>xred[j][l]:
                        outrk[i][j]+=weights[l]
                    elif xred[i][l]==xred[j][l]:
                        outrk[i][j]+=0
                    else:
                        outrk[i][j]-=weights[l]
    return outrk,lovec


def outrkdetail(objx1,objx2,objred,xred,prop,k):
    """ two disjoint object subsets objx1, objx2
    will analyzed for any attribute qi as to how far:
    x >(qi) y , of x <(qi) y,
    with x from set1 and y from set 2.
    x is coded by i and y is coded by j and
    any pair i,j has a list of attributes for which i>j: zq1q2
    and a list of attributes for which i<j: zq2q1"""
    #brg 5.7.10
    # objx1: set of objects
    # objx2: set of objects
    # objred: list of object names
    # xred: reduced (cogent) data matrix
    # prop: list of attribute names
    # k: number of attributes
    # Output: outrkset: Matrix columns and rows: object labels
    #                    each entry: i,j, list of attrib.>,
    #                    list of attrib. <
    lovec1=len(objx1)
    lovec2=len(objx2)
    outrkset=marray(lovec1,lovec2)  #11.8.10 marray(k,k). 
    z1=0
    for i in objx1:
        i1=objred.index(i)
        z2=0
        for j in objx2:
            j1=objred.index(j)
            zq1q2=[]
            zq2q1=[]
            for l in range(0,k):
                    if xred[i1][l]>xred[j1][l]:
                        zq1q2.append(prop[l])
                    elif xred[i1][l]<xred[j1][l]:
                        zq2q1.append(prop[l])
                    else:
                        pass
            outrkset[z1][z2]=[i,j,zq1q2,zq2q1]
            z2+=1
        z1+=1    
    return outrkset

def simpsonrule(r,matrix):
    """After Munda, 2008,p. 116 a method to obtain
    simpson-parameter from a outranking matrix. They can be used to get
    a ranking"""
    # brg 30.9.2010, 1.10.2010
    # r dimension of the square matrix
    # matrix is an outranking matrix whose entries have to be <=1 and >=0.
    dummy=99999

    simpson=[]
    for i in range(0,r):
        hilf=vecgen1(r)
        for j in range(0,r):
            if i!=j:
                hilf[j]=matrix[i][j]
            else:
                hilf[j]=dummy
        #print "i= ",i," hilf= ",hilf        
        simpson.append(min(hilf))
    return simpson    

def make_listpaars(x1,x2):
    """ x1 and x2 are disjoint sets. Their ordered product is stored in a list: listpa
    results are the length of xi and the list"""
    # Brg 20.8.10
    # x1 and x2 are sets . e.g. x1 =a,b,c , x2 = d,e then
    #                      x1*x2 = ad , ae, bd, be, cd, ce
    # These 6 pairs are stored as follows in listpa:
    # listpa[i][0]: number (= i) ,
    # listpa[i][1]: elements of set1 first
    # listpa[i][2]: elements of set 2 second.
    # the procedures listpaar_no_identifier and listpar_no_identifier_orient
    # are based on the configuration of listpa.
    lx1=len(x1)
    lx2=len(x2)
    lx1x2=lx1*lx2
    listpa=marray(lx1x2,3)
    z=0
    for ob1 in x1:
        for ob2 in x2:
           listpa[z][0]=z
           listpa[z][1]=ob1
           listpa[z][2]=ob2
           z+=1
    return lx1,lx2,lx1x2,listpa

def make_listpaars_except_diag(li1):
    """ A list 'listor' of all combinations of li1*li1 is obtained, except pairs like
        (a,a), (b,b), listor[i][0]=i, listor[i][1] first component of the pair
        listor[i][2]: second component of the pair"""
    #brg 20.8.10
    lli1=len(li1)
    lfin=lli1*(lli1-1)
    listor=marray(lfin,3)
    z=0
    for k1 in range(0,lli1):
        for k2 in range(0,lli1):
            if k1!=k2:
               listor[z][0]=z
               listor[z][1]=li1[k1]
               listor[z][2]=li1[k2]
               z+=1
    return z,listor             


def listpaar_no_identifier(listpa,testob,lx1x2):
    """ Two lists are obtained, where in testoblist1 those listpa-numbers appea
    where testob is in the first, whereas in testoblist2 testob appears in the second
    position"""
    # Brg 20.8.10
    # listpa is the outcome of 'male_listpaars'
    # testob is an object whose presence is checked in listpa[i][1] or listpa[i][2]
    # lx1x2 is the length of listpa.
    testoblist1=[]
    testoblist2=[]
    for i in range(0,lx1x2):
        if str(testob)==str(listpa[i][1]):
            testoblist1.append(i)
        if str(testob)==str(listpa[i][2]):
            testoblist2.append(i)
    lto1=len(testoblist1)
    lto2=len(testoblist2)
##    print "list1 ",testoblist1
##    print "list2  ",testoblist2
    return lto1,lto2,testoblist1,testoblist2


def listpaar_no_identifier_orient(listpa,testob,lx1x2,posi):
    """ Similar to listpaar_no_identifier, but now the position of
    testob can be specified for the search """
    # brg 20.8.10
    # listpa is the outcome of make_listpaars, testob is a testobject,
    # lx1x2 is the length of listpa, posi =1 or 2 according where the
    # search is to be performed.
    # The outcome is a list.
    lipaorient=[]
    for i in range(0,lx1x2):
        if str(testob)==str(listpa[i][posi]):
            lipaorient.append(i)
    llipa=len(lipaorient)
    #print "lipaorient = ",lipaorient
    return llipa,lipaorient      

def find_no_inlistpaar(listpa,x1,x2,lx1x2):
    """ In listpaar: which no has a pair x1,x2, where the sequence is important (first x1 then x2"""
    # brg 22.8.10
    # listpa is the outcome of make_listpaars, x1, x2 are objects whose no in listpa is to be found,
    # lx1x2 is the length of listpa, 
    # 
    # The outcome is a number.
    for i in range(0,lx1x2):
        if listpa[i][1]==str(x1) and listpa[i][2]==str(x2):
            numberx1x2=i
            break
    return numberx1x2    
        
   


def matrixfirstgreatersecond(x1,x2,rred,xred,objred, prop):
    """ A matrix will be generated where the ith row (for the ith attribute)
        has in the jth colum for the jth pair taken from x1*x2 a 1 if
        the attribute i leads to a > b , where a is taken from x1 and b from x2 and
        is the jth pair """
    #brg 20.8.10
    # x1,x2: disjoint sets
    # xred the reduced dm
    # objred the representative elements
    # prop : attribute list
    # outcome:
    # lx1x2: length of the listpa: how many pairs of objects
    # k0 how many attributes
    # listpa: the list of ordered pairs taken from x1*x2
    # m_1 the matrix, k0 rows , lx1x1 columns
    k0=len(prop)
    xredn=matrixnorm(rred,k0,xred)
    lx1=len(x1)
    lx2=len(x2)
    lx1x2=lx1*lx2
    
    listpa=marray(lx1x2,3)
    m_1=marray(k0,lx1x2)   #matrix with 1 if qi leads to a>b with a from x1 and b from x2
    xm_1=marray(k0,lx1x2)    
    
    z=0
    for ob1 in x1:
        iob1=objred.index(ob1)
        for ob2 in x2:
            iob2=objred.index(ob2)
            listpa[z][0]=z
            listpa[z][1]=ob1
            listpa[z][2]=ob2
            for k in range(0,k0):
                if xred[iob1][k]>xred[iob2][k]:
                    m_1[k][z]=1
                    xm_1[k][z]=abs(xredn[iob1][k]-xredn[iob2][k])
            z+=1        
    return lx1x2,k0, listpa,m_1,xm_1
    
def matrixfirstlesssecond(x1,x2,rred,xred,objred, prop):
    """ A matrix will be generated where the ith row (for the ith attribute)
        has in the jth colum for the jth pair taken from x1*x2 a 1 if
        the attribute i leads to a < b , where a is taken from x1 and b from x2 and
        is the jth pair """
    #brg 20.8.10
    # x1,x2: disjoint sets
    # xred the reduced dm
    # objred the representative elements
    # prop : attribute list
    # outcome:
    # lx1x2: length of the listpa: how many pairs of objects
    # k0 how many attributes
    # listpa: the list of ordered pairs taken from x1*x2
    # m_1 the matrix, k0 rows , lx1x1 columns
    k0=len(prop)
    xredn=matrixnorm(rred,k0,xred)
    lx1=len(x1)
    lx2=len(x2)
    lx1x2=lx1*lx2
    
    listpa=marray(lx1x2,3)
    m_1=marray(k0,lx1x2)   #matrix with 1 if qi leads to a>b with a from x1 and b from x2
    xm_1=marray(k0,lx1x2)    
    
    z=0
    for ob1 in x1:
        iob1=objred.index(ob1)
        for ob2 in x2:
            iob2=objred.index(ob2)
            listpa[z][0]=z
            listpa[z][1]=ob1
            listpa[z][2]=ob2
            for k in range(0,k0):
                if xred[iob1][k]<xred[iob2][k]:
                    m_1[k][z]=1
                    xm_1[k][z]=abs(xredn[iob1][k]-xredn[iob2][k])
            z+=1        
    return lx1x2,k0, listpa,m_1,xm_1

def matrixfirstequalsecond(x1,x2,xred,objred, prop):
    """ A matrix will be generated where the ith row (for the ith attribute)
        has in the jth colum for the jth pair taken from x1*x2 a 1 if
        the attribute i leads to a = b , where a is taken from x1 and b from x2 and
        is the jth pair """
    #brg 20.8.10, 21.8.10
    # x1,x2: disjoint sets
    # xred the reduced dm
    # objred the representative elements
    # prop : attribute list
    # outcome:
    # lx1x2: length of the listpa: how many pairs of objects
    # k0 how many attributes
    # listpa: the list of ordered pairs taken from x1*x2
    # m_1 the matrix, k0 rows , lx1x1 columns
    lx1=len(x1)
    lx2=len(x2)
    lx1x2=lx1*lx2
    k0=len(prop)
    listpa=marray(lx1x2,3)
    m_1=marray(k0,lx1x2)   #matrix with 1 if qi leads to a>b with a from x1 and b from x2
        
    
    z=0
    for ob1 in x1:
        iob1=objred.index(ob1)
        for ob2 in x2:
            iob2=objred.index(ob2)
            listpa[z][0]=z
            listpa[z][1]=ob1
            listpa[z][2]=ob2
            for k in range(0,k0):
                if xred[iob1][k]==xred[iob2][k]:
                    m_1[k][z]=1
            z+=1        
    return lx1x2,k0, listpa,m_1




def matrixsep(m_1,m_2,lx1x2,k0):
    """ a matrix is generated where  in the ith row (ith pair of attributes (qi,qj) or (qj,qi) but
        not (qi,qi) ) and in the jth column (a,b) (a taken from x1, b taken from x2) is a 1 if
        this pair separates a from b in the way a>b First attr., a<b second attribute) """
    #Brg 20.8.10
    # m_1 is the outcome of matrixfirsdtgreatersecond
    # m_2 is the outcome of matrixfirstlesssecond
    # lx1x2 is the number of objectpairs
    #k0 is the number of attributes.
    lq12=k0*1.0*(k0-1.0)
    mt=marray(int(lq12),lx1x2)
    for i in range(0,lx1x2):
        z=0
        for k1 in range(0,k0):
            for k2 in range(0,k0):
                if k1!=k2:
                    if m_1[k1][i]*m_2[k2][i]==1:
                        mt[z][i]=1
                    z+=1        
    return z,mt                

def xmatrixsep(xm_1,xm_2,lx1x2,k0):
    """ a matrix is generated where  in the ith row (ith pair of attributes (qi,qj) or (qj,qi) but
        not (qi,qi) ) and in the jth coulm (a,b) (a taken from x1, b taken from x2) is a 1 if
        this pair separates a from b in the way a>b First attr., a<b second attribute) """
    #Brg 20.8.10,21.8.10
    # xm_1 is the outcome of matrixfirsdtgreatersecond with differences
    # xm_2 is the outcome of matrixfirstlesssecond with differences
    # lx1x2 is the number of objectpairs
    #k0 is the number of attributes.
    lq12=k0*1.0*(k0-1.0)
    xmt=marray(int(lq12),lx1x2)
    for i in range(0,lx1x2):
        print "pair ",i," ",
        z=0
        for k1 in range(0,k0):
            for k2 in range(0,k0):
                if k1!=k2:
                    #print "k1 = ",k1,"   k2= ",k2," factor1 = ",xm_1[k1][i],"   factor 2 = ",xm_2[k2][i]
                    if xm_1[k1][i]*xm_2[k2][i]!=0:
                        xmt[z][i]=xm_1[k1][i]+xm_2[k2][i]
                    z+=1        
    return z,xmt          


def genlistpaar(n):
    nlist=int(1.0*n*(n-1)/2.0)
    print "nlist= ",nlist,"    n= ",n
    listpaar=[]
    for i1 in range(0,n):
        for i2 in range(i1+1,n):
            listpaar.append([i1,i2])
    return listpaar        
            

def Hasse_matrix(objpaar,q,xred):
    # brg 19.1.2012
    # objpaar : element of a listpaar [...[i1,i2],...]
    # Note objects are identified by the no of component
    # q attribute 0,1,..,k0-1
    # xred Datenmatrix
    # result: 1 if first object > second object with respect to q
    #         0 if first element = second element with respect to q
    #         -1 if first element < second object with respect to q
    o1=objpaar[0]
    o2=objpaar[1]
        
    if xred[o1][q]>xred[o2][q]:
        o1o2q=1
        
    if xred[o1][q]==xred[o2][q]:
        o1o2q=0
       
    if xred[o1][q]<xred[o2][q]:
        o1o2q=-1
    return o1o2q

def Hasse_matrixout(nlist,k0,listpr,objred,xred):
    # brg 19.1.2012
    # nlist: Laenge der Labelliste ....(0,1),(0,2),..(n-1,n),....
    # k0: Anzahl der Attribute
    # listpr: Labelliste: (0,1), (0,2),..(1,2),...(2,3),...,(n-1,n)
    # objred: objectlist must correspond to xred
    # xred: dataen matrix , data matrix
    for j in range(0,k0):
        for i in range(0,nlist):
            result=Hasse_matrix(listpr[i],j,xred)
            if result==1:
                print objred[listpr[i][0]],">( "+str(j)+") ", objred[listpr[i][1]]
            elif result==0:
                print objred[listpr[i][0]],"=( "+str(j)+") ", objred[listpr[i][1]]
            elif result==-1:
                print objred[listpr[i][0]],"<( "+str(j)+") ", objred[listpr[i][1]]
            else:
                print "this part should not be possible with real numbers! "
                pass
        print " "

def transtest(r,zetatest):
    """Comparison of zeta-matrix with its own binary power to two. If there are
        two steps which should be considered as transitive, then zeta*zeta is not zeta
        if not the zeta matrix is transitively closed"""
    # brg 30.9.2010
    # r: dimension of square test zetatest matrix
    # zetatest: a square matrix which may or may not be a real zeta matrix.
    # return: matrix and flag
    # flag=1: not transitive
    # flag=0 seems to be transitive
    zetatr=matmultnew(r,zetatest,zetatest)

    zetatrbin=marray(r,r)
    for i in range(0,r):
        for j in range(0,r):
            if zetatr[i][j]>0:
                zetatrbin[i][j]=1
                
##    matout(r,r,zetatest)
##    matout(r,r,zetatrbin)
    flag=0
    for i in range(0,r):
        for j in range(0,r):
            if zetatrbin[i][j]!=zetatest[i][j]:
                flag=1
                break
    print "flag = ",flag
    return zetatrbin,flag


def genoutrk(r,k,x):
    """  generalized outranking matrix after Saisana(JRC) """
    # brg 13.4.2011
    # dm x will be checked and two different analysis
    # of outranking will be done:
    # ordind(.,.,0) count only >-relations among attributes countgt/k
    # ordind(.,.,1) count >-relations (countgt) and =-relations (counteq)
    #               then (countgt+counteq)/(k+counteq)
    # by this the constant sum property is maintained
    # r number of objects
    # k number of attributes
    # result: ordind...0 hard case: ignore equalities
    # result: ordind.. 1 case where equality is taken into regard. Possible bias
    # result: ordind.. 2 fair distibution of equal attribute values
    
    ordind=marray3(r,r,3)
    for i in range(0,r):
        for j in range(0,r):
            counteq=0
            countgt=0
            countlt=0
            for l in range(0,k):
                if x[i][l]>x[j][l]:
                    countgt+=1
                elif x[i][l]==x[j][l]:
                    counteq+=1
                else:
                    countlt+=1

            if i==j:
                ordind[i][j][0]=0
            else:    
                ordind[i][j][0]=1.0*countgt/(1.0*k)
            if i==j:
                ordind[i][j][1]=0
            else:    
                ordind[i][j][1]=1.0*(countgt+counteq)/(1.0*(k+1.0*counteq))
            if i==j:
                ordind[i][j][2]=0
            else:
                ordind[i][j][2]=(1.0*countgt+0.5*counteq)/(1.0*k)
    return ordind


def rkinterval(r,threshold,outrk):
    """ rkintervals after application of a cut-level to rank probabilities"""
    #brg 13.4.2011
    # a row of an outranking matrix may consist of values >threshold countgt
    # and values less 1-threshold. countlt
    # the resulting ranks (as heights) are therefore larger than countgt
    # and less than r-countlt. Hence an interval in most general
    # cases in ranks is possible. Not accessible ranks are -1

    rkm=marray(r,r)
    for i in range(0,r):
        for j in range(0,r):
            rkm[i][j]=j+1
            
    for i in range(0,r):
        countgt=0
        countlt=0
        countoth=0
        for j in range(0,r):
            if i!=j:
                if outrk[i][j]>=threshold:
                    countgt+=1
                elif outrk[i][j]<1.0-threshold:
                    countlt+=1
                else:
                    countoth+=1
            else:
                pass
        #print "obj ",i," countgt= ",countgt,"  countlt= ",countlt
        for l in range(0,countgt):
            rkm[i][l]=-1
        for l in range(r-1,r-1-countlt,-1):
            rkm[i][l]=-1
    return rkm

def rktrafo(rkmact,r):
    """ ranks as heights are transformed to ranks as used in JRC or Brussels"""
    # brg 13.4.2011
    # ranks (heights) may be transformed in that way that the best get rank =1
    # as it is used in JRC.
     
    jrcrkm=marray(r,r)

    for i in range(0,r):
        for j in range(0,r):
            if rkmact[i][j]>0:
                jrcrkm[i][r-1-j]=r+1-rkmact[i][j]
            else:
                jrcrkm[i][r-1-j]=rkmact[i][j]
    return jrcrkm


def saisanamedrk(r,k,x):
    """ consider a rank probability matrix with columns the objects and rows the ranks (as heights),
    then due to Saisana (JRC) one could get the median of ranks by summing up the prob. of rank 1,..,
    and check where the sum comes closest to 0.5"""
    # brg 15.4.2011 (JRC),16.4.2011 (Ranco)
    # median of ranks based on a reank probability matrix x
    # r=k in the application where saisanamedrk should
    # be applied
    # brg
    # any column of x contains the probabilities of one object. 
    sumrk=marray(r,k)
    medrk=vecgen1(r)
    matout(r,k,x)
    for i in range(0,r):
        sum1=0
        for j in range(0,k):
            sum1+=x[j][i]
            sumrk[j][i]=sum1

     
    print "in saisana sumrk: "
    matout(r,k,sumrk)
    #columns contain the partial sums of a single object i=1,..,r
            
    for i in range(0,r):  #object loop
        for j in range(0,k):   #rk prob loop
            if j<k-1:
                if sumrk[0][i]>0.5:
                    medrk[i]=1  #if already the first sum is higher than 0.5
                if sumrk[j][i]<=0.5<sumrk[j+1][i]:
                    medrk[i]=j+1  #rank doesnt count from 0, therefore +1
                    continue
                elif sumrk[j][i]==0.5:
                    medrk[i]=1.5+j  # rank doesnt count from 0
                    continue
                elif sumrk[j][i]<0.5<=sumrk[j+1][i]:
                    medrk[i]=j+2   #rank doesnt count from 0, therefore +1
                    continue
    return medrk



def distrib(disc,n,k,mino,maxo):
    """ calculates the distribution of values in disc given a minimal and maximal
    value (mino,maxo) and the number of equivalent classes between mino and maxo"""
    #brg* 2.11.2011
    # brg act 2.11.2011
    # brg 2.11.2011
    
    #disc is the vector whose distribution into k classes is examined
    # n is the length of disc
    # k is the number of equidistant classes between mino and maxo
    # mino is the minimal value
    # maxo is the maximal value
    # mino and maxo will most often found directly from disc
    
    h=vecgen1(5)


    delta=1.0*(maxo-mino)/(1.0*k)
    #print "maxo= ",maxo,"   mino= ",mino,"  delta= ",delta
##    for j in range(0,k):
##        print mino+j*delta, mino+(j+1)*delta 


    for i in range(0,n):
        for j in range(0,k):
            if j==k-1:
                if mino+j*delta<=disc[i]<=mino+(j+1)*delta:
                    h[j]+=1
            else:
                if mino+j*delta<=disc[i]<mino+(j+1)*delta:
                    h[j]+=1

    #print h                
    return h


def permut(vec,n,a):
    #a<n-1
    #n Buchstabenvorrat
    # a Verschiebeoperator
    # invertierung: -a
    # d.h. vec1=permut(vec0,n,a)
    # und  vec2=permut(vec1,n,-a)
    # dann vec2 == vec0
    # brg *: 8.1.2012 bei Robby
    # brg act: 15.1.2012
    
    vecneu=[]
    for i in range(0,n):
        if i+a<n:
            vecneu.append(vec[a+i])
        else:
            vecneu.append(vec[(i+a)%n])
    return vecneu

def perm(l):
    # Compute the list of all permutations of l
    # r is an array , by selecting r[i], i 0... (len(l)-1)! any permutation can be
    # obtained
    # brg 20.3.2013 from help of Python
    # 10 numbers need around 5 minutes
    if len(l) <= 1:
        return [l]
    r = []
    for i in range(len(l)):
        s = l[:i] + l[i+1:]
        p = perm(s)
        for x in p:
            r.append(l[i:i+1] + x)
    return r

def txtvec(txt):
    # brg *: Robby 4.1.2012, 7.1.2012
    lt=len(txt)
    vec=[]
    for i in range(0,lt):
        if txt[i:i+1]!=" ":
            vec.append(txt[i:i+1])
        else:
            pass
    return vec


def gen_alphabet(n):
    # brg *: 7.1.2012
    vec=[]
    for i in range(0,n):
        vec.append(chr(97+i))
    return vec


def t_ad(p,lv):
    #brg *: 7.1.2012 bei Robby
    #Brg act: 15.1.2012
    #p periode, zb. p=3 : (0,0,0),(1,0,0), (2,0,0), (0,1,0), (1,1,0),...
    # lv: Laenge des Textes
    ruler=[]
    for i in range(0,lv):
        j1=(i/1)%p
        j2=(i/p)%p
        j3=(i/(p*p))%p
        ruler.append([j1,j2,j3])
    return ruler    

# procedures of fuzzydds
def extendeddm(n,k,rd,amp,meth,X,objred):
    #Brg * 24.3.2012
    # Brg act: 27.11.2012
    # a dm of continuous variables in concept will be extended by randomized rows
    # n: number of rows of the o i g i n a l  dm
    # k: number of attributes
    # rd: howoften a randomization has to be performed foreach row
    # amp: with which maximal range
    # X: original dm
    # objred: list of objectnames
    import random
    Xext=marray(n*rd,k)
    objredext=vecgen1(n*rd)
    zahl=0
    for i in range(0,n):
        groupmember=0
        for j1 in range(0,rd):
            for j in range(0,k):
                if meth=="urel":
                    Xext[zahl][j]=X[i][j]+X[i][j]*(1.0*amp)*(0.5-random.random()) #25.3.2012, after Wieland 27.11.2012
                elif meth=="uabs":
                    Xext[zahl][j]=X[i][j]+(1.0*amp)*(0.5-random.random()) 
                else:
                    print "+++Fehler+++ method not identified"
                    
            objredext[zahl]=str(objred[i])+str(groupmember)
            groupmember+=1
            zahl+=1  
    return Xext,objredext

def classes_of_randomized(n,rd,objredext):
    #brg 25.3.2012
    ra=vecgen1(n)
    i=0
    zahl=0
    while i<rd*n:
        hilf=[]
        for i1 in range(0,rd):
            hilf.append(objredext[i+i1])
        ra[zahl]=hilf
        i+=rd
        zahl+=1
    return ra

def quartile(inlist):
    #brg 27.3.2012,30.3.2012, 31.3.2012
    """ calulates the quartiles after L.Sachs, p. 158, 7th edition"""
    newlist=[]
    for i in range(0,len(inlist)):
        newlist.append(inlist[i])
    newlist.sort()
    linlist=len(inlist)
    ord1=(linlist+1)*0.25
    ord2=(linlist+1)*0.5
    ord3=(linlist+1)*0.75
    iord1=int(ord1)
    iord2=int(ord2)
    iord3=int(ord3)
    inc1=ord1-iord1
    inc2=ord2-iord2
    inc3=ord3-iord3
    
    testset=set([])
    for i in range(0,len(inlist)):
        testset.add(inlist[i])
    ltestset=len(testset)    
    print "ord ",ord1,ord2,ord3,"  iord= ",iord1,iord2,iord3,"   inc= ",inc1,inc2,inc3
    print "newlist = ",newlist
    print "testset   ",testset
    if ltestset<3 or len(inlist)<=2:
        q1=-999
        q2=-999
        q3=-999
    else:    
        if inc1==0:
            q1=newlist[int(ord1)-1]
        else:    
            q1=(1-inc1)*(newlist[int(ord1)-1])+(inc1)*(newlist[int(ord1)])
        if inc2==0:
            q2=newlist[int(ord2)-1]
        else:    
            q2=(1-inc2)*(newlist[int(ord2)-1])+(inc2)*(newlist[int(ord2)])
        if inc3==0:
            q3=newlist[int(ord3)-1]
        else:    
            q3=(1-inc3)*(newlist[iord3-1])+(inc3)*(newlist[iord3])
    return q1,q2,q3    


def onedim_matrix_vector(y1):
    """ EXCELreadin4 delivers a onedimensional field\
        such as [a,b,c] formally as a matrix in the form\
        [[a],[b],[c]]. This routine transforms this matrix \
        back to a vector [a,b,c]."""
        # brg 26.4.2012
        # y1 is a matrix of the form [[..],[..],..]
        # resut is a vector [..,..,...]
        # example, see Uebungsprogramme/Sonstig/onedimmatrixvector3.py
    y1v=[]
    ly1=len(y1)
    print "ly1 = ",ly1
    for i in range(0,ly1):
        y1v.append(y1[i][0])
    return y1v    

def weak1(r,obj,objred,f_act,eqm):
    """ extension of f_act, defined for representants to all objects according
    to the equivalence classes, rendering f_extended"""
    #brg * 31.5.2012
    # brg act: 31.5.2012
    # aim:
    # [a,e,g],[b,d],[c],[f,h] are equivalent classes f_act is defined for
    #                          a,b,c,f: f_act[a],f_act[b],f_act[c],f_act[f]
    #                          then the procedure weak1 makes:
    # f_extende[a]=f_act[a],f_extended[e]=f_act[a], f_extended[g]=f_act[a]
    # f_extended[b]=f_act[b], f_extended[d]=f_act[b]
    # f_extended[c]=f_act[c]
    # f_extended[f]=f_act[f], f_extended[h]=f_act[f]
    # objred: list of representants. Equivalence relation equality of rows of data matrix
    # obj: original list of objects corresponding to r rows of dm
    # f_act : Values associated with the representants
    # eqm equivalence matrix as outcome of equivcompactgr
    # result: f_extended: vector related to obj with r components
    #       the equivalent elements of the representat x get the value of f_act(x).
    # An example Python program is weak1.py in "Uebungsprogramme\sorting"

    f_extended=vecgen1(r)
    # first : f_extended gets at the correct position the values stored in f_act
    for ob in objred:
        iob=obj.index(ob)
        f_extended[iob]=f_act[objred.index(ob)]

    #print "f_extended",f_extended
    #Here the equivalent elements, which are not the representants get the values
    # ...corresponding to the values of their representants.
    for i in range(0,r):  # 7 objects (according to the example above) therefore eqm_act has seven rows and columns
        for i1 in range(0,r):
            if eqm[i][i1]==1:
                f_extended[i1]=f_extended[i]
                

    #print "f_extended aufgefuellt ",f_extended
    return f_extended


def weak2(r,obj,objred,hav,eqm):
    """ Like weak1, however the result - f_extended - is given as a vector"""
    #brg 15.11.2013
    # r: number of elements of obj
    # obj: List of objects
    # objred: list of representatives
    # hav: a function related to the representatives
    # eqm: outcome of equivcompactgr or equivect
    #
    # An example how to use weak2 is in Uebungsprogramme/sorting the program tie_sorting11.py
    #
    f_extended=vecgen1(r)

    for ob in objred:
        iob=obj.index(ob)
        f_extended[iob]=hav[objred.index(ob)]

    for i in range(0,r):  
        for i1 in range(0,r):
            if eqm[i][i1]==1:
                f_extended[i1]=f_extended[i]
    return f_extended


def objsort(obj,ranks):
    """ renders a vector of objects where the objects have position according to the \
    increasing ranks, due to the input 'ranks'
    Note that here it is assumed that each rank is different from each other """
    # brg 21.6.2012
    # assume obj=[a,b,c,d]
    # ranks = [2,1,4,3] meaning that a has the 2nd, b the 1st, c the 4th and d the 3rd
    #...position (ranks usually obtained from pstat.lrankdata(inlist)
    # then a vector newvec is the outcome such as [b,a,d,c]
    # see sortingobjects6.py for a working example
    newvec=vecgen1(len(obj))
    for i in range(0,len(obj)):
        newvec[int(ranks[i]-0.99)]=obj[i]
    return newvec    


def rankdistance(r,rank1,rank2):
    """ A distance (Euclidian square root) ranks calculated by
        lrankdata(inlist)(pstat) is calculated"""
    # brg 22.6.2012
    # r length of rank1
    # rank1 and rank2 must have the same length
    # ranks1, ranks2 from pstat.lrankdata(inlist) and eventually from weak1
    import math
    dis=0
    for i in range(0,r):
        dis+=(rank1[i]-rank2[i])**2
    distance=math.sqrt(dis)
    return distance
    

def objsort2(r,obj,rank):
    """ Objects are sorted into sets according
    to increasing ranks. If ties appear then the
    sets have more than one element
    R e c o m m e n d e d  """
    #obj name of objects
    # rank (as obtained from pstat.lrankdata
    # corresponds with objsortprint
    # example: see sortobjects16.py
    #brg 22.6.2012, 24.6.2012
    a=[]
    for i in range(0,r):
        a.append(set([]))

    for i in range(0,r):
        a[int(rank[i]-1)].add(obj[i])
    return a

def objsort2print(r,a):
    #brg 22.6.2012
    """ there are 6 objsort2print-versions ,
    this one just assigns to a text vector the sets.
    Emoty sets are visible according to Python symbolics """
    # r number of objects
    # a the result of objsort2
    txta=[]
    for i in range(0,r):
        if len(a[i])!=0:
            txta.append(a[i])
    lt=len(txta)
       
    return txta,lt

def objsort2print2(r,a):
    """ Same as objsortprint, however the set a will be destroyed
    in order to get a compact result list """
    #brg 22.6.2012
    # set a will be destroyed
    # a as obtained from objsort2
    txt=""
    for i in range(0,r):
        while len(a[i])!=0:
            if len(a[i])==1:
                txt+=str(a[i].pop())+",\n"
            else:    
                txt+=str(a[i].pop())+"="
    return txt

def objsort2print4(r,a):
    """ presentation of weak order of objects
    the Python formulation of empty sets is avoided"""
    #brg 22.6.2012
    # empty sets included, this facilitates
    # the presentation
    # example: see sortobjects16.py
    txta=[]
    for i in range(0,r):
        if len(a[i])!=0:
            txta.append(a[i])
        else:
            txta.append("")
    return txta

def objsort2print5(r,txta):
    """ objsort2print5 and 6 need as an interim
    step objsort2print4, because there txta is
    calculated, then in ..5 a compact output """ 
    # brg 22.6.2012
    #needs txta of objsort2print4
    txtresult=""
    for i in range(0,r):
        txtresult+="i="+str(i)+": "
        if len(txta[i])!=0:
            for ob in txta[i]:
                txtresult+=str(ob)+", "
        txtresult+="\n"       
    return txtresult

def objsort2print6(r,txta):
    """ objsort2print5 and 6 need as an interim
    step objsort2print4, because there txta is
    calculated, then in ..6 a readable output,
    where -however- the empty sets are seen
    due to their position """ 
    # brg 22.6.2012
    #needs txta of objsort2print4
    # example: see sortobjects16.py
    txtresult=vecgen1(r)
    for i in range(0,r):
        txt="i="+str(i)+": "
        if len(txta[i])!=0:
            for ob in txta[i]:
                txt+=str(ob)+", "
        txtresult[i]=txt        
              
    return txtresult

def objsort2print7(r,txta):
    """ objsort2print5 and 6 need as an interim
    step objsort2print4, because there txta is
    calculated, then in ..6 a readable output, position suppressed""" 
    # brg 22.6.2012, 24.6.2012
    #needs txta of objsort2print4
    # example: see sortobjects16.py
    txtresult=vecgen1(r)
    for i in range(0,r):
        txt=""
        if len(txta[i])!=0:
            for ob in txta[i]:
                txt+=str(ob)+", "
        txtresult[i]=txt        
              
    return txtresult

def vectordm2(r,q):
    # brg 30.1.2013
    """ tranforms a vector q (length r) formally in a matrix
    with two columns"""
    #return dm,k
    k=2
    dm=marray(r,k)
    for i in range(0,r):
        dm[i][0]=q[i]
        dm[i][1]=q[i]
    return dm,k

def atfg(t,fg):
    # brg 21.3.2013, 24.3.2013
    # Abramowitz, Stegun, Fifth Dover edition, page 948
    # Chapter 26.7 Student's t-Distrbution, subsection26.7.3 and 26.7.4
    # Recommended by Hagen Scherb, March, 2013
    import math
    ppi=math.pi
    x=(1.0*t)/(1.0*math.sqrt(fg))
    theta=math.atan(x)
    hilfg=(1+0.5*(math.cos(theta))**2+0.375*(math.cos(theta))**4+\
                      0.3125*(math.cos(theta))**6)
    hilfu=math.cos(theta)+0.666*(math.cos(theta))**3 + 0.5333*(math.cos(theta))**5
    if fg==1:
        atfg1=(2.0*theta/(1.0*ppi))
    else:
        if int(fg/2.0)==fg/2.0:
            # fg gerade
            if fg==2:
                atfg1=math.sin(theta)
            elif fg==4:
                atfg1=math.sin(theta)*(1.0+0.5*(math.cos(theta))**2)
            elif fg==6:
                hilf=(1+0.5*(math.cos(theta))**2+0.375*(math.cos(theta))**4)
                atfg1=(math.sin(theta))*hilf
            elif fg==8:
                hilf=(1+0.5*(math.cos(theta))**2+0.375*(math.cos(theta))**4+\
                      0.3125*(math.cos(theta))**6)
                atfg1=(math.sin(theta))*hilf
            else:
                qg=0.3125
                for i in range(8,int(fg)-1,2): ##24.3.2013 int(fg)
                    qg=qg*(i-1.0)/(1.0*i)
                    hilfg+=qg*math.cos(theta)**i
                atfg1=(math.sin(theta))*hilfg    
        else:
            # fg ungerade
            prefactor=(2.0/(1.0*ppi))
            if fg==3:
                atfg1=prefactor*(theta+math.sin(theta)*math.cos(theta))
            elif fg==5:
                atfg1=prefactor*(theta+math.sin(theta)*(math.cos(theta)+0.666*(math.cos(theta))**3))
            elif fg==7:
                atfg1=prefactor*(theta+math.sin(theta)*(math.cos(theta)+0.666*(math.cos(theta))**3) + \
                                 0.5333*(math.cos(theta))**5)
            else:
                qu=0.533
                for i in range(7,int(fg)-1,2):  #24.3.2013  int(fg)
                    qu=qu*(i-1.0)/(1.0*i)
                    hilfu=hilfu+qu*(math.cos(theta))**i
                atfg1=prefactor*(theta+(math.sin(theta))*hilfu)    
    return atfg1

def searchtabelle(xu,tabelle,select):
    # brg 15.3.2013
    # find the pair of tabelle[0] such that xu is between known values
    # when xu >= greatest value or xu <= least value 1in table, then a warning (flag=1)
    # The slope and constant of the last or first existing pair of the table are selected. Extrapolation
    # by elongation of the parameters of the lat and the first known interval of the table
    # brg 24.3.2013
    # xu First component in Table (probalbly the number of rows)
    # tabelle: Table with a fixed set of values for example n=1,2,3..,10,20,..,100,200,..,500 and values depending on n
    # select: 1: first component of a table, 2: second component,. etc.
    
    import stats
    import pstat
    def distance(a,b,c):
        # brg 15.3.2013
        # distance c to a,b
        #
        d=abs(a-c)+abs(b-c)
        return d

    def linterpolation(x1,x2,y1,y2,xu):
        # brg 15.3.2013
        # x1,x2 known
        # y1,y2 known
        # xu known to which yu is to be calculated
        #xu the point between x1 and x2 whose yu is to be determined
        slope=1.0*(y1-y2)/(1.0*x1-1.0*x2)
        constant=y1-slope*x1
        yu=slope*xu+constant
        print "slope = ",slope
        print "constant ",constant
        print "xu = ",xu, "   yu=  ",yu
        return yu

    distmin=99999
    Ltabelle=len(tabelle)
    print "Length Tabelle ",Ltabelle
    flag=0
    for i in range(0,Ltabelle-1):
        if xu==tabelle[i][0]:
            imin=i
        elif xu>=tabelle[Ltabelle-1][0]:
            imin=Ltabelle-2
            flag=1
        elif xu<=tabelle[0][0]:
            imin=0
            flag=1
        else:    
            dist=distance(tabelle[i][0],tabelle[i+1][0],xu)
            if dist<distmin:
                distmin=dist
                imin=i
    if flag==1:
            print "+++Warning+++: Extrapolation!! "    
    print "imin ",imin,"   distmin = " ,distmin       
    
    yu1=linterpolation(tabelle[imin][0],tabelle[imin+1][0],tabelle[imin][select],tabelle[imin+1][select],xu)
    return imin,flag, yu1


def tcritfgestimation(sd1,mean1,n1,sd2,mean2,n2):
    # brg 24.3.2013
    # Formulas found by Hagen Scherb, IBB, March 2013
    # 1 the parameter of a simulation
    # 2 the parameter of the combisimilarity results
    # sd: standard deviation
    # mean: mean value
    # n: length of sample
    import math
    #t
    nenner=math.sqrt((1.0*sd1**2/(1.0*n1))+(1.0*sd2**2/(1.0*n2)))
    tscherb=1.0*abs(mean1-mean2)/(1.0*nenner)
    #fg
    hilf1=((1.0*sd1)**2/(1.0*n1))+((1.0*sd2**2)/(1.0*n2))
    hilf21=(1.0*sd1**2/(1.0*n1))**2
    hilf22=(1.0*sd2**2/(1.0*n2))**2
    hilf211=1.0*hilf21/(n1-1.0)
    hilf221=1.0*hilf22/(n2-1.0)

    fghilf=1.0*hilf1**2/(1.0*hilf211+1.0*hilf221)
    fg=round(fghilf,0)
    return tscherb,fghilf,fg

def table(title, subtitle, vlabels, hlabels, tdata):
    rows_table = len(hlabels)
    cols_table = len(vlabels)
    txt = "\t" + str(title) + "\n"
    txt += "\t" + str(subtitle) + 2*"\n"
    txt += "\t"
    for j in range(0, cols_table):
        txt += str(vlabels[j] )+ "\t"
    txt += "\n"
    for i in range(0, rows_table):
        txt += str(hlabels[i]) + "\t"
        for j in range(0, cols_table):
            txt += str(tdata[i][j]) + "\t"
        txt += "\n"
    return txt

def calc_maxEWEV(A0,eps=0.001):
    # brg 29.10.2018, 1.11.2018
    # this procedure calculates the maximal eigenvalue and
    # its eigenvector.
    # the matrix A0 must be a square matrix
    # the eigenvector is normalized in that manner that the last ...
    # ...component equals 1
    # method: see
    # https://resources.mpi-inf.mpg.de/departments/d1/teaching/ss10/MFI2/kap51.pdf
    # how to use this procedure: see toward_calc_maxEWEV2.py in "AnderePythonprogramme\
    #....Uebungsprogramme\toward"
    # basic parameter
    n = len(A0)
    import math
    
    # start - vector, this may not always be the best solution
    r=[]
    for i0 in range(0,n):
        if i0==0:
            r.append(1)
        else:
            r.append(0)

    #preparations for while loop
    A = A0
    absdiff=99999
    count=0
    while absdiff>eps:
        r1=matvecmult(n, n, A, r )

        sumx=0
        for i1 in range(0,n):
            sumx+=r1[i1]*r1[i1]
        norm = math.sqrt(sumx)    
        for i2 in range(0,n):
            r1[i2]=1.0*r1[i2]/(1.0*norm)

        # approximation exact enough?
        absdiff=0
        for i3 in range(0,n):
            absdiff+=abs(r[i3]-r1[i3])
        #print absdiff
        for i4 in range(0,n):
            r[i4]=r1[i4]
        count+=1    
     
     
    rfinal=matvecmult(n,n,A,r)
    
    ew= 1.0*rfinal[0]/r[0]
    #Normalization by letting the nth component of r being 1
    rtest=[]
    print "eigenvector before normalization:"
    for i in range(0,n):
        print round(r[i],3)," ",
    print " "    
    print "r at ",n-1," = ", r[n-1]
    for i5 in range(0,n):
        if r[n-1]!=0:
            rtest.append(1.0*r[i5]/r[n-1])
        else:
            rtest.append(r[i5])
        #print rtest
    return ew,rtest,count

