# -*- coding: cp1252 -*-
import rmod2
import raioop2
import Tkinter
from ScrolledText import *
import random
import os
import tkFileDialog
import csv
from string import replace

# Brg 8.8.2013 following an idea of Prof. Kerber
# derived from the extended version fuzzyHD14_1.py.
# 29.8.2013 rearrangement to allow to inread several formats
# 23.3.2014 cosmetics


global q1,tech,r
tech=rmod2.vecgen1(20)
x=rmod2.marray(400,400)
y=rmod2.marray(400,400)

###### editfenster ### 29.8.2013 #####
def xsave_in_PyHasseformat():
    # brg 26.7.2013
    # 6.8.2013: taken from csvHDsimpl1.py, 27.8.2013
    global r,k,x
    la=r+1
    ls=k+1
    
    xext=rmod2.marray(la,ls)
    for i in range(0,la):
        for j in range(0,ls):
            if i==0 and j==0:
                xext[i][j]="dummy"
            elif j==0 and i>0:
                xext[i][j]=obj[i-1]
            elif j>0 and i==0:
                xext[i][j]=prop[j-1]
            else:
                xext[i][j]=x[i-1][j-1]


    print " xext-matrix "
    for i in range(0,la):
        for j in range(0,ls):
            print xext[i][j]," ",
        print " "
    print "  "    
    fnnew=tkFileDialog.asksaveasfilename(parent=hf,title="save orig dm in PyHasseformat")
    fcsv=open(fnnew,"w")
    for i in range(0,la):
        for j in range(0,ls):
            fcsv.write(str(xext[i][j])+"\t")
        fcsv.write("\n")
    fcsv.close()
   
def xsave_in_PyHasseformat_n():
    # brg 26.7.2013
    # 6.8.2013: taken from csvHDsimpl1.py, 27.8.2013
    global r,k,x
    xn=rmod2.matrixnorm(r,k,x)

    la=r+1
    ls=k+1
    
    xext=rmod2.marray(la,ls)
    for i in range(0,la):
        for j in range(0,ls):
            if i==0 and j==0:
                xext[i][j]="dummy"
            elif j==0 and i>0:
                xext[i][j]=obj[i-1]
            elif j>0 and i==0:
                xext[i][j]=prop[j-1]
            else:
                xext[i][j]=xn[i-1][j-1]


    print " xext-matrix "
    for i in range(0,la):
        for j in range(0,ls):
            print xext[i][j]," ",
        print " "
    print "  "    
    fnnew=tkFileDialog.asksaveasfilename(parent=hf,title="save normalized dm in PyHasseformat")
    fcsv=open(fnnew,"w")
    for i in range(0,la):
        for j in range(0,ls):
            fcsv.write(str(xext[i][j])+"\t")
        fcsv.write("\n")
    fcsv.close()
   

def xselectfile():
    # brg 6.8.2013
    global fn
    fn=tkFileDialog.askopenfilename()
    print "fn ",fn
    Tpopener=Tkinter.Toplevel(hf)
    Tpopener.title(' Opening window: different formats ')
    fropen2=Tkinter.Frame(Tpopener,bd=3,bg="white")
    fropen2.pack()
    # +++ Grid-Geometry manager +++
    lb0=Tkinter.Label(fropen2,text=" Select the appropriate format: ",bg="yellow",font=("arial",12,"bold"))
    lb0.grid(row=0,column=0)
    lb1=Tkinter.Label(fropen2,text="(1a) Open files, txt, tab (or blank) as delimiter (PyHasse-standard) :                ",bg="white")
    lb1.grid(row=1,column=0)
    lb2=Tkinter.Label(fropen2,text="(1b) Open files, csv, ';' as delimiter (csv with ';') :                               ",bg="white")
    lb2.grid(row=2,column=0)
    lb3=Tkinter.Label(fropen2,text="(1c) Open files, csv, ',' as delimiter (csv with ',') :                               ",bg="white")
    lb3.grid(row=3,column=0)
    lb6=Tkinter.Label(fropen2,text="(1f) Open files, pdt, internal PyHasse-format to exchange interim-results:            ",bg="white") 
    lb6.grid(row=6,column=0)
    butt1=Tkinter.Button(fropen2,text="(1a) Open txt-file       ",bg="cyan",bd=4,command=xfileopen)
    butt1.grid(row=1,column=1)
    butt2=Tkinter.Button(fropen2,text="(1b) Open csv-file (';') ",bg="cyan",bd=4,command=xcsvopenS)
    butt2.grid(row=2,column=1)
    butt3=Tkinter.Button(fropen2,text="(1c) Open csv-file (',') ",bg="cyan",bd=4,command=xcsvopenK)
    butt3.grid(row=3,column=1)
    butt6=Tkinter.Button(fropen2,text="(1f) Open pdt-file       ",bg="cyan",bd=4,command=xopenfilepdt)
    butt6.grid(row=6,column=1)


def xcsvopenS():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,obj,prop,x,xred,rred,objred,dm
    DataReader = csv.reader(open(fn), delimiter=';', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")
    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,x,obj)
    print "rred ",rred
    print "Matrix "
    rmod2.matout(r,k,xred)

    

def xcsvopenK():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,x,fn,obj,prop,xred,objred,rred,dm
    DataReader = csv.reader(open(fn), delimiter=',', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")

    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,x,obj)




def xfileopen():
    "Informs about the file-operations"
    # Excelreadin4 built in
    # Brg 29.11.07, 30.11.07, 15.1.08,18.2.08
    global fn,r,k,x,prop,obj
    x,ob,pr,r,k=rmod2.EXCELreadin6(fn)
    print "r = ",r,"   k = ",k
    obj=rmod2.vecgentext1(r)                        #29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  #recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pr[i+1]   #recoding, because pr[0] is a dummy string
    #rmod2.matout(r,k,x)
    rmod2.matcopy(r,k,x,y)
    lbopen1.config(bg="yellow")    #18.2.08
    lbopen1["text"]="File "+fn+" was opened with "+str(r)+" rows and "+str(k)+"  columns"
    
    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,x,obj)   #6.8.2013

    

def xopenfilepdt():
    """ File selection of transformed data matrices
    through other PyHasse programs """
    # brg 29.10.2012 taken from sensitivity18_3
    #* 1.6.09
    # akt. 29.10.2012 (taken from sensitivity18_3), 6.8.2013
    # source: mainHD19
    global fn,r,k,x,prop,obj,rred,xred,objred
    
    r,k,x,obj,prop=rmod2.raireadin5(fn)
    lbpdtopen.config(bg="yellow")
    lbpdtopen["text"]="selected file (PyHasse (pdt) format) : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns"

    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,x,obj)    

##### end ofg editenster ### 29.8.2013 ####


def calc():
    # brg 8.8.2013, 29.8.2013
    # acut read in
    # normalization
    # Kosko
    # Tr.closure
    # crisp matrix
    # extract order
    acut=float(eac.get())
    y=matnorm(r,k,x)
    d=genfuzzymatrix(r,k,y)
    q=fuzzyproduct()  
    cq,acut_act=crispq(q,r,acut)
    order_act,objec_act,rs_act=extract(cq,r,acut_act)
    HD(order_act,rs_act,r,objec_act,acut_act)




def matnorm(r,k,x):
    """ normalizes the columns of dm to 0,1 """
    # brg 9.12.07, 7.5.08
    
    y=rmod2.matrixnorm(r,k,x)
    #y=rmod2.matcopy1(r,k,y1)
    
    return y
    



def genfuzzymatrix(r,k,y):
    """In de Baets : the D-matrix """
    #brg 14.11.07, 7.5.08
    global d
    #print "test in genfuzzymatrix y-matrix"
    #rmod2.matout(r,k,y)
    d=rmod2.fuzzylessthan(r,k,y)
    
    return d
    
def fuzzyproduct():
    "see DeBaets,DeMeyer in Inf Sci 152, 2003, 167-179"
    #brg 14.11.07
    
    flag=0
    eps=0.1
    zaehl=0
   
    #print "In fuzzyproduct r =",r,"   k= ",k
    q=rmod2.matcopy1(r,r,d)
    
    while flag==0:
        q1=rmod2.fuzzymatmult(r,q,q)
        flag=rmod2.comparematrices(r,r,eps,q1,q)
        q=rmod2.matcopy1(r,r,q1)
        zaehl+=1
        if zaehl>20:
            break
        else:
            pass
    tech[3]=zaehl
       
    txt=""
    hilf1=rmod2.vecgen1(r*r)
    hilf2=rmod2.vecgen1(r*r)
    hilf3=rmod2.vecgen1(r*r)
    alpha=rmod2.vecgen1(r*r)
    nn=rmod2.vecgen1(r*r)
    zaehl=0
    for i in range(0,r):
        for j in range(0,r):
            hilf1[zaehl]=round(q[i][j],3)
            zaehl+=1
    
    hilf2,nn=rmod2.raisort(r*r,hilf1)
    for i in range(0,r*r):
        hilf3[i]=hilf2[i]
        
    for i in range(0,r*r):
        z=hilf2[i]
        for i1 in range(i+1,r*r):
            if z==hilf2[i1]:
                hilf3[i1]="*"
    nr_of_cuts=0
    for i in range(0,r*r):
        if hilf3[i]!="*":
            alpha[nr_of_cuts]=float(hilf3[i])
            nr_of_cuts+=1
    txt1="Number of cuts = "+str(nr_of_cuts)+"\n"
    lbalpha.config(bg="yellow")
    lbalpha["text"]=txt1
    nhisto=5         #graphics  neu 20.2.08
    nal=nr_of_cuts   #graphics
    balpha=rmod2.vecgen1(nhisto)
    for j in range(0,nhisto):
        for i in range(0,nal):
            if j<nhisto-1 and j<=nhisto*alpha[i]<j+1:
                balpha[j]+=1
            if j==nhisto-1 and j<=nhisto*alpha[i]<=j+1:
                balpha[j]+=1
    histo=Tkinter.Toplevel(hf)
    histo.title(' alpha-cuts  ')
    talfa=ScrolledText(histo,width=60,height=5)
    talfa.pack(expand="yes",fill="both")
    txt2="alpha-cuts\n "  #16.3.09
    for i in range(0,nal):
        if i>0 and i%20==0:                        #18.2.08
            txt2+=str(alpha[i])+" \n"
        else:
            txt2+=str(alpha[i])+"   "
    #txt+="\n"
    txt2+="\n"+"  - - -   eof  - - - "        
    talfa.insert("end",txt2)
    return q

def crispq(q,r,acuser):
    "depending on alpha: crisp matrices"
    # brg 14.11.07
        
    
    lbextract.config(bg="white")
    lbextract["text"]=""
    
    
    cq=rmod2.marray(r,r)
    
    for i in range(0,r):
        for j in range(0,r):
            if q[i][j]>=acuser:
                cq[i][j]=1
            else:
                cq[i][j]=0
                
    lbc.config(bg="yellow")
    lbc["text"]=" crisp matrix "
    return cq,acuser


    
def extract(cq,r,acut):
    """extracts from the crisp matrix the order relations"""
    global eqtext
    lbextract.config(bg="yellow")
    lbextract["text"]="Extraction performed"
    #brg 30.11.07, 11.4.08
    # the matrix order corresponds to objec
    
    # order is the matrix rs*rs which results after extract
    # rs is the number of rows/ columns of the square matrix order
    eqtext="\n"
    eqtext+="alphacut : "+str(acut)+":  \n"
    
    
    ec=rmod2.dmcompress(r,r,cq)             #30.11. from cq the equivalent relations
    eqtxt,Ksum_act=rmod2.eqcguiout2(r,ec,obj)        #30.11. matrix output 16.7.2013: eqc... version 2
    eqtext+=eqtxt
    eqtext+="\n"
    eqtext+="comparabilities due to the equivalent elements "+"\n"
    eqtext+="Formally x=eq y is counted as x > y, y > x"+"\n"
    eqtext+="Equiv.comp = "+str(Ksum_act)+"\n"
    eqtext+="  - - - e o f - - - "
    hfeq=Tkinter.Toplevel(hf)
    hfeq.title(' equivalence classes, alpha-cut= '+str(acut))
    lbhfeq=Tkinter.Label(hfeq,text='equivalent elements, alpha-cut= '+str(acut))
    lbhfeq.pack()
    teq=ScrolledText(hfeq,width=70,height=3)
    teq.pack(expand="yes",fill="both")
    teq.insert("end",eqtext)
    #print "r  = ",r
    txt=rmod2.irc_elim(r,ec)    #7.5.08 identifycolrows replaced by icr_elim
                                #in txt are the rows (and columns)
                                #...which can be eliminated
    
    #print "======================================="
    #print " Control in extract (ex) "
    #print "======================================="
    ltxt=len(txt)
    #print "ex1: ec : ",ec
    #print "ex1: txt , ltxt",txt," ",ltxt
    
    b=rmod2.recogempty(txt,ltxt)
    # Not only the matrix cq is to be contracted but also the object vector obj
    # txt is a code of row numbers and as such ok for the matrixeliminations
    # however, to perform a new object list, txt must
    # be transformed in the corresponding object names
    
        
    an1,ldel1=rmod2.matrixcoldel(txt,r,r,cq) # columns eliminated
    order,ldel2=rmod2.matrixrowdel(txt,r,r-ldel1,an1)
    rs=r-ldel1
    
    #print "ex2: rs ,r,ldel1,ldel2,b ",rs," ",r," ",ldel1," ",ldel2," ",b
    #print "ex3: order -matrix "
    #rmod2.matout(rs,rs,order)
    #print " "
    #print "in extract: tech[4] ",tech[4]
    if b=="true":
        #there is nothing to be reduced hence
        objec=rmod2.vecgentext1(r)
        for i in range(0,r):
            objec[i]=obj[i]
    else:        
        conobj=rmod2.vecgentext1(ltxt)
        for i in range(0,ltxt):
            conobj[i]=obj[int(txt[i])]
        #print "conobj = ",conobj    
        objec=rmod2.vecgentext1(rs)
        zaehl=0
        for i in range(0,r):
            #print "obj i  ",obj[i],"  in conobj  ",conobj
            if obj[i]not in conobj:
                objec[zaehl]=obj[i]
                zaehl+=1
        #print "ex4: Reduz. Liste der Objekte (objec in modul extract) ",objec
        #print "ex5: rs = ",rs
    return order,objec,rs



def HD(order,rs,r,objec,acut):
    "based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"
    # Brg 20.12.07, 28.12.07
    # If the number of representants > 20 then only the cover-matrix and the level-population
    #

    global zeta2,n,objred  
    try:
        modus=int(emodus.get())
    except:
        modus=1
        
        
    if r==0:
        hfwarning=Tkinter.Toplevel(hf)
        hfwarning.title('++warning++')
        frwarning=Tkinter.Frame(hfwarning,width=10,height=3)
        frwarning.pack()
        bwarning=Tkinter.Button(frwarning,text="++warning ++",command=msgwarning)
        bwarning.pack()
    #print "test 7.5.08 rs  = ",rs    
    n=rs  #14.4.08 
    objred=rmod2.vecgentext1(rs)  #changed to ..text1: 7.5.08
    
    for i in range(0,rs):
        objred[i]=objec[i]  #control 15.1.08
         
    hfhd1=Tkinter.Toplevel(hf)
    hfhd1.title(' Hasse diagram / cover matrix ')
    lbhfhd1=Tkinter.Label(hfhd1,text='Hasse diagram or cover matrix ')
    lbhfhd1.pack()
    freq=Tkinter.Frame(hfhd1,width=400,height=480)
    freq.pack()
    
   
    labeq=Tkinter.Label(freq,text="file = "+fn+": calc. is based on representants ")
    labeq.config(bg="yellow")
    labeq.pack()
    labeq2=Tkinter.Label(freq,text="alpha-cut: "+str(acut))
    labeq2.config(bg="yellow")
    labeq2.pack()
    zeta=rmod2.marray(rs,rs)
    for i in range(0,rs):
        for j in range(0,rs):
            zeta[i][j]=order[i][j]   #15.1.08 evtl. diese Manipul weglassen
    #
    #One linear extension (based on levels)
    lbhd1=Tkinter.Label(freq,text= "Level ")
    lbhd1.pack()
    utotal=rmod2.incompzeta(rs,zeta)   #9.2.2008
    #print "rs= ",rs      #16.7.2013
    comptot=rs*(rs-1.0)/2.0 - utotal
    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rs,zeta)
    
    #print "zzmax = ",zzmax
    tlev=ScrolledText(freq,width=60,height=4)
    tlev.pack(expand="yes",fill="both")
    txt1="\n"
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= objred[lobj[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)
    lbequiv=Tkinter.Label(freq,text="Nontrivial Equivalence classes")
    lbequiv.pack()
    txt2="\n equivalence classes \n\n"
    txt2+=eqtext
    txt2+="\n"
    txt2+="\n -- end of list -- "
    tlinext=ScrolledText(freq,width=60, height=2)
    tlinext.pack(expand="yes",fill="both")
    tlinext.insert("end",txt2)
    
    #Adj-Listen

    adjc=rmod2.adjacent(n,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(n,adjc,lext)
       
    
    zeta2=rmod2.cover(n,tr,lext)
    if n>100:
        cover_show1()                  #20.1.08
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram of File "+fn)
        lbhd3.pack()
        cv=Tkinter.Canvas(freq,width=400,height=480,bg="white")  #5.3.09
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(n,n)
        geomy=rmod2.marray(n,n)

        geom0x=10
        geom0y=20
        for i in range(0,lz):  #random positions 22.11.2010, 5.1.2011
            for j in range(0,l[i]):
                if modus==1:
                    ff=320.0
                else:
                    ff=random.randint(320-modus*5.0,320+modus*5.0)
                geomx[i][j]=geom0x+(ff/(pos[i]+1.0))*(j+1)  #22.11.2010    
                geomy[i][j]=geom0y+(320.0/lz)*i

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if zeta2[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        garrow1x=380
        garrow1y=20
        garrow2y=230
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
##        cv.create_line(garrow1x-4,garrow2y-4,garrow1x,garrow2y)
##        cv.create_line(garrow1x+4,garrow2y-4,garrow1x,garrow2y)
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.create_text(140,450,text="HD:\t"+str(utotal)+"  incomparable pairs"+"\n\t"+str(comptot)+"  comparabilities ")   #9.2.08
        cv.pack()
        buttcover=Tkinter.Button(freq,text="show cover relation",command=cover_show1)
        buttcover.pack()
        if utotal==0:  #13.7.2012
            import stats
            import pstat
            tplinear=Tkinter.Toplevel(hf)
            tplinear.title(' Linear order of representants ')
            tlinear=ScrolledText(tplinear,width=60,height=10)
            tlinear.pack()
            txtlinear="Linear order of representants "+"\n"
            txtlinear+=50*"="+"\n"
            sumzeta=rmod2.matrixrowsum(zeta,n,n)
            ranksumzeta=pstat.lrankdata(sumzeta)
            hilf1=rmod2.objsort2(n,objred,ranksumzeta)
            hilf2=rmod2.objsort2print4(n,hilf1)
            txtrkzeta=rmod2.objsort2print7(n,hilf2)
            #print "txtrkzeta= ",txtrkzeta
            zahl=0
            for i in range(0,len(txtrkzeta)):
                if 1.0*zahl/3.0 - zahl/3==0:
                    txtlinear+=str(txtrkzeta[i])+" > "+"\n"
                else:
                    txtlinear+=str(txtrkzeta[i])+" > "
                zahl+=1
            txtlinear+="\n"
            txtlinear+=" -  -  -  e  o  f  -  -  -"
            tlinear.insert("end",txtlinear)
            

def cover_show1():
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: -
    hfcover=Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    
    lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,n):
        txt3+="\n"+objred[i]+":\t"
        txt3+="is covered by "
        for j in range(0,n):
            if i!=j:
                if zeta2[i][j]==1:
                    txt3+=" "+objred[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=4)
    tcov.pack(expand="yes",fill="both")
    tcov.insert("end",txt3)




hf=Tkinter.Tk()
w=45
hf.title("simpleHDfuzzy posets")

helpfuzzy=raioop2.brgabout(hf,"tp1","help_fuzzysimpl.txt",13,\
            "August, the 29th,2013"," help_fuzzysimpl", "white", "t1",120,10,ScrolledText)
    
aboutfuzzy=raioop2.brgabout(hf,"tp2","about_fuzzysimpl.txt",13,\
            "August, the 29th,2013"," about_fuzzysimpl", "white", "t1",120,5,ScrolledText)
    

fr=Tkinter.Frame(hf,width=400,height=400)
fr.pack()



frinput1=Tkinter.Frame(fr,width=100,height=10)
frinput1.pack()
lbinput1=Tkinter.Label(frinput1,text="Select first the file, then decide in which format to be opened ")
lbinput1.pack()
butt1=Tkinter.Button(frinput1,text="Select filename  ",bg="white",command=xselectfile)
butt1.pack()
                      
lbopen1=Tkinter.Label(fr,text="")
lbopen1.pack()

lbalpha=Tkinter.Label(fr,text="")
lbalpha.pack()
frinput2=Tkinter.Frame(fr,width=100,height=10)
frinput2.pack()
lbinput=Tkinter.Label(frinput2,text="alpha-cut? ")
lbinput.pack(side="left",fill="x")
eac=Tkinter.Entry(frinput2,width=5)
eac.pack(side="left",fill="x")
buttcalc=Tkinter.Button(frinput2,text="Fuzzy-calculation ",bg="cyan",width=w,command=calc)
buttcalc.pack()

lbc=Tkinter.Label(fr,text="")
lbc.pack()


lbextract=Tkinter.Label(fr,text="")
lbextract.pack()
buttsave=Tkinter.Button(fr,text="Save original data matrix in PyHasse-standard format ",bg="cyan",width=w,command=xsave_in_PyHasseformat)
buttsave.pack(pady=2)
buttsaven=Tkinter.Button(fr,text="Save normalized data matrix in PyHasse-standard format ",bg="cyan",width=w,command=xsave_in_PyHasseformat_n)
buttsaven.pack(pady=2)
buttexit=Tkinter.Button(hf,text=" exit ",bg="red", width=10,command=hf.destroy)
buttexit.pack(pady=2)
hf.mainloop()
